!***********************************************************************
!
!           MCTDH subrotuine ADEFAULT.F
!
!  In this subroutine all "analyse" variables and parameters should be
!  initialized.
!
!   01/98 AJ
!
!
!***********************************************************************

      subroutine adefault

use global
use aglobal
use dvrdatmod
use griddatmod
use operdef
use psidef
use datenmod
use dirdyn
use runpropmod
use plot
use compdatmod
use compdat1mod
use versions
use logdat, only:errormsg,routine,message

      implicit none

      integer :: ierror

!-----------------------------------------------------------------------
! Set program name.
!-----------------------------------------------------------------------
! GET THE ZEROTH ARGUMENT (name of routine as called from bash)
      call mygetarg(0,progname)
      call rempath(progname,lprogname,ierror)
      if(ierror.eq.1) then
         routine='adefault'
         message=progname//' is a directory, not a file name.'
         call errormsg
      endif

!-----------------------------------------------------------------------
! reset default file paths to present directory
!-----------------------------------------------------------------------
      name     = '.  '
      rname    = '.  '
      oname    = '.  '
      dname    = '.  '

      laenge   = index(name,' ')-1
      rlaenge  = index(name,' ')-1
      olaenge  = index(name,' ')-1
      dlaenge  = index(name,' ')-1

!-----------------------------------------------------------------------
! set general defaults
!-----------------------------------------------------------------------
      laein    = 0
      laein1   = 0
      laeout   = 0
      laeoutd  = 0
      outform  = 0
      step     = 1
      lgnu     = .false.
      lagnu    = .false.
      linter   = .false.
      lallcol  = .false.
      lprint   = .false.
      lswap    = .true.
      lrenorm  = .false.
      lpgrid   = .false.
      lpop2    = .false.
      lnw      = .false.
      filein   = '  '
      fileout  = '  '
      psifile  = '  '

      lrddvr   = .false.
      lrdoper  = .false.
      lrdinwf  = .false.
 
!-----------------------------------------------------------------------
! set logicals to assign memory
!-----------------------------------------------------------------------
      lpsi   =.false.
      lpsi1  =.false.
      ldmat  =.false.
      ldmat1 =.false.
      lort   =.false.
      lgpop  =.false.
      lpdens =.false.
      ltrafo =.false.
      lfilein=.false.
      lfileexp=.false.

      maxspf  =0
      workcdim=1
      workrdim=1
      workidim=1
      workldim=1
      worksdim=1
      workfdim=1

      nstate=1

!-----------------------------------------------------------------------
! set ndof initially to 0
!-----------------------------------------------------------------------
      nmode=0
      ndof=0
      nandof=0
      nanmode=0
      ftime=-1
      fener=-1

!-----------------------------------------------------------------------
! set pes default
!-----------------------------------------------------------------------
      pesmin=-1.0d20
      pesmax= 1.0d20

!-----------------------------------------------------------------------
! npnts is no. of points for GWP DOF grid
!-----------------------------------------------------------------------
      ngwppnts = 101
      ldynspf = .false.
      lgwpphase=.true.

!-----------------------------------------------------------------------
! DD defaults
!-----------------------------------------------------------------------
      ddmindb = 99999.0_dop

!-----------------------------------------------------------------------
! mapping of ort vector is required for plotting using very long 
! grids. Set to false as not required by most programs
!-----------------------------------------------------------------------
      lmaport = .false.

      return
      end subroutine adefault

