!#######################################################################
! Module analyse/auswutil.F
! savecdat, getcdat, sortup, sortdown, decoder, decoderm, f2mdecoder
!#######################################################################
 
      module auswutil

use decimal, only:dop,long
use op1lib,  only: zeromxd, cpmxd

      implicit none
      private
      public :: savecdat,getcdat,sortdown,sortup

      contains

!#######################################################################
!
! COMPARISON DATA SETS. See also ../mctdh/compdat.F
!
!#######################################################################

      subroutine savecdat(nc)

use global
use griddatmod
use datenmod
use compdatmod
use compdat1mod

      implicit none

      integer(long)             :: n
      integer(long), intent(in) :: nc

      do n=1,npsiopt
         clpsiopt(n,nc)=lpsiopt(n)
      enddo

      cout2(nc)=out2

      return
      end subroutine savecdat

!#######################################################################

      subroutine getcdat(nc)

use global
use griddatmod
use datenmod
use compdatmod
use compdat1mod

      implicit none

      integer(long)             :: n
      integer(long), intent(in) :: nc

      do n=1,npsiopt
         lpsiopt(n)=clpsiopt(n,nc)
      enddo

      out2=cout2(nc)

      return
      end subroutine getcdat

!#######################################################################
!
! SORTUP
!
!#######################################################################

      subroutine sortup(vvmax,maxpoint,maxdim,maxv)

      implicit none

      integer(long)                                        :: i,j,p
      integer(long), intent(in)                            :: maxdim,maxv
      integer(long), dimension(maxdim,maxv), intent(inout) :: maxpoint
      real(dop)                                            :: v
      real(dop), dimension(maxv), intent(inout)            :: vvmax

      do i = 1, maxv-1
         if(vvmax(i) .gt. vvmax(i+1)) then
            v = vvmax(i+1)
            vvmax(i+1) = vvmax(i)
            vvmax(i) = v
            do j=1,maxdim
               p = maxpoint(j,i+1)
               maxpoint(j,i+1) = maxpoint(j,i)
               maxpoint(j,i) = p
            end do
         endif
      enddo

      return
      end subroutine sortup


!#######################################################################
!
! SORTDOWN
!
!#######################################################################


      subroutine sortdown(vvmin,minpoint,maxdim,maxv)

      implicit none

      integer(long)                                        :: i,j,p
      integer(long), intent(in)                            :: maxdim,maxv
      integer(long), dimension(maxdim,maxv), intent(inout) :: minpoint
      real(dop)                                            :: v
      real(dop), dimension(maxv), intent(inout)            :: vvmin

      do i = 1, maxv-1
         if(vvmin(i) .lt. vvmin(i+1)) then
            v = vvmin(i+1)
            vvmin(i+1) = vvmin(i)
            vvmin(i) = v
            do j=1,maxdim
               p = minpoint(j,i+1)
               minpoint(j,i+1) = minpoint(j,i)
               minpoint(j,i) = p
            end do
         endif
      enddo

      return
      end subroutine sortdown

      end module auswutil

