!#######################################################################
!
!#######################################################################

      program enqoper

use decimal, only: long,dop
use global
use maxv, only: maxdim,maxsta
use keyunitsmod
use dvrdatmod
use griddatmod
use rdopermod
use versions

use operdef
use dirdyn
use memdimmod
use file_enquire

      implicit none                                                     

      integer(long)   :: i,ilbl,chkdvr,chkgrd 
      logical(kind=4) :: lerr

      integer(long), external        :: myiargc
      integer(long)                  :: iarg
      character(len=80)              :: buf
      character(len=c5)              :: filename

!-----------------------------------------------------------------------
! Initialize variables
!-----------------------------------------------------------------------
      call default
      call adefault

      name = './'
      laenge = 2
      filename = 'oper'
      data_enquire = 0
      str_enquire = ' '

!-----------------------------------------------------------------------
! read options
! default: oper file is in current directory
!-----------------------------------------------------------------------
      iarg = myiargc()
      if (iarg .le. 0) then
         print*,'Enter a string for data to be printed, Use -h for help.'
         stop
      endif

      i = 0
 100  i=i+1
      call mygetarg(i,buf)
      if( buf(1:1) .eq. '-' ) then
         if(buf .eq. '-i') then
            i=i+1
            call mygetarg(i,buf)
            name = buf
            laenge=index(name,' ')-1
         else if(buf .eq. '-f') then
            i=i+1
            call mygetarg(i,buf)
            filename = buf
         else if(buf .eq. '-list') then
            i=i+1
            data_enquire=1
         else if( buf(1:2) .eq. '-h' .or. buf(1:2) .eq. '-?' ) then
            write(6,'(/,78a1,/)')  ('*',i=1,78)
            write(6,'(a)') ' Analyse program "enqoper" '
            write(6,'(1x,a/,11x,a)')&
       'Purpose : Reads the oper file to extract data.'
            write(6,'(1x,a)') 'Usage   : enqoper [-i -f -list -ver -h -?] data '
            write(6,'(a)') '  '
            write(6,'(a)') ' -i DIR  : Use DIR as name-directory.'
            write(6,'(2a,11x,a,/11x,a)') ' -f FILE : ',&
                     'read FILE rather than the default "oper"'
            write(6,'(a)') ' -list   : List data names that can be queried.'
            write(6,'(a)') &
           ' -ver    : Version information about the program.'
            write(6,'(a,/a)') &
            ' -h      : Print this help text. ',&
            ' -?      : Print this help text. '
            write(6,'(78a1)')  ('-',i=1,78)
            stop

         else if( buf(1:4) .eq. '-ver' ) then
            call wrversion(6)
            stop
         else
            write(6,'(2a)') ' unknown option : ', buf
            stop
         end if

         if (iarg .le. i) then
! finish reading options
            goto 200
         else
! get next option
            goto 100
         endif
      else
! move on to arguments
         continue
      end if

  200 continue

! if reading data set data_enquire
      if (data_enquire .eq. 0) data_enquire = 2
!
! first argument is task
!
      if (i .eq. iarg) then
         call mygetarg(i,buf)
         str_enquire = buf
      endif

      call abspath(name,laenge)
      ilbl=index(filename,' ')-1
      filename = name(1:laenge)//'/'//filename(1:ilbl)

!-----------------------------------------------------------------------
! open oper file
!-----------------------------------------------------------------------
      open(ioper,file=filename,form='unformatted',status='old',err=900)

!-----------------------------------------------------------------------
! get memory sizes
!-----------------------------------------------------------------------
      call rdmemdim(ioper)

!-----------------------------------------------------------------------
! Allocate memory
!-----------------------------------------------------------------------
      allocmemory=0
      call alloc_dvrdat
      call alloc_grddat
      call alloc_operdef
      call alloc_dirdyn
      call alloc_dddb
      call alloc_dercp
!                                                                       
      chck_enquire=.false.
      lerr=.false.
      chkdvr=1
      chkgrd=1
      call operinfo(lerr,chkdvr,chkgrd)

      close(ioper)
      call chksyserr(filename,lerr)
      if (lerr) go to 999

      if (data_enquire .eq. 2 .and. .not. chck_enquire) then
         print*,' Enquire string not found :',trim(str_enquire)
      endif

      call dealloc_dvrdat
      call dealloc_grddat
      call dealloc_operdef
      call dealloc_dirdyn
      call dealloc_dddb
      call dealloc_dercp

      stop                                                              
  900 print*,'ERROR opening oper file  ',trim(filename)
      stop                                                              
  999 continue
      write(6,'(a)') 'Error reading :'//filename(1:c5-15)
      stop

      end program enqoper
