program gui_sys

end program gui_sys

DOUBLE PRECISION FUNCTION y(x)
!USE nfw
double precision :: x
write(*,*) lmpi
y = x
return
END FUNCTION y

subroutine get_a_value(value_back)
      !
      !Subroutine to bring a value back
      ! Is a test

      character(15), intent(out)       :: value_back

      value_back = "Hola"
end subroutine

subroutine set_buffer_length(buffer, b_length)
      !Subroutine to check how long a file name is
      use decimal, only: long,dop,sip

      character(150)          ::buffer
      integer(long), INTENT(OUT)    :: b_length

     b_length=index(buffer,' ')-1

end subroutine

!Note that the array sizes get set as optional by F2PY so must be at end
!of the function options. Also output is not set in python script function call
subroutine set_inputs( int_list, info, flag_list, string_list, int_size, flag_size, str_size, output)
      !size of list must be passed as an input from python
      !set up defaults and variables for analysis
      use decimal, only: long,dop,sip
      use maxv
      use global
      use globmemmod
      use aglobal
      use versions
      use keyunitsmod
      use dvrdatmod
      use griddatmod
      use operdef
      use psidef
      use channels
      use datenmod
      use dirdyn
      use compdatmod
      use plot
      use plotutils
      use gapmod
       
      use op1lib, only: initvxi, zerovxd
      use logdat
      use iorst, only: rstinfo
      use iofile, only: rdpsiinfo
      use rddvrmod, only: dvrinfo
      use rdopermod, only: operinfo
      use zeigauswmod, only: zeigausw
      use memhopsmod, only: memhops
  
      use dd_db, only: getdbnrec
      ! 
      use module_interface

      use griddatmod
      use psidef
      use channels
      use datenmod
      use compdatmod
      use plot

      implicit none
  
      integer(long)            :: chkdvr
      integer(long)           :: chkgrd,chkdat,ilbl,chkpsi
      integer(long)           :: nrec, pytest
      character(len=c5)       :: filename
      logical(kind=4)         :: lerr,linwf,lexist
      integer(long)           :: slen

      !
      integer, INTENT(IN)           :: info
      integer, INTENT(IN)           ::  int_size
      integer, INTENT(IN)           :: flag_size
      integer, INTENT(IN)           ::  str_size
      logical, DIMENSION(flag_size), INTENT(in) ::  flag_list
      integer, DIMENSION(int_size), INTENT(in) :: int_list
      character *200,DIMENSION(str_size), INTENT(in)  :: string_list
      character(len=500), INTENT(OUT)                :: output
      
      !variables from subroutine showsysinput
      integer(long)           :: iarg,ierr,i,psilaenge
      logical(kind=4)         :: lnopes
      character(len=200)       :: buf
      !-----------------------------------------------------------------------
      ! Initialize variables
      !-----------------------------------------------------------------------
      call default
      call adefault
      lovwr = .true.
      chkdvr = 10
      !output = chkdvr
      !Load the input options
      !output = lovwr
      !-----------------------------------------------------------------------
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! Declare files to be read
      ! set flag to .true. if file is to be read
      !
      !     lrddvr    DVR file
      !     lrdoper   OPER file. This is set true if oper exists and lnopes
      !               false (set in showsysinput).
      !-----------------------------------------------------------------------
      lrddvr=.true.
      lrdoper=.false.

      !-----------------------------------------------------------------------
      ! read input options
      !-----------------------------------------------------------------------
      operfile  = ' '
      psifile  = ' '
      name  = './'
      fileout = 'surface.pl'
      ncut = 999999
      nskip=0
      zaxunit = 0.0_dop   ! Used as switch, whether unit set by option.

      lshowpsi=.true.
      lshowrst=.false.
      lpop2   =.false.
      lpop2all=.false.
      lnopes = .false.
      ldbsave = .true.
      !output = ncut

      !Read string variables
      name = string_list(1)
      dname = string_list(1)
      psifile = string_list(2)
      operfile = string_list(3)
      fileout = string_list(4)
      dirout = string_list(5) !Might need slash added at end
      !string_list(6) is unitlabel
      ddpath = string_list(7)

      !Read integer variables
      ncut = int_list(1)
      nskip = int_list(2)
      step = int_list(3)

      !Set boolean flags
      lshowpsi = flag_list(1)
      lnopes = flag_list(2)
      lrediab = flag_list(3)
      ldblocal = flag_list(4)
      lshowrst = flag_list(5)
      lnw = flag_list(6)
      lpop2 = flag_list(7)
      lpop2all = flag_list(8)


      !Get buffer lengths
      call set_buffer_length(name,laenge)
      call set_buffer_length(dname,dlaenge)
      call set_buffer_length(fileout,laeout)
      !-----------------------------------------------------------------------
      ! Open log file channel - in showsys, will do in python instead
      !-----------------------------------------------------------------------
      !-----------------------------------------------------------------------
      ! get memory sizes 
      !-----------------------------------------------------------------------
            if (lshowrst .or. lshowpsi) then
                  filename=name(1:laenge)//'/restart'
                  open(irst,file=filename,form='unformatted',status='old',err=1000)
                  call rdmemdim(irst)
                  close(irst)
            else

                  filename=name(1:laenge)//'/oper'
                  open(ioper,file=filename,form='unformatted',status='old',err=1000)
                  call rdmemdim(ioper)
                  close(ioper)
            endif

      !-----------------------------------------------------------------------
      !  Open data file
      !-----------------------------------------------------------------------
            write(*,*) 'Loading data'
            if (lshowrst) then
                  write(*,*) filename(1:slen(filename))
                  filename=psifile
                  open(irst,file=filename(1:slen(filename)),form='unformatted', &
                  status='old',err=1000)
                  !output = ' The restart file is : '//psifile(1:slen(psifile))
            elseif (lshowpsi) then
                  write(*,*) 'Loading psi2s'
                  filename=psifile
                  open(ipsi,file=filename(1:slen(filename)),form='unformatted', &
                  status='old',err=1000)
                  !output = ' The psi file is : '//psifile(1:slen(psifile))
            endif
      
      
            if (lrediab .and. .not. ldd) then
                  output = &
                  'ERROR: Not a DD calculation so cannot plot raw surfaces'
                  stop
            endif

      !-----------------------------------------------------------------------
      ! Allocate memory 
      !-----------------------------------------------------------------------
            allocmemory=0
            call alloc_dvrdat
            call alloc_grddat
            call alloc_operdef
            call alloc_dirdyn
            call alloc_dercp
            if (nbasis .eq. 0) nbasis=maxmoco
            call alloc_dirdyn_ddmctdh
            call alloc_dercp
            call alloc_gapkernel
            call alloc_psidef

      !-----------------------------------------------------------------------
      !  Read the system information
      !-----------------------------------------------------------------------
                  filename=dname(1:dlaenge)//'/dvr'
                  open(idvr,file=filename,form='unformatted',status='old',&
                  err=1000)
                  ilbl=index(filename,' ')-1
                  !output = ' The DVR file is : ',filename(1:ilbl)
                  chkdvr=1
                  call dvrinfo(lerr,chkdvr)
            
                  if (lerr) go to 999
                  close(idvr)
            
                  if (lrdoper) then
                  filename=operfile
                  open(ioper,file=filename,form='unformatted',status='old',&
                        err=1000)
                  ilbl=index(filename,' ')-1
                  !output = ' The operator file is : ',filename(1:ilbl)
                  chkdvr=2
                  chkgrd=1
                  call operinfo(lerr,chkdvr,chkgrd)
                  if (lerr) go to 999
                  close(ioper)
                  if (ldd .or. lddmctdh) then
                        lexist=.false.
                        inquire(file=ddname(1:ddlaenge)//'/geo.dba',exist=lexist)
                        if (lexist) then
                              output = ' The DD DB is in ascii format. First use convdb'
                        stop
                        endif
            
                        inquire(file=ddname(1:ddlaenge)//'/geo.db',exist=lexist)
                        if (lexist) then
                              !output = ' The DD DB is : ',ddname(1:ddlaenge)
                        else
                        write(6,'(2a)') ' Error: The DD DB is not found'
                        write(6,'(2a)') ' DB asked for is : ',ddname(1:ddlaenge)
                        write(6,'(a)') ' Use -DB keyord to specify path?'
                        stop
                        endif
                  endif
            
                  if (loptcontract) then
                        output = &
                  'Warning: Operator contains terms that mix KE and PE '
                        stop
                  endif
            
            ! if reading raw adiabatic data and multi-state, need to set this 
            ! flag to read the non-adiabatic couplings
                  if (lrediab .and. nddstate .gt. 1) ldiabdb = .true.
            ! allocate arrays to read raw data
                  if (lrediab) then
                        call getdbnrec(nrec)
                        call alloc_dirdyn_rediab(nrec,nddstate,ndofddpes)
                  endif
                  endif

!Got to line 190 of showsys
!-----------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Declare resources required (other than those needed to read a file)
!
! ncomp  : no. of comparison data sets to be used.
!          See auswutil.F for details of use of comparison sets
! lpsi   : wavefunction
! lpsi1  : second wavefunction
! lpsigrd : wavefunction to be used in grid representation (rather
!           than spf)
! ldmat  : density matrices for psi
! ldmat1 : density matrices for psi1
! lort   : grid coordinates
! lgpop  : grid populations
! ltrafo : FBR/DVR trafo matrices
! lfft   : FFT arrays rueck and fftfak
!-----------------------------------------------------------------------
                  ncomp=0
                  if (lshowpsi) then
                     lpsi=.true.
                  else
                     lpsi=.false.
                  endif
                  lpsi1=.false.
                  lpsigrd=.false.
                  ldmat=.true.
                  ldmat1=.false.
                  lort=.true.
                  lgpop=.false.
                  ltrafo=.true.
                  lfft=lpop2
            
            !-----------------------------------------------------------------------
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ! open input and output data files
            !
            ! use standard channels if possible
            !  irho : gridpop file
            !  ipsi : psi file
            !  iaut : auto file
            !  ichk : check file
            !  iaus : output file
            !-----------------------------------------------------------------------
            ! psifile is opened in showsysinput if required
            !     filename='psi'
            !     open(ipsi,file=filename,form='unformatted',status='old',err=1000)
            
            !-----------------------------------------------------------------------
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ! Read system information from property file(s)
            ! chkflags = 0   read information and ignore
            !            1   read information and store
            !            2   read information and check
            ! First read file version number
            !-----------------------------------------------------------------------
                  chkdvr=1
                  chkgrd=1
                  chkpsi=1
                  chkdat=1
                  if (lshowrst) then
                     filename='restart'
                     read(irst,err=999) filever(irst)
                     call rstinfo(linwf,lerr,chkdvr,chkgrd,chkpsi,chkdat)
                  elseif (lshowpsi) then
                     filename='psi'
                     read(ipsi,err=999) filever(ipsi)
                     call rdpsiinfo(ipsi,chkdvr,chkgrd,chkpsi,chkdat)
                  endif
                  if(dentype .gt.0 .and. lshowpsi) then
                     write(6,'(a)') 'Sorry, showsys cannot plot density-operators'
                     stop
                  endif
                  if(psitype.eq.5 .and. lshowpsi) then
                     routine='showsys'
                     message='Sorry, showsys cannot work with ML-wavefunctions.'
                     call errormsg
                  endif
            
            !-----------------------------------------------------------------------
            ! assign pointers and sizes for required arrays
            ! assign memory arrays
            !-----------------------------------------------------------------------
                  call zeigausw
                  call memausw
            
            !-----------------------------------------------------------------------
            ! here assign any further memory arrays
            !-----------------------------------------------------------------------
                  mrweight=mrdim
                  mrdim=mrweight+ortdim
                  mrpcent=mrdim
                  mrdim=mrpcent+qcentdim
            
                  miplt2ort=midim
                  midim=miplt2ort+ortdim
                  miort2plt=midim
                  midim=miort2plt+ortdim
            
            !-----------------------------------------------------------------------
            ! assign work arrays - redundant but needed for memeory allocation
            !-----------------------------------------------------------------------
                  mcworkc = mcdim
                  mrworkr = mrdim
                  miworki = midim
                  mlworkl = mldim
                  msworks = msdim
                  mfworkf = mfdim
            
            !-----------------------------------------------------------------------
            ! assign memory for operator
            !-----------------------------------------------------------------------
                  if (lrdoper) then
                     call memhops
                  else
                     mrhops=1
                  endif
            
            !-----------------------------------------------------------------------
            ! call routine
            !-----------------------------------------------------------------------
                  call wrversion(ilog)
                  ilbl = 16*mcdim+8*mrdim+4*midim+4*mldim+8*msdim+4*mfdim
                  write(ilog,'( 6(a,i10,/),a,i13,a,f10.2,a)') &
                   ' complex*16 : ', mcdim,&
                   ' real*8     : ', mrdim,&
                   ' integer    : ', midim,&
                   ' logical    : ', mldim,&
                   ' complex*8  : ', msdim,&
                   ' real*4     : ', mfdim,&
                   ' Total   : ', ilbl, ' Bytes ,', dble(ilbl)/1048576.0_dop,' MB'
                  call myflush(ilog)
            
            if(allocated(mc))deallocate(mc)
            if(allocated(mr))deallocate(mr)
            if(allocated(mi))deallocate(mi)
            if(allocated(ml))deallocate(ml)
            if(allocated(ms))deallocate(ms)
            if(allocated(mf))deallocate(mf)
            if(allocated(gfgwp))deallocate(gfgwp)
            if(allocated(aigwp))deallocate(aigwp)
            if(allocated(zgwp))deallocate(zgwp)
            if(allocated(gs2))deallocate(gs2)
            
            allocate(mc(mcdim))
            allocate(mr(mrdim))
            allocate(mi(midim))
            allocate(ml(mldim))
            allocate(ms(msdim))
            allocate(mf(mfdim))
            allocate(gfgwp(gfgwpdim))
            allocate(aigwp(aigwpdim))
            allocate(zgwp(zgwpdim))
            allocate(gs2(gs2matdim))





                  go to 1100
                  
            999 continue
                  message= 'Error reading :'//filename(1:c5-15)
                  output = message
                  go to 1100
            1000 continue
                  ilbl=index(filename,' ')-1
                  message = 'Cannot open file: '//filename(1:ilbl)
                  output = message
                  !call errormsg
                  go to 1100
            1100 continue
end subroutine set_inputs

module py_mod_con
      !This module is to be used to connect variables so python can get them
      use decimal, only: long,dop,sip

      integer(long)           :: chkdvr
end module py_mod_con
