      program inquire_rdqc

use decimal
use keyunitsmod
use ioqc
use readqc

      implicit none

      integer(long) :: iunit = 2, ilog=6

      integer(long) :: nmethod = 34  ! no. of different abintypes
      integer(long) :: istate,i,j,n
      integer(long) :: ifiletyp,imethod
      logical(kind=4) :: lfound,lfail

! Initialise Interface to QC output
      qc_ncoo = 1
      qc_nst = 1
      qc_nmode = 1
      qc_nbasis = 0
      call alloc_readqc(ilog)

      lfound=.false.
      lfail=.false.
      qc_enquire=.true.
      do ifiletyp = 1,12
         do imethod = 0,nmethod
            qcfound(:) = .false.
            call rdqcout(iunit,ifiletyp,imethod,ilog,lfound,lfail)

            call rdqc_implemented(ifiletyp,imethod,ilog)
         enddo
      enddo

! final blank line
      write(ilog,*)

      call dealloc_readqc

      stop

      contains

      subroutine rdqc_implemented(ifiletyp,imethod,ilog)

      implicit none

      integer(long), intent(in) :: ifiletyp,imethod,ilog
      character(len=40)         :: filetyp,method

      filetyp = ' '
      if (ifiletyp .eq. 1) then
         filetyp = " *** GAUSSIAN *** "
      else if (ifiletyp .eq. 2) then
         filetyp = " *** GAMESS-UK *** "
      else if (ifiletyp .eq. 3) then
         filetyp = " *** QOMMMA *** "
      else if (ifiletyp .eq. 4) then
         filetyp = " *** Bagel *** "
      else if (ifiletyp .eq. 5) then
         filetyp = " *** Molpro  *** "
      else if (ifiletyp .eq. 6) then
         filetyp = " *** DFT/MRCI *** "
      else if (ifiletyp .eq. 7) then
         filetyp = " *** Turbomole *** "
      else if (ifiletyp .eq. 8) then
         filetyp = " *** Gamess-US *** "
      else if (ifiletyp .eq. 10) then
         filetyp = " *** Q-Chem *** "
      else if (ifiletyp .eq. 11) then
         filetyp = " *** Molcas *** "
      else if (ifiletyp .eq. 12) then
         filetyp = " *** Orca *** "
      endif

      method = ' '
      if (imethod .eq. 1) then
         method = " RHF "
      else if (imethod .eq. 2) then
         method = " MP2 "
      else if (imethod .eq. 3) then
         method = " MP3 "
      else if (imethod .eq. 4) then
         method = " MP4 "
      else if (imethod .eq. 5) then
         method = " UHF "
      else if (imethod .eq. 6) then
         method = " ROHF "
      else if (imethod .eq. 9) then
         method = " ADC "
      else if (imethod .eq. 10) then
         method = " OVGF "
      else if (imethod .eq. 11) then
         method = " CIS "
      else if (imethod .eq. 12) then
         method = " CAS "
      else if (imethod .eq. 13) then
         method = " CASPT2 "
      else if (imethod .eq. 14) then
         method = " MRCI "
      else if (imethod .eq. 15) then
         method = " CAS/MRCI "
      else if (imethod .eq. 16) then
         method = "  "
      else if (imethod .eq. 17) then
         method = " EOM-CCSD "
      else if (imethod .eq. 18) then
         method = " DFT/MRCI "
      else if (imethod .eq. 19) then
         method = " DFT "
      else if (imethod .eq. 20) then
         method = " CR-EOM-CCSD(T) "
      else if (imethod .eq. 21) then
         method = " Delta-CR-EOM-CCSD(T) "
      else if (imethod .eq. 22) then
         method = " CCSD "
      else if (imethod .eq. 23) then
         method = " RI-CC2 "
      else if (imethod .eq. 24) then
         method = " TDDFT / PCM "
      else if (imethod .eq. 25) then
         method = " TDDFT / pt-ss-PCM "
      else if (imethod .eq. 26) then
         method = " local-ADC(2) "
      else if (imethod .eq. 27) then
         method = " MS-CASPT2 "
      else if (imethod .eq. 28) then
         method = " RMS-CASPT2 "
      else if (imethod .eq. 29) then
         method = " QoMMMa "
      else if (imethod .eq. 30) then
         method = " Ehrenfest "
      else if (imethod .eq. 31) then
         method = " External "
      else if (imethod .eq. 32) then
         method = " CAS/PT2 "
      else if (imethod .eq. 33) then
         method = " TDDFT "
      else if (imethod .eq. 34) then
         method = " MS-CASPT2 "
      else if (imethod .eq. 35) then
         method = " local-CC2 "

      endif
     
      if (imethod .eq. 0 .and. (filetyp .ne. '             ')) then
         write(ilog,'(/,a)') filetyp
         if (any(qcfound(1:2)) .eqv. .true.) then
            write(ilog,'(a)') ' Coordinates    Nmodes   Isotopes'
            write(ilog,'(3x,a,12x,a,6x,a)') (log2str(qcfound(i)),i=1,2),&
               log2str(qcfound(10))

            write(ilog,'(a)') &
              ' Method                  Ener  Grad  Hess  MOCO  NACT  DIP   TDIP  SOC'
         else 
            write(ilog,'(a)') ' Not Implemented '
         endif

      endif

      if (any(qcfound(3:12)) .eqv. .true.) then
         write(ilog,'(9(a,3x))') method(1:22),(log2str(qcfound(i)),i=3,9),&
            log2str(qcfound(11))
      endif

      return
      end subroutine rdqc_implemented

      function log2str(llogic)

      logical(kind=4), intent(in) :: llogic
      character(len=3)            :: log2str

      if (llogic) then
         log2str = ' Y '
      else
         log2str = '   '
      endif

      end function log2str
      
      end program inquire_rdqc


