
/** HDM  5/2004 ***************************************************
      program mmemtest
*******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int main( int argc, char *argv[]) {
    long    bytes,failed,steps,bb;
    size_t lbytes,lb;
    double mbytes,gbytes,rbytes,rbytes2;
    void *p;

    if (argc>1) {
        if ( strstr(argv[1], "-h") != NULL ) {
           printf("\n --- mmemtest : ");
           printf("A program to test how much memory can be allocated ---");
           printf("\n Usage   : mmemtest [-h] \n");
           printf(" Options : -h  Print this help text. \n");
           printf(" Run mmemtest on the computer,");
           printf(" on which you want to run a\n");
           printf(" program of the Quantics package.");
           printf(" Most Quantics-programs can use up to\n");
           printf(" 16 GB on 64 bit architectures with sufficient memory.\n");
           printf(" On 32 bit architectures one is limited to 2 GB.\n");
           printf("-----------------------------------------");
           printf("-------------------------------------- \n");
        }
        else
            printf(" Unknown option: %s . Try  `mmemtest -h'.\n",argv[1]);
        exit(0);
    }

    printf("\n --- mmemtest : ");
    printf("A program to test how much memory can be allocated ---\n");
    printf("\n int     : %d\n", sizeof(int));
    printf(" size_t  : %d   (should be 8 to allow to break the 2 GB limit)\n",
            sizeof(size_t));
    printf(" long int: %d   (should be 8 to allow to break the 2 GB limit)\n\n",
             sizeof(long int));

    bb=126900000*3/4;

    loop:;
    bb=2*bb/3;
    lb=1;
    failed=0;
    steps=0;

    for (bytes=bb; bytes>=0; bytes*=1.03) {
      steps=steps+1;
      lbytes = 32L*bytes;
       rbytes = 32.0 * (double) bytes;
       rbytes2 =  (rbytes - (double) lbytes)*(rbytes - (double) lbytes);
       if (rbytes2  > 0.5 ){
        printf("\n Integer overflow while allocating");
        printf("\n rbytes=%lf , lbytes=%ld, %lf GB\n",rbytes,lbytes,lbytes/1073741824.0);
        exit(0);
       }

        if(lbytes<lb) exit(0);
        lb=lbytes;
        mbytes = bytes/32768.0;
        gbytes = mbytes/1024.0;
        p = malloc(lbytes);
        if (p==NULL) {
          if(steps==1) goto loop;
          failed=failed+1;
          if (gbytes > 10.0){
            printf ("GB=%9.2f   bytes=%14lu   failed\n", gbytes, lbytes);
          }else{
            printf ("MB=%9.2f   bytes=%14lu   failed\n", mbytes, lbytes);
          }
      }
        else {
          if (gbytes > 10.0){
            printf ("GB=%9.2f   bytes=%14lu   allocated\n", gbytes, lbytes);
          }else{
            printf ("MB=%9.2f   bytes=%14lu   allocated\n", mbytes, lbytes);
          }
            free (p);
         }
        if (failed==1) exit(1);
        if (lbytes<=0) exit(2);
    }
    exit(0);
}

