'''
Python Script to connect to quantics DB
'''

import sqlite3

#Connect to sql database
con = sqlite3.connect('database.sql')
#create cursor to work in database
cursor = con.cursor()

#Get number of entries
cursor.execute("SELECT count(id) FROM dbentry;")
print(cursor.fetchall())

#Get version
cursor.execute("SELECT  dbversion FROM versions;")
dbvers=cursor.fetchall()[0]
print(dbvers[0])

#Get list of tables
cursor.execute("SELECT name FROM sqlite_master WHERE type='dbentry';")
print(cursor.fetchall())

#Get schema of table coord
cursor.execute("SELECT sql FROM sqlite_schema WHERE name='coord';")
print(cursor.fetchall())

#Get coordinates from geometry table for id 208
cursor.execute("SELECT * FROM nact INNER JOIN pes ON nact.id=pes.id WHERE nact.id = 5;")
geo = cursor.fetchall()
cursor.execute("SELECT nact.id,nact.dercp,pes.id,pes.eng_1_1 from nact INNER JOIN pes ON nact.id=pes.id;")
#Get coordinates from geometry table for id 208
cursor.execute("SELECT value FROM geo WHERE id=30;")
geo = cursor.fetchall()
print(geo)
#Get ref info
con.text_factory = str
cursor.execute("SELECT name FROM refdbrefgeom;")
atoms = cursor.fetchall()
print(atoms)
#cursor.execute("SELECT id FROM nmode WHERE nmdof = 11 AND value > 1.9")
#Convert into correct cartesian layout
coords = []
for index in range(0,len(geo),3):
    coords.append(str(geo[index][0]*0.529177) + "\t" + str(geo[index+1][0]*0.529177) + "\t" + str(geo[index+2][0]*0.529177))
    if index == len(geo)-3:
        break

for key, values in enumerate(coords):
#    print(str(atoms[key]) + "\t")
    print((str(atoms[key]).split("'")[1]) + "\t" + values)

#Close connection to file
con.close()
