# Python SQl scripts

This folder contains some python scripts to interact with an SQL database (specifically the Quantics DD database)

sql_info.py is an example of how to connect to a database and make some queries

python_sqlite.py contains various functions for access to the database

```python
def connect_db(db_name)
```
This creates the connection to a database called <db_name>.
Requires:
db_name - the filepath to the database
Returns: 
connect which is the sqlite3 object
curs which is the cursor to access the database

```python
def query_existing(src_cursor)
```
This gets information on which tables are present in the database.
Requires:
src_cursor - a cursor to a connected database
Returns:
tables - a list of tables names in the database

Uses the built in sqlite sqlite_master table

```python
def select_existing(src_cursor, select_text)
```
Access information from an existing DB
Performs the Select statement contained in select_text
Requires:
src_cursor -  a cursor to a connected database
select_text - the SQL statement to use
Returns:
tables - a tuple of the requested information
