      program rdggp

      use decimal
      use keyunitsmod
      use versions

      implicit none

      integer(long)      :: ichk,i,zeig,maxdim
      integer(long)      :: ndof,nmode,nstate,igwp
      integer(long)      :: ilbl,jlbl,m,s,gwpinfodim
      character(len=120) :: string
      integer(long), dimension(:,:), allocatable :: gwpdim,zgwpinfo
      integer(long), dimension(:), allocatable   :: igwpm
      logical(kind=4), dimension(:), allocatable :: gwpm
      real(dop), dimension(:), allocatable       :: ggp
      real(dop)                                  :: tinit,out1
      character(len=48)                          :: rdtag
      integer(long), external :: myiargc
      integer(long)           :: iarg
      character(len=80)       :: buf

      logical, external :: int2log

!-----------------------------------------------------------------------
! read options
!-----------------------------------------------------------------------
      iarg = myiargc()
      if (iarg .lt. 1) goto 2

      i = 0
   1  i=i+1
      if (myiargc() .ge. 1) then
         call mygetarg(i,buf)
         if( buf .eq. '-ver' ) then
            call wrversion(6)
            stop

         else if( buf .eq. '-h' .or.  buf .eq. '-?') then
            write(6,'(1x,a/,11x,a)') &
        'Purpose : Reads the Gross Gaussian Populations from "check" ',&
        'Usage   : rdggp [ -ver -h -?].'
            write(6,'(a)') ' Options : '
            write(6,'(a)')&
                     ' -ver    : Version information about the program '
            write(6,'(a,/a)') &
              ' -h      : Print this help text. ',&
              ' -?      : Print this help text. '
            stop
         else
            write(6,'(2a)') ' Unknown option :', buf
            write(6,'(2a)') ' Use option -h'
            stop
         end if
         if (iarg .le. i) goto 2
         goto 1

      end if

    2 continue


      ichk = 10
      open(ichk,file='check',form='unformatted')

! get dimensions of system
      do
   10    continue
         read(ichk,err=10,end=100) rdtag
         if (rdtag(1:1) .ne. '<') cycle

         ilbl=2
         jlbl=index(rdtag,'>')-1
         if (rdtag(ilbl:jlbl) .eq. 'maxdim') then
            read(ichk,err=999) maxdim
         else if (rdtag(ilbl:jlbl) .eq. 'ndof') then
            read(ichk,err=999) ndof
         else if (rdtag(ilbl:jlbl) .eq. 'nmode') then
            read(ichk,err=999) nmode
         else if (rdtag(ilbl:jlbl) .eq. 'nstate') then
            read(ichk,err=999) nstate
         else if (rdtag(ilbl:jlbl) .eq. 'lgwp') then
            read(ichk,err=999) igwp
         else if (rdtag(ilbl:jlbl) .eq. 'tinit') then
            read(ichk,err=999) tinit
         else if (rdtag(ilbl:jlbl) .eq. 'out1') then
            read(ichk,err=999) out1
         endif
      enddo
  100 continue

      if (nmode .eq. 0) then
         write(6,'(a)') 'ERROR: No modes found'
         stop
      endif
      if (igwp .eq. 0) then
         write(6,'(a)') 'ERROR: No GWPs in calculation'
         stop
      endif

      allocate(gwpm(maxdim))
      allocate(igwpm(maxdim))
      allocate(gwpdim(nmode,nstate))

! get system information
! gwpdim(m,s) nos. of GWPs
! gwpm(m) = true if gwp mode
      rewind(ichk)
      do
   20    continue
         read(ichk,err=20,end=200) rdtag
         if (rdtag(1:1) .ne. '<') cycle

         ilbl=2
         jlbl=index(rdtag,'>')-1
         if (rdtag(ilbl:jlbl) .eq. 'gwpm') then
            read(ichk,err=999) (igwpm(m),m=1,nmode)
            do m=1,nmode
               gwpm(m) = int2log(igwpm(m))
            enddo
         else if (rdtag(ilbl:jlbl) .eq. 'gwpdim') then
            read(ichk,err=999) ((gwpdim(m,s),m=1,nmode),s=1,nstate)
         endif
      enddo
  200 continue

      gwpinfodim=0
      zeig = 0
      do s=1,nstate
         do m=1,nmode
            zgwpinfo(m,s) = gwpinfodim+1
            gwpinfodim = gwpinfodim + gwpdim(m,s)
         enddo
      enddo

!----------------------------------------------------------------------- 
! Read GGPS
!----------------------------------------------------------------------- 
      allocate(ggp(gwpinfodim))

      rewind(ichk)
      do
! read next record - error means it is not a string so ignore and go on to next
   30    continue
         read(ichk,err=30,end=100) rdtag
         if (rdtag(1:1) .ne. '<') cycle

         ilbl=2
         jlbl=index(rdtag,'>')-1
         if (rdtag(ilbl:jlbl) .eq. 'ggp') then
            do s=1,nstate
               do m=1,nmode
                  if (.not. gwpm(m)) cycle
                  read(ichk,err=999) (ggp(zgwpinfo(m,s)+i),i=0,gwpdim(m,s)-1)
               enddo
            enddo
         endif

      enddo

  300 continue

      deallocate(ggp,gwpdim,igwpm,gwpm)

      stop

  999 print*,'ERROR: reading check file'
      stop
      end
