!***********************************************************************
!
!         MEMDVR 
!
! called from mctdh, potfit, and chnpot.
! calls logmem
!
! calculate pointers and dimensions for standard arrays.
!
!
! 10/96 AJ
!
!***********************************************************************

      subroutine memdvr

use decimal, only: long
use global
use globmemmod
use dvrdatmod

      implicit none

!-----------------------------------------------------------------------
! with the parameter "pdum" the pointers to arrays that are not
! used are initialized with the value one in order to avoid an abortion
! of the program when array bounds are checked (compiler option "-c").
!-----------------------------------------------------------------------
      integer(long), parameter :: pdum = 1

!-----------------------------------------------------------------------
! assign standard arrays to memory arrays
! mcdim, mrdim, midim and mldim are final addresses assigned in mc, 
!  mr, mi and ml. 
!-----------------------------------------------------------------------
! set pointers to complex arrays in memory array mc 
!-----------------------------------------------------------------------
      mcdim=1
      mchin=mcdim
      mcdim=mchin+fftdim
      mcrueck=mcdim
      mcdim=mcrueck+fftdim
      mcexphin=mcdim
      mcdim=mcexphin+expdim
      mcexprueck=mcdim
      mcdim=mcexprueck+expdim

!-----------------------------------------------------------------------
! set pointers to real arrays in memory array mr 
!-----------------------------------------------------------------------
      mrdim=1
      mrort=mrdim
      mrdim=mrort+ortdim
      mrtrafo=mrdim
      mrdim=mrtrafo+dvrdim
      mrdvrmat=mrdim
      mrdim=mrdvrmat+dvrdim*dvrord
      mrfftp=mrdim
      mrdim=mrfftp+fftdim
      mrkinsph = mrdim
      mrdim = mrkinsph+sphdim*3

!-----------------------------------------------------------------------
! set pointers to integer arrays in memory array mi 
!-----------------------------------------------------------------------
      midim   = 1
      mijsph = midim
      midim  = mijsph+sphdim
      mimsph = midim
      midim  = mimsph+sphdim
      mifftfak=midim
      midim=mifftfak+fftdim

!----------------------------------------------------------------------
! set pointers to logical arrays in memory array ml 
!-----------------------------------------------------------------------
      mldim   = 1

      return
      end subroutine memdvr


