!#######################################################################
!
!#######################################################################

      subroutine wrdvr(ort,trafo,dvrmat,fftp,hin,rueck,fftfak,exphin, &
                 exprueck,jsph,msph,kinsph)

use decimal, only: dop, long 
use global
use versions, only: progver
use dvrdatmod
use channels

use logdat
use iodvrdef, only: wrdvrdef

      implicit none

      integer(long)                                :: g,n,f
      integer(long), dimension(fftdim), intent(in) :: fftfak
      integer(long), dimension(sphdim), intent(in) :: jsph,msph

      real(dop), dimension(ortdim), intent(in)        :: ort
      real(dop), dimension(dvrdim), intent(in)        :: trafo
      real(dop), dimension(fftdim), intent(in)        :: fftp
      real(dop), dimension(dvrdim,dvrord), intent(in) :: dvrmat
      real(dop), dimension(3*sphdim), intent(in)      :: kinsph

      complex(dop), dimension(fftdim), intent(in) :: hin,rueck
      complex(dop), dimension(expdim), intent(in) :: exphin, exprueck
      character(len=8)                            :: stat
      character(len=100)                          :: buffer
      character(len=c2)                           :: wrtag   
      integer(long), external                     :: log2int

      routine='Wrdvr'

      if (lovwr) then
         stat='unknown'
      else
         stat='new'
      end if

      open(idvr,file=dname(1:dlaenge)//'/dvr',form='unformatted', &
           status=stat,err=999)

!-----------------------------------------------------------------------
! Program version used to write file
!-----------------------------------------------------------------------
      write(idvr) progver

!-----------------------------------------------------------------------
! write date and time of creation 
!-----------------------------------------------------------------------
      call fpstartup(buffer)
      wrtag='<create-date>'
      write(idvr) wrtag
      write(idvr) buffer

!-----------------------------------------------------------------------
! Parameters needed for array dimensioning
!-----------------------------------------------------------------------
      call wrmemdim(idvr)

!-----------------------------------------------------------------------
! write system definition 
!-----------------------------------------------------------------------
      call wrdvrdef(idvr)

      wrtag='<start dvr info>'
      write(idvr) wrtag

      wrtag='<ortdim>'
      write(idvr) wrtag
      write(idvr) ortdim
      wrtag='<dvrdim>'
      write(idvr) wrtag
      write(idvr) dvrdim
      wrtag='<fftdim>'
      write(idvr) wrtag
      write(idvr) fftdim
      wrtag='<expdim>'
      write(idvr) wrtag
      write(idvr) expdim
      wrtag='<sphdim>'
      write(idvr) wrtag
      write(idvr) sphdim

      wrtag='<zort>'
      write(idvr) wrtag
      write(idvr) (zort(f),f=1,ndof)
      wrtag='<zdvr>'
      write(idvr) wrtag
      write(idvr) (zdvr(f),f=1,ndof)
      wrtag='<zfft>'
      write(idvr) wrtag
      write(idvr) (zfft(f),f=1,ndof)
      wrtag='<zexp>'
      write(idvr) wrtag
      write(idvr) (zexp(f),f=1,ndof)
      wrtag='<zsph>'
      write(idvr) wrtag
      write(idvr) (zsph(f),f=1,ndof)

      wrtag='<end dvr info>'
      write(idvr) wrtag

!-----------------------------------------------------------------------
! write data sets 
!-----------------------------------------------------------------------
      wrtag='<ort>'
      write(idvr) wrtag
      write(idvr) (ort(g),g=1,ortdim)
      wrtag='<trafo>'
      write(idvr) wrtag
      write(idvr) (trafo(g),g=1,dvrdim)
      wrtag='<dvrord>'
      write(idvr) wrtag
      write(idvr) dvrord
      wrtag='<dvrmat>'
      write(idvr) wrtag
      write(idvr) ((dvrmat(g,n),g=1,dvrdim),n=1,dvrord)
      wrtag='<fftp>'
      write(idvr) wrtag
      write(idvr) (fftp(g),g=1,fftdim)
      wrtag='<hin>'
      write(idvr) wrtag
      write(idvr) (hin(g),g=1,fftdim)
      wrtag='<rueck>'
      write(idvr) wrtag
      write(idvr) (rueck(g),g=1,fftdim)
      wrtag='<fftfak>'
      write(idvr) wrtag
      write(idvr) (fftfak(g),g=1,fftdim)
      wrtag='<exphin>'
      write(idvr) wrtag
      write(idvr) (exphin(g),g=1,expdim)
      wrtag='<exprueck>'
      write(idvr) wrtag
      write(idvr) (exprueck(g),g=1,expdim)
      wrtag='<jsph>'
      write(idvr) wrtag
      write(idvr) (jsph(g),g=1,sphdim)
      wrtag='<msph>'
      write(idvr) wrtag
      write(idvr) (msph(g),g=1,sphdim)
      wrtag='<kinsph>'
      write(idvr) wrtag
      write(idvr) (kinsph(g),g=1,3*sphdim)

      wrtag='<end dvr data>'
      write(idvr) wrtag

      close(idvr)

      return
  999 continue
      message = 'Cannot open dvr file'
      call errormsg

      end subroutine wrdvr


