!#######################################################################
!
!#######################################################################
      module zeigdvrmod

use decimal, only: long
use global
use dvrdatmod

      implicit none
      private
      public :: zeigdvr
      contains

!-----------------------------------------------------------------------
      subroutine zeigdvr

      implicit none

      integer(long)       :: zeig,f

!-----------------------------------------------------------------------
! pointers for DVR representation matrices
!-----------------------------------------------------------------------
      zeig=1
      do f=1,ndof
         if (ldvr(f) .or. basis(f) .eq. 26) then
            zdvr(f)=zeig
            if (basis(f).eq.7 .or. basis(f).eq.20) then      ! KLeg , KLeg/R
!......The 2 was introduced (12.10.04,HDM) to account for dif3mat.
               zeig=zeig+2*gdim(f)*gdim(f)*gdim(f+1)         ! 2* 
            elseif (basis(f).eq.9 .or. basis(f).eq.21) then  ! PLeg , PLeg/R
               zeig=zeig+2*gdim(f)*gdim(f)*ipbaspar(3,f+1)   ! 2*
            elseif (basis(f).eq.33) then  ! Wigner
               zeig=zeig+2*gdim(f)*gdim(f)*ipbaspar(4,f)*ipbaspar(8,f)
            else
               zeig=zeig+gdim(f)*gdim(f)
            endif
         else
            zdvr(f) = 1
         endif
      enddo
      dvrdim=max(zeig-1,1)

!-----------------------------------------------------------------------
! pointers for FFT representation arrays
!-----------------------------------------------------------------------
      zeig=1
      do f=1,ndof
         if (basis(f).eq.4) then
            zfft(f)=zeig
            zeig=zeig+gdim(f)
         else
            zfft(f) = 1
         endif
      enddo
      fftdim=max(zeig-1,1)

!-----------------------------------------------------------------------
! pointers for the transformation arrays for the Exp-DVR
!-----------------------------------------------------------------------
      zeig=1
      do f=1,ndof
         if (basis(f).eq.5) then
            zexp(f)=zeig
            if (f.gt.1 .and. (basis(max(1,f-1)).eq.9 .or. &
                   basis(max(1,f-1)).eq.21)) then
               zeig=zeig+gdim(f)*ipbaspar(3,f)
            elseif (f.gt.1 .and. basis(max(1,f-1)).eq.33) then
               zeig=zeig+gdim(f)*ipbaspar(4,f-1)
            elseif (f.gt.2 .and. basis(max(1,f-2)).eq.33) then
               zeig=zeig+gdim(f)*ipbaspar(8,f-2)
            else
               zeig=zeig+gdim(f)**2
            endif
         else
            zexp(f)=1
         endif
      enddo
      expdim=max(zeig-1,1)
 
!-----------------------------------------------------------------------
! pointers for ort
!-----------------------------------------------------------------------
      zeig=1
      do f=1,ndof
         zort(f)=zeig
         zeig=zeig+gdim(f)
      enddo
      ortdim=zeig-1

!-----------------------------------------------------------------------
! pointers for FBR spherical harmonics representation arrays
!-----------------------------------------------------------------------
      zeig=1
      do f=1,ndof
         if (basis(f).eq.6) then
            zsph(f)=zeig
            zeig=zeig+gdim(f)
         else
            zsph(f) = 1
         endif
      enddo
      sphdim=max(zeig-1,1)

      return
      end subroutine zeigdvr

!#######################################################################

      end module zeigdvrmod

