
!***********************************************************************
!
!          MCTDH   subroutine MEMINWF
!
! called from mctdh
! calls memhops and logmem
!
! calculate pointers and dimensions for standard arrays for geninwf.
!
!***********************************************************************

      subroutine meminwf

use decimal, only: long,dop
use global
use globmemmod
use dvrdatmod
use griddatmod
use psidef
use operdef
use dirdyn
use runpropmod
use runinwfmod
use hpsimod
use crocoflymod
use memhopsmod

      implicit none

      integer(long), parameter :: pdum = 1
      integer(long)            :: dgldim1
!-----------------------------------------------------------------------
! with the parameter "pdum" the pointers to arrays that are not
! used are initialized with the value one in order to avoid an abortion
! of the program when array bounds are checked (compiler option "-c").
!-----------------------------------------------------------------------
!       workcdim=workcdim+20000

!-----------------------------------------------------------------------
! assign standard arrays to memory arrays
! mcdim, mrdim, midim and mldim are final addresses (lengths) of 
! mc, mr, mi and ml. 
!-----------------------------------------------------------------------
! set pointers to complex arrays in memory array mc 
!-----------------------------------------------------------------------
      dgldim1=1
      if(mez.gt.0) then               ! meigenf
         dgldim1=mxsdm*2
      endif
      if (inwfop(1) .gt. 0) then      ! operate
          dgldim1=max(dgldim1,dgldim)
      endif
 
      mcdim=1
      mcspf1d=mcdim
      mcdim=mcspf1d+spf1ddim
      mcintpsi=mcdim
      mcdim=mcintpsi+intpsidim
      if (inwfop(1) .gt. 0) then   ! operate  
         mchloch=mcdim
         mcdim=mchloch+hlochdim
         mchpsi=mcdim
         mcdim=mchpsi+hpsidim
         mchunpsi=mcdim
         mcdim=mchunpsi+totphidim
      else
         mchloch=pdum
         mchpsi=pdum
         mchunpsi=pdum
      endif
      if (iorthowf.gt.380) then   ! orthoWF
         mcpsiref=mcdim
         mcdim=mcdim+psirefdim 
         mcccdover=mcdim
         mcdim=mcdim+doverdim 
      else
         mcpsiref=mcdim
         mcccdover=mcdim
      endif
      if (lgwp) then
         mcadgwp = mcdim
         mcdim = mcadgwp+gsmatdim
      endif
      mcworkc = mcdim
      mcdim = mcworkc+workcdim

!-----------------------------------------------------------------------
! set pointers to real arrays in memory array mr 
!-----------------------------------------------------------------------
      mrdim=1
      mrort=mrdim
      mrdim=mrort+ortdim
      mrtrafo=mrdim
      mrdim=mrtrafo+dvrdim
      if (lgwp) then
         if (inwfop(1) .gt. 0) then
            mrqcent = mrdim
            mrdim   = mrqcent + qcentdim + 1
            mrgsval = mrdim
            mrdim   = mrgsval + gwpinfodim + 1
         else
            mrqcent = mrdim
            mrdim   = mrqcent + 1
            mrgsval = mrdim
            mrdim   = mrgsval + 1
         endif
      endif
      mrintr=mrdim
      mrdim=mrintr+intrdim
      mrworkr=mrdim
      mrdim=mrworkr+workrdim

!-----------------------------------------------------------------------
! set pointers to integer arrays in memory array mi 
!-----------------------------------------------------------------------
      midim  = 1
      mijsph = midim
      midim  = mijsph+sphdim
      mimsph = midim
      midim  = mimsph+sphdim
      if (citype .gt. 0) then
         mijindx = midim
         jindxdim = adim
         midim = mijindx+jindxdim
      else
         jindxdim = 1
         mijindx = pdum
      endif
      if (ltraj) then
         mitrajst = midim
         midim   = mitrajst + gwpinfodim + 1
      else
         mitrajst = pdum
      endif
     if (lgwp .and. inwfop(1) .gt. 0) then
         migwpdep = midim
         midim = migwpdep + gwpinfodim + 1
      else
         migwpdep = midim
         midim = migwpdep + 1
      endif
      miworki = midim
      midim   = miworki+workidim

!----------------------------------------------------------------------
! set pointers to logical arrays in memory array ml 
!-----------------------------------------------------------------------
      mldim   = 1
      mlworkl = mldim
      mldim   = mlworkl+workldim

!-----------------------------------------------------------------------
! add space for operator data
!-----------------------------------------------------------------------
      call memhops

      return
      end subroutine meminwf



