!#######################################################################
!
!              MCTDH  module HEINDEF
!
! MCTDH module to read the op_define-section
!
!            Subroutine      HEINOPDEF
!
! Reads the data defining the Hamiltonian.
! Called from: heingabe
! Calls to: warnmsg, errormsg
!
! 03/97 HDM
!
!#######################################################################

      subroutine heinopdef(loperr,iz)

use decimal, only: long,dop
use global
use maxv, only: maxdim,maxsta,maxkoe
use griddatmod
use operdef
use runopermod
use channels

use logdat

      implicit none

      integer(long)                  :: ic,ierr,i,iz0
      integer(long), intent(in)      :: iz
      logical(kind=4), intent(inout) :: loperr

      routine='Heinopdef'

      iz0 = 0

!-----------------------------------------------------------------------
! READ KEYWORDS:
!-----------------------------------------------------------------------
   10 continue
      call rdinpf(iop,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      message = inptit
      call cntrl(keyword(1),lc(1),ierr)

      i=1
   15 continue
      if (keyword(i) .eq. 'end-op_define-section') then
         goto 20

      else if( keyword(1) .eq. 'title' .or. &
               keyword(1) .eq. 'titel' ) then
         write(ilog,'(/,a,/)')  '***** Hamiltonian title *****'

  100    continue
         call rdinpf(iop,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
         if (ierr .eq. 1) then
            message = 'No "end-title" found'
            call warnmsg
         endif

         if (keyword(1) .eq. 'end-title' .or. &
             keyword(1) .eq. 'end-titel' ) then
            goto 10
         else
            write(ilog,'(a)') trim(inptit(1:80))
            go to 100
         endif

      else
         message = ' unknown keyword : '
         call wrline(i,iz,iz0)

      endif

!-----------------------------------------------------------------------
! check if more keywords are to be read, else read new line
!-----------------------------------------------------------------------
      if (i.lt.ic) then
         i=i+1
         go to 15
      else
         go to 10
      endif

   20 continue
      write(ilog,'(/,a)') '***** End Hamiltonian title *****'

!-----------------------------------------------------------------------
! After any call of 'warnmsg' (which is also called by 'wrline') the
! logical 'lwarn' is set to true.
!-----------------------------------------------------------------------
      loperr=lwarn.or.loperr
      lwarn=.false.

      return
      end subroutine heinopdef



