!#######################################################################
!
! hintern.F  : rdops,  rdallgop,  rdallgopa, rdregop, rdregopa, localisenp
!
!#######################################################################
      module hintern

use decimal, only: long, dop
use logdat
use op1lib,  only: zeromxd, cpvxi, cpvxd

      implicit none
      private
      public :: rdops
      contains

!#######################################################################

      subroutine rdops(rdop,ort)

use decimal, only: vlong
use global
use maxv, only: maxdim,maxhop
use dvrdatmod
use griddatmod
use operdef
use runopermod
use channels
use rdnatpot

      implicit none

      integer(long)       :: g,nr,f,p,nop,n,m,nn,nmode1,f1,m1,nm,zeig2,ndof1,&
                             chkdvr,chkgrd,ilbl,jlbl,i,n1,ic,iz,ierr,n2,n11,&
                             ilbl1,ilbl2,cpdrank

      integer(long), dimension(maxhop)       :: type, gdim1
      integer(long), dimension(maxdim)       :: mdvr,mmode,nspfdof1,subdim1,&
                                                pntbas,vgdim1,ngdim1,fdvr

      integer(long), dimension(maxdim,maxdim)       :: spfdof1
      integer(long)                                 :: slen

      real(dop)                                     :: coeff
      real(dop), dimension(maxdim)                  :: lpnt,wl,wr,swl,swr
      real(dop), dimension(rdopdim)                 :: rdopn
      real(dop), dimension(rdopdim), intent(out)    :: rdop
      real(dop), dimension(ortdim), intent(in)      :: ort
      integer(vlong)                                :: ipnt
      character(len=c5)                             :: filename
      character(len=6)                              :: testline
      logical(kind=4)                               :: lerr
      logical(kind=4), dimension(maxdim)            :: loned
      character(len=c2)                             :: rdtag

      pntbas=0
!-----------------------------------------------------------------------
! see if any operators are to be read from files
!-----------------------------------------------------------------------
      n=0
      n1=0
      n11=0
      n2=0
      iz=0
      do nr=1,nrdf
         filename=rdfiles(nr)
         jlbl=index(filename,' ')-1
         ilbl=jlbl-5
         ilbl1=jlbl-2
         ilbl2=jlbl-3
         if (filename(ilbl:jlbl) .eq. 'natpot') then
            open(inpot,file=filename,form='unformatted', &
                 status='unknown',err=999)

!----------------------------------------------------------------------
! read information in the natpot file 
! check the combinations of the degrees of freedom in mctdh
! and in potfit are consistent
!----------------------------------------------------------------------
            chkgrd=3
            if(npignore(nr).le.0) then
               chkdvr=3
               call npotinfo(inpot,lerr,modc,loned,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,nspfdof1,spfdof1,nmode1, &
                    subdim1,pntbas)
            else          ! if ignore is set for natpot
               chkdvr=4   ! fdvr is used but not set.
               do i=2,npignore(nr)
                  call cpvxi(mulddof2(1,npmuld(nr,i)),fdvr,ndof)
!................ npotinfo with iwrt=-1 checks the DVR-grids only.
                  call npotinfo(inpot,lerr,modc,loned,ndof1,fdvr,chkdvr, &
                  chkgrd,-1,mdvr,mmode,nspfdof1,spfdof1,nmode1,&
                  subdim1,pntbas)
                  rewind inpot
               enddo
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
               call npotinfo(inpot,lerr,modc,loned,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,nspfdof1,spfdof1,nmode1, &
                    subdim1,pntbas)
            endif

            if (filever(inpot) .ge. 11.0000_dop) then
               rewind(inpot)
               do
! read next record - error means it is not a string so ignore and go on to next
   10            continue
                 read(inpot,err=10,end=15) rdtag
                 if (rdtag(1:1) .ne. '<') cycle

                 ilbl=2
                 jlbl=index(rdtag,'>')-1
                 if (rdtag(ilbl:jlbl-10) .eq. 'oned') then
                    read(rdtag(jlbl-9:jlbl),'(i10)') f
                    n=n+1
                    f1=fdvr(f)
                    read(inpot,err=40) (rdop(zrdop(n)-1+g),g=1,gdim(f1))

                 else if (rdtag(ilbl:jlbl) .eq. 'vectors') then
                     do m=1,nmode1
                        do p=1,pdim(m)
                           n=n+1
                           nn=min(n,maxhop)
                           read(inpot,err=40) &
                                (rdop(zrdop(nn)-1+g),g=1,subdim1(m))
!-----------------------------------------------------------------------
! if mode was a point DVR in potfit, copy first element of rdop to
! complete natpot
!
! for a 2D DVR copy vector read in across matrix, taking into account
! whether 1D potfit is for DOF = 1 or 2.
!-----------------------------------------------------------------------
                           m1 = mmode(m)
                           if (lpntdvr .and. (subdim(m1).ne.subdim1(m))) then
!-----------------------------------------------------------------------------
! calculate grid dimensions (vgdim1, gdim1, ngdim1) for each mode of the 
! natpot with point dvr.
!-----------------------------------------------------------------------------
!#########
                               zeig2=1
                               do n11=1,nspfdof1(m)
                                  f=spfdof1(n11,m)

                                  if (pntbas(f) .eq. 19) then
                                     vgdim1(f) = zeig2
                                     ngdim1(f) = 1
                                    do n2=n11+1,nspfdof1(m)
                                       f1=spfdof1(n2,m)
                                       if (pntbas(f1) .ne. 19)  &
                                          ngdim1(f) = ngdim1(f)*gdim(f1)
                                    enddo

                                  call cpntmc(rdop(zrdop(nn)),rdopn, &
                                       vgdim1(f),gdim(f),ngdim1(f))

                                   call cpvxd(rdopn,rdop(zrdop(nn)), &
                                        vgdim1(f)*gdim(f)*ngdim1(f))

                                     zeig2=zeig2*gdim(f)
                                  else 
!                                     gdim1(f) = gdim(f) 
                                     zeig2=zeig2*gdim(f)
                                  endif
                               enddo
!########
                           endif
                        enddo
                     enddo

                  else if (rdtag(ilbl:jlbl) .eq. 'end natpots') then
                     exit

                  endif

               enddo

   15          continue

            else if (filever(inpot) .ge. 8.2006_dop) then
               do m=1,nmode1
                  do nn=1,nspfdof1(m)
                     f=spfdof1(nn,m)
                     if (loned(f)) then
                         n=n+1
                         f1=fdvr(f)
                         read(inpot,err=40)  &
                              (rdop(zrdop(n)-1+g),g=1,gdim(f1))
                     endif
                  enddo
               enddo

!----------------------------------------------------------------------  
! if the degrees are combined in potfit 
! the natpot operators can be  particle operators
!---------------------------------------------------------------------
               do m=1,nmode1
                  do p=1,pdim(m)
                     n=n+1
                     nn=min(n,maxhop)
                     read(inpot,err=40) &
                          (rdop(zrdop(nn)-1+g),g=1,subdim1(m))
!-----------------------------------------------------------------------
! if mode was a point DVR in potfit, copy first element of rdop to
! complete natpot
!
! for a 2D DVR copy vector read in across matrix, taking into account
! whether 1D potfit is for DOF = 1 or 2.
!-----------------------------------------------------------------------
                     m1 = mmode(m)
                     if (lpntdvr .and. (subdim(m1).ne.subdim1(m))) then
!----------------------------------------------------------------------------------------------
! calculate grid dimensions (vgdim1, gdim1, ngdim1) for each mode of the natpot with point dvr.
!----------------------------------------------------------------------------------------------
!#########
                         zeig2=1
                         do n11=1,nspfdof1(m)
                            f=spfdof1(n11,m)

                            if (pntbas(f) .eq. 19) then
                               vgdim1(f) = zeig2
                               ngdim1(f) = 1
                              do n2=n11+1,nspfdof1(m)
                                 f1=spfdof1(n2,m)
                                 if (pntbas(f1) .ne. 19)  &
                                    ngdim1(f) = ngdim1(f)*gdim(f1)
                              enddo

                            call cpntmc(rdop(zrdop(nn)),rdopn, &
                                 vgdim1(f),gdim(f),ngdim1(f))

                             call cpvxd(rdopn,rdop(zrdop(nn)), &
                                  vgdim1(f)*gdim(f)*ngdim1(f))

                               zeig2=zeig2*gdim(f)
                            else 
!                               gdim1(f) = gdim(f) 
                               zeig2=zeig2*gdim(f)
                            endif
                         enddo
!########
                     endif
                  enddo
               enddo
   
            else ! filever .lt. 8.2006
               do m=1,nmode1
                  do nn=1,nspfdof1(m)
                     f=spfdof1(nn,m)
                     if (loned(f)) then
                         n=n+1
                         f1=fdvr(f)
                         read(inpot,err=40)  &
                              (rdop(zrdop(n)-1+g),g=1,gdim(f1))
                     endif
                  enddo
               enddo

               do f=1,ndof1
                  do p=1,pdim(f)
                     n=n+1
                     f1=fdvr(f)
                     read(inpot,err=40)  &
                         (rdop(zrdop(n)-1+g),g=1,gdim(f1))
                  enddo
               enddo
            endif
!........End reading natpots.

!
! muliply by switching (localisation) function
!
            if (nplocal(nr) .gt. 0) then

               rewind(iop)
!-----------------------------------------------------------------------
! READ REFERENCE POINT
!-----------------------------------------------------------------------
   20          continue
               call rdinpf(iop,keyword,keyorig,inptit,lc,ic,iz,ierr, &
                    maxkey)
               message = inptit
               call cntrl(keyword(1),lc(1),ierr)

               i=1
               if (keyword(i)(1:16) .eq. 'refpoint-section') then
                  ilbl=18
                  jlbl=index(keyword(i),' ')-1
                  read(keyword(i)(ilbl:jlbl),*) ipnt
                  if (nplocal(nr) .eq. ipnt) then
                     do f=1,ndof
                        call rdinpf(iop,keyword,keyorig,inptit,lc,ic,iz, &
                             ierr,maxkey)
                        read(keyword(3),*) lpnt(f) 
                        read(keyword(5),*) wl(f) 
                        read(keyword(7),*) wr(f) 
                        read(keyword(9),*) swl(f) 
                        read(keyword(11),*) swr(f) 
                     enddo
                  else 
                     go to 20
                  endif
               else
                  goto 20
               endif

               n=n1
               do m=1,nmode1
                  do p=1,pdim(m)
                     n=n+1
                     nn=min(n,maxhop)
                     if (nspfdof1(m) .eq. 1) then
                        f=spfdof1(1,m)
                        f1=fdvr(f)
                        if (f1 .gt. 0) then
                           call localisenp(rdop(zrdop(n)),ort(zort(f1)), &
                                 lpnt(f1),wl(f1),wr(f1),swl(f1),swr(f1), &
                                 1,gdim(f1),1)
                        endif
                     else
                        do nm=1,nspfdof1(m)
                           f=spfdof1(nm,m)
                           f1=fdvr(f)
                           if (f1 .gt. 0) then
                              call localisenp(rdop(zrdop(n)), &
                                 ort(zort(f1)), &
                                 lpnt(f1),wl(f1),wr(f1),swl(f1),swr(f1), &
                                 vgdim(f1),gdim(f1),ngdim(f1))
                           endif
                        enddo
                    endif

                  enddo
               enddo
               
            endif

!
! store no. of natpot vector read in
!
            n1=n

         elseif (filename(max(1,jlbl-7):jlbl).eq."mlpf.dat") then
!---------------------------------------------------------------------
! Multi-Layer Potfit data files.
! These have already been read, checked, and are stored in memory.
!---------------------------------------------------------------------
            lmlop = .true.
            continue

!!!!!!!!HCPD this needs to come before cpd
         elseif (filename(ilbl2:jlbl) .eq. 'hcpd') then

            open(iop,file=filename,form='unformatted', &
                 status='unknown',err=999)

            chkgrd=3
            if(npignore(nr).le.0) then
               chkdvr=3
               call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,cpdrank,nspfdof1, &
                    spfdof1,nmode1,subdim1,loned,pntbas)
            else          ! if ignore is set for natpot
               chkdvr=4   ! fdvr is used but not set.
               do i=2,npignore(nr)
                  call cpvxi(mulddof2(1,npmuld(nr,i)),fdvr,ndof)
!................ cpdinfo with iwrt=-1 checks the DVR-grids only.
                  call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                       chkgrd,-1,mdvr,mmode,cpdrank,nspfdof1, &
                       spfdof1,nmode1,subdim1,loned,pntbas)
                  rewind iop
               enddo
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
               call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,cpdrank,nspfdof1, &
                    spfdof1,nmode1,subdim1,loned,pntbas)
            endif


            do m=1,nmode1
               do nn=1,nspfdof1(m)
                  f=spfdof1(nn,m)
                  if (loned(f)) then
                      n=n+1
                      f1=fdvr(f)
                      read(iop,err=40) (rdop(zrdop(n)-1+g),g=1,gdim(f1))
                  endif
                enddo
            enddo

!----------------------------------------------------------------------
! read hcpd terms
!---------------------------------------------------------------------
            do p=1,cpdrank
               read(iop,err=40) coeff

               do m=1,nmode1
                  n=n+1
                  nn=min(n,maxhop)
                  read(iop,err=40) (rdop(zrdop(nn)-1+g),g=1,subdim1(m)**2)

                  ! miltply the first term with the coeff
                  if (m.eq.1) then
                     do g=1,subdim1(m)**2
                        rdop(zrdop(nn)-1+g) = rdop(zrdop(nn)-1+g)*coeff
                     end do
                  end if
               enddo

            enddo

         elseif (filename(ilbl1:jlbl) .eq. 'cpd') then

            open(iop,file=filename,form='unformatted',status='unknown',err=999)

            chkgrd=3
            if(npignore(nr).le.0) then
               chkdvr=3
               call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,cpdrank,nspfdof1, &
                    spfdof1,nmode1,subdim1,loned,pntbas)
            else          ! if ignore is set for natpot
               chkdvr=4   ! fdvr is used but not set.
               do i=2,npignore(nr)
                  call cpvxi(mulddof2(1,npmuld(nr,i)),fdvr,ndof)
!................ cpdinfo with iwrt=-1 checks the DVR-grids only.
                  call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                       chkgrd,-1,mdvr,mmode,cpdrank,nspfdof1, &
                       spfdof1,nmode1,subdim1,loned,pntbas)
                  rewind iop
               enddo
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
               call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                    chkgrd,0,mdvr,mmode,cpdrank,nspfdof1, &
                    spfdof1,nmode1,subdim1,loned,pntbas)
            endif


            do m=1,nmode1
               do nn=1,nspfdof1(m)
                  f=spfdof1(nn,m)
                  if (loned(f)) then
                      n=n+1
                      f1=fdvr(f)
                      read(iop,err=40) (rdop(zrdop(n)-1+g),g=1,gdim(f1))
                  endif
                enddo
            enddo
!----------------------------------------------------------------------
! read cpd terms
!---------------------------------------------------------------------
            do p=1,cpdrank
               read(iop,err=40) coeff

               do m=1,nmode1
                  n=n+1
                  nn=min(n,maxhop)
                  read(iop,err=40) (rdop(zrdop(nn)-1+g),g=1,subdim1(m))

                  ! moltply the first term with the coeff
                  if (m.eq.1) then
                     do g=1,subdim1(m)
                        rdop(zrdop(nn)-1+g) = rdop(zrdop(nn)-1+g)*coeff
                     end do
                  end if
               enddo

            enddo

!........Read readmap-files.
         elseif(filename(jlbl-6:jlbl) .eq. 'readmap') then

!........Check type (formated/unformated first)
            open(iop,file=filename,form='formatted',status='old',err=999)

            read(iop,*,err=60) nop
            do n1=1,nop
               n=n+1
               read(iop,*,err=60) type(n)
            enddo
            n=n-nop
            do n1=1,nop
               n=n+1
               rdop(zrdop(n))=type(n)
               do i=1,3
                  read(iop,*,err=60) (rdop(zrdop(n)+g+(i-1)*type(n)) &
                                           ,g=1,type(n))
               enddo

            enddo

!........Read read-files.
         else
!........Check type (formated/unformated first)
            open(iop,file=filename,form='formatted', &
                 status='old',err=999)
            read(iop,*,err=41) testline
            if(testline.ne.'ascii' .and. testline.ne.'ASCII') goto 41
!..... ascii file
            read(iop,*,err=50) nop
            do n1=1,nop
               n=n+1
               read(iop,*,err=50) gdim1(n),type(n)
            enddo
            n=n-nop
            do n1=1,nop
               n=n+1
               if (type(n) .eq. 2) then
                  read(iop,*,err=50) (rdop(zrdop(n)-1+g),g=1,gdim1(n))
               else if (type(n) .eq. 1) then
                  call rdallgopa(iop,rdop(zrdop(n)),gdim1(n))
               else if (type(n) .eq. 3) then
                  call rdregopa(iop,rdop(zrdop(n)),gdim1(n))
               endif
            enddo
            goto 42
 
!..... binary file
  41        close(iop)
            open(iop,file=filename,form='unformatted', &
                 status='old',err=999)
            read(iop,err=50) nop
            do n1=1,nop
               n=n+1
               read(iop,err=50) gdim1(n),type(n)
            enddo
            n=n-nop
            do n1=1,nop
               n=n+1
               if (type(n) .eq. 2) then
                  read(iop,err=50) (rdop(zrdop(n)-1+g),g=1,gdim1(n))
               else if (type(n) .eq. 1) then
                  call rdallgop(iop,rdop(zrdop(n)),gdim1(n))
               else if (type(n) .eq. 3) then
                  call rdregop(iop,rdop(zrdop(n)),gdim1(n))
               endif
            enddo
 42         continue

         endif   ! (natpot/read-file)

         close(inpot)
      enddo

      return
   40 routine='hintern.F : Rdops'
      jlbl=slen(filename)
      message = 'Error reading natpots: '//filename(1:jlbl)
      call errormsg
   50 routine='hintern.F : Rdops'
      jlbl=slen(filename)
      message = 'Error reading read-files: '//filename(1:jlbl)
      call errormsg
   60 routine='hintern.F : Rdops'
      jlbl=slen(filename)
      message = 'Error reading readmap-files: '//filename(1:jlbl)
      call errormsg
  999 continue
      routine='Rdops'
      jlbl=slen(filename)
      message = 'Cannot open file: '//filename(1:jlbl)
      call errormsg

      end subroutine rdops

!#######################################################################

      subroutine rdallgop(inpot,rdop,gdim)

      implicit none

      integer(long)                                  :: g,g1
      integer(long), intent(in)                      :: gdim,inpot
      real(dop), dimension(gdim,gdim,2), intent(out) :: rdop

      read(inpot) ((rdop(g,g1,1),g=1,gdim),g1=1,gdim)
      read(inpot) ((rdop(g,g1,2),g=1,gdim),g1=1,gdim)

      return
      end subroutine rdallgop
!#######################################################################

      subroutine rdallgopa(iop,rdop,gdim)

      implicit none

      integer(long)                                  :: g,g1
      integer(long), intent(in)                      :: gdim,iop
      real(dop), dimension(gdim,gdim,2), intent(out) :: rdop

      read(iop,*) ((rdop(g,g1,1),g=1,gdim),g1=1,gdim)
      read(iop,*) ((rdop(g,g1,2),g=1,gdim),g1=1,gdim)

      return
      end subroutine rdallgopa
!#######################################################################

      subroutine rdregop(iop,rdop,gdim)

      implicit none

      integer(long)                                  :: g,g1
      integer(long), intent(in)                      :: gdim,iop
      real(dop), dimension(gdim,gdim,2), intent(out) :: rdop

      read(iop) ((rdop(g,g1,1),g=1,gdim),g1=1,gdim)
      call zeromxd(rdop(1,1,2),gdim,gdim)

      return
      end subroutine rdregop
!#######################################################################

      subroutine rdregopa(iop,rdop,gdim)

      implicit none

      integer(long)                                  :: g,g1
      integer(long), intent(in)                      :: gdim,iop
      real(dop), dimension(gdim,gdim,2), intent(out) :: rdop

      read(iop,*) ((rdop(g,g1,1),g=1,gdim),g1=1,gdim)
      call zeromxd(rdop(1,1,2),gdim,gdim)

      return
      end subroutine rdregopa
!#######################################################################

      subroutine localisenp(npvector,ort,lpnt,wl,wr,swl,swr,vgdim1, &
                            gdim1,ngdim1)

use global

      implicit none

      integer(long)                                            :: v,g,n
      integer(long), intent(in)                                :: vgdim1,gdim1,ngdim1
      real(dop)                                                :: lfunc,delta
      real(dop), intent(in)                                    :: lpnt,wl,wr,swl,swr
      real(dop), dimension(gdim1), intent(in)                  :: ort
      real(dop), dimension(vgdim1,gdim1,ngdim1), intent(inout) :: npvector


! initialise variables
      lfunc = 0.0_dop

      do g=1,gdim1
          if (ort(g).gt.(lpnt - wl).and.ort(g).lt.(lpnt + wr)) then
              lfunc = 1.0_dop
          else if (ort(g).le.(lpnt - wl)) then

!CC One needs to optimize parameter(3._dop/swl), which depends on the energy 
!CC difference between two different parts
!CC Till now my experience says its value is close to 1.0 or less than 1.0!!!! 

!              delta = dabs((ort(g) - lpnt + wl)*3.0_dop/swl)**4
              delta = dabs((ort(g) - lpnt + wl)*1.825_dop/swl)**4
              lfunc = dexp(-delta)
          else if (ort(g).ge.(lpnt + wr)) then
!              delta = dabs((ort(g) - lpnt - wr)*3.0_dop/swr)**4
              delta = dabs((ort(g) - lpnt - wr)*1.825_dop/swr)**4
              lfunc = dexp(-delta)
          endif

         do v = 1,vgdim1
            do n=1,ngdim1
               npvector(v,g,n) = lfunc*npvector(v,g,n)
                 if (abs(npvector(v,g,n)) .lt. tiny) then 
                   npvector(v,g,n) = 0.0_dop
                 endif
            enddo
         enddo
      enddo

      return
      end subroutine localisenp

!#######################################################################
      subroutine cpntmc(vecold,vecnew,vgdim,gdim,ngdim)

use global

      implicit none

      integer(long), intent(in)                           :: vgdim,gdim,ngdim
      integer(long)                                       :: v,g,n
      real(dop), dimension(vgdim,gdim,ngdim), intent(out) :: vecnew
      real(dop), dimension(vgdim,1,ngdim), intent(in)     :: vecold

      do n=1,ngdim
         do g=1,gdim
            do v=1,vgdim
               vecnew(v,g,n)= vecold(v,1,n)
            enddo
         enddo
      enddo

      return
      end subroutine cpntmc

      end module hintern


