!#######################################################################
!
! MCTDH-module zeiger
!
! calculates pointer structure and allocates the memory arrays to the
!  standard variable arrays.
!
!#######################################################################

!***********************************************************************
!
!          MCTDH   subroutine ZEIGER
!
! called from main and auswert
! calls maxmatwk
!
! calculate pointers and dimensions for standard arrays.
!
!
! 10/96 aJ
!
!***********************************************************************

      subroutine memoper

use decimal, only: long,dop
use global
use globmemmod
use dvrdatmod
use griddatmod
use operdef
use runopermod

      implicit none

!-----------------------------------------------------------------------
! with the parameter "pdum" the pointers to arrays that are not
! used are initialized with the value one in order to avoid an abortion
! of the program when array bounds are checked (compiler option "-c").
!-----------------------------------------------------------------------
      integer(long), parameter :: pdum = 1

!-----------------------------------------------------------------------
! assign standard arrays to memory arrays
! mcdim, mrdim, midim and mldim are final addresses assigned in mc, 
!  mr, mi and ml. 
!-----------------------------------------------------------------------
! set pointers to complex arrays in memory array mc 
!-----------------------------------------------------------------------
      mcdim=1

!-----------------------------------------------------------------------
! set pointers to real arrays in memory array mr 
!-----------------------------------------------------------------------
      mrdim=1
      mrort=mrdim
      mrdim=mrort+ortdim
      mrdvrmat=mrdim
      mrdim=mrdvrmat+dvrdim*dvrord
      mrtrafo=mrdim
      mrdim=mrtrafo+dvrdim
      mrfftp=mrdim
      mrdim=mrfftp+fftdim
      mrkinsph = mrdim
      mrdim = mrkinsph+sphdim
      mrrdop=mrdim
      mrdim=mrrdop+rdopdim
      mrcdvr3=mrdim
      mrdim=mrdim+ortdim

!-----------------------------------------------------------------------
! set pointers to integer arrays in memory array mi 
!-----------------------------------------------------------------------
      midim   = 1
      mijsph = midim
      midim  = mijsph+sphdim
      mimsph = midim
      midim  = mimsph+sphdim

!----------------------------------------------------------------------
! set pointers to logical arrays in memory array ml 
!-----------------------------------------------------------------------
      mldim   = 1

      return
      end subroutine memoper


