!#######################################################################
! contains:zeigrdf,zeighop
!#######################################################################

      module zeigopermod

use decimal, only: long, dop
use logdat
use op1lib,  only: zerovxi, cpvxi

      implicit none
      private
      public :: zeigrdf,zeighop
      contains

!#######################################################################

      subroutine zeigrdf

use global
use maxv, only: maxdim,maxhop
use dvrdatmod
use griddatmod
use operdef
use runopermod
use combined
use channels
use rdnatpot

      implicit none

      integer(long)       :: zeig,f,ilbl,jlbl,nrdfunc1,nr,p1,p,nop,n,&
                             gdim1,f1,m,nmode1,ptsubdim,m1,ndof1,chkdvr,&
                             chkgrd,ilbl1,ilbl2
      integer(long)       :: cpdrank

      integer(long), dimension(maxdim)             :: fdvr,mdvr,mmode,subdim1,&
                                                      nspfdof1,pntbas
      integer(long), dimension(maxdim,maxdim)       :: spfdof1
      character(len=c5)                             :: filename
      character(len=6)                              :: testline
      logical(kind=4)                               :: lerr
      logical(kind=4), dimension(maxdim)            :: loned

!-----------------------------------------------------------------------
! pointers for operators read from files
!-----------------------------------------------------------------------
      zeig=1
      nrdfunc=0
      pntbas=0
      do nr=1,nrdf
         filename=rdfiles(nr)
         jlbl=index(filename,' ')-1
         ilbl=jlbl-5
         ilbl1=jlbl-2
         ilbl2 = jlbl-3

         if (filename(ilbl:jlbl) .eq. 'natpot') then
            open(inpot,file=filename,form='unformatted',& 
                    status='old',err=999)
!-----------------------------------------------------------------------
!        pointers for natpots
!-----------------------------------------------------------------------
            if (npignore(nr).gt.0) then ! if ignore is set for natpot
               chkdvr=4
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
            else
               chkdvr=3
            endif
            chkgrd=3 
            call npotinfo(inpot,lerr,modc,loned,ndof1,fdvr,chkdvr,&
                 chkgrd,nr,mdvr,mmode,nspfdof1,spfdof1,nmode1,subdim1,&
                 pntbas)
            write(ilog,'(2a)') 'Natpot path: ', trim(filename)

            do m=1,nmode1
               do n=1,nspfdof1(m)
                  f=spfdof1(n,m)
                  if (loned(f)) then
                     nrdfunc=nrdfunc+1
                     nrdfunc1=min(nrdfunc,maxhop)
                     zrdop(nrdfunc1)=zeig
                     f1=fdvr(f)
                     zeig=zeig+gdim(f1)
                     
                     write(rdlab(nrdfunc1),'(2(a,i7))') &
                             'oned',f1,',',nr
                     call rmblnk(rdlab(nrdfunc1))
                     rdtype(nrdfunc1)=2
                  endif
               enddo
            enddo

            p1=0
            do m=1,nmode1
!
! get length of POTFIT vector.
! for point DVR potfit mode use gdim(f). Assume point DVR modes not
! combined in POTFIT (unless 2D DVR)
!
               m1 = mmode(m)
               if (lpntdvr .and. (subdim(m1) .ne. subdim1(m))) then
!                  if (nspfdof1(m) .eq. 2) then

                     ptsubdim = subdim(m1)

!                  else if (nspfdof1(m) .eq. 1) then
!                     f=spfdof1(1,m)
!                     f1=fdvr(f)
!                     ptsubdim = gdim(f1)
!                  else
!                     routine='zeigrdf'
!                     write(message,'(a)') 
!     +       'Point DVR in combined mode in POTFIT '
!                     call errormsg
!                  endif

               else
                  ptsubdim = subdim1(m)
               endif

               do p=1,pdim(m)
                  p1=p1+1
                  nrdfunc=nrdfunc+1
                  nrdfunc1=min(nrdfunc,maxhop)
                  zrdop(nrdfunc1)=zeig
                  zeig=zeig+ptsubdim
                  write(rdlab(nrdfunc1),'(2(a,i7))') &
                       'npot',p1,',',nr
                  call rmblnk(rdlab(nrdfunc1))
                  rdtype(nrdfunc1)=2
               enddo
            enddo

!-----------------------------------------------------------------------
!        pointers for hcpd
!!!!!!!!HCPD this needs to come before cpd
!-----------------------------------------------------------------------
         elseif (filename(ilbl2:jlbl) .eq. 'hcpd') then

            open(iop,file=filename,form='unformatted',status='old',err=999)
            chkdvr=0
            chkgrd=0
            if (npignore(nr).gt.0) then ! if ignore is set for cpd
               chkdvr=-1
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
            endif
            call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr, &
                 chkgrd,nr,mdvr,mmode,cpdrank,nspfdof1, &
                 spfdof1,nmode1,subdim1,loned,pntbas)

            write(ilog,'(2a)') 'HCPD path: ', trim(filename)
            ! the label 'cpdtm' is set in cpdlab called in 'matchlab'
            ! and also used in 'defgrd from assignhlab'

            do m=1,nmode1
               do n=1,nspfdof1(m)
                  f=spfdof1(n,m)
                  if (loned(f)) then
                     nrdfunc=nrdfunc+1
                     nrdfunc1=min(nrdfunc,maxhop)
                     zrdop(nrdfunc1)=zeig
                     f1=fdvr(f)
                     zeig=zeig+gdim(f1)
                     write(rdlab(nrdfunc1),'(2(a,i7))') 'oned',f1,',',nr
                     call rmblnk(rdlab(nrdfunc1))
                     rdtype(nrdfunc1)=3
                  endif
               enddo
            enddo

            p1 = 0
            do p=1,cpdrank
               do m=1,nmode1
                  nrdfunc=nrdfunc+1
                  nrdfunc1=min(nrdfunc,maxhop)
                  zrdop(nrdfunc1)=zeig
                  zeig=zeig+subdim1(m)**2
                  p1 = p1 + 1
                  write(rdlab(nrdfunc1),'(2(a,i7))') 'hcpdtm',p1,',',nr
                  call rmblnk(rdlab(nrdfunc1))

                  rdtype(nrdfunc1)=3
               enddo
            enddo

!-----------------------------------------------------------------------
!        pointers for cpd/candecomp
!-----------------------------------------------------------------------
         elseif (filename(ilbl1:jlbl) .eq. 'cpd') then
            open(iop,file=filename,form='unformatted',status='old',err=999)
            chkdvr=0
            chkgrd=0
            if (npignore(nr).gt.0) then ! if ignore is set for cpd
               chkdvr=-1
               call cpvxi(mulddof2(1,npmuld(nr,1)),fdvr,ndof)
            endif
            call cpdinfo(iop,lerr,ndof1,fdvr,chkdvr,&
                 chkgrd,nr,mdvr,mmode,cpdrank,nspfdof1,&
                 spfdof1,nmode1,subdim1,loned,pntbas)

            write(ilog,'(2a)') 'CPD path: ', trim(filename)
            ! the label 'cpdtm' is set in cpdlab called in 'matchlab'
            ! and also used in 'defgrd from assignhlab'

            do m=1,nmode1
               do n=1,nspfdof1(m)
                  f=spfdof1(n,m)
                  if (loned(f)) then
                     nrdfunc=nrdfunc+1
                     nrdfunc1=min(nrdfunc,maxhop)
                     zrdop(nrdfunc1)=zeig
                     f1=fdvr(f)
                     zeig=zeig+gdim(f1)
                     write(rdlab(nrdfunc1),'(2(a,i7))') 'oned',f1,',',nr
                     call rmblnk(rdlab(nrdfunc1))
                     rdtype(nrdfunc1)=2
                  endif
               enddo
            enddo

            p1 = 0
            do p=1,cpdrank
               do m=1,nmode1
                  nrdfunc=nrdfunc+1
                  nrdfunc1=min(nrdfunc,maxhop)
                  zrdop(nrdfunc1)=zeig
                  zeig=zeig+subdim1(m)
                  p1 = p1 + 1
                  write(rdlab(nrdfunc1),'(2(a,i7))') 'cpdtm',p1,',',nr
                  call rmblnk(rdlab(nrdfunc1))
                  rdtype(nrdfunc1)=2
               enddo
            enddo

         elseif (filename(max(1,jlbl-7):jlbl).eq."mlpf.dat") then
!-----------------------------------------------------------------------
!        pointers for MLPF leaf potentials
!-----------------------------------------------------------------------
            ! nothing to do here BUT DO NOT REMOVE THIS BRANCH
            continue

         elseif (filename(jlbl-6:jlbl) .eq. 'readmap') then
            open(iop,file=filename,form='formatted',status='old',err=999)
!-----------------------------------------------------------------------
!        pointers for readmap
!-----------------------------------------------------------------------
            read(iop,*,err=40) nop
            do n=1,nop
               nrdfunc=nrdfunc+1
               nrdfunc1=min(nrdfunc,maxhop)
               zrdop(nrdfunc1)=zeig
               read(iop,*,err=40) rdtype(nrdfunc1)
               zeig=zeig+3*rdtype(nrdfunc1)+1
               rdtype(nrdfunc1)=rdtype(nrdfunc1)+100
               write(rdlab(nrdfunc1),'(2(a,i7))') 'readmap',n,',',nr
               call rmblnk(rdlab(nrdfunc1))
            enddo

         else
!-----------------------------------------------------------------------
!        pointers for other read-files
!        check type (formated/unformated) first
!-----------------------------------------------------------------------
            open(inpot,file=filename,form='formatted', &
                    status='old',err=999)
            read(inpot,*,err=41) testline
            if(testline.ne.'ascii' .and. testline.ne.'ASCII') goto 41 
!..... ascii file
            read(inpot,*,err=40) nop
            do n=1,nop
               nrdfunc=nrdfunc+1
               nrdfunc1=min(nrdfunc,maxhop)
               zrdop(nrdfunc1)=zeig
               read(inpot,*,err=40) gdim1,rdtype(nrdfunc1)
               if (rdtype(nrdfunc1) .eq. 2) then
                  zeig=zeig+gdim1
               else
                  zeig=zeig+2*gdim1*gdim1
               endif

               write(rdlab(nrdfunc1),'(2(a,i7))') 'read',n,',',nr
               call rmblnk(rdlab(nrdfunc1))
            enddo
            goto 42

!..... binary file
  41        close(inpot)
            open(inpot,file=filename,form='unformatted', &
                 status='old',err=999)
            read(inpot,err=40) nop
            do n=1,nop
               nrdfunc=nrdfunc+1
               nrdfunc1=min(nrdfunc,maxhop)
               zrdop(nrdfunc1)=zeig
               read(inpot,err=40) gdim1,rdtype(nrdfunc1)
               if (rdtype(nrdfunc1) .eq. 2) then
                  zeig=zeig+gdim1
               else
                  zeig=zeig+2*gdim1*gdim1
               endif

               write(rdlab(nrdfunc1),'(2(a,i7))') 'read',n,',',nr
               call rmblnk(rdlab(nrdfunc1))
            enddo
  42        maxpsub=maxgdim
            maxpsub2=maxgdim2

         endif   ! (natpot/cpd/hcpd/rdfile)
         close(inpot)
      enddo      ! (nr=1,nrdf)

      rdopdim=zeig-1

      return
  999 continue
      routine='Zeigrdf'
      message = 'Cannot open file: '//trim(filename)
      call errormsg
   40 continue
      routine='Zeigrdf'
      message = 'Error reading file: '//trim(filename)
      call errormsg 

      end subroutine zeigrdf

!#######################################################################

      subroutine zeighop

use global
use maxv, only: maxhtm
use dvrdatmod
use griddatmod
use operdef
use runopermod
use channels

use rdopermod, only: assocdof

      implicit none

      integer(long)     :: f,h,zeig,k,m,f1,muld,m1,sdm,ff,f2,i,nel
      logical(kind=4)   :: found

      routine='Zeighop'
      call zerovxi(zhop,maxhtm)
!-----------------------------------------------------------------------
! calculate array pointers  for operators stored in hops
!-----------------------------------------------------------------------
      zeig=1
      do h=1,htmdim

!-----------------------------------------------------------------------
! get info on associated dof/mode
!-----------------------------------------------------------------------
         call assocdof(h,f,m,muld,f1,m1,sdm)

         found=.false.
         do k=1,ktot
            do ff=1,nopdof
               if (hamilton(ff,k) .eq. h) found=.true.
            enddo
         enddo
         do i=1,iLMR
            do ff=1,3
               if (hamLMR(i,ff) .eq. h) found=.true.
            enddo
         enddo

         if (found) then
            zhop(h)=zeig
            if (htmtype(h) .eq. 1) then
               zeig=zeig+sdm
            else if (htmtype(h) .eq. 2) then
               zeig=zeig+sdm
            else if (htmtype(h) .eq. 3) then
               zeig=zeig+sdm
            else if (htmtype(h) .eq. 4) then
               zeig=zeig+sdm*2
            else if (htmtype(h) .eq. 5) then
               zeig=zeig+gdim(f)
            else if (htmtype(h) .eq. 6) then
               zeig=zeig+gdim(f)
            else if (htmtype(h) .eq. 7) then
               zeig=zeig+gdim(f)*2
            else if (htmtype(h) .eq. 8) then
               zeig=zeig+sdm*sdm
            else if (htmtype(h) .eq. 9) then
               zeig=zeig+sdm*sdm
            else if (htmtype(h) .eq.10) then
               zeig=zeig+sdm*sdm*2
            else if (htmtype(h) .eq.11) then
               if (m1.ne.0) then
                  f2=htmadof(h) ! NEWKLEG
                  sdm=vgdim(f2+1)*ngdim(f2+1)
               endif
               zeig=zeig+sdm
            else if (htmtype(h) .eq.12) then
               zeig=zeig+sdm
            else if (htmtype(h) .eq.13) then
               zeig=zeig+sdm
            else if (htmtype(h) .eq.14) then
               zeig=zeig+sdm*2
            else if (htmtype(h) .ge. 15 .and. htmtype(h) .le. 24) then
               f2=htmadof(h) ! NEWKLEG
!              if (f2.eq.0) then
!                 call get_nth_kleg(f2,1,m1)
!              endif
               if (basis(f2).eq.7 .or. basis(f2).eq.20) then               ! Kleg, KLeg/R
                  zeig=zeig+gdim(f2)**2*gdim(f2+1)
!               elseif (basis(f2).eq.20) then          ! Kleg/R
!                  zeig=zeig+ipbaspar(3,f2)**2*gdim(f2+1)
               elseif (basis(f2).eq.9 .or. basis(f2).eq.21) then           ! Pleg. PLeg/R
                  zeig=zeig+gdim(f2)**2*ipbaspar(3,f2+1)
!               elseif (basis(f2).eq.21) then          ! Pleg/R
!                  zeig=zeig+ipbaspar(3,f2)**2*ipbaspar(3,f2+1)
               endif
            else if (htmtype(h) .eq.25) then
               nel = rdtype(hopilab(hterm(1,h)))-100
               zeig=zeig+3*nel+1
            else if (htmtype(h) .eq. 30) then !  cjpm
               f2=htmadof(h)
               zeig=zeig + (gdim(f2)**2+1)*gdim(f2+1) &
                         + (gdim(f2+2)**2+1)*gdim(f2+3)
            else if (htmtype(h) .eq. 31) then  !  Rf
               zeig=zeig+1
            else if (htmtype(h) .eq. 32) then  !  Rfm
               zeig=zeig+1
            else if (htmtype(h) .ge. 40 .and. htmtype(h) .le. 69) then
               f2=htmadof(h)    ! Wigners
               zeig=zeig+gdim(f2)**2*ipbaspar(4,f2)*ipbaspar(8,f2)
            else if (htmtype(h) .ge. 101 .and. htmtype(h) .le. 109) then 
               zeig=zeig+1                          ! analytic potential
            else if (htmtype(h) .eq. 151) then
               zeig=zeig+1
            else if (htmtype(h) .eq. 161) then
               zeig=zeig+1
            else if (htmtype(h) .eq. 202) then
               zeig=zeig+1
            else if (htmtype(h) .eq. 204) then
               zeig=zeig+1
            else if (htmtype(h).ne.0 .and. iolog.ne.6) then
               write(message,'(a,2i5)') &
                  'Unknown operator type :',htmtype(h),h
               call warnmsg
            endif
         else
            zhop(h)=0
         endif
      enddo
      hopsdim=zeig-1

      return
      end subroutine zeighop

!#######################################################################

      end module zeigopermod

