!#######################################################################
!  Include file for program Diag
!#######################################################################
      module diagmod

use decimal, only:long,dop
use global, only:c5

      implicit none

!#######################################################################
!  Pointers to the addresses of the integer, real and complex arrays
!  
!  dim - dimension of the overlap and Hamiltonian matrices
!  hdim - size of reduced Hamiltonian matrices
!  product - indicates, whether symmetric or hermitian scalar products
!            are used
!  Different pointers to intensity, eigenvector and
!                    eigenvalue arrays
!
!#######################################################################

      integer(long), save :: mcover,mcham,mcintensity,mceigenvec,&
                             mceigenval,mcwork,mrwork,miwork,dim,hdim,product,klo,&
                             khi,step,product_2

!#######################################################################
! epscut  - cut-off parameter for eigenvalues
! eoffset - offset energy for eigenvalues
! mlow    - low limit for Mtt matrix elements
! mhigh   - high limit for Mtt matrix elements
! mstep   - step for Mtt matrix elements
! ltneg   - logical parameter for including negative times 
!
!#######################################################################

      integer(long), save     :: mlow,mhigh,mstep
      real(dop), save         :: epscut,eoffset
      logical(kind=4), save   :: ltneg
      character(len=10), save :: eunit

!#######################################################################
! Names and their lengths for files need by Diag
!
!#######################################################################

      integer(long), save     :: iover,iover2,iham,iham2,ldiag,lham,lham2,llog,laein,&
                                 laein2,laeout
      character(len=c5), save :: fileout,diagfile,hamfile,hamfile2,logfile,&
                                 filein,filein2

      end module diagmod



