!***********************************************************************
!                                                                     
!              MCTDH include file linint.inc 
!                                                                     
!  Used in: opfuncs/linint.F, opfuncs/funcanld.F, mctdh/default.F 
!  Some compilers do not support integer*8, so we are using integer
!  pointer(2) to store the pointer variables
!                                                                     
!***********************************************************************
      module linintmod

      use decimal, only : long

      implicit none

! ___ blocksize for number of files
      integer(long), parameter :: li_blocksize = 8

! ___ all variables default to 0 or NULL in mctdh/default.F

! ___ current total number of files
      integer(long) :: li_total, li_allocd
      
! ___ the following are container variables for pointers, hence integer*8      
      
! ___ li_file: name of file with (real) interpolation data
      integer(long), dimension(2) :: li_file
      
! ___ li_start, li_step: start values and step lengths between arguments
!     in data sets, linear data sets are thereby assumed (cannot be bothered
! ___ with anything else at this time)
      integer(long), dimension(2) :: li_start, li_step

! ___ li_buffer: the data buffers. each is again dynamic.
      integer(long), dimension(2) :: li_buflen,li_buffer

! ___ li_init: have we initialised the data set array?
      integer(long), dimension(2) :: li_init

      save :: li_total, li_allocd, li_file, li_start, li_step, &
              li_buflen, li_buffer, li_init
      
      end module linintmod
