!***********************************************************************
!
!              MCTDH include file  OPENMPMOD.F90  
!
!  MCTDH include file defining array sizes, common blocks etc. common 
!  to several parts of the program.  
!  Declarations independent of modes and states should be placed
!  in include file "global".
!
!  07/13 GWR
!
!***********************************************************************
      module openmpmod

      use decimal, only : long,dop

      implicit none
 

!-----------------------------------------------------------------------
! INFORMATION ABOUT NUMBER OF THREADS TO BE STARTED
!
! ompthread : number of threads (processors) that can be used
!-----------------------------------------------------------------------
      integer(long), save :: ompthread = 1

!-----------------------------------------------------------------------
! DECIDES WHETHER OpenMP THREADS ARE USED OR NOT
!
!  lompthread  : set to true if threads are used
!-----------------------------------------------------------------------
      logical(kind=4), save :: lompthread = .false., &
                               lomptim = .false., &
                               lompmfield = .true., &
                               lompcalcha = .true., &
                               lompphihphi = .true., &
                               lompqc = .true., &
                               lompghelem = .true.

!-----------------------------------------------------------------------
! PARAMETERS FOR ARRAY DIMENSIONS
!
!  maxompthread:     maximum number of threads
!
!-----------------------------------------------------------------------
      integer(long), save :: maxompthread = 1

!-----------------------------------------------------------------------
! ARRAYS AND OTHER VARIABLES
!
!  ompthreadid  :  array for the id numbers of the started treads
!
!  ompthn       :  array for the number of the thread
!
!  ompthnum     :  counter variable for all loops concerning threads
!
!-----------------------------------------------------------------------

!      integer(long) :: ompidx
!      real(dop), dimension(maxompthread), save :: ompthreadid
!      integer(long), dimension(maxompthread), save :: ompthn
!      integer(long), save :: ompthnum,omptask
!                 ,parworkcdim,semcount,lbcount,  &
!                 parworkrdim,lbcount2,parworkidim,qrlimit,ctstep,      &
!                 addparmemc,addparmemr,addparmemi

      end module openmpmod
