

module constants_m
  use mlbase
  implicit none

  ! see mcalc constants
  real(dbl), parameter :: cvac  = 299792458.0_dbl         ! vacuum sped of light
  real(dbl), parameter :: au2an = 0.529177249_dbl         ! bohr to angstrom
  real(dbl), parameter :: an2au = 1.0_dbl/au2an           ! angstrom to bohr
  real(dbl), parameter :: au2ev = 27.211396131788_dbl     ! hartree to eV
  real(dbl), parameter :: ev2au = 1.0_dbl/au2ev           ! eV to hartree
  real(dbl), parameter :: au2am = 0.00054857989586762_dbl ! electron mass to AMU
  real(dbl), parameter :: am2au = 1.0_dbl/au2am           ! AMU to electron mass
  real(dbl), parameter :: au2fs = 0.024188843341_dbl      ! atomic unit time to fs
  real(dbl), parameter :: fs2au = 1.0_dbl/au2fs           ! fs to  atomic unit time
  real(dbl), parameter :: ev2kc = 23.05_dbl               ! eV to kcal/mol
  real(dbl), parameter :: kc2ev = 1.0_dbl/ev2kc           ! kcal/mol to eV
  real(dbl), parameter :: au2kc = 627.50431878767_dbl     ! hartree to kcal/mol
  real(dbl), parameter :: kc2au = 1.0_dbl/au2kc           ! kcal/mol to hartree
  real(dbl), parameter :: au2ic = 219474.63137_dbl        ! hartree to cm-1
  real(dbl), parameter :: ic2au = 1.0_dbl/au2ic           ! cm-1 to hartree
  real(dbl), parameter :: ev2ic = 8065.54353_dbl          ! eV to cm-1
  real(dbl), parameter :: ic2ev = 1.0_dbl/ev2ic           ! cm-1 to eV
  real(dbl), parameter :: ev2kj = 96.485_dbl              ! eV to kJoule/mol
  real(dbl), parameter :: kj2ev = 1.0_dbl/ev2kj           ! kJoule/mol to eV
  real(dbl), parameter :: au2db = 2.541746473_dbl         ! a.u. to debye
  real(dbl), parameter :: db2au = 1.0_dbl/au2db           ! debye to a.u.
  real(dbl), parameter :: au2mev = au2ev*1000             ! hartree to meV
  real(dbl), parameter :: mev2au = 1.0_dbl/au2mev         ! meV to hartree

end module constants_m
