

! dublicate the DVR such that we have operator
! grid indices
subroutine mkoperdvr(dvr, operdvr)
  use dvrtype_m
  implicit none

  type(dvr_t), intent(IN)    :: dvr
  type(dvr_t), intent(INOUT) :: operdvr

  integer :: i,j,k,z,f, zi,zj,zz


  operdvr%ndof    = 2*dvr%ndof
  operdvr%mbaspar = dvr%mbaspar

  operdvr%ortdim = 2*dvr%ortdim
  operdvr%dvrdim = 2*dvr%dvrdim

  if (dvr%fftdim .ne. 1) then
     operdvr%fftdim = 2*dvr%fftdim
  else
     operdvr%fftdim = 1
  end if
  if (dvr%expdim .ne. 1) then
     operdvr%expdim = 2*dvr%expdim
  else
     operdvr%expdim = 1
  end if


  if (dvr%sphdim .gt. 1) then
     operdvr%sphdim = 2*dvr%sphdim
  else
     operdvr%sphdim = 1
  end if

  operdvr%dvrord = dvr%dvrord

  allocate(operdvr%modelabel(operdvr%ndof))
  allocate(operdvr%gdim(operdvr%ndof))
  allocate(operdvr%basis(operdvr%ndof))
  allocate(operdvr%ldvr(operdvr%ndof))
  allocate(operdvr%ipbaspar(operdvr%mbaspar, operdvr%ndof))
  allocate(operdvr%rpbaspar(operdvr%mbaspar, operdvr%ndof))
  allocate(operdvr%xend(2,operdvr%ndof))


  allocate(operdvr%zort(operdvr%ndof))
  allocate(operdvr%zdvr(operdvr%ndof))
  allocate(operdvr%zfft(operdvr%ndof))
  allocate(operdvr%zexp(operdvr%ndof))
  allocate(operdvr%zsph(operdvr%ndof))

  allocate(operdvr%ort(operdvr%ortdim))
  allocate(operdvr%trafo(operdvr%dvrdim))
  allocate(operdvr%dvrmat(operdvr%dvrdim,operdvr%dvrord))
  allocate(operdvr%fftp(operdvr%fftdim))
  allocate(operdvr%hin(operdvr%fftdim))
  allocate(operdvr%rueck(operdvr%fftdim))
  allocate(operdvr%fftfak(operdvr%fftdim))
  allocate(operdvr%exphin(operdvr%expdim))
  allocate(operdvr%exprueck(operdvr%expdim))

  if (operdvr%sphdim .gt. 1) then
     allocate(operdvr%jsph(operdvr%sphdim))
     allocate(operdvr%msph(operdvr%sphdim))
     allocate(operdvr%kinsph(3*operdvr%sphdim))
  end if

  i = 1
  j = 2
  do k=1,dvr%ndof
     operdvr%modelabel(i) = trim(dvr%modelabel(k))//"_i"
     operdvr%modelabel(j) = trim(dvr%modelabel(k))//"_j"

     operdvr%gdim(i) = dvr%gdim(k)
     operdvr%gdim(j) = dvr%gdim(k)

     operdvr%basis(i) = dvr%basis(k)
     operdvr%basis(j) = dvr%basis(k)

     operdvr%ldvr(i) = dvr%ldvr(k)
     operdvr%ldvr(j) = dvr%ldvr(k)

     operdvr%ipbaspar(:,i) = dvr%ipbaspar(:,k)
     operdvr%ipbaspar(:,j) = dvr%ipbaspar(:,k)

     operdvr%rpbaspar(:,i) = dvr%rpbaspar(:,k)
     operdvr%rpbaspar(:,j) = dvr%rpbaspar(:,k)

     operdvr%xend(:,i) = dvr%xend(:,k)
     operdvr%xend(:,j) = dvr%xend(:,k)

     i = i + 2
     j = j + 2
  end do

  z = 1
  do k=1,operdvr%ndof
     operdvr%zort(k) = z
     z = z + operdvr%gdim(k)
  end do

  i = 1
  j = 2
  do k=1,dvr%ndof

     z = dvr%zort(k)
     zz = z + dvr%gdim(k) -1

     zi = operdvr%zort(i)
     zj = zi + operdvr%gdim(i) - 1

     operdvr%ort(zi:zj) = dvr%ort(z:zz)

     zi = operdvr%zort(j)
     zj = zi + operdvr%gdim(j) - 1

     operdvr%ort(zi:zj) = dvr%ort(z:zz)

     i = i + 2
     j = j + 2
  end do



  z=1
  do f=1,operdvr%ndof
     if (operdvr%ldvr(f)) then

        operdvr%zdvr(f) = z

        if (operdvr%basis(f).eq.7) then      ! KLeg

           ! The 2 was introduced (12.10.04,HDM) to account for dif3mat.
           z = z + 2*operdvr%gdim(f)*operdvr%gdim(f)*operdvr%gdim(f+1)       ! 2*
        elseif (operdvr%basis(f).eq.9) then  ! PLeg
           z = z + 2*operdvr%gdim(f)*operdvr%gdim(f)*operdvr%ipbaspar(4,f)   ! 2*
        elseif (operdvr%basis(f).eq.19) then  ! Wigner
           z = z + 2*operdvr%gdim(f)*operdvr%gdim(f)*operdvr%ipbaspar(4,f)*operdvr%ipbaspar(8,f)
        else
           z = z + operdvr%gdim(f)*operdvr%gdim(f)
        endif
     else
        operdvr%zdvr(f) = 1
     endif
  enddo

  dvrdim=max(z-1,1)
  if (dvrdim .ne. operdvr%dvrdim) then
     print*, "ERROR, dvrdim, operdvr%dvrdim", dvrdim, operdvr%dvrdim
  end if



  z=1
  do f=1,operdvr%ndof
     if (operdvr%basis(f).eq.4) then
        operdvr%zfft(f) = z
        z = z + operdvr%gdim(f)
     else
        operdvr%zfft(f) = 1
     endif
  enddo
  fftdim=max(z-1,1)

  if (fftdim .ne. operdvr%fftdim) then
     print*, "ERROR, fftdim, operdvr%fftdim", fftdim, operdvr%fftdim
  end if

  z=1
  do f=1,operdvr%ndof
     if (operdvr%basis(f).eq.5) then
        operdvr%zexp(f)=z
        if (f.gt.1 .and. operdvr%basis(max(1,f-1)).eq.9) then
           z = z + operdvr%gdim(f)*operdvr%ipbaspar(4,f-1)
        elseif (f.gt.1 .and. operdvr%basis(max(1,f-1)).eq.19) then
           z = z + operdvr%gdim(f)*operdvr%ipbaspar(4,f-1)
        elseif (f.gt.2 .and. operdvr%basis(max(1,f-2)).eq.19) then
           z = z + operdvr%gdim(f)*operdvr%ipbaspar(8,f-2)
        else
           z = z + operdvr%gdim(f)**2
        endif
     else
        operdvr%zexp(f)=1
     endif
  enddo
  expdim=max(z-1,1)

  if (expdim .ne. operdvr%expdim) then
     print*, "ERROR, expdim, operdvr%expdim", expdim, operdvr%expdim
  end if


  z=1
  do f=1,operdvr%ndof
     if (operdvr%basis(f).eq.6) then
        operdvr%zsph(f) = z
        z = z + operdvr%gdim(f)
     else
        operdvr%zsph(f) = 1
     endif
  enddo
  sphdim=max(z-1,1)

  if (sphdim .ne. operdvr%sphdim) then
     print*, "ERROR, sphdim, operdvr%sphdim", sphdim, operdvr%sphdim
  end if


  operdvr%initialized = .true.

end subroutine mkoperdvr


subroutine allocate_opercpd(opercpd,operdvr,initrank,nsysdof,nsysmode,sysdofpot,syspotdofmap,lsysoned)
  use dvrtype_m
  use cpdtype_m
  implicit none

  type(cpd_t), intent(INOUT)     :: opercpd
  type(dvr_t), intent(IN)        :: operdvr
  integer, intent(IN)            :: initrank, nsysdof, nsysmode
  integer, intent(IN)            :: sysdofpot(nsysdof), syspotdofmap(2,nsysdof)
  logical, intent(IN)            :: lsysoned(nsysdof)

  integer                        :: npmode
  integer, allocatable           :: dofpot(:), potdofmap(:,:)
  logical, allocatable           :: loned(:)

  integer :: f,i,j,m


  ndof = nsysdof*2
  npmode = nsysmode

  if (ndof .ne. operdvr%ndof) then
     print*, "Error: ndof .ne. operdvr%ndof ", ndof, operdvr%ndof
  end if

  allocate(dofpot(ndof))
  allocate(potdofmap(2,ndof))
  allocate(nspfdof(nsysmode))
  allocate(loned(ndof))

  nspfdof = 0
  do f=1,nsysdof
     m = sysdofpot(f)
     nspfdof(m) = nspfdof(m) + 1
  end do



  i = 1
  j = 2

  do f=1,nsysdof
     potdofmap(1,i) = syspotdofmap(1,f)
     potdofmap(1,j) = syspotdofmap(1,f)

     m = sysdofpot(f)
     potdofmap(2,i) = syspotdofmap(2,f)
     potdofmap(2,j) = syspotdofmap(2,f) + nspfdof(m)

     dofpot(i) = m
     dofpot(j) = m

     loned(i) = lsysoned(f)
     loned(j) = lsysoned(f)

     i = i+2
     j = j+2
  end do


  call allocate_cpd_t(opercpd,initrank,ndof,npmode,operdvr%gdim,dofpot,potdofmap, &
       operdvr%modelabel,operdvr%ort,operdvr%ortdim, loned)



end subroutine allocate_opercpd
