!   -*- f90 -*-
!***********************************************************************
!
!            MCPOTFIT subroutine MCPEINRUN
!
!
!***********************************************************************

subroutine mccpdeinrun(linperr,iz)
  use mccpdparams
  use pesselect_m, only: lomppotential
  use symmops_m, only: lautoextgrid
  use mcpfitparams
  use mcsampling

  use global
  use pglobal
  use maxv
  use griddatmod
  use operdef
  use channels
  use mpidata
  use logdat

  implicit none

  integer           :: i,iz,iz0,ic,ierr
  integer           :: ilbl, rstlen, cutslen
  logical           :: linperr !, lwarn1
  logical           :: lrddvr = .false.
  logical           :: lrundvr = .false.

!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
  routine = 'read RUN-SECTION  (mcpeinrun)'
  iz0     = 0
! set lrddvr if already specified on command line
  if (irundvr .eq. 2) lrddvr = .true.

!-----------------------------------------------------------------------
! READ KEYWORDS:
!-----------------------------------------------------------------------
10 continue
  call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
  message = inptit
  call cntrl(keyword(1),lc(1),ierr)

  i=1
15 continue

  if (keyword(i).eq.'end-run-section') then
     goto 20
  elseif (keyword(1).eq.'end-input') then
     linperr = .true.
     message = 'No end-run-section keyword at end of RUN-SECTION'
     call warnmsg
     linperr=lwarn
     lwarn=.false.
     RETURN

  else if( keyword(i) .eq. 'title' .or. keyword(i) .eq. 'titel' )  then
     if (keyword(i+1) .ne. '=' ) then
        read(iin,'(a)') runtitle
        iz = iz + 1
     else
        i = i + 2
        ilbl=index(inptit,'title')
        if(ilbl.eq.0) ilbl=index(inptit,'titel')
        runtitle = inptit(ilbl+5:80)
        ilbl=index(runtitle,'=')
        runtitle = runtitle(ilbl+1:80)
        goto 10
     end if

  else if (keyword(i) .eq. 'readdvr') then
     lrddvr=.true.
     if (keyword(i+1) .eq. '=') then
        i=i+2
        dname=keyorig(i)
        dlaenge = lc(i)
     endif
!!$ NOT YET IMPLEMENTED
!!$  elseif (keyword(i).eq.'rdnpot') then
!!$     lrdnpot    = .true.
!!$     if (keyword(i+1) .eq. '=') then
!!$        i=i+2
!!$        lnpotpath = .true.
!!$        npotname    = keyorig(i)
!!$        npotlaenge  = lc(i)
!!$        call abspath(npotname, npotlaenge)
!!$     endif
  else if( keyword(i) .eq. 'gendvr' )  then
     lrundvr=.true.
  else if( keyword(i) .eq. 'dvronly' )  then
     ldvronly=.true.
  else if( keyword(i) .eq. 'auto-extgrid' )  then
     lautoextgrid = .true.
  else if( keyword(i) .eq. 'save-initguess' )  then
     lsaveinitguess = .true.
  else if( keyword(i) .eq. 'load-cuts' )  then
     lloadcuts = .true.
     if (keyword(i+1).eq.'=') then
        mccutsdir = keyorig(i+2)
        cutslen = lc(i+2)
        call abspath(mccutsdir,cutslen)
        i = i + 2
     end if
  else if( keyword(i) .eq. 'wrfuncs' )  then
     lwrfuncs = .true.
  else if( keyword(i) .eq. 'no-blas' )  then
     luseblas = .false.
  else if( keyword(i) .eq. 'try-reuse-cuts' )  then
     ltryreusecuts = .true.
  else if (keyword(i) .eq. 'deldvr') then
     ldeldvr=.true.
  elseif (keyword(i).eq.'overwrite') then
     lovwr = .true.
  elseif (keyword(i).eq.'initguess') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with read-cpd keyword'
        call warnmsg
     else
        if (keyword(i+2) .eq. 'random') then
           linitrandom = .true.
           i=i+2
        elseif (keyword(i+2) .eq. 'cuts') then
           linitrandom = .false.
           i=i+2
        else
           linitrandom = .false.
           lloadcpd = .true.
           restarcpd = keyorig(i+2)
           rstlen = lc(i+2)
           call abspath(restarcpd,rstlen)
           if (keyword(i+1) .eq. ',') then
              if (keyword(i+2) .eq. 'override-initrank') then
                 loverride_initrank = .true.
              else
                 message = "Expecting 'override-initrank' after 'initguess=dir, ...'"
                 call warnmsg
              end if
              i=i+2
            end if
        end if
     end if
     
  elseif (keyword(i).eq.'name') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with name keyword'
        call warnmsg
     else
        if (laenge .eq. 0) then
           name = keyorig(i+2)
           laenge = lc(i+2)
           if (laenge.eq.0) then
              message = ' No path name specified'
              call wrline(zeroi,iz,iz0)
           endif
           call abspath(name,laenge)
        endif
        i=i+2
     endif
!!$ NOT YET IMPLEMENTED
!!$  elseif (keyword(i).eq.'output') then
!!$     loutfil = .true.
!!$     if (keyword(i+1).eq.'=') then
!!$        i=i+2
!!$        if (keyword(i).eq.'long') then
!!$           loutl = .true.
!!$        elseif (keyword(i).eq.'short') then
!!$           loutl = .false.
!!$        else
!!$           message='"long" or "short" must follow "output="'
!!$           call warnmsg
!!$        endif
!!$     endif
!!$  else if(keyword(i) .eq. 'nooutput'  .or. &
!!$       keyword(i) .eq. 'no-output' .or. &
!!$       keyword(i) .eq. 'screen' )  then
!!$     loutfil = .false.
!!$
!!$
!!$  else if (keyword(i).eq.'timing') then
!!$     ltime = .true.
!!$  else if( keyword(i) .eq. 'notiming' .or. &
!!$       keyword(i) .eq. 'no-timing' ) then
!!$     ltime = .false.

  else if (keyword(i) .eq. 'sampling-only') then
     lsamplingonly = .true.
  else if (keyword(i) .eq. 'cuts-only') then
     lcutsonly = .true.
  else if (keyword(i) .eq. 'sampling-energies') then
     lesample = .true.
  else if (keyword(i) .eq. 'no-omppotential') then
     lomppotential = .false.
  else if (keyword(i) .eq. 'ascii-samplings') then
     lasciisamplings = .true.
  else if (keyword(i) .eq. 'binary-samplings') then
     lasciisamplings = .false.

  else if (keyword(i) .eq. 'invert-method') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with invert-method keyword'
        call warnmsg
     else
        i=i+2
        if (keyword(i) .eq. "direct") then
           invertmethod = mc_inv_spd
        else if (keyword(i) .eq. "eigen") then
           invertmethod = mc_inv_eigen
        else
           message = "Argument of 'invert-method' must be one of" &
                //" 'direct' or 'eigen', not: " //trim(keyword(i))
           call warnmsg
        end if
     end if
     if (keyword(i+1).eq.',') then
        read(keyword(i+2),*,iostat=ierr) epsilon_invert
         if (ierr .ne. 0) then
            message = "Expecting real number after 'invert-method = " &
                 //trim(keyword(i-1))//",' " &
                 //" not: "//trim(keyword(i+2))
         end if
         i=i+2
      end if
  else if (keyword(i) .eq. 'iseed') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with iseed keyword'
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) mcseed
        if (ierr .ne. 0) then
           message = "Expecting integer after mcseed keyword" &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2
     endif

  else if (keyword(i) .eq. 'finalize-coeff') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with finalize keyword'
        call warnmsg
     else
        if (keyword(i+2) .eq. "cuts") then
           lcoeffoncuts  = .true.
           lfincoeff = .true.
        else if (keyword(i+2) .eq. "monte-carlo") then
           lcoeffoncuts  = .false.
           lfincoeff = .true.
        else if (keyword(i+2) .eq. "no") then
           lfincoeff = .false.
           lcoeffoncuts  = .false.
        else
           message = "Expecting either 'cuts' or 'monte-carlo' or 'no' after " &
                //"keyword 'finalize-coeff', not: "//trim(keyword(i+2))
           call warnmsg
        end if

        i=i+2
     endif

  else if (keyword(i) .eq. 'maxiter') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with maxiter keyword'
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) alsmaxiter
        if (ierr .ne. 0) then
           message = "Expecting integer after maxiter keyword" &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2
     endif


  else if (keyword(i) .eq. 'rank' .or. keyword(i) .eq. 'maxrank') then
     if (keyword(i+1).ne.'=') then
        message = 'No argument specified with (max)rank keyword'
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) maxrank
        if (ierr .ne. 0) then
           message = "Expecting integer after (max)rank keyword" &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2
     endif
  else if (keyword(i) .eq. 'grow-rank') then
     lgrow = .true.

     if (keyword(i+1).ne.'=') then
        message = "No argument specified with 'grow-rank' keyword"
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) initrank
        if (ierr .ne. 0) then
           message = "Expecting integer after  'grow-rank = ' keyword" &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2

     endif

     if (keyword(i+1).ne.',') then
        message = "Expecting komma after  'grow-rank = <int>'" &
             //" not: "//trim(keyword(i+1))
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) growrank
        if (ierr .ne. 0) then
           message = "Expecting second integer in 'grow-rank = <int1>,<int2>' " &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2
     end if

     if (keyword(i+1).ne.',') then
        message = "Expecting komma after  'grow-rank = <int>,<int>'" &
             //" not: "//trim(keyword(i+1))
        call warnmsg
     else
        read(keyword(i+2),*,iostat=ierr) growiter
        if (ierr .ne. 0) then
           message = "Expecting third integer in 'grow-rank = <int1>,<int2>,<int3>' " &
                //" not: "//trim(keyword(i+2))
           call warnmsg
        end if
        i=i+2
     end if

  else if (keyword(i) .eq. 'operator') then
     loperfit = .true.
     i=i+1
     if (keyword(i).eq.'=') then
        i=i+1
        if (keyword(i).eq.'hermitian') then
           lhermitian = .true.
        else
           message = "Expecting keyword 'hermitian' after  'operator = '" &
                //" not: "//trim(keyword(i))
           call warnmsg
        end if
     end if

!!$ NOT YET IMPLEMENTED
!!$  else if (keyword(i) .eq. 'subtract-pes') then
!!$     if (keyword(i+1).ne.'=') then
!!$        message = 'No argument specified with subtract-pes keyword'
!!$        call warnmsg
!!$     endif
!!$
!!$     i=i+2
!!$     operfile =  trim(keyword(i))//'/pes'
!!$     lpesfile=.true.
!!$     lsubtractpes = .true.

  else
     message = ' unknown keyword : '//trim(keyword(i))
     call wrline(i,iz,iz0)
  endif

!-----------------------------------------------------------------------
! check if more keywords are to be read, else read new line
!-----------------------------------------------------------------------
  if (i.lt.ic) then
     i=i+1
     go to 15
  else
     go to 10
  endif

20 continue


!  lesample = .true. ! this is always true in mccpd

  ! load cuts from name by default
  if (len_trim(mccutsdir) .eq.0) then
     mccutsdir = trim(name)
  end if

!-----------------------------------------------------------------------
! don't overwrite dvr file pointed to by readdvr keyword
!-----------------------------------------------------------------------
  if (lrddvr) then
     irundvr=2
  else
     irundvr=1
  endif

!-----------------------------------------------------------------------
! force generation of DVR file
!-----------------------------------------------------------------------
  if (lrundvr) irundvr = 1


  if (lcont .and. len_trim(restarcpd) .ne. 0) then
     message = "Cannot use keyword read-cpd in a continuation run (-c)"
     routine = "mccpdeinrun"
     call warnmsg
  end if
!-----------------------------------------------------------------------
! check that dname is set.
!-----------------------------------------------------------------------
  if (dlaenge .eq. 0) then
     dname=name
     dlaenge=laenge
  endif

!!$!-----------------------------------------------------------------------
!!$! if we are testing an existing natpot
!!$! and lnpotpath was not given then look in
!!$! name dir.
!!$!-----------------------------------------------------------------------
!!$  if (lrdnpot .and. .not. lnpotpath) then
!!$     npotname = trim(name)//"/natpot"
!!$     npotlaenge = len_trim(npotname)
!!$     call abspath(npotname, npotlaenge)
!!$  end if



  if (maxrank .eq. 0) then
     message = "RUNS-SECTION: 'rank' keyword is mandatory."
     routine = "mccpdeinrun"
     call warnmsg
  end if

  if (initrank .lt. 0) then
     message = "RUNS-SECTION: initial rank is negative."
     routine = "mccpdeinrun"
     call warnmsg
  end if

  if (maxrank .lt. 0) then
     message = "RUNS-SECTION: rank is negative."
     routine = "mccpdeinrun"
     call warnmsg
  end if

  if (lgrow) then
     if (growiter .lt. 0) then
        message = "RUNS-SECTION: iterations until grow is negative."
        routine = "mccpdeinrun"
        call warnmsg
     end if


     if (growiter .eq. 0) then
        message = "RUNS-SECTION: iterations until grow is zero."
        routine = "mccpdeinrun"
        call warnmsg
     end if
  end if

  if (alsmaxiter .lt. 0) then
     message = "RUNS-SECTION: maxiter is negative."
     routine = "mccpdeinrun"
     call warnmsg
  end if


  if (initrank .eq. 0 .and. maxrank .gt. 0) then
     initrank = maxrank
  end if








  if (.not.linperr) linperr=lwarn
  lwarn=.false.

end subroutine mccpdeinrun
