
module mccpdparams
  use dvrtype_m
  implicit none

  integer            :: maxrank
  integer            :: initrank
  integer            :: growiter, growrank
  integer            :: alsmaxiter

  double precision   :: epsilon_invert

  logical            :: linitrandom, ltryreusecuts, lcutsonly, luseblas
  logical            :: lloadcuts,lcoeffoncuts, lfincoeff, lgrow
  logical            :: lsaveinitguess, lwrfuncs, lloadcpd
  logical            :: loverride_initrank
  character(len=256) :: restarcpd, mccutsdir

  logical            :: loperfit, lhermitian

contains

  subroutine mccpddefault()
    implicit none

    double precision   :: DLAMCH
    external DLAMCH

    maxrank  = 0
    initrank = 0
    growiter = 0
    growrank = 0
    alsmaxiter = 100

    linitrandom    = .true.
    lloadcpd       = .false.
    lloadcuts      = .false.
    lsaveinitguess = .false.
    lcoeffoncuts   = .false. ! not working at the moment..
    lfincoeff      = .true.
    lgrow          = .false.
    ltryreusecuts  = .false.
    lwrfuncs       = .false.
    lcutsonly      = .false.
    luseblas       = .true.
    loverride_initrank = .false.

    !BLAS get machine precision
    epsilon_invert = DLAMCH("E")
    epsilon_invert = sqrt(epsilon_invert)


    restarcpd = ""
    mccutsdir = ""


    loperfit = .false.
    lhermitian = .false.


  end subroutine mccpddefault


end module mccpdparams


