

subroutine mcpeinoper (linperr,iz)
  use mcpfitparams

  use global
  use pglobal
  use maxv
  use dvrdatmod
  use griddatmod
  use operdef
  use runpfitmod
  use combined
  use channels
  use logdat
  use keyunitsmod

  implicit none

  integer  i,iz,iz0,ic,ierr,ilbl,f,hl,jlbl
  logical  linperr, lorder
  character*(c2) ctmp

!-----------------------------------------------------------------------
! set initial values
!C-----------------------------------------------------------------------
  routine = 'read OPERATOR-SECTION (mcpeinoper)'
  iz0  = 0
  hl = 1
  lorder=.false.

! --- Set default for mulddof.
  do f=1,ndof
     mulddof (f,1) = f
     mulddof2(f,1) = f
  enddo
  nmulddof(1)=ndof

!-----------------------------------------------------------------------

10 continue
  call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
  message = inptit
  call cntrl(keyword(1),lc(1),ierr)

  i=1

15 continue
  if (keyword(i) .eq. 'end-operator-section') then
     goto 20
  else if (keyword(i) .eq. 'end-input') then
     message = 'No "end-operator-section" keyword at end of OPERATOR-SECTION'
     call warnmsg
     linperr=lwarn
     lwarn=.false.
     return

  elseif (keyword(i).eq.'pes')  then
     if (keyword(i+1) .ne. '=') then
        message='Missing arguments for keyword :'
        call wrline(i,iz,iz0)
     endif
     i=i+2
     hopdim = 1
     hoplab(1)=trim(keyorig(i))

     if (keyword(i) .eq. 'pes-file') then
        if (lsubtractpes) then
           message = "pes = pes-file cannot be used together " &
                //"sustract-pes in RUN-SECTION"
           call warnmsg
        end if
        lpesfile=.true.
        if (keyword(i+1) .ne. '{') then
           message='No opening { found for pes-file path'
           call errormsg
        end if

        i=i+2
        if (keyword(i) .eq. 'name') then
           operfile = name(1:laenge)//'/pes'
           opflaenge=laenge+4
        else
           operfile = keyword(i)
           opflaenge=index(operfile,' ')-1
           operfile = operfile(1:opflaenge)//'/pes'
           opflaenge=opflaenge +4
        end if
        i=i+1
        if (keyword(i) .ne. '}') then
           message='No closing } found for pes-file path'
           call errormsg
        end if

     else if (keyword(i+1) .eq. '{') then
        i=i+2
        ilbl=1
        npesopt=npesopt+1
30      continue
        if (i .gt. ic) then
           call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
           if (ierr .eq. 1) then
              message = inptit
              call warnmsg
           endif
           i=1
        endif

        if (keyword(i) .eq. ',') then
           i=i+1
           go to 30
        endif

        if (keyword(i) .ne. '}') then
           nopts(npesopt)=nopts(npesopt)+1
           jlbl=ilbl+lc(i)
           zpesopts(nopts(npesopt),npesopt)=jlbl
           pesopts(npesopt)(ilbl:jlbl)=keyorig(i)(1:lc(i))//' '
           ilbl=jlbl+1
           i=i+1
           go to 30
        elseif (keyword(i) .eq. 'end-input') then
           message='No closing } in pes options'
           call errormsg
        else
           i=i+1
        endif

        if (nopts(npesopt) .gt. 2*maxhpar) then
           write(message,'(a,i5)') 'Increase maxhpar in operdef.inc. Minimum: ', &
                nopts(npesopt)/2+1
           call errormsg
        else if (npesopt .gt. maxpes) then
           write(message,'(a,i5)') 'Increase maxpes in operdef.inc. Minimum: ',npesopt
           call errormsg
        endif

        ilbl=index(hoplab(1),' ')-1

!       NOTE: pgf77 Rel 1.7-6.3 cannot read from and write to a character
!             variable at the same time via a single write statement.
!             hence, use ctmp as temporary string here. the f77 standard
!             does not mention this case. however, in a character
!             assignment statement like v=e, none of the character
!             positions being defined in v may be referenced in e.

        write(ctmp,'(2a,i5,a)') hoplab(1)(1:ilbl), '{',npesopt,'}'
        hoplab(hopdim)=ctmp
        call rmblnk(hoplab(hopdim))

     endif
  elseif (keyword(i).eq.'vcut' .or. keyword(i).eq.'v' ) then
     lcutpes = .true.
     if(lsoftcutpes) then
        message='ERROR: both vcut and softvcut were requested'
        call warnmsg
     endif
     if (keyword(i+1).eq.'='.or.keyword(i+1).eq.'<') then
        i=i+2
        read(keyword(i),*,iostat=ierr) pesmax
        if (ierr.ne.0) then
           message = 'A real number must be argument of "vcut". Not :'
           call wrline(i,iz,iz0)
        endif
        if (keyword(i+1).eq.',' ) then
           i=i+2
           call keyeunits(pesmax,keyword(i),ierr)
           if (ierr .eq. 1) then
              message = 'no energy unit after comma'
              call wrline(zeroi,iz,iz0)
           endif
        endif
     else if (keyword(i+1).eq.'>') then
        i=i+2
        read(keyword(i),*,iostat=ierr) pesmin
        if (ierr.ne.0) then
           message = 'A real number must be argument of "vcut". Not :'
           call wrline(i,iz,iz0)
        endif
        if (keyword(i+1).eq.',' ) then
           i=i+2
           call keyeunits(pesmin,keyword(i),ierr)
           if (ierr .eq. 1) then
              message = 'no energy unit after comma'
              call wrline(zeroi,iz,iz0)
           endif
        endif
     else
        message='No argument after vcut keyword'
        call warnmsg
     endif
  else
     message = ' unknown keyword : '
     call wrline(i,iz,iz0)
  endif

!-----------------------------------------------------------------------
! check if more keywords are to be read, else read new line
!-----------------------------------------------------------------------
  if (i.lt.ic) then
     i=i+1
     go to 15
  else
     go to 10
  endif

!-----------------------------------------------------------------------
! some more checks
!-----------------------------------------------------------------------
20 continue
  if (.not.lcspot .and. jtot.gt.-1d0) then
     message = 'Option ''cspot'' must be defined in ~.inp file ' &
          //'if ''jtot'' is command line argument'
     call warnmsg
  endif
  if( hoplab(1)(1:7).eq.'readsrf' .and. lorder ) then
     message = 'Sorry, one cannot use "order" when ' &
          //'the PES is "readsrf".'
     call warnmsg
  endif

!-----------------------------------------------------------------------
! After any call of 'warnmsg' (which is also called by 'wrline') the
! logical 'lwarn' is set to true.
!-----------------------------------------------------------------------
  if (.not.linperr) linperr=lwarn
  lwarn=.false.

  return
end subroutine mcpeinoper
