!   -*- f90 -*-

subroutine mcpfmemhops

  use global
  use pglobal
  use channels
  use maxv
  use operdef
  use logdat
  use memhopsmod
  use rdopermod, only: operinfo

  implicit none

  integer            :: chkdvr, chkgrd
  integer            :: ierr, hopdim1
  logical            :: lerr
  character(len=c2)  :: hoplab1

  ! surface label from oper-section
  ! is overwritten:
  hopdim1 = hopdim
  hoplab1 = hoplab(hopdim)

  opflaenge=index(operfile,' ')-1
  call abspath(operfile,opflaenge)
  open(ioper,file=operfile,form='unformatted',status='old',iostat=ierr)
  if (ierr.ne.0) then
     opflaenge=opflaenge-4
     operfile=operfile(1:opflaenge)
     open(ioper,file=operfile, form='unformatted',status='old',iostat=ierr)
   endif
  if (ierr.ne.0) then
     routine = "mcpfmemhops"
     message = 'Cannot open pes-file: '//trim(operfile)
     call errormsg
  end if

  chkdvr=2
  chkgrd=1
  call operinfo(lerr,chkdvr,chkgrd)
  close(ioper)
  call chksyserr(operfile,lerr)

  if (lerr) then
     routine= "mcpfmemhops"
     message= 'Error reading :'//trim(operfile)
     call errormsg
  end if

  call memhops

  ! surface label from oper-section:
  hopdim = hopdim + hopdim1
  if (hopdim .gt. maxhop) then
     routine = "mcpfmemhops (mcpfpotential.F90)"
     message = "Increase hopdim (operdef.inc) at least by 1"
     call errormsg()
  end if
  hoplab(hopdim) = hoplab1

end subroutine mcpfmemhops

