!   -*- f90 -*-

module mcprecond_m
  implicit none

  ! precon: inverse of the preconditioner matrices
  ! pccim: total size of the preconditioner matricies
  ! precontype: type of precontitioner:
  !             0 -> None
  !             1 -> diagonal matrix
  !             2 -> band matrix

  double precision, allocatable  :: precon(:), precon2(:,:), precon3(:,:,:)
  integer                        :: pcdim, zpcdim
  integer, allocatable           :: vmap(:), dmap(:)


  ! enumerate pre-conditioner types in conjgrad
  integer, parameter         :: cg_precon_none = 0
  integer, parameter         :: cg_precon_diag = 1
  integer, parameter         :: cg_precon_band = 2
  integer, parameter         :: cg_precon_sparse = 3
  integer, parameter         :: cg_precon_block = 4
  integer, parameter         :: cg_precon_maxdim = 30

  integer                    :: cg_precon_luse(cg_precon_maxdim)

  integer                    :: cg_precon_type
  integer                    :: cg_precon_size



end module mcprecond_m



subroutine mcprecond_default()
  use mcprecond_m
  implicit none

  integer :: i

  cg_precon_type = cg_precon_none
  cg_precon_size = 0

  do i=1,cg_precon_maxdim
     cg_precon_luse(i) = 1
  end do

end subroutine mcprecond_default

