!
! similiar to peinbas, but does not assign numbers
! of spf, only reads mode combinations



subroutine peinmodes(linperr,iz)

  use global
  use pglobal
  use maxv
  use dvrdatmod
  use griddatmod
  use operdef
  use runpfitmod
  use combined
  use channels
  use logdat

  implicit none

  integer, intent(INOUT) :: iz
  logical, intent(INOUT) :: linperr

  integer  :: iz0,i,m,f,f1,n, ilbl, zeig, ic, ierr


!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
  iz0 = 0
  routine = 'read MODES-SECTION (peinbas)'

  m=0
10 continue
  call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
  message = inptit
  call cntrl(keyword(1),lc(1),ierr)

  i=1
15 continue

  if (keyword(i) .eq. 'end-modes-section' ) then
     go to 60
  else
     m = m+1


40   continue
     f=0
     do f1=1,ndof
        if (keyorig(i)(1:12) .eq. modelabel(f1) ) f=f1
     enddo
     if (f.eq. 0) then
        message = 'no primitive basis for mode: '
        call wrline(i,iz,iz0)
        f=ndof+1
     endif

     if (f.gt.maxdim) then
        message = ' MAXDIM in maxdim.inc must be increased to :'
        ilbl=index(message,':')+2
        write(message(ilbl:ilbl+4),'(i5)') f
        call warnmsg
     endif

     npotdof(m)=npotdof(m)+1
     n=npotdof(m)
     potdof(n,m)=f
     dofpot(f)=m

     if (keyword(i+1).eq.',') then
        i=i+2
        go to 40
     endif

  end if

  !-----------------------------------------------------------------------
  ! check if more keywords are to be read, else read new line
  !-----------------------------------------------------------------------
  if (i.lt.ic) then
     i=i+1
     go to 15
  else
     go to 10
  endif



60 continue
  npmode=m


  !-----------------------------------------------------------------------
  ! see if any degrees of freedom  are combined
  !-----------------------------------------------------------------------
  do m=1,npmode
     if (npotdof(m) .gt. 1) lpconm = .true.
  enddo


  do m=1,npmode
     zeig=1
     do n=1,npotdof(m)
        f=potdof(n,m)
        zeig=zeig*gdim(f)
     enddo
     psubdim(m)=zeig
  enddo



  do m = 1, npmode
     if(potdim(m) .gt. psubdim(m) ) then
        linperr=.true.
        write(6,'(/2x,a,i3,a,i4,a,i4)') &
             'm =', m,',  potdim =',potdim(m),',  psubdim =',psubdim(m)
        Message = ' potdim .gt. psubdim '
        call warnmsg
     end if
  enddo

! alternative mapping
  do m=1,npmode
     do n=1,npotdof(m)
        f = potdof(n,m)
        potdofmap(1,f) = m
        potdofmap(2,f) = n
     end do
  end do

  if (.not.linperr) linperr=lwarn
  lwarn=.false.
  return

end subroutine peinmodes
