

! call this from 'eingabe'

subroutine set_up_iparam(iparam)
  implicit none
  integer, intent(IN) :: iparam

  call set_userpot_iparam(iparam)
  call set_userpotidx_iparam(iparam)


contains

  subroutine set_userpot_iparam(iparam)
    use UserPotParams, only : iup
    implicit none
    integer, intent(IN) :: iparam
    iup = iparam
  end subroutine set_userpot_iparam


  subroutine set_userpotidx_iparam(iparam)
    use UserPotIdxParams, only : iup
    implicit none
    integer, intent(IN) :: iparam
    iup = iparam
  end subroutine set_userpotidx_iparam

end subroutine set_up_iparam



! do _not_ call this from 'eingabe'
! it must be called from code all
! mpi intances will visit.

subroutine bcast_up_iparam()
  implicit none

  call bcast_userpot_iparam()
  call bcast_userpotidx_iparam()

contains

  subroutine bcast_userpot_iparam()
    use UserPotParams, only : iup
#ifdef MPI
    use mpidata
    use mpi
#endif

    implicit none

#ifdef MPI
    integer :: ierr
    call MPI_Bcast(iup,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
#endif
  end subroutine bcast_userpot_iparam


  subroutine bcast_userpotidx_iparam()
    use UserPotIdxParams, only : iup
#ifdef MPI
    use mpidata
    use mpi
#endif

    implicit none

#ifdef MPI
    integer :: ierr
    call MPI_Bcast(iup,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
#endif
  end subroutine bcast_userpotidx_iparam

end subroutine bcast_up_iparam







