! -*- f90 -*-
!
! Template for a custom implementation of
! a potential using a grid point index
!
! See also userpot.F90 for a coordinate based
! implementation of the PES routine

module UserPotIdxParams
  implicit None

  ! keep the iup variable. See '-up' command line option
  integer       :: iup

  logical, save :: UserPotIdxInitialized = .false.

  ! ADD YOUR PARAMETERS HERE

contains

  subroutine InitUserPotIdxParams()
    implicit None

    if (UserPotIdxInitialized) return


    ! INITIALIZE YOUR PARAMETERS HERE.
    ! FOR FILE IO USE UNIT 50
    ! AND CLOSE IT WHEN DONE
    ! (see 'channels.inc').

    UserPotIdxInitialized = .true.

  end subroutine InitUserPotIdxParams


end module UserPotIdxParams





! This a template function body. it can be used
! to implement a custom PES routine.
! Do not rename or change the interface.

! Input is the grid-point vector 'idx'
! to evaluate the potential.
! The coordinate vector is
! ordered as the DOF are defined in the
! PRIMITIVE-BASIS-SECTION.
!
! Note: The function UserPotIdx is usually called
! in parallel if compiled with the
! OpenMP flag. I.e., the function is called from
! inside an "omp parallel" secion.
! Therefore, the function must be
! thread safe. See also the documentation
! on how to suppress parallel execution
! when compiled with OpenMP flag.
double precision function UserPotIdx(idx,ndof)
  use UserPotIdxParams
  implicit None
  integer, intent(IN) :: ndof
  integer, intent(IN) :: idx(ndof)


  ! The routine should initialize
  ! upon the first call
  if (.not. UserPotIdxInitialized) then

     ! MAKE SURE THE INITIALISATION
     ! IS THREAD SAFE!

     !$omp critical
     call InitUserPotIdxParams()
     !$omp end critical
  end if

  ! change this top return a potential
  ! given the DVR point index 'idx'
  UserPotIdx = 0.d0

end function UserPotIdx

