!#######################################################################
! CLOSEDAT
!
! called from main
!
! closes files at end of program
!
! V5.0 MB
!
!#######################################################################

      subroutine closedat

use decimal, only: long
use global
use griddatmod
use datenmod
use runpropmod
use operdef
use runopermod
use runinwfmod
use dirdyn, only: the_db
use sqlite, only: sqlite3_close
use channels

use logdat

      implicit none

      integer(long)            :: i,ierr,ilbl
      logical(kind=4)          :: check
      character(len=100)       :: buffer
      character(len=c5)        :: filename

      call fpstartup(buffer)
      
!-----------------------------------------------------------------------
! Close files and write final time to log (output) files
!-----------------------------------------------------------------------

      inquire(iin,opened=check)
      if (check) then
        if(lusecpp)then
          close(iin, status="delete")
        else
          close(iin)
        end if
      end if

      inquire(ipsi,opened=check)
      if (check) close(ipsi)

      inquire(ichk,opened=check)
      if (check) close(ichk)

      inquire(ilnp,opened=check)
      if (check) close(ilnp)

      inquire(irho,opened=check)
      if (check) close(irho) 

      inquire(icroco,opened=check)
      if (check) close(icroco)

      inquire(iaut,opened=check)
      if (check) close(iaut)

      inquire(ictr,opened=check)
      if (check) close(ictr)

      inquire(istp,opened=check)
      if (check) close(istp)

      inquire(iupd,opened=check)
      if (check) close(iupd)

      inquire(idat,opened=check)
      if (check) close(idat)

      inquire(irst,opened=check)
      if (check) close(irst)

      inquire(ienerd,opened=check)
      if (check) close(ienerd)

      inquire(ispeed,opened=check)
      if (check) close(ispeed)

      inquire(iop,opened=check)
      if (check) close(iop)

      inquire(iaut1,opened=check)
      if (check) close(iaut1)

      inquire(iaut2,opened=check)
      if (check) close(iaut2)

      inquire(iexpect,opened=check)
      if (check) close(iexpect)

      inquire(ieigval,opened=check)
      if (check) close(ieigval)

      inquire(iorb,opened=check)
      if (check) close(iorb)

      inquire(ilancz,opened=check)
      if (check) close(ilancz)

      inquire(ieigvec,opened=check)
      if (check) close(ieigvec)

!DWF  Dynamical WF related
!DWF  read/write of the spf basis section
      inquire(ispwn,opened=check)
      if (check) close(ispwn)
!DWF  number of SPFs
      inquire(inspf,opened=check)
      if (check) close(inspf)
!DWF  eigenvalues
      inquire(iopteigen,opened=check)
      if (check) close(iopteigen)
!DWF  eigevectors
      inquire(ioptveig,opened=check)
      if (check) close(ioptveig)

      inquire(icontrol,opened=check)
      if (check) close(icontrol)

      inquire(itout,opened=check)
      if (check) close(itout)

      inquire(iactive,opened=check)
      if (check) close(iactive)

      inquire(iolog,opened=check)
      if (check) close(iolog)

      inquire(ioper,opened=check)
      if (check) close(ioper)
      if (ldelop) then
         filename=oname(1:olaenge)//'/oper'
         open(ioper,file=filename,form='unformatted',status='old', &
              iostat=ierr)
         if (ierr .ne. 0) then
            ilbl=index(filename,' ')-1
            routine = 'closedat'
            message = 'Cannot delete file: '//filename(1:ilbl)
            call warnmsg
         else
            close(ioper,status='delete')
         endif
      endif

      inquire(idvr,opened=check)
      if (check) close(idvr)
      if (ldeldvr) then
         filename=dname(1:dlaenge)//'/dvr'
         open(idvr,file=filename,form='unformatted',status='old', &
              iostat=ierr)
         if (ierr .ne. 0) then
            ilbl=index(filename,' ')-1
            routine = 'closedat'
            message = 'Cannot delete file: '//filename(1:ilbl)
            call warnmsg
         else
            close(idvr,status='delete')
         endif
      endif

      if(iout.ne.6) then
         inquire(iout,opened=check)
         if(check)then
            write(iout,*)
            write(iout,'(1x,75a)') ('-',i=1,75)
            write(iout,'(1x,a)') trim(buffer)
            write(iout,'(1x,a)') name(1:laenge)
            if (runtitle(1:10) .ne. '          ' ) &
                 write(iout,'(1x,a)') runtitle(1:78)
         endif
      endif

      inquire(itim,opened=check)
      if (check)  close(itim)

      inquire(itimp,opened=check)
      if (check) close(itimp)
#ifdef MPI
      inquire(itimmpi,opened=check)
      if (check) close(itimmpi)
#endif

      inquire(ilog,opened=check)
      if (check) then
         write (ilog,'(a)') trim(buffer)
         close(ilog)
      endif

      inquire(iBEL,opened=check)
      if (check) then
         close(iBEL)
      endif

      if( lstopf ) then
         inquire(istop,opened=check)
         if (check) then
            close(istop,status='delete')
         else
            inquire(file=name(1:laenge)//'/stop',exist=check)
            if(check) then
               open (istop,file=name(1:laenge)//'/stop', &
                    form='formatted',status='old')
               close(istop,status='delete')
            end if
         end if
      end if

      if( the_db%db_open ) call sqlite3_close( the_db )

      return
      end subroutine closedat

