!***********************************************************************
!
!           MCTDH subroutine MDEFAULT.F
!
!  In this subroutine all non-local variables and parameters
!  should be initialized.
!
!   01/98 AJ
!
!***********************************************************************

      subroutine mdefault

use decimal, only: long
use global
use globmemmod
use maxv
use dvrdatmod
use griddatmod
use operdef
use dirdyn
use psidef
use runopermod
use runinwfmod
use runpropmod
use datenmod
use versions
use paths
use compdatmod
use linintmod
use oct
use lctmod
use gapmod

use logdat
use op1lib, only: zerovxl,zerovxi,zerovxd,zerovxz,initvxd,initvxz,initvxi,&
                  initvxl,zeromxi,zeromxd,zeromxl,initmxz,initmxl

      implicit none

!-----------------------------------------------------------------------
!     Set initial UNIX time. Needed for wall-time stops via stopfile.
!-----------------------------------------------------------------------
      call unixzeit(tm_zero)

!-----------------------------------------------------------------------
!     Set path for operator files (xxx.op) to default 
!     $QUANTICS_DIR/operators. This can be re-set in operator-section
!-----------------------------------------------------------------------
      oppath=oppathdef
      opplaenge=index(oppathdef,' ')-1

!-----------------------------------------------------------------------
! read by subroutines openin and einrun
!-----------------------------------------------------------------------
      sstop    = '  '
      scpu     = '  '
      swall    = '  '
      optstring= '  '
      precon   = 0
      precon2  = 0
      constop  = -1.0_dop
      e1stop   = 10.0_dop
      e2stop   = 1.0_dop
      npd1     = 0
      npd2     = 0
      npd3     = 0
      npd4     = 0
      phicount = 0
      lddmctdh = .false.
      lgaptest = .false.
      ddcoo    = -1
      loutfil  = .true.
      lpdens   = .false.
      lgpop    = .false.
      lauto    = .false.
      lautodoub= .false.
      lautoord1= .false.
      lautoord2= .false.
      lintstep = .false.
      lupdate  = .true.
      lspeed   = .true.
      lstopf   = .true.
      lpsi     = .false.
      liopt    = .false.
      llanczvec= .false.
      leigvec  = .false.
      lcross   = .false.
      lctr     = .false.
      lreonly  = .false.
      lreonly1 = .false.
      lquadpop = .false.
      lquadphi = .false.
      lbackr   = .false.
      lnatpopstop= .false.
      lstop    = .false.
      leinint  = .false.
      ltinitcmd= .false.

!-----------------------------------------------------------------------
! optcntrl
!-----------------------------------------------------------------------
      loptcntrl= .false.
      loctpc   = .false. 
      lsimprop = .false. 
      loctupdate= .false.

!-----------------------------------------------------------------------
! lwrlog controls writing to logfile in subroutine rstinfo
! Added to prevent flooding of logfile when using optcntrl
!-----------------------------------------------------------------------
      lwrlog   = .true.
      lortho   = .false.
      lquad    = .false.
      lolsen   = .false.
      lautoblk = .false.
      lsplitrst= .false.
      lrealphi = .false.
      louteverystep = .false.
      nexpect  = 0
      nexpect1 = 0
      ctrnum   = 0 
      ctrname  = ' '
      psicut   = 1.0d-8
      gmatf1   = 0
      gmatf2   = 0
      call zerovxl(lpsiopt,6)

!-----------------------------------------------------------------------
! local control variables and flags
!-----------------------------------------------------------------------
      ilctenv = 1
      lctevalue = -999.0d0
      lctftime = 300.0d0*fs
      lctenvtime = 200.0d0*fs
      lctenvwidth = 50.0d0*fs

!-----------------------------------------------------------------------
! check that space for comparison data sets is present (used to switch 
!between different system parameter sets, e.g. in geninwf and genoper) 
!-----------------------------------------------------------------------
      ncomp=2
      if (ncomp .gt. maxcomp) then
         routine='Mdefault'
         write(message,'(a,i5)') &
            'Increase MAXCOMP in compdat.inc. Minimum : ',ncomp
         call errormsg
      endif


!-----------------------------------------------------------------------
! initialize some variables related to linear interpolation (linint.inc) 
!-----------------------------------------------------------------------
      li_total=0
      li_allocd=0
      li_file(1)=0
      li_file(2)=0
      li_start(1)=0
      li_start(2)=0
      li_step(1)=0
      li_step(2)=0
      li_buflen(1)=0
      li_buflen(2)=0
      li_buffer(1)=0
      li_buffer(2)=0
      li_init(1)=0
      li_init(2)=0

!-----------------------------------------------------------------------
! initialize variables for Davidson arrays
!-----------------------------------------------------------------------
      ikrylov=0
      ikryc=0

      return
      end subroutine mdefault

