!#######################################################################
!
! module CISELECT
!
! contains :: venindex,venindex1,venpsi,venpsi1
!
! venindex it is not called from anywhere!
!#######################################################################

      module ciselect

use decimal, only: long, dop

      implicit none

      private
      public :: venindex,venindex1,venpsi,venpsi1
      contains

!#######################################################################
      subroutine venindex(m,jspace,jindex,jblock,iblock,nmode, &
                 jvdim,jdim,jndim,fvdim)

      implicit none

      integer(long)             :: n,e,v,k2,l,k1,fvdim1
      integer(long), intent(in) :: nmode,m,jndim,jvdim,jdim,jblock,iblock

      integer(long), dimension(iblock), intent(out) :: jindex
      integer(long), dimension(jblock), intent(in)  :: jspace
      integer(long), dimension(nmode), intent(in)   :: fvdim

      if (m .eq. nmode) then
         fvdim1=1
      else
         fvdim1=fvdim(m+1)
      endif

      k1=jvdim
      l=0
      k2=0
      do n=1,jndim
!  10    continue
!        lindx=l*fvdim1+1
!        if (lindx .lt. jspace(k1)) then
!           l=l+1
!           go to 10
!        endif
         l=jspace(k1)-1
         l=(l/fvdim1) 

         do e=1,jdim
            do v=1,jvdim
               k2=k2+1
               jindex(k2) =  jspace(v)+fvdim(m)*(e-1)+l*fvdim1
            enddo
         enddo

   20    continue
         if (jspace(k1) .le. jindex(k2)) then
            k1=k1+1
            go to 20
         endif

      enddo

      return
      end subroutine venindex

!#######################################################################

      subroutine venindex1(m,vjspace,njspace,jindex,vblock,nblock, &
                 iblock,nmode,jvdim,jdim,jndim,fvdim)

      implicit none

      integer(long)             :: n,e,v,k2,l,k1,fvdim1,lindx
      integer(long), intent(in) :: nmode,m,jndim,jvdim,jdim,iblock,vblock,nblock

      integer(long), dimension(vblock), intent(in)  :: vjspace
      integer(long), dimension(nblock), intent(in)  :: njspace
      integer(long), dimension(iblock), intent(out) :: jindex
      integer(long), dimension(nmode), intent(in)   :: fvdim

      if (m .eq. nmode) then
         fvdim1=1
      else
         fvdim1=fvdim(m+1)
      endif

      k2=1
      k1=1
      l=1
      do n=1,jndim
         do e=1,jdim
            do v=1,jvdim
               jindex(k2) = vjspace(v) + fvdim(m)*(e-1) + &
                               (l-1)*fvdim1
               k2=k2+1
            enddo
         enddo

         lindx = 1 + l*fvdim1
   20    continue
         if (njspace(k1) .eq. lindx) then
            l=l+1
         else if (njspace(k1) .gt. lindx) then
            l=l+1
            lindx = 1 + l*fvdim1
            go to 20
         else if (k1 .lt. nblock) then
            k1=k1+1
            go to 20
         endif
      enddo

      return
      end subroutine venindex1

!#######################################################################
!
! VENPSI
!
! changes S-MCTDH wavefunction so that coefficients can be arranged
! as tensor A(vdim,dim,ndim)
!
! input:
!   psi   :  old wavefunction
!   jindx : index vector for old wavefunction
!   jspace: index space from which indices are taken
! output:
!   psi1   : new wavefunction coefficients
!   jindx1 : index vector for new wavefunction
!
!#######################################################################

      subroutine venpsi(m,jspace,jindx1,jindx,jblock,block1,block, &
                 nmode,jvdim,jdim,jndim,fvdim,psi1,psi)

      implicit none

      integer(long)             :: n,e,v,k2,l,k1,fvdim1,k3
      integer(long), intent(in) :: nmode,m,jndim,jvdim,jdim,jblock,block1,block

      integer(long), dimension(jblock), intent(in)  :: jspace
      integer(long), dimension(block), intent(in)   :: jindx
      integer(long), dimension(block1), intent(out) :: jindx1
      integer(long), dimension(nmode), intent(in)   :: fvdim
      complex(dop), dimension(block), intent(in)    :: psi
      complex(dop), dimension(block1), intent(out)  :: psi1

      if (m .eq. nmode) then
         fvdim1=fvdim(m)*jdim
      else
         fvdim1=fvdim(m+1)
      endif

      k1=jvdim
      k2=0
      k3=1
      do n=1,jndim
         l=jspace(k1)-1
         l=(l/fvdim1) 

         do e=1,jdim
            do v=1,jvdim
               k2=k2+1
               jindx1(k2) = jspace(v)+fvdim(m)*(e-1)+l*fvdim1

   10          continue
               if (jindx1(k2) .eq. jindx(k3)) then
                  psi1(k2)=psi(k3)
               else if (jindx1(k2) .gt. jindx(k3) .and. &
                        k3 .lt. block) then
                  k3=k3+1
                  go to 10
               else
                  psi1(k2)=0.0_dop
               endif

            enddo
         enddo

         if (n .lt. jndim) then
   20       continue
            k1=k1+1
            if (jspace(k1) .le. jindx1(k2)) go to 20
         endif

      enddo

      return
      end subroutine venpsi

!#######################################################################

      subroutine venpsi1(m,vjspace,njspace,jindex1,jindex,vblock,nblock, &
                block1,block,nmode,jvdim,jdim,jndim,fvdim,psi1,psi)

      implicit none

      integer(long)                                 :: n,e,v,k2,l,k1,fvdim1,lindx,k3
      integer(long), intent(in)                     :: nmode,m,jndim,jvdim,jdim,vblock,nblock,block1,block

      integer(long), dimension(vblock), intent(in)  :: vjspace
      integer(long), dimension(nblock), intent(in)  :: njspace
      integer(long), dimension(block), intent(in)   :: jindex
      integer(long), dimension(block1), intent(out) :: jindex1
      integer(long), dimension(nmode), intent(in)   :: fvdim
      complex(dop), dimension(block), intent(in)    :: psi
      complex(dop), dimension(block1), intent(out)  :: psi1

      if (m .eq. nmode) then
         fvdim1=0
      else
         fvdim1=fvdim(m+1)
      endif

      k1=1
      k2=1
      l=1
      k3=1
      do n=1,jndim
         do e=1,jdim
            do v=1,jvdim
               jindex1(k2) = vjspace(v) + fvdim(m)*(e-1) + &
                               (l-1)*fvdim1

   10          continue
               if (jindex1(k2) .eq. jindex(k3)) then
                  psi1(k2)=psi(k3)
               else if (jindex1(k2) .gt. jindex(k3) .and. &
                        k3 .lt. block) then
                  k3=k3+1
                  go to 10
               else
                  psi1(k2)=0.0_dop
               endif

               k2=k2+1

            enddo
         enddo

         lindx = 1 + l*fvdim1
   20    continue
         if (njspace(k1) .eq. lindx) then
            l=l+1
         else if (njspace(k1) .gt. lindx) then
            l=l+1
            lindx = 1 + l*fvdim1
            go to 20
         else if (k1 .lt. nblock) then
            k1=k1+1
            go to 20
         endif
      enddo

      return
      end subroutine venpsi1
!#######################################################################

      end module ciselect
     

