!#######################################################################
!
!#######################################################################

     module file_enquire

use decimal, only: long, dop
use global, only: c2

      implicit none
      private
      public :: wrenquire

      public :: data_enquire,str_enquire,chck_enquire

      interface wrenquire
         module procedure wrenquire_i,&
                          wrenquire_i1,&
                          wrenquire_i2,&
                          wrenquire_d,&
                          wrenquire_d1,&
                          wrenquire_d2,&
                          wrenquire_c,&
                          wrenquire_l,&
                          wrenquire_l1,&
                          wrenquire_l2
      end interface wrenquire

!-----------------------------------------------------------------------
! If ldata_enquire true then data printed to screen
!    str_enquire : string containing data to be printed
!-----------------------------------------------------------------------
      integer(long), save     :: data_enquire=0
      character(len=c2), save :: str_enquire
      logical(kind=4), save   :: chck_enquire

      contains

!#######################################################################

      subroutine wrenquire_i(rdtag,idata)

      implicit none

      integer(long), intent(in)    :: idata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,*) trim(str_enquire),' : ',idata
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_i

!#######################################################################

      subroutine wrenquire_i1(rdtag,idata,dim1,per1)

      implicit none

      integer(long), intent(in)    :: dim1
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      integer(long), dimension(dim1), intent(in) :: idata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,i10)') trim(str_enquire),'  Dimension : ',dim1
         do i=1,dim1,p1
            write(6,*) idata(i:i+p1-1)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_i1

!#######################################################################

      subroutine wrenquire_i2(rdtag,idata,dim1,dim2,per1)

      implicit none

      integer(long), intent(in)    :: dim1,dim2
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      integer(long), dimension(:,:), intent(in) :: idata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i,j

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,2i10)') trim(str_enquire),'  Dimension : ',dim1,dim2
         do j=1,dim2
            do i=1,dim1,p1
               write(6,*) idata(i:i+p1-1,j)
            enddo
            write(6,*)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_i2

!#######################################################################

      subroutine wrenquire_d(rdtag,ddata)

      implicit none

      real(dop), intent(in)        :: ddata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,*) trim(str_enquire),' : ',ddata
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_d

!#######################################################################

      subroutine wrenquire_d1(rdtag,ddata,dim1,per1)

      implicit none

      integer(long), intent(in)    :: dim1
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      real(dop), dimension(dim1), intent(in) :: ddata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,i10)') trim(str_enquire),'  Dimension : ',dim1
         do i=1,dim1,p1
            write(6,*) ddata(i:i+p1-1)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_d1

!#######################################################################

      subroutine wrenquire_d2(rdtag,ddata,dim1,dim2,per1)

      implicit none

      integer(long), intent(in)    :: dim1,dim2
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      real(dop), dimension(:,:), intent(in)  :: ddata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i,j

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,2i10)') trim(str_enquire),'  Dimension : ',dim1,dim2
         do j=1,dim2
            do i=1,dim1,p1
               write(6,*) ddata(i:i+p1-1,j)
            enddo
            write(6,*)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_d2

!#######################################################################

      subroutine wrenquire_c(rdtag,cdata)

      implicit none

      character(len=*), intent(in) :: cdata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,a)') trim(str_enquire),' : ',trim(cdata)
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_c

!#######################################################################

      subroutine wrenquire_l(rdtag,ldata)

      implicit none

      logical(kind=4), intent(in)  :: ldata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,*) trim(str_enquire),' : ',ldata
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_l

!#######################################################################

      subroutine wrenquire_l1(rdtag,ldata,dim1,per1)

      implicit none

      integer(long), intent(in)    :: dim1
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      logical(kind=4), dimension(dim1), intent(in) :: ldata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,i10)') trim(str_enquire),'  Dimension : ',dim1
         do i=1,dim1,p1
            write(6,*) ldata(i:i+p1-1)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_l1

!#######################################################################

      subroutine wrenquire_l2(rdtag,ldata,dim1,dim2,per1)

      implicit none

      integer(long), intent(in)    :: dim1,dim2
      integer(long), intent(in), optional    :: per1
      integer(long)                          :: p1
      logical(kind=4), dimension(:,:), intent(in) :: ldata
      character(len=*), intent(in) :: rdtag
      integer(long) :: ilbl,jlbl,i,j

      p1=1
      if (present(per1)) p1=per1

      ilbl = index(rdtag,'<')+1
      jlbl = index(rdtag,'>')-1

      if (data_enquire .eq. 1) then
         write(6,'(a)') rdtag(ilbl:jlbl)
      else if (data_enquire .eq. 2 .and. &
         trim(str_enquire) .eq. rdtag(ilbl:jlbl)) then
         write(6,'(2a,2i10)') trim(str_enquire),'  Dimension : ',dim1,dim2
         do j=1,dim2
            do i=1,dim1,p1
               write(6,*) ldata(i:i+p1-1,j)
            enddo
            write(6,*)
         enddo
         chck_enquire = .true.
      endif

      return
      end subroutine wrenquire_l2

      end module file_enquire

