  
      subroutine chksyserr(file,lerr)

use decimal, only: long
use global

use logdat

      implicit none

      integer(long)                :: ilbl
      character(len=*), intent(in) :: file
      logical(kind=4), intent(out) :: lerr

      routine='Chksyserr'
      ilbl=index(file,' ')-1

      lerr=.false.
      if (chkerr(1) .ne. 0) then
         lerr=.true.
         message = 'Error reading file : '//file(1:ilbl)
         call warnmsg
      else if (chkerr(2) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Dofs differ from system'
         call warnmsg
      else if (chkerr(3) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' DVR bases differ from system'
         call warnmsg
      else if (chkerr(4) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Mode combinations differ from system'
         call warnmsg
      else if (chkerr(5) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Electronic basis type differs from system'
         call warnmsg
      else if (chkerr(6) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Spf basis differs from system'
         call warnmsg
      else if (chkerr(7) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Dofs not subset of system dofs'
         call warnmsg
      else if (chkerr(8) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' not for this system'
         call warnmsg
      else if (chkerr(9) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Psi type differs from system'
         call warnmsg
      else if (chkerr(10) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' Density matrix type differs from system'
         call warnmsg
      else if (chkerr(11) .ne. 0) then
         lerr=.true.
         message = &
         file(1:ilbl)//' GWP basis type differs from system'
         call warnmsg
      endif


      return
      end subroutine chksyserr

