!#######################################################################
!          MCTDH   module MEMHOPS
!
!   Contains:  memhops,  chkmemwk  
!
! memhops calculates the pointers for the operator arrays: hc hr hi hl.
! re-sets the memory arrays: mc mr mi ml
! Called from: memprop, meminwf, flux, maxpe, showsys, expect, pexpect,
!              vminmax
!#######################################################################
      module memhopsmod

use decimal, only: long, dop, vlong
!use decimal, only: long, dop
use global
use globmemmod
use dvrdatmod
use griddatmod
use psidef
use operdef

      implicit none
      private
      public :: memhops

      contains
!#######################################################################

      subroutine memhops

      implicit none

!-----------------------------------------------------------------------
! alter memory assignments for mc etc to include data needed by hops
!-----------------------------------------------------------------------
      mcdim=mcworkc 
      mchin=mcdim
      mcdim=mchin+fftdim + 1 
      mcrueck=mcdim
      mcdim=mcrueck+fftdim + 1
      mcexphin=mcdim
      mcdim=mcexphin+expdim + 1
      mcexprueck=mcdim
      mcdim=mcexprueck+expdim  + 1
      mcworkc=mcdim 
      mcdim=mcdim+workcdim

      mrdim=mrworkr
      mrhops=mrdim 
      mrdim=mrhops+hopsdim + 1
      mrworkr=mrdim
      mrdim=mrdim+workrdim 
      mrdim=mrdim+d3matdim*2

      midim=miworki
      mifftfak=midim
      midim=mifftfak+fftdim
      miworki=midim
      midim=midim+workidim

      return
      end subroutine memhops

      end module memhopsmod

