      module xlocphihphimod

use decimal, only: dop,long
use op1lib, only: zeromxz

      implicit none
      private
      public :: xlocphihunphi,xlocphihphi
      contains

!#######################################################################

      subroutine xlocphihphi (psi,hteil,h,f,subdim1,dim1)

use global
use maxv, only: maxdim
use operdef

use potevalmod, only: poteval

      implicit none

      integer(long)                                     :: e,idum
      integer(long), intent(in)                         :: h,dim1,subdim1,f
      real(dop)                                         :: v
      real(dop), dimension(maxdim)                      :: rdum
      real(dop), dimension(maxdim)                      :: gpoint
      complex(dop)                                      :: vz
      complex(dop), dimension(subdim1,dim1), intent(in) :: psi
      complex(dop), dimension(dim1,dim1), intent(out)   :: hteil

      call zeromxz(hteil,dim1,dim1)

      do e=1,dim1
         if (htmtype(h) .eq. 101) then
            gpoint(f)=dble(psi(1,e))
         else if (htmtype(h) .eq. 102) then
            gpoint(f)=dble(psi(2,e))
         endif
         call poteval (h,v,gpoint,vz,rdum,idum)
         hteil(e,e)=v
      enddo

      return
      end subroutine xlocphihphi

!#######################################################################

      subroutine xlocphihunphi (psi,hteil,m,f,subdim1,dim1,nham)

use global
use maxv, only: maxdim
use operdef

use potevalmod, only: poteval

      implicit none

      integer(long)                                     :: e,h,k,k1,k2,idum
      integer(long), intent(in)                         :: m,dim1,subdim1,f,nham
      real(dop)                                         :: v
      real(dop), dimension(maxdim)                      :: rdum
      real(dop), dimension(maxdim)                      :: gpoint
      complex(dop)                                      :: vz
      complex(dop), dimension(subdim1,dim1), intent(in) :: psi
      complex(dop), dimension(dim1,dim1), intent(out)   :: hteil

      call zeromxz(hteil,dim1,dim1)

      k1=zhun(m,1,nham)
      k2=zhun(m,1,nham)+khzahl(m,1,nham)-1
      do k=k1,k2
         h=hamilton(f,k)
         if (htmtype(h) .eq. 101) then
            do e=1,dim1
               gpoint(f)=dble(psi(1,e))
               call poteval (h,v,gpoint,vz,rdum,idum)
               hteil(e,e)=hteil(e,e)+v
            enddo
!        else if (htmtype(h) .eq. 102) then
!           call anlmomeval (h,workc,psi,subdim1,dim1)           
!           call addmxxzo(workc,hteil,dim1,dim1)
         endif
      enddo

      return
      end subroutine xlocphihunphi

      end module xlocphihphimod
