!-----------------------------------------------------------------------
subroutine sv_mlpf_read(lun,nr,ndof,fmap,gdim)
!-----------------------------------------------------------------------
   use genmlham
   implicit none
   integer :: lun,nr,ndof,fmap(ndof),gdim(*)
   integer :: f,mapgdim(ndof)
   do f=1,ndof
      mapgdim(f) = gdim(fmap(f))
   enddo
   call mlpf_read(lun,nr,fmap,mapgdim)
end subroutine sv_mlpf_read


!-----------------------------------------------------------------------
subroutine sv_mlpf_check_dofs(nr,ndof,mulddof,lmatch)
!-----------------------------------------------------------------------
   use genmlham
   implicit none
   integer :: nr,ndof,mulddof(ndof)
   logical :: lmatch
   lmatch = mlpf_check_dofs(nr,mulddof)
end subroutine sv_mlpf_check_dofs


!-----------------------------------------------------------------------
subroutine sv_mlop_enqueue(totmlop,ndof,imlop,hamnum)
!-----------------------------------------------------------------------
   use genmlham
   implicit none
   integer :: totmlop,ndof,hamnum,imlop(ndof)
   totmlop = mlop_enqueue(imlop,hamnum)
end subroutine sv_mlop_enqueue


!-----------------------------------------------------------------------
subroutine sv_mlop_finalize(nham,tape)
!-----------------------------------------------------------------------
   use mltypes
   use maxv, only: maxtape
   use genmlham
   use wftree
   use wftree1
   use if_grid
   use global
   implicit none
   integer                :: nham,tape(maxtape)
   type(wfnode_t),pointer :: mlwf
   mlwf => new_wftree(tape,if_spfdof)
   call mlop_finalize(nham,mlwf)
   call dispose_wftree(mlwf)
end subroutine sv_mlop_finalize


!-----------------------------------------------------------------------
subroutine fdefmlop(ifunc,label,ifile,ipar,rpar,maxpar)
!-----------------------------------------------------------------------
   use mlbase
   use operutil, only: mlnp_parse
   implicit none
   integer          :: ifunc,ifile,maxpar,ipar(maxpar)
   real*8           :: rpar(maxpar),rpar1
   character(len=*) :: label
   integer          :: imlop,ileaf,ibasis
   if (label(1:4) /= "mlnp") return
   ! Read label.
   call mlnp_parse(label,imlop,ileaf,ibasis)
   if (imlop==0 .or. ileaf==0 .or. ibasis==0) call stop_code('(none)', 'fdefmlop', &
      'error reading parameters from MLNP label, hoplab = "'//trim(label)//'"')
   ! Return values.
   ifile = 9
   ifunc = imlop
   ipar(1) = ileaf
   ipar(2) = ibasis

! rpar not used
   rpar1 = rpar(1)
end subroutine fdefmlop


!-----------------------------------------------------------------------
subroutine callmlop(hopd,sdm,imlop,ileaf,ibasis)
!-----------------------------------------------------------------------
   use mltypes
   use genmlham
   use vtree
   use mlbase
   implicit none
   integer               :: sdm,imlop,ileaf,ibasis
   real*8                :: hopd(sdm)
   type(vtree_t),pointer :: mlpf
   type(vnode_t),pointer :: leaf

   ! Recall the MLPF that this MLOp was made from.
   mlpf => mlop_get_mlpf(imlop)
   ! Find the leaf.
   leaf => mlpf%leaves(ileaf)%p
   ! Check.
   if (sdm /= leaf%plen .or. ibasis<1 .or. ibasis>leaf%nbasis) then
      write (*,'(a,i0)') "mlop number = ",imlop
      write (*,'(a,i0)') "leaf number = ",ileaf
      write (*,'(a,i0)') "leaf pot.   = ",ibasis
      write (*,'(a,i0)') "subdim      = ",sdm
      write (*,'(a,i0)') "leaf plen   = ",leaf%plen
      write (*,'(a,i0)') "leaf nbasis = ",leaf%nbasis
      call stop_code("(none)", "callmlop", "inconsistency detected")
   endif
   ! Copy the requested leaf potential.
   hopd = leaf%basis(:,ibasis)

end subroutine callmlop

