

! search the iterations file
! to get the current iteration number
! for restart jobs
subroutine getstartiter(startiter, iterationsfile)
  use global
  use channels
  use logdat
  implicit none
  integer, intent(OUT)          :: startiter
  character(len=*), intent(IN)  :: iterationsfile
  integer                       :: ierr, ierr1

  open(idump, file=iterationsfile, status='old', action='read', iostat=ierr)
  if (ierr.ne.0) then
     routine = "getstartiter"
     message = "Unable do get restart iteration number: could not open file: " &
          //trim(iterationsfile)//". Will start at zero."
     call warnmsg
     startiter = 0
     return
  end if

  ierr = 0
  do while(ierr.eq.0)
     read(idump, *, iostat=ierr)

     if (ierr.lt.0) then
        ! we arrived behind the EOF marker
        backspace(idump)
        ! we are just in front of the EOF marker
        backspace(idump)
        ! we are at the begining of last line
        read(idump, *, iostat=ierr1) startiter
        if (ierr1.ne.0) goto 112
        close(idump)
        return
     elseif (ierr.gt.0) then
        ! read error
        goto 112
     else
        continue
     end if

  end do
  close(idump)

  return

112 continue
  routine = "getstartiter"
  message = "Unable do get restart iteration number: read error on file: " &
       //trim(iterationsfile)//". Will start at zero"
  call warnmsg
  close(idump)
  startiter = 0
  return

end subroutine getstartiter
