

! dot_product with quad presision result
! if available. otherwise fall back to
! blas ddot
function qddot(N,arr1,arr2) result(dot)
  use decimal
  use global
  use ISO_FORTRAN_ENV
  integer, intent(IN)     :: N
  real(dbl), intent(IN)   :: arr1(N), arr2(N)

#if defined(__GFORTRAN__) || defined(__INTEL_COMPILER)
  real(kind=real128)      :: dot
  integer                 :: i

  dot = 0.d0
  do i=1,N
     dot = dot + arr1(i)*arr2(i)
  end do

#else

  real(dbl)               :: dot, ddot

  ! real*8 blas
  dot = ddot(N,arr1,1,arr2,1)

#endif

end function qddot




! check is the stop file exists
! and if it says 'continue'
! if not, then stop iterations.
subroutine chkstop(stopfile, lstop)
  use global
  implicit none
  character(len=*), intent(IN) :: stopfile
  logical, intent(OUT)         :: lstop
  logical           :: lexists
  integer           :: istop
  character(len=c4) :: content
  integer           :: ilbl
  character(len=c5) :: rout, mdl, msg

  inquire(file=trim(stopfile), exist=lexists)

  if (.not. lexists) then
     lstop = .true.
  else
     open(newunit=istop, file=stopfile, err=398)
     read(istop,*,err=399) content
     close(istop)
     call cncntrblnk(content)
     content = adjustl(content)
     ilbl = index(content,' ')
     if (content(1:ilbl) .eq. "continue") then
        lstop = .false.
     else
        lstop = .true.
     end if
  end if

  return

398 continue
  ! open-error
  rout = "chkstop"
  mdl  = "hcpd_optimize"
  msg  = "Could not open file: "//trim(stopfile)
  call warn_msg(mdl,rout,msg)
  lstop = .true.
  return
399 continue
  ! read or open-error
  rout = "chkstop"
  mdl  = "hcpd_als"
  msg  = "Could not read file: "//trim(stopfile)
  call warn_msg(mdl,rout,msg)
  lstop = .true.
  return

end subroutine chkstop
