!#######################################################################

      module funcgrdmod

use decimal, only: long, dop
use xvlib,   only: xqxxdzo, xuxxdda, xqxxzd, xdxsdda, xdxxdda
use mmlib,   only: qqxxdd, qqtxdd
use op1lib,  only: zeromxz, cpqxdz, initmxz

use global
use dvrdatmod
use griddatmod
use logdat

      implicit none
      private
      public :: fdefgrd,funcgrd
      contains

!#######################################################################
! 
! ifile = 3
!#######################################################################

      subroutine fdefgrd(hopilab,hoplab,hopfile,hlabipar,hlabrpar, &
                 hoppar)

      implicit none

      integer(long)                                  :: ipower,ilbl,si,sf,&
                                                        jlbl,klbl,np,dk
      integer(long), intent(out)                     :: hopilab, hopfile
      integer(long), dimension(maxhpar), intent(out) :: hlabipar
      real(dop), dimension(maxhpar), intent(out)     :: hlabrpar
      real(dop), dimension(maxhpar,*), intent(in)    :: hoppar
      character(len=*), intent(in)                   :: hoplab

!-----------------------------------------------------------------------
! assign function number
!-----------------------------------------------------------------------
      if (hoplab .eq. 'KEfft') then
         hopilab=1

      else if (hoplab(1:6) .eq. 'dqfft^') then
         ilbl=index(hoplab,' ')-1
         read(hoplab(7:ilbl),*) ipower
         hlabipar(1)=ipower
         hopilab=2

      else if (hoplab .eq. 'pfft ') then
         ipower=1
         hlabipar(1)=ipower
         hopilab=3
      else if (hoplab(1:5) .eq. 'pfft^') then
         ilbl=index(hoplab,' ')-1
         read(hoplab(6:ilbl),*) ipower
         hlabipar(1)=ipower
         hopilab=3

      else if (hoplab .eq. 'KEdvr') then
         hopilab=5

      else if (hoplab .eq. 'dqdvr^1') then
         hopilab=6

      else if (hoplab .eq. 'dth1') then
         hopilab=6

      else if (hoplab .eq. 'dth2') then
         hopilab=6 

      else if (hoplab .eq. 'sdq:sin') then
         hopilab=6

      else if (hoplab .eq. 'sdq:cos') then
         hopilab=6

      else if (hoplab .eq. 'qdq:rHO') then
         hopilab=6

      else if (hoplab .eq. 'dqdvr^2') then
         hopilab=7

      else if (hoplab .eq. 'j^2') then
         hopilab=8

      else if (hoplab .eq. 'j^2sph') then
         hopilab=9

      else if (hoplab(1:1) .eq. 'S') then
         ilbl=2
         jlbl=index(hoplab,'&')
         if(jlbl.eq.0) goto 90
         klbl=index(hoplab,' ')-1
         read(hoplab(ilbl:jlbl-1),*) sf
         read(hoplab(jlbl+1:klbl),*) si
         hlabipar(2)=sf
         hlabipar(3)=si

         hopilab=10

      else if (hoplab .eq. 'pdvr') then
         hopilab=11

      else if (hoplab(1:1) .eq. 'Z') then
         ilbl=2
         jlbl=index(hoplab,'&')
         if(jlbl.eq.0) goto 90
         klbl=index(hoplab,' ')-1
         read(hoplab(ilbl:jlbl-1),*) sf
         read(hoplab(jlbl+1:klbl),*) si
         hlabipar(2)=sf
         hlabipar(3)=si

         hopilab=12

      else if (hoplab .eq. 'jzsph') then
         hopilab=13

      else if (hoplab .eq. 'jzzsph') then
         hopilab=14

! lowering operator
      else if (hoplab(1:3) .eq. 'low') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 3) then
            if (hoplab(4:4) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(5:ilbl),*) np
               hlabrpar(1)=hoppar(1,np)
               hlabrpar(2)=hoppar(2,np)
               hlabrpar(3)=hoppar(3,np)
            else
               hlabrpar(1)=1.0_dop
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=0.0_dop
               ilbl=2
            endif
         endif
         hopilab=15
         
! raising operator
      else if (hoplab(1:3) .eq. 'rai') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 3) then
            if (hoplab(4:4) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(5:ilbl),*) np
               hlabrpar(1)=hoppar(1,np)
               hlabrpar(2)=hoppar(2,np)
               hlabrpar(3)=hoppar(3,np)
            else
               hlabrpar(1)=1.0_dop
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=0.0_dop
               ilbl=2
            endif
         endif
         hopilab=16

! number operator
      else if (hoplab(1:3) .eq. 'num') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 3) then
            if (hoplab(4:4) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(5:ilbl),*) np
               hlabrpar(1)=hoppar(1,np)
               hlabrpar(2)=hoppar(2,np)
               hlabrpar(3)=hoppar(3,np)
            else
               hlabrpar(1)=1.0_dop
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=0.0_dop
               ilbl=2
            endif
         endif
         hopilab=17

! lowering Morse operator
      else if (hoplab(1:7) .eq. 'lwmorse') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 7) then
            if (hoplab(8:8) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(9:ilbl),*) np
               hlabrpar(1)=hoppar(1,np) ! M
               hlabrpar(2)=hoppar(2,np) ! omega
               hlabrpar(3)=hoppar(3,np) ! Lambda
               hlabrpar(4)=hoppar(4,np) ! alpha
               hlabrpar(5)=hoppar(5,np) ! z0
            else
               hlabrpar(1)=1.0_dop
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=1.0_dop              
               hlabrpar(4)=1.0_dop
               hlabrpar(5)=1.0_dop
               ilbl=6
            endif
         endif
         hopilab=18          

! raising Morse operator
      else if (hoplab(1:7) .eq. 'ramorse') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 6) then
            if (hoplab(8:8) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(9:ilbl),*) np
               hlabrpar(1)=hoppar(1,np) ! m
               hlabrpar(2)=hoppar(2,np) ! omega
               hlabrpar(3)=hoppar(3,np) ! Lambda
               hlabrpar(4)=hoppar(4,np) ! alpha
               hlabrpar(5)=hoppar(5,np) ! z0
            else
               hlabrpar(1)=1.0_dop
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=1.0_dop     
               hlabrpar(4)=1.0_dop  
               hlabrpar(5)=1.0_dop
               ilbl=6
            endif
         endif
         hopilab=19

! Flux operator for sin-DVR, Sinc-DVR, Wsinc_DVR, exp-DVR and FFT.
      else if (hoplab(1:5) .eq. 'flux[') then
         ilbl = index(hoplab,']')-1
         read(hoplab(6:ilbl),*) np
         hlabrpar(1)=hoppar(1,np) ! x-cut 
         hlabrpar(2)=hoppar(2,np) ! exponent of smoothing function.
         hopilab=20

! Total angular momentum operators Jp, Jm, Jx, Jy.
      else if (hoplab .eq. 'Jp') then
         hopilab=21

      else if (hoplab .eq. 'Jm') then
         hopilab=22

      else if (hoplab .eq. 'Jx') then
         hopilab=23

      else if (hoplab .eq. 'Jy') then
         hopilab=24

! Projector Gauss function | G >< G |
      else if (hoplab(1:6) .eq. 'pgauss') then
         ilbl = index(hoplab,']')-1
         read(hoplab(8:ilbl),*) np
         if (np .gt. 0) then
            hlabrpar(2)=hoppar(1,np)
            hlabrpar(3)=hoppar(2,np)
         else
            hlabrpar(2)=1.0_dop
            hlabrpar(3)=0.0_dop
         endif
         hopilab=25

! Operators of the form 0.5*(dq f(q) + f(q) dq)
      else if (hoplab .eq. 'cdq') then
         hopilab=26
      else if (hoplab .eq. 'sdq') then
         hopilab=27
      else if (hoplab .eq. 'udq') then
         hopilab=28
      else if (hoplab .eq. 'qdq') then
         hopilab=29
      else if (hoplab .eq. 'udq2') then
         hopilab=31
      else if (hoplab .eq. 'sdq2') then
         hopilab=32
      else if (hoplab .eq. 'uqdq') then
         hopilab=33
      else if (hoplab .eq. 'csdq') then
         hopilab=34
      else if (hoplab .eq. 'cdq2') then
         hopilab=35

! simple shift
      else if (hoplab(1:6) .eq. 'shift[') then
         ilbl = index(hoplab,']')-1
         read(hoplab(7:ilbl),*) np
         dk=nint(hoppar(1,np))
         hlabipar(2)=dk ! hlabipar(1) might already be used, who knows...
         hopilab=30
      else if (hoplab(1:7) .eq. 'kshift[') then
!        old operator name
         ilbl = index(hoplab,']')-1
         read(hoplab(8:ilbl),*) np
         dk=nint(hoppar(1,np))
         hlabipar(2)=dk
         hopilab=30

! general creation and annihilation operators (second quantisation).
      else if (hoplab .eq. 'crea') then
         hopilab=36
      else if (hoplab .eq. 'anni') then
         hopilab=37

! operators for symmetric double well (trick of U. Manthe)
      else if (hoplab .eq. 'Rf') then
         hopilab=38
      else if (hoplab .eq. 'hKEh') then
         hopilab=39
      else if (hoplab .eq. 'hFRh') then
         hopilab=40
      else if (hoplab .eq. 'hdqh') then
         hopilab=41
      else if (hoplab .eq. 'hdqRh') then
         hopilab=42
      else if (hoplab .eq. 'dqR') then
         hopilab=43
      else if (hoplab .eq. 'dq2R') then
         hopilab=44
      else if (hoplab .eq. 'Rfm') then
         hopilab=45

! continuum energy
      else if (hoplab(1:2) .eq. 'CE') then
         hopilab=46

! continuum-discrete state coupling element
! flag continuum state as negative
! if last character is "s", this is a single-set operator and the 
! bound state must be 1 (actual bound state given in an Ss&s1 operator)
      else if (hoplab(1:2) .eq. 'CS' .and. hoplab(3:3) .ne. '_') then
         ilbl=3
         jlbl=index(hoplab,'&')
         if(jlbl.eq.0) goto 90
         klbl=index(hoplab,' ')-1
         if (hoplab(klbl:klbl) .eq. 's') klbl = klbl-1
         read(hoplab(ilbl:jlbl-1),*) sf
         read(hoplab(jlbl+1:klbl),*) si
         hlabipar(2)=sf
         hlabipar(3)=si
         if (sebcont(sf)) then
            hlabipar(2)=-hlabipar(2)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(3) = 1
         else
            hlabipar(3)=-hlabipar(3)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(2) = 1
         endif
       
         hopilab=47

! continuum-continuum state coupling element
! flag continuum state as negative
! if last character is "s", this is a single-set operator and the 
! bound state must be 1 (actual bound state given in an Ss&s1 operator)
      else if (hoplab(1:2) .eq. 'CZ') then
         ilbl=3
         jlbl=index(hoplab,'&')
         if(jlbl.eq.0) goto 90
         klbl=index(hoplab,' ')-1
         if (hoplab(klbl:klbl) .eq. 's') klbl = klbl-1
         read(hoplab(ilbl:jlbl-1),*) sf
         read(hoplab(jlbl+1:klbl),*) si
         hlabipar(2)=sf
         hlabipar(3)=si
         if (sebcont(sf)) then
            hlabipar(2)=-hlabipar(2)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(3) = 1
         else
            hlabipar(3)=-hlabipar(3)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(2) = 1
         endif

         hopilab=48

! gwp 2nd derivative
      else if (hoplab .eq. 'dqgwp^2') then
         hopilab=49

! gwp kinetic energy
      else if (hoplab .eq. 'KEgwp') then
         hopilab=50

! gwp single derivative 
      else if (hoplab .eq. 'dqgwp^1') then      
         hopilab=51

! Leg 2nd derivative -cos*j^2 - dtheta*sin
      else if (hoplab .eq. 'd2th1') then      
         hopilab=52

! Flux operator for Wsinc_DVR, digonal matrix, JCP 108,5404(1998)
      else if (hoplab(1:7) .eq. 'fluxws[') then
         ilbl = index(hoplab,']')-1
         read(hoplab(8:ilbl),*) np
         hlabrpar(1)=hoppar(1,np) ! x-cut 
         hopilab=53


!Alice- CS_bath coupling function

      else if (hoplab(1:7) .eq. 'CS_bath') then
         ilbl=8
         jlbl=index(hoplab,'&')
         if(jlbl.eq.0) goto 90
         klbl=index(hoplab,' ')-1
         if (hoplab(klbl:klbl) .eq. 's') klbl = klbl-1
         read(hoplab(ilbl:jlbl-1),*) sf
         read(hoplab(jlbl+1:klbl),*) si
         hlabipar(2)=sf
         hlabipar(3)=si
         if (sebcont(sf)) then
            hlabipar(2)=-hlabipar(2)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(3) = 1
         else
            hlabipar(3)=-hlabipar(3)
            if (hoplab(klbl+1:klbl+1) .eq. 's') hlabipar(2) = 1
         endif

         hopilab=54

!-Alice - tight binding 1D model

      else if (hoplab(1:4) .eq. 'tb1d') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 4) then
            if (hoplab(5:5) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(6:ilbl),*) np
               hlabipar(1)=nint(hoppar(1,np))
               hlabrpar(2)=hoppar(2,np)
               hlabrpar(3)=hoppar(3,np)
!               hlabrpar(4)=hoppar(4,np)
            else
               hlabipar(1)=1
               hlabrpar(2)=1.0_dop
               hlabrpar(3)=0.0_dop
!               hlabrpar(4)=1.0_dop
               ilbl=2
            endif
         endif
         hopilab=55

!-Alice - Vibronic on-diagonals for tight binding 1D model

      else if (hoplab(1:6) .eq. 'tbdiag') then
         ilbl=index(hoplab,' ')-1
         if (ilbl .ne. 6) then
            if (hoplab(7:7) .eq. '[') then
               ilbl = index(hoplab,']')-1
               read(hoplab(8:ilbl),*) np
               hlabipar(1)=nint(hoppar(1,np))
            else
               hlabipar(1)=1
               ilbl=2
            endif
         endif
         hopilab=56

! second quantized (SQ) creation and annihilation operators.
      else if (hoplab .eq. 'AA') then
         hopilab=57
      else if (hoplab .eq. 'AD') then
         hopilab=58
      else if (hoplab .eq. 'NN') then
         hopilab=59
      else if (hoplab .eq. 'AP') then
         hopilab=60
      else if (hoplab .eq. 'AM') then
         hopilab=61

! single point of p-grid
      else if (hoplab(1:5) .eq. 'pfft%') then
         ilbl=index(hoplab,' ')-1
         read(hoplab(6:ilbl),*) ipower
         hlabipar(1)=ipower
         hopilab=62

!-----------------------------------------------------------------------
! end of if loop
!-----------------------------------------------------------------------
      endif

!-----------------------------------------------------------------------
! if label is assigned, assign hopfile no.
!-----------------------------------------------------------------------
      if (hopilab .ne. 0) hopfile=3

!-----------------------------------------------------------------------
! check if there is an unallowed exponent
!-----------------------------------------------------------------------
      if (hopilab .ge. 15 .and. hopilab .lt. 25) then
         ilbl=index(hoplab,'^')-1
         if(ilbl .gt. 1 ) then
            write(6,'(/a)') &
            'Powers are allowed only for potential like operators'
            hopilab=0
            hopfile=0
         endif
      endif

 90   return
      end subroutine fdefgrd

!#######################################################################

      subroutine funcgrd(hmat,gdim,ifunc,ipar,rpar,mass,dif1mat,dif2mat, &
                 kinsph,fftp,ort,sphdim,basis,workc,jtot,trafo, &
                 rpbaspar,ipbaspar)

      implicit none

      integer(long)                                   :: ipower,sf,si,g,nflux
      integer(long), intent(in)                       :: gdim,ifunc,sphdim,basis
      integer(long), dimension(*), intent(in)         :: ipar,ipbaspar

      real(dop)                                       :: factor,xc,x0,xl,dx
      real(dop), intent(in)                           :: mass,jtot
      real(dop), dimension(*), intent(in)             :: rpar,rpbaspar
      real(dop), dimension(gdim), intent(in)          :: fftp,kinsph, ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif2mat,dif1mat,trafo

      complex(dop)                                    :: nimag
      complex(dop), dimension(2*gdim), intent(out)    :: workc
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

     select case (ifunc)

     case default
      write(6,'(/a,i4)') 'funcgrd: wrong ifunc =',ifunc
      call stopnow

     case (1) ! KEfft
      call kefftterm(fftp,hmat,mass,gdim)
      return

     case (2) ! dqfft^ipower
      ipower=ipar(1)
      call dqfft(fftp,hmat,ipower,gdim)
      return

     case (3) ! Pfft^ipower
      ipower=ipar(1)
      call pfft(fftp,hmat,ipower,gdim)
      return

     case (5) ! KEdvr
      call kedvrterm(dif2mat,hmat,mass,gdim)
      return

     case (6) ! dqdvr^1
      call cpqxdz(dif1mat,hmat,gdim)
      return

     case (7) ! dqdvr^2
      call cpqxdz(dif2mat,hmat,gdim)
      return

     case (8) ! j^2
      nimag=(-1.0_dop,0.0_dop)
      call xqxxzd(nimag,dif2mat,hmat,gdim)
      return

     case (9) ! j^2sphr
      call kefbrterm(kinsph,hmat,gdim)
      return

     case (10) ! State matrix
      sf=ipar(2)
      si=ipar(3)
      call ebas(sf,si,hmat,gdim)
      return

     case (11) ! Pdvr
      nimag=(0.0_dop,-1.0_dop)
      call xqxxzd(nimag,dif1mat,hmat,gdim)
      return

     case (12) ! non-symmetric state matrix
      sf=ipar(2)
      si=ipar(3)
      call ebas1(sf,si,hmat,gdim)
      return

     case (13) ! jzsphr
      call kefbrterm(kinsph(sphdim+1),hmat,gdim)
      return
      case (14) ! jz^2sphr
      call kefbrterm(kinsph(2*sphdim+1),hmat,gdim)
      return

     case (15) ! lowering operator
      factor = 1.0_dop / sqrt( 2.0_dop*rpar(1)*rpar(2) )
      call cpqxdz(dif1mat,hmat,gdim)
      call xqxxdzo(factor,hmat,gdim)
      factor = sqrt( rpar(1)*rpar(2) / 2.0_dop )
      call xdxxdda(factor,ort,hmat,gdim)
      call xuxxdda(rpar(3),hmat,gdim)
      return

     case (16) ! raising operator
      factor = - 1.0_dop / sqrt( 2.0_dop*rpar(1)*rpar(2) )
      call cpqxdz(dif1mat,hmat,gdim)
      call xqxxdzo(factor,hmat,gdim)
      factor = sqrt( rpar(1)*rpar(2) / 2.0_dop )
      call xdxxdda(factor,ort,hmat,gdim)
      call xuxxdda(rpar(3),hmat,gdim)
      return

     case (17) ! number operator
      factor = - 1.0_dop / (2.0_dop*rpar(1)*rpar(2))
      call cpqxdz(dif2mat,hmat,gdim)
      call xqxxdzo(factor,hmat,gdim)
      factor = rpar(1)*rpar(2) / 2.0_dop
      call xdxsdda(factor,ort,hmat,gdim)
      factor = sqrt( 2.0_dop*rpar(1)*rpar(2) ) * rpar(3)
      call xdxxdda(factor,ort,hmat,gdim)
      factor = rpar(3)**2 - 0.5_dop
      call xuxxdda(factor,hmat,gdim)
      return
      
     case (18) ! lowering operator for morse potential
      continue
! ---  momentum operator
      factor = 1.0_dop / sqrt(2.0_dop*rpar(1)*rpar(2)) 
      call cpqxdz(dif1mat,hmat,gdim)
      call xqxxdzo(factor,hmat,gdim)
! ---  constant part  
      factor = (rpar(3) - 0.5_dop) * rpar(4) &
             / sqrt(2.0_dop*rpar(1)*rpar(2))
      call xuxxdda(factor,hmat,gdim)    
! ---  position part      
      do g=1,gdim
          factor = -rpar(3)*rpar(4) &
                 / sqrt(2.0_dop*rpar(1)*rpar(2))
          factor = factor*exp(-rpar(4)*(ort(g)-rpar(5)))
          hmat(g,g) = hmat(g,g) + factor
      enddo 
      return
      
     case (19) ! raising operator for Morse potential
      continue
! ---  momentum operator      
      factor = - 1.0_dop / sqrt( 2.0_dop*rpar(1)*rpar(2) )
      call cpqxdz(dif1mat,hmat,gdim)
      call xqxxdzo(factor,hmat,gdim)
! ---  constant part
      factor = (rpar(3) - 0.5_dop) * rpar(4) &
             / sqrt(2.0_dop*rpar(1)*rpar(2))
      call xuxxdda(factor,hmat,gdim)    
! ---  position part      
      do g=1,gdim
          factor = -rpar(3)*rpar(4) &
                 / sqrt(2.0_dop*rpar(1)*rpar(2))
          factor = factor*exp(-rpar(4)*(ort(g)-rpar(5)))
          hmat(g,g) = hmat(g,g) + factor         
      enddo 
      return     
      
     case (20) ! Flux operator for sine/SInc/Wsinc/exp/FFT DVR 
               ! (exact matrix elements)
               ! For GWP basis matrix elements evaluated in gh_elements
      continue
      xc=rpar(1)
      x0=2.0_dop*ort(1)-ort(2)
      if(basis.eq.3 .or. basis==31 .or. basis==32) then
         xl=2.0_dop*ort(gdim)-ort(gdim-1)-x0
         xc=(xc-x0)/xl
         call fluxsmat(hmat,xc,xl,gdim,mass,rpar(2)) 
      elseif(basis.eq.4 .or. basis.eq.5) then
         xl=ort(gdim)-x0
         xc=(xc-x0)/xl
         call fluxemat(hmat,xc,xl,gdim,mass,rpar(2), &
                       workc,workc(gdim+1)) 
      elseif(basis.eq.25) then
         call initmxz(hmat,gdim,gdim)
      else
         call zeromxz(hmat,gdim,gdim)
         write(6,'(/a/)')'flux[] operator requires sin/SInc/Wsinc/exp/FFT-basis'
         write(2,'(/a/)')'ERROR: flux[] operator requires sin-basis'
         call stopnow
      endif
      return  

     case (21) !  Jp
      call jtotp(hmat,ort,gdim,jtot)
      return

     case (22) !  Jm
      call jtotm(hmat,ort,gdim,jtot)
      return

     case (23) !  Jx
      call jtotx(hmat,ort,gdim,jtot)
      return

     case (24) !  Jy
      call jtoty(hmat,ort,gdim,jtot)
      return

     case (25) ! pgauss
      call pgauss(hmat,ort,gdim,rpar(2),rpar(3),trafo,basis,rpbaspar, &
           ipbaspar)
      return

     case (26) ! cdq; (dq cos(q) + cos(q) dq)/2
      call cdq(hmat,ort,dif1mat,gdim)
      return
      
     case (27) ! sdq; (dq sin(q) + sin(q) dq)/2
      call sdq(hmat,ort,dif1mat,gdim)
      return

     case (28) ! udq; (dq sqrt(1-q^2) + sqrt(1-q^2) dq)/2
      call udq(hmat,ort,dif1mat,gdim)
      return
 
     case (29) ! qdq; (dq*q + q*dq)/2
      call qdq(hmat,ort,dif1mat,gdim)
      return
 
     case (30) ! shift
      call kshift(hmat,gdim,ipar(2))
      return

     case (31) ! udq2; ((1-q^2)dq + dq(1-q^2))/2
      call udq2(hmat,ort,dif1mat,gdim)
      return

     case (32) ! sdq2; (sin^2(q)dq + dq(sin^2(q))/2
      call sdq2(hmat,ort,dif1mat,gdim)
      return

     case (33) ! uqdq; (sqrt(1-q^2) q dq + dq q (sqrt(1-q^2))/2
      call uqdq(hmat,ort,dif1mat,gdim)
      return

     case (34) ! csdq; (cos(q)sin(q)dq + dq cos(q)sin(q))/2
      call csdq(hmat,ort,dif1mat,gdim)
      return

     case (35) ! csdq; (cos^2(q)dq + dq cos^2(q))/2
      call cdq2(hmat,ort,dif1mat,gdim)
      return

     case(36) ! crea; c^dagger, second quantisation creation operator  
      call crea(hmat,gdim)
      return

     case(37) ! anni; c, second quantisation annihilation operator  
      call anni(hmat,gdim)
      return

     case(38) ! Rf; reflection operator. Do nothing. (Operation done in hop @hphi.F)
      return              !            (See subroutine rflx on hphi.F)

     case(39) ! hKEh; projected KE (from doubled grid). Must be sin-DVR.  
      call hkeh(hmat,gdim,ort,mass)
      return

     case(40) ! hFRh; projected Flux*Reflection (from doubled grid). 
              ! Must be sin-DVR.  
      call hfrh(hmat,gdim,ort,mass)
      return

     case(41) ! hdqh; projected KE (from doubled grid). Must be sin-DVR.  
      call hdqh(hmat,gdim,ort)
      return

     case(42) ! hdqRh; projected dq*Reflection (from doubled grid). 
              ! Must be sin-DVR.  
      call hdqrh(hmat,gdim,ort)
      return

     case(43) ! dqR; dq*Reflection  
      call dqr(hmat,dif1mat,gdim)
      return

     case(44) ! dq2R; dq^2*Reflection  
      call dqr(hmat,dif2mat,gdim)
      return

     case(45) ! Rfm; reflection operator. Do nothing. 
              ! (Operation done in hop @hphi.F)
      return              !             (See subroutine rflxm on hphi.F)

     case (46) ! Econtinuum 
     call econt(hmat,ort,gdim)
     return

     case (47) ! bound-continuum coupling
      sf=ipar(2)
      si=ipar(3)
      call ebas1(sf,si,hmat,gdim)
      return

     case (48) ! bound-continuum coupling
      sf=ipar(2)
      si=ipar(3)
      call ebas1(sf,si,hmat,gdim)
      return

     case (4,49:51) ! 49 gwp 2nd derivative not used here
! 50 gwp kinetic energy not used here
! 51 gwp kinetic energy not used here
      return

     case (52) ! Leg 2nd derivative -cos*j^2 - dtheta*sin
      call d2th1(hmat,gdim,trafo)
      return

     case (53) ! Flux operator for Wsinc DVR only!
      xc=rpar(1)
      nflux=gdim-nint((ort(gdim)-xc)*(gdim-1)/(ort(gdim)-ort(1)))
      dx=ort(2)-ort(1)
      if(basis==32) then
         call fluxwsmat(hmat,dx,nflux,gdim,mass)
      else
         write(6,'(/a/)')'wsflux[] operator requires Wsinc-basis'
         write(2,'(/a/)')'ERROR: wsflux[] operator requires sin-basis'
         stop
      endif
      return
!_Alice_CS-bath
     case (54)  
      call cs_proj (hmat,ort,gdim,ipar(2),ipar(3))
      return

!-Alice_TB1D
     case (55)
      call tb1d (hmat,gdim,ipar(1),rpar(2),rpar(3))
      return

!-Alice_TBDIAG
     case (56)
      call tbdiag (hmat,gdim,ipar(1))
      return

! AA; bosonic SQ annihilation operator
     case (57)
      call zeromxz(hmat,gdim,gdim)
      do g=1,gdim-1
         hmat(g,g+1)=sqrt(dble(g))
      enddo
      return

! AD; bosonic SQ creation operator (AA-dagger)
     case (58)
      call zeromxz(hmat,gdim,gdim)
      do g=1,gdim-1
         hmat(g+1,g)=sqrt(dble(g))
      enddo
      return

! NN; bosonic SQ number operator (AA-dagger*AA)
     case (59)
      call zeromxz(hmat,gdim,gdim)
      do g=1,gdim-1
         hmat(g+1,g+1)=dble(g)
      enddo
      return

! AP; bosonic SQ operator (AA + AA-dagger)
     case (60)
      call zeromxz(hmat,gdim,gdim)
      do g=1,gdim-1
         hmat(g,g+1)=sqrt(dble(g))
         hmat(g+1,g)=sqrt(dble(g))
      enddo
      return

! AM; bosonic SQ operator (AA - AA-dagger)
     case (61)
      call zeromxz(hmat,gdim,gdim)
      do g=1,gdim-1
         hmat(g,g+1)=sqrt(dble(g))
         hmat(g+1,g)=-sqrt(dble(g))
      enddo
      return

! pfft%ipoint
     case (62)
      ipower=ipar(1)
      call pfftpt(fftp,hmat,ipower,gdim)
      return

     end select

      end subroutine funcgrd


!#######################################################################

      subroutine kedvrterm(matrix1,hmat,mass, gdim)

      implicit none

      integer(long)                                   :: g,g1
      integer(long), intent(in)                       :: gdim
      real(dop), intent(in)                           :: mass
      real(dop), dimension(gdim,gdim), intent(in)     :: matrix1
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do g=1,gdim
         do g1=1,gdim
            hmat(g1,g) = -matrix1(g1,g)/(2.0_dop*mass)
         enddo
      enddo

      return
      end subroutine kedvrterm

!#######################################################################
! only for spherical harmonics FBR for the moment

      subroutine kefbrterm(kinsph,hvec,gdim)

      implicit none

      integer(long)                                   :: g
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: kinsph
      complex(dop), dimension(gdim,gdim), intent(out) :: hvec

      do g=1,gdim
         hvec(g,g) = kinsph(g)
      enddo

      return
      end subroutine kefbrterm

!#######################################################################

      subroutine kefftterm(fftp,hvec,mass,gdim)

      implicit none
      integer(long)                                   :: g
      integer(long), intent(in)                       :: gdim
      real(dop), intent(in)                           :: mass
      real(dop), dimension(gdim), intent(in)          :: fftp
      complex(dop), dimension(gdim,gdim), intent(out) :: hvec

      do g=1,gdim
         hvec(g,g)=fftp(g)**2
         hvec(g,g)=hvec(g,g)/(2.0_dop*mass)
         hvec(g,g)=hvec(g,g)/gdim
      enddo

      return
      end subroutine kefftterm

!#######################################################################

      subroutine dqfft(fftp,pot,ipower,gdim)

      implicit none
      integer(long)                                   :: g
      integer(long), intent(in)                       :: gdim,ipower
      real(dop), dimension(gdim), intent(in)          :: fftp
      complex(dop), dimension(gdim,gdim), intent(out) :: pot

      do g=1,gdim
         pot(g,g)=dcmplx(0.0_dop,fftp(g))
! (0,0)**power gives numerical problems
         if (fftp(g) .eq. 0.0) then
            pot(g,g)=(0.0_dop,0.0_dop)
         else
            pot(g,g)=pot(g,g)**ipower
         endif
         pot(g,g)=pot(g,g)/gdim
      enddo

      return
      end subroutine dqfft

!#######################################################################

      subroutine pfft(fftp,pot,ipower,gdim)

      implicit none

      integer(long)                                   :: g
      integer(long), intent(in)                       :: gdim,ipower
      real(dop), dimension(gdim), intent(in)          :: fftp
      complex(dop), dimension(gdim,gdim), intent(out) :: pot

      if(ipower.eq.1) then
         do g=1,gdim
            pot(g,g)=fftp(g)/gdim
         enddo 
      else
         do g=1,gdim
! (0,0)**power gives numerical problems
            if (fftp(g) .eq. 0.0) then
               pot(g,g)=(0.0d0,0.0d0)
            else
               pot(g,g)=(fftp(g)**ipower)/gdim
            endif
         enddo
      endif

      return
      end subroutine pfft

!#######################################################################

      subroutine pfftpt(fftp,pot,ipoint,gdim)

      implicit none

      integer(long)                                   :: g
      integer(long), intent(in)                       :: ipoint,gdim
      real(dop), dimension(gdim), intent(in)          :: fftp
      complex(dop), dimension(gdim,gdim), intent(out) :: pot

      if(ipoint.le.0 .or. ipoint.gt.gdim) then
         write(6,'(/a,i4,a,i4)') ' Symbol p%i, i =',ipoint, &
            ' must be larger 0 and .le. gdim =', gdim
         stop
      endif
      write(29,'(a,i5,a,f12.4)')  & ! write to op.log 
         ' p% : ipoint =',ipoint,' gives p =',fftp(ipoint)

      do g=1,gdim
         pot(g,g)=(0.0d0,0.0d0)
      enddo

      pot(ipoint,ipoint)=1.d0/gdim

      return
      end

!#######################################################################
!
! symmetrical state matrix operators, i.e. Ss1&s2 for single-set
! and coupling bound states in a continuum calculation.
!
!#######################################################################

      subroutine ebas(sf,si,ebasis,gdim)

      implicit none

      integer(long), intent(in)                      :: gdim,si,sf
      complex(dop), dimension(gdim,gdim), intent(out) :: ebasis

      if ((si .gt. gdim) .or. (sf .gt. gdim)) then
         routine = 'Ebas (funcgrd)'
         write(message,'(a,2i5)') &
            'More states in operator than in basis :',max(sf,si),gdim
         call errormsg
      endif

      call zeromxz(ebasis,gdim,gdim)

      if (si.eq.sf) then
         ebasis(si,si)=(1.0_dop,0.0_dop)
      else
         ebasis(sf,si)=(1.0_dop,0.0_dop)
         ebasis(si,sf)=(1.0_dop,0.0_dop)
      endif

      return
      end subroutine ebas

!#######################################################################
!
! unsymmetrical state matrix operators, i.e. Zs1&s2 for single-set
! and coupling continuum states in a continuum calculation.
!
!#######################################################################

      subroutine ebas1(sf,si,ebasis,gdim)

      implicit none

      integer(long), intent(in)                       :: gdim,si,sf
      integer(long)                                   :: i
      complex(dop), dimension(gdim,gdim), intent(out) :: ebasis

      call zeromxz(ebasis,gdim,gdim)

      if (si .lt. 0 .and. sf .lt. 0) then
! contiuum on both sides (unit operator required)
         do i=1,gdim
            ebasis(i,i) = 1.0_dop
         enddo
      else if (sf .lt. 0) then
! continuum on LHS (projects SPFs to state on RHS)
         do i=1,gdim
            ebasis(i,1) = 1.0_dop
         enddo
      else if (si .lt. 0) then
! continuum on RHS (projects SPFs to state on LHS)
         do i=1,gdim
            ebasis(1,i) = 1.0_dop
         enddo
      else
! bound-bound unsymmetrical coupling
         ebasis(sf,si)=(1.0_dop,0.0_dop)
      endif

      return
      end subroutine ebas1

!#######################################################################

      subroutine fluxsmat(hmat,xc,xl,gdim,mass,power)
! --- For sin-DVR. A and B exchanged in the writeup.
      implicit none

      integer(long)                                   :: k, g1, g2, g
      integer(long), intent(in)                       :: gdim
      real(dop)                                       :: c,pi,a1,a2,b1,b2,z
      real(dop), intent(in)                           :: xl,mass,power
      real(dop), intent(inout)                        :: xc
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      pi = 4.0_dop*atan(1.0_dop)
      xc = xc*pi
      z  = pi/dble(gdim+1)
      c  = pi/dble(2*gdim+1)
! --- xl = interval-length = gid-length + 2*delta-x
! --- xc = pi*(x-x0)/xl, reduced step position
! --- The diagonal of hmat is (mis)-used as a scratch array.
      do g = 1, gdim
         hmat(g,g) = (0.0_dop,0.0_dop)
         do k = 1, gdim
             hmat(g,g) = hmat(g,g) + dcmplx(k*cos(k*xc),sin(k*xc))*&
                             sin(g*k*z)*(cosh(k*c)*cos(k*c))**power
         enddo
      enddo

      do g1 = 2, gdim
         a1 = dble (hmat(g1,g1))
         b1 = dimag(hmat(g1,g1)) 
         do g2 = 1, g1-1
            a2 = dble (hmat(g2,g2))
            b2 = dimag(hmat(g2,g2))
            hmat(g1,g2) = dcmplx(0.0_dop,(a1*b2-b1*a2)*2.0_dop*z/(xl*xl*mass))
            hmat(g2,g1) = dconjg(hmat(g1,g2))
         enddo
      enddo

      do g = 1, gdim
         hmat(g,g) = (0.0_dop,0.0_dop)
      enddo

      return
      end subroutine fluxsmat

!#######################################################################

      subroutine fluxemat(hmat,xc,xl,gdim,mass,power,a,b)
! --- For exp-DVR and FFT. NB: A is B^* in the writeup.
      implicit none

      integer(long)                                   :: k, g1, g2, g, n1
      integer(long), intent(in)                       :: gdim
      real(dop)                                       :: c,pi
      real(dop), intent(in)                           :: xl,mass,power
      real(dop), intent(inout)                        :: xc
      complex(dop), dimension(gdim), intent(out)      :: a, b
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      pi = 4.0_dop*atan(1.0_dop)
      n1 = (gdim-1)/2
      xc = xc*pi*2.0_dop
      c  = pi/dble(gdim)
! --- xl = interval-length = gid-length + delta-x
! --- xc = 2*pi*(x-x0)/xl, reduced step position
      do g = 1, gdim
         a(g) = (0.0_dop,0.0_dop)
         b(g) = (0.0_dop,0.0_dop)
         hmat(g,g) = (0.0_dop,0.0_dop)
         do k = -n1, n1
             a(g) = a(g) + k*exp(dcmplx(0.0_dop,-(2.0_dop*c*g-xc)*dble(k)))* &
                                       (cosh(k*c)*cos(k*c))**power
             b(g) = b(g) +   exp(dcmplx(0.0_dop,-(2.0_dop*c*g-xc)*dble(k)))* &
                                       (cosh(k*c)*cos(k*c))**power
         enddo
      enddo

      do g1 = 2, gdim
         do g2 = 1, g1-1
            hmat(g1,g2) = (dconjg(a(g1))*b(g2)+dconjg(b(g1))*a(g2))* &
                                                      c/(xl*xl*mass)
            hmat(g2,g1) = dconjg(hmat(g1,g2))
         enddo
      enddo

      return
      end subroutine fluxemat

!#######################################################################

      subroutine jtotp(hmat,ort,kdim,jtot)

      implicit none

      integer(long)                                   :: k
      integer(long), intent(in)                       :: kdim
      real(dop), intent(in)                           :: jtot
      real(dop)                                       :: ac
      real(dop), dimension(kdim), intent(in)          :: ort
      complex(dop), dimension(kdim,kdim), intent(out) :: hmat

      call zeromxz(hmat,kdim,kdim)
      do k=1,kdim-1
         ac=jtot*(jtot+1.d0)-ort(k)*(ort(k)+1.d0)
         if(abs(ac).le.1.d-8) then
            hmat(k,k+1)=0.d0
         else if(ac.gt.0.d0) then
            hmat(k,k+1)=sqrt(ac)
         else
            write(2,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotp : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            write(6,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotp : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            call stopnow
         endif
      enddo

      return
      end subroutine jtotp

!----------------------------------------------------------------------

      subroutine jtotm(hmat,ort,kdim,jtot)

      implicit none
      integer(long)                                   :: k
      integer(long), intent(in)                       :: kdim
      real(dop), intent(in)                           :: jtot
      real(dop)                                       :: ac
      real(dop), dimension(kdim), intent(in)          :: ort
      complex(dop), dimension(kdim,kdim), intent(out) :: hmat

      call zeromxz(hmat,kdim,kdim)
      do k=1,kdim-1
         ac=jtot*(jtot+1.d0)-ort(k)*(ort(k)+1.d0)
         if(abs(ac).le.1.d-8) then
            hmat(k+1,k)=0.d0
         else if(ac.gt.0.d0) then
            hmat(k+1,k)=sqrt(ac)
         else
            write(2,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotm : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            write(6,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotm : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            call stopnow
         endif

      enddo

      return
      end subroutine jtotm

!----------------------------------------------------------------------

      subroutine jtotx(hmat,ort,kdim,jtot)

      implicit none

      integer(long)                                   :: k
      integer(long), intent(in)                       :: kdim
      real(dop)                                       :: ac
      real(dop), intent(in)                           :: jtot
      real(dop), dimension(kdim), intent(in)          :: ort
      complex(dop), dimension(kdim,kdim), intent(out) :: hmat

      call zeromxz(hmat,kdim,kdim)
      do k=1,kdim-1
         ac=jtot*(jtot+1.d0)-ort(k)*(ort(k)+1.d0)
         if(abs(ac).le.1.d-8) then
            hmat(k,k+1)=0.d0
            hmat(k+1,k)=0.d0
         else if(ac.gt.0.d0) then
            hmat(k+1,k)=0.5d0*sqrt(ac)
            hmat(k,k+1)=0.5d0*sqrt(ac)
         else
            write(2,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotx : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            write(6,'(/a,f5.1,a,f5.1/)') '### ERROR in jtotx : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            call stopnow
         endif
      enddo

      return
      end subroutine jtotx

!----------------------------------------------------------------------

      subroutine jtoty(hmat,ort,kdim,jtot)

      implicit none

      integer(long)                                   :: k
      integer(long), intent(in)                       :: kdim
      real(dop)                                       :: ac
      real(dop), intent(in)                           :: jtot
      real(dop), dimension(kdim), intent(in)          :: ort
      complex(dop), dimension(kdim,kdim), intent(out) :: hmat

      call zeromxz(hmat,kdim,kdim)
      do k=1,kdim-1
         ac=jtot*(jtot+1.d0)-ort(k)*(ort(k)+1.d0)
         if(abs(ac).le.1.d-8) then
            hmat(k+1,k)=0.d0
            hmat(k,k+1)=0.d0
         else if(ac.gt.0.d0) then
            hmat(k+1,k)=-0.5d0*sqrt(ac)
            hmat(k,k+1)= 0.5d0*sqrt(ac)
         else
            write(2,'(/a,f5.1,a,f5.1/)') '### ERROR in jtoty : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            write(6,'(/a,f5.1,a,f5.1/)') '### ERROR in jtoty : jtot =', &
              jtot, ' is absolutely smaller than K =',ort(k)
            call stopnow
         endif
      enddo

      return
      end subroutine jtoty

!----------------------------------------------------------------------

      subroutine kshift(hmat,gdim,dk)

      implicit none

      integer(long)                                   :: k
      integer(long), intent(in)                       :: gdim,dk
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      call zeromxz(hmat,gdim,gdim)
      if (dk.gt.0) then
         do k=1,gdim-dk
            hmat(k+dk,k)=1.0_dop
         enddo
      else
         do k=1,gdim+dk
            hmat(k,k-dk)=1.0_dop
         enddo
      endif

      return
      end subroutine kshift

!#######################################################################

      subroutine pgauss(hmat,ort,gdim,sigma,x0,trafo,basis,rpbaspar, &
                 ipbaspar)

      implicit none

      integer(long)                                   :: g,g1
      integer(long), intent(in)                       :: gdim,basis
      integer(long), dimension(*), intent(in)         :: ipbaspar
      real(dop)                                       :: r,r1,norm,pi,width
      real(dop), intent(in)                           :: x0,sigma
      real(dop), dimension(*), intent(in)             :: rpbaspar
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim)                      :: weight
      real(dop), dimension(gdim,gdim), intent(in)     :: trafo
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

!-----------------------------------------------------------------------
! get DVR weigts
!-----------------------------------------------------------------------
      call dvrweights(trafo,ort,gdim,gdim,weight,basis, &
                      rpbaspar,ipbaspar,ipbaspar,.false.,.false.)

      pi = 4.0_dop*datan(1.0_dop)
      width = 4.0_dop*sigma**2
      width = 1.0_dop/width
      norm = sigma*dsqrt(2.0_dop*pi)
      norm = 1.0_dop/norm
      do g=1,gdim
         r=ort(g)-x0
         hmat(g,g)=norm*dexp(-2.0_dop*width*r*r)
         hmat(g,g)=hmat(g,g)*weight(g)*weight(g)
         do g1=g+1,gdim
            r1=ort(g1)-x0
            hmat(g1,g)=norm*dexp(-width*(r*r + r1*r1))
            hmat(g1,g)=hmat(g1,g)*weight(g1)*weight(g)
            hmat(g,g1)=hmat(g1,g)
         enddo
      enddo

      return
      end subroutine pgauss

!#######################################################################

      subroutine qdq(hmat,ort,dif1mat,gdim)

      implicit none
      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)*(ort(i)+ort(j))
         enddo
      enddo

      return
      end subroutine qdq

!#######################################################################

      subroutine cdq(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)*(cos(ort(i))+cos(ort(j)))
         enddo
      enddo

      return
      end subroutine cdq

!#######################################################################

      subroutine sdq(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)*(sin(ort(i))+sin(ort(j)))
         enddo
      enddo

      return
      end subroutine sdq

!#######################################################################

      subroutine udq(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)* &
                        (sqrt(1.0_dop-ort(i)**2)+sqrt(1.0_dop-ort(j)**2))
         enddo
      enddo

      return
      end subroutine udq

!#######################################################################

      subroutine udq2(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)* &
                        ((1.0_dop-ort(i)**2)+(1.0_dop-ort(j)**2))
         enddo
      enddo

      return
      end subroutine udq2

!#######################################################################

      subroutine sdq2(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)*&
                        ((sin(ort(i)))**2+(sin(ort(j)))**2)
         enddo
      enddo

      return
      end subroutine sdq2

!#######################################################################

      subroutine cdq2(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)*&
                        ((cos(ort(i)))**2+(cos(ort(j)))**2)
         enddo
      enddo

      return
      end subroutine cdq2

!#######################################################################

      subroutine csdq(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)* &
           (cos(ort(i))*sin(ort(i))+cos(ort(j))*sin(ort(j)))
         enddo
      enddo

      return
      end subroutine csdq

!#######################################################################

      subroutine uqdq(hmat,ort,dif1mat,gdim)

      implicit none

      integer(long)                                   :: i,j
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      real(dop), dimension(gdim,gdim), intent(in)     :: dif1mat
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do j=1,gdim
         do i=1,gdim
            hmat(i,j) = 0.5_dop*dif1mat(i,j)* &
           (sqrt(1.0_dop-ort(i)**2)*ort(i)+sqrt(1.0_dop-ort(j)**2)*ort(j))
         enddo
      enddo

      return
      end subroutine uqdq

!----------------------------------------------------------------------

      subroutine crea(hmat,gdim)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             :: k
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

      call zeromxz(hmat,gdim,gdim)

      do k=1,gdim-1
         hmat(k+1,k)=sqrt(dble(k))
      enddo

      return
      end subroutine crea

!----------------------------------------------------------------------

      subroutine anni(hmat,gdim)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             :: k
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

      call zeromxz(hmat,gdim,gdim)

      do k=1,gdim-1
         hmat(k,k+1)=sqrt(dble(k))
      enddo

      return
      end subroutine anni

!----------------------------------------------------------------------

      subroutine hkeh(hmat,gdim,ort,mass)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             ::g1,g2
      real(dop), dimension(gdim), intent(in) :: ort
      real(dop), intent(in)                  :: mass
      real(dop)                              :: Pi,x,deltax,fac1
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

      call zeromxz(hmat,gdim,gdim)

      Pi     = 4.d0*atan(1.d0)
      deltax = (ort(gdim)-ort(1))/dble(gdim-1)
      x      = 2.d0*gdim+1.d0
      fac1   = Pi/x

! --- Check that grid points are correctly positioned
      if( abs(ort(gdim) + 0.5d0*deltax) .gt. 1.d-11*deltax) then 
         write(6,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         write(6,'(a,f10.4)')  ' deltax =',deltax
         write(2,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         call stopnow
      endif 

! --- Second derivative in Sine-DVR basis (given analytically)
! --- Use the upper left corner of the matrix.
      do g1=1,gdim
         do g2=1,g1-1
            hmat(g2,g1)=-(Pi/deltax)**2*2d0*(-1d0)**(g2-g1)/x**2 &
                 *sin(g2*fac1)*sin(g1*fac1)/(cos(g2*fac1)-cos(g1*fac1))**2
            hmat(g2,g1)=-hmat(g2,g1)/(2d0*mass)
            hmat(g1,g2)=hmat(g2,g1)
         enddo
         hmat(g1,g1)=-(Pi/deltax)**2*(1d0/3d0+1d0/(6d0*x**2) &
                      -1d0/(2d0*x**2*sin(g1*fac1)**2))
         hmat(g1,g1)=-hmat(g1,g1)/(2d0*mass)
      enddo

      return
      end subroutine hkeh

!----------------------------------------------------------------------

      subroutine hfrh(hmat,gdim,ort,mass)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             ::g1,g2,g3
      real(dop), dimension(gdim), intent(in) :: ort
      real(dop), intent(in)                  :: mass
      real(dop)                              :: Pi,x,deltax,fac1
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

      call zeromxz(hmat,gdim,gdim)

      Pi     = 4.d0*atan(1.d0)
      deltax = (ort(gdim)-ort(1))/dble(gdim-1)
      x      = 2.d0*gdim+1.d0
      fac1   = Pi/x

! --- Check that grid points are correctly positioned
      if( abs(ort(gdim) + 0.5d0*deltax) .gt. 1.d-11*deltax) then
         write(6,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         write(6,'(a,f10.4)')  ' deltax =',deltax
         write(2,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         call stopnow
      endif

! --- Second derivative in Sine-DVR basis (given analytically)
! --- Use the upper right corner of the matrix and invert the first index.
      do g1=1,gdim
         g3=2*gdim+1-g1
         do g2=1,gdim
            hmat(g2,g1)=-(Pi/deltax)**2*2d0*(-1d0)**(g2-g3)/x**2 &
                 *sin(g2*fac1)*sin(g3*fac1)/(cos(g2*fac1)-cos(g3*fac1))**2
            hmat(g2,g1)=-hmat(g2,g1)/(2d0*mass)
         enddo
      enddo

      return
      end subroutine hfrh

!----------------------------------------------------------------------

      subroutine hdqh(hmat,gdim,ort)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             ::g1,g2
      real(dop), dimension(gdim), intent(in) :: ort
      real(dop)                              :: Pi,x,deltax,fac1,fac2
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat
      real(dop), dimension(2*gdim,2*gdim)             :: trafo,dfmat,workr

      call zeromxz(hmat,gdim,gdim)

      Pi     = 4.d0*atan(1.d0)
      deltax = (ort(gdim)-ort(1))/dble(gdim-1)
      x      = 2.d0*gdim+1.d0
      fac1   = Pi/x

! --- Check that grid points are correctly positioned
      if( abs(ort(gdim) + 0.5d0*deltax) .gt. 1.d-11*deltax) then
         write(6,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         write(6,'(a,f10.4)')  ' deltax =',deltax
         write(2,'(a,/a)') 'hKEh; Grid incorrectly positioned! STOP'
         call stopnow
      endif

! --- DVR/FBR transformation matrix is analytically given
      do g1=1,2*gdim
         do g2=1,2*gdim
            trafo(g2,g1)= sqrt(2d0/x)*sin(g2*g1*fac1)
         enddo
      enddo

! --- Derivative in FBR basis is analytically given for SIN-DVR
         fac2 = 4.d0/((2*gdim+1)*deltax)
         do g1=1,2*gdim
            do g2=1,g1-1
               if (mod(g2+g1,2).eq.0) then
                  dfmat(g2,g1) = 0.d0
               else
                  dfmat(g2,g1) = fac2*g2*g1/(g2**2-g1**2)
               endif
               dfmat(g1,g2) = -dfmat(g2,g1)
            enddo
            dfmat(g1,g1) = 0.d0
         enddo

! --- Transform first derivative matrix from FBR to DVR form.
      call qqxxdd(dfmat,trafo,workr,2*gdim)
      call qqtxdd(trafo,workr,dfmat,2*gdim)

! --- Copy the upper left block to hmat
      do g1=1,gdim
         do g2=1,gdim
            hmat(g2,g1)= dfmat(g2,g1)
         enddo
      enddo

      return
      end subroutine hdqh

!----------------------------------------------------------------------

      subroutine hdqRh(hmat,gdim,ort)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long)             ::g1,g2
      real(dop), dimension(gdim), intent(in) :: ort
      real(dop)                              :: Pi,x,deltax,fac1,fac2
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat
      real(dop), dimension(2*gdim,2*gdim)             :: trafo,dfmat,workr

      call zeromxz(hmat,gdim,gdim)

      Pi     = 4.d0*atan(1.d0)
      deltax = (ort(gdim)-ort(1))/dble(gdim-1)
      x      = 2.d0*gdim+1.d0
      fac1   = Pi/x

! --- Check that grid points are correctly positioned
      if( abs(ort(gdim) + 0.5d0*deltax) .gt. 1.d-11*deltax) then
         write(6,'(a)') 'hdqh; Grid incorrectly positioned! STOP'
         write(6,'(a,f10.4)')  ' deltax =',deltax
         write(2,'(a)') 'hdqh; Grid incorrectly positioned! STOP'
         call stopnow
      endif

! --- DVR/FBR transformation matrix is analytically given
      do g1=1,2*gdim
         do g2=1,2*gdim
            trafo(g2,g1)= sqrt(2d0/x)*sin(g2*g1*fac1)
         enddo
      enddo

! --- Derivative in FBR basis is analytically given for SIN-DVR
         fac2 = 4.d0/((2*gdim+1)*deltax)
         do g1=1,2*gdim
            do g2=1,g1-1
               if (mod(g2+g1,2).eq.0) then
                  dfmat(g2,g1) = 0.d0
               else
                  dfmat(g2,g1) = fac2*g2*g1/(g2**2-g1**2)
               endif
               dfmat(g1,g2) = -dfmat(g2,g1)
            enddo
            dfmat(g1,g1) = 0.d0
         enddo

! --- Transform first derivative matrix from FBR to DVR form.
      call qqxxdd(dfmat,trafo,workr,2*gdim)
      call qqtxdd(trafo,workr,dfmat,2*gdim)

! --- Copy the upper right block with reflected second index to hmat
      do g1=1,gdim
         do g2=1,gdim
            hmat(g2,g1) = dfmat(g2,2*gdim+1-g1)
         enddo
      enddo

      return
      end subroutine hdqRh

!----------------------------------------------------------------------

      subroutine dqr(hmat,dfmat,gdim)

      implicit none

      integer(long), intent(in) :: gdim
      integer(long) :: g1,g2
      real(dop), dimension(gdim,gdim), intent(in) :: dfmat
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

      do g2=1,gdim
         do g1=1,gdim
            hmat(g1,g2) = dfmat(g1,gdim+1-g2)
         enddo
      enddo

      return
      end subroutine dqr

!----------------------------------------------------------------------
!#######################################################################

      subroutine econt(hmat,ort,gdim)

      implicit none

      integer(long)                                   :: i
      integer(long), intent(in)                       :: gdim
      real(dop), dimension(gdim), intent(in)          :: ort
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      do i=1,gdim
         hmat(i,i) = ort(i)
      enddo

      return
      end subroutine econt

!#######################################################################
!
! cos*j^2 + dtheta*sin  Needed for angular term in binding coordinates
! KE operator
!
!#######################################################################

      subroutine d2th1(hmat,gdim,trafo)

      implicit none

      integer(long)                                   :: g,g1,g2
      integer(long), intent(in)                       :: gdim
      real(dop)                                       :: x
      real(dop), dimension(gdim,gdim), intent(in)     :: trafo
      complex(dop), dimension(gdim,gdim), intent(out) ::  hmat

! --- in Leg FBR 
! < l | cos *j^2 + dtheta*sin | l +1 > = c_{l+1} * (l+1)**2
! < l+1 | cos *j^2 + dtheta*sin | l > = c_{l+1} * (l+1)**2
!
! transform to DVR
      call zeromxz(hmat,gdim,gdim)
! g = l+1
      do g=1,gdim-1
         x=g*g
         x=x*sqrt((g**2)/(4.0_dop*g*g-1.0_dop))
         do g1=1,gdim
            do g2=1,gdim
               hmat(g2,g1)=hmat(g2,g1)+trafo(g+1,g2) &
                    *trafo(g,g1)*x+trafo(g,g2)*trafo(g+1,g1)*x

            enddo
         enddo
      enddo

      return
      end subroutine d2th1

!#######################################################################
! Calculation of the Flux matrix elements in the wrapped sinc-DVR
! JCP 108,5404(1998)
!#######################################################################

      subroutine fluxwsmat(hmat,dx,nflux,gdim,mass)

      implicit none

      integer(long)                                   :: g
      integer(long), intent(in)                       :: gdim,nflux
      real(dop)                                       :: fac1,fac2,invm
      real(dop), intent(in)                           :: mass,dx
      complex(dop), dimension(gdim,gdim), intent(out) :: hmat

      invm=1.0_dop/(mass*dx*dx)

      call zeromxz(hmat,gdim,gdim)

      do g = 1, nflux-1
         fac1=((-1.0d0)**(nflux-g))/float(nflux-g)
         fac2=((-1.0d0)**(nflux+g))/float(nflux+g)
!...
         hmat(g,g)=invm*(fac1-fac2)
      enddo

      do g = nflux+1,gdim
         fac1=((-1.0d0)**(nflux-g))/float(nflux-g)
         fac2=((-1.0d0)**(nflux+g))/float(nflux+g)
!...
         hmat(g,g)=invm*(fac1-fac2)
      enddo

      return
      end subroutine fluxwsmat

!#######################################################################
!Alice--Calculation of coupling matrix elements of  donor and acceptor
! continuum from kon06:1364 paper
!#######################################################################

     subroutine cs_proj(ebasis,ort,gdim,sf,si)
     
     implicit none

     real(dop)                                       :: uev
     integer(long)                                   :: i
     integer(long), intent(in)                       :: gdim,sf,si
     real(dop), dimension(gdim), intent(in)          :: ort
     complex(dop), dimension(gdim,gdim), intent(out) :: ebasis
     real(dop), dimension(:), allocatable            :: Vdk

     parameter (uev=27.21138386d0)
      
      call zeromxz(ebasis,gdim,gdim)
  
      call tbdecay(gdim,Vdk,ort)
      
      if (sf .lt. 0) then
          do i=1,gdim
             ebasis(i,si) = Vdk(i)    
          enddo
       else if (si .lt. 0) then
          do i=1,gdim
             ebasis(sf,i) = Vdk(i)
          enddo
      endif
    
contains

    subroutine tbdecay(Nstates,Vdk,E)
   
    implicit none
   
    real(dop)                                   :: v0,v,E0,epsilon
    integer(long), intent(in)                   ::Nstates
    real(dop), dimension(gdim), intent(in)      :: E   
    integer(long)                               ::i
    real(dop), dimension(:), allocatable        ::decay
    real(dop), dimension(:), allocatable,intent(out) ::Vdk
    real(dop), parameter                        ::pi= 2*asin(1.0)

!---
 ! parameter (v0=0.49594D0  )
   parameter (v0=0.05000D0  )
   parameter (v=2D0         )           
   parameter (E0=-1.6D0     )          
 ! parameter (E0=0.1784D0   )          
   parameter (epsilon=1.6D0 )            


      allocate (decay(Nstates),Vdk(Nstates))
! Need to convert ort (au) <--> E  (eV) - used uev conversion


      do i=1,Nstates
         decay(i)=tbdecay_func(E(i),E0,epsilon,v,v0)
      enddo

      do i=1,Nstates 
         Vdk(i)=(decay(i)/(2*pi))**0.5
         Vdk(i)=Vdk(i)/uev  
      end do
   


 
    end subroutine tbdecay

!---##  Function for decay ###################
    double precision function tbdecay_func(E,E0,epsilon,v,v0)

    implicit none
    real(dop), intent(in) :: E
    real(dop),intent(in)  :: epsilon,v,E0,v0
      if (E.eq.0) then
         tbdecay_func=0
       else 
         tbdecay_func=(((2*v0*v0)*((E*uev)-E0))/(v*v))*((1-((((((E*uev)-E0)*&
                &((E*uev)-E0))-(epsilon*epsilon)-(2*v*v))/(2*v*v))**2))**0.5)
      end if   
    end function tbdecay_func

    end subroutine cs_proj

!---################################################################
!-Alice - Setting up the matrix for a 1D tight binding hamiltonian
!#####################################################################
       subroutine tb1d(mat,nstates,cont,epsilon,beta)

      implicit none

      real(dop)                                             :: uev
      integer(long)                                         :: i, j
      integer(long), intent(in)                             :: nstates,cont
      real(dop),intent(in)                                  :: epsilon, beta!, surface
      complex(dop), dimension(nstates,nstates), intent(out) :: mat
 
     parameter (uev=27.21138386d0)
   call zeromxz(mat,nstates,nstates)

 do i= cont, nstates
    do j=cont, nstates
        mat(i,j) = 0
    end do
 end do
   

 do i=cont,Nstates,2
    mat (i,i) = epsilon
 end do
  do i=cont+1,nstates,2
     mat (i,i) = -epsilon
  end do

 do i = cont, Nstates-1
    mat (i,i+1) = beta
    mat (i+1,i) = beta
 end do

!Alice-test
! print *, "cont", cont,"beta", beta, "epsilon", epsilon, "surface", surface,"nstates", nstates
!do i= 1, nstates 
!   do j = 1, nstates 
!       write(*,*),mat(i,j)
!   end do
!end do


      return
      end subroutine tb1d
!#########################################################################
 subroutine tbdiag(mat,nstates, cont)

      implicit none

      integer(long)                                         :: i
      integer(long), intent(in)                             :: nstates,cont
      complex(dop), dimension(nstates,nstates), intent(out) :: mat
   call zeromxz(mat,nstates,nstates)

   mat = 0 

 do i=cont,Nstates
    mat (i,i) = 1
 end do
   


 end subroutine tbdiag
      end module funcgrdmod

    
