c#######################################################################

      subroutine defnh3_gwr(hopilab,label)

      implicit none

      integer hopilab
      character*(*) label

      if(label.eq.'nh3_gwr_e_s0') then
         hopilab =   1
  
      else if(label.eq.'nh3_gwr_e_s1') then
         hopilab =   2

      else if(label.eq.'nh3_gwr_e_s01') then
         hopilab =   3

!      elseif (label.eq.'nh3_gwr_dx_s0') then
!         hopilab =   4

!      elseif (label.eq.'nh3_gwr_dy_s0') then
!         hopilab =   5

      elseif (label.eq.'nh3_gwr_dz_s0') then
         hopilab =   6

!      elseif (label.eq.'nh3_gwr_pxx_s0') then
!         hopilab =   7

!      elseif (label.eq.'nh3_gwr_pyx_s0') then
!         hopilab =   8

!      elseif (label.eq.'nh3_gwr_pyy_s0') then
!         hopilab =   9

!      elseif (label.eq.'nh3_gwr_pzx_s0') then
!         hopilab =   10

!      elseif (label.eq.'nh3_gwr_pzy_s0') then
!         hopilab =   11

      elseif (label.eq.'nh3_gwr_pzz_s0') then
         hopilab =   12

!      elseif (label.eq.'nh3_gwr_dx_s1') then
!         hopilab =   13

!      elseif (label.eq.'nh3_gwr_dy_s1') then
!         hopilab =   14

      elseif (label.eq.'nh3_gwr_dz_s1') then
         hopilab =   15

!      elseif (label.eq.'nh3_gwr_pxx_s1') then
!         hopilab =   16

!      elseif (label.eq.'nh3_gwr_pyx_s1') then
!         hopilab =   17

!      elseif (label.eq.'nh3_gwr_pyy_s1') then
!         hopilab =   18

!      elseif (label.eq.'nh3_gwr_pzx_s1') then
!         hopilab =   19

!      elseif (label.eq.'nh3_gwr_pzy_s1') then
!         hopilab =   20

      elseif (label.eq.'nh3_gwr_pzz_s1') then
         hopilab =   21

!      elseif (label.eq.'nh3_gwr_dx_s01') then
!         hopilab =   22

!      elseif (label.eq.'nh3_gwr_dy_s01') then
!         hopilab =   23

      elseif (label.eq.'nh3_gwr_dz_s01') then
         hopilab =   24

!      elseif (label.eq.'nh3_gwr_pxx_s01') then
!         hopilab =   25

!      elseif (label.eq.'nh3_gwr_pyx_s01') then
!         hopilab =   26

!      elseif (label.eq.'nh3_gwr_pyy_s01') then
!         hopilab =   27

!      elseif (label.eq.'nh3_gwr_pzx_s01') then
!         hopilab =   28

!      elseif (label.eq.'nh3_gwr_pzy_s01') then
!         hopilab =   29

      elseif (label.eq.'nh3_gwr_pzz_s01') then
         hopilab =   30

      else
         write(*,*) 'Ammonia surface ',label,' not available'
         stop
      endif

      return
      end

C#######################################################################

      subroutine func_nh3_gwr(v,gpoint,ifunc,icoord)

      use paths
      use splinepotmod
      use splinepot2dmod

      implicit none

      integer icoord,ifunc,ilbl
      real*8 gpoint(2),v,r,theta,efield,pi,angfac,b,arg,ang
      real*8 tfac,pesmax,angstroem,debye
      character(len=120) filename

      parameter (tfac=0.533205d0)
      parameter (angstroem=0.52917725d0)
      parameter (debye=0.393430307d0) ! 1Debye = 0.393430307ea_0

      pi = 4.0d0*atan(1.0d0)
      angfac = 180.0d0/pi
      
!     Define point at which we wish the spline to be evaluated. 
      r = gpoint(1)
      ang = gpoint(2)
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,
     &       23,24,25,26,27,28,29,30)ifunc
    
      print*,'ERROR: NOF function not found :',ifunc
      stop

!     Extract values of energy, dipole, polarisability at the coordinates
!     required, r and ang. G03 outputs dipoles in Debye so the values are 
!     converted to atomic units here.

    1 ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_e.dat'
      call splinepot2d_css(r,ang,v,filename)
      return
  
    2 ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_e.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 3    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_e.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 4    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_dx.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 5    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_dy.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 6    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_dz.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 7    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pxx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 8    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pyx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 9    ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pyy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 10   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pzx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 11   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pzy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 12   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s0_pzz.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 13   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_dx.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 14   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_dy.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 15   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_dz.dat'
      call splinepot2d_css(r,ang,v,filename)
      v = v * debye
      return 
  
 16   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pxx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 17   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pyx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 18   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pyy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 19   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pzx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 20   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pzy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 21   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s1_pzz.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 22   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_dx.dat'
      call splinepot2d_css(r,ang,v,filename)
!      v = v * debye
      return 
  
 23   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_dy.dat'
      call splinepot2d_css(r,ang,v,filename)
!      v = v * debye
      return 
  
 24   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_dz.dat'
      call splinepot2d_css(r,ang,v,filename)
!      v = v * debye
      return 
  
 25   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pxx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 26   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pyx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 27   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pyy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 28   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pzx.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 29   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pzy.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
 30   ilbl=index(opdatadef,' ')-1
      filename=opdatadef(1:ilbl)//'/nh3_data/s01_pzz.dat'
      call splinepot2d_css(r,ang,v,filename)
      return 
  
      end

