!***********************************************************************
!
!            POTFIT subroutine PEINOPER
!
!  11/97 AJ
!
!***********************************************************************

      subroutine peinoper 

use decimal, only:long,dop
use global
use pglobal
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use logdat
use op1lib
use keyunitsmod

      implicit none

      integer(long)                :: i,iz0,ic,ierr,ilbl,f,f1,hl,jlbl,m,n,k,np
      integer(long)                :: iz
      real(dop)                    :: rdum
      logical(kind=4)              :: lorder
      logical(kind=4)              :: linperr
      character(len=c2)            :: label,ctmp

!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
      routine = 'read OPERATOR-SECTION (peinoper)'
      iz0  = 0
      hl = 1
      lorder=.false.
      linperr=.false.

      hopdim1 = 0
      lcspot = .false.
      jtot   = -2.0_dop
      jbf    = 0.0_dop
      csmass = 1.0_dop
      ploned  = .false.
      do f=1,maxdim
         onedipot(f)=0
      enddo
      lsubtract = .false.
      subtrpes = '  '
      lensubtr = 0
      npesopt = 0
      do np=1,maxpes
         nopts(np) = 0
         pesopts(np) = ' '
         do n=1,maxhpar
            zpesopts(n,np)=0
         enddo
      enddo

      hopdim=0
      hoplab(:) = ' '
      hopilab(:) = 0
      hopfile(:) = 0
      hoprpar(:,:) = 0.0_dop
      hopipar(:,:) = 0
      hopidef(:) = 0

!-----------------------------------------------------------------------
! needed for cutoff of PES surface
!-----------------------------------------------------------------------
      lsoftcutpes=.false.
      lcutpes=.false.
      pesmin=-1.0e20_dop
      pesmax= 1.0d20

!-----------------------------------------------------------------------
! For include file operdef.inc
!-----------------------------------------------------------------------
      hoplab0=' + '
      nremoved=0
      mulddim=0
      call zerovxi(nmulddof,maxmuld)
      call zerovxi(muldsize,maxmuld)
      call zeromxi(mulddof,maxdim,maxmuld)
      call zeromxi(mulddof2,maxdim,maxmuld)
      call zerovxi(goff,maxdim)

!-----------------------------------------------------------------------
! these need to be set due to grid checking when a pes is subtracted
!-----------------------------------------------------------------------
      gwptype = 3
      gwpphase = 1

! --- Set default for mulddof.
      do f=1,ndof
         mulddof (f,1) = f
         mulddof2(f,1) = f
      enddo
      nmulddof(1)=ndof

!-----------------------------------------------------------------------
! read down to operator-section
!-----------------------------------------------------------------------
      rewind(iin)
      iz=0
      do 
         call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
         if (ierr .eq. 1) then
            routine = 'peingabe (operator-section)'
            message = inptit
            call warnmsg
         endif

         if (keyword(1) .eq. 'operator-section') then
            exit
         else if (keyword(1) .eq. 'end-input') then
            routine = 'peingabe (operator-section)'
            message='No OPERATOR-SECTION in input file'
            call errormsg
         endif
      enddo

!-----------------------------------------------------------------------

 10   continue
      call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      message = inptit
      call cntrl(keyword(1),lc(1),ierr)
      
      i=1

 15   continue
      if (keyword(i) .eq. 'end-operator-section') then
         goto 20
      else if (keyword(i) .eq. 'end-input') then 
         message = &
          'No "end-operator-section" keyword at end of OPERATOR-SECTION'
         call warnmsg
         linperr=lwarn
         lwarn=.false.
         RETURN

      elseif (keyword(i).eq.'pes')  then
         if (keyword(i+1) .ne. '=') then
            message='Missing arguments for keyword :'
            call wrline(i,iz,iz0)
         endif
         i=i+2
         hopdim=1
         hoplab(1)=trim(keyorig(i))

         if (keyword(i) .eq. 'pes-file') then
            lpesfile=.true.
            if (keyword(i+1) .ne. '{') then
               message='No opening { found for pes-file path'
               call errormsg
            end if

            i=i+2
            if (keyword(i) .eq. 'name') then
               operfile = name(1:laenge)//'/pes'
               opflaenge=laenge+4
            else
               operfile = keyword(i)
               opflaenge=index(operfile,' ')-1
               operfile = operfile(1:opflaenge)//'/pes'
               opflaenge=opflaenge +4
            end if

            i=i+1
            if (keyword(i) .ne. '}') then
               message='No closing } found for pes-file path'
               call errormsg
            end if

         else if (keyword(i+1) .eq. '{') then
            i=i+2
            ilbl=1
            npesopt=npesopt+1

   30       continue
            if (i .gt. ic) then
               call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,&
                       ierr,maxkey)
               if (ierr .eq. 1) then
                  message = inptit
                  call warnmsg
               endif
               i=1
            endif

            if (keyword(i) .eq. ',') then
               i=i+1
               go to 30
            endif

            if (keyword(i) .ne. '}') then
               nopts(npesopt)=nopts(npesopt)+1
               jlbl=ilbl+lc(i)
               zpesopts(nopts(npesopt),npesopt)=jlbl
               pesopts(npesopt)(ilbl:jlbl)=keyorig(i)(1:lc(i))//' '
               ilbl=jlbl+1
               i=i+1
               go to 30
            elseif (keyword(i) .eq. 'end-input') then
               message='No closing } in pes options'
               call errormsg
            else
              i=i+1
            endif

!           if (nopts(npesopt) .gt. 2*maxhpar) then
!              print*,'NOPTS',npesopt,nopts(npesopt)
!              write(message,'(a,i5)')&
!                 'Increase maxhpar in operdef.inc. Minimum: ',&
!                 nopts(npesopt)/2+1
!              call errormsg
!           else if (npesopt .gt. maxpes) then
!              write(message,'(a,i5)')&
!                 'Increase maxpes in operdef.inc. Minimum: ',npesopt
!              call errormsg
!           endif

            ilbl=index(hoplab(1),' ')-1
            write(ctmp,'(2a,i5,a)') hoplab(1)(1:ilbl),&
                    '{',npesopt,'}'
            hoplab(1)=ctmp
            call rmblnk(hoplab(1))
            hopidef(1)=0

! add zero to end list of options
            zpesopts(nopts(npesopt)+1,npesopt)=0
         endif

      elseif (keyword(i)(1:4).eq.'oned') then
         ploned=.true.
         ilbl=index(keyorig(i),' ')-1
         label=keyorig(i)(6:ilbl)
         f=0
         do f1=1,ndof
            if (label .eq. modelabel(f1)) f=f1
         enddo

         if (f .eq. 0) then
            message='Oned: mode missing or unused in calculation'
            call errormsg
         endif

         if (keyword(i+1) .ne. '=') then
            message='No oned curve defined'
            call errormsg
         else
            i=i+2
            hopdim=hopdim+1
            hl=hopdim
            onedipot(f)=hl
            hoplab(hl)=trim(keyorig(i))
         endif
!
! if no directory is given, assumed that pes file is in name directory.
! This is steered by lensubtr=0
!
      elseif (keyword(i).eq.'subtract') then
         lsubtract = .true.
         if (keyword(i+1).ne.'=') then
            subtrpes = '  '
            lensubtr = 0
         else
            i=i+2
            subtrpes = keyword(i)
            lensubtr = lc(i)
            call abspath(subtrpes,lensubtr)
         endif

      elseif (keyword(i).eq.'order' ) then
         lorder=.true.
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "order" '
            call wrline(zeroi,iz,iz0)
         else
            i=i+2
            if (keyword(i).eq.'dof') then
! ---          do nothing, default.
               continue
            elseif(keyword(i)(1:4).eq.'mode' .or. &
                   keyword(i)(1:4).eq.'part') then
               k=0
               do m=1,npmode
                  do n=1,npotdof(m)
                     k=k+1
                     f=potdof(n,m)
                     mulddof (k,1) = f
                     mulddof2(k,1) = f
                  enddo
               enddo
               nmulddof(1)=k
            else
               read (keyword(i),*,iostat=ierr) f1
               if (ierr.ne.0) then
                  message='Expecting "dof" or "mode" or "particle" or'&
                  //' a permutation of the numers 1...ndof. Not :'
                  call wrline(i,iz,iz0)
               endif
               do f = 1, ndof
                  read (keyword(i),*,iostat=ierr) f1
                  if (ierr.ne.0 .or. f1.le.0 .or. f1.gt.ndof) then
                     write(6,'(a,3i4)') ' f, ndof, f1',f,ndof,f1
                     message=&
                     'Expecting a positive integer .le. ndof. Not :'
                     call wrline(i,iz,iz0)
                  endif
                  do k=1,f-1
                     if(mulddof(k,1) .eq. f1) then
                        write(6,'(a,3i4)') ' k, f, f1',k,f,f1 
                        message='Not a permutation. One number '//&
                        'appeared twice as argument to "order"'
                        call wrline(zeroi,iz,iz0)
                     endif
                  enddo
                  mulddof( f,1) = f1
                  mulddof2(f,1) = f1
                  i=i+1
                  if(keyword(i).eq.',') i=i+1
               enddo
               i=i-1 
            endif
         endif

      elseif (keyword(i).eq.'softvcut' ) then
         lsoftcutpes = .true.
         if(lcutpes) then
            message='ERROR: both vcut and softvcut were requested'
            call warnmsg
         endif
         if (keyword(i+1).eq.'='.or.keyword(i+1).eq.'<') then
            i=i+2
            read(keyword(i),*,iostat=ierr) pesmax
            if (ierr.ne.0) then
               message = 'A real number must be argument of "softvcut". Not :'
               call wrline(i,iz,iz0)
            endif
            if (keyword(i+1).eq.',' ) then
               i=i+2
               call keyeunits(pesmax,keyword(i),ierr)
               if (ierr .eq. 1) then
                  message = 'no energy unit after comma'
                  call wrline(zeroi,iz,iz0)
               endif
            endif
         else if (keyword(i+1).eq.'>') then
            i=i+2
            read(keyword(i),*,iostat=ierr) pesmin
            if (ierr.ne.0) then
               message = 'A real number must be argument of "softvcut". Not :'
               call wrline(i,iz,iz0)
            endif
            if (keyword(i+1).eq.',' ) then
               i=i+2
               call keyeunits(pesmin,keyword(i),ierr)
               if (ierr .eq. 1) then
                  message = 'no energy unit after comma'
                  call wrline(zeroi,iz,iz0)
               endif
            endif
         else
            message='No argument after softvcut keyword'
            call warnmsg
         endif

      elseif (keyword(i).eq.'vcut' .or. keyword(i).eq.'v' ) then   
         lcutpes = .true.
         if(lsoftcutpes) then
            message='ERROR: both vcut and softvcut were requested'
            call warnmsg
         endif
         if (keyword(i+1).eq.'='.or.keyword(i+1).eq.'<') then
            i=i+2
            read(keyword(i),*,iostat=ierr) pesmax
            if (ierr.ne.0) then
               message&
               = 'A real number must be argument of "vcut". Not :'
               call wrline(i,iz,iz0) 
            endif
            if (keyword(i+1).eq.',' ) then
               i=i+2
               call keyeunits(pesmax,keyword(i),ierr)
               if (ierr .eq. 1) then
                  message = 'no energy unit after comma'
                  call wrline(zeroi,iz,iz0)
               endif
            endif
         else if (keyword(i+1).eq.'>') then
            i=i+2
            read(keyword(i),*,iostat=ierr) pesmin
            if (ierr.ne.0) then
               message&
               = 'A real number must be argument of "vcut". Not :'
               call wrline(i,iz,iz0)
            endif
            if (keyword(i+1).eq.',' ) then
               i=i+2
               call keyeunits(pesmin,keyword(i),ierr)
               if (ierr .eq. 1) then
                  message = 'no energy unit after comma'
                  call wrline(zeroi,iz,iz0)
               endif
            endif
         else
            message='No argument after vcut keyword'
            call warnmsg
         endif

      elseif (keyword(i).eq.'cspot') then
         lcspot = .true.
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "cspot" '
            call wrline(zeroi,iz,iz0)
         else
            read(keyword(i+2),*,iostat=ierr) rdum
            if (ierr.ne.0) then
               message&
             = 'A real number must be first argument of "cspot". Not :'
               call wrline(i+2,iz,iz0) 
            endif
!-----------------------------------------------------------------------
! If 'jtot' was defined as command line argument of 'potfit' then take
! this value and ignore the ~.inp file value.
!-----------------------------------------------------------------------
            if (jtot.lt.-1.0_dop) jtot=rdum
            read(keyword(i+3),*,iostat=ierr) jbf
            if (ierr.ne.0) then
               message&
            = 'A real number must be second argument of "cspot". Not :'
               call wrline(i+2,iz,iz0) 
            endif
            read(keyword(i+4),*,iostat=ierr) csmass
            if (ierr.ne.0) then
               message&
              = 'A real number must be third argument of "cspot". Not :'
               call wrline(i+2,iz,iz0) 
            endif
            i=i+5
            if (keyword(i).eq.',' ) then
               i=i+1
               call keymunits(csmass,keyword(i),ierr)
               if (ierr .eq. 1) then
                  message = 'no mass unit after comma'
                  call wrline(zeroi,iz,iz0)
               endif
            endif
         endif

      elseif (keyword(i) .eq. 'ft') then
         message='FT potfits no longer allowed. Use projection instead.'
         call wrline(zeroi,iz,iz0)

      else
         message = ' unknown keyword : '
         call wrline(i,iz,iz0)
      endif
      
!-----------------------------------------------------------------------
! check if more keywords are to be read, else read new line
!-----------------------------------------------------------------------
      if (i.lt.ic) then
         i=i+1
         go to 15
      else
         go to 10
      endif

!-----------------------------------------------------------------------
! some more checks
!-----------------------------------------------------------------------
 20   continue
      if (.not.lcspot .and. jtot.gt.-1.0_dop) then
         message = 'Option ''cspot'' must be defined in ~.inp file '//&
              'if ''jtot'' is command line argument'
         call warnmsg
      endif
      if( hoplab(1)(1:7).eq.'readsrf' .and. lorder ) then
         message = 'Sorry, one cannot use "order" when '//&
              'the PES is "readsrf".'
         call warnmsg
      endif

!-----------------------------------------------------------------------
! After any call of 'warnmsg' (which is also called by 'wrline') the
! logical 'lwarn' is set to true.
!-----------------------------------------------------------------------
      if (.not.linperr) linperr=lwarn
      lwarn=.false.

      return
      end subroutine peinoper

!#######################################################################
!
! Read operator-section of input file and get dimensions needed
! to set up operator
!
!#######################################################################

      subroutine pmemdimoper 

use decimal, only:long,dop
use global
use pglobal
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use logdat
use op1lib

      implicit none

      integer(long)                :: i,iz0,ic,ierr
      integer(long)                :: iz,nopt

!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
      routine = 'read OPERATOR-SECTION (pmemdimoper)'
      maxhop = 0
      maxpes = 0
      maxhpar = 0

!-----------------------------------------------------------------------
! read down to operator-section
!-----------------------------------------------------------------------
      rewind(iin)
      iz=0
      do 
         call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
         if (ierr .eq. 1) then
            routine = 'peingabe (operator-section)'
            message = inptit
            call warnmsg
         endif

         if (keyword(1) .eq. 'operator-section') then
            exit
         else if (keyword(1) .eq. 'end-input') then
            routine = 'peingabe (operator-section)'
            message='No OPERATOR-SECTION in input file'
            call errormsg
         endif
      enddo

!-----------------------------------------------------------------------

      do 

         call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
         message = inptit
         call cntrl(keyword(1),lc(1),ierr)
      
         i=0
         do
            i=i+1
            if (i .gt. ic) exit

            if (keyword(i) .eq. 'end-operator-section') then
               go to 100
            else if (keyword(i) .eq. 'end-input') then 
               routine = 'peingabe (operator-section)'
               message = &
                'No "end-operator-section" keyword at end of OPERATOR-SECTION'
               call errormsg

            elseif (keyword(i).eq.'pes')  then
               if (keyword(i+1) .ne. '=') then
                  message='Missing arguments for keyword :'
                  call wrline(i,iz,iz0)
               endif
               maxhop=maxhop+1
               i=i+2

               nopt=0
               if (keyword(i+1) .eq. '{') then
                  maxpes=maxpes+1

                  nopt=1
                  i=i+2
                  do
                     if (keyword(i) .eq. ',') then
                        i=i+1
                     else if (keyword(i) .eq. '}') then
                        exit
                     elseif (keyword(i) .eq. 'end-input') then
                        message='No closing } in pes options'
                        call errormsg
                     else
                        i=i+1
                        nopt=nopt+1
                     endif
                  enddo
               endif

               maxhpar = max(maxhpar, nopt/2+1)

            elseif (keyword(i)(1:4).eq.'oned') then
               if (keyword(i+1) .ne. '=') then
                  message='No oned curve defined'
                  call errormsg
               else
                  i=i+2
                  maxhop=maxhop+1
               endif

            endif

         enddo
      enddo

  100 continue

! allow space for separable weight operators (1 / DOF). These are read in
! peinsepwei.
      maxhop = maxhop+maxdim

      return
      end subroutine pmemdimoper 

