!***********************************************************************
!
!            POTFIT subroutine PEINRUN
!
!  11/97 AJ
!
!***********************************************************************

      subroutine peinrun(linperr,iz)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim
use griddatmod
use operdef
use runpfitmod
use channels
use logdat
use op1lib, only:zerovxi
use mpidata
#ifdef MPI
   use mpi
#endif

      implicit none

      integer(long)                 :: i,j,iz0,ic,ierr,ilbl
      integer(long)                 :: nselmode
      integer(long), intent(inout)  :: iz
      logical(kind=4), intent(out)  :: linperr
      logical(kind=4)               :: lrddvr,lcontopt

!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
      routine = 'read RUN-SECTION  (peinrun)'
      iz0     = 0
      lrddvr  = .false.
      lcontopt = lcont ! lcont may already be set by option -c

!-----------------------------------------------------------------------
! READ KEYWORDS: 
!-----------------------------------------------------------------------
   10 continue
      call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      message = inptit
      call cntrl(keyword(1),lc(1),ierr)

      i=1
   15 continue
      if (keyword(i).eq.'end-run-section') then
         goto 20
      elseif (keyword(1).eq.'end-input') then 
         linperr = .true.
         message = &
            'No end-run-section keyword at end of RUN-SECTION'
         call warnmsg
         linperr=lwarn
         lwarn=.false.
         RETURN

      else if( keyword(i) .eq. 'title' .or. &
               keyword(i) .eq. 'titel' )  then
         if (keyword(i+1) .ne. '=' ) then
            read(iin,'(a)') runtitle
            iz = iz + 1
         else
            i = i + 2
            ilbl=index(inptit,'title')
            if(ilbl.eq.0) ilbl=index(inptit,'titel')
            runtitle = inptit(ilbl+5:80)
            ilbl=index(runtitle,'=')
            runtitle = runtitle(ilbl+1:80)
            goto 10
         end if

      elseif (keyword(i)(1:5).eq.'niter') then
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "niteration" '
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) niters
            if (niters.lt.0) litia = .true.
            if (ierr.ne.0) then
               message=&
               'An integer number must be argument of "niter". Not :'
               call wrline(i+2,iz,iz0) 
            endif
         endif
         if (niters.ne.0) lit = .true.
         i=i+2
         if (keyword(i+1) .eq. ',') then
            read (keyword(i+2),*,iostat=ierr) njump
            if (ierr.ne.0) then
               message='An integer number must be '//&
               'second argument of "niter". Not :'
               call wrline(i+1,iz,iz0)
            endif
            i=i+2
         endif

      elseif (keyword(i).eq.'iteration-factor') then
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "iteration-factor" '
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) facit
            if (ierr.ne.0) then
               message='An real number must be argument '//&
                       'of "iteration-factor". Not :'
               call wrline(i+2,iz,iz0)
            endif
            i=i+2
         endif

      elseif (keyword(i).eq.'buffer') then
         if (keyword(i+1).ne.'=') then
            message = 'No argument specified with buffer keyword'
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) bufferlength
            if (bufferlength.le.0 .or. ierr.ne.0) then
               message=&
               'A positive integer must be argument of "buffer". Not :'
               call wrline(i+2,iz,iz0)
            endif
            i=i+2
         endif

      else if (keyword(i) .eq. 'readdvr') then
         lrddvr=.true.
         if (keyword(i+1) .eq. '=') then
            i=i+2
            dname=keyorig(i)
            dlaenge = lc(i)
         endif
      else if( keyword(i) .eq. 'ctensor' )  then
         lctensor=.true.
         lwrallevec=.true.
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "ctensor" '
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) mctens
            if (ierr.ne.0) then
               message= 'The argument of "ctensor" must be an integer. Not :'
               call wrline(i+2,iz,iz0)
            endif
            i=i+2
         endif
      else if( keyword(i) .eq. 'wrallevec' )  then
         lwrallevec=.true.
      else if( keyword(i) .eq. 'gendvr' )  then 
         irundvr=1
      else if (keyword(i).eq.'nofiterr') then
         lfiterr=.false.
      else if (keyword(i).eq.'printrho') then
         lprintrho = .true.
      else if (keyword(i).eq.'fullcoarse') then
         lmgpf       = .true.
         lfullcoarse = .true.
         lonlydcoeff = .false.
         ldcoeff     = .false.
      else if (keyword(i).eq.'onlydcoeff') then
         lmgpf       = .true.
         lonlydcoeff = .true.
         ldcoeff     = .true.
      else if (keyword(i)(1:8).eq.'finemode') then
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "finemode" '
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) ifinemode
            if (ierr.ne.0.or.ifinemode.le.0) then
               message= &
               'A positive integer number must be argument of "finemode". Not :'
               call wrline(i+2,iz,iz0)
            endif
            i=i+2
         endif
         lmgpf       = .true.
         lfinemode   = .true.
         lonlydcoeff = .false.
         ldcoeff     = .false.
      else if (keyword(i).eq.'ext-natpot') then
         lmgpf       = .true.
         lextpot     = .true.
         lonlydcoeff = .false.
         ldcoeff     = .true.
         lfinemode   = .false.
      elseif (keyword(i).eq.'no-dcoeff') then
         ldcoeff     = .false.
         lonlydcoeff = .false.
      elseif (keyword(i).eq.'cutnpot') then
         lcutnpot    = .true.
         if (keyword(i+1) .eq. '=') then
            i=i+2
            lnpotpath = .true.
            npotname    = keyorig(i)
            npotlaenge  = lc(i)
            call abspath(npotname, npotlaenge)
         endif
      elseif (keyword(i).eq.'rdnpot') then
         lrdnpot   = .true.
         lreadvpot = .true.
         lrddvr    = .true.
      elseif (keyword(i).eq.'sp-energy') then
         if (keyword(i+1) .eq. '=') then
            lspenergy  = .true.
            i=i+2
            if(ic-2.eq.0)then
              routine = 'peinrun (run-section)'
              message =' no DVR indices for sp-energy found'
              call errormsg
            end if
            call zerovxi(isppoint, maxdim)
            do j=1, ic-2
              read(keyword(i),*,iostat=ierr) isppoint(j)
              if(ierr.ne.0) then
                routine = 'peinrun (run-section)'
                message =' DVR indices in sp-energy must be integers'
                call errormsg
              end if
              i=i+1
            end do
         else
            routine = 'peinrun (run-section)'
            message = ' Missing DVR indices for sp-energy calculation'
            call errormsg
         endif
      elseif (keyword(i).eq.'cutalong') then
         lcutalong  = .true.
         if (keyword(i+1) .eq. '=') then
            i=i+2
            if(ic-2.eq.0)then
              routine = 'peinrun (run-section)'
              message =' no DVR indices for cutalong found'
              call errormsg
            end if
            call zerovxi(isppoint, maxdim)
            do j=1, ic-2
              read(keyword(i),*,iostat=ierr) isppoint(j)
              if(ierr.ne.0) then
                routine = 'peinrun (run-section)'
                message =' DVR indices in cutalong must be integers'
                call errormsg
              end if
              i=i+1
            end do

            selmode  = 0
            nselmode = 0

            do j=1, ic-2
              if(isppoint(j).eq.0) then
                selmode = j
                nselmode = nselmode + 1
              end if
            end do
            if(selmode .le. 0) then
              routine = 'peinrun (run-section)'
              message = ' No mode for cutalong was specified'
              call errormsg
            elseif(nselmode .gt. 1) then
              routine = 'peinrun (run-section)'
              message = 'Only one mode should be specified for cutalong'
              call errormsg
            end if
         else
            routine = 'peinrun (run-section)'
            message = ' Missing DVR indices for cutalong calculation'
            call errormsg
         endif
      else if (keyword(i) .eq. 'deldvr') then
         ldeldvr=.true.
      elseif (keyword(i).eq.'overwrite') then
         lovwr = .true.
      elseif (keyword(i)(1:4).eq.'iter') then
         litf = .true.
      elseif (keyword(i)(1:4).eq.'cont') then
         lcont = .true.
         lrddvr=.true.
         lreadvpot=.true.
         lovwr=.true.
      elseif (keyword(i).eq.'name') then
         if (keyword(i+1).ne.'=') then
            message = 'No argument specified with name keyword'
            call warnmsg
         else
            if (laenge .eq. 0) then
               name = keyorig(i+2)
               laenge = lc(i+2)
               if (laenge.eq.0) then
                  message = ' No path name specified'
                  call wrline(zeroi,iz,iz0)
               endif
               call abspath(name,laenge)
            endif
            i=i+2
         endif
      elseif (keyword(i).eq.'output') then
         loutfil = .true.
         if (keyword(i+1).eq.'=') then
           i=i+2
           if (keyword(i).eq.'long') then
              loutl = .true.
           elseif (keyword(i).eq.'short') then
              loutl = .false.
           else
            message='"long" or "short" must follow "output="'
            call warnmsg
           endif
        endif
      else if(keyword(i) .eq. 'nooutput'  .or.&
              keyword(i) .eq. 'no-output' .or.&
              keyword(i) .eq. 'screen' )  then
         loutfil = .false.
      elseif (keyword(i).eq.'prodwei') then
         lprodw  = .true.
      elseif (keyword(i).eq.'timing') then
         ltime = .true.
      else if( keyword(i) .eq. 'notiming' .or.&
               keyword(i) .eq. 'no-timing' ) then
         ltime = .false.                  
      elseif (keyword(i).eq.'pestiming') then
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "pestiming" '
            call warnmsg
         else
            read (keyword(i+2),*,iostat=ierr) npest
            if (ierr.ne.0) then
               message=&
               'An integer number must be argument ' //&
                    'of "pestiming". Not :'
               call wrline(i+2,iz,iz0) 
            endif
         endif
         i=i+2
      elseif ( keyword(i).eq.'writecw'   .or. &
               keyword(i).eq.'write_cw'  .or. &
               keyword(i).eq.'write-cw' ) then
         lwrcw = .true.
      elseif (keyword(i).eq.'write_every_fit') then
         lwef = .true.
      elseif (keyword(i).eq.'write-only' .or.&
              keyword(i).eq.'write_only' .or.&
              keyword(i).eq. 'wo' ) then
         lwo = .true.
      elseif (keyword(i).eq.'single-precision' .or.&
              keyword(i).eq.'single_precision' .or.&
              keyword(i).eq. 'sp' ) then
         write(6,'(a)') 'Single precision no longer supported.'
         call stopnow
      elseif (keyword(i).eq.'direct') then
         if (keyword(i+1).ne.'=') then
            message =  'missing "=" after "direct" '
            call warnmsg
         else
            if (keyword(i+2).eq.'0') then
               write(6,'(a)') 'direct=0 no longer allowed.'
               write(6,'(a)') 'Do not use the direct keyword.'
               call stopnow
            elseif (keyword(i+2).eq.'1') then
            elseif (keyword(i+2).eq.'1_sp') then
               write(6,'(a)') 'Single precision no longer supported.'
               call stopnow
            elseif (keyword(i+2).eq.'1_wo') then
               lwo=.true.
            elseif (keyword(i+2).eq.'1_sp_wo' .or.&
                 keyword(i+2).eq.'1_wo_sp') then
               write(6,'(a)') 'Single precision no longer supported.'
               call stopnow
            elseif (keyword(i+2).eq.'2') then
               write(6,'(a)') 'direct=2 no longer allowed.'
               write(6,'(a)') 'Do not use the direct keyword.'
               call stopnow
            else
               message=&
               'unknown argument for keyword "direct" :'
               call wrline(i+2,iz,iz0) 
            endif
         endif
         i=i+2
      else if (keyword(i) .eq. 'readvpot') then
         lreadvpot=.true.
         if (keyword(i+1) .eq. '=') then
            i=i+2
            vname=keyorig(i)
            vlength = lc(i)
         endif
      else if (keyword(i) .eq. 'genvpot') then
         lgenvpot=.true.
      else if (keyword(i) .eq. 'delvpot') then
         ldelvpot=.true.
      else if (keyword(i) .eq. 'lowmem') then
         lprojlowmem=.true.
      else if (keyword(i) .eq. 'vpot-format') then
         if (keyword(i+1).ne.'=') then
            message = 'missing "=" after "vpot-format"'
            call warnmsg
         else
            i=i+2
            read(keyword(i),*,iostat=ierr) vpotfmt
            if (ierr.ne.0) then
               message='Argument to "vpot-format" must be integer, not:'
               call wrline(i,iz,iz0)
            endif
         endif
      else if (keyword(i) .eq. 'transfo') then
         ltr=.true.

      else if (keyword(i) .eq. 'usempi') then
#ifdef MPI
         lmpi=.true.
#else
         routine = 'peinrun'
         message = 'not compiled with MPI support - usempi ignored'
         call warnmsg1
         lmpi=.false.
#endif

      else
         message = ' unknown keyword : '//keyword(i)
         call wrline(i,iz,iz0) 
      endif

!-----------------------------------------------------------------------
! check if more keywords are to be read, else read new line
!-----------------------------------------------------------------------
      if (i.lt.ic) then
         i=i+1
         go to 15
      else
         go to 10
      endif

 20   continue

!-----------------------------------------------------------------------
! don't overwrite dvr file pointed to by readdvr keyword
!-----------------------------------------------------------------------
      if (lrddvr) then
         irundvr=2
      else
         irundvr=1
      endif

!-----------------------------------------------------------------------
! check that dname is set.
!-----------------------------------------------------------------------
      if (dlaenge .eq. 0) then
         dname=name
         dlaenge=laenge
      endif

!-----------------------------------------------------------------------
! check that vname is set.
!-----------------------------------------------------------------------
      if (vlength .eq. 0) then
         vname=name(1:laenge)//'/vpot'
         vlength=laenge+5
      endif

!-----------------------------------------------------------------------
! check if the option -c was set is set.
!-----------------------------------------------------------------------
      if(lcontopt) then
         lrdnpot=.false.
         lcutnpot=.false.
         lcutalong=.false.
         lspenergy=.false.
      endif
!---  Consistency checks
      if(lrdnpot) then
         ltime=.false.
         if (lcont.or.lcutnpot) then
            routine = 'peinrun (run-section)'
            message = ' continuation and/or cutnpot tasks'// &
                      ' cannot be set simultaneously with rdnpot'
            call errormsg
         endif
      endif

      if(lcutnpot) then
         ltime=.false.
         if (lcont.or.lrdnpot) then
            routine = 'peinrun (run-section)'
            message = ' continuation and/or rdnpot tasks'// &
                      ' cannot be set simultaneously with cutnpot'
            call errormsg
         endif
      endif

      if (.not.linperr) linperr=lwarn
      lwarn=.false.

      end subroutine peinrun
