!***********************************************************************
!
!            POTFIT subroutine PEINSEPWEI
!
!
!***********************************************************************

      subroutine peinsepwei (linperr,iz)

use decimal, only:long,dop
use global
use pglobal
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use channels

use logdat
use op1lib
use keyunitsmod

      implicit none

      integer(long)                :: i,iz0,jpar,f,f1,ic,ierr,ierr1,uerr,hl
      integer(long), intent(in)    :: iz
      logical(kind=4), intent(out) :: linperr
      real(dop)                    :: wpartmp

!-----------------------------------------------------------------------
! set initial values
!-----------------------------------------------------------------------
      routine = 'read SEPARABLE-WEIGHT-SECTION (peinsepwei)'
      iz0=0

      call zerovxi(iwei,maxdim)
      call zeromxd(wpar,maxwpar,maxdim)

 10   continue
      call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      message = inptit
      call cntrl(keyword(1),lc(1),ierr)
      if (keyword(1).eq.'end-separable-weight-section') then
         goto 20
      else if (keyword(1).eq.'end-input') then 
         message = &
          'No "end-separable-weight-section" keyword at end of ' //&
          'SEPARABLE-WEIGHT-SECTION'
         call warnmsg
         linperr=lwarn
         lwarn=.false.
         return
      end if
      ierr1 = 0
      f=0
      i=1
      jpar=1
      do f1=1,ndof
         if (keyorig(i)(1:12).eq.modelabel(f1)) f=f1
      enddo
      if (f .eq. 0) then
         message = ' unknown keyword : '
         call wrline(1,iz,iz0)
      endif
      i=i+1
      read(keyword(i),*,iostat=ierr) iwei(f)
      if (ierr .ne. 0) then
         message ='iwei must be an integer. Not :'
         call wrline(twoi,iz,iz0)
      endif
      i=i+1
      if (iwei(f) .eq. 2) then
         hopdim=hopdim+1
         hl=hopdim
         hoplab(hl)=trim(keyorig(i))
         wpar(jpar,f)=hl
         i=i+1
         jpar=jpar+1
      endif
 30   if (i.gt.ic) goto 40
      read(keyword(i),*,iostat=ierr) wpartmp
      ierr1 = ierr1 + ierr
      wpar(jpar,f)=wpartmp
      i=i+1
      if(i.gt.ic) goto 40
      if (keyword(i).eq.',') then
         i=i+1
         if(i.gt.ic) then
            message = 'missing unit after comma'
            call wrline(zeroi,iz,iz0)
            goto 40
         endif
         uerr=0
         if(iwei(f).eq.2.and.jpar.eq.2) then
            call keyeunits(wpartmp,keyword(i),uerr)
            if (uerr .eq. 1) then
               message = 'no energy unit after comma'
               call wrline(zeroi,iz,iz0)
            endif
         else
            call keylunits(wpartmp,keyword(i),uerr)
            if (uerr .eq. 1) then
               message = 'no length unit after comma'
               call wrline(zeroi,iz,iz0)
            endif
         endif
         wpar(jpar,f)=wpartmp
         i=i+1
      endif
      jpar=jpar+1
      goto 30
      
 40   wpar(jpar,f)=wpartmp
      if (ierr1 .ne. 0) then
         message ='wpar must be a number.'
         call wrline(zeroi,iz,iz0)
      endif
      goto 10
            
 20   continue
!-----------------------------------------------------------------------
! Set 'linperr=true' if a warnmsg occurred
!-----------------------------------------------------------------------
      if (.not.linperr) linperr=lwarn
      lwarn=.false.     
 
      return
      end subroutine peinsepwei
