module potmod_interface

 interface

!##
subroutine compiweight(gpoint,v,weight)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use combined

      implicit none

      real(dop)                              :: sine,cosine
      real(dop), intent(in)                  :: v
      real(dop), dimension(ndof), intent(in) :: gpoint
      integer(long)                          :: f
      integer(long), intent(out)             :: weight

end subroutine compiweight

!##

subroutine peincorwei (linperr,iz)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use logdat

      implicit none

      integer(long)                :: i,iz0,f,f1,ic,ierr
      integer(long), intent(in)    :: iz
      real(dop)                    :: xx
      logical(kind=4), intent(out) :: linperr

end subroutine peincorwei

!##

subroutine peinoper 

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use logdat

      implicit none

      integer(long)                :: i,iz0,ic,ierr,ilbl,f,f1,hl,jlbl,m,n,k
      integer(long)                :: iz
      real(dop)                    :: rdum
      logical(kind=4)              :: lorder
      logical(kind=4)              :: linperr
      character(len=c2)            :: label,ctmp

end subroutine peinoper

!##

subroutine peinrun(linperr,iz)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use channels

use logdat

      implicit none

      integer(long)                 :: i,iz0,ic,ierr,ilbl
      integer(long), intent(inout)  :: iz
      logical(kind=4), intent(out)  :: linperr

end subroutine peinrun

!##

subroutine peinsepwei (linperr,iz)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use dvrdatmod
use griddatmod
use operdef
use runpfitmod
use channels

use logdat

      implicit none

      integer(long)                :: i,iz0,jpar,f,f1,ic,ierr,ierr1,uerr,hl
      integer(long), intent(in)    :: iz
      logical(kind=4), intent(out) :: linperr
      real(dop)                    :: wpartmp

end subroutine peinsepwei

!##

 end interface

end module potmod_interface

