module potmod_interface2

 interface

!##

subroutine peingabe (linperr)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use peingutil, only:popenin,popenlog,popendat,pausgab
use logdat
use rddvrmod, only:dvrinfo
use einpbasmod, only:einpbas

use potmod_interface

      implicit None

      integer(long)                            :: i,iz,ic,ierr,ilbl,chkdvr,m,n,f
      logical(kind=4), dimension(maxdim)       :: modelist
      logical(kind=4)                          :: lerr,lmnd,lghost
      logical(kind=4), intent(out)             :: linperr
      character(len=c5)                        :: filename

end subroutine peingabe

!##

subroutine projein (linperr)

use decimal, only:long,dop
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use logdat
use rddvrmod, only: dvrinfo
use einpbasmod, only: einpbas
use projutil, only: projstupid
use peinprojmod, only: peinproj

use potmod_interface

      implicit None

      integer(long)                      :: iz,ic,ierr,i,ilbl,chkdvr,m,n,f,p,q
      logical(kind=4), dimension(maxdim) :: modelist
      logical(kind=4)                    :: lerr,lmnd,lghost
      logical(kind=4), intent(out)       :: linperr
      character(len=c5)                  :: filename

end subroutine projein


!##

subroutine runpfit

use decimal, only:long,dop,sip
use global
use pglobal
use maxv, only:maxdim,maxsta,maxkoe
use griddatmod
use operdef
use runpfitmod
use combined
use channels

use compdat, only:getcsys
use direct, only:directfit
use wrpgitter, only: wrgrid,wroned
use rddvrmod, only:rddvr
use rdopermod, only:rdoper
use getpesmod, only:getpes,pescut
use zeigpfitmod, only:zeigpfit,mempfit
use memhopsmod, only:memhops
use directutil, only: index2coord, indexmap
use logdat

use potmod_interface

      implicit none

      real(dop), dimension(:), allocatable       :: mr
      integer(long), dimension(:), allocatable   :: mi
      real(sip), dimension(:), allocatable       :: mf
      real(sip), dimension(:), allocatable       :: fvvec
      real(dop), dimension(:), allocatable       :: vvec
      real(dop), dimension(:), allocatable       :: coeff
      real(dop), dimension(:), allocatable       :: work2

      character(len=10)                       :: cerr
      integer(long)                           :: aerr, ierr
      integer(long)                           :: chkdvr,i,chkgrd,n,cw,ccw,ashift,f
      integer(long)                           :: j,m,offset,woffset
      integer(long), dimension(1)             :: idum
      integer(long), dimension(maxhpar)       :: zpesopts0
      integer(long), dimension(maxdim)        :: igpoint
      real(dop), dimension(maxdim)            :: gpoint
      real(dop)                               :: cpu,totmem
      real(dop)                               :: v
      real(dop), dimension(1)                 :: rdum
      complex(dop), dimension(1)              :: zdum
      real(dop), external                     :: fcputime,fsystime
      character(len=80)                       :: actual
      character(len=c4)                       :: pesopts0
      logical(kind=4)                         :: lpacked

end subroutine runpfit

!##

 end interface

end module potmod_interface2

