!***********************************************************************
      module calcdatrwmod

use decimal, only: long, dop
use logdat
    
      implicit none
      private
      public :: calcdatrw
      contains

!***********************************************************************
      subroutine calcdatrw(psit1,hpsit1,spop,ecorr,etot,euncorr)

use global
use griddatmod
use psidef
use runpropmod
use operdef
use hpsimod

use op1lib, only: sum2vxd

      implicit none

      real(dop), dimension(nstate), intent(out)          :: spop,ecorr,euncorr,etot
      real(dop), dimension(totphidim), intent(in)        :: hpsit1,psit1
      real(dop)                                          :: sum
      real(dop), external                                :: ddot

!-----------------------------------------------------------------------
! get no. of states
!-----------------------------------------------------------------------
      if (nstate > 1) then
         routine = 'Calcdatrw'
         message = 'Real wavepacket calculation set only in sigle surface'
         call errormsg
      endif
 
!-----------------------------------------------------------------------
! calculate state populations
!-----------------------------------------------------------------------
      call sum2vxd(psit1,sum,totphidim)
      spop(1)= sum

!-----------------------------------------------------------------------
! calculate energy expectation value 
! A trajectory calculation is treated as a single-set MCTDH run.
! Therefore nstate = 1 and spop(1) = 1.0 for all runs
!-----------------------------------------------------------------------
      ecorr(1)   = 0.0_dop
      euncorr(1) = 0.0_dop

      etot(1) = ddot(totphidim,psit1,1,hpsit1,1)

      euncorr(1) = 0.0_dop
      ecorr(1)   = etot(1)

      return
      end subroutine calcdatrw

!#######################################################################
 
      end module calcdatrwmod
