!######################################################################
      module psioutrwmod

use decimal, only: long, dop

      implicit none
      private
      public :: psioutrw
      contains

!######################################################################
!
!                      MCTDH module PSIOUT
!
! Controls the input and output of the wavefunction.
!
! subroutines :
!    psiout   : write psi to psi file
!
!  V6.4 GW    
!
!######################################################################

      subroutine psioutrw (psit1)

use griddatmod
use operdef
use psidef
use datenmod
use channels

      implicit none

      integer(long)                                 :: d,m,s
      real(dop), dimension(totphidim), intent(in)   :: psit1
      real(dop), dimension(dgldim)                  :: psi
      logical(kind=4)                               :: lpsisp,lpsicm,&
                                                       lpsinat,lselect
      character(len=c2)                             :: wrtag

!-----------------------------------------------------------------------
! unpack various options
!-----------------------------------------------------------------------
      lpsisp=lpsiopt(1)
      lpsicm=lpsiopt(2)
      lpsinat=lpsiopt(3)
      lselect=lpsiopt(4)

      if (.not. (lpsisp .and. .not. lpsinat)) then
         write(*,*)' Error in psioutrw in writing psi' 
         stop
      endif

      m=1
! The MCTDH expansion coefficients to 1.0
      do s=1,nstate
         psi(zpsi(s)) = 1.0_dop
      enddo
! for psi
      do d=zetf(m,1),dgldim !s=1
         psi(d)=psit1(d-1)
      enddo
!-----------------------------------------------------------------------
! write wavefunction
!-----------------------------------------------------------------------
     countpsi=countpsi+1

      write(wrtag,'(a9,i10,a1)') '<data set',countpsi,'>'
      write(ipsi) wrtag

      wrtag='<psi>'
      write(ipsi) wrtag
      write(ipsi) (real(psi(d)), d = 1,dgldim)

      write(wrtag,'(a13,i10,a1)') '<end data set',countpsi,'>'
      write(ipsi) wrtag
      call myflush(ipsi)

      return
      end subroutine psioutrw


      end module psioutrwmod

