!***********************************************************************
      module memproptrmod

use decimal, only: dop, long
use globmemmod

      implicit none
      private
      public :: memproptr
      contains

!***********************************************************************
!
!          MCTDH   subroutine MEMPROP
!
! called from main and auswert
! calls maxmatwk
!
! calculate pointers and dimensions for standard arrays.
!
!
! 10/96 aJ
!
!***********************************************************************

      subroutine memproptr

use decimal, only: dop, long
use global
use dvrdatmod
use griddatmod
use operdef
use psidef
use datenmod
use runpropmod
use hpsimod
use dirdyn
use crocoflymod

use memhopsmod, only: memhops

      implicit none

!-----------------------------------------------------------------------
! with the parameter "pdum" the pointers to arrays that are not
! used are initialized with the value one in order to avoid an abortion
! of the program when array bounds are checked (compiler option "-c").
!-----------------------------------------------------------------------
      integer(long), parameter :: pdum = 1

!-----------------------------------------------------------------------
! assign standard arrays to memory arrays
! mcdim, mrdim, midim and mldim are final addresses assigned in mc, 
!  mr, mi and ml. 
!-----------------------------------------------------------------------
! set pointers to complex arrays in memory array mc 
!-----------------------------------------------------------------------
      mcdim=1
      mchpsi=mcdim
      mcdim=mchpsi+hpsidim + 1
      mchunpsi=mcdim
      mcdim=mchunpsi+totphidim + 1  
      mcintpsi=mcdim
      mcdim=mcintpsi+intpsidim + 1
!      mchteil=mcdim
!      mcdim=mchteil+pmatdim + 1 
      if (lconstvar .or. lcmfadaa) then
         mcoldpsi=mcdim
         mcdim=mcoldpsi+dgldim + 1
         mcpredpsi=mcdim
         mcdim=mcpredpsi+dgldim + 1
      elseif (lcmfadaphi) then
         mcoldpsi=mcdim
         mcdim=mcoldpsi+dgldim + 1
         mcpredpsi=mcdim
         if (lgwp) then
            mcdim=mcpredpsi+dgldim + 1
         else
            mcdim=mcpredpsi+totphidim + 1
         endif
      else if (lconst) then ! cmf/fix
         mcoldpsi=mcdim
         mcdim=mcoldpsi+totphidim + 1
         mcpredpsi=mcdim
         if (lgwp) then
            mcdim = mcpredpsi + adim + 1
         else
            mcdim = mcpredpsi + 1
         endif
      else ! vmf
         mcoldpsi=mcdim
         mcdim=mcoldpsi + 1
         mcpredpsi=mcdim
         mcdim = mcpredpsi + 1
      endif
      if (lautodoub) then
         mcautopsi=mcdim
         mcdim=mcautopsi+dgldim + 1
         if (lautoord2) then
            mcautodtpsi=mcdim
            mcdim=mcautodtpsi+dgldim + 1
         else
            mcautodtpsi=mcdim
            mcdim = mcautodtpsi + 1
         endif
      else
         mcautopsi=mcdim
         mcdim = mcautopsi + 1
         mcautodtpsi=mcdim
         mcdim = mcautodtpsi + 1
      endif
      mchloch=mcdim
      mcdim=mchloch+hlochdim + 1
!      mcdicht1=mcdim
!      mcdim=mcdicht1+dmatdim + 1
!      mcdicht2=mcdim
!      mcdim=mcdicht2+dmatdim + 1
!      mcdicht4=mcdim
!      mcdim=mcdicht4+dmatdim + 1
      if (lcdvr.or.ltdvr) then
         mccdvr2=mcdim
         mcdim=mccdvr2+dmatdim + 1
         mccdvr4=mcdim
         mcdim=mccdvr4+dmatdim + 1
      else
         mccdvr2=mcdim
         mcdim = mccdvr2 + 1
         mccdvr4=mcdim
         mcdim = mccdvr4 + 1
      endif
      if (lconst .and. nmulpot(1) .gt. 0) then
         if (.not. lcdvr .and. .not. ltdvr) then
            mcphi=mcdim
            mcdim=mcphi+totphidim + 1
         else
            mcphi=mcdim
            mcdim = mcphi + 1
         endif
      else
         mcphi = mcdim
         mcdim = mcphi + 1
      endif
      if (lxloc) then
         mcpcons=mcdim
         mcdim=mcdim+pconsdim + 1
      else
         mcpcons=mcdim
         mcdim=mcpcons + 1
      endif

      if (lcross) then
         mcpsiref=mcdim
         mcdim=mcdim+psirefdim + 1
         mcccdover=mcdim
         if (dentype .ne. 2) then
            mcdim=mcdim+doverdim + 1
         else
            mcdim=mcdim+2*doverdim + 1
         endif
      else
         mcpsiref=mcdim
         mcdim = mcpsiref + 1
         mcccdover=mcdim
         mcdim = mcccdover + 1
      endif

      if(loctpc) then   ! OCT PC
         mcoctpsi=mcdim
         mcdim=mcoctpsi+dgldim + 1
      else
         mcoctpsi=mcdim
         mcdim=mcoctpsi + 1
      endif 

!     variables not used, but also checked in checkmemprop
      mcspf1d = mcdim
      mcdim = mcspf1d + 1

      mcworkc = mcdim
      mcdim = mcworkc+workcdim + 1

!-----------------------------------------------------------------------
! set pointers to real arrays in memory array mr 
!-----------------------------------------------------------------------
      mrdim=1
      mrort=mrdim
      mrdim=mrort+ortdim + 1
      mrtrafo=mrdim
      mrdim=mrtrafo+dvrdim + 1
      mrfftp=mrdim
      mrdim=mrfftp+fftdim + 1
      mrgpop1=mrdim
      mrdim=mrgpop1+ortdim*nstate + 1
      mrgpop2=mrdim
      mrdim=mrgpop2+ortdim*nstate + 1
      if (lcdvr.or.ltdvr) then
         mrcdvr3=mrdim
         mrdim=mrcdvr3+d3matdim + 1
      else 
         mrcdvr3=mrdim
         mrdim = mrcdvr3 + 1
      endif
      if (ltraj .or. lgwp) then
         mrqcent = mrdim
         mrdim   = mrqcent + qcentdim + 1
      else
         mrqcent = mrdim
         mrdim   = mrqcent + 1
      endif
      if (lgwp) then
         mrqcent = mrdim
         mrdim   = mrqcent + qcentdim + 1
      else
         mrqcent = mrdim
         mrdim   = mrqcent + 1
      endif
      if (ltraj) then
         mrpcent = mrdim
         mrdim   = mrpcent + qcentdim + 1
      else
         mrpcent = mrdim
         mrdim   = mrpcent + 1
      endif
      mrintr = mrdim
      mrdim  = mrdim+intrdim + 1 
!     unused variables, but also checked in checkmemprop
      mrdvrmat = mrdim
      mrdim = mrdvrmat + 1
      mrkinsph = mrdim
      mrdim = mrkinsph + 1

      mrworkr = mrdim
      mrdim = mrworkr+workrdim + 1

!-----------------------------------------------------------------------
! set pointers to integer arrays in memory array mi 
!-----------------------------------------------------------------------
      midim=1
      mijsph = midim
      midim  = mijsph+sphdim
      mimsph = midim
      midim  = mimsph+sphdim
      if (citype .gt. 0) then
         mijindx = midim
         jindxdim = adim
         midim = mijindx+jindxdim
      else
         mijindx = pdum
         jindxdim = 1
      endif
      if (lcross) then
         miccjindx = midim
         midim = midim+ccjindxdim
      else
         miccjindx = pdum
      endif
      if (ltraj) then
         mitrajst = midim
         midim   = mitrajst + gwpinfodim + 1
      else
         mitrajst = midim
         midim   = mitrajst + 1
      endif
      migwpdep = midim
      miworki = midim
      midim   = miworki+workidim

!----------------------------------------------------------------------
! set pointers to logical arrays in memory array ml 
!-----------------------------------------------------------------------
! ml(1) is used in ABM to flag whether in predicotor or corrector step
      mldim=2
      mlworkl = mldim
      mldim   = mlworkl+workldim


!-----------------------------------------------------------------------
! now add space for operator data
!-----------------------------------------------------------------------
      call memhops

      return
      end subroutine memproptr                      ! of memprop


      end module memproptrmod

