!***********************************************************************
      module mempropmod

use decimal, only: dop, long
use global
use globmemmod
use dvrdatmod
use griddatmod
use operdef
use psidef
use datenmod
use runpropmod
use hpsimod
use dirdyn
use crocoflymod
use logdat

use memhopsmod, only: memhops

      implicit none
      private
      public :: memprop,checkmemprop,wrmcchckmem,wrmrchckmem
      contains

!***********************************************************************
!
!          MCTDH   subroutine MEMPROP
!
! called from main and auswert
! calls maxmatwk
!
! calculate pointers and dimensions for standard arrays.
!
!
! 10/96 aJ
!
!***********************************************************************

      subroutine memprop

      implicit none

!-----------------------------------------------------------------------
! with the parameter "pdum" the pointers to arrays that are not
! used are initialized with the value one in order to avoid an abortion
! of the program when array bounds are checked (compiler option "-c").
!-----------------------------------------------------------------------
      integer(long), parameter :: pdum = 1

!-----------------------------------------------------------------------
! assign standard arrays to memory arrays
! mcdim, mrdim, midim and mldim are final addresses assigned in mc, 
!  mr, mi and ml. 
!-----------------------------------------------------------------------
! set pointers to complex arrays in memory array mc 
!-----------------------------------------------------------------------
      mcdim=1
      mchpsi=mcdim
      mcdim=mchpsi+hpsidim + 1
      if (lexact) then
         mchunpsi=mcdim
         mcdim=mchunpsi+1  
      else
         mchunpsi=mcdim
         mcdim=mchunpsi+totphidim + 1  
      endif
      mcintpsi=mcdim
      mcdim=mcintpsi+intpsidim + 1
      if (lconst) then
         mcdtgwp = mcdim
         mcdim = mcdtgwp + totphidim + 1
      else
         mcdtgwp = mcdim
         mcdim = mcdtgwp + 1
      endif
      if (lconstvar .or. lcmfadaa) then
         mcoldpsi=mcdim
         mcdim=mcoldpsi+dgldim + 1
         mcpredpsi=mcdim
         mcdim=mcpredpsi+dgldim + 1
      elseif (lcmfadaphi) then
         mcoldpsi=mcdim
         mcdim=mcoldpsi+dgldim + 1
         mcpredpsi=mcdim
         mcdim=mcpredpsi+totphidim + 1
      else if (lconst) then ! cmf/fix
         mcoldpsi=mcdim
         mcdim=mcoldpsi+totphidim + 1
         mcpredpsi=mcdim
         mcdim = mcpredpsi + 1
      else ! vmf
         mcoldpsi=mcdim
         mcdim=mcoldpsi + 1
         mcpredpsi=mcdim
         mcdim = mcpredpsi + 1
      endif
      if (lautodoub) then
         mcautopsi=mcdim
         mcdim=mcautopsi+dgldim + 1
         if (lautoord2) then
            mcautodtpsi=mcdim
            mcdim=mcautodtpsi+dgldim + 1
         else
            mcautodtpsi=mcdim
            mcdim = mcautodtpsi + 1
         endif
      else
         mcautopsi=mcdim
         mcdim = mcautopsi + 1
         mcautodtpsi=mcdim
         mcdim = mcautodtpsi + 1
      endif
      mchloch=mcdim
      mcdim=mchloch+hlochdim + 1
      if (lcdvr.or.ltdvr) then
         mccdvr2=mcdim
         mcdim=mccdvr2+dmatdim + 1
         mccdvr4=mcdim
         mcdim=mccdvr4+dmatdim + 1
      else
         mccdvr2=mcdim
         mcdim = mccdvr2 + 1
         mccdvr4=mcdim
         mcdim = mccdvr4 + 1
      endif
      if (lconst .and. (nmulpot(1) .gt. 0 .or. lklha)) then
         if (.not. lcdvr .and. .not. ltdvr) then
            mcphi=mcdim
            mcdim=mcphi+totphidim + 1
         else
            mcphi=mcdim
            mcdim = mcphi + 1
         endif
      else
         mcphi = mcdim
         mcdim = mcphi + 1
      endif
      if (lxloc) then
         mcpcons=mcdim
         mcdim=mcdim+pconsdim + 1
      else
         mcpcons=mcdim
         mcdim=mcpcons + 1
      endif

! ... arrays related to Gaussian mode: 

      if (lgwp) then
         if (psitype .eq. 0) then
            mcadgwp   = mcdim
            mcdim   = mcadgwp + gsmatdim + 1 
         else
            mcadgwp   = mcdim
            mcdim   = mcadgwp + 1 
         endif
      else
         mcadgwp   = mcdim
         mcdim   = mcadgwp + 1 
      endif

      if (lcross) then
         mcpsiref=mcdim
         mcdim=mcdim+psirefdim + 1
         mcccdover=mcdim
         if (dentype .ne. 2) then
            mcdim=mcdim+doverdim + 1
         else
            mcdim=mcdim+2*doverdim + 1
         endif
      else
         mcpsiref=mcdim
         mcdim = mcpsiref + 1
         mcccdover=mcdim
         mcdim = mcccdover + 1
      endif

      if(loctpc) then   ! OCT PC
         mcoctpsi=mcdim
         mcdim=mcoctpsi+dgldim + 1
      else
         mcoctpsi=mcdim
         mcdim=mcoctpsi + 1
      endif 

!     variables not used, but also checked in checkmemprop
      mcspf1d = mcdim
      mcdim = mcspf1d + 1

      mcworkc = mcdim
      mcdim = mcworkc+workcdim + 1
      if (lBEL) write(1000,*)'huge(1_long)',huge(1_long)
!      if (lBEL) write(1000,*)'huge(1_vlong)',huge(1_vlong)

!-----------------------------------------------------------------------
! set pointers to real arrays in memory array mr 
!-----------------------------------------------------------------------
      mrdim=1
      mrort=mrdim
      mrdim=mrort+ortdim + 1
      mrtrafo=mrdim
      mrdim=mrtrafo+dvrdim + 1
      mrfftp=mrdim
      mrdim=mrfftp+fftdim + 1
      mrgpop1=mrdim
      mrdim=mrgpop1+ortdim*nstate + 1
      mrgpop2=mrdim
      mrdim=mrgpop2+ortdim*nstate + 1
      if (lcdvr.or.ltdvr) then
         mrcdvr3=mrdim
         mrdim=mrcdvr3+c3matdim + 1
      else 
         mrcdvr3=mrdim
         mrdim = mrcdvr3 + 1
      endif
      if (ltraj) then
         mrqcent = mrdim
         mrdim   = mrqcent + qcentdim + 1
         mrpcent = mrdim
         mrdim   = mrpcent + qcentdim + 1
      else
         mrqcent = mrdim
         mrdim   = mrqcent + 1
         mrpcent = mrdim
         mrdim   = mrpcent + 1
      endif
      if (lgwp) then
         mrqcent = mrdim
         mrdim   = mrqcent + qcentdim + 1
         mrgsval = mrdim
         mrdim   = mrgsval + gwpinfodim + 1
      else
         mrqcent = mrdim
         mrdim   = mrqcent + 1
         mrgsval = mrdim
         mrdim   = mrgsval + 1
      endif
      mrintr = mrdim
      mrdim  = mrdim+intrdim + 1 
!     unused variables, but also checked in checkmemprop
      mrdvrmat = mrdim
      mrdim = mrdvrmat + 1
      mrkinsph = mrdim
      mrdim = mrkinsph + 1

      mrworkr = mrdim
      mrdim = mrworkr+workrdim + 1

!-----------------------------------------------------------------------
! set pointers to integer arrays in memory array mi 
!-----------------------------------------------------------------------
      midim=1
      mijsph = midim
      midim  = mijsph+sphdim
      mimsph = midim
      midim  = mimsph+sphdim
      if (citype .gt. 0) then
         mijindx = midim
         jindxdim = adim
         midim = mijindx+jindxdim
      else
         mijindx = pdum
         jindxdim = 1
      endif
      if (lcross) then
         miccjindx = midim
         midim = midim+ccjindxdim
      else
         miccjindx = pdum
      endif
      if (ltraj) then
         mitrajst = midim
         midim   = mitrajst + gwpinfodim + 1
      else
         mitrajst = midim
         midim   = mitrajst + 1
      endif
      if (lgwp) then
         migwpdyn = midim
         midim = migwpdyn + gwpdyndim + 1
         migwpdep = midim
         midim = migwpdep + gwpinfodim + 1
      else
         migwpdyn = midim
         midim = migwpdyn + 1
         migwpdep = midim
         midim = migwpdep + 1
      endif
      miworki = midim
      midim   = miworki+workidim

!----------------------------------------------------------------------
! set pointers to logical arrays in memory array ml 
!-----------------------------------------------------------------------
! ml(1) is used in ABM to flag whether in predicotor or corrector step
      mldim=2
      mlworkl = mldim
      mldim   = mlworkl+workldim

!-----------------------------------------------------------------------
! now add space for operator data
!-----------------------------------------------------------------------
      call memhops

      return
      end subroutine memprop                      ! of memprop


!***********************************************************************
!
!          subroutine checkmemprop
!
! This routine checks the consistency of the mc,mr,mi,ml arrays.
!
! Input:
!   check : true,  check the consistency  
!           false, set the control variables
!   mc    : complex*16 data array
!
!
!
!  03/2002 CC
!
!***********************************************************************

      subroutine checkmemprop(check,indx)

      implicit none

      integer(long), parameter                       :: mccount=21,mrcount=12,&
                                                        micount=7,mlcount=2,&
                                                        mscount=2,mfcount=2
      real(dop), parameter                           :: realcheck = 3.45990253977358381_dop
      complex(dop), parameter                        :: cplxcheck = &
                                      (3.14159265358979312_dop,0.31830988618379069_dop)

      integer(long)                                  :: mcpointer
      integer(long)                                  :: mrpointer
!      integer(long)                                  :: pointer
      integer(long), intent(in)                      :: indx
      logical(kind=4), save                          :: called
      logical(kind=4), intent(in)                    :: check
      integer(long)                                  :: n
      integer(long), dimension(mccount)              :: mccheck
      integer(long), dimension(mrcount)              :: mrcheck

      mccheck(1)=mcdim
      mccheck(2)=mchpsi
      mccheck(3)=mchunpsi
      mccheck(4)=mcintpsi
      mccheck(5)=mchin
      mccheck(6)=mcrueck
      mccheck(7)=mchloch
      mccheck(8)=mccdvr2
      mccheck(9)=mccdvr4
      mccheck(10)=mcoldpsi
      mccheck(11)=mcpredpsi
      mccheck(12)=mcautopsi
      mccheck(13)=mcautodtpsi
      mccheck(14)=mcspf1d
      mccheck(15)=mcphi
      mccheck(16)=mcexphin
      mccheck(17)=mcexprueck
      mccheck(18)=mcpsiref
      mccheck(19)=mcccdover
      mccheck(20)=mcoctpsi
      mccheck(21)=mcworkc

      mrcheck(1)=mrdim
      mrcheck(2)=mrort
      mrcheck(3)=mrdvrmat
      mrcheck(4)=mrtrafo
      mrcheck(5)=mrfftp
      mrcheck(6)=mrgpop1
      mrcheck(7)=mrgpop2
      mrcheck(8)=mrcdvr3
      mrcheck(9)=mrkinsph
      mrcheck(10)=mrhops
      mrcheck(11)=mrintr
      mrcheck(12)=mrworkr

      if (check) then
!    --- check the mc-array        
         if (mc(mccheck(1)).ne.cplxcheck) then
            call wrmcchckmem(mc(mccheck(1)),cplxcheck,mccheck(1), &
                             1,ilog,called)
            call wrmcchckmem(mc(mccheck(1)),cplxcheck,mccheck(1), &
                             1,6,called)
         endif
         do n=3,mccount
            mcpointer = mccheck(n)-1
            if (mc(mcpointer).ne.cplxcheck) then
               call wrmcchckmem(mc(mcpointer),cplxcheck,mcpointer, &
                             n,ilog,called)
               call wrmcchckmem(mc(mcpointer),cplxcheck,mcpointer, &
                             n,6,called)
!            pointer = mccheck(n)-1
!            if (mc(pointer).ne.cplxcheck) then
!               call wrmcchckmem(mc(pointer),cplxcheck,pointer, &
!                             n,ilog,called)
!               call wrmcchckmem(mc(pointer),cplxcheck,pointer, &
!                             n,6,called)
            endif
         enddo
!    --- check the mr-array
         if (mr(mrcheck(1)).ne.realcheck) then
            call wrmrchckmem(mr(mrcheck(1)),realcheck,mrcheck(1), &
                             1,ilog,called)
            call wrmrchckmem(mr(mrcheck(1)),realcheck,mrcheck(1), &
                             1,6,called)
         endif
         do n=3,mrcount
            mrpointer = mrcheck(n)-1
            if (mr(mrpointer).ne.realcheck) then
               call wrmrchckmem(mr(mrpointer),realcheck,mrpointer, &
                             n,ilog,called)
               call wrmrchckmem(mr(mrpointer),realcheck,mrpointer, &
                             n,6,called)
!            pointer = mrcheck(n)-1
!            if (mr(pointer).ne.realcheck) then
!               call wrmrchckmem(mr(pointer),realcheck,pointer, &
!                             n,ilog,called)
!               call wrmrchckmem(mr(pointer),realcheck,pointer, &
!                             n,6,called)
            endif
         enddo
         if(called .and. indx.gt.0 ) then
            write(6,*)    'Stopped at:', indx
            write(ilog,*) 'Stopped at:', indx
            write (6,99) 'hpsi',mchpsi,hpsidim,mchpsi+hpsidim
            write (6,99) 'hunpsi',mchunpsi,totphidim,mchunpsi+totphidim
            write (6,99) 'intpsi',mcintpsi,intpsidim,mcintpsi+intpsidim
            write (6,99) 'oldpsi', mcoldpsi,dgldim,mcoldpsi+dgldim
            write (6,99) 'predpsi', mcpredpsi,totphidim, &
                                    mcpredpsi+totphidim
            write (6,99) 'autopsi',mcautodtpsi,dgldim,mcautodtpsi+dgldim
            write (6,99) 'hloch',mchloch,hlochdim,mchloch+hlochdim
            if (lcross) then
               write (6,99) 'psiref',mcpsiref,psirefdim, &
                                     mcpsiref+psirefdim
               write (6,99) 'ccdover',mcccdover,doverdim, &
                                   mcccdover+doverdim
            endif
            write (6,99) 'workc',mcworkc,workcdim,mcworkc+workcdim
            write (6,99) 'mcdim', mcdim
            write(6,*) lcross,lconstvar,lcmfadaa,lconst
  99        format(a10,3i10)
            call stopnow
         endif


! --- Set the check variables
      else
         called=.false.
         mc(mccheck(1)) = cplxcheck
         do n=3,mccount
            mc(mccheck(n)-1) = cplxcheck
         enddo

         mr(mrcheck(1)) = realcheck
         do n=3,mrcount
            mr(mrcheck(n)-1) = realcheck
         enddo

      endif

      return
      end subroutine checkmemprop                      ! of checkmemprop


!***********************************************************************
      subroutine wrmcchckmem(val,cplxcheck,pointer,errnum,dev,called)

      implicit none

      complex(dop), intent(in)     :: val, cplxcheck
!      integer(long), intent(in)    :: dev, pointer,errnum 
      integer(long), intent(in)    :: pointer 
      integer(long), intent(in)    :: dev,errnum 
      logical(kind=4), intent(out) :: called

      write(dev,'(a)')'================================================'
      write(dev,'(a)')         '            BUG-WARNING  '
      write(dev,'(a)')         '    Consistency of mc-array fails :'
      write(dev,'(a,i3,a)')    '    ',errnum,'  overwritten !! '
      write(dev,'(a,2f21.17)') '    value    : ',val
      write(dev,'(a,2f21.17)') '    check    : ',cplxcheck
      write(dev,'(a,i9)')      '    pointer  : ',pointer 
      write(dev,'(a)')'================================================'
      write(dev,*)
      called = .true.

      return
      end subroutine wrmcchckmem


!***********************************************************************
      subroutine wrmrchckmem(val,realcheck,pointer,errnum,dev,called)

      implicit none

      real(dop), intent(in)        :: val,realcheck
      integer(long), intent(in)    :: dev, pointer,errnum 
      logical(kind=4), intent(out) :: called

      write(dev,'(a)')'================================================'
      write(dev,'(a)')         '            BUG-WARNING  '
      write(dev,'(a)')         '    Consistency of mr-array fails :'
      write(dev,'(a,i3,a)')    '    ',errnum,'  overwritten !! '
      write(dev,'(a,2f21.17)') '    value    : ',val
      write(dev,'(a,1f21.17)') '    check    : ',realcheck
      write(dev,'(a,i9)')      '    pointer  : ',pointer 
      write(dev,'(a)')'================================================'
      write(dev,*)
      called = .true.

      return
      end subroutine wrmrchckmem


      end module mempropmod

