      module mpifunctionmod

use decimal, only: dop, long
use logdat

      implicit none
      private
#ifdef MPI
      public :: mpifunka2
      contains

!#######################################################################

!-----------------------------------------------------------------------
!   mpifunka2
!-----------------------------------------------------------------------

      subroutine mpifunka2(Krylov,HKrylov)

use mpi

use global
use globmemmod
use dvrdatmod
use griddatmod
use operdef
use psidef
use datenmod
use runpropmod
use hpsimod
use timing
use channels
use distribmod
use mpidata

use op1lib, only: cpvxd,zerovxd
use op2lib, only: addvxxdo
use xvlib, only: xvxxdda
use mtlib, only: mtxxzd,qtxxzd

      implicit none

      real(dop), dimension(*), intent(in)           :: Krylov
      real(dop), dimension(*), intent(out)          :: HKrylov
      integer(long) :: koffset,k0,s,s1,zeig1,zeig2,zeig3,k,h,m,vdim1

! --- Get Data
! ... A-Vector
      call MPI_Bcast(Krylov,adim,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,mpierr)

! --- Do the work for prozess mpirank
! --- INITIALISE VARIABLES --- 

      call zerovxd(HKrylov,adim)
      koffset=zham(1)+kzahl(1)-1
      k0=zham(1)

! --- LOOP OVER EACH CORRELATED HAMILTONIAN TERM ---

      do k=k0+mpirank,koffset,nmpi
         if(kskip.eq.0) goto 88
         if(diag(meb,k)) goto 88 ! next line: reflex
         if(abs(hteil(pmat(meb,k)-3+kskip*3)).le.1.d-8) goto 99
88       s = kf(k)
         s1= ki(k)
         if(s.eq.s1) then
            zeig2 = maxblock + 1
            zeig1 = 1
            call cpvxd(Krylov(zpsi(s)),mr(mrworkr+zeig2-1),block(s))
            do m = 1,nmode
               if (.not. diag(m,k)) then

!       --- SWAP POINTERS OR SELECT COEFFICIENTS ---

                  zeig3 = zeig1
                  zeig1 = zeig2
                  zeig2 = zeig3

!       --- MULTIPLY WITH MATRIX ELEMENTS ---

                  call qtxxzd(hteil(pmat(m,k)), &
                       mr(mrworkr+zeig1-1), &
                       mr(mrworkr+zeig2-1), &
                       vdim(m,s),dim(m,s),ndim(m,s))
               endif
            enddo
         else
            zeig2 = maxblock+1
            zeig1 = 1
            call cpvxd(Krylov(zpsi(s1)),mr(mrworkr+zeig2-1),block(s1))

            vdim1 = vdim(1,s1)
            do m = 1,nmode

!    --- SWAP POINTERS ---

               zeig3 = zeig1
               zeig1 = zeig2
               zeig2 = zeig3
               
!    --- MULTIPLY WITH MATRIX ELEMENTS ---

               call mtxxzd(hteil(pmat(m,k)), &
                    mr(mrworkr+zeig1-1), &
                    mr(mrworkr+zeig2-1), &
                    vdim1,dim(m,s1),ndim(m,s1),dim(m,s))
               vdim1 = vdim1*dim(m,s)
            enddo
         endif

!    --- STORE RIGHT HAND SIDE IN DTPSI ---
         
         h=hamilton(fkoe,k)
         if (htmtype(h) .eq. 1) then
            call addvxxdo(mr(mrworkr+zeig2-1),HKrylov(zpsi(s)),block(s))
         else
            call xvxxdda(dble(koeff(k)),mr(mrworkr+zeig2-1), &
                 HKrylov(zpsi(s)),block(s))
         endif
99       continue
      enddo

! --- Reduce Data
      call MPI_Reduce(HKrylov,mr(mrworkr),adim,MPI_DOUBLE_PRECISION, &
                                        MPI_SUM,0,MPI_COMM_WORLD,mpierr)
      call cpvxd(mr(mrworkr),HKrylov,adim)

      return
      end subroutine mpifunka2

#endif
end module mpifunctionmod
