c      
c A Viel 18 July 2002
c Potential.f for Ethene
c
c Krawczyk, R. P. and Viel, A. and Manthe, U. and Domcke, W.
c JCP (03) 119: 1397
c
      subroutine eth6Dpot (vdia,q)
      implicit none
      real*8       q(*)
      real*8       phi,t_R,t_L,a_R,a_L,R
      real*8       vpot,v_pi,vpyr,v__C,vdel
      real*8       s2phi,cphi
      real*8       vdia(3,3),vadia(3),Vecprop(3,3),temp(3)
      integer i,j,imode,ierr
    
      real*8 alpha0,A,A2,A4,A02,A04,A22
     .      ,A001 ,A002 ,A003 ,A004,A201
     .      ,A0001,A0002,A2001,A00011
     .      ,B02,B04,B0001,B22
     .      ,C1,C3,C12,C101,C102,C1001,C1002,C10011
     .      ,D ,D001,D002,D0001,D0002,D00011
     .      ,Eo,E001,E002,E0001,E0002,E00011   

      common /ethen_pot/alpha0,A,A2,A4,A02,A04,A22
     .      ,A001 ,A002 ,A003 ,A004,A201
     .      ,A0001,A0002,A2001,A00011
     .      ,B02,B04,B0001,B22
     .      ,C1,C3,C12,C101,C102,C1001,C1002,C10011
     .      ,D ,D001,D002,D0001,D0002,D00011
     .      ,Eo,E001,E002,E0001,E0002,E00011       

c
c  case phi, thetaR thetaL alphaR alphaL R   (6D)
       phi    = q(1)
       t_R    = q(2)
       t_L    = q(3)
       a_R    = q(4)
       a_L    = q(5)
       R      = q(6)
c
c Computation of diabatic representation of V
c 6 coordinates
c 
c
      s2phi=dsin(phi)*dsin(phi)
      cphi =dcos(phi)
c
      vpot=A  + A2  * s2phi  + A4  * s2phi**2
     .    +     A02 * t_R**2 + A04 * t_R**4
     .    +     A02 * t_L**2 + A04 * t_L**4
     .    + A001 *R   +A002  *R**2 +A003*R**3 +A004*R**4
     .    + A0001*a_R +A0002 *a_R**2
     .    + A0001*a_L +A0002 *a_L**2
     .    + A22 * s2phi * t_R**2
     .    + A22 * s2phi * t_L**2
     .    + A2001 * s2phi * a_R**2
     .    + A2001 * s2phi * a_L**2
     .    + A00011 * a_R * a_L
     .    + A201   * s2phi * R 
c
      v_pi=C1 * cphi + C3 * cphi**3
     .    + C12 * cphi * t_R**2 
     .    + C12 * cphi * t_L**2 
     .    + C101 * cphi * R + C102 * cphi * R**2
     .    + C1001* cphi * a_L + C1002 *cphi * a_L**2
     .    + C1001* cphi * a_R + C1002 *cphi * a_R**2
     .    + C10011 * cphi *a_L * a_R
c
      vpyr=B02  * t_R**2 + B04 * t_R**4
     .    -B02  * t_L**2 - B04 * t_L**4
     .    +B0001 * a_R
     .    -B0001 * a_L
     .    +B22 * s2phi * t_R**2
     .    -B22 * s2phi * t_L**2  
c
      v__c=D +D001  * R   + D002  * R**2
     .    +   D0001 * a_L + D0002 * a_L**2
     .    +   D0001 * a_R + D0002 * a_R**2
     .    +   D00011 * a_L * a_R
c
      vdel=Eo+E001  * R   + E002  * R**2
     .    +   E0001 * a_L + E0002 * a_L**2
     .    +   E0001 * a_R + E0002 * a_R**2
     .    +   E00011 * a_L * a_R  
c
      vdia(1,1)=vpot+v__c*0.5d0+v_pi
      vdia(2,2)=vpot+v__c*0.5d0-v_pi
      vdia(3,3)=vpot-v__c
      vdia(1,2)=vdel+v__c*0.5d0
      vdia(2,1)=vdel+v__c*0.5d0
      vdia(1,3)=vpyr/dsqrt(2.d0)
      vdia(3,1)=vpyr/dsqrt(2.d0)
      vdia(2,3)=vpyr/dsqrt(2.d0)
      vdia(3,2)=vpyr/dsqrt(2.d0)    
 
c
c Diagonalization of the matrix
c 
c      call tred2(3,3,vdia,vadia,temp,vecprop)
c      call tql2 (3,3,vadia,temp,Vecprop,ierr)
c      Write(6,10)(q(i),i=1,6),(vadia(i),i=1,3)
c 10   format("ADIA",6f15.6,3g26.10)

      return
      end

c A Viel 28 June 2002
c######################################################################

      subroutine eth6Dinit 

      implicit none

      integer     i

      real*8 g_value_phy,g_value_the,g_value_sci
      real*8 mh,mc,R,Rch
      real*8 autoeV,aumass
c
      real*8 f_A,f_A2,f_A4,f_A02,f_A04,f_A22    
     .      ,f_A001 ,f_A002 ,f_A003 ,f_A004,f_A201
     .      ,f_A0001,f_A0002,f_A2001,f_A00002
     .      ,f_B02,f_B04,f_B22,f_B00001
     .      ,f_C1,f_C3,f_C12,f_C101,f_C102,f_C1001,f_C1002,f_C10002
     .      ,f_D ,f_D001,f_D002,f_D0001,f_D0002,f_D00011
     .      ,f_Eo,f_E001,f_E002,f_E0001,f_E0002,f_E00011
c
      real*8 alpha0,A,A2,A4,A02,A04,A22    
     .      ,A001 ,A002 ,A003 ,A004,A201
     .      ,A0001,A0002,A2001,A00011
     .      ,B02,B04,B0001,B22
     .      ,C1,C3,C12,C101,C102,C1001,C1002,C10011
     .      ,D ,D001,D002,D0001,D0002,D00011
     .      ,Eo,E001,E002,E0001,E0002,E00011

      common /ethen_pot/alpha0,A,A2,A4,A02,A04,A22
     .      ,A001 ,A002 ,A003 ,A004,A201
     .      ,A0001,A0002,A2001,A00011
     .      ,B02,B04,B0001,B22
     .      ,C1,C3,C12,C101,C102,C1001,C1002,C10011
     .      ,D ,D001,D002,D0001,D0002,D00011
     .      ,Eo,E001,E002,E0001,E0002,E00011


      Data     autoeV/27.21d0/
      Data aumass/1822.802d0/
c
c Update of potential parameter (From R. Krawczyk 16 May 2002  )
c tranform into atomic unit of energy
      f_A      =  6.8539537   d0 /autoev    ! phi theta
      f_A2     = -3.1580260   d0 /autoev    ! phi theta
      f_A4     =  1.0118908   d0 /autoev    ! phi theta
      f_A02    =  0.59909707  d0 /autoev    ! phi theta
      f_A04    =  0.060730974 d0 /autoev    ! phi theta
      f_A22    =  0.061186803 d0 /autoev    ! phi theta
      f_A001   = -4.0108838   d0 /autoev     ! phi R
      f_A002   =  8.6820374   d0 /autoev     ! phi R
      f_A003   = -7.7573488   d0 /autoev     ! phi R
      f_A004   =  3.4532310   d0 /autoev     ! phi R
      f_A201   =  2.2087898   d0 /autoev     ! phi R
      f_A0001  =  0.45824154  d0 /autoev      ! phi alpha
      f_A0002  =  3.6479706   d0 /autoev      ! phi alpha
      f_A2001  =  0.20728508  d0 /autoev      ! phi alpha
      f_A00002 =  4.3823      d0 /autoev       ! phi anti
      f_B02    = -0.98950647  d0 /autoev    ! phi theta
      f_B04    =  0.064393247 d0 /autoev    ! phi theta
      f_B00001 =  0.6416      d0 /autoev       ! phi anti
      f_B22    =  0.10015988  d0 /autoev    ! phi theta
      f_C1     = -4.7441726   d0 /autoev    ! phi theta
      f_C3     = -1.5326638   d0 /autoev    ! phi theta
      f_C12    =  0.16367105  d0 /autoev    ! phi theta
      f_C101   =  4.3934028   d0 /autoev     ! phi R
      f_C102   = -0.13733079  d0 /autoev     ! phi R
      f_C1001  = -0.38369586  d0 /autoev      ! phi alpha
      f_C1002  =  0.99539850  d0 /autoev      ! phi alpha
      f_C10002 =  0.2589      d0 /autoev       ! phi anti
      f_D      = -0.80241721  d0 /autoev    ! phi theta
      f_D001   = -0.79648663  d0 /autoev    ! phi R
      f_D002   =  0.20687243  d0 /autoev    ! phi R
      f_D0001  = -0.17708983  d0 /autoev      ! phi alpha
      f_D0002  = -0.09464950  d0 /autoev      ! phi alpha
      f_Eo     =  1.6857299   d0 /autoev    ! phi theta
      f_E001   =  1.1379357   d0 /autoev     ! phi R
      f_E002   = -0.2293324   d0 /autoev     ! phi R
      f_E0001  =  0.26915003  d0 /autoev      ! phi alpha
      f_E0002  = -0.70881129  d0 /autoev      ! phi alpha
c
c parameter used in the code : mainly change from alpha_s alpha_a to alpha_r alpha_l
      A     = f_A      
      A2    = f_A2     
      A4    = f_A4     
      A02   = f_A02    
      A04   = f_A04    
      A22   = f_A22    
      A001  = f_A001   
      A002  = f_A002   
      A003  = f_A003   
      A004  = f_A004   
      A201  = f_A201   
      A0001 = f_A0001  * 0.5 d0
      A0002 = f_A0002  / 4.0 d0 + f_A00002 / 4.d0
      A2001 = f_A2001  * 0.5 d0
      A00011= f_A0002  / 2.0 d0 - f_A00002 / 2.d0
      B02   = f_B02    
      B04   = f_B04    
      B0001 = f_B00001 / 2.d0
      B22   = f_B22    
      C1    = f_C1     
      C3    = f_C3     
      C12   = f_C12    
      C101  = f_C101   
      C102  = f_C102   
      C1001 = f_C1001   /2.d0 
      C1002 = f_C1002  / 4. d0 + f_C10002 / 4. d0 
      C10011= f_C1002  / 2. d0 - f_C10002 / 2. d0
      D     = f_D      
      D001  = f_D001   
      D002  = f_D002   
      D0001 = f_D0001  / 2.d0
      D0002 = f_D0002  / 4.d0
      D00011= f_D0002  / 2.d0
      Eo    = f_Eo     
      E001  = f_E001   
      E002  = f_E002   
      E0001 = f_E0001  / 2.d0
      E0002 = f_E0002  / 4.d0
      E00011= f_E0002  / 2.d0

c Geometry parameters and masses April 29 2002
      mh     =  1.00794 *aumass
      mc     = 12.0107 *aumass
      Rch    =  2.04207272   !atomic unit
      R      =  2.51734      !atomic unit
      alpha0 =  2.04699196  !rad          

      return
      end

