
! The model dissociative diatomic gas-surface potential of Frankcombe, Collins, Zhang, JCP 137 (2012) 144701

subroutine gsmodel(cvec,e)        ! ,dv)
 ! Cartesians in bohr.
 ! Energy in Eh
implicit none
real(kind=8),dimension(6),intent(in)::cvec
!real(kind=8),dimension(2,3),intent(in)::c
!real(kind=8),dimension(2,3),intent(out)::dv
real(kind=8),intent(out)::e
real(kind=8),parameter::D1=9,D2=1/7.0_8,r0=1.4_8,a=6
real(kind=8),parameter::alpha2=0.5_8,gamma=0.1_8
real(kind=8),parameter::as=1.5_8,ds=0.9_8
real(kind=8),parameter::root3=1.73205080756887729352_8
real(kind=8),parameter::pi=3.1415926535897932384626_8
real(kind=8),dimension(2,2),parameter::B= &
        a*reshape((/1.0_8,0.0_8,0.5_8,root3*0.5_8/),(/2,2/))
real(kind=8),dimension(2,2),parameter::Binv= &
        reshape((/root3*0.5_8,0.0_8,-0.5_8,1.0_8/),(/2,2/))/(a*root3*0.5_8)
real(kind=8),dimension(2,3)::c
real(kind=8),dimension(2)::x,x0
real(kind=8)::r,r6,z,ez,p,rho
c(1,:)=cvec(1:3)
c(2,:)=cvec(4:6)
r=sqrt(sum((c(1,:)-c(2,:))**2))
r6=r**6
z=0.5_8*(c(1,3)+c(2,3))
 ! LJ-like term
e=D1*(1/r6**2-2/(r0+1/z**3)**6/r6)
!dv(1,:)=D1*(12/(r0+1/z**3)**6/r6-12/r6**2)/r**2*(c(1,:)-c(2,:))
!dv(2,:)=-dv(1,:)
!dv(:,3)=dv(:,3)-D1*12/(r0+1/z**3)**7/r6/z**4*1.5_8
 ! Z-dependent Morse (drives dissociation)
ez=exp(-as*(c(1,3)-ds))
e=e+D2*((1-ez)**2-1)
!dv(1,3)=dv(1,3)+2*D2*(1-ez)*ez*as
ez=exp(-as*(c(2,3)-ds))
e=e+D2*((1-ez)**2-1)
!dv(2,3)=dv(2,3)+2*D2*(1-ez)*ez*as
 ! Symmetry-inducing cos on the lattice sites
 ! First atom
x=matmul(Binv,c(1,1:2))     ! there must be a smarter way of doing this...
x=x-floor(x)
x=matmul(B,x)
x0=0
rho=sum(x**2)
p=sum((x-B(:,1))**2)
if (p<rho) then
  rho=p
  x0=B(:,1)
endif
p=sum((x-B(:,2))**2)
if (p<rho) then
  rho=p
  x0=B(:,2)
endif
p=sum((x-B(:,1)-B(:,2))**2)
if (p<rho) then
  rho=p
  x0=B(:,1)+B(:,2)
endif
rho=rho+alpha2*c(1,3)**2
rho=sqrt(rho)/a
if (rho<0.5_8) then
  e=e+gamma*(cos(2*pi*rho)+1)*0.5_8
!  dv(1,1:2)=dv(1,1:2)-gamma*pi*sin(2*pi*rho)/rho*(x-x0)/a**2
!  dv(1,3)=dv(1,3)-gamma*pi*sin(2*pi*rho)/rho*c(1,3)/a**2*alpha2
endif
 ! Second atom
x=matmul(Binv,c(2,1:2))     ! there must be a smarter way of doing this...
x=x-floor(x)
x=matmul(B,x)
x0=0
rho=sum(x**2)
p=sum((x-B(:,1))**2)
if (p<rho) then
  rho=p
  x0=B(:,1)
endif
p=sum((x-B(:,2))**2)
if (p<rho) then
  rho=p
  x0=B(:,2)
endif
p=sum((x-B(:,1)-B(:,2))**2)
if (p<rho) then
  rho=p
  x0=B(:,1)+B(:,2)
endif
rho=rho+alpha2*c(2,3)**2
rho=sqrt(rho)/a
if (rho<0.5_8) then
  e=e+gamma*(cos(2*pi*rho)+1)*0.5_8
!  dv(2,1:2)=dv(2,1:2)-gamma*pi*sin(2*pi*rho)/rho*(x-x0)/a**2
!  dv(2,3)=dv(2,3)-gamma*pi*sin(2*pi*rho)/rho*c(2,3)/a**2*alpha2
endif
end subroutine gsmodel

