c A Viel 2021.11.04
c for Graham Worth
c NO3- potential as published in JCP 140, 224109 (2014)
c supported vibrational levels in JCP 146 0343030 (2017)
c
c input : 6 mass weighted normal modes (NO3 diabatic)
c order : 
c     1  symmetric stretch
c     2  umbrella mode
c     3  asymmetric stretch ex
c     4  asymmetric stretch ey
c     5  asymmetric bend ex
c     6  asymmetric bend ey
c
c output : potential energy in hartree
c range of validity : not tested
c
c usage : init step to be done once
c version without openmp features
c
c expected output for 8 arbitrary geometries (in hartree and in cm-1)
c
c     10.93          0.00          0.00          0.00          0.00          0.00  -0.996279452E-03   -218.658065    
c    -10.00          0.00          0.00          0.00          0.00          0.00   0.464987840E-02    1020.53035    
c      0.00        -10.00          0.00          0.00          0.00          0.00   0.122947837E-02    269.839311    
c      0.00          0.00        -10.00          0.00          0.00          0.00   0.271328468E-02    595.497154    
c      0.00          0.00          0.00        -10.00          0.00          0.00   0.280110339E-02    614.771134    
c      0.00          0.00          0.00          0.00        -10.00          0.00   0.103176412E-02    226.446050    
c      0.00          0.00          0.00          0.00          0.00        -10.00   0.103040635E-02    226.148054    
c      8.00          3.00          4.00          0.00         -2.00          6.00  -0.279143419E-03   -61.2648990    
c
c
c
c

c A Viel 22 march 2005 - October 2021
c intialization of Trans_coord common block
c
c from mass weighted normal mode to internal symmetry
c coordinate (for PES computation)
c
      Subroutine init_pot_no3m
      Implicit none
      real*8   ref(12),redm(6),transform(12,6)
      real*8   phi_ref,le_ref,beta_ref
      real*8   pi,sq2,sq3,sq6
      real*8   massatom(12)
c
      common /transformcoordblock/ref,redm,transform,
     &         phi_ref,le_ref,beta_ref,pi,sq2,sq3,sq6
     &        ,massatom
c
      Write(6,*)'# init_pot dated:30/03/2021'
      Write(6,*)'# init_pot dated:26/06/2012'
      Write(6,*)'# normal mode to symmetry NO3 minus 2014'
c
      pi=4.d0*datan(1.d0)
      sq2=1.d0/dsqrt(2.d0)
      sq3=1.d0/dsqrt(3.d0)
      sq6=1.d0/dsqrt(6.d0)
c
c
      massatom( 1)= 25526.041027440679D0 ! Nitrogen NIST value
      massatom( 2)= 25526.041027440679D0
      massatom( 3)= 25526.041027440679D0
      massatom( 4)=  29156.944158785842D0   ! Oxygen NIST value
      massatom( 5)=  29156.944158785842D0   ! Oxygen NIST value
      massatom( 6)=  29156.944158785842D0   ! Oxygen NIST value
      massatom( 7)=  29156.944158785842D0   ! Oxygen NIST value
      massatom( 8)=  29156.944158785842D0   ! Oxygen NIST value
      massatom( 9)=  29156.944158785842D0   ! Oxygen NIST value
      massatom(10)=  29156.944158785842D0   ! Oxygen NIST value
      massatom(11)=  29156.944158785842D0   ! Oxygen NIST value
      massatom(12)=  29156.944158785842D0   ! Oxygen NIST value
c

c
c reference geometry
      phi_ref=120.d0/180.d0*pi
      le_ref=2.344419d0
c for completness reno=2.344419d0,reoo=4.0606528d0,rad=0.017453293d0)
      beta_ref=pi*0.5d0
      Write(6,*)'# ref geometry:'
      Write(6,*)'# phi_ref: ',phi_ref
      Write(6,*)'# le_ref:  ',le_ref
      Write(6,*)'# beta_ref:',beta_ref

      Write(6,*)'# Mass N:',massatom(1)
      Write(6,*)'# Mass O:',massatom(4)
c
c array for normal mode
c normal mode
      redm(1) = 1.d0
      redm(2) = 1.d0
      redm(3) = 1.d0
      redm(4) = 1.d0
      redm(5) = 1.d0
      redm(6) = 1.d0

c 3912 Mar 29 13:41 /raid/home/viel/NO3/NORMALMODE/Normal_NO3diab.fort.99
      ref( 1)= 0.000000000000000
      ref( 2)= 0.000000000000000
      ref( 3)= 0.000000000000000
      ref( 4)= 2.337983200000000
      ref( 5)= 0.000000000000000
      ref( 6)= 0.000000000000000
      ref( 7)=-1.168991600000000
      ref( 8)= 2.024752844821230
      ref( 9)= 0.000000000000000
      ref(10)=-1.168991600000000
      ref(11)=-2.024752844821230
      ref(12)= 0.000000000000000
c symmetric stretch           
c     0.50032159E-02         1098.0802
      transform( 1, 1) =      -0.000015893
      transform( 2, 1) =       0.000000000
      transform( 3, 1) =       0.000000000
      transform( 4, 1) =       0.577315920
      transform( 5, 1) =       0.000000000
      transform( 6, 1) =       0.000000000
      transform( 7, 1) =      -0.288698723
      transform( 8, 1) =       0.500006212
      transform( 9, 1) =       0.000000000
      transform(10, 1) =      -0.288698723
      transform(11, 1) =      -0.500006212
      transform(12, 1) =       0.000000000
c umbrella mode               
c     0.45801249E-02         1005.2224
      transform( 1, 2) =       0.000000000
      transform( 2, 2) =       0.000000000
      transform( 3, 2) =       0.879836965
      transform( 4, 2) =       0.000000000
      transform( 5, 2) =       0.000000000
      transform( 6, 2) =      -0.274400508
      transform( 7, 2) =       0.000000000
      transform( 8, 2) =       0.000000000
      transform( 9, 2) =      -0.274400508
      transform(10, 2) =       0.000000000
      transform(11, 2) =       0.000000000
      transform(12, 2) =      -0.274400508
c asymmetric stretch ex       
c     0.65666018E-02         1441.2042
      transform( 1, 3) =       0.829675733
      transform( 2, 3) =       0.000000000
      transform( 3, 3) =       0.000000000
      transform( 4, 3) =      -0.450917269
      transform( 5, 3) =       0.000000000
      transform( 6, 3) =       0.000000000
      transform( 7, 3) =      -0.162691631
      transform( 8, 3) =       0.166395105
      transform( 9, 3) =       0.000000000
      transform(10, 3) =      -0.162691631
      transform(11, 3) =      -0.166395105
      transform(12, 3) =       0.000000000
c asymmetric stretch ey       
c     0.65667646E-02         1441.2399
      transform( 1, 4) =       0.000000000
      transform( 2, 4) =       0.829650788
      transform( 3, 4) =       0.000000000
      transform( 4, 4) =       0.000000000
      transform( 5, 4) =      -0.066593388
      transform( 6, 4) =       0.000000000
      transform( 7, 4) =       0.166471513
      transform( 8, 4) =      -0.354837541
      transform( 9, 4) =       0.000000000
      transform(10, 4) =      -0.166471513
      transform(11, 4) =      -0.354837541
      transform(12, 4) =       0.000000000
c asymmetric bend ex          
c     0.26312858E-02          577.5011
      transform( 1, 5) =       0.292855045
      transform( 2, 5) =       0.000000000
      transform( 3, 5) =       0.000000000
      transform( 4, 5) =       0.453169707
      transform( 5, 5) =       0.000000000
      transform( 6, 5) =       0.000000000
      transform( 7, 5) =      -0.363497066
      transform( 8, 5) =      -0.471493852
      transform( 9, 5) =       0.000000000
      transform(10, 5) =      -0.363497066
      transform(11, 5) =       0.471493852
      transform(12, 5) =       0.000000000
c asymmetric bend ey          
c     0.26311749E-02          577.4768
      transform( 1, 6) =       0.000000000
      transform( 2, 6) =       0.292903340
      transform( 3, 6) =       0.000000000
      transform( 4, 6) =       0.000000000
      transform( 5, 6) =      -0.635818721
      transform( 6, 6) =       0.000000000
      transform( 7, 6) =      -0.471423946
      transform( 8, 6) =       0.180915884
      transform( 9, 6) =       0.000000000
      transform(10, 6) =       0.471423946
      transform(11, 6) =       0.180915884
      transform(12, 6) =       0.000000000

      Return
      End

c A Viel 2013.10.11
c update parameters for NO3- ground state surface
      Subroutine init_pot_no3m_para
      Implicit none
      real*8 p(149),e0ref,e0rho
      integer iref,pst(2,100)

      integer npoly(2)
      double precision a(20)  !copy of the first elements of p array

      integer n,i,npst,j
c
      common /no3minus_pot/e0ref,e0rho,p,pst,iref

      common /tmc/a,npoly


c
c second order 
c      iref=0
c correction to second order
c      iref=1
c all parameters
      iref=2
c
      n=149
      npst=30
c

!fit/anion/12
!generation 30
!low points added
!modified fitting weights

       p(  1)=  -0.423420505D+00
       p(  2)=   0.449874853D+02
       p(  3)=   0.330455319D+02
       p(  4)=  -0.939255160D+02
       p(  5)=   0.213702586D+02
       p(  6)=   0.123400003D+00
       p(  7)=   0.264359038D+03
       p(  8)=   0.214446044D+04
       p(  9)=   0.123400003D+00
       p( 10)=   0.580634309D+02
       p( 11)=   0.561775142D+02
       p( 12)=   0.677091064D+02
       p( 13)=  -0.167905184D+02
       p( 14)=   0.833270240D+02
       p( 15)=   0.123400003D+00
       p( 16)=   0.594357444D+01
       p( 17)=  -0.277295130D+01
       p( 18)=   0.199296047D+02
       p( 19)=  -0.198890894D+02
       p( 20)=   0.526761368D+00
       p( 21)=   0.123399990D+00
       p( 22)=  -0.137121937D+02
       p( 23)=  -0.277461806D+01
       p( 24)=  -0.485690676D+01
       p( 25)=   0.627736894D+00
       p( 26)=   0.188429272D+02
       p( 27)=  -0.103233480D+02
       p( 28)=  -0.535770502D+01
       p( 29)=   0.240002161D+03
       p( 30)=  -0.464198142D+03
       p( 31)=  -0.941686735D+03
       p( 32)=  -0.138031898D+03
       p( 33)=   0.226652993D+04
       p( 34)=  -0.744002207D+03
       p( 35)=   0.516517933D+02
       p( 36)=  -0.324189212D+03
       p( 37)=  -0.372308783D+02
       p( 38)=  -0.963568275D+03
       p( 39)=  -0.167001045D+03
       p( 40)=   0.959289088D+01
       p( 41)=   0.423934459D+03
       p( 42)=  -0.333087721D+04
       p( 43)=   0.338811425D+04
       p( 44)=   0.322848643D+04
       p( 45)=   0.768405039D+03
       p( 46)=   0.120740372D+04
       p( 47)=  -0.252869299D+03
       p( 48)=  -0.303013305D+04
       p( 49)=  -0.900706792D+04
       p( 50)=  -0.321022601D+02
       p( 51)=   0.579109468D+01
       p( 52)=  -0.143202972D+03
       p( 53)=  -0.365156901D+00
       p( 54)=   0.267363400D+02
       p( 55)=  -0.240046373D+03
       p( 56)=  -0.811714260D-03
       p( 57)=   0.253835931D+03
       p( 58)=  -0.782238114D+03
       p( 59)=   0.123400004D+00
       p( 60)=   0.124150659D+02
       p( 61)=   0.452639937D-01
       p( 62)=   0.553436441D+01
       p( 63)=  -0.203133792D+03
       p( 64)=  -0.475110370D+03
       p( 65)=  -0.395995479D+03
       p( 66)=   0.110095625D+01
       p( 67)=   0.414478996D+04
       p( 68)=  -0.137885187D+05
       p( 69)=   0.123400003D+00
       p( 70)=   0.324020496D+03
       p( 71)=   0.169246160D+03
       p( 72)=  -0.241261705D+05
       p( 73)=   0.123400003D+00
       p( 74)=  -0.389797177D+01
       p( 75)=  -0.393411888D+03
       p( 76)=   0.126527978D+05
       p( 77)=   0.123400003D+00
       p( 78)=   0.162847567D+04
       p( 79)=  -0.244726391D+01
       p( 80)=  -0.688821434D+00
       p( 81)=   0.104788478D+03
       p( 82)=  -0.516867452D+01
       p( 83)=   0.420023603D+00
       p( 84)=   0.123876549D+03
       p( 85)=  -0.592752889D+03
       p( 86)=  -0.794740745D+03
       p( 87)=   0.511595507D+00
       p( 88)=   0.437992809D+03
       p( 89)=   0.103546430D+02
       p( 90)=   0.357564428D+06
       p( 91)=   0.188801119D+04
       p( 92)=  -0.278353065D-01
       p( 93)=   0.132394151D+01
       p( 94)=  -0.130865846D+00
       p( 95)=   0.945783976D+02
       p( 96)=   0.134995989D+03
       p( 97)=   0.440287210D+04
       p( 98)=   0.388818207D+01
       p( 99)=   0.336063583D+01
       p(100)=  -0.351793092D+02
       p(101)=   0.929851196D+02
       p(102)=   0.101715217D+02
       p(103)=   0.109064280D+01
       p(104)=   0.256667475D+03
       p(105)=  -0.331607816D+03
       p(106)=  -0.153857461D+03
       p(107)=  -0.683676644D+03
       p(108)=  -0.532482414D+02
       p(109)=  -0.823038481D+01
       p(110)=   0.420934472D+02
       p(111)=  -0.231280666D+03
       p(112)=  -0.119548891D+03
       p(113)=   0.340116696D+04
       p(114)=   0.166635471D+04
       p(115)=  -0.138370595D+05
       p(116)=   0.173527444D+03
       p(117)=  -0.108423400D+02
       p(118)=  -0.165168643D+01
       p(119)=   0.235161905D+00
       p(120)=  -0.777849986D+00
       p(121)=   0.401203439D+02
       p(122)=  -0.231801644D+01
       p(123)=  -0.258505894D+01
       p(124)=   0.243417288D+00
c Vertical Energy
       p(125)=  0.d0    !-0.280090101D+03
       p(126)=   0.000000000D+00
       p(127)=   0.245582954D+00
       p(128)=   0.000000000D+00
       p(129)=   0.000000000D+00
       p(130)=   0.666178977D+00
       p(131)=   0.000000000D+00
       p(132)=  -0.155067843D+00
       p(133)=  -0.611352264D-01
       p(134)=  -0.733560693D-01
       p(135)=  -0.400136794D-01
       p(136)=  -0.455797478D-01
       p(137)=   0.000000000D+00
       p(138)=   0.750000000D+00
       p(139)=   0.000000000D+00
       p(140)=   0.000000000D+00
       p(141)=   0.000000000D+00
       p(142)=   0.000000000D+00
       p(143)=   0.000000000D+00
       p(144)=   0.000000000D+00
       p(145)=   0.000000000D+00
       p(146)=   0.000000000D+00
       p(147)=   0.000000000D+00
       p(148)=   0.631776400D+01
       p(149)=   0.804891560D+00
       e0ref=   0.200000000D+00
       e0rho=   0.100000000D+00
      pst(1,  1)=  1
      pst(2,  1)=  6
      pst(1,  2)=  7
      pst(2,  2)=  3
      pst(1,  3)= 10
      pst(2,  3)=  6
      pst(1,  4)= 16
      pst(2,  4)=  6
      pst(1,  5)= 22
      pst(2,  5)= 28
      pst(1,  6)= 50
      pst(2,  6)= 10
      pst(1,  7)= 60
      pst(2,  7)= 10
      pst(1,  8)= 70
      pst(2,  8)=  0
      pst(1,  9)= 70
      pst(2,  9)=  0
      pst(1, 10)= 70
      pst(2, 10)=  0
      pst(1, 11)= 70
      pst(2, 11)=  0
      pst(1, 12)= 70
      pst(2, 12)=  0
      pst(1, 13)= 70
      pst(2, 13)=  4
      pst(1, 14)= 74
      pst(2, 14)=  4
      pst(1, 15)= 78
      pst(2, 15)=  0
      pst(1, 16)= 78
      pst(2, 16)=  0
      pst(1, 17)= 78
      pst(2, 17)=  6
      pst(1, 18)= 84
      pst(2, 18)=  8
      pst(1, 19)= 92
      pst(2, 19)=  0
      pst(1, 20)= 92
      pst(2, 20)=  3
      pst(1, 21)= 95
      pst(2, 21)=  3
      pst(1, 22)= 98
      pst(2, 22)=  0
      pst(1, 23)= 98
      pst(2, 23)=  0
      pst(1, 24)= 98
      pst(2, 24)= 26
      pst(1, 25)=124
      pst(2, 25)=  0
      pst(1, 26)=124
      pst(2, 26)=  1
      pst(1, 27)=125
      pst(2, 27)=  1
      pst(1, 28)=126
      pst(2, 28)= 11
      pst(1, 29)=137
      pst(2, 29)= 11
      pst(1, 30)=148
      pst(2, 30)=  2
c
      Write(6,*)'# anion NO3- 11/10/2013'
      Write(6,*)'# EISFELD/ANION/'
      Write(6,*)'#anion-avqz-final-tmc-lowpts_20131011.par.30'
      Write(6,*)'# iref ',iref
      Write(6,*)'# iref is not used'
      Write(6,*)'# npar ',n
      do i=1,npst
        Write(6,2)i,pst(1,i),i,pst(2,i)
      enddo
      do i=1,n
      Write(6,1)i,p(i)
      enddo
      Write(6,*)'# e0ref au and ev', e0ref,e0ref*27.21d0
      Write(6,*)'# e0rho au and eV', e0rho,e0rho*27.21d0

 1    format('# p(',i3,')=',f20.10)
 2    format('# pst(1,',i3,')=',i5,' pst(2,',i3,')=',i5)
c
      j=1
      do i=pst(1,28),pst(1,28)+pst(2,28)-1
        a(j)=p(i)
        j=j+1
      enddo
c
      npoly(1)=5
      npoly(2)=5

      Write(6,*)'# TMC     npoly(1) : ',npoly(1)
      Write(6,*)'# TMC     npoly(2) : ',npoly(2)
c
      Return
      End


c A Viel 30.09.2015
c Version taken from model-prec.f
c No openmp features
c
      subroutine potentialno3minus (v,q)
c REMOVE OMP AVIEL 03.11.2021
c      use omp_lib
      implicit none
      integer itd ,i,itemp 
      integer teil
      real*8       v,q(*)
      real*8       qinter(7),e,damp
      real*8 eref,damplow,ediff, ediff2
      real*8 polynom,polynom2,vjt6
      real*8 vcoup_ea,vcoup_ea2,vcoup_aa,vcoup_ee
      real*8 vcoup_eea2,vcoup_eaa2,vcoup_eea1
      real*8 dum
      real*8 eloworder(2,2)
      integer iref,pst(2,100)
      real*8 p(149),e0ref,e0rho
c
      common /no3minus_pot/e0ref,e0rho,p,pst,iref
c
      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

c
c initializations -> in main program
c      call init_pot
c      call init_pot_para
c
c compute symmetrized internal coordinate for PES
       call trans_coordm(q,qinter)
c
c PES computation
c
c
c vertical excitation
c      e=p(pst(1,27))  !in low order term eref
       e=0.d0
!..   damping factor for umbrella motion, using hyperradius:
c qinter(7): (no1+no2+no3)/3
      damp=dexp(-dabs(p(pst(1,26))*qinter(7)))       !damping of pure umbrella mode

c precompute terms
c remove OPEN MP AViel 03.11.2021 
c      itd=omp_get_thread_num()
c      itd=itd+1
      itd=1
      call vwzprec(itd,qinter)

c reference low order surface

c computing first order matrix (iref=0 in Wofgang Eisfeld code)
      itemp=0
c vertical excitation
      eref=p(pst(1,27))
c
c symmetric stretching
!..   a1 symmetric stretch:
c      call Epolynom(dum,itd, p(pst(1,1)), pst(2,1), itemp)
      dum=pa(1,itd) * p(pst(1,1))+pa(2,itd) * p(pst(1,1)+1)
      eref=eref+dum

c umbrella mode
!..   a2 umbrella:
c      call Epolynom2(dum,itd, p(pst(1,2)), pst(2,2), itemp)
      dum=pb(1,itd) * p(pst(1,2))
      eref=eref+dum*damp

c e stretching mode:
c e bending mode:
c      call Evjt6a(dum,itd, p(pst(1,3)), pst(2,3), itemp)
      dum= p(pst(1,3)) * va(1,itd)
      eref = eref + dum
c      call Evjt6b(dum,itd, p(pst(1,4)), pst(2,4), itemp)
      dum= p(pst(1,4)) * vb(1,itd)
      eref = eref + dum

!..   mode-mode coupling of a1-e
c      call Evcoup_e1a(dum,itd, p(pst(1,6)), pst(2,6), itemp)  ! e-a coupling 1. e mode
      dum= (p(pst(1,6))*pa(1,itd)*va(1,itd))
      eref = eref + dum
c      call Evcoup_e2a(dum,itd, p(pst(1,7)), pst(2,7), itemp)  ! e-a coupling 2. e mode
      dum=(p(pst(1,7))*pa(1,itd)*vb(1,itd))
      eref = eref + dum

!..   mode-mode coupling of a2-e
c      call Evcoup_e1a2(dum,itd, p(pst(1,13)), pst(2,13), itemp)     !  coupling with asym. str.
      dum=p(pst(1,13))*pb(1,itd)*va(1,itd)
      eref = eref + dum*damp
c      call Evcoup_e2a2(dum,itd, p(pst(1,14)), pst(2,14), itemp)     !  coupling with asym. bend
      dum=p(pst(1,14))*pb(1,itd)*vb(1,itd)
      eref = eref + dum*damp


!..   mode-mode coupling of a1-a2
c      call Evcoup_aa(dum,itd,p(pst(1,17)),pst(2,17), itemp)         !  coupling of a1 and a2
      dum=p(pst(1,17)) * pa(1,itd) * pb(1,itd)
      eref = eref + dum*damp


!..   mode-mode coupling e-e
c      call Evcoup_ee(dum,itd, p(pst(1,5)), pst(2,5), itemp)        ! e-e coupling
      dum=p(pst(1,5)) * vee(1,itd)
      eref = eref + dum


!..   3-mode coupling e-e-a2
c      call Evcoup_eea2(dum,itd,p(pst(1,18)),pst(2,18),itemp)        !  e-e-a2 coupling
      dum=p(pst(1,18)) * pb(1,itd) * vee(1,itd)
      eref = eref + dum*damp


!..   3-mode coupling e-a1-a2
c      call Evcoup_e1aa2(dum,itd,p(pst(1,20)),pst(2,20),itemp)        !  e-a1-a2 coupling (asym. stretch)
      dum=(p(pst(1,20)) * pa(1,itd) * pb(1,itd) * va(1,itd))
      eref = eref + dum*damp
c      call Evcoup_e2aa2(dum,itd,p(pst(1,21)),pst(2,21),itemp)        !  e-a1-a2 coupling (asym. bend)
      dum=(p(pst(1,21)) * pa(1,itd) * pb(1,itd) * vb(1,itd))
      eref = eref + dum*damp


!..   3-mode coupling e-e-a1
c      call Evcoup_eea1(dum,itd,p(pst(1,24)),pst(2,24),itemp)        !  e-e-a1 coupling
      dum=p(pst(1,24)) * pa(1,itd) * vee(1,itd)
      eref = eref + dum
c
!..   dynamic damping depending on lowest reference state energy:
!     we use switching function with origin at 3 eV above NO2 + O asymptote and
!     damp out the correction matrix within +/- 1 eV

c
      IREF=1    ! Check if used in potential_functions

c symmetric stretching
!..   a1 symmetric stretch:
!      e = e + polynom(qinter(1), p(pst(1,1)), pst(2,1), iref)
      call Epolynom(dum,itd, p(pst(1,1)), pst(2,1), iref)
      e=e+dum

c umbrella mode
!..   a2 umbrella:
!      e = e + damp*polynom2(qinter(2), p(pst(1,2)), pst(2,2), iref) ! even powers in s2
      call Epolynom2(dum,itd, p(pst(1,2)), pst(2,2), iref)
      e=e+dum*damp

c e stretching mode:
c      e = e + vjt6(qinter(3), p(pst(1,3)), pst(2,3), iref)
c e bending mode:
c      e = e + vjt6(qinter(5), p(pst(1,4)), pst(2,4), iref)
      call Evjt6a(dum,itd, p(pst(1,3)), pst(2,3), iref)
      e = e + dum
      call Evjt6b(dum,itd, p(pst(1,4)), pst(2,4), iref)
      e = e + dum

!..   mode-mode coupling of a1-e
c      e= e + vcoup_ea(qinter(1), qinter(3), p(pst(1,6)), pst(2,6), iref)  ! e-a coupling 1. e mode
c      e= e + vcoup_ea(qinter(1), qinter(5), p(pst(1,7)), pst(2,7), iref)  ! e-a coupling 2. e mode
      call Evcoup_e1a(dum,itd, p(pst(1,6)), pst(2,6), iref)  ! e-a coupling 1. e mode
      e = e + dum
      call Evcoup_e2a(dum,itd, p(pst(1,7)), pst(2,7), iref)  ! e-a coupling 2. e mode
      e = e + dum

!..   mode-mode coupling of a2-e
c      e=e+damp*vcoup_ea2(qinter(2),qinter(3),p(pst(1,13)),pst(2,13)
c     &  ,iref) ! coupling with asym. str.
c      e=e+damp*vcoup_ea2(qinter(2),qinter(5),p(pst(1,14)),pst(2,14)
c     &     ,iref) ! coupling with asym. bend
      call Evcoup_e1a2(dum,itd, p(pst(1,13)), pst(2,13), iref)     !  coupling with asym. str.
      e = e + dum*damp
      call Evcoup_e2a2(dum,itd, p(pst(1,14)), pst(2,14), iref)     !  coupling with asym. bend
      e = e + dum*damp


!..   mode-mode coupling of a1-a2
c      e = e  + damp*vcoup_aa(qinter(1),qinter(2),p(pst(1,17)),pst(2,17)
c     &       , iref) ! coupling of a1 and a2
      call Evcoup_aa(dum,itd,p(pst(1,17)),pst(2,17), iref)              !  coupling of a1 and a2
      e = e + dum*damp


!..   mode-mode coupling e-e
c      e =e + vcoup_ee(qinter(3), qinter(5), p(pst(1,5)), pst(2,5), iref)        !  e-e coupling
      call Evcoup_ee(dum,itd, p(pst(1,5)), pst(2,5), iref)        ! e-e coupling
      e = e + dum


!..   3-mode coupling e-e-a2
c      e=e+damp*vcoup_eea2(qinter(2),qinter(3),qinter(5)
c     &   ,p(pst(1,18)),pst(2,18),iref) ! e-e-a2 coupling
      call Evcoup_eea2(dum,itd,p(pst(1,18)),pst(2,18),iref)        !  e-e-a2 coupling
      e = e + dum*damp


!..   3-mode coupling e-a1-a2
c      e=e+damp*vcoup_eaa2(qinter(1),qinter(2),qinter(3)
c     &        ,p(pst(1,20)),pst(2,20),iref) ! e-a1-a2 coupling (asym. stretch)
c      e=e+damp*vcoup_eaa2(qinter(1),qinter(2),qinter(5)
c     &    ,p(pst(1,21)),pst(2,21),iref) ! e-a1-a2 coupling (asym. bend)
      call Evcoup_e1aa2(dum,itd,p(pst(1,20)),pst(2,20),iref)        !  e-a1-a2 coupling (asym. stretch)
      e = e + dum*damp
      call Evcoup_e2aa2(dum,itd,p(pst(1,21)),pst(2,21),iref)        !  e-a1-a2 coupling (asym. bend)
      e = e + dum*damp


!..   3-mode coupling e-e-a1
c      e = e + vcoup_eea1(qinter(1),qinter(3),qinter(5)
c     &             ,p(pst(1,24)),pst(2,24),iref) ! e-e-a1 coupling
      call Evcoup_eea1(dum,itd,p(pst(1,24)),pst(2,24),iref)        !  e-e-a1 coupling
      e = e + dum
c
c.. damping high order 
       ediff=(ediff-e0ref)/e0rho

      if (ediff.lt.0.d0) then
         damplow=1.d0
      elseif(ediff.gt.1d0) then
         damplow=0.d0
      else
         ediff2=ediff**2
         damplow=1.d0 - ediff2 * (2.d0 - ediff2)
      endif 

c
c update v
      v=eref+e*damplow
c
      return
c
      End


c A Viel 30.03.2021
c version using normal mode (the one of the no3 radical lowest diabatic)
c from Trans_curv_symno3_scaled_2014.f
c to internal symmetry coordinates (for PES computation)
c
      Subroutine trans_coordm(q,qinter)
      implicit none 
      real*8 q(*),qinter(*)
c
      integer i,j,k
      real*8   qm(6),x(12),xvec(9),xvecinvers(9)
      Real*8   xintern(0:6) !beta, 3 distances, 3 angles
      real*8   tnorm,det,det3t3,t(3)
      real*8   f  ! function for morse evaluation
      real*8   rnodist,rnoprod
c
      real*8   ref(12),redm(6),transform(12,6)
      real*8   phi_ref,le_ref,beta_ref
      real*8   pi,sq2,sq3,sq6
      real*8   massatom(12)
c
c
      common /transformcoordblock/ref,redm,transform,
     &         phi_ref,le_ref,beta_ref,pi,sq2,sq3,sq6
     &        ,massatom
c
c normal modes
c .....remove mass weighting
      do i=1,6
        qm(i)=q(i)/dsqrt(redm(i))
      enddo

c
c Cartesian displacement
      do i=1,12
         x(i)=ref(i)
      enddo
c 
      do i=1,12
       do j=1,6
        x(i)=x(i)+transform(i,j)*qm(j)/dsqrt(massatom(i))
       enddo
      enddo
c
c copy of internal.f subroutine
c NH vectors matrix (3x3)
      do i=0,2
         xvec(3*i+1)=x(3*(i+1)+1)-x(1)
         xvec(3*i+2)=x(3*(i+1)+2)-x(2)
         xvec(3*i+3)=x(3*(i+1)+3)-x(3)
      enddo
c no distances
      rnodist=
     &   dsqrt(xvec(1)**2+xvec(2)**2+xvec(3)**2)
     & + dsqrt(xvec(4)**2+xvec(5)**2+xvec(6)**2)
     & + dsqrt(xvec(7)**2+xvec(8)**2+xvec(9)**2)
      rnoprod=dsqrt(xvec(1)**2+xvec(2)**2+xvec(3)**2)
     & * dsqrt(xvec(4)**2+xvec(5)**2+xvec(6)**2)
     & * dsqrt(xvec(7)**2+xvec(8)**2+xvec(9)**2)


c normalization
      do i=0,2
      xintern(i+1)=dsqrt(xvec(3*i+1)**2+xvec(3*i+2)**2+xvec(3*i+3)**2)
      enddo
      k=1
      do j=1,3
      do i=1,3
         xvec(k)=xvec(k)/xintern(j)
         k=k+1
      enddo
      enddo
c determinant
      det=det3t3(xvec)
c
c planar case
      if (dabs(det).lt.1.d-13) then
        call planarnew(xvec,xintern(4),xintern(0),pi)
      else
c Pyramdal case
c trisector
         call mat_invers(xvec,xvecinvers,det)
         t(1)=xvecinvers(1)+xvecinvers(2)+xvecinvers(3)
         t(2)=xvecinvers(4)+xvecinvers(5)+xvecinvers(6)
         t(3)=xvecinvers(7)+xvecinvers(8)+xvecinvers(9)
         tnorm=dsqrt(t(1)**2+t(2)**2+t(3)**2)
         xintern(0)=dacos(1.d0/tnorm)
c projected angles
         call proangnew(xvec,t,tnorm,xintern(0),xintern(4),pi)
      endif
c
c
c xintern(0)=trisector
c xintern(1)=ditance no1
c xintern(2)=ditance no2
c xintern(3)=ditance no3
c xintern(4)=angle o2no3  TOCHECK
c xintern(5)=angle o3no1  TOCHECK
c xintern(6)=angle o1no2  TOCHECK
c 13.06.2012 order seems coherent with surface definition
c
!...    now transform angles so they properly dissociate:
c        a1=(a1)/((no2+reno)*(no3+reno))
c        a2=(a2)/((no1+reno)*(no3+reno))
c        a3=(a3)/((no1+reno)*(no2+reno))
         xintern(4)=xintern(4)/(xintern(2)*xintern(3))
         xintern(5)=xintern(5)/(xintern(1)*xintern(3))
         xintern(6)=xintern(6)/(xintern(1)*xintern(2))
c
c Displace NO distances
      do i=1,3
      xintern(i)=xintern(i)-le_ref
      enddo
      xintern(0)=xintern(0)-beta_ref ! planar = 0 for Eisfeld PES
c
c compute morse or tmc morse
      do i=1,3
         call ff(xintern(i),1,f)
         xintern(i)= 1.d0 - dexp(-f*xintern(i))
      enddo

c symmetrization
c
      qinter(1)=(xintern(1)+xintern(2)+xintern(3))*sq3
      qinter(2)=xintern(0)/rnoprod
      qinter(3)=(2.d0*xintern(1)-xintern(2)-xintern(3))*sq6
      qinter(4)=(xintern(2)-xintern(3))*sq2
      qinter(5)=(2.d0*xintern(4)-xintern(5)-xintern(6))*sq6
      qinter(6)=(xintern(5)-xintern(6))*sq2
c radial variable for damping in the trisector variable
      qinter(7)=rnodist/3.d0
c
      Return
      End

c A Viel 2012.07.13
c Version with iref=1 hard coded 
c
c fixing memory conflicts when threading
c ATTENTION limited to 32 threads (mx=32)
c
c iref proper usage included
c iref=0 second order
c iref=1 correction
c iref=2 everything at once
c
c generic functions needed for jt problems
c NO3 case
c TAKEN from genetic suite (W. Eisfeld)
c version -prec-
c 
c------------------------------------------------------------------------------
c returns exponent of tunable Morse coordinate
c exponent is polynomial * gaussian (skewed)
c ilabel = 1 or 2 selects the parameters a and sfac to be used
!      function f(x,ilabel)
c      function f(x,ii)
      subroutine ff(x,ii,f)

      implicit none
      integer ii,i, pn, nmax
      double precision x, r, f, gaus, poly, skew
      integer npoly(2)
      double precision a(20)

      common /tmc/a,npoly

! a(1):        position of equilibrium
! a(2):        constant of exponent
! a(3):        constant for skewing the gaussian
! a(4):        tuning for skewing the gaussian
! a(5):        Gaussian exponent
! a(6):        Shift of Gaussian maximum
! a(7)...:     polynomial coefficients
! a(8+n)...:   coefficients of Morse Power series

! Tunable Morse function
! Power series in Tunable Morse coordinates of order m
! exponent is polynomial of order npoly * gaussian + switching function


!.....set r  r-r_e
      r=x            !/0.529177d0
      r=r-a(1)

      a(2)=dabs(a(2))
      a(5)=dabs(a(5))

!..   set up skewing function:
      skew=0.5d0 * a(3) *(dtanh(dabs(a(4))*(r-a(6))) + 1.d0)

!..   set up gaussian function:
      gaus=dexp(-a(5)*(r)**2)

!..   set up power series:
      poly=0.d0
      do i=0,npoly(ii)-1
        poly=poly+a(7+i)*r**i
      enddo

!..   set up full exponent function:
      f=a(2)  + skew + gaus*poly

      end

!---------------------------------------------------------------------------------      
!     function to generate polynomial of any order 
 
!      function polynom(n, p, j, iref)
      subroutine Epolynom(polynom,n, p, j, iref)
      implicit none
      double precision polynom, p(*)
      integer n, i, j, fact, ii, jj, iref
      logical dbg

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

      polynom = 0.d0

c      if (iref.eq.0) then
c         ii=1
c         jj=2
c      elseif(iref.eq.1) then
         ii=3
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         polynom = polynom + pa(i,n) * p(i) 
      enddo

      end

!---------------------------------------------------------------------------------      
!     function to generate polynomial of even power  
 
!      function polynom2(n, p, j, iref)
      subroutine Epolynom2(polynom2,n, p, j, iref)
      implicit none
      double precision polynom2, p(*)
      integer n, i, j, fact, ii, jj, iref
      logical dbg

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee
      
      
      polynom2 = 0.d0
      
c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj 
         polynom2 = polynom2 + pb(i,n) * p(i) 
      enddo
      
      end

!---------------------------------------------------------------------------------      
!     function to generate V Jahn-Teller matrix elements up to 6th order   
     
!      function vjt6a(n, par, j, iref)
      subroutine Evjt6a(vjt6a,n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, ii, jj, iref
      parameter (lnx=6)
      double precision vjt6a, par(*), p(lnx), x, y 
      logical dbg

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj 
         p(i) = par(i)
      enddo

!.....
!     2nd order
      vjt6a = p(1) * va(1,n) 

!     3rd order
      vjt6a = vjt6a + (p(2) * va(2,n)) 

!     4th order
      vjt6a = vjt6a + (p(3) * va(3,n)) 

!     5th order
      vjt6a = vjt6a + (p(4) * va(4,n)) 

!     6th order
      vjt6a = vjt6a + (p(5) * va(5,n) + p(6) * va(6,n))  
     
      end
     
!---------------------------------------------------------------------------------      
!     function to generate V Jahn-Teller matrix elements up to 6th order   
     
!      function vjt6b(n, par, j, iref)
      subroutine Evjt6b(vjt6b, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, ii, jj, iref
      parameter (lnx=6)
      double precision vjt6b, par(*), p(lnx)
      logical dbg

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj 
         p(i) = par(i)
      enddo

!.....
!     2nd order
      vjt6b = p(1) * vb(1,n)   !/ fact(2)  

!     3rd order
      vjt6b = vjt6b + (p(2) * vb(2,n))   !/ fact(3)   

!     4th order
      vjt6b = vjt6b + (p(3) * vb(3,n))   !/ fact(4)  

!     5th order
      vjt6b = vjt6b + (p(4) * vb(4,n))   !/ fact(5)

!     6th order
      vjt6b = vjt6b + (p(5) * vb(5,n) + p(6) * vb(6,n))   !/ fact(6)
     
      end
     
!------------------------------------------------------------------------------      
!      function vcoup_ee(n, par, j, iref)
      subroutine Evcoup_ee(vcoup_ee, n, par, j, iref)
!     28 parameters

      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=28)
      double precision vcoup_ee, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj 
         p(i) = par(i)
      enddo

!.....
!     2nd order
      vcoup_ee = vee(1,n) * p(1)  !/ fact(2) 

!     3rd order
      vcoup_ee = vcoup_ee + (vee(2,n) * p(2) + vee(3,n) * p(3))  !/ fact(3)

!     4th order
      vcoup_ee = vcoup_ee + (vee(4,n) * p(4) + vee(5,n) * p(5) 
     $ + vee(6,n) * p(6) +  vee(7,n) * p(7))  !/ fact(4)

!     5th order
      vcoup_ee = vcoup_ee + p(8)*vee(8,n)+p(9)*vee(9,n)+p(10)*vee(10,n)        
     &          + p(11)*vee(11,n) + p(12)*vee(12,n) + p(13)*vee(13,n)          
     &          + p(14)*vee(14,n) + p(15)*vee(15,n)

!     6th order
      vcoup_ee = vcoup_ee + p(16)*vee(16,n) + p(17)*vee(17,n)                  
     & + p(18)*vee(18,n)+p(19)*vee(19,n)+p(20)*vee(20,n)+p(21)*vee(21,n)       
     & + p(22)*vee(22,n) + p(23)*vee(23,n) + p(24)*vee(24,n)                  
     & + p(25)*vee(25,n) + p(26)*vee(26,n) + p(27)*vee(27,n)                   
     & + p(28)*vee(28,n)

      end

!------------------------------------------------------------------------------      
!     function to generate V matrix elements for the coupling between e and a modes up to fourth order 
     
!      function vcoup_e1a(n, par, j, iref)
      subroutine Evcoup_e1a(vcoup_e1a, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=10)
      double precision vcoup_e1a, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         p(i) = par(i)
      enddo
!.....
!     3rd order
      vcoup_e1a =  (p(1)*pa(1,n)*va(1,n)) ! / fact(3)
 
!     4th order
      vcoup_e1a = vcoup_e1a+(p(2)*pa(1,n)*va(2,n)+p(3)*pa(2,n)*va(1,n)) ! / fact(4)

!     5th order
      vcoup_e1a = vcoup_e1a + (p(4)*pa(1,n)*va(3,n)+p(5)*pa(2,n)*va(2,n)        
     &        + p(6)*pa(3,n)*va(1,n))
     & ! /fact(5)

!     6th order
      vcoup_e1a= vcoup_e1a + p(7)*pa(1,n)*va(4,n) + p(8)*pa(2,n)*va(3,n)
     &        + p(9)*pa(3,n)*va(2,n) + p(10)*pa(4,n)*va(1,n)
      
      end   
      
!------------------------------------------------------------------------------      
!     function to generate V matrix elements for the coupling between e and a modes up to fourth order 
     
!      function vcoup_e2a(n, par, j, iref)
      subroutine Evcoup_e2a(vcoup_e2a, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=10)
      double precision vcoup_e2a, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj
         p(i) = par(i)
      enddo
!.....
!     3rd order
      vcoup_e2a =  (p(1)*pa(1,n)*vb(1,n)) ! / fact(3)
 
!     4th order
      vcoup_e2a = vcoup_e2a+(p(2)*pa(1,n)*vb(2,n)+p(3)*pa(2,n)*vb(1,n)) ! / fact(4)

!     5th order
      vcoup_e2a=vcoup_e2a + (p(4)*pa(1,n)*vb(3,n) + p(5)*pa(2,n)*vb(2,n)       
     &        + p(6)*pa(3,n)*vb(1,n))
     & ! /fact(5)

!     6th order
      vcoup_e2a= vcoup_e2a + p(7)*pa(1,n)*vb(4,n) + p(8)*pa(2,n)*vb(3,n)
     &        + p(9)*pa(3,n)*vb(2,n) + p(10)*pa(4,n)*vb(1,n)
      
      end   
      
!-------------------------------------------------------------------------------------
!     function to generate V matrix elements for the coupling between a1 and a2 modes up to sixth order 
!     only even orders in a2

!      function vcoup_aa(n, par, j, iref)
      subroutine Evcoup_aa(vcoup_aa, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=6)
      double precision vcoup_aa, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj
         p(i) = par(i)
      enddo
!.....

!..   third order
      vcoup_aa = p(1) * pa(1,n) * pb(1,n)

!..   fourth order
      vcoup_aa = vcoup_aa + p(2) * pa(2,n) * pb(1,n)

!..   fifth order
      vcoup_aa = vcoup_aa + p(3) * pa(1,n) * pb(2,n) 
     &                    + p(4) * pa(3,n) * pb(1,n)

!..   sixths order
      vcoup_aa = vcoup_aa + p(5) * pa(2,n) * pb(2,n)
     &                    + p(6) * pa(4,n) * pb(1,n)

      end

!------------------------------------------------------------------------------            
!     function to generate V matrix elements for the coupling between e and a modes up to sixth order 
!     only even orders in a

!      function vcoup_e1a2(n, par, j, iref)
      subroutine Evcoup_e1a2(vcoup_e1a2, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=9)
      double precision vcoup_e1a2, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif
c
      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     4th order
      vcoup_e1a2 = p(1)*pb(1,n)*va(1,n)

!     5th order
      vcoup_e1a2 = vcoup_e1a2 + p(2)*pb(1,n)*va(2,n)                          
     & ! /fact(5)

!     6th order
      vcoup_e1a2 = vcoup_e1a2 + p(3)*pb(1,n)*va(3,n)                           
     &                    + p(4)*pb(2,n)*va(1,n)

!     7th order
      vcoup_e1a2 = vcoup_e1a2 + p(5)*pb(1,n)*va(4,n)                           
     &                      + p(6)*pb(2,n)*va(2,n)

!     8th order
      vcoup_e1a2 = vcoup_e1a2 + p(7)*pb(1,n)*va(5,n)                          
     &                      + p(8)*pb(1,n)*va(6,n)                           
     &                      + p(9)*pb(2,n)*va(3,n)

      end

!------------------------------------------------------------------------------            
!     function to generate V matrix elements for the coupling between e and a modes up to sixth order 
!     only even orders in a

!      function vcoup_e2a2(n, par, j, iref)
      subroutine Evcoup_e2a2(vcoup_e2a2, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=9)
      double precision vcoup_e2a2, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif

      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     4th order
      vcoup_e2a2 = p(1)*pb(1,n)*vb(1,n)

!     5th order
      vcoup_e2a2 = vcoup_e2a2 + p(2)*pb(1,n)*vb(2,n)                        
     & ! /fact(5)

!     6th order
      vcoup_e2a2 = vcoup_e2a2 + p(3)*pb(1,n)*vb(3,n)                       
     &                    + p(4)*pb(2,n)*vb(1,n)

!     7th order
      vcoup_e2a2 = vcoup_e2a2 + p(5)*pb(1,n)*vb(4,n)                      
     &                      + p(6)*pb(2,n)*vb(2,n)

!     8th order
      vcoup_e2a2 = vcoup_e2a2 + p(7)*pb(1,n)*vb(5,n)                      
     &                      + p(8)*pb(1,n)*vb(6,n)                          
     &                      + p(9)*pb(2,n)*vb(3,n)

      end

!-------------------------------------------------------------------------------------
!  3-mode coupling of a1 + e + e
!      function vcoup_eea1(n, par, j, iref)
      subroutine Evcoup_eea1(vcoup_eea1, n, par, j, iref)
!     26 parameters

      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=26)
      double precision vcoup_eea1, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     3rd order
      vcoup_eea1 = p(1) * pa(1,n) * vee(1,n)

!     4th order
      vcoup_eea1=vcoup_eea1 + pa(1,n) * (p(2)*vee(2,n) + p(3)*vee(3,n))
      vcoup_eea1=vcoup_eea1 + p(4) * pa(2,n) * vee(1,n)

!     5th order
      vcoup_eea1 = vcoup_eea1 + pa(1,n)*(p(5)*vee(4,n) + p(6)*vee(5,n)        
     &                        + p(7)*vee(6,n) + p(8)*vee(7,n))
     & +pa(2,n)*(p(9)*vee(2,n)+ p(10)*vee(3,n)) + pa(3,n)*p(11)*vee(1,n)

!     6th order
      vcoup_eea1=vcoup_eea1 + pa(2,n) * (p(12)*vee(4,n) + p(13)*vee(5,n)     
     &                        + p(14)*vee(6,n) + p(15)*vee(7,n)) 
     & +pa(3,n)*(p(16)*vee(2,n)+p(17)*vee(3,n)) + pa(4,n)*p(18)*vee(1,n)

!................................................................................
! order not logical because added later!
      vcoup_eea1 = vcoup_eea1 + pa(1,n)*(p(19)*vee(8,n)+p(20)*vee(9,n)      
     & +p(21)*vee(10,n) +p(22)*vee(11,n)+p(23)*vee(12,n)+p(24)*vee(13,n)    
     & +p(25)*vee(14,n) +p(26)*vee(15,n) )

      end

!------------------------------------------------------------------------------      
!  3-mode coupling
!      function vcoup_eea2(n, par, j, iref)
      subroutine Evcoup_eea2(vcoup_eea2, n, par, j, iref)
!     7 parameters

      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=8)
      double precision vcoup_eea2, par(*), p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     4th order
      vcoup_eea2 = p(1) * pb(1,n) * vee(1,n)

!     5th order
      vcoup_eea2 = vcoup_eea2 + pb(1,n)*(vee(2,n)*p(2)+vee(3,n)*p(3)) 

!     6th order
      vcoup_eea2 = vcoup_eea2 + p(4) * pb(2,n) * vee(1,n)
     & + pb(1,n) * (vee(4,n) * p(5) + vee(5,n) * p(6)                     
     & + vee(6,n) * p(7) +  vee(7,n) * p(8))

      end

!------------------------------------------------------------------------------      
!     function to generate V matrix elements for the coupling between e and a modes up to fourth order 
     
!      function vcoup_e1aa2(n, par, j, iref)
      subroutine Evcoup_e1aa2(vcoup_e1aa2, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=3)
      double precision vcoup_e1aa2, par(*), y, p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     5th order
      vcoup_e1aa2 =  (p(1) * pa(1,n) * pb(1,n) * va(1,n))
 
!     6th order
      vcoup_e1aa2 = vcoup_e1aa2 + (p(2)*pa(1,n)*pb(1,n)*va(2,n) 
     &            + p(3)*pa(2,n)*pb(1,n)*va(1,n))

      end   
      
!------------------------------------------------------------------------------      
!     function to generate V matrix elements for the coupling between e and a modes up to fourth order 
     
!      function vcoup_e2aa2(n, par, j, iref)
      subroutine Evcoup_e2aa2(vcoup_e2aa2, n, par, j, iref)
      implicit none
      integer n, i, lnx, j, fact, iref, ii, jj
      parameter (lnx=3)
      double precision vcoup_e2aa2, par(*), y, p(lnx)

      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

!.....copy parameters to local ones to account for shorter than max. expansions
      do i = 1, lnx
         p(i) = 0.d0
      enddo

c      if (iref.eq.0) then
c         ii=1
c         jj=1
c      elseif(iref.eq.1) then
         ii=2
         jj=j
c      elseif (iref.eq.2) then
c         ii=1
c         jj=j
c      else
c        Write(6,*)"Incorrect iref",iref
c      endif


      do i = ii, jj
         p(i) = par(i)
      enddo

!.....
!     5th order
      vcoup_e2aa2 =  (p(1) * pa(1,n) * pb(1,n) * vb(1,n))
 
!     6th order
      vcoup_e2aa2 = vcoup_e2aa2 + (p(2)*pa(1,n)*pb(1,n)*vb(2,n) 
     &            + p(3)*pa(2,n)*pb(1,n)*vb(1,n))

      end   
      
!-------------------------------------------------------------------------------------

      subroutine vwzprec(n,q)
      implicit none


      integer mx
      parameter (mx=32)
      double precision pa(8,mx), pb(4,mx)
      double precision va(6,mx), vb(6,mx)
      double precision wa(9,mx), wb(9,mx), za(9,mx), zb(9,mx)
      double precision vee(28,mx),  wee(49,mx), zee(49,mx)

      common /acoord/ pa,pb
      common /vjt/ va, vb, wa, wb, za, zb
      common /vee/ vee,  wee, zee

      integer n,j
      double precision q(6), a, b, x3, x4, y3, y4

      a=q(1)
      b=q(2)
      x3=q(3)
      y3=q(4)
      x4=q(5)
      y4=q(6)

!     compute powers of a1 mode:
      pa(1,n) = a
      pa(2,n) = a**2
      pa(3,n) = a**3
      pa(4,n) = a**4
      pa(5,n) = a**5
      pa(6,n) = a**6
      pa(7,n) = a**7
      pa(8,n) = a**8

!     compute powers of a2 mode:
      pb(1,n) = b**2
      pb(2,n) = b**4
      pb(3,n) = b**6
      pb(4,n) = b**8

!..   compute vjt terms for first e set:
      va(1,n) = x3**2 + y3**2
      va(2,n) = 2.d0 * x3**3 - 6.d0 * x3 * y3**2
      va(3,n) = x3**4 + 2.d0 * x3**2 * y3**2 + y3**4
      va(4,n) = 2.d0 * x3**5 - 4.d0 * x3**3 * y3**2 - 6.d0 * x3 * y3**4
      va(5,n) = 2.d0 * x3**6 - 30.d0*x3**4*y3**2 + 30.d0*x3**2*y3**4
     &   -2.d0 * y3**6
      va(6,n) = x3**6 + 3.d0 * x3**4 * y3**2 + 3.d0 * x3**2 * y3**4
     &   + y3**6

!..   compute vjt terms for second e set:
      vb(1,n) = x4**2 + y4**2
      vb(2,n) = 2.d0 * x4**3 - 6.d0 * x4 * y4**2
      vb(3,n) = x4**4 + 2.d0 * x4**2 * y4**2 + y4**4
      vb(4,n) = 2.d0 * x4**5 - 4.d0 * x4**3 * y4**2 - 6.d0 * x4 * y4**4
      vb(5,n) = 2.d0 * x4**6 - 30.d0*x4**4*y4**2 + 30.d0*x4**2*y4**4
     &   -2.d0 * y4**6
      vb(6,n) = x4**6 + 3.d0 * x4**4 * y4**2 + 3.d0 * x4**2 * y4**4
     &   + y4**6

!..   compute wjt terms for first e set:
      wa(1,n) = x3
      wa(2,n) = x3**2 - y3**2
      wa(3,n) = x3**3 + x3*y3**2
      wa(4,n) = x3**4 - 6.d0 * x3**2 * y3**2 + y3**4
      wa(5,n) = x3**4 - y3**4
      wa(6,n) = x3**5 - 10.d0 * x3**3 * y3**2 + 5.d0 * x3 * y3**4
      wa(7,n) = x3**5 + 2.d0 * x3**3 * y3**2 + x3 * y3**4
      wa(8,n) = x3**6 - 5.d0 * x3**4 * y3**2 - 5.d0 * x3**2*y3**4+y3**6
      wa(9,n) = x3**6 + x3**4 * y3**2 - x3**2 * y3**4 - y3**6

!..   compute wjt terms for second e set:
      wb(1,n) = x4
      wb(2,n) = x4**2 - y4**2
      wb(3,n) = x4**3 + x4*y4**2
      wb(4,n) = x4**4 - 6.d0 * x4**2 * y4**2 + y4**4
      wb(5,n) = x4**4 - y4**4
      wb(6,n) = x4**5 - 10.d0 * x4**3 * y4**2 + 5.d0 * x4 * y4**4
      wb(7,n) = x4**5 + 2.d0 * x4**3 * y4**2 + x4 * y4**4
      wb(8,n) = x4**6 - 5.d0 * x4**4 * y4**2 - 5.d0 * x4**2*y4**4+y4**6
      wb(9,n) = x4**6 + x4**4 * y4**2 - x4**2 * y4**4 - y4**6

!..   compute zjt terms for first e set:
      za(1,n) = y3
      za(2,n) = -2.d0*x3*y3
      za(3,n) = y3**3 + y3*x3**2
      za(4,n) = 4.d0*x3**3*y3 - 4.d0*x3*y3**3
      za(5,n) = -2.d0*x3**3*y3 - 2.d0*x3*y3**3
      za(6,n) = -5.d0*x3**4*y3 + 10.d0*x3**2*y3**3 - y3**5
      za(7,n) =  x3**4*y3 + 2.d0*x3**2*y3**3 + y3**5
      za(8,n) = 4.d0*x3**5*y3 - 4.d0*x3*y3**5
      za(9,n) = -2.d0*x3**5*y3 - 4.d0*x3**3*y3**3 - 2.d0*x3*y3**5

!..   compute zjt terms for second e set:
      zb(1,n) = y4
      zb(2,n) = -2.d0*x4*y4
      zb(3,n) = y4**3 + y4*x4**2
      zb(4,n) = 4.d0*x4**3*y4 - 4.d0*x4*y4**3
      zb(5,n) = -2.d0*x4**3*y4 - 2.d0*x4*y4**3
      zb(6,n) = -5.d0*x4**4*y4 + 10.d0*x4**2*y4**3 - y4**5
      zb(7,n) =  x4**4*y4 + 2.d0*x4**2*y4**3 + y4**5
      zb(8,n) = 4.d0*x4**5*y4 - 4.d0*x4*y4**5
      zb(9,n) = -2.d0*x4**5*y4 - 4.d0*x4**3*y4**3 - 2.d0*x4*y4**5

!..   compute Vcoup_ee terms:
      vee(1,n) =  2.d0*x3*x4 + 2.d0*y3*y4
      vee(2,n) = 2.d0*x3*x4**2 - 2.d0*x3*y4**2 - 4.d0*x4*y3*y4
      vee(3,n) = 2.d0*x3**2*x4 - 2.d0*x4*y3**2 - 4.d0*x3*y3*y4
      vee(4,n) = 2.d0*x3**2*x4**2 - 2.d0*x3**2*y4**2                        
     &          - 2.d0*x4**2*y3**2 + 2.d0*y3**2*y4**2                       
     &          + 8.d0*x3*x4*y3*y4
      vee(5,n) = 2.d0*x3**3*x4 + 2.d0*x3**2*y3*y4                           
     &          + 2.d0*x3*x4*y3**2 + 2.d0*y3**3*y4
      vee(6,n) = 2.d0*x4**3*x3 + 2.d0*x3*x4*y4**2                           
     &         + 2.d0*x4**2*y3*y4 + 2.d0*y4**3*y3
      vee(7,n) = x3**2*x4**2 + x3**2*y4**2                                  
     &          + x4**2*y3**2 + y3**2*y4**2

      vee(8,n) = x3*y4**4-4*x4*y3*y4**3-6*x3*x4**2*y4**2+4*x4**3*y3*y4      
     &          +x3*x4**4
      vee(9,n) = (y4**2+x4**2)*(x3*y4**2+2*x4*y3*y4-x3*x4**2)
      vee(10,n) = (y3**2+x3**2)*(x3*y4**2+2*x4*y3*y4-x3*x4**2)
      vee(11,n) = x4*(y3**2+x3**2)*(3.d0*y4**2-x4**2)
      vee(12,n) = (2.d0*x3*y3*y4+x4*y3**2-x3**2*x4)*(y4**2+x4**2)
      vee(13,n) = x3*(3.d0*y3**2-x3**2)*(y4**2+x4**2)
      vee(14,n) = 4.d0*x3*y3**3*y4-4.d0*x3**3*y3*y4-x4*y3**4                
     &          +6.d0*x3**2*x4*y3**2-x3**4*x4
      vee(15,n) = (y3**2+x3**2)*(2.d0*x3*y3*y4+x4*y3**2-x3**2*x4)


      vee(16,n) = (y3*y4**5-5.d0*x3*x4*y4**4-10.d0*x4**2*y3*y4**3           
     &          +10.d0*x3*x4**3*y4**2+5.d0*x4**4*y3*y4-x3*x4**5)
      vee(17,n) = (y3*y4**2-x3*y4**2-2.d0*x4*y3*y4-2.d0*x3*x4*y4            
     &          -x4**2*y3+x3*x4**2)*(y3*y4**2+x3*y4**2+2.d0*x4*y3*y4       
     &          -2.d0*x3*x4*y4-x4**2*y3-x3*x4**2)
      vee(18,n) = (y3*y4-x3*x4)*(y3**2*y4**2-3.d0*x3**2*y4**2              
     &          -8.d0*x3*x4*y3*y4-3.d0*x4**2*y3**2+x3**2*x4**2)
      vee(19,n) = (y3**2*y4-2.d0*x3*y3*y4-x3**2*y4-x4*y3**2                
     &          -2.d0*x3*x4*y3+x3**2*x4)*(y3**2*y4+2.d0*x3*y3*y4           
     &          -x3**2*y4+x4*y3**2-2.d0*x3*x4*y3-x3**2*x4)
      vee(20,n) = (y3**5*y4-10.d0*x3**2*y3**3*y4+5.d0*x3**4*y3*y4          
     &          -5.d0*x3*x4*y3**4+10.d0*x3**3*x4*y3**2-x3**5*x4)

      vee(21,n) = (y3*y4+x3*x4)*(y4**2+x4**2)**2
      vee(22,n) = (y3*y4-x3*y4+x4*y3+x3*x4)*(y3*y4+x3*y4                   
     &          -x4*y3+x3*x4)*(y4**2+x4**2)
      vee(23,n) = (y3**2+x3**2)*(y4**2+x4**2)**2
      vee(24,n) = (y3*y4+x3*x4)*(y3**2*y4**2-3.d0*x3**2*y4**2              
     &          +8.d0*x3*x4*y3*y4-3.d0*x4**2*y3**2+x3**2*x4**2)
      vee(25,n) = (y3**2+x3**2)*(y3*y4+x3*x4)*(y4**2+x4**2)
      vee(26,n) = (y3**2+x3**2)*(y3*y4-x3*y4+x4*y3+x3*x4)                  
     &          *(y3*y4+x3*y4-x4*y3+x3*x4)
      vee(27,n) = (y3**2+x3**2)**2*(y4**2+x4**2)
      vee(28,n) = (y3**2+x3**2)**2*(y3*y4+x3*x4)

!..   compute Wcoup_ee terms:
      wee(1,n) = x3 * x4 - y3 * y4
      wee(2,n) = x3**2 * x4 + x4 * y3**2
      wee(3,n) = x3 * y4**2 + x3 * x4**2
      wee(4,n) = 2.d0 * x3 * y3 * y4 + x3**2 * x4 - x4 * y3**2
      wee(5,n) = x3 * x4**2 + 2.d0 * x4 * y3*y4 - x3 * y4**2
      wee(6,n) = x3**3 * x4 - 3.d0 * x3**2 *y3*y4                              
     &            - 3.d0*x3*x4*y3**2 + y3**3*y4
      wee(7,n) = x3**2*x4**2 - x3**2*y4**2 - x4**2*y3**2 + y3**2*y4**2         
     & - 4.d0*x3*x4*y3*y4
      wee(8,n) =x4**3*x3 - 3.d0*x3*x4*y4**2 - 3.d0*x4**2*y3*y4+y4**3*y3
!               wee44(9,n) =x3**3*x4 - 3.d0*x3**2*y3*y4 -3.d0*x3*x4*y3**2-y3**3*y4
      wee(9,n) =x3**3*x4 + 3.d0*x3**2*y3*y4 - 3.d0*x3*x4*y3**2-y3**3*y4
!               wee45(10,n) =x4**3*x3 - 3.d0*x3*x4*y4**2 - 3.d0*x4**2*y3*y4-y4**3*y3
      wee(10,n) =x4**3*x3 - 3.d0*x3*x4*y4**2 + 3.d0*x4**2*y3*y4-y4**3*y3
      wee(11,n) = x3**3*x4 - x3**2*y3*y4 + x3*x4*y3**2 - y3**3*y4
      wee(12,n) = x3**2*x4**2 + x3**2*y4**2 - x4**2*y3**2 - y3**2*y4**2
      wee(13,n) = x3**2*x4**2 - x3**2*y4**2 + x4**2*y3**2 - y3**2*y4**2
      wee(14,n) = x3*x4**3 + x3*x4*y4**2 - x4**2*y3*y4 - y4**3*y3

      wee(15,n) = (x3*y4**4+4.d0*x4*y3*y4**3-6.d0*x3*x4**2*y4**2                
     &          -4.d0*x4**3*y3*y4+x3*x4**4)
      wee(16,n) = (2.d0*x3*y3*y4**3+3.d0*x4*y3**2*y4**2                        
     & -3.d0*x3**2*x4*y4**2-6.d0*x3*x4**2*y3*y4-x4**3*y3**2+x3**2*x4**3)
      wee(17,n) = (3.d0*x3*y3**2*y4**2-x3**3*y4**2+2.d0*x4*y3**3*y4
     &          -6.d0*x3**2*x4*y3*y4-3.d0*x3*x4**2*y3**2+x3**3*x4**2)
      wee(18,n) = (4.d0*x3*y3**3*y4-4.d0*x3**3*y3*y4+x4*y3**4                 
     &          -6.d0*x3**2*x4*y3**2+x3**4*x4)

      wee(19,n) = -(y4**2+x4**2)*(x3*y4**2-2.d0*x4*y3*y4-x3*x4**2)
      wee(20,n) = x3*(y4**2+x4**2)**2
      wee(21,n) = -(2.d0*x3*y3*y4**3-3.d0*x4*y3**2*y4**2+3.d0*x3**2           
     &          *x4*y4**2-6.d0*x3*x4**2*y3*y4+x4**3*y3**2-x3**2*x4**3)
      wee(22,n) = x4*(y3**2+x3**2)*(y4**2+x4**2)
      wee(23,n) = -(y3**2+x3**2)*(x3*y4**2-2.d0*x4*y3*y4-x3*x4**2)
      wee(24,n) = x3*(y3**2+x3**2)*(y4**2+x4**2)
      wee(25,n) = x4*(y3**2+x3**2)**2
      wee(26,n) = (y3**2+x3**2)*(2.d0*x3*y3*y4-x4*y3**2+x3**2*x4)

      wee(27,n) = (y3*y4**5+5.d0*x3*x4*y4**4-10.d0*x4**2*y3*y4**3               
     &    -10.d0*x3*x4**3*y4**2+5.d0*x4**4*y3*y4+x3*x4**5)
      wee(28,n) = (y4**2+x4**2)*(y3*y4**3-3.d0*x3*x4*y4**2                      
     &    -3.d0*x4**2*y3*y4+x3*x4**3)
      wee(29,n) = (y3**2+x3**2)*(y4**2-2.d0*x4*y4-x4**2)                        
     &    *(y4**2+2.d0*x4*y4-x4**2)
      wee(30,n) = (y3*y4-x3*y4-x4*y3-x3*x4)*(y3*y4+x3*y4                        
     &    +x4*y3-x3*x4)*(y4**2+x4**2)
      wee(31,n) = (y3**2+x3**2)*(y3*y4**3-3.d0*x3*x4*y4**2                      
     &    -3.d0*x4**2*y3*y4+x3*x4**3)
      wee(32,n) = (y3**3*y4-3.d0*x3**2*y3*y4-3.d0*x3*x4*y3**2+x3**3*x4)         
     &    *(y4**2+x4**2)
      wee(33,n) = (y3**2+x3**2)*(y3*y4-x3*y4-x4*y3-x3*x4)                       
     &    *(y3*y4+x3*y4+x4*y3-x3*x4)
      wee(34,n) = (y3**2-2.d0*x3*y3-x3**2)*(y3**2+2.d0*x3*y3-x3**2)             
     &    *(y4**2+x4**2)
      wee(35,n) = (y3**2+x3**2)*(y3**3*y4-3.d0*x3**2*y3*y4                      
     &    -3.d0*x3*x4*y3**2+x3**3*x4)
      wee(36,n)= (y3**5*y4-10.d0*x3**2*y3**3*y4+5.d0*x3**4*y3*y4               
     &    +5.d0*x3*x4*y3**4-10.d0*x3**3*x4*y3**2+x3**5*x4)

      wee(37,n) = (y3*y4-x3*x4)*(y4**2+x4**2)**2
      wee(38,n) = (y4**2+x4**2)*(y3*y4**3+3.d0*x3*x4*y4**2                     
     &    -3.d0*x4**2*y3*y4-x3*x4**3)
      wee(39,n) = (y3**2+x3**2)*(y4-x4)*(y4+x4)*(y4**2+x4**2)
      wee(40,n) = (y3-x3)*(y3+x3)*(y4**2+x4**2)**2
      wee(41,n) = (y3*y4**2-x3*y4**2+2.d0*x4*y3*y4+2.d0*x3*x4*y4               
     &    -x4**2*y3+x3*x4**2)*(y3*y4**2+x3*y4**2-2.d0*x4*y3*y4                 
     &    +2.d0*x3*x4*y4-x4**2*y3-x3*x4**2)
      wee(42,n) = (y3**3*y4-3.d0*x3**2*y3*y4+3.d0*x3*x4*y3**2-x3**3*x4)        
     &    *(y4**2+x4**2)
      wee(43,n) = (y3**2+x3**2)*(y3*y4-x3*x4)*(y4**2+x4**2)
      wee(44,n) = (y3**2+x3**2)*(y3*y4**3+3.d0*x3*x4*y4**2                     
     &    -3.d0*x4**2*y3*y4-x3*x4**3)
      wee(45,n) = (y3**2*y4-2.d0*x3*y3*y4-x3**2*y4+x4*y3**2                    
     &    +2.d0*x3*x4*y3-x3**2*x4)*(y3**2*y4+2.d0*x3*y3*y4-x3**2*y4            
     &    -x4*y3**2+2.d0*x3*x4*y3+x3**2*x4)
      wee(46,n) = (y3-x3)*(y3+x3)*(y3**2+x3**2)*(y4**2+x4**2)
      wee(47,n) = (y3**2+x3**2)**2*(y4-x4)*(y4+x4)
      wee(48,n) = (y3**2+x3**2)*(y3**3*y4-3.d0*x3**2*y3*y4                     
     &    +3.d0*x3*x4*y3**2-x3**3*x4)
      wee(49,n) = (y3**2+x3**2)**2*(y3*y4-x3*x4)

!..   compute Zcoup_ee terms:
      zee(1,n) = -x3*y4 - x4*y3

      zee(2,n) = y3**2*y4 + x3**2*y4
      zee(3,n) = y3*y4**2 + x4**2*y3
      zee(4,n) = y3**2*y4 + 2.d0*x3*x4*y3 - x3**2*y4
      zee(5,n) = y4**2*y3 + 2.d0*x3*x4*y4 - x4**2*y3

      zee(6,n) = x3**3*y4 + 3.d0*x3**2*x4*y3                                  
     &          - 3.d0*x3*y3**2*y4 - x4*y3**3
      zee(7,n) = 2.d0*x3**2*x4*y4 + 2.d0*x3*x4**2*y3 - 2.d0*x3*y3*y4**2      
     & - 2.d0*x4*y3**2*y4
      zee(8,n) =x4**3*y3 +3.d0*x3*x4**2*y4 - 3.d0*x4*y3*y4**2 - x3*y4**3
      zee(9,n) =x3**3*y4 -3.d0*x3**2*x4*y3 - 3.d0*x3*y3**2*y4 + x4*y3**3
      zee(10,n)=x4**3*y3 -3.d0*x3*x4**2*y4 - 3.d0*x4*y3*y4**2 + x3*y4**3
      zee(11,n) = - x3**3*y4 - x3**2*x4*y3 - x3*y3**2*y4 - x4*y3**3
      zee(12,n) = - 2.d0*x3*x4**2*y3 - 2.d0*x3*y3*y4**2
      zee(13,n) = - 2.d0*x3**2*x4*y4 - 2.d0*x4*y3**2*y4
      zee(14,n) = - y4**3*x3 - x3*x4**2*y4 - x4*y3*y4**2 - y3*x4**3

      zee(15,n) = -(y3*y4**4-4.d0*x3*x4*y4**3-6.d0*x4**2*y3*y4**2           
     &           +4.d0*x3*x4**3*y4+x4**4*y3)
      zee(16,n) = -(y3**2*y4**3-x3**2*y4**3-6.d0*x3*x4*y3*y4**2            
     &     -3.d0*x4**2*y3**2*y4+3.d0*x3**2*x4**2*y4+2.d0*x3*x4**3*y3)
      zee(17,n) = -(y3**3*y4**2-3.d0*x3**2*y3*y4**2-6.d0*x3*x4*y3**2*y4       
     &           +2.d0*x3**3*x4*y4-x4**2*y3**3+3.d0*x3**2*x4**2*y3)
      zee(18,n)=-(y3**4*y4-6.d0*x3**2*y3**2*y4+x3**4*y4-4.d0*x3*x4*y3**3      
     &           +4.d0*x3**3*x4*y3)

      zee(19,n) = (y4**2+x4**2)*(y3*y4**2+2.d0*x3*x4*y4-x4**2*y3)
      zee(20,n) = y3*(y4**2+x4**2)**2
      zee(21,n) = (y3**2*y4**3-x3**2*y4**3+6.d0*x3*x4*y3*y4**2                
     &     -3.d0*x4**2*y3**2*y4+3.d0*x3**2*x4**2*y4-2.d0*x3*x4**3*y3)
      zee(22,n) = (y3**2+x3**2)*y4*(y4**2+x4**2)
      zee(23,n) = (y3**2+x3**2)*(y3*y4**2+2.d0*x3*x4*y4-x4**2*y3)
      zee(24,n) = y3*(y3**2+x3**2)*(y4**2+x4**2)
      zee(25,n) = (y3**2+x3**2)**2*y4
      zee(26,n) = (y3**2+x3**2)*(y3**2*y4-x3**2*y4+2.d0*x3*x4*y3)

      zee(27,n) = (x3*y4**5-5.d0*x4*y3*y4**4-10.d0*x3*x4**2*y4**3               
     &   +10.d0*x4**3*y3*y4**2+5.d0*x3*x4**4*y4-x4**5*y3)
      zee(28,n) = -(y4**2+x4**2)*(x3*y4**3+3.d0*x4*y3*y4**2                     
     &   -3.d0*x3*x4**2*y4-x4**3*y3)
      zee(29,n) = -4.d0*x4*(y3**2+x3**2)*y4*(y4-x4)*(y4+x4)
      zee(30,n) = -2.d0*(x3*y4+x4*y3)*(y3*y4-x3*x4)*(y4**2+x4**2)
      zee(31,n) = -(y3**2+x3**2)*(x3*y4**3+3.d0*x4*y3*y4**2                     
     &   -3.d0*x3*x4**2*y4-x4**3*y3)
      zee(32,n) = -(3.d0*x3*y3**2*y4-x3**3*y4+x4*y3**3                          
     &   -3.d0*x3**2*x4*y3)*(y4**2+x4**2)
      zee(33,n) = -2.d0*(y3**2+x3**2)*(x3*y4+x4*y3)*(y3*y4-x3*x4)
      zee(34,n) = -4.d0*x3*y3*(y3-x3)*(y3+x3)*(y4**2+x4**2)
      zee(35,n) = -(y3**2+x3**2)*(3.d0*x3*y3**2*y4-x3**3*y4+x4*y3**3            
     &   -3.d0*x3**2*x4*y3)
      zee(36,n)= -(5.d0*x3*y3**4*y4-10.d0*x3**3*y3**2*y4+x3**5*y4              
     &   -x4*y3**5+10.d0*x3**2*x4*y3**3-5.d0*x3**4*x4*y3)


      zee(37,n) = (x3*y4+x4*y3)*(y4**2+x4**2)**2
      zee(38,n) = -(y4**2+x4**2)*(x3*y4**3-3.d0*x4*y3*y4**2                    
     &   -3.d0*x3*x4**2*y4+x4**3*y3)
      zee(39,n) = 2.d0*x3*y3*(y4**2+x4**2)**2
      zee(40,n) = 2.d0*x4*(y3**2+x3**2)*y4*(y4**2+x4**2)
      zee(41,n) = -2.d0*(x3*y4**2-2.d0*x4*y3*y4-x3*x4**2)
     &   *(y3*y4**2+2.d0*x3*x4*y4-x4**2*y3)
      zee(42,n) = (3.d0*x3*y3**2*y4-x3**3*y4-x4*y3**3+3.d0*x3**2*x4*y3)        
     &   *(y4**2+x4**2)
      zee(43,n) = (y3**2+x3**2)*(x3*y4+x4*y3)*(y4**2+x4**2)
      zee(44,n) = -(y3**2+x3**2)*(x3*y4**3-3.d0*x4*y3*y4**2                    
     &   -3.d0*x3*x4**2*y4+x4**3*y3)
      zee(45,n) = 2.d0*(2.d0*x3*y3*y4-x4*y3**2+x3**2*x4)                       
     &   *(y3**2*y4-x3**2*y4+2.d0*x3*x4*y3)
      zee(46,n) = 2.d0*x3*y3*(y3**2+x3**2)*(y4**2+x4**2)
      zee(47,n) = 2.d0*x4*(y3**2+x3**2)**2*y4
      zee(48,n) = (y3**2+x3**2)*(3.d0*x3*y3**2*y4-x3**3*y4-x4*y3**3            
     &   +3.d0*x3**2*x4*y3)
      zee(49,n) = (y3**2+x3**2)**2*(x3*y4+x4*y3)

      end

c------------------------------------------------------------------------------
c AViel 2013.09.06 putting back the working arrays
C      subroutine rs(nm,n,a,w,matz,z,fv1,fv2,ierr)
c      subroutine rs(nm,n,a,w,matz,z)
c
C      integer n,nm,ierr,matz
C      double precision a(nm,n),w(n),z(nm,n),fv1(n),fv2(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real symmetric matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real symmetric matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        w  contains the eigenvalues in ascending order.
c
c        z  contains the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for tqlrat
c           and tql2.  the normal completion code is zero.
c
c        fv1  and  fv2  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
C      if (n .le. nm) go to 10
C      ierr = 10 * n
C      go to 50
c
C   10 if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
C      call  tred1(nm,n,a,w,fv1,fv2)
*  tqlrat encounters catastrophic underflow on the Vax
*     call  tqlrat(n,w,fv2,ierr)
C      call  tql1(n,w,fv1,ierr)
C      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
C   20 call  tred2(nm,n,a,w,fv1,z)
C      call  tql2(nm,n,w,fv1,z,ierr)
C   50 return
C      end

c------------------------------------------------------------------------------
