#!/usr/bin/perl
# Reads a file that contains "blocks" and outputs a file that
# contains these blocks multiple times.
# A block starts with two lines beginning with `#' and ends with
# a line containing a single `e'.

sub usage() {
    $name = `basename $0`;
    chomp $name;
    print "Usage: $name N <infile >outfile\n";
    exit 1
}

$times = shift or usage();

$inblock = 0;
@lines = ();
while (<>) {
    if ($inblock) {
        # look for block end
        if (/^e$/) {
            # yup; reset flags and counters
            $inblock = 0;
            # print block N times
            # TODO header, footer?
            print $save;
            for ($i=1; $i<=$times; $i++) {
                print @lines;
                print "e\n";
            }
            # discard block
            @lines = ();
        } else {
            # save line for later
            push @lines, $_;
        }
    } else {
        # look for block start
        if (/^#/) {
            $save = $_;
            # look at next line
            if (($x = <>) =~ /^#/) {
                # block has started
                $save .= $x;
                $inblock=1;
            }
        }
    }
}
