#! /usr/bin/env python
import sys
import numpy as np
from math import *
from os import system

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False
#READS MOLPRO ORBITAL/OVERLAP FILES
def E2E(num):
  expp = abs(int('{0:29.20e}'.format(num).strip().split('e')[1])+1)
  pom = '{0:29.20e}'.format(num).strip().split('e')[1][0]
  arg = '{0:26.20f}'.format(float('{0:29.20e}'.format(num).strip().split('e')[0])/10.0)
  return arg + 'E'+pom + str(expp).zfill(3);

def loadvecs(filenam,methstr):
 dim = 0
 fil = file(filenam,'r').readlines()
 for ln in [ ff for ff in fil if methstr in ff ]:
   if is_number(ln.split(methstr)[1].split()[0]):
    if int(ln.split(methstr)[1].split()[0].split('.')[0]) > dim:
     dim = int(ln.split(methstr)[1].split()[0].split('.')[0])
 civecs = [[] for i in range(0,dim)]
 bidx = fil.index([ ff for ff in fil if 'N' not in ff and 'M' not in ff and '*' not in ff ][0])
 rlen = len(fil[bidx].split()[0]) + 6
 cii = 0
 for ln in fil[bidx:]:
  if '---' in ln or 'M' in ln:
   break
  if len(ln[:rlen].strip()) > 0:
   si = 0
  for it in ln[rlen:].split():
    civecs[si].append(float(it.strip()))
    si += 1
 return civecs 

def loadordvecs(filenam,orda,methstr):
 dim = 0
 fil = file(filenam,'r').readlines()
 for ln in [ ff for ff in fil if methstr in ff ]:
   if is_number(ln.split(methstr)[1].split()[0]):
    if int(ln.split(methstr)[1].split()[0].split('.')[0]) > dim:
     dim = int(ln.split(methstr)[1].split()[0].split('.')[0])
 bidx = fil.index([ff for ff in fil if 'N' not in ff and 'M' not in ff and '*' not in ff ][0])
 rlen = len(fil[bidx].split()[0]) + 6
 cii = 0
 vic = {}
 for ln in fil[bidx:]:
  if '---' in ln or 'M' in ln:
   break
  if len(ln[:rlen].strip()) > 0:
   ci = ln.split()[0]
   vic[ci] = []
   cii += 1
  for it in ln[rlen:].split():
    vic[ci].append(float(it.strip()))
 dim = len(vic[ci])
 civecs = [[] for i in range(0,dim)]
 for si in range(0,dim):
  for ky in orda:
   civecs[si].append( vic[ky][si] )
 return civecs 

def get_ref_ci_order(filenam):
 cior = []
 fil = file(filenam,'r').readlines()
 bidx = fil.index([ ff for ff in fil if 'N' not in ff and 'M' not in ff and '*' not in ff ][0])
 rlen = len(fil[bidx].split()[0]) + 6
 for ln in fil[bidx:]:
  if '---' in ln or 'M' in ln:
   break
  if len(ln[:rlen].strip()) > 0:
   cior.append(ln.split()[0])
 return cior 

#OUTPUTS ORBITALS 
def outmat(mat,filnam):
 system('rm -f '+filnam)
 stri = ''
 out = [str(len(mat)).zfill(5) + ' ' +  str(len(mat[0])).zfill(10) +'\n']
 for i in range(0,len(mat)):
  stri = ''
  for j in range(0,len(mat[i])):
   stri = stri + E2E(mat[i][j])
   if (j+1)%10==0:
    out.append(stri+'\n')
    stri = ''
  out.append(stri+'\n')
 file(filnam,'w').writelines(out)

def outmatE(mat,filnam):
 system('rm -f '+filnam)
 stri = ''
 out = []
 for i in range(0,len(mat)):
  stri = ''
  for j in range(0,len(mat[i])):
   stri = stri + '{0:26.20f}'.format(mat[i][j])
   if (j+1)%20==0:
    out.append(stri+'\n')
    stri = ''
  out.append(stri+'\n')
 file(filnam,'w').writelines(out)

def outarray(mat,filnam):
 system('rm -f '+filnam)
 out = []
 for i in range(0,len(mat)):
  out.append('{0:26.20f}'.format(mat[i]) + '\n')
 file(filnam,'w').writelines(out)


#CLEANS MATRICES
def clmat(mat):
 mm = mat.tolist()
 for i in range(0,len(mm)):
  for j in range(0,len(mm[i])):
   if abs(mm[i][j]) <= 1e-6:
    mm[i][j] = 0.0
   elif abs(mm[i][j])-1.0 <= 1e-6 and abs(mm[i][j])-1.0 > 0.0:
    mm[i][j] = 1.0*(mm[i][j])/abs(mm[i][j])
 return np.matrix(mm)

#GENERATES SIGMA MATRIX IN KABSCH ALGORITHM
def gensigma(Eval,U,V):
 sgn = np.linalg.det(U*V.transpose())
 sidx = Eval.tolist().index(sorted(Eval)[0])
 sig = np.array([ 1.0 for i in range(0,len(Eval))])
 sig[sidx] = sgi
 return makediag(sig,V.transpose(),1);

#CREATES SOME TYPE OF DIAGONAL MATRIX USING EIGENVALUES ARRAY
def makediag(Eval,Zmat,h):
 mat = np.zeros(Zmat.shape)
 for i in range(0,len(Eval)):
  if h == 0:
   mat[:len(Eval)][:len(Eval)] = np.linalg.inv(np.sqrt(np.diag(Eval)))
  else:
   mat[:len(Eval)][:len(Eval)] = np.diag(Eval)
 return mat;

# BEGIN
EThresh = float([ f for f in file(sys.argv[1],'r').readlines() if 'thresh,' == f.split()[0]][0].split(',')[-1].strip())
projfils = [ f for f in file(sys.argv[1],'r').readlines() if 'projfils,' == f.split()[0]][0].split(',')[-1].strip()
adiabfils = [ f for f in file(sys.argv[1],'r').readlines() if 'adfils,' == f.split()[0]][0].split(',')[-1].strip()
reffil = [ f for f in file(sys.argv[1],'r').readlines() if 'ref,' == f.split()[0]][0].split(',')[-1].strip()
cutoff = float([ f for f in file(sys.argv[1],'r').readlines() if 'cut,' == f.split()[0]][0].split(',')[-1].strip())
method = int([ f for f in file(sys.argv[1],'r').readlines() if 'method,' == f.split()[0]][0].split(',')[-1].strip())
qcmeth = [ f for f in file(sys.argv[1],'r').readlines() if 'qcmethod,' == f.split()[0]][0].split(',')[-1].strip()
if 'mrci' in qcmeth:
 methstr = 'MRCI STATE'
elif 'cas' in qcmeth:
 methstr =  'MCSCF STATE'

refCI = loadvecs(reffil,methstr)
ciord = get_ref_ci_order(reffil) 
refen = []
for ln in [ ff for ff in file(reffil,'r').readlines() if methstr in ff and 'Energy' in ff ]:
 refen.append(float(ln.split(methstr)[1].split()[2])) 
#adiabCI = {}
#adiaben = {}
projCI = []
#dfilnam = {}
#g = 0
#for fil in [f.strip() for f in file(adiabfils,'r').readlines()]:
# dfilnam[g] = fil.split()[0].split('.')[0] + '.endiab'
# adiaben[g] = []
# for ln in [ ff for ff in file(fil,'r').readlines() if 'Energy' in ff ]:
#  adiaben[g].append( float(ln.split(methstr)[1].split()[2]))
# adiabCI[g] = loadordvecs(fil,ciord,methstr)
# i = 0 
# print 'Geometry ' + str(g), 'File = ', dfilnam[g]
# g+=1 
dfilnam = adiabfils.split()[0].split('.')[0] + '.endiab'
adiaben = []
for ln in [ ff for ff in file(adiabfils,'r').readlines() if 'Energy' in ff ]:
    adiaben.append( float(ln.split(methstr)[1].split()[2]))
    adiabCI = loadordvecs(adiabfils,ciord,methstr)
# i = 0 
#    print 'Geometry: ' , 'File = ', dfilnam
#g = 0
#for fil in [f.strip() for f in file(projfils,'r').readlines()]:
# ene = []
# for ln in [ ff for ff in file(fil,'r').readlines() if 'Energy' in ff ]:
#  ene.append( float(ln.split(methstr)[1].split()[2]))
# CI = loadordvecs(fil,ciord,methstr)
# i = 0 
# print 'Projection Geometry ' + str(g), 'File = ', fil
# c=0
# for en in ene:
#  if en <= cutoff:
#    projCI.append(CI[i])
#    c+=1
#  i+=1
# print 'Number of states below cutoff energy = ' + str(c)
# g+=1 
#g = 0

ene = []
for ln in [ ff for ff in file(projfils,'r').readlines() if 'Energy' in ff ]:
    ene.append( float(ln.split(methstr)[1].split()[2]))
    CI = loadordvecs(projfils,ciord,methstr)
i = 0 
print 'Projection Geometry: ' , 'File = ', projfils
c=0
for en in ene:
    if en <= cutoff:
        projCI.append(CI[i])
        c+=1
        i+=1
        print 'Number of states below cutoff energy = ' + str(c)
        Pd = np.matrix(projCI).transpose()

print 'Projecting...'
eval,tmp = np.linalg.eigh(Pd.transpose()*Pd)
CIv = (tmp*Pd.transpose()).transpose()
coff = 0
absvec = [[0.0,i] for i in range(0,len(CIv.tolist()[0]))]
for i in range(0, len(eval)):
 if abs(eval[i]) > EThresh or 'test' in sys.argv:
  print str(len(eval)-i) ,eval[i]
  coff +=1

if EThresh == 0.0:
  coff = len(adiabCI[0])
print 'CUTOFF = ', coff
CIv = np.matrix(CIv.transpose().tolist()[-coff:]).transpose()
#outmat(CIv.tolist(),'Proj_Matrix')

if 'test' in sys.argv:
  quit()

# create projected reference 
RfEn = np.diag(np.array(refen))
RfCI = np.matrix(refCI).transpose()
PRfCI = clmat(CIv*np.linalg.inv(CIv.transpose()*CIv)*CIv.transpose()*RfCI)

OrdPRfCI = [PRfCI.transpose().tolist()[0]]
OrdRfCI = [RfCI.transpose().tolist()[0]]
cval = [np.diagonal(PRfCI.transpose()*PRfCI).tolist()[0]]
OrdE = [RfEn.tolist()[0][0]]
for i, w in enumerate(np.diagonal(PRfCI.transpose()*PRfCI).tolist()[1:],start=1):
 for c, wc in enumerate(cval,start=0):
  if float(w)*0.98 > float(wc):
   OrdPRfCI.insert(c,PRfCI.transpose().tolist()[i])
   OrdRfCI.insert(c,RfCI.transpose().tolist()[i])
   cval.insert(c,w)
   OrdE.insert(c,RfEn.tolist()[i][i])
   break
  elif c+1 == len(cval):
   OrdPRfCI.append(PRfCI.transpose().tolist()[i])
   OrdRfCI.append(RfCI.transpose().tolist()[i])
   cval.append(w)
   OrdE.append(RfEn.tolist()[i][i])
   break
#outmat(PRfCI.transpose().tolist(),'PRfCI')
#outmat(OrdPRfCI,'OrdPRfCI')

eval, PRfCIV = np.linalg.eigh(PRfCI.transpose()*PRfCI)
seval = [ e for e in eval if abs(e) > 0.05]
RfE = (PRfCIV.transpose()*RfEn*PRfCIV).tolist()
RfEns = np.matrix([ff[-coff:][::-1] for ff in RfE[-coff:][::-1]])
#outmatE(RfEns.tolist(),'seeout')

RfCIV = np.matrix((PRfCIV.transpose()*RfCI.transpose()).tolist()[-coff:][::-1])
ROrdRfCI = np.matrix(OrdRfCI[:coff])
ROrdPRfCI = np.matrix(OrdPRfCI[:coff])

U, s, V = np.linalg.svd(RfCIV*ROrdRfCI.transpose())
O = clmat(U*V)
RRef = (O.transpose()*RfCIV).transpose()
RRefEn = (O.transpose()*RfEns*O).transpose()
print 'FINAL OVERLAP 1= ', np.diagonal(RRef.transpose()*ROrdRfCI.transpose())

#for g in adiabCI:
print 'FILE  = ', dfilnam
Mi = np.matrix(adiabCI).transpose()
EnV = np.diag(np.array(adiaben))
PCIvMa = clmat(CIv*np.linalg.inv(CIv.transpose()*CIv)*CIv.transpose()*Mi)
eval, PCIvMaV = np.linalg.eigh(PCIvMa.transpose()*PCIvMa)
OrdCI = [Mi.transpose().tolist()[0]]
OrdE = [EnV.tolist()[0][0]]
cval = [np.diagonal(PCIvMa.transpose()*PCIvMa).tolist()[0]]
for i, w in enumerate(np.diagonal(PCIvMa.transpose()*PCIvMa).tolist()[1:],start=1):
    for c, wc in enumerate(cval,start=0):
        if float(w)*0.98 > float(wc):
            cval.insert(c,w)
            OrdE.insert(c,EnV.tolist()[i][i])
            OrdCI.insert(c,Mi.transpose().tolist()[i])
            break
        elif c+1 == len(cval):
            cval.append(w)
            OrdE.append(EnV.tolist()[i][i])
            OrdCI.append(Mi.transpose().tolist()[i])
            break

if method == 1:
# seval = [ e for e in eval if abs(e) > 0.05]
# print eval[-len(seval)-5:]
    RA = np.matrix((PCIvMaV.transpose()*Mi.transpose()).tolist()[-coff:]).transpose()
    PRARef = RA.transpose()*RRef  
    U, s, V = np.linalg.svd(clmat(PRARef))  
    O = clmat(U*V) 
    RRA = (O.transpose()*RA.transpose()).transpose()
    RE = (PCIvMaV.transpose()*EnV*PCIvMaV).tolist()
    REn = np.matrix( [ ff[-coff:] for ff in RE[-coff:]])
else:
    OrCI = np.matrix(OrdCI[:coff]).transpose()
    U, s, V = np.linalg.svd( OrCI.transpose()*RRef)
    O = clmat(U*V)
    REn = np.matrix(np.diag(OrdE[:len(O)]))

RREn = (O.transpose()*REn*O)
Mi = []
outmatE(RREn.transpose().tolist(),dfilnam) 
outarray(np.diag(RREn).tolist(),'diag_' + dfilnam)
eee, evv = np.linalg.eigh(RREn)
outarray(eee,'adiab_' + dfilnam)
SOrdE = sorted(OrdE[:len(eee)])
res = (eee - np.array([SOrdE[f] for f in range(0,len(eee))])).tolist()
print '########################################################################'
print ' State         Adiab Model        Adiab Molpro      Mol Stat#    Residue (eV)'
for i in range(0,len(eee)):
    print str(i).ljust(10) + '{0:18.9f}'.format(eee[i]) + '{0:18.9f}'.format(SOrdE[i]) + str(adiaben.index(SOrdE[i])+1).rjust(10) + '{0:20.9f}'.format(res[i]*27.2114)
    
