#!/usr/bin/env python3


from minput import MSection, InputError


class ClusterstatModesSection(MSection):

    def __init__(self, lines):

        self.mode_combinations=[]

        MSection.__init__(self,lines)

        if lines[0].upper() != "MODES-SECTION":
            message="Input seems not to contain a " \
                     + "MODES-SECTION. First line reads: " \
                     + lines[0]
            raise Exception(message)
        elif lines[-1].lower() != "end-modes-section":
            message="Input seems not to contain a " \
                     + "MODES-SECTION. Last line reads: " \
                     + lines[-1]
            raise Exception(message)
        self.openstr = lines.pop(0)
        self.closestr = lines.pop(-1)
        for line in lines:
            labels = line.split(',')
            if labels:
                for lab in labels:
                    if lab.find(" ") >= 0:
                        message = "MODES-SECTION: coord labels must "
                        message += "be comma separated: " + str(lab)
                        raise InputError(message)
                self.mode_combinations.append(tuple(labels))


    def __str__(self):
        string = str(self.openstr) + '\n'
        for mc in self.mode_combinations:
            string += ' ' + ', '.join(mc) + '\n'
        string += self.closestr + "\n"
        return string


