#!/usr/bin/env python
"""
Version info for source code related to the cluster expansion.
"""

import sys

# global defaults
__author__ = "Markus Schroeder"
__copyright__ = "Theoretical Chemistry, University of Heidelberg"
__version__ = "0.9"
__maintainer__ = "Hans-Dieter Meyer"
__email__ = "markus.schroeder@pci.uni-heidelberg.de"
__status__ = "Development"


def versionInfo(progname="Unknown",
                version="Unknown",
                status="Unknown",
                author="Unknown",
                copyright="Unknown",
                maintainer="Unknown",
                support="N/A"):
    """
    Print version info

    versionInfo(progname="Unknown",
            version="Unknown",
            status="Unknown",
            author="Unknown",
            copyright="Unknown",
            maintainer="Unknown",
            support="N/A")

    """

    message = "-"*70 + "\n\n"
    message += " ****** Source code info ******\n\n"
    message += " Program....... " + str(progname) + "\n"
    message += " Version....... " + str(version) + "\n"
    message += " Status........ " + str(status) + "\n"
    message += " Author........ " + str(author) + "\n"
    message += " Copyright..... " + str(copyright) + "\n"
    message += " Maintainer.... " + str(maintainer) + "\n"
    message += " Support....... " + str(support) + "\n\n"
    message += "-"*70 + "\n"
    sys.stdout.write(message)