#!/bin/bash

# get environment
if [ -e "$QUANTICS_DIR/install/QUANTICS_client" ] ; then
   source "$QUANTICS_DIR/install/QUANTICS_client"
else
   echo ' '
   echo 'No platform.cnf file. First run install_quantics.'
   echo ' '
fi

# Generate files with the options for the analysis programs

for i in $(egrep -ih "^ *program" $QUANTICS_DIR/HDmctdh/analyse/*.[Ffc] \
       $QUANTICS_DIR/HDmctdh/analyse/*.[Ff]90 2>/dev/null | awk '{print $2}' ) ; do
   echo "Writing : $i.html"
   if [ -e $i.html ]; then 
      rm $i.html 
   fi
   if [ $i == "moduledep" ] ; then
      echo "MODULEDEP: no help"
   else
      echo '<PRE>' >> $i.html
      $QUANTICS_DIR/bin/binary/$QUANTICS_PLATFORM/$i -h >> $i.html
      echo '</PRE>' >> $i.html
   fi
done

cd $QUANTICS_DIR/HDmctdh/analyse
pylist=`ls *.py` 
cd $QUANTICS_DIR/doc/analyse/anal_opts
for i in $pylist ; do
   echo "Writing : $i.html"
   if [ -e $i.html ]; then 
      rm $i.html 
   fi
   echo '<PRE>' >> $i.html
   $QUANTICS_DIR/bin/$i -h 2>> $i.html
   echo '</PRE>' >> $i.html
done

i="notavailable"
   if [ -e $i.html ]; then rm $i.html; fi
echo '<PRE>' >> $i.html
 echo "-------------------------------------" >> $i.html
 echo "Program not yet available in Quantics" >> $i.html
 echo "-------------------------------------" >> $i.html
echo '</PRE>' >> $i.html

