#include <stdio.h>
#include <math.h>
#include <errno.h>
#include <string.h>
#include "mcalc.h"
#include "y.tab.h"

#include <stdlib.h>
#include <readline/readline.h>
/* #include <readline/history.h> */

extern int yydebug; 
extern FILE *yyin;

int
main (int argc, char **argv)
{
  int res;
  char *histfile = ".mcalc_history";
  char *home;
  static char *history;
  
  home = getenv("HOME");
  if(home==NULL) {fprintf(stderr,"HOME variable not set\n"); exit(42);}
  history = malloc(strlen(home)+strlen(histfile)+2);
  if(history==NULL) {fprintf(stderr,"Malloc returned NULL"); exit(42);}
  sprintf(history,"%s/%s",home,histfile);
  

  using_history();
  res = read_history(history);

  if ( argc > 1 ) { /* !! this is ignored when using readline */
    yyin = fopen( argv[1], "r" );
    if(yyin==NULL) {
      fprintf(stderr,"ERROR: Opening file %s\n",argv[1]);
      yyin=stdin;
    }
  }
  else
    yyin = stdin;

  yydebug=0;
  printf("-- mcalc -- enter 'help' for more information.\n");
  yyparse ();

  res = write_history(history);
  if(res!=0) fprintf(stderr,"Writing history:%s.\n",strerror(errno));

  return(0);
}

yyerror (char *s)  /* Called by yyparse on error */
{
  printf ("ERROR: %s\n", s);
}
     
int yywrap(void) 
{
  return(1);
}

