#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef USE_READLINE
#  include <readline/readline.h>
#  include <readline/history.h>
#else
char *readline(char *prompt);
#endif

void nextline(char *line);

static char sline[1024];
static char *lp;
static int new;
char 
st_input(void)
{
  static int firsttime=0;
  char c;
  if(firsttime==0) {
    using_history();
    firsttime=1;
    new=1;
    lp = sline;
  }

  if(new==1) {
    nextline(sline);
    lp=sline;
    new=0;
  }
  if((*lp)=='\0') {new=1; return('\n'); }

  return(*(lp++));
}

void 
st_unput(char c)
{
  if(lp>sline) lp--;
}

void
st_output(char c)
{
  printf("%c",c);
}

void 
nextline(char *line)
{
  char *text;
  int l;

  text = readline("mcalc> ");
  if(text==NULL) {
    strcpy(line,"quit");
  } else {
    strncpy(line,text,1023);
  }
  free(text);
  
  if (line[0]) {
    char *expansion;
    int result;
    
    result = history_expand (line, &expansion);
    if (result)
      fprintf (stderr, "ERROR:%s\n", expansion);
    
    if (result < 0 || result == 2) {
      free (expansion);
      line[0]='\0';
      return;
    }
      
    add_history (expansion);
    strncpy (line, expansion, sizeof (line) - 1);
    line[strlen(expansion)]   = '\n';
    line[strlen(expansion)+1] = '\0';
    free (expansion);
    return;
  }
}
