export OMP_NUM_THREADS=6     # Set this to the number of threads used.
export OMP_PROC_BIND=true
export OMP_PLACES=cores
export OMP_STACKSIZE="64M"
export OMP_SCHEDULE="dynamic,1"
#export MKL_NUM_THREADS=4    # Incomment if MKL library is used.
#export MKL_DYNAMIC=1        # Incomment if MKL library is used.
ulimit -s unlimited

echo "OMP_NUM_THREADS = $OMP_NUM_THREADS"
echo "OMP_PROC_BIND   = $OMP_PROC_BIND"
echo "OMP_PLACES      = $OMP_PLACES"
echo "OMP_STACKSIZE   = $OMP_STACKSIZE"
echo "OMP_SCHEDULE    = $OMP_SCHEDULE"

##########################################################################
#
# NOTE: Some executables are enabled to use shared-memory parallelization
#       via OpenMP directives. To make use of this, you should set the
#       following environment variables in your *execution* environment:
#
#       OMP_NUM_THREADS=<n>       # number of CPU cores to use
#
#       OMP_SCHEDULE="dynamic,1"  # threading schedule
#                                 # (consider other schedules as well)
#
#       OMP_STACKSIZE="64M"       # stack size per thread
#                                 # (you might need to increase this)
#
# HINT: For performance optimization one might also consider seting
#       the variables OMP_PLACES and OMP_PROC_BIND.
#
#       It is recommended to link to a parallel version of LAPACK
#       for 'mcpotfit' and 'natpot2cpd' as these make extensive use
#       of linear algebra tools. See -x option of 'compile'.
#
# NOTE: Within MCTDH 8.5 at present, only the programs 'vminmax',
#       'mcpotfit', 'potfit' and 'natpot2cpd' support OpenMP. 'Potfit'
#       only when re-fitting a PES file. For all other programs the -P
#       option makes no difference. Note that the excecutables produced by
#       'compile -P' carry the extension P. Depending on your installation
#       you might need to set 'ulimit -s unlimited' in execution shell.
#
##########################################################################

