#-#!/bin/bash   ---  This line is for mcb

#------------------  quantics.profile  ---------------------------------

########################################################################
# The bash function pathplus adds directories to the PATH environment  #
# variable. It removes redundant (multiple) entries.       (HDM 12/99) #
# ldpathplus is the same but for the LD_LIBRARY_PATH variable
########################################################################

pathplus() {
if [ -z "$1" ] ; then return ; fi

path=:
for i in $@ ; do
      path=$path:$i
done
path="${path#::}"
path="${path#:}"
path="$path:$PATH:"
newpath=:

while [ "$path" ] ; do
  p1="${path%%:*}"
  p1="${p1%/}"
  path="${path#*:}"
  if [ "$newpath" = "${newpath%:$p1:*}" ] ; then
     newpath="$newpath$p1:"
  fi
done

newpath="${newpath#:}"
newpath="${newpath%:}"
export PATH="$newpath"
return
}

ldpathplus() {
if [ -z "$1" ] ; then return ; fi

ldpath=:
for i in $@ ; do
      ldpath=$ldpath:$i
done
ldpath="${ldpath#::}"
ldpath="${ldpath#:}"
ldpath="$ldpath:$LD_LIBRARY_PATH:"
newldpath=:

while [ "$ldpath" ] ; do
  p1="${ldpath%%:*}"
  p1="${p1%/}"
  ldpath="${ldpath#*:}"
  if [ "$newldpath" = "${newldpath%:$p1:*}" ] ; then
     newldpath="$newldpath$p1:"
  fi
done

newldpath="${newldpath#:}"
newldpath="${newldpath%:}"
export LD_LIBRARY_PATH="$newldpath"
return
}



#####   -------------   ACTUAL SCRIPT BEGINS HERE  -------------   #####

if [ -z "$QUANTICS_DIR" ] ; then
   echo " "
   echo 'First set $QUANTICS_DIR environment variable to base directory.'
   echo " "
else
   if [ -e "$QUANTICS_DIR/install/platform.cnf" ] ; then
      source "$QUANTICS_DIR/install/platform.cnf"
      pathplus "$QUANTICS_DIR/bin/binary/$QUANTICS_PLATFORM" 
      pathplus "$QUANTICS_DIR/bin"
      ldpathplus "$QUANTICS_DIR/bin/dyn_libs"
   else
      echo ' '
      echo 'No platform.cnf file. First run install_quantics.'
      echo ' '
   fi
fi

export QUANTICS_PLATFORM

