      program cleandb

      implicit none
      integer(4):: na,ne,i,j,n,itimes,li,lj
      integer(4),dimension(:),allocatable:: k
      real(8):: d
      real(8),dimension(:),allocatable:: geoi,geoj
      real(8),dimension(:,:),allocatable:: pesi,pesj
      real(8),dimension(:,:,:),allocatable:: grai,graj
      real(8),dimension(:,:,:,:),allocatable:: hesi,hesj

      open(10,file='geo.db',form='unformatted',err=2000)
      open(11,file='pes.db',form='unformatted',err=2000)
      open(12,file='gra.db',form='unformatted',err=2000)
      open(13,file='hes.db',form='unformatted',err=2000)
      open(14,file='geoclean.db',form='unformatted')
      open(15,file='pesclean.db',form='unformatted')
      open(16,file='graclean.db',form='unformatted')
      open(17,file='hesclean.db',form='unformatted')

      print*,'What is the number of atoms?'
      read*,na
      print*,'What is the number of electronic states?'
      read*,ne
      allocate(geoi(3*na),geoj(3*na)) 
      allocate(pesi(ne,ne),pesj(ne,ne)) 
      allocate(grai(3*na,ne,ne),graj(3*na,ne,ne))
      allocate(hesi(3*na,3*na,ne,ne),hesj(3*na,3*na,ne,ne))

      n=0
 10   if (.true.) then
        read(10,end=100,err=1000)
        n=n+1
        go to 10
      endif
 100  continue
      rewind(10)
      print*,'number of records:',n
      if (n == 0 .or. n == 1) then
        print*,'no need to clean'
        stop
      endif

      allocate(k(n))

      k(:)=1
      do i=1,n-1
        if (i > 1) then
          do itimes=1,i-1
            read(10) 
            read(11) 
            read(12) 
            read(13) 
          enddo
        endif
        read(10) li,geoi
        read(11) pesi
        read(12) grai
        read(13) hesi
        do j=i+1,n
          read(10) lj,geoj
          read(11) pesj
          read(12) graj
          read(13) hesj
          if (k(j) /= 0) then
            d=dsqrt(sum((geoi-geoj)**2))
            if (d <= 1.d-7) then
              k(j)=0
              print*,'identical records:',i,'&',j
              if (li /= lj) then
                print*,'WARNING: unconsistent State-Average status' 
              endif
            endif
          endif
        enddo
        rewind(10)
        rewind(11)
        rewind(12)
        rewind(13)
      enddo

      print*,'number of distinct records:',sum(k(:))
      if (n == sum(k(:))) then
        print*,'the data base was already clean'
        stop
      endif

      j=0
      do i=1,n
        read(10) li,geoi
        read(11) pesi
        read(12) grai
        read(13) hesi
        if (k(i) == 1) then
          j=j+1
          write(14) li,geoi
          write(15) pesi
          write(16) grai
          write(17) hesi
        endif
      enddo
      print*,'the clean data base has now',j,'distinct records'

      deallocate(k,geoi,geoj,pesi,pesj,grai,graj,hesi,hesj)
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      stop
 1000 print*,'ERROR reading DB file'
      stop
 2000 print*,'ERROR opening DB file'
      stop
      end 
