      program cutdb

      implicit none
      integer:: na,ne,i,n,ncut,l
      real(8),dimension(:),allocatable:: geo
      real(8),dimension(:,:),allocatable:: pes
      real(8),dimension(:,:,:),allocatable:: gra
      real(8),dimension(:,:,:,:),allocatable:: hes

      open(10,file='geo.db',form='unformatted',err=2000)
      open(11,file='pes.db',form='unformatted',err=2000)
      open(12,file='gra.db',form='unformatted',err=2000)
      open(13,file='hes.db',form='unformatted',err=2000)
      open(14,file='geocut.db',form='unformatted')
      open(15,file='pescut.db',form='unformatted')
      open(16,file='gracut.db',form='unformatted')
      open(17,file='hescut.db',form='unformatted')

      print*,'What is the number of atoms?'
      read*,na
      print*,'What is the number of electronic states?'
      read*,ne
      allocate(geo(3*na))
      allocate(pes(ne,ne))
      allocate(gra(3*na,ne,ne))
      allocate(hes(3*na,3*na,ne,ne))

      n=0
 10   if (.true.) then
        read(10,end=100,err=1000)
        n=n+1
        go to 10
      endif
 100  continue
      rewind(10)
      print*,'number of records:',n
      if (n == 0 .or. n == 1) then
        print*,'can''t be cut'
        stop
      endif

      print*,'Number of records to cut?'
      read*,ncut
      if (ncut >= n) then
        print*,'too big!'
        stop
      endif
        
      do i=1,ncut
        read(10)
        read(11)
        read(12)
        read(13)
      enddo
      do i=ncut+1,n
        read(10) l,geo
        read(11) pes
        read(12) gra
        read(13) hes
        write(14) l,geo
        write(15) pes
        write(16) gra
        write(17) hes
      enddo
      print*,'the cut data base has now',n-ncut,'records'

      deallocate(geo,pes,gra,hes)
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      stop
 1000 print*,'ERROR reading DB file'
      stop
 2000 print*,'ERROR opening DB file'
      stop
      end 
