C#######################################################################
C  This program is called by dd_generator                              #
C  and creates the output directory.                                   #
C N.B.: it is adapted to the new version MCTDH90.31dv                  #
C#######################################################################
C                                                           BL 12/08   #
C#######################################################################

      program main

      implicit none
      integer(4),parameter:: nat=20
      integer(4):: meth,nq,na,nx,ierr,nb,
     +             diab,ngwp,nsta,ista,root,rdmo,nred,
     +             j,k,i,n
      integer(4),dimension((3*nat-6)/5+1):: nc
      integer(4),dimension(3*nat-6):: jj,qnum
      real(8):: e0,tstp,tfin,dbcr,theta,phi,chi,eexc,mtot
      real(8),dimension(3):: com
      real(8),dimension(3*nat):: ref,xmas,con,dcp,grd
      real(8),dimension(3*nat-6):: qfre,qmom,q
      real(8),dimension(3*nat,3*nat-6):: qvec
      real(8),dimension(nat):: amas
      real(8),dimension(3*nat,3*nat-6):: back
      real(8),dimension(3*nat-6,3*nat):: for
      character(4):: dbst
      character(5),dimension(3*nat-6):: qnam
      character(12):: string
      character(10),dimension(nat):: at
      character(10),dimension(3*nat-6):: qsym
      character(20):: opnm
      character(120):: datdir,outdir,gname,file1,file2

      print*,'  about to read parameters...'
      read*,na
      read(*,'(a)') datdir
      read*,meth
      read(*,'(a)') opnm
      read*,diab
      read*,tstp
      read*,tfin
      read(*,'(a)') outdir
      read*,ngwp
      read*,nsta
      read*,ista
      read(*,'(a)') gname
      read*,root
      read(*,'(a)') dbst
      read*,dbcr
      read*,theta
      read*,phi
      read*,chi
      read*,rdmo
      read*,eexc
      read*,nred
      do j=1,nred
         read*,jj(j)
      enddo
      print*,'  ... parameters just read'

      dbcr=0.01d0*dbcr
      theta=4.d0*datan(1.d0)*theta/180.d0
      phi=4.d0*datan(1.d0)*phi/180.d0
      chi=4.d0*datan(1.d0)*chi/180.d0

      ierr=0

      if (na .gt. nat) then
         ierr=1
         go to 999
      endif

      nx=3*na
      if (na .eq. 2) then
         nq=1
      else
         nq=3*na-6
      endif

C-----------------------------------------------------------------------
C Reading start.log
C-----------------------------------------------------------------------
      file1=datdir(1:index(datdir,' ')-1)//'/start.log'
      print*,'  about to read file '//file1//'...'
      call rdstart(nat,nq,na,nx,meth,ierr,nb,nc,e0,ref,qfre,
     +             qvec,at,qsym,file1)
      print*,'  ... file '//file1//' read successfully'

C-----------------------------------------------------------------------
C Determining the masses of the nuclei
C-----------------------------------------------------------------------
      call atmass(nat,na,ierr,amas,xmas,at)

C-----------------------------------------------------------------------
C Re-centring the reference geometry to the centre of mass
C-----------------------------------------------------------------------
      mtot=0.d0
      do n=1,na
         mtot=mtot+amas(n)
      enddo
      do i=1,3
         com(i)=0.d0
         do n=1,na
            com(i)=com(i)+amas(n)*ref((n-1)*3+i)
         enddo
         com(i)=com(i)/mtot
         do n=1,na
            ref((n-1)*3+i)=ref((n-1)*3+i)-com(i)
         enddo
      enddo

C-----------------------------------------------------------------------
C Writing the reference geometry
C-----------------------------------------------------------------------
      file1=datdir(1:index(datdir,' ')-1)//'/refdb.dat'
      call wrrefdb(nat,na,at,ref,file1)

C-----------------------------------------------------------------------
C Writing the transformation matrices
C-----------------------------------------------------------------------
      file1=datdir(1:index(datdir,' ')-1)//'/forward.dat'
      file2=datdir(1:index(datdir,' ')-1)//'/backward.dat'
      call transf(nat,nq,nx,nred,jj,xmas,qvec,qfre,back,for,file1,file2)

C-----------------------------------------------------------------------
C Reading coin.log if needed
C-----------------------------------------------------------------------
      if (diab .eq. 1) then
         file1=datdir(1:index(datdir,' ')-1)//'/coin.log'
         print*,'  about to read file '//file1//'...'
         call rdcoin(nat,na,nx,nq,ierr,theta,phi,chi,ref,con,
     +               dcp,grd,qfre,q,amas,back,file1)
         print*,'  ... file '//file1//' read successfully'
      endif

C-----------------------------------------------------------------------
C Determining the names of the normal modes
C-----------------------------------------------------------------------
      do j=1,nq
         qnum(j)=0
         do k=1,j
            if (qsym(j) .eq. qsym(k)) qnum(j)=qnum(j)+1
         enddo
      enddo
      do j=1,nq
         write(string,'(i2,a)') qnum(j),qsym(j)
         call rmlblnk(string)
         call rmblnk(string)
         qnam(j)=string(1:5)
      enddo

C-----------------------------------------------------------------------
C Redefining nc and nb (columns and blocks) for actual dimensionality
C-----------------------------------------------------------------------
      if (nred/5 .eq. 0) then
         nb=1
         nc(nb)=nred
      else
         do k=1,nred/5
            nc(k)=5
         enddo
         if (mod(nred,5) .eq. 0) then
            nb=nred/5
         else
            nb=nred/5+1
            nc(nb)=mod(nred,5)
         endif
      endif

C-----------------------------------------------------------------------
C Reading momentum.dat if needed
C-----------------------------------------------------------------------
      if (rdmo .eq. 1) then
         file1=datdir(1:index(datdir,' ')-1)//'/momentum.dat'
         print*,'  about to read file '//file1//'...'
         call rdmomentum(nat,nq,ierr,nred,jj,eexc,qmom,qfre,file1)
         print*,'  ... file '//file1//' read successfully'
      else
         do j=1,nq
            qmom(j)=0.d0
         enddo
      endif

C-----------------------------------------------------------------------
C Generating the .inp and .op files
C-----------------------------------------------------------------------
      file1=datdir(1:index(datdir,' ')-1)//'/input.tmp'
      file2=datdir(1:index(datdir,' ')-1)//'/oper.tmp'
      call generator(nat,nx,nb,na,diab,ngwp,nsta,ista,root,nred,jj,nc,
     +               e0,tstp,tfin,dbcr,ref,con,dcp,grd,qmom,qfre,back,
     +               for,dbst,qnam,at,opnm,file1,file2,outdir,gname)

C-----------------------------------------------------------------------
C Determining the kind of error if any
C-----------------------------------------------------------------------
  999 continue
      if (ierr .eq. 0) go to 1000
      if (ierr .eq. 1) go to 1001
      if (ierr .eq. 2) go to 1002
      if (ierr .eq. 3) go to 1003
      if (ierr .eq. 4) go to 1004
      if (ierr .eq. 5) go to 1005
      if (ierr .eq. 6) go to 1006
      if (ierr .eq. 7) go to 1007
      if (ierr .eq. 8) go to 1008
      if (ierr .eq. 9) go to 1009
      if (ierr .eq. 10) go to 1010
      if (ierr .eq. 11) go to 1011
      if (ierr .eq. 12) go to 1012
      if (ierr .eq. 13) go to 1013
      if (ierr .eq. 14) go to 1014
      if (ierr .eq. 15) go to 1015

 1000 print*,'Data extracted successfully'
      stop
 1001 print*,'The number of atoms is > 20: you must alter dd_filegen.f'
      stop
 1002 print*,'I cannot open the start.log file'
      stop
 1003 print*,'I cannot read the start.log file'
      stop
 1004 print*,'I cannot read the list of atoms in start.log file'
      stop
 1005 print*,'I cannot read the geometry in start.log file'
      stop
 1006 print*,'I cannot read the energy in start.log file'
      stop
 1007 print*,'I cannot read the frequency analysis in start.log file'
      stop
 1008 print*,'Nuclear masses of elements other than H to Ar '//
     +       '(most common isotope) and D yet to be implemented'
      stop
 1009 print*,'I cannot read the geometry in coin.log file'
      stop
 1010 print*,'I cannot read the derivative coupling in coin.log file'
      stop
 1011 print*,'I cannot read the gradient difference in coin.log file'
      stop
 1012 print*,'I cannot open the coin.log file'
      stop
 1013 print*,'I cannot read the coin.log file'
      stop
 1014 print*,'I cannot open the momentum.dat file'
      stop
 1015 print*,'I cannot read the momentum.dat file'
      stop

      end

C#######################################################################

      subroutine rdstart(nat,nq,na,nx,meth,ierr,nb,nc,e0,ref,qfre,
     +                   qvec,at,qsym,file1)

      implicit none
      integer(4):: nat,nq,na,nx,meth,ierr,
     +             i,nb,k,j
      integer(4),dimension((3*nat-6)/5+1):: nc
      integer(4),dimension(3):: found
      real(8):: e0
      real(8),dimension(3*nat):: ref
      real(8),dimension(3*nat-6):: qfre
      real(8),dimension(3*nat,3*nat-6):: qvec
      character(80):: string
      character(10),dimension(nat):: at
      character(10),dimension(3*nat-6):: qsym
      character(120):: file1

      open(10,file=file1,status='old',err=1000)

      do i=1,3
         found(i)=0
      enddo

      if (nq/5 .eq. 0) then
         nb=1
         nc(nb)=nq
      else
         do k=1,nq/5
            nc(k)=5
         enddo
         if (mod(nq,5) .eq. 0) then
            nb=nq/5
         else
            nb=nq/5+1
            nc(nb)=mod(nq,5)
         endif
      endif

   10 continue
      read(10,'(a)',end=999,err=2000) string
      if (string(1:19) .eq. " Symbolic Z-matrix:"
     +   .and. found(1) .eq. 0) then
         read(10,*)
         do i=1,na
            read(10,'(a)',end=999,err=2000) string
            call rmlblnk(string)
            read(string,'(a10)') at(i)
         enddo
         found(1)=1
      else if (string(27:44) .eq. "Input orientation:"
     +   .and. found(2) .eq. 0) then
         do i=1,4
            read(10,*)
         enddo
         do i=1,nx-2,3
            read(10,'(a)',end=999,err=2000) string
            read(string,'(34x,3f12.6)') ref(i),ref(i+1),ref(i+2)
         enddo
         found(2)=1
      else if (string(2:20) .eq. "SCF Done:  E(RHF) =") then
         if (meth .eq. 0 .and. found(3) .eq. 0) then
            read(string,'(20x,f16.9)',err=2000) e0
            found(3)=1
         endif
      else if (string(7:22) .eq. ")     EIGENVALUE") then
         if (meth .eq. 1) then
             read(string,'(24x,f17.10)',err=2000) e0
             found(3)=1
         endif
      else if (string(1:24) .eq. " and normal coordinates:"
     +        .and. found(4) .eq. 0) then
         do k=1,nb
            read(10,*)
            read(10,'(a)',end=999,err=2000) string
            read(string,'(26x,5a10)') (qsym((k-1)*5+j),j=1,nc(k))
            read(10,'(a)',end=999,err=2000) string
            read(string,'(23x,5f10.4)') (qfre((k-1)*5+j),j=1,nc(k))
            do i=1,4
               read(10,*)
            enddo
            do i=1,nx
               read(10,'(a)',end=999,err=2000) string
               read(string,'(23x,5f10.5)') (qvec(i,(k-1)*5+j),j=1,nc(k))
            enddo
         enddo
         found(4)=1
      endif
      go to 10

  999 continue
      if(found(1) .ne. 1) ierr=4
      if(found(2) .ne. 1) ierr=5
      if(found(3) .ne. 1) ierr=6
      if(found(4) .ne. 1) ierr=7

      close(10)

      return
 1000 ierr=2
      return
 2000 ierr=3
      return

      end

C#######################################################################

      subroutine wrrefdb(nat,na,at,ref,file1)

      implicit none
      integer(4):: nat,na,
     +             n,i
      real(8),dimension(3*nat):: ref
      character(10),dimension(nat):: at
      character(120):: file1

      open(11,file=file1)

      do n=1,na
         write(11,'(a10,3f12.6)') at(n),(ref((n-1)*3+i),i=1,3)
      enddo

      close(11)

      end

C#######################################################################

      subroutine atmass(nat,na,ierr,amas,xmas,at)

      implicit none
      integer(4):: nat,na,ierr,
     +             n,i
      real(8),dimension(nat):: amas
      real(8),dimension(3*nat):: xmas
      character(10),dimension(nat):: at
      character(10):: string

! Masses in u (GAUSSIAN values) 
      do n=1,na
         string=at(n)
         call rmlblnk(string)
         if (string(1:2) .eq. 'H ') then
            amas(n)=1.007825037d0
         elseif (string(1:2) .eq. 'He') then
            amas(n)=4.002603250d0
         elseif (string(1:2) .eq. 'Li') then
            amas(n)=7.016004500d0
         elseif (string(1:2) .eq. 'Be') then
            amas(n)=9.012182500d0
         elseif (string(1:2) .eq. 'B ') then
            amas(n)=11.009305300d0
         elseif (string(1:2) .eq. 'C ') then
            amas(n)=12.d0
         elseif (string(1:2) .eq. 'N ') then
            amas(n)=14.003074008d0
         elseif (string(1:2) .eq. 'O ') then
            amas(n)=15.994914640d0
         elseif (string(1:2) .eq. 'F ') then
            amas(n)=18.998403250d0
         elseif (string(1:2) .eq. 'Ne') then
            amas(n)=19.992439100d0
         elseif (string(1:2) .eq. 'Na') then
            amas(n)=22.989769700d0
         elseif (string(1:2) .eq. 'Mg') then
            amas(n)=23.985045000d0
         elseif (string(1:2) .eq. 'Al') then
            amas(n)=26.981541300d0
         elseif (string(1:2) .eq. 'Si') then
            amas(n)=27.976928400d0
         elseif (string(1:2) .eq. 'P ') then
            amas(n)=30.973763400d0
         elseif (string(1:2) .eq. 'S ') then
            amas(n)=31.972071800d0
         elseif (string(1:2) .eq. 'Cl') then
            amas(n)=34.968852729d0
         elseif (string(1:2) .eq. 'Ar') then
            amas(n)=39.962383100d0
         elseif (string(1:8) .eq. 'H(Iso=2)') then
            amas(n)=2.014101787d0
         else
            ierr=8
            return
         endif
      enddo

      do n=1,na
         do i=1,3
            xmas((n-1)*3+i)=amas(n)
         enddo
      enddo

      end

C#######################################################################

      subroutine transf(nat,nq,nx,nred,jj,xmas,qvec,qfre,back,for,
     +                  file1,file2)

      implicit none
      integer(4):: nat,nq,nx,nred,
     +             j,i
      integer(4),dimension(3*nat-6):: jj
      real(8):: bohr,me,hartree,norm
      real(8),dimension(3*nat):: xmas
      real(8),dimension(3*nat,3*nat-6):: qvec
      real(8),dimension(3*nat-6):: qfre
      real(8),dimension(3*nat,3*nat-6):: back
      real(8),dimension(3*nat-6,3*nat):: for
      character(120):: file1,file2

      open(12,file=file1)
      open(13,file=file2)

! Masses in u (unified atomic mass unit), frequencies (wavenumbers) in cm-1
      bohr=0.52917725d0        ! in Angstroem (MCTDH value)
      me=5.4857990943d-4       ! in u (2006 CODATA)
      hartree=2.194746313705d5 ! in cm-1 (2006 CODATA)

      do j=1,nq
        norm=0.d0
        do i=1,nx
           norm=norm+xmas(i)*qvec(i,j)**2 
        enddo
        norm=dsqrt(norm)
        do i=1,nx
           qvec(i,j)=dsqrt(xmas(i))*qvec(i,j)/norm
        enddo
        qfre(j)=qfre(j)/hartree
      enddo

      do i=1,nx
         xmas(i)=xmas(i)/me
      enddo

      do i=1,nx
        do j=1,nq
          back(i,j)=dsqrt(xmas(i)*qfre(j))/bohr*qvec(i,j)
          for(j,i)=bohr/dsqrt(xmas(i)*qfre(j))*qvec(i,j)
        enddo
      enddo

      write(12,'(a,2(i2,a))') 'forward transformation: ',
     +            nred,' Dyn. fmw normal modes (a.u.) to ',
     +            nx,' PES Cartesian (Angst.)'
      do j=1,nred
        write(12,'(5F15.10)') (for(jj(j),i),i=1,nx)
        write(12,*)
      enddo

      write(13,'(a,2(i2,a))') 'backward transformation: ',
     +            nx,' PES Cartesian (Angst.) to ',
     +            nred,' Dyn. fmw normal modes (a.u.)'
      do i=1,nx
        write(13,'(5F15.10)') (back(i,jj(j)),j=1,nred)
        write(13,*)
      enddo

      close(12)
      close(13)

      end

C#######################################################################

      subroutine rdcoin(nat,na,nx,nq,ierr,theta,phi,chi,ref,con,
     +                  dcp,grd,qfre,q,amas,back,file1)

      implicit none
      integer(4):: nat,na,nx,nq,ierr,
     +             i,n,j
      integer(4),dimension(3):: found
      real(8):: theta,phi,chi,
     +          bohr,me,mtot,nold,nnew,nvib,nrot,s1,s2,alpha
      real(8),dimension(3):: com
      real(8),dimension(nat):: amas
      real(8),dimension(3*nat):: ref,con,dcp,grd
      real(8),dimension(3*nat-6):: qfre,q
      real(8),dimension(3*nat,3*nat-6):: back
      character(80):: string
      character(120):: file1

      open(14,file=file1,status='old',err=1000)

      bohr=0.52917725d0        ! in Angstroem (MCTDH value)
      me=5.4857990943d-4       ! in u (2006 CODATA)

      do i=1,3
         found(i)=0
      enddo

   10 continue
      read(14,'(a)',end=999,err=2000) string
      if (string(27:44) .eq. "Input orientation:") then
         do i=1,4
            read(14,*)
         enddo
         do i=1,nx-2,3
            read(14,'(a)',end=999,err=2000) string
            read(string,'(34x,3f12.6)') con(i),con(i+1),con(i+2)
         enddo
         found(1)=1
      else if (string(1:20) .eq. " Derivative Coupling") then
         do i=1,nx-2,3
            read(14,'(a)',end=999,err=2000) string
            read(string,'(x,3f20.10)') dcp(i),dcp(i+1),dcp(i+2)
         enddo
         found(2)=1
      else if (string(1:29) .eq. " Unscaled Gradient Difference") then
         do i=1,nx-2,3
            read(14,'(a)',end=999,err=2000) string
            read(string,'(x,3f20.10)') grd(i),grd(i+1),grd(i+2)
         enddo
         found(3)=1
      endif
      go to 10

  999 continue
C-----------------------------------------------------------------------
C Re-centring and re-orientating with Euler angles given by the user
C-----------------------------------------------------------------------
      mtot=0.d0
      do n=1,na
         mtot=mtot+amas(n)
      enddo
      do i=1,3
         com(i)=0.d0
         do n=1,na
            com(i)=com(i)+amas(n)*con((n-1)*3+i)
         enddo
         com(i)=com(i)/mtot
         do n=1,na
            con((n-1)*3+i)=con((n-1)*3+i)-com(i)
         enddo
      enddo
      nold=0.d0
      do i=1,3
         do n=1,na
            nold=nold+amas(n)*(con((n-1)*3+i)-ref((n-1)*3+i))**2
         enddo
      enddo
      nold=dsqrt(nold)
      do n=1,na
         com(1)=(dcos(theta)*dcos(phi)*dcos(chi)
     +         -dsin(phi)*dsin(chi))*con((n-1)*3+1)
     +         +(-dcos(theta)*dcos(phi)*dsin(chi)
     +         -dsin(phi)*dcos(chi))*con((n-1)*3+2)
     +         +dsin(theta)*dcos(phi)*con((n-1)*3+3)
         com(2)=(dcos(theta)*dsin(phi)*dcos(chi)
     +         +dcos(phi)*dsin(chi))*con((n-1)*3+1)
     +         +(-dcos(theta)*dsin(phi)*dsin(chi)
     +         +dcos(phi)*dcos(chi))*con((n-1)*3+2)
     +         +dsin(theta)*dsin(phi)*con((n-1)*3+3)
         com(3)=-dsin(theta)*dcos(chi)*con((n-1)*3+1)
     +         +dsin(theta)*dsin(chi)*con((n-1)*3+2)
     +         +dcos(theta)*con((n-1)*3+3)
         do i=1,3
            con((n-1)*3+i)=com(i)
         enddo
      enddo
      nnew=0.d0
      do i=1,3
         do n=1,na
            nnew=nnew+amas(n)*(con((n-1)*3+i)-ref((n-1)*3+i))**2
         enddo
      enddo
      nnew=dsqrt(nnew)
      do n=1,na
         com(1)=(dcos(theta)*dcos(phi)*dcos(chi)
     +         -dsin(phi)*dsin(chi))*grd((n-1)*3+1)
     +         +(-dcos(theta)*dcos(phi)*dsin(chi)
     +         -dsin(phi)*dcos(chi))*grd((n-1)*3+2)
     +         +dsin(theta)*dcos(phi)*grd((n-1)*3+3)
         com(2)=(dcos(theta)*dsin(phi)*dcos(chi)
     +         +dcos(phi)*dsin(chi))*grd((n-1)*3+1)
     +         +(-dcos(theta)*dsin(phi)*dsin(chi)
     +         +dcos(phi)*dcos(chi))*grd((n-1)*3+2)
     +         +dsin(theta)*dsin(phi)*grd((n-1)*3+3)
         com(3)=-dsin(theta)*dcos(chi)*grd((n-1)*3+1)
     +         +dsin(theta)*dsin(chi)*grd((n-1)*3+2)
     +         +dcos(theta)*grd((n-1)*3+3)
         do i=1,3
            grd((n-1)*3+i)=com(i)
         enddo
      enddo
      do n=1,na
         com(1)=(dcos(theta)*dcos(phi)*dcos(chi)
     +         -dsin(phi)*dsin(chi))*dcp((n-1)*3+1)
     +         +(-dcos(theta)*dcos(phi)*dsin(chi)
     +         -dsin(phi)*dcos(chi))*dcp((n-1)*3+2)
     +         +dsin(theta)*dcos(phi)*dcp((n-1)*3+3)
         com(2)=(dcos(theta)*dsin(phi)*dcos(chi)
     +         +dcos(phi)*dsin(chi))*dcp((n-1)*3+1)
     +         +(-dcos(theta)*dsin(phi)*dsin(chi)
     +         +dcos(phi)*dcos(chi))*dcp((n-1)*3+2)
     +         +dsin(theta)*dsin(phi)*dcp((n-1)*3+3)
         com(3)=-dsin(theta)*dcos(chi)*dcp((n-1)*3+1)
     +         +dsin(theta)*dsin(chi)*dcp((n-1)*3+2)
     +         +dcos(theta)*dcp((n-1)*3+3)
         do i=1,3
            dcp((n-1)*3+i)=com(i)
         enddo
      enddo

C-----------------------------------------------------------------------
C Checking the rotational contribution to the displacement
C-----------------------------------------------------------------------
      do j=1,nq
         q(j)=0.d0
         do i=1,nx
            q(j)=q(j)+back(i,j)*(con(i)-ref(i))/dsqrt(qfre(j)/me)*bohr
         enddo
      enddo
      nvib=0.d0
      do j=1,nq
         nvib=nvib+q(j)**2
      enddo
      nvib=dsqrt(nvib)
      nrot=nnew-nvib
      print*,'*********************************************************'
      if (dabs(nrot) .gt. 5.d-5) then
         print*,'/!\ WARNING: YOU SHOULD CHECK HOW YOU CALCULATED /!\'
         print*,'/!\ VALUES OF THE EULER ANGLES. THEY SEEM WRONG! /!\'
      endif
      print*,'Mass-weighted displacement from start to coin:'
      write(*,'(a,f10.6)') '    old total norm:',nold
      write(*,'(a,f10.6)') '    new total norm:',nnew
      write(*,'(a,f10.6)') '  vibrational part:',nvib
      write(*,'(a,f10.6)') '   rotational part:',nrot
      print*,'*********************************************************'

C-----------------------------------------------------------------------
C Mixing the BS vectors to set up the initial gauge
C-----------------------------------------------------------------------
      s1=0.d0
      s2=0.d0
      do i=1,nx
         s1=s1+0.5d0*(ref(i)-con(i))*grd(i)
         s2=s2+(ref(i)-con(i))*dcp(i)
      enddo
      alpha=0.5d0*datan2(s2,s1)
      do i=1,nx
         s1=0.5d0*grd(i)
         s2=dcp(i)
         grd(i)=2.d0*(dcos(2.d0*alpha)*s1+dsin(2.d0*alpha)*s2)
         dcp(i)=-dsin(2.d0*alpha)*s1+dcos(2.d0*alpha)*s2
      enddo

      if(found(1) .ne. 1) ierr=9
      if(found(2) .ne. 1) ierr=10
      if(found(3) .ne. 1) ierr=11

      close(14)

      return
 1000 ierr=12
      return
 2000 ierr=13
      return

      end

C#######################################################################

      subroutine rdmomentum(nat,nq,ierr,nred,jj,eexc,qmom,qfre,file1)

      implicit none
      integer(4):: nat,nq,nred,ierr,
     +             j
      integer(4),dimension(3*nat-6):: jj
      real(8):: hartree,eexc,
     +          eexc0
      real(8),dimension(3*nat-6):: qmom,qfre
      character(120):: file1

      open(15,file=file1,status='old',err=1000)

      hartree=27.211384523d0 ! in eV (2006 CODATA)

      do j=1,nq
         read(15,*,err=2000) qmom(j)
      enddo

      eexc0=0.d0
      do j=1,nred
         eexc0=eexc0+0.5d0*qfre(jj(j))*qmom(jj(j))**2
      enddo
      eexc0=eexc0*hartree
      print*,'*********************************************************'
      print*,'Using the momentum given in momentum.dat would have given'
      write(*,'(a,f7.3)') 'an excess kinetic energy (in eV) of:',eexc0
      if (nred .lt. nq) then
         print*,'  N.B.: using active coordinates only.'
      endif
      do j=1,nred
         qmom(jj(j))=dsqrt(eexc/eexc0)*qmom(jj(j))
      enddo
      print*,'For your information, the momentum has been multiplied'
      write(*,'(a,f7.3)') 'by a factor of:',dsqrt(eexc/eexc0)
      print*,'*********************************************************'
      print*,' '

      close(15)

      return
 1000 ierr=14
      return
 2000 ierr=15
      return

      end

C#######################################################################

      subroutine generator(nat,nx,nb,na,diab,ngwp,nsta,ista,root,
     +                     nred,jj,nc,e0,tstp,tfin,dbcr,ref,con,dcp,grd,
     +                     qmom,qfre,back,for,dbst,qnam,at,opnm,file1,
     +                     file2,outdir,gname)

      implicit none
      integer(4):: nat,nx,nb,na,
     +             diab,ngwp,nsta,ista,root,nred,
     +             k,j,i,n
      integer(4),dimension(3*nat-6):: jj
      integer(4),dimension((3*nat-6)/5+1):: nc
      real(8):: e0,tstp,tfin,dbcr
      real(8),dimension(3*nat):: ref,con,dcp,grd
      real(8),dimension(3*nat-6):: qmom,qfre
      real(8),dimension(3*nat,3*nat-6):: back
      real(8),dimension(3*nat-6,3*nat):: for
      character(4):: dbst
      character(5),dimension(3*nat-6):: qnam
      character(10),dimension(nat):: at
      character(20):: opnm
      character(80):: string,strong
      character(120):: file1,file2,outdir,gname


      open(8,file=file1)
      open(9,file=file2)

      write(8,'(a)') '#'
      write(8,'(a)') '# Direct dynamics input file'
      write(8,'(a)') '# (add any comment here)'
      write(8,'(a)') '#'
      write(8,*)
      write(8,'(a)') 'OPERATOR-SECTION'
      write(8,'(2a)') 'opname = ',opnm(1:index(opnm,' ')-1)
      if (diab .eq. 0) then
         write(8,'(a)') 'dd_adiab'
      else if (diab .eq. 1) then
         write(8,'(a)') 'dd_diab = regularized'
      else if (diab .eq. 2) then
         write(8,'(a)') 'dd_diab = local'
      else if (diab .eq. 3) then
         write(8,'(a)') 'dd_diab = global'
      endif
      write(8,'(a)') 'ddregions = 100.0, 10.0, 0.1, eV'
      write(8,'(a,i3)') 'ddtrans =',nx
      write(8,'(a)') 'sacas'
      write(8,'(a)') 'end-operator-section'
      write(8,*)
      write(8,'(a)') 'RUN-SECTION'
      write(8,'(a,f6.2,a,f8.2,a,f6.2,a)') 'propagation tout =',tstp,
     +           ' tfinal =',tfin,' tpsi =',tstp,' direct'
      write(8,'(2a)') 'name = ',outdir(1:index(outdir,' ')-1)
      write(8,'(a)') 'output timing ddpes auto update psi'
      write(8,'(a)') 'end-run-section'
      write(8,*)
      write(8,'(a)') 'SBASIS-SECTION'
      write(8,'(a)') 'gwp_type=frozen,normal'
      write(8,'(a)') 'single-set'
      if (nb .gt. 1) then
         do k=1,nb-1
            write(string,'(11a)')
     +      (qnam(jj((k-1)*5+j)),',',j=1,nc(k)),'%'
            call rmlblnk(string)
            call rmblnk(string)
            write(8,'(a)') string(1:index(string,' ')-1)
         enddo
      endif 
      if (nc(nb) .eq. 1) then
            write(string,'(2a,i5)') qnam(jj(nred)),'=',ngwp
            call rmlblnk(string)
            call rmblnk(string)
            write(8,'(a)') string(1:index(string,' ')-1)
      else
            write(string,'(8a)') (qnam(jj((nb-1)*5+j)),',',j=1,nc(nb)-1)
            call rmlblnk(string)
            call rmblnk(string)
            write(strong,'(2a,i5)') string(1:index(string,' ')-1)//
     +                              qnam(jj(nred)),'=',ngwp
            call rmlblnk(strong)
            call rmblnk(strong)
            write(8,'(a)') strong(1:index(strong,' ')-1)
      endif
      write(8,'(a)') 'end-sbasis-section'
      write(8,*)
      write(8,'(a)') 'PBASIS-SECTION'
      do j=1,nred
         write(8,'(a5,a5)') qnam(jj(j)),'gwp'
      enddo
      if (nsta .gt. 1) write(8,'(a10,i5)') 'el     el ',nsta
      write(8,'(a)') 'end-pbasis-section'
      write(8,*)
      write(8,'(a)') 'INTEGRATOR-SECTION'
      write(8,'(a)') '# RK5/spf  = , imp-or       # (alternative)'
      write(8,'(a)') 'dd_update = tout'
      write(8,'(a)') 'end-integrator-section'
      write(8,*)
      write(8,'(a)') 'INIT_WF-SECTION'
      write(8,'(a)') ' build'
      write(8,'(a,i3)') ' init_state =',ista
      do j=1,nred
         write(8,'(2a,f9.3,a)') qnam(jj(j)),
     +      '  gwp   shell   0.0000',qmom(jj(j)),'    0.7071    ovl=0.8'
      enddo
      write(8,'(a)') ' end-build'
      write(8,'(a)') 'end-init_wf-section'
      write(8,*)
      write(8,'(a)') 'DDPOINTS-SECTION'
      write(8,'(a)') 'reference_point'
      do n=1,na
         write(8,'(a10,3f12.6)') at(n),(ref((n-1)*3+i),i=1,3)
      enddo
      write(8,'(a)') 'conical_intersection'
      do n=1,na
         write(8,'(a10,3f12.6)') at(n),(con((n-1)*3+i),i=1,3)
      enddo
      write(8,'(a)') ' Deriv_Coup'
      do n=1,na
         write(8,'(a10,3f20.10)') at(n),(dcp((n-1)*3+i),i=1,3)
      enddo
      write(8,'(a)') ' Grad_Diff'
      do n=1,na
         write(8,'(a10,3f20.10)') at(n),(grd((n-1)*3+i),i=1,3)
      enddo
      write(8,'(a)') 'end-ddpoints-section'
      write(8,*)
      write(8,'(a)') 'DDTRANS-SECTION'
      write(8,*)
      write(8,'(a)') 'reference geometry (Angst.)'
      do n=1,na
         write(8,'(a10,3f12.6)') at(n),(ref((n-1)*3+i),i=1,3)
      enddo
      write(8,*)
      write(8,'(a,2(i2,a))') 'forward transformation: ',
     +            nred,' Dyn. fmw normal modes (a.u.) to ',
     +            nx,' PES Cartesian (Angst.)'
      do j=1,nred
        write(8,'(5F15.10)') (for(jj(j),i),i=1,nx)
        write(8,*)
      enddo
      write(8,'(a,2(i2,a))') 'backward transformation: ',
     +            nx,' PES Cartesian (Angst.) to ',
     +            nred,' Dyn. fmw normal modes (a.u.)'
      do i=1,nx
        write(8,'(5F15.10)') (back(i,jj(j)),j=1,nred)
        write(8,*)
      enddo
      write(8,'(a)') 'end-ddtrans-section'
      write(8,*)
      write(8,'(a)') 'end-input'

      write(9,'(a)') 'OP_DEFINE-SECTION'
      write(9,'(a)') 'title'
      write(9,'(a)') 'Direct dynamics'
      write(9,'(a)') '(add any comment here)'
      write(9,'(a)') 'end-title'
      write(9,'(a)') 'end-op_define-section'
      write(9,*)
      write(9,'(a)') 'PARAMETER-SECTION'
      do j=1,nred
         string='omega_'//qnam(jj(j))
         call rmblnk(string)
         write(9,'(2a,f13.10)') string(1:index(string,' ')-1),' =',
     +                          qfre(jj(j))
      enddo
      write(9,'(a)') 'end-parameter-section'
      write(9,*)
      write(9,'(a)') 'HAMILTONIAN-SECTION'
      write(9,'(a)')
     +  '--------------------------------------------------------------'
      if (nb .gt. 1) then
         do k=1,nb-1 
            write(string,'(5a8)') (qnam(jj((k-1)*5+j))//' | ',j=1,nc(k))
            write(9,'(a)') '   modes  | '//string(1:40)
         enddo
      endif 
      if (nc(nb) .eq. 1) then
            if (nsta .eq. 1) then
               write(string,'(a5,a)') qnam(jj(nred)),'%'
            else
               write(string,'(a10,a)') qnam(jj(nred))//' | el','%'
            endif
            write(9,'(a)') '   modes  | '//string(1:index(string,'%')-1)
      else
            write(string,'(5a)')
     +      (qnam(jj((nb-1)*5+j))//' | ',j=1,nc(nb)-1),'%'
            if (nsta .eq. 1) then
               write(strong,'(a,a5,a)') string(1:index(string,'%')-1),
     +                                  qnam(jj(nred)),'%'
            else
               write(strong,'(a,a10,a)') string(1:index(string,'%')-1),
     +                                   qnam(jj(nred))//' | el','%'
            endif
            write(9,'(a)') '   modes  | '//strong(1:index(strong,'%')-1)
      endif
      do j=1,nred
         string='omega_'//qnam(jj(j))
         call rmblnk(string)
         write(strong,'(i3)') j
         call rmblnk(strong)
         write(9,'(a)') string(1:index(string,' ')-1)//' |'//
     +                  strong(1:index(strong,' ')-1)//' KE'
      enddo
      if (nred .gt. 1) then
         write(string,'(i4)') -nred
         call rmlblnk(string)
      else
         write(string,'(a)') ' '
      endif
      write(strong,'(i3)') nred+1
      call rmlblnk(strong)
      write(9,'(a)') '1.0       |1'//
     +               string(1:index(string,' '))//'V1'//
     +               '                                    |'//
     +               strong(1:index(strong,' ')-1)//' S1&1'
      if (nsta .eq. 2) then
         write(9,'(a)') '1.0       |1'//
     +                  string(1:index(string,' '))//'V2'//
     +                  '                                    |'//
     +                  strong(1:index(strong,' ')-1)//' S2&2'
         write(9,'(a)') '1.0       |1'//
     +                  string(1:index(string,' '))//'V12'//
     +                  '                                   |'//
     +                  strong(1:index(strong,' ')-1)//' S1&2'
      else if (nsta .gt. 2) then
         print*,'/!\ ADD Sn&n AND Sn&m FOR MISSING STATES /!\'
      endif
      write(9,'(a)')
     +  '--------------------------------------------------------------'
      write(9,'(a)') 'end-hamiltonian-section'
      write(9,*)
      write(9,'(a)') 'labels-section'
      write(9,'(3a)') 'V1 = external{ GAUSSIAN, ',
     +                gname(1:index(gname,' ')-1),', '
      write(strong,'(i3)') root
      call rmlblnk(strong)
      write(9,'(a,f17.10,3a)') '   ',e0,', CAS, NRoot:',
     +                          strong(1:index(strong,' ')-1),', '
      if (dbst(1:2) .eq. 'rd') then
         write(string,'(2a)') 'DB',dbst
         call rmblnk(string)
         write(strong,'(f7.4)') dbcr
         call rmlblnk(strong)
         write(9,'(5a)') '     ',string(1:index(string,' ')-1),
     +                   ':',strong(1:index(strong,' ')-1),' }'
      else
         write(string,'(2a)') 'DB',dbst
         call rmblnk(string)
         write(9,'(3a)') '     ',string(1:index(string,' ')-1),' }'
      endif
      if (nsta .eq. 2) then
         write(9,'(3a)') 'V2 = external{ GAUSSIAN, ',
     +                   gname(1:index(gname,' ')-1),', '
         write(strong,'(i3)') root
         call rmlblnk(strong)
         write(9,'(a,f17.10,3a)') '   ',e0,', CAS, NRoot:',
     +                             strong(1:index(strong,' ')-1),', '
         if (dbst(1:2) .eq. 'rd') then
            write(string,'(2a)') 'DB',dbst
            call rmblnk(string)
            write(strong,'(f7.4)') dbcr
            call rmlblnk(strong)
            write(9,'(5a)') '     ',string(1:index(string,' ')-1),
     +                      ':',strong(1:index(strong,' ')-1),' }'
         else
            write(string,'(2a)') 'DB',dbst
            call rmblnk(string)
            write(9,'(3a)') '     ',string(1:index(string,' ')-1),' }'
         endif
         write(9,'(3a)') 'V12 = external{ GAUSSIAN, ',
     +                   gname(1:index(gname,' ')-1),', '
         write(strong,'(i3)') root
         call rmlblnk(strong)
         write(9,'(a,f17.10,3a)') '    ',e0,', CAS, NRoot:',
     +                             strong(1:index(strong,' ')-1),', '
         if (dbst(1:2) .eq. 'rd') then
            write(string,'(2a)') 'DB',dbst
            call rmblnk(string)
            write(strong,'(f7.4)') dbcr
            call rmlblnk(strong)
            write(9,'(5a)') '      ',string(1:index(string,' ')-1),
     +                      ':',strong(1:index(strong,' ')-1),' }'
         else
            write(string,'(2a)') 'DB',dbst
            call rmblnk(string)
            write(9,'(3a)') '      ',string(1:index(string,' ')-1),' }'
         endif
      else if (nsta .gt. 2) then
         write(9,*) '/!\ ADD Vn AND Vnm FOR MISSING STATES /!\'
      endif
      write(9,'(a)') 'end-labels-section'
      write(9,*)
      write(9,'(a)') 'end-operator'

      close(8)
      close(9)

      end

C#######################################################################
C
C     subroutine rmblnk
C
C     removes blanks between words in a string
C
C#######################################################################

      subroutine rmblnk(string)

      implicit none
      integer i,j,length
      character*(*) string

      length=len(string)

      j=0
      do i=1,length
         if (string(i:i) .ne. ' ') then
            j=j+1
            string(j:j)=string(i:i)
         endif
      enddo
      do i=j+1,length
         string(i:i)=' '
      enddo

      return
      end

C#######################################################################
C
C     subroutine rmlblnk
C
C     removes leading blanks of a string
C
C#######################################################################

      subroutine rmlblnk(string)

      implicit none
      integer i,j,k,length
      character*(*) string

      length=len(string)

      do i=1,length
         if (string(i:i).ne.' ') goto 10
      enddo
   10 if (i.gt.length) return

      j=0
      do k=i,length
         j=j+1
         string(j:j)=string(k:k)
      enddo
      do i=j+1,length
         string(i:i)=' '
      enddo

      return
      end

