      program deldb

      implicit none
      integer:: na,ne,i,n,ndel,l
      real(8),dimension(:),allocatable:: geo
      real(8),dimension(:,:),allocatable:: pes
      real(8),dimension(:,:,:),allocatable:: gra
      real(8),dimension(:,:,:,:),allocatable:: hes

      open(10,file='geo.db',form='unformatted',err=2000)
      open(11,file='pes.db',form='unformatted',err=2000)
      open(12,file='gra.db',form='unformatted',err=2000)
      open(13,file='hes.db',form='unformatted',err=2000)
      open(14,file='geodel.db',form='unformatted')
      open(15,file='pesdel.db',form='unformatted')
      open(16,file='gradel.db',form='unformatted')
      open(17,file='hesdel.db',form='unformatted')

      print*,'What is the number of atoms?'
      read*,na
      print*,'What is the number of electronic states?'
      read*,ne
      allocate(geo(3*na))
      allocate(pes(ne,ne))
      allocate(gra(3*na,ne,ne))
      allocate(hes(3*na,3*na,ne,ne))

      n=0
 10   if (.true.) then
        read(10,end=100,err=1000)
        n=n+1
        go to 10
      endif
 100  continue
      rewind(10)
      print*,'number of records:',n
      if (n == 0 .or. n == 1) then
        print*,'no need to delete 0 or 1 record'
        stop
      endif

      print*,'Record to delete?'
      read*,ndel
      if (ndel > n) then
        print*,'too big!'
        stop
      endif

      if (ndel > 1) then
        do i=1,ndel-1
          read(10) l,geo
          read(11) pes
          read(12) gra
          read(13) hes
          write(14) l,geo
          write(15) pes
          write(16) gra
          write(17) hes
        enddo
      endif
      read(10)
      read(11)
      read(12)
      read(13)
      if (ndel < n) then
        do i=ndel+1,n
          read(10) l,geo
          read(11) pes
          read(12) gra
          read(13) hes
          write(14) l,geo
          write(15) pes
          write(16) gra
          write(17) hes
        enddo
      endif
      print*,'the cut data base has now',n-1,'records'

      deallocate(geo,pes,gra,hes)
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      stop
 1000 print*,'ERROR reading DB file'
      stop
 2000 print*,'ERROR opening DB file'
      stop
      end 
