      program seedb

      implicit none
      integer:: na,ne,i,n,l,j
      real(8),dimension(:),allocatable:: geo
      real(8),dimension(:,:),allocatable:: pes
      real(8),dimension(:,:,:),allocatable:: gra
      real(8),dimension(:,:,:,:),allocatable:: hes

      open(10,file='geo.db',form='unformatted',err=2000)
      open(11,file='pes.db',form='unformatted',err=2000)
      open(12,file='gra.db',form='unformatted',err=2000)
      open(13,file='hes.db',form='unformatted',err=2000)
      open(14,file='see.db')

      print*,'What is the number of atoms?'
      read*,na
      print*,'What is the number of electronic states?'
      read*,ne
      allocate(geo(3*na))
      allocate(pes(ne,ne))
      allocate(gra(3*na,ne,ne))
      allocate(hes(3*na,3*na,ne,ne))

      n=0
 10   if (.true.) then
        read(10,end=100,err=1000)
        n=n+1
        go to 10
      endif
 100  continue
      rewind(10)
      print*,'number of records:',n
      if (n == 0 .or. n == 1) then
        print*,'can''t be cut'
        stop
      endif

      print*,'Which record do you want to see?'
      read*,j

      do i=1,n
        read(10) l,geo
        read(11) pes
        read(12) gra
        read(13) hes
        if (i == j) then
          write(14,*) 'SA'
          write(14,*) l
          write(14,*) 'geo'
          write(14,'(3(F10.6))') geo
          write(14,*) 'pes'
          write(14,*) pes
          write(14,*) 'gra'
          write(14,*) gra
          write(14,*) 'hes'
          write(14,*) hes
        endif
      enddo

      deallocate(geo,pes,gra,hes)
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      stop
 1000 print*,'ERROR reading DB file'
      stop
 2000 print*,'ERROR opening DB file'
      stop
      end 
