
C **********************************************************************
C *                                                                    *
C *                          FKEYWORD (fkeyword.inc)                   *
C *                                                                    *
C * Include file containing variables needed in the input routines.    *
C *                                                                    *
C * Michael Beck                                                  4/98 *
C *                                                                    *
C **********************************************************************

C ----------------------------------------------------------------------
C                                 VARIABLES
C
C input: single string which contains the input file (with blanks and
C        comments removed)
C inplength: length of "input"
C maxkeys: maximum number of keywords
C keyword: array containing the keywords
C param: array containing the corresponding parameters (as character
C        string)
C paralen: length of "param"
C found: true for each keyword in the input file that has been found
C found2: true for each keyword in the command line that has been found
C status: 0: keyword has not been found in input, default is used
C         1: default is taken but ignored (used for keywords which are
C            only valid in combination with certain other keywords)
C         2: keyword is taken from input
C         3: keyword is given in input but ignored
C         4: keyword is taken from the command line
C         5: keyword is given in the command line but ignored
C         6: keyword is compulsory
C         7: parameter has been computed (e.g. by examining the
C            autocorrelation function)
C counter: counter for the keywords
C ----------------------------------------------------------------------

      integer maxkeys
      parameter (maxkeys = 100)

      logical        initial, found(0:maxkeys), found2(0:maxkeys)
      integer        inplength, cmdlength, counter, paralen(1:maxkeys),
     +               status(1:maxkeys)
      character*80   keyword(1:maxkeys), param(1:maxkeys)
      character*9999 input, cmdline

      common /inputlog/  found, found2, initial
      common /inputint/  inplength, cmdlength, counter, paralen, status
      common /inputchar/ input, cmdline, keyword, param
