
C **********************************************************************
C *                                                                    *
C *                           FMEMORY (fmemory.inc)                    *
C *                                                                    *
C * Include file containing the pointers to the "giant" memory array.  *
C *                                                                    *
C * Michael Beck                                                  9/97 *
C *                                                                    *
C **********************************************************************

C ----------------------------------------------------------------------
C                                POINTERS
C
C h0,h1,h2: pointers to the Hamiltonian matrices of order 0, 1, and 2
C reauto0,...,imauto2: pointers to real and imaginary part,
C    respectively, of the autocorrelation function of order 0, 1, and 2
C intensity: pointer to vector containing the intensities
C eigenvec: pointer to eigenvector matrix
C eigenval: pointer to eigenvalue vector
C eigenerror: pointer to vector containing the errors of the eigenvalues
C exactenergy: pointer to vector containing exact energies
C exactintensity: pointer to vector containing exact intensities
C dampvalue: array containing values of the damp function
C dampvalue2: array containing values of the damp function (needed when
C             only c0 is used)
C intensity2: pointer to vector containing the intensities computed with
C             a different variational principle (for error estimation)
C intenserr: pointer to vector containing the difference of intensities
C eigenvec2: pointer to eigenvector matrix computed with a different
C            variational principle (for error estimation)
C eigenval2: pointer to eigenvalue vector computed with a different
C            variational principle (for error estimation)
C assignforw: integer array with assignments from computed to exact
C             eigenvalues
C assignback: integer array with assignments from exact to computed
C             eigenvalues
C work: pointer to real workspace
C ----------------------------------------------------------------------

      integer h0, h1, h2, reauto0, imauto0, reauto1, imauto1, reauto2,
     +        imauto2, intensity, eigenvec, eigenval, eigenerror,
     +        exactenergy, exactintensity, dampvalue, dampvalue2,
     +        assignforw, assignback, eigenvec2, eigenval2, intensity2,
     +        intenserr, work

      common /memory/ h0, h1, h2, reauto0, imauto0, reauto1, imauto1,
     +                reauto2, imauto2, intensity, eigenvec, eigenval,
     +                eigenerror, exactenergy, exactintensity,
     +                dampvalue, dampvalue2, assignforw, assignback,
     +                eigenvec2, eigenval2, intensity2, intenserr,
     +                work
