# Quantics local.mk file for MLPOTFIT
# code is in $QUANTICS_DIR/source/mlpotfit
#
# Copy this file to local.mk and change compilation settings
# according to your compiler and BLAS/LAPACK libraries.
#
# If you use gfortran and LAPACK/BLAS, you may use this file as is

# the Fortran compiler
FC := gfortran

# the Fortran compiler options
FFLAGS := -Wall -g -fcheck=all -O2

# the Fortran compiler flag that specifies where .mod files are put
MODFLAG := -J

# the C compiler
CC := gcc

# the C compiler options
CFLAGS := -Wall -g

# the linking options
# e.g. -L/path/to/openblas/lib
# Path here is the path to the Quantics Lapack and Blas libraries
LDFLAGS := -L $(QUANTICS_DIR)/object/$(QUANTICS_PLATFORM)/gfortran

# the libraries (BLAS/LAPACK or compatible)
# for OpenBLAS, e.g. -lopenblas
LIBS := -llapack -lblas

# vim: set ts=8 noexpandtab syntax=make:
