module fldrdinp

use decimal, only: long,dop

      implicit none
      private
      public :: rdfldop, fldopeindef

      contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine rdfldop()

use global
use channels
use oct

use logdat

      implicit none

      integer(long) :: ic,iz,ierr, slen,i

      routine="rdfldop (fldrdinp.F)"

      open(iin,file=inputfile(1:inplaenge),status='old',form='formatted',err=12)
 
      iz=0
 110  continue
 
      call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      if (ierr .eq. 1) then
         message = inptit
         call errormsg
      endif

      if (keyword(1) .eq. 'begin-fldop') then
         call fldopeindef(iz)
      else if (keyword(1) .eq. 'end-input') then
         write(ilog,'(/2a)') '######    No operation definitions found', &
              '   ######'
         write(6,'(/2a)') '######    No operation definitions found', &
            '   ######'
         message=keyword(1)(1:slen(keyword(1)))//' found!'
         call errormsg
      else
         go to 110
      endif


      if (nfldop .eq. 0) then
         message='Operation definition is empty.'
         call errormsg
      end if 

      write(ilog,*)'fldops: no, type, ipar, rpar,','func, addpar'
      do i=1,nfldop
         write(ilog,'(3i4,f16.8,4x,a12,4x,a12)') &
              i,fldoptype(i), fldiparam(i), &
              fldrparam(i),fldfunclab(i)(1:12),fldaddprm(i)(1:12)
       end do
       call myflush(ilog)

      return

 12   continue
      message="Unable to open input file: "//inputfile(1:inplaenge)
      call errormsg

      end subroutine rdfldop

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      subroutine fldopeindef(iz)

use global
use channels
use maxv, only: maxdim, maxsta, maxkoe
use oct
use operdef
use datenmod

use logdat

      implicit none


      integer(long), intent(in) :: iz
      integer(long) :: ic, ierr,ii,jj,ilbl
      logical(kind=4) :: match, lneedop
      character(len=c5) :: filename

      lneedop=.false.
      routine='fldopeindef (octrdfld.F)'

      !init      
      do nfldop=1,maxfldop
         fldaddprm(nfldop)     = ' '
         fldfunclab(nfldop)    = ' '
         fldrparam(nfldop)     = 0.d0
         fldoptype(nfldop)     = 0
         fldiparam(nfldop)     = 0
      end do

      nfldop=0
 
 13   continue
      nfldop=nfldop+1


      call rdinpf(iin,keyword,keyorig,inptit,lc,ic,iz,ierr,maxkey)
      message = inptit
      call cntrl(keyword(1),lc(1),ierr)
 
      if (keyword(1)(1:lc(1)) .eq. 'end-fldop' ) then
         nfldop=nfldop-1
         return
      elseif (nfldop .gt. maxfldop) then
         !too many operations
         goto 14
      end if

      if (keyword(1)(1:8) .eq. 'multfnc' ) then 
!     multiply with a function
         fldoptype(nfldop) = 1
         lneedop=.true.
      else if (keyword(1)(1:9) .eq. 'maxval' ) then
!     set maximum value
         fldoptype(nfldop) = 2
      else if (keyword(1)(1:6) .eq. 'filter' ) then
!     apply fft, multiply function, apply fft^-1 
         fldoptype(nfldop) = 3
         lneedop=.true.
      else if (keyword(1)(1:7) .eq. 'norm' ) then
!     normalize
         fldoptype(nfldop) = 4
      else if (keyword(1)(1:8) .eq. 'symmetry' ) then
!     symmetrize wrt T/2
         fldoptype(nfldop) = 5
      else if (keyword(1)(1:8) .eq. 'reverse' ) then
!     reverse the sampling points
         fldoptype(nfldop) = 6
      else if (keyword(1)(1:8) .eq. 'complex' ) then
!     get real, imag, conjg or abs of possibly complex field
         fldoptype(nfldop) = 7
      else if (keyword(1)(1:5) .eq. 'scale' ) then
!     multiply with real (complex) number
         fldoptype(nfldop) = 8
      else if (keyword(1)(1:6) .eq. 'addfnc' ) then
!     add a function
         fldoptype(nfldop) = 9
         lneedop=.true.
      else
         message='Unknown operation type:'//keyword(1)
         call errormsg
      end if
 
      if (lneedop .and. .not. lrdfnc ) then
         ilbl = index(keyword(1),' ')
         message=keyword(1)(1:ilbl)// 'requires -O option.'
         call errormsg
      end if
      
! --- Check for "="
      ii=2
      if (keyword(ii).ne.'=' .and.  fldoptype(nfldop).ne.6) then
         write(*,*)'Expecting "=" after filter type '//keyword(1)
         write(*,*)"wrong line reads:"
         write(*,*) inptit
         write(ilog,*)'Expecting "=" after filter type '//keyword(1)
         write(ilog,*)"wrong line reads:"
         write(ilog,*) inptit
      end if
      ii=ii+1


! --- function to apply (multfnc, addfnc, filter)
      if (fldoptype(nfldop).eq.1 .or. fldoptype(nfldop).eq.3 &
           .or. fldoptype(nfldop).eq.9 ) then

         fldfunclab(nfldop)=trim(keyword(ii))
         
         match=.false.
         do jj=1,hamdim
            if (hamlab(jj) .eq. fldfunclab(nfldop)) match=.true.
         end do
         if (.not.match) then
            inquire(UNIT=iin,NAME=filename)
            write(*,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(*,*)"Function definition not found in "//filename
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(ilog,*)"Function definition not found in "//filename
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if
         ii=ii+1

!     --- real parameter (maxval)
      else if (fldoptype(nfldop).eq.2 ) then
         read(keyword(ii),*,iostat=ierr) fldrparam(nfldop)
         if(ierr.ne.0) then
            write(*,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(*,*)"Expecting real number"
            write(*,*)'as argument of "maxval".'
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(ilog,*)"Expecting real number"
            write(ilog,*)'as argument of "maxval".'
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if
         ii=ii+1

! --- real parameter (norm)
      else if (fldoptype(nfldop).eq.4 ) then
         read(keyword(ii),*,iostat=ierr) fldrparam(nfldop)
         if(ierr.ne.0) then
            write(*,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(*,*)"Expecting real number"
            write(*,*)'as argument of "norm".'
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)"ERROR in subroutine fldopeindef (rdfldop.F)"
            write(ilog,*)"Expecting real number"
            write(ilog,*)'as argument of "norm".'
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if

         ii=ii+1
! --- symmetry
      else if (fldoptype(nfldop).eq.5 ) then
         if (keyword(ii)(1:4).eq.'even' .or. keyword(ii)(1:3).eq.'odd') then
            fldaddprm(nfldop) = trim(keyword(ii))
            ii=ii+1
         end if
! --- complex operations
      else if (fldoptype(nfldop).eq.7) then
 
         if (keyword(ii)(1:4) .eq. 'real' ) then
            fldaddprm(nfldop) =  'real'
         else if (keyword(ii)(1:4) .eq. 'imag' ) then
            fldaddprm(nfldop) = 'imag'
         else if (keyword(ii)(1:5) .eq. 'conjg' ) then
            fldaddprm(nfldop) = 'conjg'
         else if (keyword(ii)(1:3) .eq. 'abs' ) then
            fldaddprm(nfldop) = 'abs'
         else
            write(*,*)'Expecting "real", "imag", "conjg" or "abs"'
            write(*,*)'as argument of "complex". '
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)'Expecting "real", "imag", "conjg" or "abs"'
            write(ilog,*)'as argument of "complex". '
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if
         ii=ii+1
! --- fft
      else if (fldoptype(nfldop).eq.8 ) then
         if (keyword(ii)(1:2).eq.'1 ' .or. keyword(ii)(1:3).eq.'+1 '  ) then
            fldiparam(nfldop) = 1
         else if(keyword(ii)(1:3).eq.'-1 ') then
            fldiparam(nfldop) = -1
         else
            write(*,*)'Expecting (+)1 (forward) or -1 (backward)'
            write(*,*)'as argument of "fft". '
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)'Expecting (+)1 (forward) or -1 (backward)'
            write(ilog,*)'as argument of "fft". '
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if
         ii=ii+1
! --- scale
      else if (fldoptype(nfldop).eq.9 ) then
         read(keyword(ii),*,iostat=ierr) fldrparam(nfldop) 
         if (ierr .ne. 0) then
            write(*,*)'Expecting real number'
            write(*,*)'as argument of "scale". '
            write(*,*)"Wrong line reads:"
            write(*,*) inptit
            write(ilog,*)'Expecting real number'
            write(ilog,*)'as argument of "scale". '
            write(ilog,*)"Wrong line reads:"
            write(ilog,*) inptit
            stop 1
         end if
         ii=ii+1


      end if

! --- Check if more keywords on the line
      if (ii .le. ic) then
         write(*,*) 'WARNING: fldopeindef (rdfldop.F)'
         write(*,*) 'Additional unexpected keyword(s) found'
         write(*,*) 'Keyword will be ignored: '//keyorig(ii)
         write(*,*) 'Input line reads:'
         write(*,*)  inptit
    
         write(ilog,*) 'WARNING: fldopeindef (rdfldop.F)'
         write(ilog,*) 'Additional unexpected keyword(s) found'
         write(ilog,*) 'Keyword will be ignored: '//keyorig(ii)
         write(ilog,*) 'Input line reads:'
         write(ilog,*)  inptit
      end if
      

      goto 13


 14   continue
      routine='fldopeindef (fldrdinp.F)'
      message='Too many operations found! Increase maxfldop'//' (oct.inc).'
      call errormsg
 

      end subroutine fldopeindef

end module fldrdinp
