program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    !get the test functions from their respective suites
    use test_suite1, only : collect_suite1
    !Get the functions to test ioqc
    use test_readqc, only : collect_readqc

    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'
  
    stat = 0
  
    !Add new test suite here (use commas to separate in JSONish format)
    testsuites = [ &
      !new_testsuite("suite1", collect_suite1), &
      new_testsuite("readqc_test",collect_readqc) &
      ]
  
    do is = 1, size(testsuites)
      write(error_unit, fmt) "Testing:", testsuites(is)%name
      call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do
  
    if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      !error stop	!If called this way raises stack trace, seems not needed
      stop
    end if
  
  end program tester