!#######################################################################
!
!   Some simple unit tests?
!
!   Mainly rough and ready right now
!#######################################################################

program testframe
   !Standard Global Quantics settings for types
   use decimal, only: sip, dop, long
   !Standard Global Quantics
   use global 
   !SQL STUFF
   use db_sql
   use sqlite
   use dirdyn
   
   implicit none
   !Database variables
   type(SQLITE_DATABASE)      :: dbin, dbout  !The database object
   integer(long), dimension(2)                  :: dbvers  !Quantics and database version
   integer(long)                :: sql_ver, sql_out !The database version in and out
   real(dop)                    :: quanticsver
   character(len=c5)                           :: dbname,dbnamein, dbnameout   !path to DB
   !character(len=c6)                              ::sql_string, tabname

   integer(long)                   :: ncoo !Normally from dirdyn
   integer(long)                    ::nddstate, nrec, nummodes
   ! integer(long)                   :: nddstate,nrec,&
   !                                    nfam,&
   !                                    dercpdim,dbpntgp,nsymop,&
   !                                    maxdim, nummodes,compdim
   !real(dop)                       :: dde0
   !real(dop), dimension(:), allocatable        :: mref
   !character(len=c1), dimension(:), allocatable:: atnam
   !real(dop), dimension(:,:), allocatable      :: xref
   !integer(long), dimension(:,:), allocatable  :: dbsymmap

   !Booleans for programme control
   logical(kind=4)                             :: lnumrec = .false.                                               
   !integer(long)                               :: ilog = 6  !unit for logging
   !Id value
   integer(long)                                ::rowID, rwID
   !From the dbentry
   integer(long), dimension(1) :: stat
   integer(long)                :: timestamp
   !Get the geom for a point
   real(dop), dimension(:,:), allocatable           :: geomp
  !Get the pes and normal modes for a point
   real(dop), dimension(:,:,:), allocatable     ::pesp, diabtrans
   !aPES
   real(dop), dimension(:,:,:), allocatable      :: apesp
   !Normal modes
   real(dop), dimension(:,:), allocatable           :: nmpoint
   !Nonadiabatic coupling
   real(dop), dimension(:,:,:), allocatable      :: nact
   !Gradient
   real(dop), dimension(:,:,:,:), allocatable    :: deriv1, aderiv1
   !Hessian
   real(dop), dimension(:,:,:,:,:), allocatable  :: deriv2, aderiv2
   !MO coefficients
   real(sip), dimension(:,:,:), allocatable      :: mocoeff
   !Symreps
   integer(long), dimension(:,:), allocatable              :: rep
   !Info stuff
   character(len=500)                        :: method, basis, prog, templatef

   character(len=500)           :: cmd
   character(len=150)            :: bstr
   
   type(SQLITE_COLUMN), dimension(:), pointer  :: cols_p
   type(SQLITE_STATEMENT)                   :: stmt
   logical(kind=4)                          :: finished

   ilog = 6
   write(*,*) "Entering Testing"
   !Load existing database
   dbnamein = './database.sql'   !Existing database
   dbnameout = './full_database4.sql' !New database to write to
   write(*,*) 'Opening ' , dbnamein
   !Open the existing database
   !Really should error check
   sql_ver = 2
   !DBopen is the only time the sql_version must be sent
   call dbopen(dbnamein, dbin,sql_ver,quanticsver,infoarray,flagarray, 1 )
   !Check which version this database is using
   write(*,*) "The loaded SQL version is " , dbin%db_vers
   !call dbgetallversion(dbin,dbvers)
   !write(*,*) dbin%db_vers
   
   !Set version for output
   sql_out = 4 !The output sql version
   !Version doesn't matter for refdb, but pass version for any future changes
   call dbrdrefdb(dbin, natm, nroot, nddstate, nbasis, dde0,&
        dimref, nfam, dercpdim, dbpntgp, nsymop, nsocstate, nddmult)
   
   !Version does matter for refdbgeom
   call dbrdrefdbgeom(dbin, natm, mref, atnam, xref)

   if (natm.le.0) then
      write(*,*)'FATAL: number of atoms is wrong: ', natm
      stop
   endif

      write(*,*) 'Database name:  ', dbnamein
      write(*,*) 'Quantics version:', dbvers(1)
      write(*,*) 'SQL version:     ', sql_ver
      write(*,*)    'No. of atoms: ', natm
      write(*,*)    'Nroot:        ', nroot
      write(*,*)    'Nddstate:     ', nddstate
      write(*,*)    'Nbasis:       ', nbasis
      write(*,*)    'dde0:         ', dde0
      write(*,*)    'dimref:       ', dimref
      write(*,*)    'nfam:         ', nfam
      write(*,*)    'dercpdim:     ', dercpdim
      write(*,*)    'dbpntgp :     ', dbpntgp
      if (dbpntgp .gt. 0) then
         write(*,*) '  nsymop:     ', nsymop
      endif

   call dbgetentries(dbin, ilog, lpesdb, lgradb, lhesdb, lapesdb, lagradb, &
                        lahesdb, ldipdb, ladipdb, lmocodb, lnactdb, ltransdb, &
                        lnmdb, lcasocdb, lsymdb, lcpesdb, lctransdb, lcivecdb)
      !Fill array with flag values

   method = ""
   basis = ""
   prog = ""
   call dbrdinfo(dbin,method, basis, prog)
   method = "CAS"
   basis = "6-311G"
   prog = "molpro"
   write(*,*) "Calculation method: ", trim(method)
   write(*,*) "Basis Set: ", trim(basis) 
   write(*,*) "Calculated with: ", trim(prog)
   !Fill flag array with values from dbgetentries
   call makeflagarray

   call dbgetnrec(dbin, nrec)
   write(*,'(1x,/,a19,i0)')   'Number of records: ', nrec  
   call makeinfoarray(nddstate)

   ncoo = 3*natm !number of coordinates
   maxdim = 3*natm+3
   if(natm.gt.2)then
      nummodes = 3* natm -6 !3N-6 
   else
      nummodes = 3* natm -5 !3N-5 
   endif

   
!Set up new db
   allocate(dbsymmap(natm,nsymop))
   !Need to read refsymmmap
   if (dbpntgp .gt. 0) call dbrdrefdbmaps(dbin,natm,nsymop,dbsymmap)
   !write(*,*) dbsymmap
!Write back out into new db
   call dbopen(dbnameout,dbout,sql_out,quanticsver,infoarray,flagarray,2)

!    call sqlite3_query_table( dbout, 'nact, pes', cols_p )
! call sqlite3_prepare_select(dbout, 'nact, pes', cols_p, stmt, &
!                                         'INNER JOIN pes ON nact.id=pes.id ')

! call sqlite3_next_row(stmt, cols_p, finished)
if (dbout%error.ne.SQLITE_OK) then
   write(*,*) 'sql error while beginning transaction: ', &
                         dbout%errmsg

endif
! write(*,*) cols_p
   !Write out refdb - needs refgeom info?
   
   call dbwrrefdb(dbout,natm,nroot,nddstate,nbasis,dde0,dimref,nfam,mref,&
        atnam,xref,dercpdim,dbpntgp,nsymop,nsocstate,dbsymmap,nddmult,&
        prog,method,basis, ddtrfile,ddname,ddlaenge)
   !Write out Info
   !call dbwrinfo(dbout,method,basis,prog)
   templatef = "./template.dat"
   call dbwrtemplate(dbout,templatef)
!Going to check we read things back in
rowID = 1

!Allocate every thing here - will be easier when looping
!The final index 1 is for the SQL interface that requires a DB index
allocate(geomp(ncoo,1))
allocate(nmpoint(nummodes,1))
allocate(nact(ncoo,dercpdim,1))
allocate(deriv1(maxdim,nddstate,nddstate,1))
allocate(aderiv1(maxdim,nddstate,nddstate,1))
allocate(deriv2(maxdim,maxdim,nddstate,nddstate,1))
allocate(aderiv2(maxdim,maxdim,nddstate,nddstate,1))
allocate(mocoeff(nbasis,nbasis,1))
allocate(pesp(nddstate,nddstate,1))
allocate(apesp(nddstate,nddstate,1))
allocate(diabtrans(nddstate,nddstate,1))
allocate(rep(nsymop,1))

do rwID =0 ,1
   !First dbentry
   rowID = rwID
   call dbrdentry(dbin,rowID,-1,stat,timestamp)
   write(*,*) rwID,rowID,stat, timestamp
   call dbwrentry(dbout,rowID,stat(1),timestamp)
   !Read in geom
   call dbrdgeo(dbin,natm,rowID,-1,geomp)
   !write(*,*) geomp
   call dbwrgeo(dbout,rowID,natm,geomp(:,1))
   !Do PES and cPes if needed
   if (lpesdb .eqv. .true.) then
      call dbrdpes(dbin,nddstate,rowID,-1,pesp)
      !write(*,*) pesp
      call dbwrpes(dbout,rowID,nddstate,pesp(:,:,1))
   endif
   !Do Adiabatic PES
   if (lapesdb .eqv. .true.) then
      call dbrdapes(dbin,nddstate,rowID,-1,apesp)
      !write(*,*) apesp
      call dbwrapes(dbout,rowID,nddstate,apesp(:,:,1))
   endif

   !Go through list and load what is there
   !Get normals modes
   if (lnmdb .eqv. .true.) then
   !Load normal modes
      call dbrdnm(dbin,rowID,nummodes,-1,nmpoint)
      !write(*,*)  nmpoint
      call dbwrnm(dbout,rowID,nummodes,nmpoint(:,1))
   endif

   !Get nacts
   if (lnactdb .eqv. .true.) then
      call dbrdnact(dbin,natm,dercpdim,rowID,-1,nact)
      !write(*,*) nact
      call dbwrnact(dbout,rowID,natm,nddstate,nact(:,:,1))
   endif

   !Do Gradient
   if (lgradb .eqv. .true.) then
      call dbrdgra(dbin,nddstate,natm,rowID,-1,deriv1)
      !write(*,*) deriv1
      call dbwrgra(dbout,rowID,natm,nddstate,deriv1(:,:,:,1))
   endif

   !Do aGradient
   if (lagradb .eqv. .true.) then
      call dbrdagra(dbin,nddstate,natm,rowID,-1, aderiv1)
      !write(*,*) aderiv1
      call dbwragra(dbout,rowID,natm,nddstate,aderiv1(:,:,:,1))
   endif

   !Do Hessian
   if (lhesdb .eqv. .true.) then
      call dbrdhes(dbin,nddstate,natm, rowID,-1,deriv2)
      !write(*,*) deriv2
      call dbwrhes(dbout,rowID,natm,nddstate,deriv2(:,:,:,:,1))
   endif

   !Do aHessian
   if (lahesdb .eqv. .true.) then
      call dbrdahes(dbin,nddstate, natm,rowID,-1,aderiv2)
      !write(*,*) aderiv2
      call dbwrahes(dbout,rowID,natm,nddstate,aderiv2(:,:,:,:,1))
   endif

   !Do Trans
   if (ltransdb .eqv. .true.) then
      call dbrdtrans(dbin,nddstate, rowID,-1, diabtrans)
      !write(*,*) diabtrans
      call dbwrtrans(dbout,rowID, nddstate, diabtrans(:,:,1))
   endif

   !Do MOCO
   if (lmocodb .eqv. .true.) then
      call dbrdmoco(dbin,nbasis,rowID,-1,mocoeff)
      !write(*,*) mocoeff
      call dbwrmoco(dbout,rowID,nbasis,mocoeff(:,:,1))
   endif

   !Do symrep - untested as now examples
   if (lsymdb .eqv. .true.) then
      call dbrdsymrep(dbin,nsymop,rowID,-1,rep)
      !write(*,*) rep
      call dbwrsymrep(dbout,rowID,nsymop,rep(:,1))
   endif
enddo

if (allocated(geomp)) deallocate(geomp)
if (allocated(pesp)) deallocate(pesp)
if (allocated(nmpoint)) deallocate(nmpoint)
if (allocated(nact)) deallocate(nact)
if (allocated(deriv1)) deallocate(deriv1)
if (allocated(aderiv1)) deallocate(aderiv1)
if (allocated(deriv2)) deallocate(deriv2)
if (allocated(aderiv2)) deallocate(aderiv2)
if (allocated(mocoeff)) deallocate(mocoeff)
if (allocated(pesp)) deallocate(pesp)
if (allocated(apesp)) deallocate(apesp)
if (allocated(diabtrans)) deallocate(diabtrans)
if (allocated(rep)) deallocate(rep)

if (allocated(dbsymmap)) deallocate(dbsymmap)

end program testframe
