# Unit Tests for Quantics

Create unit tests for the functions used in Quantics here.

Uses the test-frame fortran package
<https://github.com/fortran-lang/test-drive>
available under an Apache or MIT license

## Usage

Running:

```console
compile quantics_tests
```

creates the test executable. It is not created with the

```console
compile all
```

command

Tests are created in a test suite, with the individual tests collected by a collect function.
Each test should be named so that it is clear what is being tested in the function.

For example, the ```test_rdqc_allocreadqc_valid``` test in the ```test_rdqc``` suite. This test tests that the arrays needed in readqc are correctly allocated. It also is a test that must be valid, that is the sizes are as expected.

In contrast an invalid test would be one that is expected to fail (and in that way pass).

## To run the tests

To run the test suite first compile ```quantics_tests```

Then from the source/tests directory run quantics_tests.

## How a test suite works

We will explain how a test suite works, how it is set up and interacts with the test programme

For example, take the test_readqc test suite. This is defined in the test_readqc.f90 file.

It contains the individual test functions, such as ```test_rdqc_allocreadqc_valid``` these are then combined using the collect function, ```collect_readqc```. This collect function is a public function of the module.

```quantics_tests.f90``` is the main test programme. This runs the various test suites by calling the collect functions of each module.
 The test suite programmes, such as test_readqc.f90 are included in a use statement in quantics_tests. They are then added into the test list.

If you wish to test a new module then create a new test suit programme. It should have a name that makes it clear which module is being tested. It should also be in a folder that contains any extra input files that are needed for the test.
