module test_suite1
	!Example test_suite to use with quantics_tests
  use testdrive, only : new_unittest, unittest_type, error_type, check
  implicit none
  private

  public :: collect_suite1

contains

! Collect all exported unit tests
subroutine collect_suite1(testsuite)
  ! Collection of tests in suite 1
  type(unittest_type), allocatable, intent(out) :: testsuite(:)
  
  !Collect the tests into a suite to export to quantics_test
  testsuite = [ &
    new_unittest("valid", test_valid), &
    new_unittest("invalid", test_invalid, should_fail=.true.), &
	new_unittest("simple", test_simple) &
    ]

end subroutine collect_suite1

subroutine test_valid(error)
	!Example of a test that shouldn't fail - is valid
  type(error_type), allocatable, intent(out) :: error
  ! ...
end subroutine test_valid

subroutine test_invalid(error)
	!Example of a test that should fail - is invalid
  type(error_type), allocatable, intent(out) :: error
  	integer								:: num_test
	
	write(*,*) "Passing 2"
	call simple_is(3,num_test)
	write(*,*) "Returns", num_test
	call check(error, num_test, 4)
end subroutine test_invalid

subroutine test_simple(error)
	type(error_type), allocatable, intent(out) :: error
	integer								:: num_test
	
	write(*,*) "Passing 2"
	call simple_is(2,num_test)
	write(*,*) "Returns", num_test
	call check(error, num_test, 4)
	
end subroutine test_simple

subroutine simple_is(number_in, number_out)
	!Simple function to test the tests
	integer, intent(in)				::number_in
	integer, intent(out)			::number_out
	
	number_out = number_in*number_in
	
	return number_out

end subroutine simple_is

end module test_suite1