!-----------------------------------------------------------------------
      module vcglobal

use decimal, only: long,dop
use global, only: c5

      implicit none

!-----------------------------------------------------------------------
! i/o channels
! ilog = 2 to match QUANTICS routines
!-----------------------------------------------------------------------
      integer(long), save ::    iin   = 1
      integer(long), save ::    ilog  = 2
      integer(long), save ::    iout  = 3
      integer(long), save ::    iguess= 4
      integer(long), save ::    idat  = 10
      integer(long), save ::    idat1 = 11
      integer(long), save ::    idat2 = 12
      integer(long), save ::    ipar  = 13
      integer(long), save ::    idens = 15
      integer(long), save ::    idat3 = 16
      integer(long), save ::    iop = 22
      integer(long), save ::    icl = 23
      integer(long), save ::    itmpin = 24
      integer(long), save ::    igo = 25

!-----------------------------------------------------------------------
! files
!-----------------------------------------------------------------------
      character(len=c5), save :: filein,fileout,file0,guessfile,filelog,datfile
      character(len=c5), save :: file0orient,fileq0,subfile0

!-----------------------------------------------------------------------
! CHARACTER STRINGS TO PASS MESSAGES TO ERROR ROUTINE
!-----------------------------------------------------------------------
      character(len=240), save  :: message1
      logical(kind=4), save     :: lgaanal

!-----------------------------------------------------------------------
! pointers for memory arrays
! optcoodim: no. of "coordinates" to be optimised in vchfit. Must be 
!            kept separate from other patahers in mc, mr, mi, ml arrays
!            due to structure of library routines separating main
!            program from function routines.
! mc, mr, mi, ml: complex, real, integer and logical memory arrays
!-----------------------------------------------------------------------
      integer(long), save :: optcoodim,mcdim,mrdim,midim,mldim,msdim,mfdim 
      integer(long), save :: mrenergy,mrder1,mrxder1,mrder2,mrxder2,mrdcp,mrxdcp,&
                             mrqcoo,mrxcoo,mrconst,mrkappa,mrlambda,mrgamma,mriota,&
                             mrmu,mrexpcoe,mrconstini,mrkappaini,mrlambdaini,&
                             mrgammaini,mriotaini,mrmuini,mrexpcoeini,mrtdip,&
                             mrhess,mrcovar,mrcorrel,mrdpar,mrerrpar,mrhigher,&
                             mrhigherini,mrtermk,mrtermkini,mrcpcoe,mrswitch

      integer(long), save :: mrkappa2,mrlambda2,mrgamma2,mrmu2,mriota2,mrexpcoe2,&
                             mrtermk2,mrkappa3,mrlambda3,mrgamma3,mrmu3,mriota3,&
                             mrexpcoe3,mrtermk3,mrlogdata,mrimportval

      integer(long), save :: miconstmask,mikappamask,milambdamask,&
                             migammamask,miiotamask,mimumask,miexpcoemask,&
                             mitermkmask,micpcoemask,miswitchmask

      integer(long), save :: mikappacomask,milambdacomask,migammacomask,mimucomask,&
                             miiotacomask,mitermkcomask,miexpcoecomask

!     2D couling functions
      integer(long), save :: micp2d, mrcp2d

!-----------------------------------------------------------------------
! pointers for memory arrays required in lmfit
!-----------------------------------------------------------------------
  integer(long), save :: mrdipole,mrpolar,mradipole,mrapolar,mrdipzero,&
                         mrdipder1,mrdipder2,mrdipder3,mrdipder4,&
                         mrpolarzero,mrpolarder1,mrpolarder2,mrpolarder3,&
                         mrpolarder4

  integer(long), save :: midipzeromask,midipder1mask,midipder2mask,&
                         midipder3mask,midipder4mask,mipolarzeromask,&
                         mipolarder1mask,mipolarder2mask,mipolarder3mask,&
                         mipolarder4mask

!-----------------------------------------------------------------------
! PARAMETERS FOR CALCULATIONS
!
! pi : pi is defined by 4d0*atan(1d0) 
! ev : energy conversion from a.u. to ev (x[a.u.] = x[eV]/ev).
!-----------------------------------------------------------------------
      !real(dop), save :: pi, fs, ev
      !removed by MAP 21/01/19 due to clashing with global constants
!-----------------------------------------------------------------------
! ___ for function passing - current state - silly idea, really
!-----------------------------------------------------------------------
      integer(long), save :: currsta,currsta1

!------------------------------------------------------------------------
! size of system
!
! ncoo:  no. Cartesian coordinates
! nmodes: no. internal (vibrational) modes
! nsta: no. states
! nsets: no. of datasets
! nsets1: If gradient information present, nsets1 = nsets
! nsets2: If hessian information present, nsets2 = nsets
! nsets3: If derivative coupling information present, nsets3 = nsets
! nsetm: maximum no. of sets - needed if nsets > maxset
! natm: no. of atoms
! nactdim: no. of NACs
!------------------------------------------------------------------------
      integer(long), save :: ncoo,nmodes,nsta,nsets,nsets1,nsets2,nsets3,nsetm,&
                             natm,fragnmodes,fragncoo,fragnatom,comb_nsta,&
                             nactdim = 1

      integer(long), parameter :: maxpar=400

      end module vcglobal


