C
      SUBROUTINE init_amoeba(p,y,x,ndim,func,rdata,idata)

      implicit none

      integer i,j,ndim,idata(*)
      real*8 func,rdata(*)
      real*8 p(ndim,ndim+1),h,y(ndim+1),x(ndim)
      

      print*,"Initialising Amoeba..."
      
      do i=1,ndim
         p(i,1)=x(i)
      enddo
      y(1)=func(p(1,1),rdata,idata)
      do j=2,ndim+1
         do i=1,ndim
            p(i,j)=x(i)
         enddo
         h=0.5
   10    continue
         p(j-1,j)=x(j-1)+h
         y(j)=func(p(1,j),rdata,idata)
         if (y(j) .gt. y(1)*1000.0) then
            h=h*0.9
            !print*, "Going to 10"
            go to 10
         endif
      enddo

      return
      end

C
C p(ndim+1,ndim) = input points
C y(ndim+1) = input values
C mp=ndim+1
C psum(ndim),ptry(ndim) = work arrays
C
      SUBROUTINE amoeba(p,y,ndim,ftol,func,iter,psum,ptry,rdata,idata)

      INTEGER iter,ndim,ITMAX,idata(*)
      REAL*8 ftol,p(ndim,ndim+1),y(ndim+1),func,rdata(*)
      !PARAMETER (ITMAX=5000)  !Changed from 100000 - MAP
      EXTERNAL func
CU    USES amotry,func
      INTEGER i,ihi,ilo,inhi,j,m,n,ifunc
      REAL*8 rtol,sum,swap,ysave,ytry,psum(ndim),amotry,ptry(ndim)

      print*,"Fitting Amoeba..."
      ITMAX = iter  !Added so that it obeys the input file
      iter=0
      ifunc=0   ! no. of function calls. This is iter in original code.

1     do 12 n=1,ndim

        sum=0.
        do 11 m=1,ndim+1
          sum=sum+p(n,m)
11      continue
        psum(n)=sum
12    continue
2     ilo=1
      if (y(1).gt.y(2)) then
        ihi=1
        inhi=2
      else
        ihi=2
        inhi=1
      endif
      do 13 i=1,ndim+1
        if(y(i).le.y(ilo)) ilo=i
        if(y(i).gt.y(ihi)) then
          inhi=ihi
          ihi=i
        else if(y(i).gt.y(inhi)) then
          if(i.ne.ihi) inhi=i
        endif
13    continue
      rtol=2.*abs(y(ihi)-y(ilo))/(abs(y(ihi))+abs(y(ilo)))
      print*, "ITER " , iter, ", change in tol " , rtol !MAP 23/07/19
      if (rtol.lt.ftol) then
        swap=y(1)
        y(1)=y(ilo)
        y(ilo)=swap
        do 21 n=1,ndim
          swap=p(n,1)
          p(n,1)=p(n,ilo)
          p(n,ilo)=swap
21      continue
        print*, "Amoeba Converged. No. function calls: ",ifunc
        return
      endif
      if (iter.ge.ITMAX) then 
        !added MAP even if too many iter return results
        !stop 'ITMAX exceeded in amoeba'
        print*, "ITMAX exceeded in amoeba. No. function calls: ",ifunc
        !return results so we see what we get MAP 23/07/19
        swap=y(1)
        y(1)=y(ilo)
        y(ilo)=swap
        do 14 n=1,ndim
          swap=p(n,1)
          p(n,1)=p(n,ilo)
          p(n,ilo)=swap
14      continue
        return
      endif
      iter=iter+1
      ifunc=ifunc+2
      ytry=amotry(p,y,psum,ndim,func,ihi,-1.0d0,ptry,rdata,idata)
      if (ytry.le.y(ilo)) then
        ytry=amotry(p,y,psum,ndim,func,ihi,2.0d0,ptry,rdata,idata)
      else if (ytry.ge.y(inhi)) then
        ysave=y(ihi)
        ytry=amotry(p,y,psum,ndim,func,ihi,0.5d0,ptry,rdata,idata)
        if (ytry.ge.ysave) then
          do 16 i=1,ndim+1
            if(i.ne.ilo)then
              do 15 j=1,ndim
                psum(j)=0.5*(p(j,i)+p(j,ilo))
                p(j,i)=psum(j)
15            continue
              y(i)=func(psum,rdata,idata)
            endif
16        continue
          ifunc=ifunc+ndim
          goto 1
        endif
       else
         ifunc=ifunc-1
      endif
      goto 2
      END

      FUNCTION amotry(p,y,psum,ndim,func,ihi,fac,ptry,rdata,idata)

      INTEGER ihi,ndim,idata(*)
      REAL*8 amotry,fac,p(ndim,ndim+1),psum(ndim),y(ndim+1),func,
     +       rdata(*)
      EXTERNAL func
CU    USES func
      INTEGER j
      REAL*8 fac1,fac2,ytry,ptry(ndim)
      fac1=(1.-fac)/ndim
      fac2=fac1-fac
      do 11 j=1,ndim
        ptry(j)=psum(j)*fac1-p(j,ihi)*fac2
11    continue
      ytry=func(ptry,rdata,idata)
      if (ytry.lt.y(ihi)) then
        y(ihi)=ytry
        do 12 j=1,ndim
          psum(j)=psum(j)-p(j,ihi)+ptry(j)
          p(j,ihi)=ptry(j)
12      continue
      endif
      amotry=ytry
      return
      END

