C
C iprn is a print flag
C      0 work silently   1 print 
C
      SUBROUTINE frprmn(p,n,ftol,iter,fret,func,dfunc,ilog,lb,iprn,
     +           rdata,idata)

      INTEGER iter,n,NMAX,ITMAX,ilog,iprn,idata(*)
      REAL*8 fret,ftol,p(n),EPS,func,lb,maxxi,rdata(*)
      EXTERNAL func,dfunc
      PARAMETER (NMAX=50000,EPS=1.e-10)
CU    USES dfunc,func,linmin
      INTEGER its,j
      REAL*8 dgg,fp,gam,gg,g(NMAX),h(NMAX),xi(NMAX)


      if (n .gt. nmax) then
         write(6,'(a,i5)') 'Redimension NMAX in frprmn. Minimum :',n
         stop
      endif
      if (iprn .eq. 1) then
         write(ilog,'(a,i5,5x,a,e16.8)') 'Niter = ',iter,'Tol = ',ftol
         write(6,'(a,i5,5x,a,e16.8)') 'Niter = ',iter,'Tol = ',ftol
      endif
      ITMAX = iter
      fp=func(p,rdata,idata)
      call dfunc(p,xi,rdata,idata)
      maxxi=0.0
      do 6 j=1,n
         maxxi=max(maxxi,abs(xi(j)))
 6    continue
      if(maxxi.le.ftol) then
         if(iprn .eq. 1) then
            write(ilog,'(a)') 'Zero gradients at start of Optimisation '
         endif

         return
      endif

      do 11 j=1,n
        g(j)=-xi(j)
        h(j)=g(j)
        xi(j)=h(j)
11    continue
      do 14 its=1,ITMAX
        iter=its
        if (iprn .eq. 1) then
           write(ilog,'(a,i7)') 
     +             '+++++++++++ calculating iteration: ',iter
           write(6,'(a,i7)') 
     +             '+++++++++++ calculating iteration: ',iter
        endif
        call linmin(p,xi,n,fret,func,rdata,idata)
        if (fret .lt. lb) then
           if (iprn .eq. 1) then
              write(ilog,'(a)') 'Under lower bounds for function '
              write(6,'(a,f12.8)') 
     +              'Under lower bounds for function ',fret
           endif

           return
        endif

        call dfunc(p,xi,rdata,idata)
        maxxi=0.0
        do 21 j=1,n
           maxxi=max(maxxi,abs(xi(j)))
21      continue
        if(maxxi.le.ftol) then
           if (iprn .eq. 1) then
              write(ilog,'(a)') 'Optimisation converged'
           else if (iprn .eq. 2) then
              write(ilog,'(a,i5)') 'Optimisation converged, Niter = ',iter
           endif

           return
        endif

        if(2.*abs(fret-fp).le.ftol*(abs(fret)+abs(fp)+EPS)) then
           if (iprn .eq. 1) then
              write(ilog,'(a,i5)') 'Optimisation finished, Niter = ',iter
              write(6,'(a,i5)') 'Optimisation finished, Niter = ',iter

              write(ilog,'(/,2a)') 
     +    'Optimisation: gradients above tolerance at convergence of',
     +    ' function'
              write(ilog,'(a,2e16.8)') 'Max. Grad/ tolerance : ',
     +           maxxi,ftol
              write(ilog,'(a)') 
     +    'Try different optimisation method? e.g. optimiser = simplex'

           endif

           return
        endif

        fp=func(p,rdata,idata)

        gg=0.
        dgg=0.
        do 12 j=1,n
          gg=gg+g(j)**2
          dgg=dgg+(xi(j)+g(j))*xi(j)
12      continue

        if(gg.eq.0.)return
        gam=dgg/gg
        do 13 j=1,n
          g(j)=-xi(j)
          h(j)=g(j)+gam*h(j)
          xi(j)=h(j)
13      continue
        if (iprn .eq. 1) then
           write(ilog,'(a,e16.8)') '  function value = ',fret
           write(6,'(a,e16.8)') '  function value = ',fret
        endif
14    continue
      if (iprn .eq. 1) then
         write(ilog,'(a)') 'Maximum optimisation iterations exceeded'
         write(6,'(a)') 'Maximum optimisation iterations exceeded'
      endif

      return
      END
