***********************************************************************
*
*     H4 PES Fit to the 6101 ab initio points of Boothroyd et al.
*     J. Chem. Phys. 95, 4331 (1991)
*
*     See :
*     A. Aguado, C. Suarez and M. Paniagua, J. C. P. 101, 4004, (1994)
*
************************************************************************
************************************************************************
*     See EQ. (1) in JCP paper
************************************************************************
      SUBROUTINE h4srf(RAB,RAC,RBC,RAD,RBD,RCD,v)
      IMPLICIT REAL*8 (A-H,O-Z)
      CALL H2KOLOS(RAB,EAB)
      CALL H2KOLOS(RAC,EAC)
      CALL H2KOLOS(RBC,EBC)
      CALL H2KOLOS(RAD,EAD)
      CALL H2KOLOS(RBD,EBD)
      CALL H2KOLOS(RCD,ECD)
      CALL H310(RAB,RAC,RBC,E3ABC)
      CALL H310(RAB,RAD,RBD,E3ABD)
      CALL H310(RAC,RAD,RCD,E3ACD)
      CALL H310(RBC,RBD,RCD,E3BCD)
      E4 = V4ABCD(RAB,RAC,RBC,RAD,RBD,RCD)
      v=E4+E3ABC+E3ABD+E3ACD+E3BCD+EAB+EAC+EBC+EAD+EBD+ECD
      RETURN
      END
************************************************************************
*     See EQ. (9) in JCP paper
************************************************************************
      FUNCTION V4ABCD(RAB,RAC,RBC,RAD,RBD,RCD)
      IMPLICIT  REAL * 8 (A-H,O-Z)
      PARAMETER (NEXP=865,IGRAD=12)
      COMMON /SM/ VEX,SM(NEXP),MT,IS
      COMMON /IPAINF/ IPA(NEXP,7)
      COMMON /XYZ/ X13(0:IGRAD-2), X23(0:IGRAD-2), X33(0:IGRAD-2),
     ,             X43(0:IGRAD-2), X53(0:IGRAD-2), X63(0:IGRAD-2)
      AUX = RAB*DEXP(-VEX*RAB)
      BUX = RAC*DEXP(-VEX*RAC)
      CUX = RBC*DEXP(-VEX*RBC)
      DUX = RAD*DEXP(-VEX*RAD)
      EUX = RBD*DEXP(-VEX*RBD)
      FUX = RCD*DEXP(-VEX*RCD)
      X13(0) = 1.D0
      X23(0) = 1.D0
      X33(0) = 1.D0
      X43(0) = 1.D0
      X53(0) = 1.D0
      X63(0) = 1.D0
      DO 70 IAUX = 1, MT-2
         X13(IAUX) = AUX*X13(IAUX-1)
         X23(IAUX) = BUX*X23(IAUX-1)
         X33(IAUX) = CUX*X33(IAUX-1)
         X43(IAUX) = DUX*X43(IAUX-1)
         X53(IAUX) = EUX*X53(IAUX-1)
         X63(IAUX) = FUX*X63(IAUX-1)
   70 CONTINUE
      SUM = 0.D0
      DO 1000 J=1,IS
      GOTO(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,
     ,     24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
     ,     41,42,43,44,45,46,47,48), IPA(J,7)
    1    xx = fun1(j)
         goto 999
    2    xx = fun2(j)
         goto 999
    3    xx = fun3(j)
         goto 999
    4    xx = fun4(j)
         goto 999
    5    xx = fun5(j)
         goto 999
    6    xx = fun6(j)
         goto 999
    7    xx = fun7(j)
         goto 999
    8    xx = fun8(j)
         goto 999
    9    xx = fun9(j)
         goto 999
   10    xx = fun10(j)
         goto 999
   11    xx = fun11(j)
         goto 999
   12    xx = fun12(j)
         goto 999
   13    xx = fun13(j)
         goto 999
   14    xx = fun14(j)
         goto 999
   15    xx = fun15(j)
         goto 999
   16    xx = fun16(j)
         goto 999
   17    xx = fun17(j)
         goto 999
   18    xx = fun18(j)
         goto 999
   19    xx = fun19(j)
         goto 999
   20    xx = fun20(j)
         goto 999
   21    xx = fun21(j)
         goto 999
   22    xx = fun22(j)
         goto 999
   23    xx = fun23(j)
         goto 999
   24    xx = fun24(j)
         goto 999
   25    xx = fun25(j)
         goto 999
   26    xx = fun26(j)
         goto 999
   27    xx = fun27(j)
         goto 999
   28    xx = fun28(j)
         goto 999
   29    xx = fun29(j)
         goto 999
   30    xx = fun30(j)
         goto 999
   31    xx = fun31(j)
         goto 999
   32    xx = fun32(j)
         goto 999
   33    xx = fun33(j)
         goto 999
   34    xx = fun34(j)
         goto 999
   35    xx = fun35(j)
         goto 999
   36    xx = fun36(j)
         goto 999
   37    xx = fun37(j)
         goto 999
   38    xx = fun38(j)
         goto 999
   39    xx = fun39(j)
         goto 999
   40    xx = fun40(j)
         goto 999
   41    xx = fun41(j)
         goto 999
   42    xx = fun42(j)
         goto 999
   43    xx = fun43(j)
         goto 999
   44    xx = fun44(j)
         goto 999
   45    xx = fun45(j)
         goto 999
   46    xx = fun46(j)
         goto 999
   47    xx = fun47(j)
         goto 999
   48    xx = fun48(j)
  999 CONTINUE
         SUM = SUM + SM(J)*XX
 1000 CONTINUE
      V4ABCD = SUM
      RETURN
      END
C      BLOCKDATA given a name GAW 7/19
      BLOCKDATA INIT
      IMPLICIT  REAL * 8 (A-H,O-Z)
      PARAMETER (NEXP=865)
      COMMON /IPAINF/ IPA(NEXP,7)
      DATA (IPA(  1,I),I=1,7)/ 1, 0, 1, 1, 0, 0, 6/
      DATA (IPA(  2,I),I=1,7)/ 1, 1, 0, 1, 0, 0, 7/
      DATA (IPA(  3,I),I=1,7)/ 0, 0, 1, 1, 1, 1, 3/
      DATA (IPA(  4,I),I=1,7)/ 1, 1, 0, 0, 1, 1, 4/
      DATA (IPA(  5,I),I=1,7)/ 2, 0, 1, 1, 0, 0,11/
      DATA (IPA(  6,I),I=1,7)/ 1, 0, 2, 1, 0, 0,12/
      DATA (IPA(  7,I),I=1,7)/ 2, 1, 0, 1, 0, 0,13/
      DATA (IPA(  8,I),I=1,7)/ 0, 1, 1, 1, 1, 1, 2/
      DATA (IPA(  9,I),I=1,7)/ 1, 0, 2, 2, 0, 0,11/
      DATA (IPA( 10,I),I=1,7)/ 2, 0, 1, 2, 0, 0,12/
      DATA (IPA( 11,I),I=1,7)/ 1, 2, 0, 2, 0, 0,13/
      DATA (IPA( 12,I),I=1,7)/ 2, 0, 0, 1, 1, 1,10/
      DATA (IPA( 13,I),I=1,7)/ 2, 1, 0, 0, 1, 1,11/
      DATA (IPA( 14,I),I=1,7)/ 0, 1, 2, 0, 1, 1,12/
      DATA (IPA( 15,I),I=1,7)/ 2, 0, 1, 0, 1, 1,13/
      DATA (IPA( 16,I),I=1,7)/ 3, 0, 1, 1, 0, 0,11/
      DATA (IPA( 17,I),I=1,7)/ 1, 0, 3, 1, 0, 0,12/
      DATA (IPA( 18,I),I=1,7)/ 3, 1, 0, 1, 0, 0,13/
      DATA (IPA( 19,I),I=1,7)/ 1, 1, 1, 1, 1, 1, 1/
      DATA (IPA( 20,I),I=1,7)/ 2, 0, 2, 2, 0, 0, 6/
      DATA (IPA( 21,I),I=1,7)/ 2, 2, 0, 2, 0, 0, 7/
      DATA (IPA( 22,I),I=1,7)/ 2, 0, 1, 1, 1, 1, 8/
      DATA (IPA( 23,I),I=1,7)/ 1, 1, 2, 0, 1, 1, 9/
      DATA (IPA( 24,I),I=1,7)/ 3, 0, 0, 1, 1, 1,10/
      DATA (IPA( 25,I),I=1,7)/ 3, 1, 0, 0, 1, 1,11/
      DATA (IPA( 26,I),I=1,7)/ 0, 1, 3, 0, 1, 1,12/
      DATA (IPA( 27,I),I=1,7)/ 3, 0, 1, 0, 1, 1,13/
      DATA (IPA( 28,I),I=1,7)/ 4, 0, 1, 1, 0, 0,11/
      DATA (IPA( 29,I),I=1,7)/ 1, 0, 4, 1, 0, 0,12/
      DATA (IPA( 30,I),I=1,7)/ 4, 1, 0, 1, 0, 0,13/
      DATA (IPA( 31,I),I=1,7)/ 2, 2, 1, 1, 0, 0,14/
      DATA (IPA( 32,I),I=1,7)/ 1, 1, 2, 2, 0, 0,15/
      DATA (IPA( 33,I),I=1,7)/ 0, 2, 2, 1, 1, 0,16/
      DATA (IPA( 34,I),I=1,7)/ 2, 1, 2, 1, 0, 0,17/
      DATA (IPA( 35,I),I=1,7)/ 2, 1, 1, 2, 0, 0,18/
      DATA (IPA( 36,I),I=1,7)/ 0, 1, 2, 2, 1, 0,19/
      DATA (IPA( 37,I),I=1,7)/ 3, 2, 0, 1, 0, 0,21/
      DATA (IPA( 38,I),I=1,7)/ 2, 0, 3, 1, 0, 0,22/
      DATA (IPA( 39,I),I=1,7)/ 3, 0, 2, 1, 0, 0,23/
      DATA (IPA( 40,I),I=1,7)/ 1, 0, 3, 2, 0, 0,24/
      DATA (IPA( 41,I),I=1,7)/ 2, 1, 1, 1, 1, 1, 2/
      DATA (IPA( 42,I),I=1,7)/ 3, 0, 1, 1, 1, 1, 8/
      DATA (IPA( 43,I),I=1,7)/ 1, 1, 3, 0, 1, 1, 9/
      DATA (IPA( 44,I),I=1,7)/ 5, 0, 1, 1, 0, 0,11/
      DATA (IPA( 45,I),I=1,7)/ 1, 0, 5, 1, 0, 0,12/
      DATA (IPA( 46,I),I=1,7)/ 5, 1, 0, 1, 0, 0,13/
      DATA (IPA( 47,I),I=1,7)/ 1, 0, 3, 3, 0, 0,11/
      DATA (IPA( 48,I),I=1,7)/ 3, 0, 1, 3, 0, 0,12/
      DATA (IPA( 49,I),I=1,7)/ 1, 3, 0, 3, 0, 0,13/
      DATA (IPA( 50,I),I=1,7)/ 3, 0, 2, 2, 0, 0,11/
      DATA (IPA( 51,I),I=1,7)/ 2, 0, 3, 2, 0, 0,12/
      DATA (IPA( 52,I),I=1,7)/ 3, 2, 0, 2, 0, 0,13/
      DATA (IPA( 53,I),I=1,7)/ 4, 0, 0, 1, 1, 1,10/
      DATA (IPA( 54,I),I=1,7)/ 4, 1, 0, 0, 1, 1,11/
      DATA (IPA( 55,I),I=1,7)/ 0, 1, 4, 0, 1, 1,12/
      DATA (IPA( 56,I),I=1,7)/ 4, 0, 1, 0, 1, 1,13/
      DATA (IPA( 57,I),I=1,7)/ 1, 0, 0, 2, 2, 2,10/
      DATA (IPA( 58,I),I=1,7)/ 1, 2, 0, 0, 2, 2,11/
      DATA (IPA( 59,I),I=1,7)/ 0, 2, 1, 0, 2, 2,12/
      DATA (IPA( 60,I),I=1,7)/ 1, 0, 2, 0, 2, 2,13/
      DATA (IPA( 61,I),I=1,7)/ 0, 2, 2, 1, 1, 1,10/
      DATA (IPA( 62,I),I=1,7)/ 0, 1, 2, 2, 1, 1,11/
      DATA (IPA( 63,I),I=1,7)/ 2, 1, 0, 2, 1, 1,12/
      DATA (IPA( 64,I),I=1,7)/ 0, 2, 1, 2, 1, 1,13/
      DATA (IPA( 65,I),I=1,7)/ 4, 2, 0, 1, 0, 0,21/
      DATA (IPA( 66,I),I=1,7)/ 2, 0, 4, 1, 0, 0,22/
      DATA (IPA( 67,I),I=1,7)/ 4, 0, 2, 1, 0, 0,23/
      DATA (IPA( 68,I),I=1,7)/ 1, 0, 4, 2, 0, 0,24/
      DATA (IPA( 69,I),I=1,7)/ 3, 2, 1, 1, 0, 0,25/
      DATA (IPA( 70,I),I=1,7)/ 3, 1, 1, 2, 0, 0,26/
      DATA (IPA( 71,I),I=1,7)/ 0, 3, 2, 1, 1, 0,27/
      DATA (IPA( 72,I),I=1,7)/ 0, 1, 3, 2, 1, 0,28/
      DATA (IPA( 73,I),I=1,7)/ 1, 1, 2, 3, 0, 0,29/
      DATA (IPA( 74,I),I=1,7)/ 2, 1, 3, 1, 0, 0,30/
      DATA (IPA( 75,I),I=1,7)/ 3, 1, 2, 1, 0, 0,31/
      DATA (IPA( 76,I),I=1,7)/ 2, 1, 1, 3, 0, 0,32/
      DATA (IPA( 77,I),I=1,7)/ 1, 1, 3, 2, 0, 0,33/
      DATA (IPA( 78,I),I=1,7)/ 3, 1, 1, 1, 1, 1, 2/
      DATA (IPA( 79,I),I=1,7)/ 0, 0, 2, 2, 2, 2, 3/
      DATA (IPA( 80,I),I=1,7)/ 2, 2, 0, 0, 2, 2, 4/
      DATA (IPA( 81,I),I=1,7)/ 2, 2, 1, 1, 1, 1, 3/
      DATA (IPA( 82,I),I=1,7)/ 1, 1, 2, 2, 1, 1, 4/
      DATA (IPA( 83,I),I=1,7)/ 4, 0, 1, 1, 1, 1, 8/
      DATA (IPA( 84,I),I=1,7)/ 1, 1, 4, 0, 1, 1, 9/
      DATA (IPA( 85,I),I=1,7)/ 6, 0, 1, 1, 0, 0,11/
      DATA (IPA( 86,I),I=1,7)/ 1, 0, 6, 1, 0, 0,12/
      DATA (IPA( 87,I),I=1,7)/ 6, 1, 0, 1, 0, 0,13/
      DATA (IPA( 88,I),I=1,7)/ 4, 0, 2, 2, 0, 0,11/
      DATA (IPA( 89,I),I=1,7)/ 2, 0, 4, 2, 0, 0,12/
      DATA (IPA( 90,I),I=1,7)/ 4, 2, 0, 2, 0, 0,13/
      DATA (IPA( 91,I),I=1,7)/ 2, 0, 3, 3, 0, 0,11/
      DATA (IPA( 92,I),I=1,7)/ 3, 0, 2, 3, 0, 0,12/
      DATA (IPA( 93,I),I=1,7)/ 2, 3, 0, 3, 0, 0,13/
      DATA (IPA( 94,I),I=1,7)/ 5, 0, 0, 1, 1, 1,10/
      DATA (IPA( 95,I),I=1,7)/ 5, 1, 0, 0, 1, 1,11/
      DATA (IPA( 96,I),I=1,7)/ 0, 1, 5, 0, 1, 1,12/
      DATA (IPA( 97,I),I=1,7)/ 5, 0, 1, 0, 1, 1,13/
      DATA (IPA( 98,I),I=1,7)/ 0, 1, 1, 2, 2, 2,10/
      DATA (IPA( 99,I),I=1,7)/ 0, 2, 1, 1, 2, 2,11/
      DATA (IPA(100,I),I=1,7)/ 1, 2, 0, 1, 2, 2,12/
      DATA (IPA(101,I),I=1,7)/ 0, 1, 2, 1, 2, 2,13/
      DATA (IPA(102,I),I=1,7)/ 3, 3, 1, 1, 0, 0,14/
      DATA (IPA(103,I),I=1,7)/ 1, 1, 3, 3, 0, 0,15/
      DATA (IPA(104,I),I=1,7)/ 0, 3, 3, 1, 1, 0,16/
      DATA (IPA(105,I),I=1,7)/ 3, 1, 3, 1, 0, 0,17/
      DATA (IPA(106,I),I=1,7)/ 3, 1, 1, 3, 0, 0,18/
      DATA (IPA(107,I),I=1,7)/ 0, 1, 3, 3, 1, 0,19/
      DATA (IPA(108,I),I=1,7)/ 5, 2, 0, 1, 0, 0,21/
      DATA (IPA(109,I),I=1,7)/ 2, 0, 5, 1, 0, 0,22/
      DATA (IPA(110,I),I=1,7)/ 5, 0, 2, 1, 0, 0,23/
      DATA (IPA(111,I),I=1,7)/ 1, 0, 5, 2, 0, 0,24/
      DATA (IPA(112,I),I=1,7)/ 4, 3, 0, 1, 0, 0,21/
      DATA (IPA(113,I),I=1,7)/ 3, 0, 4, 1, 0, 0,22/
      DATA (IPA(114,I),I=1,7)/ 4, 0, 3, 1, 0, 0,23/
      DATA (IPA(115,I),I=1,7)/ 1, 0, 4, 3, 0, 0,24/
      DATA (IPA(116,I),I=1,7)/ 3, 2, 0, 1, 1, 1,20/
      DATA (IPA(117,I),I=1,7)/ 3, 2, 1, 0, 1, 1,21/
      DATA (IPA(118,I),I=1,7)/ 2, 1, 3, 0, 1, 1,22/
      DATA (IPA(119,I),I=1,7)/ 3, 1, 2, 0, 1, 1,23/
      DATA (IPA(120,I),I=1,7)/ 0, 1, 3, 2, 1, 1,24/
      DATA (IPA(121,I),I=1,7)/ 4, 2, 1, 1, 0, 0,25/
      DATA (IPA(122,I),I=1,7)/ 4, 1, 1, 2, 0, 0,26/
      DATA (IPA(123,I),I=1,7)/ 0, 4, 2, 1, 1, 0,27/
      DATA (IPA(124,I),I=1,7)/ 0, 1, 4, 2, 1, 0,28/
      DATA (IPA(125,I),I=1,7)/ 1, 1, 2, 4, 0, 0,29/
      DATA (IPA(126,I),I=1,7)/ 2, 1, 4, 1, 0, 0,30/
      DATA (IPA(127,I),I=1,7)/ 4, 1, 2, 1, 0, 0,31/
      DATA (IPA(128,I),I=1,7)/ 2, 1, 1, 4, 0, 0,32/
      DATA (IPA(129,I),I=1,7)/ 1, 1, 4, 2, 0, 0,33/
      DATA (IPA(130,I),I=1,7)/ 3, 1, 2, 2, 0, 0,25/
      DATA (IPA(131,I),I=1,7)/ 3, 2, 2, 1, 0, 0,26/
      DATA (IPA(132,I),I=1,7)/ 0, 3, 1, 2, 2, 0,27/
      DATA (IPA(133,I),I=1,7)/ 0, 2, 3, 1, 2, 0,28/
      DATA (IPA(134,I),I=1,7)/ 2, 2, 1, 3, 0, 0,29/
      DATA (IPA(135,I),I=1,7)/ 1, 2, 3, 2, 0, 0,30/
      DATA (IPA(136,I),I=1,7)/ 3, 2, 1, 2, 0, 0,31/
      DATA (IPA(137,I),I=1,7)/ 1, 2, 2, 3, 0, 0,32/
      DATA (IPA(138,I),I=1,7)/ 2, 2, 3, 1, 0, 0,33/
      DATA (IPA(139,I),I=1,7)/ 4, 1, 1, 1, 1, 1, 2/
      DATA (IPA(140,I),I=1,7)/ 3, 0, 3, 3, 0, 0, 6/
      DATA (IPA(141,I),I=1,7)/ 3, 3, 0, 3, 0, 0, 7/
      DATA (IPA(142,I),I=1,7)/ 2, 2, 2, 1, 1, 1, 5/
      DATA (IPA(143,I),I=1,7)/ 2, 1, 2, 2, 1, 1, 6/
      DATA (IPA(144,I),I=1,7)/ 2, 2, 1, 2, 1, 1, 7/
      DATA (IPA(145,I),I=1,7)/ 5, 0, 1, 1, 1, 1, 8/
      DATA (IPA(146,I),I=1,7)/ 1, 1, 5, 0, 1, 1, 9/
      DATA (IPA(147,I),I=1,7)/ 3, 2, 1, 1, 1, 1, 8/
      DATA (IPA(148,I),I=1,7)/ 1, 1, 3, 2, 1, 1, 9/
      DATA (IPA(149,I),I=1,7)/ 1, 0, 2, 2, 2, 2, 8/
      DATA (IPA(150,I),I=1,7)/ 2, 2, 1, 0, 2, 2, 9/
      DATA (IPA(151,I),I=1,7)/ 7, 0, 1, 1, 0, 0,11/
      DATA (IPA(152,I),I=1,7)/ 1, 0, 7, 1, 0, 0,12/
      DATA (IPA(153,I),I=1,7)/ 7, 1, 0, 1, 0, 0,13/
      DATA (IPA(154,I),I=1,7)/ 5, 0, 2, 2, 0, 0,11/
      DATA (IPA(155,I),I=1,7)/ 2, 0, 5, 2, 0, 0,12/
      DATA (IPA(156,I),I=1,7)/ 5, 2, 0, 2, 0, 0,13/
      DATA (IPA(157,I),I=1,7)/ 1, 0, 4, 4, 0, 0,11/
      DATA (IPA(158,I),I=1,7)/ 4, 0, 1, 4, 0, 0,12/
      DATA (IPA(159,I),I=1,7)/ 1, 4, 0, 4, 0, 0,13/
      DATA (IPA(160,I),I=1,7)/ 6, 0, 0, 1, 1, 1,10/
      DATA (IPA(161,I),I=1,7)/ 6, 1, 0, 0, 1, 1,11/
      DATA (IPA(162,I),I=1,7)/ 0, 1, 6, 0, 1, 1,12/
      DATA (IPA(163,I),I=1,7)/ 6, 0, 1, 0, 1, 1,13/
      DATA (IPA(164,I),I=1,7)/ 3, 0, 0, 2, 2, 2,10/
      DATA (IPA(165,I),I=1,7)/ 3, 2, 0, 0, 2, 2,11/
      DATA (IPA(166,I),I=1,7)/ 0, 2, 3, 0, 2, 2,12/
      DATA (IPA(167,I),I=1,7)/ 3, 0, 2, 0, 2, 2,13/
      DATA (IPA(168,I),I=1,7)/ 0, 3, 3, 1, 1, 1,10/
      DATA (IPA(169,I),I=1,7)/ 0, 1, 3, 3, 1, 1,11/
      DATA (IPA(170,I),I=1,7)/ 3, 1, 0, 3, 1, 1,12/
      DATA (IPA(171,I),I=1,7)/ 0, 3, 1, 3, 1, 1,13/
      DATA (IPA(172,I),I=1,7)/ 5, 3, 0, 1, 0, 0,21/
      DATA (IPA(173,I),I=1,7)/ 3, 0, 5, 1, 0, 0,22/
      DATA (IPA(174,I),I=1,7)/ 5, 0, 3, 1, 0, 0,23/
      DATA (IPA(175,I),I=1,7)/ 1, 0, 5, 3, 0, 0,24/
      DATA (IPA(176,I),I=1,7)/ 6, 2, 0, 1, 0, 0,21/
      DATA (IPA(177,I),I=1,7)/ 2, 0, 6, 1, 0, 0,22/
      DATA (IPA(178,I),I=1,7)/ 6, 0, 2, 1, 0, 0,23/
      DATA (IPA(179,I),I=1,7)/ 1, 0, 6, 2, 0, 0,24/
      DATA (IPA(180,I),I=1,7)/ 4, 3, 0, 2, 0, 0,21/
      DATA (IPA(181,I),I=1,7)/ 3, 0, 4, 2, 0, 0,22/
      DATA (IPA(182,I),I=1,7)/ 4, 0, 3, 2, 0, 0,23/
      DATA (IPA(183,I),I=1,7)/ 2, 0, 4, 3, 0, 0,24/
      DATA (IPA(184,I),I=1,7)/ 4, 2, 0, 1, 1, 1,20/
      DATA (IPA(185,I),I=1,7)/ 4, 2, 1, 0, 1, 1,21/
      DATA (IPA(186,I),I=1,7)/ 2, 1, 4, 0, 1, 1,22/
      DATA (IPA(187,I),I=1,7)/ 4, 1, 2, 0, 1, 1,23/
      DATA (IPA(188,I),I=1,7)/ 0, 1, 4, 2, 1, 1,24/
      DATA (IPA(189,I),I=1,7)/ 5, 2, 1, 1, 0, 0,25/
      DATA (IPA(190,I),I=1,7)/ 5, 1, 1, 2, 0, 0,26/
      DATA (IPA(191,I),I=1,7)/ 0, 5, 2, 1, 1, 0,27/
      DATA (IPA(192,I),I=1,7)/ 0, 1, 5, 2, 1, 0,28/
      DATA (IPA(193,I),I=1,7)/ 1, 1, 2, 5, 0, 0,29/
      DATA (IPA(194,I),I=1,7)/ 2, 1, 5, 1, 0, 0,30/
      DATA (IPA(195,I),I=1,7)/ 5, 1, 2, 1, 0, 0,31/
      DATA (IPA(196,I),I=1,7)/ 2, 1, 1, 5, 0, 0,32/
      DATA (IPA(197,I),I=1,7)/ 1, 1, 5, 2, 0, 0,33/
      DATA (IPA(198,I),I=1,7)/ 4, 3, 1, 1, 0, 0,25/
      DATA (IPA(199,I),I=1,7)/ 4, 1, 1, 3, 0, 0,26/
      DATA (IPA(200,I),I=1,7)/ 0, 4, 3, 1, 1, 0,27/
      DATA (IPA(201,I),I=1,7)/ 0, 1, 4, 3, 1, 0,28/
      DATA (IPA(202,I),I=1,7)/ 1, 1, 3, 4, 0, 0,29/
      DATA (IPA(203,I),I=1,7)/ 3, 1, 4, 1, 0, 0,30/
      DATA (IPA(204,I),I=1,7)/ 4, 1, 3, 1, 0, 0,31/
      DATA (IPA(205,I),I=1,7)/ 3, 1, 1, 4, 0, 0,32/
      DATA (IPA(206,I),I=1,7)/ 1, 1, 4, 3, 0, 0,33/
      DATA (IPA(207,I),I=1,7)/ 4, 1, 2, 2, 0, 0,25/
      DATA (IPA(208,I),I=1,7)/ 4, 2, 2, 1, 0, 0,26/
      DATA (IPA(209,I),I=1,7)/ 0, 4, 1, 2, 2, 0,27/
      DATA (IPA(210,I),I=1,7)/ 0, 2, 4, 1, 2, 0,28/
      DATA (IPA(211,I),I=1,7)/ 2, 2, 1, 4, 0, 0,29/
      DATA (IPA(212,I),I=1,7)/ 1, 2, 4, 2, 0, 0,30/
      DATA (IPA(213,I),I=1,7)/ 4, 2, 1, 2, 0, 0,31/
      DATA (IPA(214,I),I=1,7)/ 1, 2, 2, 4, 0, 0,32/
      DATA (IPA(215,I),I=1,7)/ 2, 2, 4, 1, 0, 0,33/
      DATA (IPA(216,I),I=1,7)/ 2, 1, 3, 3, 0, 0,25/
      DATA (IPA(217,I),I=1,7)/ 2, 3, 3, 1, 0, 0,26/
      DATA (IPA(218,I),I=1,7)/ 0, 2, 1, 3, 3, 0,27/
      DATA (IPA(219,I),I=1,7)/ 0, 3, 2, 1, 3, 0,28/
      DATA (IPA(220,I),I=1,7)/ 3, 3, 1, 2, 0, 0,29/
      DATA (IPA(221,I),I=1,7)/ 1, 3, 2, 3, 0, 0,30/
      DATA (IPA(222,I),I=1,7)/ 2, 3, 1, 3, 0, 0,31/
      DATA (IPA(223,I),I=1,7)/ 1, 3, 3, 2, 0, 0,32/
      DATA (IPA(224,I),I=1,7)/ 3, 3, 2, 1, 0, 0,33/
      DATA (IPA(225,I),I=1,7)/ 3, 0, 2, 2, 1, 1,25/
      DATA (IPA(226,I),I=1,7)/ 3, 2, 2, 0, 1, 1,26/
      DATA (IPA(227,I),I=1,7)/ 1, 3, 0, 2, 2, 1,27/
      DATA (IPA(228,I),I=1,7)/ 1, 2, 3, 0, 2, 1,28/
      DATA (IPA(229,I),I=1,7)/ 2, 2, 0, 3, 1, 1,29/
      DATA (IPA(230,I),I=1,7)/ 0, 2, 3, 2, 1, 1,30/
      DATA (IPA(231,I),I=1,7)/ 3, 2, 0, 2, 1, 1,31/
      DATA (IPA(232,I),I=1,7)/ 0, 2, 2, 3, 1, 1,32/
      DATA (IPA(233,I),I=1,7)/ 2, 2, 3, 0, 1, 1,33/
      DATA (IPA(234,I),I=1,7)/ 5, 1, 1, 1, 1, 1, 2/
      DATA (IPA(235,I),I=1,7)/ 0, 2, 2, 2, 2, 2, 2/
      DATA (IPA(236,I),I=1,7)/ 3, 3, 1, 1, 1, 1, 3/
      DATA (IPA(237,I),I=1,7)/ 1, 1, 3, 3, 1, 1, 4/
      DATA (IPA(238,I),I=1,7)/ 1, 1, 2, 2, 2, 2, 3/
      DATA (IPA(239,I),I=1,7)/ 2, 2, 1, 1, 2, 2, 4/
      DATA (IPA(240,I),I=1,7)/ 6, 0, 1, 1, 1, 1, 8/
      DATA (IPA(241,I),I=1,7)/ 1, 1, 6, 0, 1, 1, 9/
      DATA (IPA(242,I),I=1,7)/ 4, 2, 1, 1, 1, 1, 8/
      DATA (IPA(243,I),I=1,7)/ 1, 1, 4, 2, 1, 1, 9/
      DATA (IPA(244,I),I=1,7)/ 8, 0, 1, 1, 0, 0,11/
      DATA (IPA(245,I),I=1,7)/ 1, 0, 8, 1, 0, 0,12/
      DATA (IPA(246,I),I=1,7)/ 8, 1, 0, 1, 0, 0,13/
      DATA (IPA(247,I),I=1,7)/ 6, 0, 2, 2, 0, 0,11/
      DATA (IPA(248,I),I=1,7)/ 2, 0, 6, 2, 0, 0,12/
      DATA (IPA(249,I),I=1,7)/ 6, 2, 0, 2, 0, 0,13/
      DATA (IPA(250,I),I=1,7)/ 4, 0, 3, 3, 0, 0,11/
      DATA (IPA(251,I),I=1,7)/ 3, 0, 4, 3, 0, 0,12/
      DATA (IPA(252,I),I=1,7)/ 4, 3, 0, 3, 0, 0,13/
      DATA (IPA(253,I),I=1,7)/ 2, 0, 4, 4, 0, 0,11/
      DATA (IPA(254,I),I=1,7)/ 4, 0, 2, 4, 0, 0,12/
      DATA (IPA(255,I),I=1,7)/ 2, 4, 0, 4, 0, 0,13/
      DATA (IPA(256,I),I=1,7)/ 7, 0, 0, 1, 1, 1,10/
      DATA (IPA(257,I),I=1,7)/ 7, 1, 0, 0, 1, 1,11/
      DATA (IPA(258,I),I=1,7)/ 0, 1, 7, 0, 1, 1,12/
      DATA (IPA(259,I),I=1,7)/ 7, 0, 1, 0, 1, 1,13/
      DATA (IPA(260,I),I=1,7)/ 4, 0, 0, 2, 2, 2,10/
      DATA (IPA(261,I),I=1,7)/ 4, 2, 0, 0, 2, 2,11/
      DATA (IPA(262,I),I=1,7)/ 0, 2, 4, 0, 2, 2,12/
      DATA (IPA(263,I),I=1,7)/ 4, 0, 2, 0, 2, 2,13/
      DATA (IPA(264,I),I=1,7)/ 1, 0, 0, 3, 3, 3,10/
      DATA (IPA(265,I),I=1,7)/ 1, 3, 0, 0, 3, 3,11/
      DATA (IPA(266,I),I=1,7)/ 0, 3, 1, 0, 3, 3,12/
      DATA (IPA(267,I),I=1,7)/ 1, 0, 3, 0, 3, 3,13/
      DATA (IPA(268,I),I=1,7)/ 3, 2, 2, 1, 1, 1,10/
      DATA (IPA(269,I),I=1,7)/ 3, 1, 2, 2, 1, 1,11/
      DATA (IPA(270,I),I=1,7)/ 2, 1, 3, 2, 1, 1,12/
      DATA (IPA(271,I),I=1,7)/ 3, 2, 1, 2, 1, 1,13/
      DATA (IPA(272,I),I=1,7)/ 4, 4, 1, 1, 0, 0,14/
      DATA (IPA(273,I),I=1,7)/ 1, 1, 4, 4, 0, 0,15/
      DATA (IPA(274,I),I=1,7)/ 0, 4, 4, 1, 1, 0,16/
      DATA (IPA(275,I),I=1,7)/ 4, 1, 4, 1, 0, 0,17/
      DATA (IPA(276,I),I=1,7)/ 4, 1, 1, 4, 0, 0,18/
      DATA (IPA(277,I),I=1,7)/ 0, 1, 4, 4, 1, 0,19/
      DATA (IPA(278,I),I=1,7)/ 3, 3, 2, 2, 0, 0,14/
      DATA (IPA(279,I),I=1,7)/ 2, 2, 3, 3, 0, 0,15/
      DATA (IPA(280,I),I=1,7)/ 0, 3, 3, 2, 2, 0,16/
      DATA (IPA(281,I),I=1,7)/ 3, 2, 3, 2, 0, 0,17/
      DATA (IPA(282,I),I=1,7)/ 3, 2, 2, 3, 0, 0,18/
      DATA (IPA(283,I),I=1,7)/ 0, 2, 3, 3, 2, 0,19/
      DATA (IPA(284,I),I=1,7)/ 7, 2, 0, 1, 0, 0,21/
      DATA (IPA(285,I),I=1,7)/ 2, 0, 7, 1, 0, 0,22/
      DATA (IPA(286,I),I=1,7)/ 7, 0, 2, 1, 0, 0,23/
      DATA (IPA(287,I),I=1,7)/ 1, 0, 7, 2, 0, 0,24/
      DATA (IPA(288,I),I=1,7)/ 6, 3, 0, 1, 0, 0,21/
      DATA (IPA(289,I),I=1,7)/ 3, 0, 6, 1, 0, 0,22/
      DATA (IPA(290,I),I=1,7)/ 6, 0, 3, 1, 0, 0,23/
      DATA (IPA(291,I),I=1,7)/ 1, 0, 6, 3, 0, 0,24/
      DATA (IPA(292,I),I=1,7)/ 5, 4, 0, 1, 0, 0,21/
      DATA (IPA(293,I),I=1,7)/ 4, 0, 5, 1, 0, 0,22/
      DATA (IPA(294,I),I=1,7)/ 5, 0, 4, 1, 0, 0,23/
      DATA (IPA(295,I),I=1,7)/ 1, 0, 5, 4, 0, 0,24/
      DATA (IPA(296,I),I=1,7)/ 5, 3, 0, 2, 0, 0,21/
      DATA (IPA(297,I),I=1,7)/ 3, 0, 5, 2, 0, 0,22/
      DATA (IPA(298,I),I=1,7)/ 5, 0, 3, 2, 0, 0,23/
      DATA (IPA(299,I),I=1,7)/ 2, 0, 5, 3, 0, 0,24/
      DATA (IPA(300,I),I=1,7)/ 5, 2, 0, 1, 1, 1,20/
      DATA (IPA(301,I),I=1,7)/ 5, 2, 1, 0, 1, 1,21/
      DATA (IPA(302,I),I=1,7)/ 2, 1, 5, 0, 1, 1,22/
      DATA (IPA(303,I),I=1,7)/ 5, 1, 2, 0, 1, 1,23/
      DATA (IPA(304,I),I=1,7)/ 0, 1, 5, 2, 1, 1,24/
      DATA (IPA(305,I),I=1,7)/ 4, 3, 0, 1, 1, 1,20/
      DATA (IPA(306,I),I=1,7)/ 4, 3, 1, 0, 1, 1,21/
      DATA (IPA(307,I),I=1,7)/ 3, 1, 4, 0, 1, 1,22/
      DATA (IPA(308,I),I=1,7)/ 4, 1, 3, 0, 1, 1,23/
      DATA (IPA(309,I),I=1,7)/ 0, 1, 4, 3, 1, 1,24/
      DATA (IPA(310,I),I=1,7)/ 3, 1, 0, 2, 2, 2,20/
      DATA (IPA(311,I),I=1,7)/ 3, 1, 2, 0, 2, 2,21/
      DATA (IPA(312,I),I=1,7)/ 1, 2, 3, 0, 2, 2,22/
      DATA (IPA(313,I),I=1,7)/ 3, 2, 1, 0, 2, 2,23/
      DATA (IPA(314,I),I=1,7)/ 0, 2, 3, 1, 2, 2,24/
      DATA (IPA(315,I),I=1,7)/ 6, 2, 1, 1, 0, 0,25/
      DATA (IPA(316,I),I=1,7)/ 6, 1, 1, 2, 0, 0,26/
      DATA (IPA(317,I),I=1,7)/ 0, 6, 2, 1, 1, 0,27/
      DATA (IPA(318,I),I=1,7)/ 0, 1, 6, 2, 1, 0,28/
      DATA (IPA(319,I),I=1,7)/ 1, 1, 2, 6, 0, 0,29/
      DATA (IPA(320,I),I=1,7)/ 2, 1, 6, 1, 0, 0,30/
      DATA (IPA(321,I),I=1,7)/ 6, 1, 2, 1, 0, 0,31/
      DATA (IPA(322,I),I=1,7)/ 2, 1, 1, 6, 0, 0,32/
      DATA (IPA(323,I),I=1,7)/ 1, 1, 6, 2, 0, 0,33/
      DATA (IPA(324,I),I=1,7)/ 5, 3, 1, 1, 0, 0,25/
      DATA (IPA(325,I),I=1,7)/ 5, 1, 1, 3, 0, 0,26/
      DATA (IPA(326,I),I=1,7)/ 0, 5, 3, 1, 1, 0,27/
      DATA (IPA(327,I),I=1,7)/ 0, 1, 5, 3, 1, 0,28/
      DATA (IPA(328,I),I=1,7)/ 1, 1, 3, 5, 0, 0,29/
      DATA (IPA(329,I),I=1,7)/ 3, 1, 5, 1, 0, 0,30/
      DATA (IPA(330,I),I=1,7)/ 5, 1, 3, 1, 0, 0,31/
      DATA (IPA(331,I),I=1,7)/ 3, 1, 1, 5, 0, 0,32/
      DATA (IPA(332,I),I=1,7)/ 1, 1, 5, 3, 0, 0,33/
      DATA (IPA(333,I),I=1,7)/ 5, 1, 2, 2, 0, 0,25/
      DATA (IPA(334,I),I=1,7)/ 5, 2, 2, 1, 0, 0,26/
      DATA (IPA(335,I),I=1,7)/ 0, 5, 1, 2, 2, 0,27/
      DATA (IPA(336,I),I=1,7)/ 0, 2, 5, 1, 2, 0,28/
      DATA (IPA(337,I),I=1,7)/ 2, 2, 1, 5, 0, 0,29/
      DATA (IPA(338,I),I=1,7)/ 1, 2, 5, 2, 0, 0,30/
      DATA (IPA(339,I),I=1,7)/ 5, 2, 1, 2, 0, 0,31/
      DATA (IPA(340,I),I=1,7)/ 1, 2, 2, 5, 0, 0,32/
      DATA (IPA(341,I),I=1,7)/ 2, 2, 5, 1, 0, 0,33/
      DATA (IPA(342,I),I=1,7)/ 4, 0, 2, 2, 1, 1,25/
      DATA (IPA(343,I),I=1,7)/ 4, 2, 2, 0, 1, 1,26/
      DATA (IPA(344,I),I=1,7)/ 1, 4, 0, 2, 2, 1,27/
      DATA (IPA(345,I),I=1,7)/ 1, 2, 4, 0, 2, 1,28/
      DATA (IPA(346,I),I=1,7)/ 2, 2, 0, 4, 1, 1,29/
      DATA (IPA(347,I),I=1,7)/ 0, 2, 4, 2, 1, 1,30/
      DATA (IPA(348,I),I=1,7)/ 4, 2, 0, 2, 1, 1,31/
      DATA (IPA(349,I),I=1,7)/ 0, 2, 2, 4, 1, 1,32/
      DATA (IPA(350,I),I=1,7)/ 2, 2, 4, 0, 1, 1,33/
      DATA (IPA(351,I),I=1,7)/ 2, 0, 3, 3, 1, 1,25/
      DATA (IPA(352,I),I=1,7)/ 2, 3, 3, 0, 1, 1,26/
      DATA (IPA(353,I),I=1,7)/ 1, 2, 0, 3, 3, 1,27/
      DATA (IPA(354,I),I=1,7)/ 1, 3, 2, 0, 3, 1,28/
      DATA (IPA(355,I),I=1,7)/ 3, 3, 0, 2, 1, 1,29/
      DATA (IPA(356,I),I=1,7)/ 0, 3, 2, 3, 1, 1,30/
      DATA (IPA(357,I),I=1,7)/ 2, 3, 0, 3, 1, 1,31/
      DATA (IPA(358,I),I=1,7)/ 0, 3, 3, 2, 1, 1,32/
      DATA (IPA(359,I),I=1,7)/ 3, 3, 2, 0, 1, 1,33/
      DATA (IPA(360,I),I=1,7)/ 4, 3, 2, 1, 0, 0,34/
      DATA (IPA(361,I),I=1,7)/ 4, 2, 3, 1, 0, 0,35/
      DATA (IPA(362,I),I=1,7)/ 0, 4, 3, 2, 1, 0,36/
      DATA (IPA(363,I),I=1,7)/ 0, 3, 4, 2, 1, 0,37/
      DATA (IPA(364,I),I=1,7)/ 2, 1, 3, 4, 0, 0,38/
      DATA (IPA(365,I),I=1,7)/ 4, 2, 1, 3, 0, 0,39/
      DATA (IPA(366,I),I=1,7)/ 4, 3, 1, 2, 0, 0,40/
      DATA (IPA(367,I),I=1,7)/ 3, 2, 1, 4, 0, 0,41/
      DATA (IPA(368,I),I=1,7)/ 4, 1, 2, 3, 0, 0,42/
      DATA (IPA(369,I),I=1,7)/ 3, 1, 2, 4, 0, 0,43/
      DATA (IPA(370,I),I=1,7)/ 4, 1, 3, 2, 0, 0,44/
      DATA (IPA(371,I),I=1,7)/ 3, 2, 4, 1, 0, 0,45/
      DATA (IPA(372,I),I=1,7)/ 3, 1, 4, 2, 0, 0,46/
      DATA (IPA(373,I),I=1,7)/ 2, 1, 4, 3, 0, 0,47/
      DATA (IPA(374,I),I=1,7)/ 0, 2, 4, 3, 1, 0,48/
      DATA (IPA(375,I),I=1,7)/ 6, 1, 1, 1, 1, 1, 2/
      DATA (IPA(376,I),I=1,7)/ 1, 2, 2, 2, 2, 2, 2/
      DATA (IPA(377,I),I=1,7)/ 7, 0, 1, 1, 1, 1, 8/
      DATA (IPA(378,I),I=1,7)/ 1, 1, 7, 0, 1, 1, 9/
      DATA (IPA(379,I),I=1,7)/ 3, 0, 2, 2, 2, 2, 8/
      DATA (IPA(380,I),I=1,7)/ 2, 2, 3, 0, 2, 2, 9/
      DATA (IPA(381,I),I=1,7)/ 5, 2, 1, 1, 1, 1, 8/
      DATA (IPA(382,I),I=1,7)/ 1, 1, 5, 2, 1, 1, 9/
      DATA (IPA(383,I),I=1,7)/ 4, 3, 1, 1, 1, 1, 8/
      DATA (IPA(384,I),I=1,7)/ 1, 1, 4, 3, 1, 1, 9/
      DATA (IPA(385,I),I=1,7)/ 9, 0, 1, 1, 0, 0,11/
      DATA (IPA(386,I),I=1,7)/ 1, 0, 9, 1, 0, 0,12/
      DATA (IPA(387,I),I=1,7)/ 9, 1, 0, 1, 0, 0,13/
      DATA (IPA(388,I),I=1,7)/ 7, 0, 2, 2, 0, 0,11/
      DATA (IPA(389,I),I=1,7)/ 2, 0, 7, 2, 0, 0,12/
      DATA (IPA(390,I),I=1,7)/ 7, 2, 0, 2, 0, 0,13/
      DATA (IPA(391,I),I=1,7)/ 1, 0, 5, 5, 0, 0,11/
      DATA (IPA(392,I),I=1,7)/ 5, 0, 1, 5, 0, 0,12/
      DATA (IPA(393,I),I=1,7)/ 1, 5, 0, 5, 0, 0,13/
      DATA (IPA(394,I),I=1,7)/ 5, 0, 3, 3, 0, 0,11/
      DATA (IPA(395,I),I=1,7)/ 3, 0, 5, 3, 0, 0,12/
      DATA (IPA(396,I),I=1,7)/ 5, 3, 0, 3, 0, 0,13/
      DATA (IPA(397,I),I=1,7)/ 3, 0, 4, 4, 0, 0,11/
      DATA (IPA(398,I),I=1,7)/ 4, 0, 3, 4, 0, 0,12/
      DATA (IPA(399,I),I=1,7)/ 3, 4, 0, 4, 0, 0,13/
      DATA (IPA(400,I),I=1,7)/ 8, 0, 0, 1, 1, 1,10/
      DATA (IPA(401,I),I=1,7)/ 8, 1, 0, 0, 1, 1,11/
      DATA (IPA(402,I),I=1,7)/ 0, 1, 8, 0, 1, 1,12/
      DATA (IPA(403,I),I=1,7)/ 8, 0, 1, 0, 1, 1,13/
      DATA (IPA(404,I),I=1,7)/ 5, 0, 0, 2, 2, 2,10/
      DATA (IPA(405,I),I=1,7)/ 5, 2, 0, 0, 2, 2,11/
      DATA (IPA(406,I),I=1,7)/ 0, 2, 5, 0, 2, 2,12/
      DATA (IPA(407,I),I=1,7)/ 5, 0, 2, 0, 2, 2,13/
      DATA (IPA(408,I),I=1,7)/ 2, 0, 0, 3, 3, 3,10/
      DATA (IPA(409,I),I=1,7)/ 2, 3, 0, 0, 3, 3,11/
      DATA (IPA(410,I),I=1,7)/ 0, 3, 2, 0, 3, 3,12/
      DATA (IPA(411,I),I=1,7)/ 2, 0, 3, 0, 3, 3,13/
      DATA (IPA(412,I),I=1,7)/ 0, 4, 4, 1, 1, 1,10/
      DATA (IPA(413,I),I=1,7)/ 0, 1, 4, 4, 1, 1,11/
      DATA (IPA(414,I),I=1,7)/ 4, 1, 0, 4, 1, 1,12/
      DATA (IPA(415,I),I=1,7)/ 0, 4, 1, 4, 1, 1,13/
      DATA (IPA(416,I),I=1,7)/ 0, 1, 1, 3, 3, 3,10/
      DATA (IPA(417,I),I=1,7)/ 0, 3, 1, 1, 3, 3,11/
      DATA (IPA(418,I),I=1,7)/ 1, 3, 0, 1, 3, 3,12/
      DATA (IPA(419,I),I=1,7)/ 0, 1, 3, 1, 3, 3,13/
      DATA (IPA(420,I),I=1,7)/ 4, 2, 2, 1, 1, 1,10/
      DATA (IPA(421,I),I=1,7)/ 4, 1, 2, 2, 1, 1,11/
      DATA (IPA(422,I),I=1,7)/ 2, 1, 4, 2, 1, 1,12/
      DATA (IPA(423,I),I=1,7)/ 4, 2, 1, 2, 1, 1,13/
      DATA (IPA(424,I),I=1,7)/ 2, 3, 3, 1, 1, 1,10/
      DATA (IPA(425,I),I=1,7)/ 2, 1, 3, 3, 1, 1,11/
      DATA (IPA(426,I),I=1,7)/ 3, 1, 2, 3, 1, 1,12/
      DATA (IPA(427,I),I=1,7)/ 2, 3, 1, 3, 1, 1,13/
      DATA (IPA(428,I),I=1,7)/ 3, 1, 1, 2, 2, 2,10/
      DATA (IPA(429,I),I=1,7)/ 3, 2, 1, 1, 2, 2,11/
      DATA (IPA(430,I),I=1,7)/ 1, 2, 3, 1, 2, 2,12/
      DATA (IPA(431,I),I=1,7)/ 3, 1, 2, 1, 2, 2,13/
      DATA (IPA(432,I),I=1,7)/ 8, 2, 0, 1, 0, 0,21/
      DATA (IPA(433,I),I=1,7)/ 2, 0, 8, 1, 0, 0,22/
      DATA (IPA(434,I),I=1,7)/ 8, 0, 2, 1, 0, 0,23/
      DATA (IPA(435,I),I=1,7)/ 1, 0, 8, 2, 0, 0,24/
      DATA (IPA(436,I),I=1,7)/ 7, 3, 0, 1, 0, 0,21/
      DATA (IPA(437,I),I=1,7)/ 3, 0, 7, 1, 0, 0,22/
      DATA (IPA(438,I),I=1,7)/ 7, 0, 3, 1, 0, 0,23/
      DATA (IPA(439,I),I=1,7)/ 1, 0, 7, 3, 0, 0,24/
      DATA (IPA(440,I),I=1,7)/ 6, 4, 0, 1, 0, 0,21/
      DATA (IPA(441,I),I=1,7)/ 4, 0, 6, 1, 0, 0,22/
      DATA (IPA(442,I),I=1,7)/ 6, 0, 4, 1, 0, 0,23/
      DATA (IPA(443,I),I=1,7)/ 1, 0, 6, 4, 0, 0,24/
      DATA (IPA(444,I),I=1,7)/ 6, 3, 0, 2, 0, 0,21/
      DATA (IPA(445,I),I=1,7)/ 3, 0, 6, 2, 0, 0,22/
      DATA (IPA(446,I),I=1,7)/ 6, 0, 3, 2, 0, 0,23/
      DATA (IPA(447,I),I=1,7)/ 2, 0, 6, 3, 0, 0,24/
      DATA (IPA(448,I),I=1,7)/ 5, 4, 0, 2, 0, 0,21/
      DATA (IPA(449,I),I=1,7)/ 4, 0, 5, 2, 0, 0,22/
      DATA (IPA(450,I),I=1,7)/ 5, 0, 4, 2, 0, 0,23/
      DATA (IPA(451,I),I=1,7)/ 2, 0, 5, 4, 0, 0,24/
      DATA (IPA(452,I),I=1,7)/ 6, 2, 0, 1, 1, 1,20/
      DATA (IPA(453,I),I=1,7)/ 6, 2, 1, 0, 1, 1,21/
      DATA (IPA(454,I),I=1,7)/ 2, 1, 6, 0, 1, 1,22/
      DATA (IPA(455,I),I=1,7)/ 6, 1, 2, 0, 1, 1,23/
      DATA (IPA(456,I),I=1,7)/ 0, 1, 6, 2, 1, 1,24/
      DATA (IPA(457,I),I=1,7)/ 5, 3, 0, 1, 1, 1,20/
      DATA (IPA(458,I),I=1,7)/ 5, 3, 1, 0, 1, 1,21/
      DATA (IPA(459,I),I=1,7)/ 3, 1, 5, 0, 1, 1,22/
      DATA (IPA(460,I),I=1,7)/ 5, 1, 3, 0, 1, 1,23/
      DATA (IPA(461,I),I=1,7)/ 0, 1, 5, 3, 1, 1,24/
      DATA (IPA(462,I),I=1,7)/ 4, 1, 0, 2, 2, 2,20/
      DATA (IPA(463,I),I=1,7)/ 4, 1, 2, 0, 2, 2,21/
      DATA (IPA(464,I),I=1,7)/ 1, 2, 4, 0, 2, 2,22/
      DATA (IPA(465,I),I=1,7)/ 4, 2, 1, 0, 2, 2,23/
      DATA (IPA(466,I),I=1,7)/ 0, 2, 4, 1, 2, 2,24/
      DATA (IPA(467,I),I=1,7)/ 7, 2, 1, 1, 0, 0,25/
      DATA (IPA(468,I),I=1,7)/ 7, 1, 1, 2, 0, 0,26/
      DATA (IPA(469,I),I=1,7)/ 0, 7, 2, 1, 1, 0,27/
      DATA (IPA(470,I),I=1,7)/ 0, 1, 7, 2, 1, 0,28/
      DATA (IPA(471,I),I=1,7)/ 1, 1, 2, 7, 0, 0,29/
      DATA (IPA(472,I),I=1,7)/ 2, 1, 7, 1, 0, 0,30/
      DATA (IPA(473,I),I=1,7)/ 7, 1, 2, 1, 0, 0,31/
      DATA (IPA(474,I),I=1,7)/ 2, 1, 1, 7, 0, 0,32/
      DATA (IPA(475,I),I=1,7)/ 1, 1, 7, 2, 0, 0,33/
      DATA (IPA(476,I),I=1,7)/ 6, 3, 1, 1, 0, 0,25/
      DATA (IPA(477,I),I=1,7)/ 6, 1, 1, 3, 0, 0,26/
      DATA (IPA(478,I),I=1,7)/ 0, 6, 3, 1, 1, 0,27/
      DATA (IPA(479,I),I=1,7)/ 0, 1, 6, 3, 1, 0,28/
      DATA (IPA(480,I),I=1,7)/ 1, 1, 3, 6, 0, 0,29/
      DATA (IPA(481,I),I=1,7)/ 3, 1, 6, 1, 0, 0,30/
      DATA (IPA(482,I),I=1,7)/ 6, 1, 3, 1, 0, 0,31/
      DATA (IPA(483,I),I=1,7)/ 3, 1, 1, 6, 0, 0,32/
      DATA (IPA(484,I),I=1,7)/ 1, 1, 6, 3, 0, 0,33/
      DATA (IPA(485,I),I=1,7)/ 5, 4, 1, 1, 0, 0,25/
      DATA (IPA(486,I),I=1,7)/ 5, 1, 1, 4, 0, 0,26/
      DATA (IPA(487,I),I=1,7)/ 0, 5, 4, 1, 1, 0,27/
      DATA (IPA(488,I),I=1,7)/ 0, 1, 5, 4, 1, 0,28/
      DATA (IPA(489,I),I=1,7)/ 1, 1, 4, 5, 0, 0,29/
      DATA (IPA(490,I),I=1,7)/ 4, 1, 5, 1, 0, 0,30/
      DATA (IPA(491,I),I=1,7)/ 5, 1, 4, 1, 0, 0,31/
      DATA (IPA(492,I),I=1,7)/ 4, 1, 1, 5, 0, 0,32/
      DATA (IPA(493,I),I=1,7)/ 1, 1, 5, 4, 0, 0,33/
      DATA (IPA(494,I),I=1,7)/ 6, 1, 2, 2, 0, 0,25/
      DATA (IPA(495,I),I=1,7)/ 6, 2, 2, 1, 0, 0,26/
      DATA (IPA(496,I),I=1,7)/ 0, 6, 1, 2, 2, 0,27/
      DATA (IPA(497,I),I=1,7)/ 0, 2, 6, 1, 2, 0,28/
      DATA (IPA(498,I),I=1,7)/ 2, 2, 1, 6, 0, 0,29/
      DATA (IPA(499,I),I=1,7)/ 1, 2, 6, 2, 0, 0,30/
      DATA (IPA(500,I),I=1,7)/ 6, 2, 1, 2, 0, 0,31/
      DATA (IPA(501,I),I=1,7)/ 1, 2, 2, 6, 0, 0,32/
      DATA (IPA(502,I),I=1,7)/ 2, 2, 6, 1, 0, 0,33/
      DATA (IPA(503,I),I=1,7)/ 4, 3, 2, 2, 0, 0,25/
      DATA (IPA(504,I),I=1,7)/ 4, 2, 2, 3, 0, 0,26/
      DATA (IPA(505,I),I=1,7)/ 0, 4, 3, 2, 2, 0,27/
      DATA (IPA(506,I),I=1,7)/ 0, 2, 4, 3, 2, 0,28/
      DATA (IPA(507,I),I=1,7)/ 2, 2, 3, 4, 0, 0,29/
      DATA (IPA(508,I),I=1,7)/ 3, 2, 4, 2, 0, 0,30/
      DATA (IPA(509,I),I=1,7)/ 4, 2, 3, 2, 0, 0,31/
      DATA (IPA(510,I),I=1,7)/ 3, 2, 2, 4, 0, 0,32/
      DATA (IPA(511,I),I=1,7)/ 2, 2, 4, 3, 0, 0,33/
      DATA (IPA(512,I),I=1,7)/ 4, 1, 3, 3, 0, 0,25/
      DATA (IPA(513,I),I=1,7)/ 4, 3, 3, 1, 0, 0,26/
      DATA (IPA(514,I),I=1,7)/ 0, 4, 1, 3, 3, 0,27/
      DATA (IPA(515,I),I=1,7)/ 0, 3, 4, 1, 3, 0,28/
      DATA (IPA(516,I),I=1,7)/ 3, 3, 1, 4, 0, 0,29/
      DATA (IPA(517,I),I=1,7)/ 1, 3, 4, 3, 0, 0,30/
      DATA (IPA(518,I),I=1,7)/ 4, 3, 1, 3, 0, 0,31/
      DATA (IPA(519,I),I=1,7)/ 1, 3, 3, 4, 0, 0,32/
      DATA (IPA(520,I),I=1,7)/ 3, 3, 4, 1, 0, 0,33/
      DATA (IPA(521,I),I=1,7)/ 2, 1, 4, 4, 0, 0,25/
      DATA (IPA(522,I),I=1,7)/ 2, 4, 4, 1, 0, 0,26/
      DATA (IPA(523,I),I=1,7)/ 0, 2, 1, 4, 4, 0,27/
      DATA (IPA(524,I),I=1,7)/ 0, 4, 2, 1, 4, 0,28/
      DATA (IPA(525,I),I=1,7)/ 4, 4, 1, 2, 0, 0,29/
      DATA (IPA(526,I),I=1,7)/ 1, 4, 2, 4, 0, 0,30/
      DATA (IPA(527,I),I=1,7)/ 2, 4, 1, 4, 0, 0,31/
      DATA (IPA(528,I),I=1,7)/ 1, 4, 4, 2, 0, 0,32/
      DATA (IPA(529,I),I=1,7)/ 4, 4, 2, 1, 0, 0,33/
      DATA (IPA(530,I),I=1,7)/ 5, 0, 2, 2, 1, 1,25/
      DATA (IPA(531,I),I=1,7)/ 5, 2, 2, 0, 1, 1,26/
      DATA (IPA(532,I),I=1,7)/ 1, 5, 0, 2, 2, 1,27/
      DATA (IPA(533,I),I=1,7)/ 1, 2, 5, 0, 2, 1,28/
      DATA (IPA(534,I),I=1,7)/ 2, 2, 0, 5, 1, 1,29/
      DATA (IPA(535,I),I=1,7)/ 0, 2, 5, 2, 1, 1,30/
      DATA (IPA(536,I),I=1,7)/ 5, 2, 0, 2, 1, 1,31/
      DATA (IPA(537,I),I=1,7)/ 0, 2, 2, 5, 1, 1,32/
      DATA (IPA(538,I),I=1,7)/ 2, 2, 5, 0, 1, 1,33/
      DATA (IPA(539,I),I=1,7)/ 1, 0, 3, 3, 2, 2,25/
      DATA (IPA(540,I),I=1,7)/ 1, 3, 3, 0, 2, 2,26/
      DATA (IPA(541,I),I=1,7)/ 2, 1, 0, 3, 3, 2,27/
      DATA (IPA(542,I),I=1,7)/ 2, 3, 1, 0, 3, 2,28/
      DATA (IPA(543,I),I=1,7)/ 3, 3, 0, 1, 2, 2,29/
      DATA (IPA(544,I),I=1,7)/ 0, 3, 1, 3, 2, 2,30/
      DATA (IPA(545,I),I=1,7)/ 1, 3, 0, 3, 2, 2,31/
      DATA (IPA(546,I),I=1,7)/ 0, 3, 3, 1, 2, 2,32/
      DATA (IPA(547,I),I=1,7)/ 3, 3, 1, 0, 2, 2,33/
      DATA (IPA(548,I),I=1,7)/ 5, 3, 2, 1, 0, 0,34/
      DATA (IPA(549,I),I=1,7)/ 5, 2, 3, 1, 0, 0,35/
      DATA (IPA(550,I),I=1,7)/ 0, 5, 3, 2, 1, 0,36/
      DATA (IPA(551,I),I=1,7)/ 0, 3, 5, 2, 1, 0,37/
      DATA (IPA(552,I),I=1,7)/ 2, 1, 3, 5, 0, 0,38/
      DATA (IPA(553,I),I=1,7)/ 5, 2, 1, 3, 0, 0,39/
      DATA (IPA(554,I),I=1,7)/ 5, 3, 1, 2, 0, 0,40/
      DATA (IPA(555,I),I=1,7)/ 3, 2, 1, 5, 0, 0,41/
      DATA (IPA(556,I),I=1,7)/ 5, 1, 2, 3, 0, 0,42/
      DATA (IPA(557,I),I=1,7)/ 3, 1, 2, 5, 0, 0,43/
      DATA (IPA(558,I),I=1,7)/ 5, 1, 3, 2, 0, 0,44/
      DATA (IPA(559,I),I=1,7)/ 3, 2, 5, 1, 0, 0,45/
      DATA (IPA(560,I),I=1,7)/ 3, 1, 5, 2, 0, 0,46/
      DATA (IPA(561,I),I=1,7)/ 2, 1, 5, 3, 0, 0,47/
      DATA (IPA(562,I),I=1,7)/ 0, 2, 5, 3, 1, 0,48/
      DATA (IPA(563,I),I=1,7)/ 4, 3, 2, 0, 1, 1,34/
      DATA (IPA(564,I),I=1,7)/ 4, 2, 3, 0, 1, 1,35/
      DATA (IPA(565,I),I=1,7)/ 1, 4, 3, 2, 0, 1,36/
      DATA (IPA(566,I),I=1,7)/ 1, 3, 4, 2, 0, 1,37/
      DATA (IPA(567,I),I=1,7)/ 2, 0, 3, 4, 1, 1,38/
      DATA (IPA(568,I),I=1,7)/ 4, 2, 0, 3, 1, 1,39/
      DATA (IPA(569,I),I=1,7)/ 4, 3, 0, 2, 1, 1,40/
      DATA (IPA(570,I),I=1,7)/ 3, 2, 0, 4, 1, 1,41/
      DATA (IPA(571,I),I=1,7)/ 4, 0, 2, 3, 1, 1,42/
      DATA (IPA(572,I),I=1,7)/ 3, 0, 2, 4, 1, 1,43/
      DATA (IPA(573,I),I=1,7)/ 4, 0, 3, 2, 1, 1,44/
      DATA (IPA(574,I),I=1,7)/ 3, 2, 4, 0, 1, 1,45/
      DATA (IPA(575,I),I=1,7)/ 3, 0, 4, 2, 1, 1,46/
      DATA (IPA(576,I),I=1,7)/ 2, 0, 4, 3, 1, 1,47/
      DATA (IPA(577,I),I=1,7)/ 1, 2, 4, 3, 0, 1,48/
      DATA (IPA(578,I),I=1,7)/ 2, 2, 2, 2, 2, 2, 1/
      DATA (IPA(579,I),I=1,7)/ 7, 1, 1, 1, 1, 1, 2/
      DATA (IPA(580,I),I=1,7)/ 4, 4, 1, 1, 1, 1, 3/
      DATA (IPA(581,I),I=1,7)/ 1, 1, 4, 4, 1, 1, 4/
      DATA (IPA(582,I),I=1,7)/ 0, 0, 3, 3, 3, 3, 3/
      DATA (IPA(583,I),I=1,7)/ 3, 3, 0, 0, 3, 3, 4/
      DATA (IPA(584,I),I=1,7)/ 4, 0, 4, 4, 0, 0, 6/
      DATA (IPA(585,I),I=1,7)/ 4, 4, 0, 4, 0, 0, 7/
      DATA (IPA(586,I),I=1,7)/ 3, 3, 3, 1, 1, 1, 5/
      DATA (IPA(587,I),I=1,7)/ 3, 1, 3, 3, 1, 1, 6/
      DATA (IPA(588,I),I=1,7)/ 3, 3, 1, 3, 1, 1, 7/
      DATA (IPA(589,I),I=1,7)/ 8, 0, 1, 1, 1, 1, 8/
      DATA (IPA(590,I),I=1,7)/ 1, 1, 8, 0, 1, 1, 9/
      DATA (IPA(591,I),I=1,7)/ 6, 2, 1, 1, 1, 1, 8/
      DATA (IPA(592,I),I=1,7)/ 1, 1, 6, 2, 1, 1, 9/
      DATA (IPA(593,I),I=1,7)/ 5, 3, 1, 1, 1, 1, 8/
      DATA (IPA(594,I),I=1,7)/ 1, 1, 5, 3, 1, 1, 9/
      DATA (IPA(595,I),I=1,7)/ 4, 0, 2, 2, 2, 2, 8/
      DATA (IPA(596,I),I=1,7)/ 2, 2, 4, 0, 2, 2, 9/
      DATA (IPA(597,I),I=1,7)/ 3, 1, 2, 2, 2, 2, 8/
      DATA (IPA(598,I),I=1,7)/ 2, 2, 3, 1, 2, 2, 9/
      DATA (IPA(599,I),I=1,7)/10, 0, 1, 1, 0, 0,11/
      DATA (IPA(600,I),I=1,7)/ 1, 0,10, 1, 0, 0,12/
      DATA (IPA(601,I),I=1,7)/10, 1, 0, 1, 0, 0,13/
      DATA (IPA(602,I),I=1,7)/ 9, 0, 0, 1, 1, 1,10/
      DATA (IPA(603,I),I=1,7)/ 9, 1, 0, 0, 1, 1,11/
      DATA (IPA(604,I),I=1,7)/ 0, 1, 9, 0, 1, 1,12/
      DATA (IPA(605,I),I=1,7)/ 9, 0, 1, 0, 1, 1,13/
      DATA (IPA(606,I),I=1,7)/ 8, 0, 2, 2, 0, 0,11/
      DATA (IPA(607,I),I=1,7)/ 2, 0, 8, 2, 0, 0,12/
      DATA (IPA(608,I),I=1,7)/ 8, 2, 0, 2, 0, 0,13/
      DATA (IPA(609,I),I=1,7)/ 6, 0, 3, 3, 0, 0,11/
      DATA (IPA(610,I),I=1,7)/ 3, 0, 6, 3, 0, 0,12/
      DATA (IPA(611,I),I=1,7)/ 6, 3, 0, 3, 0, 0,13/
      DATA (IPA(612,I),I=1,7)/ 6, 0, 0, 2, 2, 2,10/
      DATA (IPA(613,I),I=1,7)/ 6, 2, 0, 0, 2, 2,11/
      DATA (IPA(614,I),I=1,7)/ 0, 2, 6, 0, 2, 2,12/
      DATA (IPA(615,I),I=1,7)/ 6, 0, 2, 0, 2, 2,13/
      DATA (IPA(616,I),I=1,7)/ 2, 0, 5, 5, 0, 0,11/
      DATA (IPA(617,I),I=1,7)/ 5, 0, 2, 5, 0, 0,12/
      DATA (IPA(618,I),I=1,7)/ 2, 5, 0, 5, 0, 0,13/
      DATA (IPA(619,I),I=1,7)/ 5, 2, 2, 1, 1, 1,10/
      DATA (IPA(620,I),I=1,7)/ 5, 1, 2, 2, 1, 1,11/
      DATA (IPA(621,I),I=1,7)/ 2, 1, 5, 2, 1, 1,12/
      DATA (IPA(622,I),I=1,7)/ 5, 2, 1, 2, 1, 1,13/
      DATA (IPA(623,I),I=1,7)/ 4, 1, 1, 2, 2, 2,10/
      DATA (IPA(624,I),I=1,7)/ 4, 2, 1, 1, 2, 2,11/
      DATA (IPA(625,I),I=1,7)/ 1, 2, 4, 1, 2, 2,12/
      DATA (IPA(626,I),I=1,7)/ 4, 1, 2, 1, 2, 2,13/
      DATA (IPA(627,I),I=1,7)/ 0, 3, 3, 2, 2, 2,10/
      DATA (IPA(628,I),I=1,7)/ 0, 2, 3, 3, 2, 2,11/
      DATA (IPA(629,I),I=1,7)/ 3, 2, 0, 3, 2, 2,12/
      DATA (IPA(630,I),I=1,7)/ 0, 3, 2, 3, 2, 2,13/
      DATA (IPA(631,I),I=1,7)/ 5, 5, 1, 1, 0, 0,14/
      DATA (IPA(632,I),I=1,7)/ 1, 1, 5, 5, 0, 0,15/
      DATA (IPA(633,I),I=1,7)/ 0, 5, 5, 1, 1, 0,16/
      DATA (IPA(634,I),I=1,7)/ 5, 1, 5, 1, 0, 0,17/
      DATA (IPA(635,I),I=1,7)/ 5, 1, 1, 5, 0, 0,18/
      DATA (IPA(636,I),I=1,7)/ 0, 1, 5, 5, 1, 0,19/
      DATA (IPA(637,I),I=1,7)/ 4, 4, 2, 2, 0, 0,14/
      DATA (IPA(638,I),I=1,7)/ 2, 2, 4, 4, 0, 0,15/
      DATA (IPA(639,I),I=1,7)/ 0, 4, 4, 2, 2, 0,16/
      DATA (IPA(640,I),I=1,7)/ 4, 2, 4, 2, 0, 0,17/
      DATA (IPA(641,I),I=1,7)/ 4, 2, 2, 4, 0, 0,18/
      DATA (IPA(642,I),I=1,7)/ 0, 2, 4, 4, 2, 0,19/
      DATA (IPA(643,I),I=1,7)/ 3, 3, 2, 2, 1, 1,14/
      DATA (IPA(644,I),I=1,7)/ 2, 2, 3, 3, 1, 1,15/
      DATA (IPA(645,I),I=1,7)/ 1, 3, 3, 2, 2, 1,16/
      DATA (IPA(646,I),I=1,7)/ 3, 2, 3, 2, 1, 1,17/
      DATA (IPA(647,I),I=1,7)/ 3, 2, 2, 3, 1, 1,18/
      DATA (IPA(648,I),I=1,7)/ 1, 2, 3, 3, 2, 1,19/
      DATA (IPA(649,I),I=1,7)/ 9, 2, 0, 1, 0, 0,21/
      DATA (IPA(650,I),I=1,7)/ 2, 0, 9, 1, 0, 0,22/
      DATA (IPA(651,I),I=1,7)/ 9, 0, 2, 1, 0, 0,23/
      DATA (IPA(652,I),I=1,7)/ 1, 0, 9, 2, 0, 0,24/
      DATA (IPA(653,I),I=1,7)/ 8, 3, 0, 1, 0, 0,21/
      DATA (IPA(654,I),I=1,7)/ 3, 0, 8, 1, 0, 0,22/
      DATA (IPA(655,I),I=1,7)/ 8, 0, 3, 1, 0, 0,23/
      DATA (IPA(656,I),I=1,7)/ 1, 0, 8, 3, 0, 0,24/
      DATA (IPA(657,I),I=1,7)/ 7, 4, 0, 1, 0, 0,21/
      DATA (IPA(658,I),I=1,7)/ 4, 0, 7, 1, 0, 0,22/
      DATA (IPA(659,I),I=1,7)/ 7, 0, 4, 1, 0, 0,23/
      DATA (IPA(660,I),I=1,7)/ 1, 0, 7, 4, 0, 0,24/
      DATA (IPA(661,I),I=1,7)/ 7, 3, 0, 2, 0, 0,21/
      DATA (IPA(662,I),I=1,7)/ 3, 0, 7, 2, 0, 0,22/
      DATA (IPA(663,I),I=1,7)/ 7, 0, 3, 2, 0, 0,23/
      DATA (IPA(664,I),I=1,7)/ 2, 0, 7, 3, 0, 0,24/
      DATA (IPA(665,I),I=1,7)/ 7, 2, 0, 1, 1, 1,20/
      DATA (IPA(666,I),I=1,7)/ 7, 2, 1, 0, 1, 1,21/
      DATA (IPA(667,I),I=1,7)/ 2, 1, 7, 0, 1, 1,22/
      DATA (IPA(668,I),I=1,7)/ 7, 1, 2, 0, 1, 1,23/
      DATA (IPA(669,I),I=1,7)/ 0, 1, 7, 2, 1, 1,24/
      DATA (IPA(670,I),I=1,7)/ 6, 5, 0, 1, 0, 0,21/
      DATA (IPA(671,I),I=1,7)/ 5, 0, 6, 1, 0, 0,22/
      DATA (IPA(672,I),I=1,7)/ 6, 0, 5, 1, 0, 0,23/
      DATA (IPA(673,I),I=1,7)/ 1, 0, 6, 5, 0, 0,24/
      DATA (IPA(674,I),I=1,7)/ 6, 4, 0, 2, 0, 0,21/
      DATA (IPA(675,I),I=1,7)/ 4, 0, 6, 2, 0, 0,22/
      DATA (IPA(676,I),I=1,7)/ 6, 0, 4, 2, 0, 0,23/
      DATA (IPA(677,I),I=1,7)/ 2, 0, 6, 4, 0, 0,24/
      DATA (IPA(678,I),I=1,7)/ 6, 3, 0, 1, 1, 1,20/
      DATA (IPA(679,I),I=1,7)/ 6, 3, 1, 0, 1, 1,21/
      DATA (IPA(680,I),I=1,7)/ 3, 1, 6, 0, 1, 1,22/
      DATA (IPA(681,I),I=1,7)/ 6, 1, 3, 0, 1, 1,23/
      DATA (IPA(682,I),I=1,7)/ 0, 1, 6, 3, 1, 1,24/
      DATA (IPA(683,I),I=1,7)/ 5, 4, 0, 3, 0, 0,21/
      DATA (IPA(684,I),I=1,7)/ 4, 0, 5, 3, 0, 0,22/
      DATA (IPA(685,I),I=1,7)/ 5, 0, 4, 3, 0, 0,23/
      DATA (IPA(686,I),I=1,7)/ 3, 0, 5, 4, 0, 0,24/
      DATA (IPA(687,I),I=1,7)/ 5, 4, 0, 1, 1, 1,20/
      DATA (IPA(688,I),I=1,7)/ 5, 4, 1, 0, 1, 1,21/
      DATA (IPA(689,I),I=1,7)/ 4, 1, 5, 0, 1, 1,22/
      DATA (IPA(690,I),I=1,7)/ 5, 1, 4, 0, 1, 1,23/
      DATA (IPA(691,I),I=1,7)/ 0, 1, 5, 4, 1, 1,24/
      DATA (IPA(692,I),I=1,7)/ 5, 1, 0, 2, 2, 2,20/
      DATA (IPA(693,I),I=1,7)/ 5, 1, 2, 0, 2, 2,21/
      DATA (IPA(694,I),I=1,7)/ 1, 2, 5, 0, 2, 2,22/
      DATA (IPA(695,I),I=1,7)/ 5, 2, 1, 0, 2, 2,23/
      DATA (IPA(696,I),I=1,7)/ 0, 2, 5, 1, 2, 2,24/
      DATA (IPA(697,I),I=1,7)/ 4, 3, 2, 1, 1, 1,20/
      DATA (IPA(698,I),I=1,7)/ 4, 3, 1, 2, 1, 1,21/
      DATA (IPA(699,I),I=1,7)/ 3, 1, 4, 2, 1, 1,22/
      DATA (IPA(700,I),I=1,7)/ 4, 1, 3, 2, 1, 1,23/
      DATA (IPA(701,I),I=1,7)/ 2, 1, 4, 3, 1, 1,24/
      DATA (IPA(702,I),I=1,7)/ 2, 1, 0, 3, 3, 3,20/
      DATA (IPA(703,I),I=1,7)/ 2, 1, 3, 0, 3, 3,21/
      DATA (IPA(704,I),I=1,7)/ 1, 3, 2, 0, 3, 3,22/
      DATA (IPA(705,I),I=1,7)/ 2, 3, 1, 0, 3, 3,23/
      DATA (IPA(706,I),I=1,7)/ 0, 3, 2, 1, 3, 3,24/
      DATA (IPA(707,I),I=1,7)/ 8, 2, 1, 1, 0, 0,25/
      DATA (IPA(708,I),I=1,7)/ 8, 1, 1, 2, 0, 0,26/
      DATA (IPA(709,I),I=1,7)/ 0, 8, 2, 1, 1, 0,27/
      DATA (IPA(710,I),I=1,7)/ 0, 1, 8, 2, 1, 0,28/
      DATA (IPA(711,I),I=1,7)/ 1, 1, 2, 8, 0, 0,29/
      DATA (IPA(712,I),I=1,7)/ 2, 1, 8, 1, 0, 0,30/
      DATA (IPA(713,I),I=1,7)/ 8, 1, 2, 1, 0, 0,31/
      DATA (IPA(714,I),I=1,7)/ 2, 1, 1, 8, 0, 0,32/
      DATA (IPA(715,I),I=1,7)/ 1, 1, 8, 2, 0, 0,33/
      DATA (IPA(716,I),I=1,7)/ 7, 3, 1, 1, 0, 0,25/
      DATA (IPA(717,I),I=1,7)/ 7, 1, 1, 3, 0, 0,26/
      DATA (IPA(718,I),I=1,7)/ 0, 7, 3, 1, 1, 0,27/
      DATA (IPA(719,I),I=1,7)/ 0, 1, 7, 3, 1, 0,28/
      DATA (IPA(720,I),I=1,7)/ 1, 1, 3, 7, 0, 0,29/
      DATA (IPA(721,I),I=1,7)/ 3, 1, 7, 1, 0, 0,30/
      DATA (IPA(722,I),I=1,7)/ 7, 1, 3, 1, 0, 0,31/
      DATA (IPA(723,I),I=1,7)/ 3, 1, 1, 7, 0, 0,32/
      DATA (IPA(724,I),I=1,7)/ 1, 1, 7, 3, 0, 0,33/
      DATA (IPA(725,I),I=1,7)/ 7, 1, 2, 2, 0, 0,25/
      DATA (IPA(726,I),I=1,7)/ 7, 2, 2, 1, 0, 0,26/
      DATA (IPA(727,I),I=1,7)/ 0, 7, 1, 2, 2, 0,27/
      DATA (IPA(728,I),I=1,7)/ 0, 2, 7, 1, 2, 0,28/
      DATA (IPA(729,I),I=1,7)/ 2, 2, 1, 7, 0, 0,29/
      DATA (IPA(730,I),I=1,7)/ 1, 2, 7, 2, 0, 0,30/
      DATA (IPA(731,I),I=1,7)/ 7, 2, 1, 2, 0, 0,31/
      DATA (IPA(732,I),I=1,7)/ 1, 2, 2, 7, 0, 0,32/
      DATA (IPA(733,I),I=1,7)/ 2, 2, 7, 1, 0, 0,33/
      DATA (IPA(734,I),I=1,7)/ 6, 4, 1, 1, 0, 0,25/
      DATA (IPA(735,I),I=1,7)/ 6, 1, 1, 4, 0, 0,26/
      DATA (IPA(736,I),I=1,7)/ 0, 6, 4, 1, 1, 0,27/
      DATA (IPA(737,I),I=1,7)/ 0, 1, 6, 4, 1, 0,28/
      DATA (IPA(738,I),I=1,7)/ 1, 1, 4, 6, 0, 0,29/
      DATA (IPA(739,I),I=1,7)/ 4, 1, 6, 1, 0, 0,30/
      DATA (IPA(740,I),I=1,7)/ 6, 1, 4, 1, 0, 0,31/
      DATA (IPA(741,I),I=1,7)/ 4, 1, 1, 6, 0, 0,32/
      DATA (IPA(742,I),I=1,7)/ 1, 1, 6, 4, 0, 0,33/
      DATA (IPA(743,I),I=1,7)/ 6, 0, 2, 2, 1, 1,25/
      DATA (IPA(744,I),I=1,7)/ 6, 2, 2, 0, 1, 1,26/
      DATA (IPA(745,I),I=1,7)/ 1, 6, 0, 2, 2, 1,27/
      DATA (IPA(746,I),I=1,7)/ 1, 2, 6, 0, 2, 1,28/
      DATA (IPA(747,I),I=1,7)/ 2, 2, 0, 6, 1, 1,29/
      DATA (IPA(748,I),I=1,7)/ 0, 2, 6, 2, 1, 1,30/
      DATA (IPA(749,I),I=1,7)/ 6, 2, 0, 2, 1, 1,31/
      DATA (IPA(750,I),I=1,7)/ 0, 2, 2, 6, 1, 1,32/
      DATA (IPA(751,I),I=1,7)/ 2, 2, 6, 0, 1, 1,33/
      DATA (IPA(752,I),I=1,7)/ 5, 1, 3, 3, 0, 0,25/
      DATA (IPA(753,I),I=1,7)/ 5, 3, 3, 1, 0, 0,26/
      DATA (IPA(754,I),I=1,7)/ 0, 5, 1, 3, 3, 0,27/
      DATA (IPA(755,I),I=1,7)/ 0, 3, 5, 1, 3, 0,28/
      DATA (IPA(756,I),I=1,7)/ 3, 3, 1, 5, 0, 0,29/
      DATA (IPA(757,I),I=1,7)/ 1, 3, 5, 3, 0, 0,30/
      DATA (IPA(758,I),I=1,7)/ 5, 3, 1, 3, 0, 0,31/
      DATA (IPA(759,I),I=1,7)/ 1, 3, 3, 5, 0, 0,32/
      DATA (IPA(760,I),I=1,7)/ 3, 3, 5, 1, 0, 0,33/
      DATA (IPA(761,I),I=1,7)/ 5, 3, 2, 2, 0, 0,25/
      DATA (IPA(762,I),I=1,7)/ 5, 2, 2, 3, 0, 0,26/
      DATA (IPA(763,I),I=1,7)/ 0, 5, 3, 2, 2, 0,27/
      DATA (IPA(764,I),I=1,7)/ 0, 2, 5, 3, 2, 0,28/
      DATA (IPA(765,I),I=1,7)/ 2, 2, 3, 5, 0, 0,29/
      DATA (IPA(766,I),I=1,7)/ 3, 2, 5, 2, 0, 0,30/
      DATA (IPA(767,I),I=1,7)/ 5, 2, 3, 2, 0, 0,31/
      DATA (IPA(768,I),I=1,7)/ 3, 2, 2, 5, 0, 0,32/
      DATA (IPA(769,I),I=1,7)/ 2, 2, 5, 3, 0, 0,33/
      DATA (IPA(770,I),I=1,7)/ 3, 1, 4, 4, 0, 0,25/
      DATA (IPA(771,I),I=1,7)/ 3, 4, 4, 1, 0, 0,26/
      DATA (IPA(772,I),I=1,7)/ 0, 3, 1, 4, 4, 0,27/
      DATA (IPA(773,I),I=1,7)/ 0, 4, 3, 1, 4, 0,28/
      DATA (IPA(774,I),I=1,7)/ 4, 4, 1, 3, 0, 0,29/
      DATA (IPA(775,I),I=1,7)/ 1, 4, 3, 4, 0, 0,30/
      DATA (IPA(776,I),I=1,7)/ 3, 4, 1, 4, 0, 0,31/
      DATA (IPA(777,I),I=1,7)/ 1, 4, 4, 3, 0, 0,32/
      DATA (IPA(778,I),I=1,7)/ 4, 4, 3, 1, 0, 0,33/
      DATA (IPA(779,I),I=1,7)/ 2, 0, 4, 4, 1, 1,25/
      DATA (IPA(780,I),I=1,7)/ 2, 4, 4, 0, 1, 1,26/
      DATA (IPA(781,I),I=1,7)/ 1, 2, 0, 4, 4, 1,27/
      DATA (IPA(782,I),I=1,7)/ 1, 4, 2, 0, 4, 1,28/
      DATA (IPA(783,I),I=1,7)/ 4, 4, 0, 2, 1, 1,29/
      DATA (IPA(784,I),I=1,7)/ 0, 4, 2, 4, 1, 1,30/
      DATA (IPA(785,I),I=1,7)/ 2, 4, 0, 4, 1, 1,31/
      DATA (IPA(786,I),I=1,7)/ 0, 4, 4, 2, 1, 1,32/
      DATA (IPA(787,I),I=1,7)/ 4, 4, 2, 0, 1, 1,33/
      DATA (IPA(788,I),I=1,7)/ 4, 2, 3, 3, 0, 0,25/
      DATA (IPA(789,I),I=1,7)/ 4, 3, 3, 2, 0, 0,26/
      DATA (IPA(790,I),I=1,7)/ 0, 4, 2, 3, 3, 0,27/
      DATA (IPA(791,I),I=1,7)/ 0, 3, 4, 2, 3, 0,28/
      DATA (IPA(792,I),I=1,7)/ 3, 3, 2, 4, 0, 0,29/
      DATA (IPA(793,I),I=1,7)/ 2, 3, 4, 3, 0, 0,30/
      DATA (IPA(794,I),I=1,7)/ 4, 3, 2, 3, 0, 0,31/
      DATA (IPA(795,I),I=1,7)/ 2, 3, 3, 4, 0, 0,32/
      DATA (IPA(796,I),I=1,7)/ 3, 3, 4, 2, 0, 0,33/
      DATA (IPA(797,I),I=1,7)/ 4, 0, 3, 3, 1, 1,25/
      DATA (IPA(798,I),I=1,7)/ 4, 3, 3, 0, 1, 1,26/
      DATA (IPA(799,I),I=1,7)/ 1, 4, 0, 3, 3, 1,27/
      DATA (IPA(800,I),I=1,7)/ 1, 3, 4, 0, 3, 1,28/
      DATA (IPA(801,I),I=1,7)/ 3, 3, 0, 4, 1, 1,29/
      DATA (IPA(802,I),I=1,7)/ 0, 3, 4, 3, 1, 1,30/
      DATA (IPA(803,I),I=1,7)/ 4, 3, 0, 3, 1, 1,31/
      DATA (IPA(804,I),I=1,7)/ 0, 3, 3, 4, 1, 1,32/
      DATA (IPA(805,I),I=1,7)/ 3, 3, 4, 0, 1, 1,33/
      DATA (IPA(806,I),I=1,7)/ 6, 3, 2, 1, 0, 0,34/
      DATA (IPA(807,I),I=1,7)/ 6, 2, 3, 1, 0, 0,35/
      DATA (IPA(808,I),I=1,7)/ 0, 6, 3, 2, 1, 0,36/
      DATA (IPA(809,I),I=1,7)/ 0, 3, 6, 2, 1, 0,37/
      DATA (IPA(810,I),I=1,7)/ 2, 1, 3, 6, 0, 0,38/
      DATA (IPA(811,I),I=1,7)/ 6, 2, 1, 3, 0, 0,39/
      DATA (IPA(812,I),I=1,7)/ 6, 3, 1, 2, 0, 0,40/
      DATA (IPA(813,I),I=1,7)/ 3, 2, 1, 6, 0, 0,41/
      DATA (IPA(814,I),I=1,7)/ 6, 1, 2, 3, 0, 0,42/
      DATA (IPA(815,I),I=1,7)/ 3, 1, 2, 6, 0, 0,43/
      DATA (IPA(816,I),I=1,7)/ 6, 1, 3, 2, 0, 0,44/
      DATA (IPA(817,I),I=1,7)/ 3, 2, 6, 1, 0, 0,45/
      DATA (IPA(818,I),I=1,7)/ 3, 1, 6, 2, 0, 0,46/
      DATA (IPA(819,I),I=1,7)/ 2, 1, 6, 3, 0, 0,47/
      DATA (IPA(820,I),I=1,7)/ 0, 2, 6, 3, 1, 0,48/
      DATA (IPA(821,I),I=1,7)/ 5, 4, 2, 1, 0, 0,34/
      DATA (IPA(822,I),I=1,7)/ 5, 2, 4, 1, 0, 0,35/
      DATA (IPA(823,I),I=1,7)/ 0, 5, 4, 2, 1, 0,36/
      DATA (IPA(824,I),I=1,7)/ 0, 4, 5, 2, 1, 0,37/
      DATA (IPA(825,I),I=1,7)/ 2, 1, 4, 5, 0, 0,38/
      DATA (IPA(826,I),I=1,7)/ 5, 2, 1, 4, 0, 0,39/
      DATA (IPA(827,I),I=1,7)/ 5, 4, 1, 2, 0, 0,40/
      DATA (IPA(828,I),I=1,7)/ 4, 2, 1, 5, 0, 0,41/
      DATA (IPA(829,I),I=1,7)/ 5, 1, 2, 4, 0, 0,42/
      DATA (IPA(830,I),I=1,7)/ 4, 1, 2, 5, 0, 0,43/
      DATA (IPA(831,I),I=1,7)/ 5, 1, 4, 2, 0, 0,44/
      DATA (IPA(832,I),I=1,7)/ 4, 2, 5, 1, 0, 0,45/
      DATA (IPA(833,I),I=1,7)/ 4, 1, 5, 2, 0, 0,46/
      DATA (IPA(834,I),I=1,7)/ 2, 1, 5, 4, 0, 0,47/
      DATA (IPA(835,I),I=1,7)/ 0, 2, 5, 4, 1, 0,48/
      DATA (IPA(836,I),I=1,7)/ 5, 3, 2, 0, 1, 1,34/
      DATA (IPA(837,I),I=1,7)/ 5, 2, 3, 0, 1, 1,35/
      DATA (IPA(838,I),I=1,7)/ 1, 5, 3, 2, 0, 1,36/
      DATA (IPA(839,I),I=1,7)/ 1, 3, 5, 2, 0, 1,37/
      DATA (IPA(840,I),I=1,7)/ 2, 0, 3, 5, 1, 1,38/
      DATA (IPA(841,I),I=1,7)/ 5, 2, 0, 3, 1, 1,39/
      DATA (IPA(842,I),I=1,7)/ 5, 3, 0, 2, 1, 1,40/
      DATA (IPA(843,I),I=1,7)/ 3, 2, 0, 5, 1, 1,41/
      DATA (IPA(844,I),I=1,7)/ 5, 0, 2, 3, 1, 1,42/
      DATA (IPA(845,I),I=1,7)/ 3, 0, 2, 5, 1, 1,43/
      DATA (IPA(846,I),I=1,7)/ 5, 0, 3, 2, 1, 1,44/
      DATA (IPA(847,I),I=1,7)/ 3, 2, 5, 0, 1, 1,45/
      DATA (IPA(848,I),I=1,7)/ 3, 0, 5, 2, 1, 1,46/
      DATA (IPA(849,I),I=1,7)/ 2, 0, 5, 3, 1, 1,47/
      DATA (IPA(850,I),I=1,7)/ 1, 2, 5, 3, 0, 1,48/
      DATA (IPA(851,I),I=1,7)/ 4, 3, 1, 0, 2, 2,34/
      DATA (IPA(852,I),I=1,7)/ 4, 1, 3, 0, 2, 2,35/
      DATA (IPA(853,I),I=1,7)/ 2, 4, 3, 1, 0, 2,36/
      DATA (IPA(854,I),I=1,7)/ 2, 3, 4, 1, 0, 2,37/
      DATA (IPA(855,I),I=1,7)/ 1, 0, 3, 4, 2, 2,38/
      DATA (IPA(856,I),I=1,7)/ 4, 1, 0, 3, 2, 2,39/
      DATA (IPA(857,I),I=1,7)/ 4, 3, 0, 1, 2, 2,40/
      DATA (IPA(858,I),I=1,7)/ 3, 1, 0, 4, 2, 2,41/
      DATA (IPA(859,I),I=1,7)/ 4, 0, 1, 3, 2, 2,42/
      DATA (IPA(860,I),I=1,7)/ 3, 0, 1, 4, 2, 2,43/
      DATA (IPA(861,I),I=1,7)/ 4, 0, 3, 1, 2, 2,44/
      DATA (IPA(862,I),I=1,7)/ 3, 1, 4, 0, 2, 2,45/
      DATA (IPA(863,I),I=1,7)/ 3, 0, 4, 1, 2, 2,46/
      DATA (IPA(864,I),I=1,7)/ 1, 0, 4, 3, 2, 2,47/
      DATA (IPA(865,I),I=1,7)/ 2, 1, 4, 3, 0, 2,48/
      END
************************************************************************
* BLOCKDATA corresponding to the best FIT. See JCP paper. 865 parameters
*
* Results   rms = 1.92 mhartree = 1.2 kcal/mol
************************************************************************
      BLOCKDATA H4G12
      IMPLICIT  REAL * 8 (A-H,O-Z)
      PARAMETER (NEXP=865)
      COMMON /SM/ VEX,SM(NEXP),MT,IS
      DATA VEX/0.1404000000000000D+01/
      DATA MT/12/,IS/865/
      DATA SM(  1)/-0.13564615143409478345801082203672321D+04/
      DATA SM(  2)/-0.49649526725504892714766309552267765D+03/
      DATA SM(  3)/ 0.57556459435283376179124982274739668D+04/
      DATA SM(  4)/ 0.14301154078991450508775804643700880D+06/
      DATA SM(  5)/ 0.22440950027568240470599310781035737D+05/
      DATA SM(  6)/ 0.26254943880375699348269055164069072D+04/
      DATA SM(  7)/ 0.63071737434961632843355438990924097D+04/
      DATA SM(  8)/ 0.31383693593781222586746721368999879D+06/
      DATA SM(  9)/-0.11774661757512315782595626835105358D+06/
      DATA SM( 10)/-0.15013676952259538355484615587354933D+06/
      DATA SM( 11)/-0.31559217382358564022765282600455146D+05/
      DATA SM( 12)/-0.11287381164715920819956234447696878D+06/
      DATA SM( 13)/-0.13971385350324405663136218005270314D+07/
      DATA SM( 14)/-0.11091446921895798172265014477628559D+05/
      DATA SM( 15)/-0.50315552486423864358888250938998617D+06/
      DATA SM( 16)/-0.54922178690910514820782947057248101D+05/
      DATA SM( 17)/ 0.33324557499504250913449660801937654D+06/
      DATA SM( 18)/-0.44021238880554444632513103025680590D+05/
      DATA SM( 19)/-0.68794608056891601584635047132045631D+07/
      DATA SM( 20)/-0.21254848232829160091973351577174745D+06/
      DATA SM( 21)/-0.25255052571781783942205804153723932D+07/
      DATA SM( 22)/ 0.85190600355825065745846516659902435D+06/
      DATA SM( 23)/-0.53732522111561157431058508990651073D+07/
      DATA SM( 24)/-0.12708785991478775144115633100576745D+07/
      DATA SM( 25)/ 0.36873456335994222305210133628641970D+07/
      DATA SM( 26)/-0.53846840801375740065458694928089744D+06/
      DATA SM( 27)/ 0.52779675936723953950330483687158636D+07/
      DATA SM( 28)/-0.87260270287363577501775856786678290D+05/
      DATA SM( 29)/-0.53788980003305683212456094784997531D+07/
      DATA SM( 30)/ 0.87495766305131519198443504482834413D+05/
      DATA SM( 31)/-0.98664522984055448893654186291848322D+06/
      DATA SM( 32)/ 0.21075848882993178777082321070551006D+07/
      DATA SM( 33)/ 0.19385023794942055549842394663548781D+08/
      DATA SM( 34)/ 0.12843968681626871577918294659180792D+07/
      DATA SM( 35)/ 0.29023166131224786939356534966176695D+07/
      DATA SM( 36)/ 0.24607704614123539847142410669707124D+07/
      DATA SM( 37)/ 0.59999572244480580432911751406964785D+06/
      DATA SM( 38)/-0.22572581692771095163435483355740665D+07/
      DATA SM( 39)/ 0.75551719695137218668832081101645842D+06/
      DATA SM( 40)/ 0.12699766456323919372344957580939067D+07/
      DATA SM( 41)/ 0.11336876277123099327749785359069052D+08/
      DATA SM( 42)/-0.67737166006480348368461913816184223D+08/
      DATA SM( 43)/ 0.27601072734477453262124445832873925D+06/
      DATA SM( 44)/-0.90747077638490219726610368090561369D+07/
      DATA SM( 45)/ 0.43049574553128298454203595179405866D+08/
      DATA SM( 46)/-0.15339096578298165901991815917181712D+08/
      DATA SM( 47)/-0.36036553808948325981428563059085425D+08/
      DATA SM( 48)/ 0.43145217043547151904327887936088364D+07/
      DATA SM( 49)/-0.10872851099005192284800884156497188D+08/
      DATA SM( 50)/ 0.40395852362400150889387260500861429D+07/
      DATA SM( 51)/ 0.15183007303318018485134443311347083D+08/
      DATA SM( 52)/ 0.90098224843941403602164554713735175D+07/
      DATA SM( 53)/ 0.44284840855272238525798848021389059D+08/
      DATA SM( 54)/ 0.22984808359515035543843127908423888D+08/
      DATA SM( 55)/ 0.88833042493457513531910504065848007D+07/
      DATA SM( 56)/-0.59372042288602213529181970910700702D+07/
      DATA SM( 57)/-0.27769054195909488122407240152748734D+08/
      DATA SM( 58)/-0.99001903763655383484042292926588153D+08/
      DATA SM( 59)/-0.41840218127048740590110594320612710D+08/
      DATA SM( 60)/-0.11742538869043250496936102590320380D+08/
      DATA SM( 61)/ 0.56051948336218107992243474481563443D+08/
      DATA SM( 62)/-0.10064959658564028832287961233109605D+09/
      DATA SM( 63)/ 0.24798005324275614207862583787373216D+08/
      DATA SM( 64)/ 0.96571994284969594791075309755164083D+08/
      DATA SM( 65)/ 0.47599704132226429992942405885449768D+07/
      DATA SM( 66)/ 0.35507165779970270909886023677357443D+08/
      DATA SM( 67)/ 0.52683964817880753498870152872108051D+07/
      DATA SM( 68)/-0.84538553823165542720053521307148180D+07/
      DATA SM( 69)/ 0.10283926980686226652203051386037950D+08/
      DATA SM( 70)/ 0.25974312980952006291145102769581498D+08/
      DATA SM( 71)/-0.10964344290552646629453676628590680D+09/
      DATA SM( 72)/ 0.45859333425259037348638908791394486D+08/
      DATA SM( 73)/ 0.21013564820604858840874144922186315D+08/
      DATA SM( 74)/-0.13030944789080464257729490959169223D+08/
      DATA SM( 75)/-0.23671378390103746593103938220500962D+07/
      DATA SM( 76)/-0.48911023319520463972166881353481284D+08/
      DATA SM( 77)/ 0.29354632944274515706606650810070363D+08/
      DATA SM( 78)/-0.36524936355416748440566415962095105D+09/
      DATA SM( 79)/-0.39680858203028574267811762831272596D+08/
      DATA SM( 80)/ 0.17767937336628329317088787762036280D+10/
      DATA SM( 81)/ 0.27624611105617906750427465264959083D+09/
      DATA SM( 82)/-0.49020248210074109384564351274231385D+09/
      DATA SM( 83)/ 0.74320438230667431451077448561407755D+09/
      DATA SM( 84)/-0.39603645507947974766990510218112077D+09/
      DATA SM( 85)/ 0.11719687286928198853122320518457364D+09/
      DATA SM( 86)/-0.22984377865461356935885690387958338D+09/
      DATA SM( 87)/ 0.26768747352823341861660824237634352D+09/
      DATA SM( 88)/-0.12995221004798936876438279651756651D+09/
      DATA SM( 89)/-0.12635324215376062448292101550698570D+09/
      DATA SM( 90)/ 0.45957778368632466653949039578356137D+08/
      DATA SM( 91)/-0.22721698441207829695833879902473628D+08/
      DATA SM( 92)/-0.75687869745243180750921907649140005D+08/
      DATA SM( 93)/-0.45660949999075485722224159067041051D+08/
      DATA SM( 94)/-0.36581317741568013803858339881714129D+09/
      DATA SM( 95)/-0.21879759436969668748166741708848178D+09/
      DATA SM( 96)/-0.96170888072891389580072298671511628D+08/
      DATA SM( 97)/-0.26793001108998230706920667017949463D+09/
      DATA SM( 98)/ 0.26502409185682796096125937409270038D+08/
      DATA SM( 99)/-0.27806186505916225751483316917495732D+09/
      DATA SM(100)/-0.24247254462111595090632148088193984D+09/
      DATA SM(101)/ 0.26956451250708357213579159280557395D+08/
      DATA SM(102)/ 0.83558655595835196500990749530235527D+07/
      DATA SM(103)/-0.39234905116741826346936320571593166D+09/
      DATA SM(104)/ 0.10873884535958721986058729933654785D+10/
      DATA SM(105)/ 0.51851425950375593643462537675571316D+08/
      DATA SM(106)/-0.74981227796204000759781626119376439D+08/
      DATA SM(107)/-0.21876469949730966544391599293581256D+09/
      DATA SM(108)/-0.10674003178620473032191963898583342D+09/
      DATA SM(109)/-0.14177991399191782890061321764438185D+09/
      DATA SM(110)/-0.17924410749946635136802835947478113D+08/
      DATA SM(111)/ 0.47683887653867756728885983117712979D+08/
      DATA SM(112)/ 0.32227070201856312281020433770081747D+08/
      DATA SM(113)/-0.16774696164608573210027134325885390D+09/
      DATA SM(114)/-0.23103221619756514200859385936681105D+08/
      DATA SM(115)/ 0.25066635279187175167980802597733302D+09/
      DATA SM(116)/-0.18398511734080868615383322995943575D+09/
      DATA SM(117)/-0.45462841489375696010738149532936267D+09/
      DATA SM(118)/ 0.21520249076267615121499762122264024D+09/
      DATA SM(119)/-0.39820247617294992295989579516526855D+09/
      DATA SM(120)/ 0.85643430469131826979572193077490961D+09/
      DATA SM(121)/-0.42161065407812169613913452121351839D+08/
      DATA SM(122)/-0.20624106067838774895304948164303335D+09/
      DATA SM(123)/ 0.88074125514898209363236056667536024D+08/
      DATA SM(124)/-0.19111743271963569358164332065212122D+09/
      DATA SM(125)/-0.40318770291478283002840303127344372D+09/
      DATA SM(126)/-0.17843094374146524807295309749025968D+07/
      DATA SM(127)/ 0.32825473267285387375238747370287949D+08/
      DATA SM(128)/ 0.34179463917263845258156601056319468D+09/
      DATA SM(129)/-0.45849669069653081368449175746492150D+09/
      DATA SM(130)/ 0.15169312353773786991206383648500473D+09/
      DATA SM(131)/ 0.20994340469864143629276694844228917D+08/
      DATA SM(132)/-0.30163926462837487932786585278494815D+09/
      DATA SM(133)/ 0.99383196993293815156393480321900993D+09/
      DATA SM(134)/ 0.35514516825281702010821769008347026D+09/
      DATA SM(135)/ 0.28773660858971124014608156784386646D+09/
      DATA SM(136)/-0.53240371184393071372812279348811781D+08/
      DATA SM(137)/ 0.28751847775625128126288675048755637D+09/
      DATA SM(138)/ 0.39002939576731563497746224539117647D+08/
      DATA SM(139)/ 0.42486883688117959264527492344048086D+10/
      DATA SM(140)/-0.19045303408915565543406544091431891D+09/
      DATA SM(141)/ 0.69609377607922897001447353276922756D+09/
      DATA SM(142)/-0.16804869180083511670961849746585969D+10/
      DATA SM(143)/ 0.14479220952141378648704697836674415D+10/
      DATA SM(144)/-0.58306126755804941010003489913692380D+10/
      DATA SM(145)/-0.43012113156312280738334040940528326D+10/
      DATA SM(146)/ 0.45935583916920336608083331071985720D+10/
      DATA SM(147)/-0.65761191151778137398033659185749002D+09/
      DATA SM(148)/ 0.12693201229170082056820021437184755D+10/
      DATA SM(149)/-0.72682284539773030455193950204715364D+09/
      DATA SM(150)/ 0.14014974355518760046573136348392533D+11/
      DATA SM(151)/-0.78681921239628627291952998021409357D+09/
      DATA SM(152)/ 0.88781025589474788584196416859736684D+09/
      DATA SM(153)/-0.16796253745057138823562586645082948D+10/
      DATA SM(154)/ 0.35735135641219242548293906608079665D+09/
      DATA SM(155)/ 0.24073103468992660506551884074121705D+09/
      DATA SM(156)/ 0.18850599966808152277096607149613121D+09/
      DATA SM(157)/-0.10559898165234427845851792346293264D+10/
      DATA SM(158)/ 0.36390890627021493241742462010921382D+09/
      DATA SM(159)/-0.15102897755312484260781612489775989D+09/
      DATA SM(160)/ 0.12442816765155143575474923052284817D+10/
      DATA SM(161)/ 0.70101720338759088906092137337051354D+09/
      DATA SM(162)/ 0.58424281652380993524725598934900452D+09/
      DATA SM(163)/ 0.25550957238524651948567358757142360D+10/
      DATA SM(164)/ 0.19048345410944058382526596159838324D+10/
      DATA SM(165)/-0.63488920576116389715046929457991767D+10/
      DATA SM(166)/-0.12002246100676297038410235712673289D+09/
      DATA SM(167)/-0.52946061331000271938205385331714052D+08/
      DATA SM(168)/ 0.43029603196001392849478049719290378D+10/
      DATA SM(169)/-0.12610934236183475986593748170391973D+10/
      DATA SM(170)/ 0.75299685405878448627448577295089045D+09/
      DATA SM(171)/ 0.59821601113665403641589638879727316D+10/
      DATA SM(172)/ 0.45066245794975664416065241733498036D+09/
      DATA SM(173)/ 0.11980418666541881660825340511453667D+10/
      DATA SM(174)/-0.52285369501424553357165084797610801D+08/
      DATA SM(175)/-0.10727286485855301968218857838522585D+10/
      DATA SM(176)/ 0.14965267017697407788459385190866993D+09/
      DATA SM(177)/-0.14616729195609850344852579798576096D+09/
      DATA SM(178)/ 0.65394741254958449108789159118822116D+08/
      DATA SM(179)/-0.14428328313754013308661509155950228D+09/
      DATA SM(180)/-0.34941391492385842632674115910378747D+09/
      DATA SM(181)/ 0.63807116742291774583284232535161598D+09/
      DATA SM(182)/ 0.84071407954309123674177780147138926D+09/
      DATA SM(183)/ 0.74508619811279630817658139159668017D+08/
      DATA SM(184)/-0.30204089830768515737896477012116358D+10/
      DATA SM(185)/-0.77610191313151132117919931378295998D+09/
      DATA SM(186)/-0.22054074153581858714879890662739629D+10/
      DATA SM(187)/ 0.27861830705330268615339963090844921D+10/
      DATA SM(188)/-0.14341064489593858732255689502007969D+10/
      DATA SM(189)/ 0.30102006416991949526802229352204734D+09/
      DATA SM(190)/ 0.70572978491562507179024075896944192D+09/
      DATA SM(191)/ 0.17152966158359571005545903699591425D+10/
      DATA SM(192)/-0.12232886980460150177493882225790609D+09/
      DATA SM(193)/ 0.26460816664633909002986340689568354D+10/
      DATA SM(194)/ 0.81680147234586044663533084341918019D+09/
      DATA SM(195)/-0.49714822862613418383374174948612808D+09/
      DATA SM(196)/-0.12479714730998969503221402415616165D+10/
      DATA SM(197)/ 0.28335368869596509347613505998325409D+10/
      DATA SM(198)/-0.48636352567918033096439736443384040D+09/
      DATA SM(199)/ 0.11725488871799442324935729459841828D+10/
      DATA SM(200)/-0.38048266128080726051059350892546340D+10/
      DATA SM(201)/-0.11056659013121052717338353763314637D+10/
      DATA SM(202)/ 0.13869125061542225147061207812871692D+10/
      DATA SM(203)/-0.13993997701904512619652801427199134D+10/
      DATA SM(204)/ 0.76359097458348735704090095837649753D+09/
      DATA SM(205)/-0.64855353779532785937967370823074840D+09/
      DATA SM(206)/ 0.20243536924299287961854553126125953D+10/
      DATA SM(207)/-0.35702270936103452243838747516157691D+08/
      DATA SM(208)/-0.16700979441547961980220797915692388D+09/
      DATA SM(209)/ 0.39064755103553579017601897175871642D+10/
      DATA SM(210)/-0.37010947197994673727003485860402398D+10/
      DATA SM(211)/-0.16754307123600272313753966234909642D+10/
      DATA SM(212)/-0.13721708058851262395911536813929492D+10/
      DATA SM(213)/ 0.12592748493655782406698953241219736D+10/
      DATA SM(214)/-0.57048573397683212690529141070404847D+09/
      DATA SM(215)/ 0.15518310946026128600507171754931486D+10/
      DATA SM(216)/-0.97359644527984916552004229091850040D+07/
      DATA SM(217)/-0.98643876735024635070929707345064888D+09/
      DATA SM(218)/-0.21195003572169362614711932918972717D+10/
      DATA SM(219)/ 0.52392474768626386235511576869548257D+10/
      DATA SM(220)/-0.68023374009465712743263628428235631D+09/
      DATA SM(221)/-0.17408356680066037070588698298137534D+10/
      DATA SM(222)/-0.33602781415275429226379101500121003D+09/
      DATA SM(223)/-0.16673121805571523063348705488261625D+10/
      DATA SM(224)/ 0.99962388010140379776465473488918040D+09/
      DATA SM(225)/ 0.66143981791009911763343872904641254D+10/
      DATA SM(226)/-0.13341969916020764723773110940941981D+10/
      DATA SM(227)/ 0.70457319846184814049944105297405558D+09/
      DATA SM(228)/ 0.22921622816319302870689752173285439D+10/
      DATA SM(229)/-0.29368965751685362803459911668350784D+10/
      DATA SM(230)/-0.57536511354211325234778961511839821D+10/
      DATA SM(231)/ 0.18358689168342594407619509552276591D+10/
      DATA SM(232)/-0.56092089628229033972575457544184803D+10/
      DATA SM(233)/ 0.18334432131331067334257062168637985D+10/
      DATA SM(234)/-0.76355688458362848849257944775403838D+10/
      DATA SM(235)/ 0.58723304247992366858370584078131285D+11/
      DATA SM(236)/ 0.43315399028094995295353792242866066D+11/
      DATA SM(237)/ 0.56319719140972884881808580144949963D+11/
      DATA SM(238)/ 0.32715729519290300163647070296516042D+10/
      DATA SM(239)/ 0.99312701172793927639035805358923549D+11/
      DATA SM(240)/ 0.15116696727199303085577944458324599D+11/
      DATA SM(241)/-0.17756812892793582762837460958402686D+11/
      DATA SM(242)/-0.20080420194823491525765451955235710D+11/
      DATA SM(243)/ 0.29696065773921700542529037186710103D+11/
      DATA SM(244)/ 0.37297885499681004432417581380463932D+10/
      DATA SM(245)/-0.22849567009744059813535698192004814D+10/
      DATA SM(246)/ 0.43196100669642410540844820969293382D+10/
      DATA SM(247)/ 0.26382082806541868162154489059708128D+10/
      DATA SM(248)/ 0.12586826017459841238354112917072403D+10/
      DATA SM(249)/-0.45188705677941288130332843924252835D+10/
      DATA SM(250)/-0.35828535797856815827787522958363191D+10/
      DATA SM(251)/ 0.30818523579710112072049750344593298D+10/
      DATA SM(252)/-0.72634998385168343993735217477063679D+09/
      DATA SM(253)/-0.90945199620168462393699574338700995D+09/
      DATA SM(254)/-0.13868700187758867258738662273278577D+10/
      DATA SM(255)/ 0.69190098525015223544592036107130899D+09/
      DATA SM(256)/-0.19680667633926416764445987711873634D+10/
      DATA SM(257)/ 0.12637720684457236022648382276226583D+08/
      DATA SM(258)/-0.17674217086896607722247203758838557D+10/
      DATA SM(259)/-0.11972480448963302500288418561875480D+11/
      DATA SM(260)/-0.86980441928005400426771293242661112D+10/
      DATA SM(261)/-0.32317597774439388317679997385956958D+10/
      DATA SM(262)/ 0.24890212516718875444142319586518066D+10/
      DATA SM(263)/ 0.92492694625058349879335447340032242D+10/
      DATA SM(264)/ 0.33657460437021258162281053379407007D+10/
      DATA SM(265)/-0.16010678426687588997993688404331142D+11/
      DATA SM(266)/ 0.23076775675129374915962155933223045D+10/
      DATA SM(267)/ 0.65236154598041148012863984250925294D+10/
      DATA SM(268)/-0.80338063099686827558035759682520006D+10/
      DATA SM(269)/ 0.67266437807326196771735216300796823D+11/
      DATA SM(270)/-0.59316989549047933640277191184185483D+11/
      DATA SM(271)/ 0.14900107377707921898742954950542020D+10/
      DATA SM(272)/ 0.48440356543706318573792522218835439D+10/
      DATA SM(273)/ 0.42276173305781394449744761657627159D+09/
      DATA SM(274)/ 0.16860509325868161173176840494964521D+11/
      DATA SM(275)/ 0.63121730201348682936078886531121371D+07/
      DATA SM(276)/-0.35011247405485362579441612435362720D+09/
      DATA SM(277)/ 0.89399527833874864028340091777885439D+10/
      DATA SM(278)/-0.89518605797251335753970192737466743D+10/
      DATA SM(279)/ 0.12557610306524884152520751367517054D+10/
      DATA SM(280)/ 0.45337892816623899453430891938869583D+11/
      DATA SM(281)/ 0.98227830390340264830403308302128534D+09/
      DATA SM(282)/-0.90395676446780320238927881944210866D+09/
      DATA SM(283)/-0.12422309287304243077654142825862429D+11/
      DATA SM(284)/ 0.33159558955097842974850037498286025D+10/
      DATA SM(285)/ 0.26093311959555244418243220556270181D+10/
      DATA SM(286)/-0.20168651708960322634435209983808534D+10/
      DATA SM(287)/-0.60607372991984286554368420191110315D+08/
      DATA SM(288)/-0.34290573107175882510127988797280995D+10/
      DATA SM(289)/-0.36372878703358478934256757228193694D+10/
      DATA SM(290)/ 0.21814822399724324636784263785931487D+10/
      DATA SM(291)/ 0.29874589015200942398544229528702216D+10/
      DATA SM(292)/-0.60918047329201922818913483818432830D+09/
      DATA SM(293)/-0.24016219883194862700557118149869387D+10/
      DATA SM(294)/-0.67395815474318006219162865811951339D+09/
      DATA SM(295)/ 0.24244929777200613045191275839709567D+10/
      DATA SM(296)/ 0.26119158297151920605284648879525148D+10/
      DATA SM(297)/-0.32323506506624982408928133879020469D+10/
      DATA SM(298)/-0.41854464375947746375779240976480647D+10/
      DATA SM(299)/-0.13331922928343383449896361138650073D+09/
      DATA SM(300)/ 0.21804904941585798617634464838738442D+11/
      DATA SM(301)/ 0.70152095001486295905597339687849366D+10/
      DATA SM(302)/ 0.26483709075715599903989971460576536D+10/
      DATA SM(303)/-0.96802561896082131295732598470772761D+10/
      DATA SM(304)/-0.63071908235587490746069974742718979D+10/
      DATA SM(305)/-0.11351351455400707785825469663430464D+11/
      DATA SM(306)/-0.14040645772707705590034902294621507D+11/
      DATA SM(307)/ 0.12219613727526074478024091413458842D+11/
      DATA SM(308)/-0.13788308921207479723773323218111077D+11/
      DATA SM(309)/-0.20147412240008539169265975553300110D+11/
      DATA SM(310)/-0.23067062644988579670916464494392338D+11/
      DATA SM(311)/-0.31856493156666443297611018074493067D+11/
      DATA SM(312)/-0.56849939484978200318557700932598758D+10/
      DATA SM(313)/-0.41154175282599985664655139159568966D+11/
      DATA SM(314)/ 0.38787859629922056759872424086070242D+11/
      DATA SM(315)/-0.43030380077525630554483067038815233D+10/
      DATA SM(316)/-0.14403914857004162936994638504207014D+10/
      DATA SM(317)/-0.90576445645821763003630782283082618D+10/
      DATA SM(318)/ 0.98239017905533702009826195823980262D+09/
      DATA SM(319)/-0.91225539639638517395141113705758001D+10/
      DATA SM(320)/-0.44463259535602884701369618218252622D+10/
      DATA SM(321)/ 0.37894010826619227390800084323262832D+10/
      DATA SM(322)/ 0.33511065648177860934072695899410501D+10/
      DATA SM(323)/-0.85205043446347908707567264032629767D+10/
      DATA SM(324)/ 0.25358583452181670327472005786089153D+10/
      DATA SM(325)/-0.44586072711765923235325003558858439D+10/
      DATA SM(326)/ 0.33933378770999657318396783407680423D+10/
      DATA SM(327)/ 0.97762595259408997954381223515928971D+10/
      DATA SM(328)/-0.12212123823343455749234518684787349D+10/
      DATA SM(329)/ 0.76922132074665011973703547222468312D+10/
      DATA SM(330)/-0.55398653696165200706199975658206548D+10/
      DATA SM(331)/ 0.41880383507948393165669001495717548D+10/
      DATA SM(332)/-0.58956593217186721901187673883386736D+10/
      DATA SM(333)/-0.47075863437096713483031260601576468D+10/
      DATA SM(334)/ 0.54257575421568810119143350580947353D+10/
      DATA SM(335)/-0.12481682596035665836021271816212253D+11/
      DATA SM(336)/ 0.92996800884691272061748524414004069D+10/
      DATA SM(337)/ 0.37046764695787343601934904745279596D+10/
      DATA SM(338)/ 0.36862777289029114609089379144181292D+10/
      DATA SM(339)/-0.24352910603574817982061235897445834D+10/
      DATA SM(340)/-0.21688115132883232218323662492462418D+10/
      DATA SM(341)/-0.94380206883101311415614706787364767D+10/
      DATA SM(342)/-0.32832965199757923154413316798053854D+11/
      DATA SM(343)/ 0.87054279390338556018685557321360681D+10/
      DATA SM(344)/ 0.11983945590959747935197108310748047D+11/
      DATA SM(345)/ 0.10979224143834509987256804161074873D+11/
      DATA SM(346)/ 0.11206662323482140337252635083320678D+11/
      DATA SM(347)/ 0.37725681411357027235663608497558106D+11/
      DATA SM(348)/-0.13885959312004340724290521230466553D+11/
      DATA SM(349)/ 0.34972191196492669976190442710512736D+11/
      DATA SM(350)/-0.12782072482214365796549141356757058D+11/
      DATA SM(351)/ 0.46034422860590723981418171325466099D+11/
      DATA SM(352)/-0.48518272542857260934832452306545943D+09/
      DATA SM(353)/-0.15934011143637088098893328891608747D+11/
      DATA SM(354)/ 0.27207224846649001393619624279525323D+11/
      DATA SM(355)/ 0.97199653565442345943234277342884354D+10/
      DATA SM(356)/-0.10437111478010265940814398602526781D+11/
      DATA SM(357)/-0.12156388214683598236154663658100926D+09/
      DATA SM(358)/-0.88112858491851739887467685693938140D+10/
      DATA SM(359)/ 0.88588338996743228647880268769400207D+09/
      DATA SM(360)/-0.69260740310071949586029657797104903D+10/
      DATA SM(361)/ 0.20844038080305823900205603271092092D+10/
      DATA SM(362)/ 0.16288052454630522561436734615351207D+11/
      DATA SM(363)/-0.82549443325394735445516744196780306D+10/
      DATA SM(364)/-0.56026292469754044945610228078946967D+10/
      DATA SM(365)/-0.41528664502892605288303493456430575D+10/
      DATA SM(366)/ 0.13693420804490153025152165275909650D+10/
      DATA SM(367)/ 0.11304723362527053679354462055939796D+10/
      DATA SM(368)/ 0.67807623595500780209894823424536588D+10/
      DATA SM(369)/ 0.29608224525521161496642980079795888D+10/
      DATA SM(370)/ 0.52730241436934036194131351001277651D+10/
      DATA SM(371)/-0.15800632303937645514951127222061930D+09/
      DATA SM(372)/ 0.53131946126310925831241434714027651D+10/
      DATA SM(373)/-0.32321645990281339176091577685010215D+10/
      DATA SM(374)/-0.13739686818483619580882191821702694D+11/
      DATA SM(375)/-0.32685865184233008616492639602195586D+11/
      DATA SM(376)/ 0.44857106622470766988255336932104133D+12/
      DATA SM(377)/-0.28882147712244324345084929242966587D+11/
      DATA SM(378)/ 0.32023170459961298632013297010522631D+11/
      DATA SM(379)/-0.12385136351797306080690286352402684D+12/
      DATA SM(380)/ 0.12665986776179714931858142313060946D+12/
      DATA SM(381)/ 0.12513820997844216195539642895264117D+12/
      DATA SM(382)/-0.13476846517712913109029413396617009D+12/
      DATA SM(383)/-0.78666565443886590736303745986700453D+11/
      DATA SM(384)/-0.47165845346728425123396173001368406D+12/
      DATA SM(385)/-0.10540248271514685806153993099237647D+11/
      DATA SM(386)/ 0.32140989623711611491533965462888009D+10/
      DATA SM(387)/-0.26601745328841620312227820118397366D+10/
      DATA SM(388)/-0.12097835637084230471671830320965345D+11/
      DATA SM(389)/-0.52255445062148561465561063800453079D+10/
      DATA SM(390)/ 0.16657853596074286352772085896285553D+11/
      DATA SM(391)/-0.24154339183417543976724198668253369D+10/
      DATA SM(392)/ 0.37992903552579821383149628221926840D+10/
      DATA SM(393)/ 0.90834366062902916681721591475477212D+09/
      DATA SM(394)/ 0.23061373509424404617931089021873562D+11/
      DATA SM(395)/-0.79046007947925337157905250508715709D+10/
      DATA SM(396)/-0.50952886450984816613478738378028993D+10/
      DATA SM(397)/-0.16763631672507182030255548665518884D+11/
      DATA SM(398)/-0.14488233984510853496420716401941306D+10/
      DATA SM(399)/ 0.33591307614725818130579885494311998D+10/
      DATA SM(400)/ 0.38678370606924801504924876099449372D+10/
      DATA SM(401)/-0.57223134320563288622609542964304411D+10/
      DATA SM(402)/ 0.23044148916644459110395907417202603D+10/
      DATA SM(403)/ 0.29696205439762983996404704994034441D+11/
      DATA SM(404)/ 0.18448203138059006374365392201626640D+11/
      DATA SM(405)/ 0.53805187066505972194164354334599273D+11/
      DATA SM(406)/-0.30348634896653544101243801930499718D+11/
      DATA SM(407)/-0.44341359918726510445092584873909283D+11/
      DATA SM(408)/-0.27574981768166435926391187649043871D+11/
      DATA SM(409)/-0.71225813969335978665548225734552174D+11/
      DATA SM(410)/ 0.24708208343624833094812891541601183D+11/
      DATA SM(411)/-0.18755086752230949123921421890816960D+11/
      DATA SM(412)/ 0.53919719184342411670293776383638564D+11/
      DATA SM(413)/ 0.11281175583713328351623843409349560D+12/
      DATA SM(414)/ 0.19879379093582826424697494474688614D+11/
      DATA SM(415)/ 0.49291268416262488151470388796806879D+11/
      DATA SM(416)/ 0.72275475649724017889556850767667423D+11/
      DATA SM(417)/ 0.10231844050993447671050817554186155D+12/
      DATA SM(418)/-0.19353613614062201300222304191074174D+12/
      DATA SM(419)/-0.31578105784437260753313365984303344D+11/
      DATA SM(420)/-0.19628640127569267921919381644366614D+12/
      DATA SM(421)/-0.23493835682428916483805075589036442D+12/
      DATA SM(422)/ 0.34596814316043803379945280716863554D+12/
      DATA SM(423)/-0.19369291137118491832423911785551437D+12/
      DATA SM(424)/ 0.16277376176336069879170040427886232D+12/
      DATA SM(425)/ 0.54110401145692065210913932551244100D+12/
      DATA SM(426)/-0.61678545188606053697262743693339336D+11/
      DATA SM(427)/ 0.15110884408276901908640386985866782D+12/
      DATA SM(428)/-0.56873900738593417483951256570015073D+12/
      DATA SM(429)/-0.21638364396266190103009009972881171D+12/
      DATA SM(430)/ 0.30209351691193232219395356977251490D+12/
      DATA SM(431)/-0.59744789723002401178186876232266200D+12/
      DATA SM(432)/-0.16018373907054360201788680751233688D+11/
      DATA SM(433)/-0.75445205932715657457372635459612485D+10/
      DATA SM(434)/ 0.10473209035945709925417641281799677D+11/
      DATA SM(435)/ 0.13934473152298940036649128777262056D+10/
      DATA SM(436)/ 0.86903916358530088808107003612077942D+10/
      DATA SM(437)/ 0.65595498738522089567180706087937270D+10/
      DATA SM(438)/-0.76450472287433200005495900701556174D+10/
      DATA SM(439)/-0.49704349339060044534177068250313436D+10/
      DATA SM(440)/ 0.44560926250593545477582162491471822D+10/
      DATA SM(441)/ 0.36745354663424684573086728593619665D+10/
      DATA SM(442)/-0.15149689478068439497807665212087262D+10/
      DATA SM(443)/-0.31416027511176204604739642152734567D+10/
      DATA SM(444)/-0.42049603541611115941801263988053874D+10/
      DATA SM(445)/ 0.56687748226473938721451269749192154D+10/
      DATA SM(446)/ 0.28863121223146162782669150952217626D+10/
      DATA SM(447)/-0.18823671565008502236492357567445266D+10/
      DATA SM(448)/-0.31075067429470327642957854283747437D+10/
      DATA SM(449)/ 0.46740639085174519249725445942954444D+10/
      DATA SM(450)/ 0.58484093395206450116154903925518922D+10/
      DATA SM(451)/ 0.44213097570011899418892405242780871D+10/
      DATA SM(452)/-0.62143227631964246981842307975987093D+11/
      DATA SM(453)/-0.17680403113649078870084004898471458D+11/
      DATA SM(454)/ 0.16896740789892919320083557528738543D+11/
      DATA SM(455)/ 0.27947234981939973979721984679749040D+11/
      DATA SM(456)/ 0.23107635067864883910284655295075547D+11/
      DATA SM(457)/-0.34358865279038207119363916058374440D+10/
      DATA SM(458)/ 0.38776789977171160750281852089433573D+10/
      DATA SM(459)/-0.49447327997461438997290173806011387D+11/
      DATA SM(460)/ 0.14933408836014318903416485691713725D+11/
      DATA SM(461)/ 0.82188666253275604169706440121524464D+11/
      DATA SM(462)/ 0.14624923281114244609694624485094252D+12/
      DATA SM(463)/ 0.21079402121036546690336726456301033D+12/
      DATA SM(464)/ 0.71642080022521860587400511477727061D+11/
      DATA SM(465)/-0.88209178612804860573760981166211010D+11/
      DATA SM(466)/-0.12990918630333240424374819229341065D+12/
      DATA SM(467)/ 0.23738997209852260643388859092222113D+11/
      DATA SM(468)/-0.91784213123213253116543212874137050D+09/
      DATA SM(469)/ 0.20642444914862166810138859775106026D+11/
      DATA SM(470)/ 0.69450181919474136330863918489079065D+09/
      DATA SM(471)/ 0.17255495763480089960570407763946246D+11/
      DATA SM(472)/ 0.54699902016132805866575282269598148D+10/
      DATA SM(473)/-0.18874376180874451202236781061834147D+11/
      DATA SM(474)/-0.81964034643529213145963873710114382D+10/
      DATA SM(475)/ 0.92017356505769462591594428686825954D+10/
      DATA SM(476)/-0.17031998159486861994577501115898940D+11/
      DATA SM(477)/ 0.59478519230910275986214032308315998D+10/
      DATA SM(478)/ 0.97592242236040677571034873720046050D+10/
      DATA SM(479)/-0.23249135050725817882928595428396287D+11/
      DATA SM(480)/-0.14683430792539325154343461139570124D+10/
      DATA SM(481)/-0.17471039919653526214664094784002806D+11/
      DATA SM(482)/ 0.24562371966930817173221137764662112D+11/
      DATA SM(483)/-0.82136801469605868552928344254370534D+10/
      DATA SM(484)/ 0.13307293270706511435217886877725458D+11/
      DATA SM(485)/-0.64595039727099266673766212347714359D+10/
      DATA SM(486)/ 0.82914203909505393512796775948734071D+10/
      DATA SM(487)/-0.26974543318223804456603064036344905D+11/
      DATA SM(488)/-0.22813213715346292542965525389204715D+11/
      DATA SM(489)/-0.16535441370035943928788947421481516D+11/
      DATA SM(490)/ 0.55949541883323008542667448899918857D+10/
      DATA SM(491)/-0.32327211335948944247956202102061745D+10/
      DATA SM(492)/-0.87824083779490565685465781451557578D+10/
      DATA SM(493)/-0.97170062213839257730138454803177609D+10/
      DATA SM(494)/ 0.25214413287831547256287957724874502D+11/
      DATA SM(495)/-0.24783534806164615628099663883513002D+11/
      DATA SM(496)/ 0.19986679194578281764001496398013973D+11/
      DATA SM(497)/-0.14341972324344581931166033281912257D+11/
      DATA SM(498)/-0.40074524720258805199015091308160337D+10/
      DATA SM(499)/-0.10974041355596713474856734746020509D+10/
      DATA SM(500)/ 0.14792927945024232753370634929167766D+10/
      DATA SM(501)/ 0.10164705975214059146275977900392559D+11/
      DATA SM(502)/ 0.33175274955574552370840199193113221D+11/
      DATA SM(503)/ 0.19791481907513175284556816970687347D+11/
      DATA SM(504)/ 0.16929119975672209958194931972372277D+11/
      DATA SM(505)/-0.85843608874763770403739204260763796D+11/
      DATA SM(506)/ 0.99249590008636233276041811665330449D+11/
      DATA SM(507)/-0.72444424426441793285957645923998599D+11/
      DATA SM(508)/ 0.15593211274669623761936725747666542D+10/
      DATA SM(509)/ 0.18495867372606136448041930862341587D+11/
      DATA SM(510)/ 0.15942494963892655287365120404032367D+11/
      DATA SM(511)/-0.44466158703951073635440500419660825D+11/
      DATA SM(512)/-0.59277489829699676991857315990721193D+11/
      DATA SM(513)/-0.18300395769228663891830671705567288D+11/
      DATA SM(514)/ 0.61225485335948573323577740038641771D+11/
      DATA SM(515)/ 0.17514671312346359804015818130656446D+11/
      DATA SM(516)/-0.21673851382206089376125697295855676D+11/
      DATA SM(517)/ 0.37950080199704963141661173095380146D+11/
      DATA SM(518)/ 0.19020619699070814200922684399440318D+10/
      DATA SM(519)/ 0.27886338187060313438712294330000418D+11/
      DATA SM(520)/ 0.33628808325907977874370921864734700D+11/
      DATA SM(521)/ 0.25149945546631235061672714945109969D+11/
      DATA SM(522)/-0.15935715579207739069219550492802237D+11/
      DATA SM(523)/-0.63514612630198862613061752649371732D+10/
      DATA SM(524)/-0.96726173737644648557185380517281309D+10/
      DATA SM(525)/-0.10501524483747882366649635556126628D+11/
      DATA SM(526)/-0.32384254273213982205465197908347055D+11/
      DATA SM(527)/ 0.11963369802086350633644411031396384D+11/
      DATA SM(528)/-0.13741871116415976308377500324658295D+11/
      DATA SM(529)/-0.10463670185093812508679763848055171D+11/
      DATA SM(530)/ 0.65874262017824002304997086850142786D+11/
      DATA SM(531)/-0.20517197412508945812140338794860401D+11/
      DATA SM(532)/-0.45256139453083517577762394729655048D+11/
      DATA SM(533)/-0.86769383815848213049161801218904838D+11/
      DATA SM(534)/-0.34307938638921594191164062084449238D+11/
      DATA SM(535)/-0.10457912291180974921712927346714965D+12/
      DATA SM(536)/ 0.62614127596739587181235280253823320D+11/
      DATA SM(537)/-0.77308543229817823774278737140944898D+11/
      DATA SM(538)/ 0.50545047390979849738630930115120264D+10/
      DATA SM(539)/ 0.24653719482401738500207948764413314D+12/
      DATA SM(540)/-0.15548748751443012007775225812385207D+12/
      DATA SM(541)/ 0.55516261797372286543059243369534211D+11/
      DATA SM(542)/-0.23398677906749377497975328633341099D+12/
      DATA SM(543)/ 0.34233946796456951873120842406491576D+12/
      DATA SM(544)/-0.69275094103443016136500486802401512D+10/
      DATA SM(545)/-0.13931518351592867498483746485959534D+12/
      DATA SM(546)/-0.37545458900001495046816775029133696D+11/
      DATA SM(547)/ 0.35558516200449541323981121153283960D+12/
      DATA SM(548)/ 0.38093947678656577015431759367517366D+11/
      DATA SM(549)/-0.79113295399894166219596758637330814D+09/
      DATA SM(550)/-0.52625780094140172438031007540361251D+11/
      DATA SM(551)/ 0.41280492186813171025991921659070553D+11/
      DATA SM(552)/ 0.20910605823261192011599675815579025D+11/
      DATA SM(553)/ 0.48987613701598977086676085428358770D+10/
      DATA SM(554)/ 0.40759749289067439094517999874928857D+10/
      DATA SM(555)/ 0.21975250070412796231794529643335659D+10/
      DATA SM(556)/ 0.49032311699646621045472805246629728D+10/
      DATA SM(557)/ 0.89545476874963265989933581648895573D+10/
      DATA SM(558)/-0.50516612425060954738014499163487646D+10/
      DATA SM(559)/-0.62171738392550718055728731602678913D+10/
      DATA SM(560)/-0.15905418918275073646063270229265924D+11/
      DATA SM(561)/ 0.43969142757202602205776285070001271D+10/
      DATA SM(562)/ 0.55173428977607827350348716250733739D+10/
      DATA SM(563)/ 0.10229697821480446138533747457700308D+09/
      DATA SM(564)/-0.50097554292666355340897843625046703D+08/
      DATA SM(565)/ 0.56915009862487249288028179145860724D+11/
      DATA SM(566)/ 0.21328013336331710698023521477614660D+11/
      DATA SM(567)/-0.57174984260663403510055242449716063D+11/
      DATA SM(568)/-0.33765733344901002252761598024414934D+11/
      DATA SM(569)/-0.40895671446707468789389208515687196D+11/
      DATA SM(570)/-0.57661283419499124907194907688593384D+09/
      DATA SM(571)/ 0.11276236064457863406359826161097958D+12/
      DATA SM(572)/-0.85808326762718828296320185736768259D+11/
      DATA SM(573)/ 0.14847547050951319835091971609749537D+12/
      DATA SM(574)/ 0.29383954797538491776244062272611373D+11/
      DATA SM(575)/-0.10139741385090911873277024150983968D+12/
      DATA SM(576)/-0.43077117534621665740951613993087725D+11/
      DATA SM(577)/-0.20496618392329783226955327749555435D+12/
      DATA SM(578)/ 0.10522726367333872613052822635818687D+14/
      DATA SM(579)/ 0.10969675166680712353566281145828221D+12/
      DATA SM(580)/ 0.53481478109412014965918542850849207D+12/
      DATA SM(581)/ 0.10418991864030758443804041130411316D+13/
      DATA SM(582)/ 0.13419901991408884588311139260858378D+12/
      DATA SM(583)/ 0.24896115163766649669379216121149499D+12/
      DATA SM(584)/ 0.10667301780932052249555983750675113D+11/
      DATA SM(585)/ 0.55805990528620096058730242159449050D+10/
      DATA SM(586)/ 0.14114531469995903591790216584390678D+13/
      DATA SM(587)/-0.15204399455530183808629958103980953D+13/
      DATA SM(588)/ 0.21415600546532929121995663847989606D+13/
      DATA SM(589)/ 0.21669165783581379354706193323755752D+11/
      DATA SM(590)/-0.32763179830971496922277776759446290D+11/
      DATA SM(591)/-0.23099289447061905253783609074850080D+12/
      DATA SM(592)/ 0.19757164850817692659447364189292360D+12/
      DATA SM(593)/-0.80391886308944134366540731870431937D+11/
      DATA SM(594)/ 0.70294156592622135901700586389542107D+12/
      DATA SM(595)/-0.25374384130811919444681587136938336D+12/
      DATA SM(596)/ 0.12336945360446705690240960371038069D+13/
      DATA SM(597)/-0.32984890699832305715238462405099750D+13/
      DATA SM(598)/ 0.60621279575268592954361280673673095D+13/
      DATA SM(599)/ 0.12255991861927443722600678313080344D+11/
      DATA SM(600)/-0.16569494434298508998984160052564230D+10/
      DATA SM(601)/-0.37465037367901137746803409815920099D+10/
      DATA SM(602)/-0.83460776502667504945292531786336948D+10/
      DATA SM(603)/ 0.99636951029418793614203368743100409D+10/
      DATA SM(604)/-0.63773929484624047306490964278555012D+09/
      DATA SM(605)/-0.30393967954446752040103212863001955D+11/
      DATA SM(606)/ 0.12130257496402840606465242479348669D+11/
      DATA SM(607)/ 0.47346692535756003026125448228613293D+10/
      DATA SM(608)/-0.18923940675262791614346957468422987D+11/
      DATA SM(609)/-0.22620170190776614250062820126569835D+11/
      DATA SM(610)/ 0.55954907973725060436403618193653068D+10/
      DATA SM(611)/ 0.20835592015167982002347073644096953D+11/
      DATA SM(612)/ 0.19314297891091026214951225604446492D+10/
      DATA SM(613)/-0.91013830381428741181017095045889349D+11/
      DATA SM(614)/ 0.75755805401238799274887942921313201D+11/
      DATA SM(615)/ 0.63074945691368418089029157725206045D+11/
      DATA SM(616)/-0.99891129917701746594537052803826659D+10/
      DATA SM(617)/-0.32928576033791082260980834668231199D+10/
      DATA SM(618)/ 0.10277719146531437206896732243423550D+11/
      DATA SM(619)/ 0.70545269222250465035373425898728607D+12/
      DATA SM(620)/ 0.44571769909150405626786000715496694D+11/
      DATA SM(621)/-0.61040841320202121118605436843211166D+12/
      DATA SM(622)/ 0.85435196753548225869868614309458021D+12/
      DATA SM(623)/ 0.26696411037051450242875449600927103D+13/
      DATA SM(624)/-0.10492893251893087058130399612349581D+13/
      DATA SM(625)/-0.15825344392326773434824532101525060D+13/
      DATA SM(626)/ 0.28732006076927773781730488542483570D+13/
      DATA SM(627)/ 0.16940174373471583553473301159508279D+13/
      DATA SM(628)/-0.65986893709011900929294096640336046D+12/
      DATA SM(629)/-0.93983563615769439492542045330853831D+12/
      DATA SM(630)/ 0.14877359248789877031292310112005627D+13/
      DATA SM(631)/ 0.52270725258263757282758728952018899D+11/
      DATA SM(632)/ 0.25326721905316116258719861966324787D+11/
      DATA SM(633)/ 0.42470651172405122951041307633925848D+11/
      DATA SM(634)/-0.15355403008030581085729319032051587D+10/
      DATA SM(635)/-0.68871303873673750963381522188186284D+09/
      DATA SM(636)/ 0.23173809317748255109310941480306772D+11/
      DATA SM(637)/ 0.84473594643648832369719678709102833D+11/
      DATA SM(638)/ 0.17168405100757996748239352717048574D+12/
      DATA SM(639)/ 0.15005430811351394465210566429393369D+12/
      DATA SM(640)/-0.24425687314852918225557954819263128D+10/
      DATA SM(641)/-0.13819410892808211621621392455900307D+12/
      DATA SM(642)/-0.17311949288467083345652553212636673D+12/
      DATA SM(643)/ 0.34365860912854871678518831969740004D+13/
      DATA SM(644)/ 0.39754752428596090132346058021315101D+13/
      DATA SM(645)/ 0.39668103689082449149486068429493578D+13/
      DATA SM(646)/-0.15591654062196956708769641849163956D+13/
      DATA SM(647)/-0.16425471203186052301460958337489588D+13/
      DATA SM(648)/-0.19527522731978752654086690867420936D+13/
      DATA SM(649)/ 0.21693951353484112573627322666452655D+11/
      DATA SM(650)/ 0.79750561688086878589440856000591548D+10/
      DATA SM(651)/-0.15369089536357827081920760556474941D+11/
      DATA SM(652)/-0.22589424118088980334942202814672781D+10/
      DATA SM(653)/-0.87191644155791555148279119992435317D+10/
      DATA SM(654)/-0.71785453733192256779313061867275528D+10/
      DATA SM(655)/ 0.60049418279189088941388893753598835D+10/
      DATA SM(656)/ 0.37460498910395500175357196938391940D+10/
      DATA SM(657)/-0.42218352039802751286934563690675883D+10/
      DATA SM(658)/ 0.26462616141645707740046880523793975D+09/
      DATA SM(659)/ 0.53912425584874123990226387755780127D+10/
      DATA SM(660)/ 0.18512540737444039258256175825628696D+10/
      DATA SM(661)/-0.12029221326801760040891946948871490D+09/
      DATA SM(662)/-0.11797177867694165177318452334947163D+10/
      DATA SM(663)/ 0.93041159576987143534279241930400194D+10/
      DATA SM(664)/ 0.43367359688825514066657001103992254D+10/
      DATA SM(665)/ 0.60603509915669758962348766358468869D+11/
      DATA SM(666)/ 0.17108971076374485750755920922000447D+11/
      DATA SM(667)/-0.31132854962317323865667977542550155D+11/
      DATA SM(668)/-0.34285181385067413621523264602125641D+11/
      DATA SM(669)/-0.23580698259378850880831300773133917D+11/
      DATA SM(670)/-0.31642160204360929686894074690733685D+10/
      DATA SM(671)/-0.39994612617379118684558701687511591D+10/
      DATA SM(672)/-0.24273593861441649440013657677988226D+10/
      DATA SM(673)/ 0.79108598544304184559172934830306022D+09/
      DATA SM(674)/-0.35227767846536893549408596787079935D+10/
      DATA SM(675)/-0.69851059690680301513383753046872019D+10/
      DATA SM(676)/-0.78117756753481091478804851275837920D+10/
      DATA SM(677)/-0.33734331734066901377988725936206148D+10/
      DATA SM(678)/ 0.64774333014402186572262795653054841D+11/
      DATA SM(679)/ 0.23848049183482086739448541556206978D+11/
      DATA SM(680)/-0.21212081876712867634290100424398883D+11/
      DATA SM(681)/ 0.28099740155289560534153379024980792D+11/
      DATA SM(682)/-0.82506321762525625627556297767507259D+11/
      DATA SM(683)/-0.33849802839977835505223446403244815D+10/
      DATA SM(684)/ 0.73352302423084615890036658101258149D+10/
      DATA SM(685)/-0.19296420834618897596611041386325174D+11/
      DATA SM(686)/ 0.21111156458974061444486479665534450D+11/
      DATA SM(687)/-0.93400355342976200323346992553552476D+11/
      DATA SM(688)/-0.52993693521386102922333391719995505D+11/
      DATA SM(689)/ 0.99870846841992827828210302874465412D+11/
      DATA SM(690)/-0.10601575960710452170268651477051973D+12/
      DATA SM(691)/-0.15435766649698120716263565694905330D+12/
      DATA SM(692)/-0.25227321376477920345906223080233275D+12/
      DATA SM(693)/-0.41276347041824333914982485060445314D+12/
      DATA SM(694)/-0.36396420540921237896225719663850166D+12/
      DATA SM(695)/ 0.34999822704070679946385883026858699D+12/
      DATA SM(696)/ 0.17570048251230331024207941932130579D+12/
      DATA SM(697)/-0.58836650518821257848413448250499858D+12/
      DATA SM(698)/-0.80669280247705669516513951716117608D+12/
      DATA SM(699)/-0.90146755074543680229963580606233227D+12/
      DATA SM(700)/ 0.16026912087372580295312980920590488D+13/
      DATA SM(701)/-0.99775665360772045143165902543387320D+12/
      DATA SM(702)/-0.48587414819233483301547445875267866D+12/
      DATA SM(703)/-0.27791792775227040574621973303108332D+12/
      DATA SM(704)/-0.50433081736184612266025144188895579D+12/
      DATA SM(705)/-0.53474810919522218302428932621445459D+12/
      DATA SM(706)/ 0.99146402169038228946439003788650827D+12/
      DATA SM(707)/-0.40801632371217509428072733039255130D+11/
      DATA SM(708)/ 0.79276207009514853846368248928883931D+10/
      DATA SM(709)/-0.19114184191801006046875483430930368D+11/
      DATA SM(710)/-0.21151880802880290352153355876913447D+10/
      DATA SM(711)/-0.14463159574445512350326784310609979D+11/
      DATA SM(712)/ 0.51740564951512444567814947087694435D+10/
      DATA SM(713)/ 0.35681949245551624329290254386818435D+11/
      DATA SM(714)/ 0.10926650560351913023480959105486176D+11/
      DATA SM(715)/ 0.24675984967828312278969761631108080D+10/
      DATA SM(716)/ 0.45980412357904738149739182239639435D+11/
      DATA SM(717)/ 0.64262345011214162499135529070566158D+10/
      DATA SM(718)/-0.17353238480935122028199280257948657D+11/
      DATA SM(719)/ 0.18466107953832716471201300058912556D+11/
      DATA SM(720)/ 0.15653367878912859168996602008684955D+10/
      DATA SM(721)/ 0.13609759680357122590251440139970244D+11/
      DATA SM(722)/-0.34195557997017009754837189838054723D+11/
      DATA SM(723)/ 0.70788613707506560696161734627147371D+09/
      DATA SM(724)/-0.16571026245085433337437188522425622D+11/
      DATA SM(725)/-0.40106188414696584601626955043345158D+11/
      DATA SM(726)/ 0.14930263365219318352795672997729338D+11/
      DATA SM(727)/-0.14955944150354679065102150090133029D+11/
      DATA SM(728)/ 0.92031670376768210424070887599156531D+10/
      DATA SM(729)/ 0.94067826097649396795978762117401338D+10/
      DATA SM(730)/-0.76631033063155509801324736259618563D+10/
      DATA SM(731)/-0.11421281473617389984054548093743884D+11/
      DATA SM(732)/-0.10859864590611109627069523459895701D+11/
      DATA SM(733)/-0.53604623554180846073806285135059397D+11/
      DATA SM(734)/-0.32062494899332250037609795443293504D+11/
      DATA SM(735)/-0.15805159954374279485192746907757881D+11/
      DATA SM(736)/ 0.60848223318962412521455496752037976D+10/
      DATA SM(737)/ 0.16894400012792001360257723755416615D+11/
      DATA SM(738)/ 0.22852280827143055734356470997406606D+11/
      DATA SM(739)/-0.97281426661251708416686041901450865D+10/
      DATA SM(740)/ 0.75579062856868706949008486651288914D+10/
      DATA SM(741)/ 0.20334811034910322127660973828712583D+11/
      DATA SM(742)/ 0.12457994435999859434523602253094762D+11/
      DATA SM(743)/-0.99532884904058551573876579812027413D+10/
      DATA SM(744)/ 0.86125979627906071766822886111279265D+10/
      DATA SM(745)/ 0.43731710982464434242032732507831034D+11/
      DATA SM(746)/ 0.10765722529818863396015152466986862D+12/
      DATA SM(747)/ 0.11551096891773992516326255028751441D+12/
      DATA SM(748)/ 0.11832451935422033093952342742727253D+12/
      DATA SM(749)/-0.13993181858010918378848753263839755D+12/
      DATA SM(750)/ 0.63650451884720523632763787389722288D+11/
      DATA SM(751)/ 0.11938869709355541350819451951234850D+12/
      DATA SM(752)/ 0.70914422423678236532711335759928176D+11/
      DATA SM(753)/ 0.56195749720346647359959909267539538D+11/
      DATA SM(754)/-0.73354937386589887819497656903528160D+11/
      DATA SM(755)/ 0.45357870079009941589538158648826685D+11/
      DATA SM(756)/ 0.41253558526132775341534245736142105D+11/
      DATA SM(757)/-0.52985745072038850028442212555314727D+11/
      DATA SM(758)/-0.78270248697012599172242631852850268D+11/
      DATA SM(759)/-0.54336038693144137539955129096313679D+11/
      DATA SM(760)/-0.77485286841727034709894553788862916D+11/
      DATA SM(761)/-0.10785469388191215382331120365349313D+12/
      DATA SM(762)/ 0.97308530740296217262160238150674985D+11/
      DATA SM(763)/ 0.59307353240904485824837395273619597D+11/
      DATA SM(764)/-0.15334953812937824726801605680150519D+12/
      DATA SM(765)/ 0.12019128863143613157578214259230916D+12/
      DATA SM(766)/-0.16457219908976934244667547305257637D+11/
      DATA SM(767)/-0.11901828544295650367570940839038600D+11/
      DATA SM(768)/-0.18885437056815540452675312338734286D+11/
      DATA SM(769)/ 0.49466695175474127852558932453424135D+11/
      DATA SM(770)/-0.10572003759868598457883884676104550D+12/
      DATA SM(771)/ 0.22103130356082966197255823367521159D+11/
      DATA SM(772)/-0.86941262600339813198625200459271104D+11/
      DATA SM(773)/-0.63660640730725010786119617901667384D+11/
      DATA SM(774)/ 0.83230331748524675972152168409729868D+11/
      DATA SM(775)/ 0.94652643685469074062532687527751157D+11/
      DATA SM(776)/-0.14799271888149665693962018400209703D+11/
      DATA SM(777)/ 0.50488721757672617527413100890683140D+11/
      DATA SM(778)/-0.67440756861365333514829183983615709D+11/
      DATA SM(779)/-0.83980041085670446341014428648104403D+11/
      DATA SM(780)/ 0.39543631155581918406010179610889344D+11/
      DATA SM(781)/-0.28342845205578413445921487385369569D+12/
      DATA SM(782)/ 0.45051553551277127986496224468133422D+12/
      DATA SM(783)/ 0.28593962844071599342919540737593593D+12/
      DATA SM(784)/-0.54628334103790186337888437832057768D+11/
      DATA SM(785)/-0.77222523702610322114534262947854257D+11/
      DATA SM(786)/-0.45362698739735788414866643422045539D+11/
      DATA SM(787)/ 0.65191283503675488781918721507051609D+11/
      DATA SM(788)/-0.15655874843003006116084932134906175D+12/
      DATA SM(789)/ 0.16263116424985549021806578669682322D+11/
      DATA SM(790)/-0.17255971006527396886626443290554878D+11/
      DATA SM(791)/ 0.17688793751630664076329809106221475D+12/
      DATA SM(792)/ 0.19307259484796019002610976076895593D+12/
      DATA SM(793)/-0.60051762527566807393852031272532906D+10/
      DATA SM(794)/-0.17218718979645217237582000900364280D+11/
      DATA SM(795)/-0.49926926098401811118295099463884724D+11/
      DATA SM(796)/ 0.19740327120113986489829997619348168D+10/
      DATA SM(797)/ 0.29265803125814030885591667197006681D+11/
      DATA SM(798)/-0.18278107562637239168227745891222080D+11/
      DATA SM(799)/-0.49918130085483389946134532737028733D+11/
      DATA SM(800)/-0.51300548515133544800527061697815590D+12/
      DATA SM(801)/ 0.43206279787363597395736154577221888D+12/
      DATA SM(802)/ 0.45226673811882416323578424975647941D+12/
      DATA SM(803)/-0.26859270874246858291967261820523569D+12/
      DATA SM(804)/ 0.46449216587803376867424441245621764D+12/
      DATA SM(805)/ 0.25614771958574675909996244598856241D+11/
      DATA SM(806)/-0.42549555972311882332771776683959165D+11/
      DATA SM(807)/ 0.11062277013501404013317100463110895D+11/
      DATA SM(808)/ 0.61137834578088090810911870891967699D+11/
      DATA SM(809)/-0.52443881639697974147355004205817848D+11/
      DATA SM(810)/-0.26857314318119333332000827408907703D+11/
      DATA SM(811)/-0.18455058976632068709698186229690070D+10/
      DATA SM(812)/ 0.24055785319958007488107717663802484D+11/
      DATA SM(813)/-0.11884951227560447003126356727125175D+11/
      DATA SM(814)/-0.57276963874089883327002722743427359D+11/
      DATA SM(815)/-0.20280971545310735852299006654533493D+11/
      DATA SM(816)/-0.92336119809306568744842434781233638D+10/
      DATA SM(817)/ 0.21551762530765231862336676119259664D+11/
      DATA SM(818)/ 0.13057919938724618958539737843250440D+11/
      DATA SM(819)/ 0.24441460979190370303064636152947044D+10/
      DATA SM(820)/ 0.10390817371195307416017107873507333D+11/
      DATA SM(821)/ 0.30278019854172809530417692598948545D+10/
      DATA SM(822)/-0.30248196609917671357108877054307269D+11/
      DATA SM(823)/ 0.50720395783195835407247697730581932D+11/
      DATA SM(824)/-0.28365446508922024692363729111160748D+11/
      DATA SM(825)/-0.29378050149373048389047198467455032D+11/
      DATA SM(826)/ 0.21320333013275871257310073099316360D+11/
      DATA SM(827)/-0.19827584186588884066110447375240070D+10/
      DATA SM(828)/-0.21889977838531829278325802315316062D+11/
      DATA SM(829)/ 0.42072096880864563904879318279842436D+11/
      DATA SM(830)/ 0.25064222527879310441149712223067633D+11/
      DATA SM(831)/ 0.10705401684194370774159738636327044D+11/
      DATA SM(832)/ 0.34895188687405619952438149370667215D+11/
      DATA SM(833)/ 0.18887867835048886037280335425081949D+11/
      DATA SM(834)/-0.28243288478760058419600810718384183D+11/
      DATA SM(835)/ 0.46145085664188274367006984819311453D+11/
      DATA SM(836)/-0.81576648603011915197942626727568050D+10/
      DATA SM(837)/ 0.15976470163130821020518575882870180D+10/
      DATA SM(838)/ 0.21546396615380451694401598201753545D+12/
      DATA SM(839)/ 0.53930874995991084384574091705600891D+11/
      DATA SM(840)/-0.24646799881646800105020019290177127D+10/
      DATA SM(841)/ 0.16969185238442237554752193966033984D+12/
      DATA SM(842)/ 0.25511959627853164559039112061428014D+11/
      DATA SM(843)/-0.81331577403233051499916243488545319D+11/
      DATA SM(844)/-0.26253554685330060585093176585068566D+12/
      DATA SM(845)/ 0.20476648171197632544017692194988468D+12/
      DATA SM(846)/-0.37229400751075312486864681055527127D+12/
      DATA SM(847)/-0.96559938489314609339246086914398987D+11/
      DATA SM(848)/ 0.25469420504021232798656179610874593D+12/
      DATA SM(849)/-0.22683098578711538763327063725651661D+10/
      DATA SM(850)/ 0.28769345095504168876983896893775867D+12/
      DATA SM(851)/-0.52324094217444192562982694331046233D+12/
      DATA SM(852)/ 0.71840580867755524320145368052291194D+12/
      DATA SM(853)/ 0.52932518711540073629818739644459070D+12/
      DATA SM(854)/-0.38657846643631804207945811229201193D+12/
      DATA SM(855)/-0.56735904755304412231705542269579991D+12/
      DATA SM(856)/ 0.41379672897948473401997550697609256D+12/
      DATA SM(857)/-0.54243962307229200698738122131609864D+12/
      DATA SM(858)/-0.45840326143970396797148040470867733D+11/
      DATA SM(859)/-0.20370825616901948969322418399135910D+12/
      DATA SM(860)/ 0.41354425629968435917167044341464281D+12/
      DATA SM(861)/-0.33935622380446523846699610932376099D+12/
      DATA SM(862)/-0.18911499075461436164166493663393863D+12/
      DATA SM(863)/ 0.63617716124350220783920712170298538D+12/
      DATA SM(864)/-0.52893604032252756122734030043085206D+12/
      DATA SM(865)/ 0.76940753783563672146289290704853234D+12/
      END
      SUBROUTINE H2KOLOS(X,ENER)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CF(  1: 12)
      DATA CF(  1)/0.101416837740073D+01/
      DATA CF(  2)/-.488154275098716D+01/
      DATA CF(  3)/0.104303200226445D+03/
      DATA CF(  4)/-.254367660766904D+04/
      DATA CF(  5)/0.491360282731773D+05/
      DATA CF(  6)/-.692054319622142D+06/
      DATA CF(  7)/0.691682195800685D+07/
      DATA CF(  8)/-.481905764769837D+08/
      DATA CF(  9)/0.227937841254387D+09/
      DATA CF( 10)/-.696105358658324D+09/
      DATA CF( 11)/0.123619149806826D+10/
      DATA CF( 12)/-.968646696513115D+09/
      ENER = 0.000000000000000D+00
      ENER=ENER+CF(  1)*DEXP(-0.192970754099340D+01*X)/X
      RHO = X*DEXP(-0.175088401605984D+01*X)
      DO 1 I=  2, 12
         ENER=ENER+CF(I)*RHO**(I-1)
    1 CONTINUE
      RETURN
      END
      SUBROUTINE H310(X,Y,Z,ENER)
      IMPLICIT  REAL * 8 (A-H,O-Z)
      DIMENSION I(255), J(255), K(255), CF(255)
      DIMENSION XXX(0:9), YYY(0:9), ZZZ(0:9)
      DATA CF(  1)/0.72341991623262372512765794516260D+02/
      DATA I(  1)/ 1/,J(  1)/ 1/,K(  1)/ 0/
      DATA CF(  2)/0.72341991623262372512765794516260D+02/
      DATA I(  2)/ 1/,J(  2)/ 0/,K(  2)/ 1/
      DATA CF(  3)/0.72341991623262372512765794516260D+02/
      DATA I(  3)/ 0/,J(  3)/ 1/,K(  3)/ 1/
      DATA CF(  4)/0.15747446586304044260284156891668D+03/
      DATA I(  4)/ 1/,J(  4)/ 1/,K(  4)/ 1/
      DATA CF(  5)/-.10891814124540260287472687232338D+04/
      DATA I(  5)/ 2/,J(  5)/ 1/,K(  5)/ 0/
      DATA CF(  6)/-.10891814124540260287472687232338D+04/
      DATA I(  6)/ 2/,J(  6)/ 0/,K(  6)/ 1/
      DATA CF(  7)/-.10891814124540260287472687232338D+04/
      DATA I(  7)/ 1/,J(  7)/ 2/,K(  7)/ 0/
      DATA CF(  8)/-.10891814124540260287472687232338D+04/
      DATA I(  8)/ 1/,J(  8)/ 0/,K(  8)/ 2/
      DATA CF(  9)/-.10891814124540260287472687232338D+04/
      DATA I(  9)/ 0/,J(  9)/ 2/,K(  9)/ 1/
      DATA CF( 10)/-.10891814124540260287472687232338D+04/
      DATA I( 10)/ 0/,J( 10)/ 1/,K( 10)/ 2/
      DATA CF( 11)/-.14265539847910886553232321059401D+04/
      DATA I( 11)/ 2/,J( 11)/ 1/,K( 11)/ 1/
      DATA CF( 12)/-.14265539847910886553232321059401D+04/
      DATA I( 12)/ 1/,J( 12)/ 2/,K( 12)/ 1/
      DATA CF( 13)/-.14265539847910886553232321059401D+04/
      DATA I( 13)/ 1/,J( 13)/ 1/,K( 13)/ 2/
      DATA CF( 14)/0.39494336568704414985169780732877D+05/
      DATA I( 14)/ 2/,J( 14)/ 2/,K( 14)/ 0/
      DATA CF( 15)/0.39494336568704414985169780732877D+05/
      DATA I( 15)/ 2/,J( 15)/ 0/,K( 15)/ 2/
      DATA CF( 16)/0.39494336568704414985169780732877D+05/
      DATA I( 16)/ 0/,J( 16)/ 2/,K( 16)/ 2/
      DATA CF( 17)/-.24691357244074774459518000698609D+04/
      DATA I( 17)/ 3/,J( 17)/ 1/,K( 17)/ 0/
      DATA CF( 18)/-.24691357244074774459518000698609D+04/
      DATA I( 18)/ 3/,J( 18)/ 0/,K( 18)/ 1/
      DATA CF( 19)/-.24691357244074774459518000698609D+04/
      DATA I( 19)/ 1/,J( 19)/ 3/,K( 19)/ 0/
      DATA CF( 20)/-.24691357244074774459518000698609D+04/
      DATA I( 20)/ 1/,J( 20)/ 0/,K( 20)/ 3/
      DATA CF( 21)/-.24691357244074774459518000698609D+04/
      DATA I( 21)/ 0/,J( 21)/ 3/,K( 21)/ 1/
      DATA CF( 22)/-.24691357244074774459518000698609D+04/
      DATA I( 22)/ 0/,J( 22)/ 1/,K( 22)/ 3/
      DATA CF( 23)/0.76809092464023648577550457965998D+05/
      DATA I( 23)/ 2/,J( 23)/ 2/,K( 23)/ 1/
      DATA CF( 24)/0.76809092464023648577550457965998D+05/
      DATA I( 24)/ 2/,J( 24)/ 1/,K( 24)/ 2/
      DATA CF( 25)/0.76809092464023648577550457965998D+05/
      DATA I( 25)/ 1/,J( 25)/ 2/,K( 25)/ 2/
      DATA CF( 26)/-.55734852976377202418291214375338D+05/
      DATA I( 26)/ 3/,J( 26)/ 1/,K( 26)/ 1/
      DATA CF( 27)/-.55734852976377202418291214375338D+05/
      DATA I( 27)/ 1/,J( 27)/ 3/,K( 27)/ 1/
      DATA CF( 28)/-.55734852976377202418291214375338D+05/
      DATA I( 28)/ 1/,J( 28)/ 1/,K( 28)/ 3/
      DATA CF( 29)/-.32244161252385658183564313393601D+06/
      DATA I( 29)/ 3/,J( 29)/ 2/,K( 29)/ 0/
      DATA CF( 30)/-.32244161252385658183564313393601D+06/
      DATA I( 30)/ 3/,J( 30)/ 0/,K( 30)/ 2/
      DATA CF( 31)/-.32244161252385658183564313393601D+06/
      DATA I( 31)/ 2/,J( 31)/ 3/,K( 31)/ 0/
      DATA CF( 32)/-.32244161252385658183564313393601D+06/
      DATA I( 32)/ 2/,J( 32)/ 0/,K( 32)/ 3/
      DATA CF( 33)/-.32244161252385658183564313393601D+06/
      DATA I( 33)/ 0/,J( 33)/ 3/,K( 33)/ 2/
      DATA CF( 34)/-.32244161252385658183564313393601D+06/
      DATA I( 34)/ 0/,J( 34)/ 2/,K( 34)/ 3/
      DATA CF( 35)/0.16638981276114379345902558549099D+06/
      DATA I( 35)/ 4/,J( 35)/ 1/,K( 35)/ 0/
      DATA CF( 36)/0.16638981276114379345902558549099D+06/
      DATA I( 36)/ 4/,J( 36)/ 0/,K( 36)/ 1/
      DATA CF( 37)/0.16638981276114379345902558549099D+06/
      DATA I( 37)/ 1/,J( 37)/ 4/,K( 37)/ 0/
      DATA CF( 38)/0.16638981276114379345902558549099D+06/
      DATA I( 38)/ 1/,J( 38)/ 0/,K( 38)/ 4/
      DATA CF( 39)/0.16638981276114379345902558549099D+06/
      DATA I( 39)/ 0/,J( 39)/ 4/,K( 39)/ 1/
      DATA CF( 40)/0.16638981276114379345902558549099D+06/
      DATA I( 40)/ 0/,J( 40)/ 1/,K( 40)/ 4/
      DATA CF( 41)/-.18275583282955472835338697193381D+07/
      DATA I( 41)/ 2/,J( 41)/ 2/,K( 41)/ 2/
      DATA CF( 42)/0.22577527928431135607417186454584D+06/
      DATA I( 42)/ 3/,J( 42)/ 2/,K( 42)/ 1/
      DATA CF( 43)/0.22577527928431135607417186454584D+06/
      DATA I( 43)/ 3/,J( 43)/ 1/,K( 43)/ 2/
      DATA CF( 44)/0.22577527928431135607417186454584D+06/
      DATA I( 44)/ 2/,J( 44)/ 3/,K( 44)/ 1/
      DATA CF( 45)/0.22577527928431135607417186454584D+06/
      DATA I( 45)/ 2/,J( 45)/ 1/,K( 45)/ 3/
      DATA CF( 46)/0.22577527928431135607417186454584D+06/
      DATA I( 46)/ 1/,J( 46)/ 3/,K( 46)/ 2/
      DATA CF( 47)/0.22577527928431135607417186454584D+06/
      DATA I( 47)/ 1/,J( 47)/ 2/,K( 47)/ 3/
      DATA CF( 48)/0.42430787275525929611877574977588D+07/
      DATA I( 48)/ 3/,J( 48)/ 3/,K( 48)/ 0/
      DATA CF( 49)/0.42430787275525929611877574977588D+07/
      DATA I( 49)/ 3/,J( 49)/ 0/,K( 49)/ 3/
      DATA CF( 50)/0.42430787275525929611877574977588D+07/
      DATA I( 50)/ 0/,J( 50)/ 3/,K( 50)/ 3/
      DATA CF( 51)/-.17308426003233516635773058143115D+06/
      DATA I( 51)/ 4/,J( 51)/ 1/,K( 51)/ 1/
      DATA CF( 52)/-.17308426003233516635773058143115D+06/
      DATA I( 52)/ 1/,J( 52)/ 4/,K( 52)/ 1/
      DATA CF( 53)/-.17308426003233516635773058143115D+06/
      DATA I( 53)/ 1/,J( 53)/ 1/,K( 53)/ 4/
      DATA CF( 54)/0.11853380424658765637051580449061D+06/
      DATA I( 54)/ 4/,J( 54)/ 2/,K( 54)/ 0/
      DATA CF( 55)/0.11853380424658765637051580449061D+06/
      DATA I( 55)/ 4/,J( 55)/ 0/,K( 55)/ 2/
      DATA CF( 56)/0.11853380424658765637051580449061D+06/
      DATA I( 56)/ 2/,J( 56)/ 4/,K( 56)/ 0/
      DATA CF( 57)/0.11853380424658765637051580449061D+06/
      DATA I( 57)/ 2/,J( 57)/ 0/,K( 57)/ 4/
      DATA CF( 58)/0.11853380424658765637051580449061D+06/
      DATA I( 58)/ 0/,J( 58)/ 4/,K( 58)/ 2/
      DATA CF( 59)/0.11853380424658765637051580449061D+06/
      DATA I( 59)/ 0/,J( 59)/ 2/,K( 59)/ 4/
      DATA CF( 60)/-.13955282994984728343930999882205D+07/
      DATA I( 60)/ 5/,J( 60)/ 1/,K( 60)/ 0/
      DATA CF( 61)/-.13955282994984728343930999882205D+07/
      DATA I( 61)/ 5/,J( 61)/ 0/,K( 61)/ 1/
      DATA CF( 62)/-.13955282994984728343930999882205D+07/
      DATA I( 62)/ 1/,J( 62)/ 5/,K( 62)/ 0/
      DATA CF( 63)/-.13955282994984728343930999882205D+07/
      DATA I( 63)/ 1/,J( 63)/ 0/,K( 63)/ 5/
      DATA CF( 64)/-.13955282994984728343930999882205D+07/
      DATA I( 64)/ 0/,J( 64)/ 5/,K( 64)/ 1/
      DATA CF( 65)/-.13955282994984728343930999882205D+07/
      DATA I( 65)/ 0/,J( 65)/ 1/,K( 65)/ 5/
      DATA CF( 66)/0.66831738526311829275950686960029D+07/
      DATA I( 66)/ 3/,J( 66)/ 2/,K( 66)/ 2/
      DATA CF( 67)/0.66831738526311829275950686960029D+07/
      DATA I( 67)/ 2/,J( 67)/ 3/,K( 67)/ 2/
      DATA CF( 68)/0.66831738526311829275950686960029D+07/
      DATA I( 68)/ 2/,J( 68)/ 2/,K( 68)/ 3/
      DATA CF( 69)/0.82618337052469415206828250824097D+07/
      DATA I( 69)/ 3/,J( 69)/ 3/,K( 69)/ 1/
      DATA CF( 70)/0.82618337052469415206828250824097D+07/
      DATA I( 70)/ 3/,J( 70)/ 1/,K( 70)/ 3/
      DATA CF( 71)/0.82618337052469415206828250824097D+07/
      DATA I( 71)/ 1/,J( 71)/ 3/,K( 71)/ 3/
      DATA CF( 72)/-.10889797203903453669136800116063D+08/
      DATA I( 72)/ 4/,J( 72)/ 2/,K( 72)/ 1/
      DATA CF( 73)/-.10889797203903453669136800116063D+08/
      DATA I( 73)/ 4/,J( 73)/ 1/,K( 73)/ 2/
      DATA CF( 74)/-.10889797203903453669136800116063D+08/
      DATA I( 74)/ 2/,J( 74)/ 4/,K( 74)/ 1/
      DATA CF( 75)/-.10889797203903453669136800116063D+08/
      DATA I( 75)/ 2/,J( 75)/ 1/,K( 75)/ 4/
      DATA CF( 76)/-.10889797203903453669136800116063D+08/
      DATA I( 76)/ 1/,J( 76)/ 4/,K( 76)/ 2/
      DATA CF( 77)/-.10889797203903453669136800116063D+08/
      DATA I( 77)/ 1/,J( 77)/ 2/,K( 77)/ 4/
      DATA CF( 78)/-.16044675080816785129759014617011D+08/
      DATA I( 78)/ 4/,J( 78)/ 3/,K( 78)/ 0/
      DATA CF( 79)/-.16044675080816785129759014617011D+08/
      DATA I( 79)/ 4/,J( 79)/ 0/,K( 79)/ 3/
      DATA CF( 80)/-.16044675080816785129759014617011D+08/
      DATA I( 80)/ 3/,J( 80)/ 4/,K( 80)/ 0/
      DATA CF( 81)/-.16044675080816785129759014617011D+08/
      DATA I( 81)/ 3/,J( 81)/ 0/,K( 81)/ 4/
      DATA CF( 82)/-.16044675080816785129759014617011D+08/
      DATA I( 82)/ 0/,J( 82)/ 4/,K( 82)/ 3/
      DATA CF( 83)/-.16044675080816785129759014617011D+08/
      DATA I( 83)/ 0/,J( 83)/ 3/,K( 83)/ 4/
      DATA CF( 84)/0.97381282202000264281398126725484D+07/
      DATA I( 84)/ 5/,J( 84)/ 1/,K( 84)/ 1/
      DATA CF( 85)/0.97381282202000264281398126725484D+07/
      DATA I( 85)/ 1/,J( 85)/ 5/,K( 85)/ 1/
      DATA CF( 86)/0.97381282202000264281398126725484D+07/
      DATA I( 86)/ 1/,J( 86)/ 1/,K( 86)/ 5/
      DATA CF( 87)/0.83354813602737303963018495747252D+07/
      DATA I( 87)/ 5/,J( 87)/ 2/,K( 87)/ 0/
      DATA CF( 88)/0.83354813602737303963018495747252D+07/
      DATA I( 88)/ 5/,J( 88)/ 0/,K( 88)/ 2/
      DATA CF( 89)/0.83354813602737303963018495747252D+07/
      DATA I( 89)/ 2/,J( 89)/ 5/,K( 89)/ 0/
      DATA CF( 90)/0.83354813602737303963018495747252D+07/
      DATA I( 90)/ 2/,J( 90)/ 0/,K( 90)/ 5/
      DATA CF( 91)/0.83354813602737303963018495747252D+07/
      DATA I( 91)/ 0/,J( 91)/ 5/,K( 91)/ 2/
      DATA CF( 92)/0.83354813602737303963018495747252D+07/
      DATA I( 92)/ 0/,J( 92)/ 2/,K( 92)/ 5/
      DATA CF( 93)/0.51696092889138482840847796304877D+07/
      DATA I( 93)/ 6/,J( 93)/ 1/,K( 93)/ 0/
      DATA CF( 94)/0.51696092889138482840847796304877D+07/
      DATA I( 94)/ 6/,J( 94)/ 0/,K( 94)/ 1/
      DATA CF( 95)/0.51696092889138482840847796304877D+07/
      DATA I( 95)/ 1/,J( 95)/ 6/,K( 95)/ 0/
      DATA CF( 96)/0.51696092889138482840847796304877D+07/
      DATA I( 96)/ 1/,J( 96)/ 0/,K( 96)/ 6/
      DATA CF( 97)/0.51696092889138482840847796304877D+07/
      DATA I( 97)/ 0/,J( 97)/ 6/,K( 97)/ 1/
      DATA CF( 98)/0.51696092889138482840847796304877D+07/
      DATA I( 98)/ 0/,J( 98)/ 1/,K( 98)/ 6/
      DATA CF( 99)/-.12089791161679081296844751626625D+08/
      DATA I( 99)/ 3/,J( 99)/ 3/,K( 99)/ 2/
      DATA CF(100)/-.12089791161679081296844751626625D+08/
      DATA I(100)/ 3/,J(100)/ 2/,K(100)/ 3/
      DATA CF(101)/-.12089791161679081296844751626625D+08/
      DATA I(101)/ 2/,J(101)/ 3/,K(101)/ 3/
      DATA CF(102)/-.34277179678489953105723695986384D+08/
      DATA I(102)/ 4/,J(102)/ 2/,K(102)/ 2/
      DATA CF(103)/-.34277179678489953105723695986384D+08/
      DATA I(103)/ 2/,J(103)/ 4/,K(103)/ 2/
      DATA CF(104)/-.34277179678489953105723695986384D+08/
      DATA I(104)/ 2/,J(104)/ 2/,K(104)/ 4/
      DATA CF(105)/0.18124750509777669648480875116219D+07/
      DATA I(105)/ 4/,J(105)/ 3/,K(105)/ 1/
      DATA CF(106)/0.18124750509777669648480875116219D+07/
      DATA I(106)/ 4/,J(106)/ 1/,K(106)/ 3/
      DATA CF(107)/0.18124750509777669648480875116219D+07/
      DATA I(107)/ 3/,J(107)/ 4/,K(107)/ 1/
      DATA CF(108)/0.18124750509777669648480875116219D+07/
      DATA I(108)/ 3/,J(108)/ 1/,K(108)/ 4/
      DATA CF(109)/0.18124750509777669648480875116219D+07/
      DATA I(109)/ 1/,J(109)/ 4/,K(109)/ 3/
      DATA CF(110)/0.18124750509777669648480875116219D+07/
      DATA I(110)/ 1/,J(110)/ 3/,K(110)/ 4/
      DATA CF(111)/0.93546077189901274708008117502405D+08/
      DATA I(111)/ 4/,J(111)/ 4/,K(111)/ 0/
      DATA CF(112)/0.93546077189901274708008117502405D+08/
      DATA I(112)/ 4/,J(112)/ 0/,K(112)/ 4/
      DATA CF(113)/0.93546077189901274708008117502405D+08/
      DATA I(113)/ 0/,J(113)/ 4/,K(113)/ 4/
      DATA CF(114)/0.44601269467415885408316085451830D+08/
      DATA I(114)/ 5/,J(114)/ 2/,K(114)/ 1/
      DATA CF(115)/0.44601269467415885408316085451830D+08/
      DATA I(115)/ 5/,J(115)/ 1/,K(115)/ 2/
      DATA CF(116)/0.44601269467415885408316085451830D+08/
      DATA I(116)/ 2/,J(116)/ 5/,K(116)/ 1/
      DATA CF(117)/0.44601269467415885408316085451830D+08/
      DATA I(117)/ 2/,J(117)/ 1/,K(117)/ 5/
      DATA CF(118)/0.44601269467415885408316085451830D+08/
      DATA I(118)/ 1/,J(118)/ 5/,K(118)/ 2/
      DATA CF(119)/0.44601269467415885408316085451830D+08/
      DATA I(119)/ 1/,J(119)/ 2/,K(119)/ 5/
      DATA CF(120)/-.60474783813292919997975070953238D+07/
      DATA I(120)/ 5/,J(120)/ 3/,K(120)/ 0/
      DATA CF(121)/-.60474783813292919997975070953238D+07/
      DATA I(121)/ 5/,J(121)/ 0/,K(121)/ 3/
      DATA CF(122)/-.60474783813292919997975070953238D+07/
      DATA I(122)/ 3/,J(122)/ 5/,K(122)/ 0/
      DATA CF(123)/-.60474783813292919997975070953238D+07/
      DATA I(123)/ 3/,J(123)/ 0/,K(123)/ 5/
      DATA CF(124)/-.60474783813292919997975070953238D+07/
      DATA I(124)/ 0/,J(124)/ 5/,K(124)/ 3/
      DATA CF(125)/-.60474783813292919997975070953238D+07/
      DATA I(125)/ 0/,J(125)/ 3/,K(125)/ 5/
      DATA CF(126)/-.54800880590393407195840566720437D+08/
      DATA I(126)/ 6/,J(126)/ 1/,K(126)/ 1/
      DATA CF(127)/-.54800880590393407195840566720437D+08/
      DATA I(127)/ 1/,J(127)/ 6/,K(127)/ 1/
      DATA CF(128)/-.54800880590393407195840566720437D+08/
      DATA I(128)/ 1/,J(128)/ 1/,K(128)/ 6/
      DATA CF(129)/-.30302451152312220633392024923968D+08/
      DATA I(129)/ 6/,J(129)/ 2/,K(129)/ 0/
      DATA CF(130)/-.30302451152312220633392024923968D+08/
      DATA I(130)/ 6/,J(130)/ 0/,K(130)/ 2/
      DATA CF(131)/-.30302451152312220633392024923968D+08/
      DATA I(131)/ 2/,J(131)/ 6/,K(131)/ 0/
      DATA CF(132)/-.30302451152312220633392024923968D+08/
      DATA I(132)/ 2/,J(132)/ 0/,K(132)/ 6/
      DATA CF(133)/-.30302451152312220633392024923968D+08/
      DATA I(133)/ 0/,J(133)/ 6/,K(133)/ 2/
      DATA CF(134)/-.30302451152312220633392024923968D+08/
      DATA I(134)/ 0/,J(134)/ 2/,K(134)/ 6/
      DATA CF(135)/-.99804335855223918231147803420228D+07/
      DATA I(135)/ 7/,J(135)/ 1/,K(135)/ 0/
      DATA CF(136)/-.99804335855223918231147803420228D+07/
      DATA I(136)/ 7/,J(136)/ 0/,K(136)/ 1/
      DATA CF(137)/-.99804335855223918231147803420228D+07/
      DATA I(137)/ 1/,J(137)/ 7/,K(137)/ 0/
      DATA CF(138)/-.99804335855223918231147803420228D+07/
      DATA I(138)/ 1/,J(138)/ 0/,K(138)/ 7/
      DATA CF(139)/-.99804335855223918231147803420228D+07/
      DATA I(139)/ 0/,J(139)/ 7/,K(139)/ 1/
      DATA CF(140)/-.99804335855223918231147803420228D+07/
      DATA I(140)/ 0/,J(140)/ 1/,K(140)/ 7/
      DATA CF(141)/-.68989622747009937444330833521638D+09/
      DATA I(141)/ 3/,J(141)/ 3/,K(141)/ 3/
      DATA CF(142)/0.26983661411798900432655232590127D+09/
      DATA I(142)/ 4/,J(142)/ 3/,K(142)/ 2/
      DATA CF(143)/0.26983661411798900432655232590127D+09/
      DATA I(143)/ 4/,J(143)/ 2/,K(143)/ 3/
      DATA CF(144)/0.26983661411798900432655232590127D+09/
      DATA I(144)/ 3/,J(144)/ 4/,K(144)/ 2/
      DATA CF(145)/0.26983661411798900432655232590127D+09/
      DATA I(145)/ 3/,J(145)/ 2/,K(145)/ 4/
      DATA CF(146)/0.26983661411798900432655232590127D+09/
      DATA I(146)/ 2/,J(146)/ 4/,K(146)/ 3/
      DATA CF(147)/0.26983661411798900432655232590127D+09/
      DATA I(147)/ 2/,J(147)/ 3/,K(147)/ 4/
      DATA CF(148)/0.20461083118711064454973257023781D+09/
      DATA I(148)/ 4/,J(148)/ 4/,K(148)/ 1/
      DATA CF(149)/0.20461083118711064454973257023781D+09/
      DATA I(149)/ 4/,J(149)/ 1/,K(149)/ 4/
      DATA CF(150)/0.20461083118711064454973257023781D+09/
      DATA I(150)/ 1/,J(150)/ 4/,K(150)/ 4/
      DATA CF(151)/-.14959485520150104986723525653244D+09/
      DATA I(151)/ 5/,J(151)/ 2/,K(151)/ 2/
      DATA CF(152)/-.14959485520150104986723525653244D+09/
      DATA I(152)/ 2/,J(152)/ 5/,K(152)/ 2/
      DATA CF(153)/-.14959485520150104986723525653244D+09/
      DATA I(153)/ 2/,J(153)/ 2/,K(153)/ 5/
      DATA CF(154)/-.29707605961164184566068388980506D+09/
      DATA I(154)/ 5/,J(154)/ 3/,K(154)/ 1/
      DATA CF(155)/-.29707605961164184566068388980506D+09/
      DATA I(155)/ 5/,J(155)/ 1/,K(155)/ 3/
      DATA CF(156)/-.29707605961164184566068388980506D+09/
      DATA I(156)/ 3/,J(156)/ 5/,K(156)/ 1/
      DATA CF(157)/-.29707605961164184566068388980506D+09/
      DATA I(157)/ 3/,J(157)/ 1/,K(157)/ 5/
      DATA CF(158)/-.29707605961164184566068388980506D+09/
      DATA I(158)/ 1/,J(158)/ 5/,K(158)/ 3/
      DATA CF(159)/-.29707605961164184566068388980506D+09/
      DATA I(159)/ 1/,J(159)/ 3/,K(159)/ 5/
      DATA CF(160)/-.12846799480484985538414296849355D+09/
      DATA I(160)/ 5/,J(160)/ 4/,K(160)/ 0/
      DATA CF(161)/-.12846799480484985538414296849355D+09/
      DATA I(161)/ 5/,J(161)/ 0/,K(161)/ 4/
      DATA CF(162)/-.12846799480484985538414296849355D+09/
      DATA I(162)/ 4/,J(162)/ 5/,K(162)/ 0/
      DATA CF(163)/-.12846799480484985538414296849355D+09/
      DATA I(163)/ 4/,J(163)/ 0/,K(163)/ 5/
      DATA CF(164)/-.12846799480484985538414296849355D+09/
      DATA I(164)/ 0/,J(164)/ 5/,K(164)/ 4/
      DATA CF(165)/-.12846799480484985538414296849355D+09/
      DATA I(165)/ 0/,J(165)/ 4/,K(165)/ 5/
      DATA CF(166)/0.77013504493465179596463978220899D+08/
      DATA I(166)/ 6/,J(166)/ 2/,K(166)/ 1/
      DATA CF(167)/0.77013504493465179596463978220899D+08/
      DATA I(167)/ 6/,J(167)/ 1/,K(167)/ 2/
      DATA CF(168)/0.77013504493465179596463978220899D+08/
      DATA I(168)/ 2/,J(168)/ 6/,K(168)/ 1/
      DATA CF(169)/0.77013504493465179596463978220899D+08/
      DATA I(169)/ 2/,J(169)/ 1/,K(169)/ 6/
      DATA CF(170)/0.77013504493465179596463978220899D+08/
      DATA I(170)/ 1/,J(170)/ 6/,K(170)/ 2/
      DATA CF(171)/0.77013504493465179596463978220899D+08/
      DATA I(171)/ 1/,J(171)/ 2/,K(171)/ 6/
      DATA CF(172)/0.11397880302289757627557238789847D+09/
      DATA I(172)/ 6/,J(172)/ 3/,K(172)/ 0/
      DATA CF(173)/0.11397880302289757627557238789847D+09/
      DATA I(173)/ 6/,J(173)/ 0/,K(173)/ 3/
      DATA CF(174)/0.11397880302289757627557238789847D+09/
      DATA I(174)/ 3/,J(174)/ 6/,K(174)/ 0/
      DATA CF(175)/0.11397880302289757627557238789847D+09/
      DATA I(175)/ 3/,J(175)/ 0/,K(175)/ 6/
      DATA CF(176)/0.11397880302289757627557238789847D+09/
      DATA I(176)/ 0/,J(176)/ 6/,K(176)/ 3/
      DATA CF(177)/0.11397880302289757627557238789847D+09/
      DATA I(177)/ 0/,J(177)/ 3/,K(177)/ 6/
      DATA CF(178)/0.71355568287149051159168799206364D+08/
      DATA I(178)/ 7/,J(178)/ 1/,K(178)/ 1/
      DATA CF(179)/0.71355568287149051159168799206364D+08/
      DATA I(179)/ 1/,J(179)/ 7/,K(179)/ 1/
      DATA CF(180)/0.71355568287149051159168799206364D+08/
      DATA I(180)/ 1/,J(180)/ 1/,K(180)/ 7/
      DATA CF(181)/0.21556013673270958520994702317476D+08/
      DATA I(181)/ 7/,J(181)/ 2/,K(181)/ 0/
      DATA CF(182)/0.21556013673270958520994702317476D+08/
      DATA I(182)/ 7/,J(182)/ 0/,K(182)/ 2/
      DATA CF(183)/0.21556013673270958520994702317476D+08/
      DATA I(183)/ 2/,J(183)/ 7/,K(183)/ 0/
      DATA CF(184)/0.21556013673270958520994702317476D+08/
      DATA I(184)/ 2/,J(184)/ 0/,K(184)/ 7/
      DATA CF(185)/0.21556013673270958520994702317476D+08/
      DATA I(185)/ 0/,J(185)/ 7/,K(185)/ 2/
      DATA CF(186)/0.21556013673270958520994702317476D+08/
      DATA I(186)/ 0/,J(186)/ 2/,K(186)/ 7/
      DATA CF(187)/0.13607289564610890563800042037746D+08/
      DATA I(187)/ 8/,J(187)/ 1/,K(187)/ 0/
      DATA CF(188)/0.13607289564610890563800042037746D+08/
      DATA I(188)/ 8/,J(188)/ 0/,K(188)/ 1/
      DATA CF(189)/0.13607289564610890563800042037746D+08/
      DATA I(189)/ 1/,J(189)/ 8/,K(189)/ 0/
      DATA CF(190)/0.13607289564610890563800042037746D+08/
      DATA I(190)/ 1/,J(190)/ 0/,K(190)/ 8/
      DATA CF(191)/0.13607289564610890563800042037746D+08/
      DATA I(191)/ 0/,J(191)/ 8/,K(191)/ 1/
      DATA CF(192)/0.13607289564610890563800042037746D+08/
      DATA I(192)/ 0/,J(192)/ 1/,K(192)/ 8/
      DATA CF(193)/0.18480926875801236945411236465530D+09/
      DATA I(193)/ 4/,J(193)/ 3/,K(193)/ 3/
      DATA CF(194)/0.18480926875801236945411236465530D+09/
      DATA I(194)/ 3/,J(194)/ 4/,K(194)/ 3/
      DATA CF(195)/0.18480926875801236945411236465530D+09/
      DATA I(195)/ 3/,J(195)/ 3/,K(195)/ 4/
      DATA CF(196)/0.10685496440960547917498461335742D+10/
      DATA I(196)/ 4/,J(196)/ 4/,K(196)/ 2/
      DATA CF(197)/0.10685496440960547917498461335742D+10/
      DATA I(197)/ 4/,J(197)/ 2/,K(197)/ 4/
      DATA CF(198)/0.10685496440960547917498461335742D+10/
      DATA I(198)/ 2/,J(198)/ 4/,K(198)/ 4/
      DATA CF(199)/-.11476903487280922936768485533273D+10/
      DATA I(199)/ 5/,J(199)/ 3/,K(199)/ 2/
      DATA CF(200)/-.11476903487280922936768485533273D+10/
      DATA I(200)/ 5/,J(200)/ 2/,K(200)/ 3/
      DATA CF(201)/-.11476903487280922936768485533273D+10/
      DATA I(201)/ 3/,J(201)/ 5/,K(201)/ 2/
      DATA CF(202)/-.11476903487280922936768485533273D+10/
      DATA I(202)/ 3/,J(202)/ 2/,K(202)/ 5/
      DATA CF(203)/-.11476903487280922936768485533273D+10/
      DATA I(203)/ 2/,J(203)/ 5/,K(203)/ 3/
      DATA CF(204)/-.11476903487280922936768485533273D+10/
      DATA I(204)/ 2/,J(204)/ 3/,K(204)/ 5/
      DATA CF(205)/-.18914976506653546584588998471850D+09/
      DATA I(205)/ 5/,J(205)/ 4/,K(205)/ 1/
      DATA CF(206)/-.18914976506653546584588998471850D+09/
      DATA I(206)/ 5/,J(206)/ 1/,K(206)/ 4/
      DATA CF(207)/-.18914976506653546584588998471850D+09/
      DATA I(207)/ 4/,J(207)/ 5/,K(207)/ 1/
      DATA CF(208)/-.18914976506653546584588998471850D+09/
      DATA I(208)/ 4/,J(208)/ 1/,K(208)/ 5/
      DATA CF(209)/-.18914976506653546584588998471850D+09/
      DATA I(209)/ 1/,J(209)/ 5/,K(209)/ 4/
      DATA CF(210)/-.18914976506653546584588998471850D+09/
      DATA I(210)/ 1/,J(210)/ 4/,K(210)/ 5/
      DATA CF(211)/0.30140516491928228254794882484466D+09/
      DATA I(211)/ 5/,J(211)/ 5/,K(211)/ 0/
      DATA CF(212)/0.30140516491928228254794882484466D+09/
      DATA I(212)/ 5/,J(212)/ 0/,K(212)/ 5/
      DATA CF(213)/0.30140516491928228254794882484466D+09/
      DATA I(213)/ 0/,J(213)/ 5/,K(213)/ 5/
      DATA CF(214)/0.10658937256491739087920736930265D+10/
      DATA I(214)/ 6/,J(214)/ 2/,K(214)/ 2/
      DATA CF(215)/0.10658937256491739087920736930265D+10/
      DATA I(215)/ 2/,J(215)/ 6/,K(215)/ 2/
      DATA CF(216)/0.10658937256491739087920736930265D+10/
      DATA I(216)/ 2/,J(216)/ 2/,K(216)/ 6/
      DATA CF(217)/0.59274731500842401069747819084949D+09/
      DATA I(217)/ 6/,J(217)/ 3/,K(217)/ 1/
      DATA CF(218)/0.59274731500842401069747819084949D+09/
      DATA I(218)/ 6/,J(218)/ 1/,K(218)/ 3/
      DATA CF(219)/0.59274731500842401069747819084949D+09/
      DATA I(219)/ 3/,J(219)/ 6/,K(219)/ 1/
      DATA CF(220)/0.59274731500842401069747819084949D+09/
      DATA I(220)/ 3/,J(220)/ 1/,K(220)/ 6/
      DATA CF(221)/0.59274731500842401069747819084949D+09/
      DATA I(221)/ 1/,J(221)/ 6/,K(221)/ 3/
      DATA CF(222)/0.59274731500842401069747819084949D+09/
      DATA I(222)/ 1/,J(222)/ 3/,K(222)/ 6/
      DATA CF(223)/-.96109347543722990850254379981841D+08/
      DATA I(223)/ 6/,J(223)/ 4/,K(223)/ 0/
      DATA CF(224)/-.96109347543722990850254379981841D+08/
      DATA I(224)/ 6/,J(224)/ 0/,K(224)/ 4/
      DATA CF(225)/-.96109347543722990850254379981841D+08/
      DATA I(225)/ 4/,J(225)/ 6/,K(225)/ 0/
      DATA CF(226)/-.96109347543722990850254379981841D+08/
      DATA I(226)/ 4/,J(226)/ 0/,K(226)/ 6/
      DATA CF(227)/-.96109347543722990850254379981841D+08/
      DATA I(227)/ 0/,J(227)/ 6/,K(227)/ 4/
      DATA CF(228)/-.96109347543722990850254379981841D+08/
      DATA I(228)/ 0/,J(228)/ 4/,K(228)/ 6/
      DATA CF(229)/-.44500952352221120886848909040612D+09/
      DATA I(229)/ 7/,J(229)/ 2/,K(229)/ 1/
      DATA CF(230)/-.44500952352221120886848909040612D+09/
      DATA I(230)/ 7/,J(230)/ 1/,K(230)/ 2/
      DATA CF(231)/-.44500952352221120886848909040612D+09/
      DATA I(231)/ 2/,J(231)/ 7/,K(231)/ 1/
      DATA CF(232)/-.44500952352221120886848909040612D+09/
      DATA I(232)/ 2/,J(232)/ 1/,K(232)/ 7/
      DATA CF(233)/-.44500952352221120886848909040612D+09/
      DATA I(233)/ 1/,J(233)/ 7/,K(233)/ 2/
      DATA CF(234)/-.44500952352221120886848909040612D+09/
      DATA I(234)/ 1/,J(234)/ 2/,K(234)/ 7/
      DATA CF(235)/-.90719673107177789357180325610804D+08/
      DATA I(235)/ 7/,J(235)/ 3/,K(235)/ 0/
      DATA CF(236)/-.90719673107177789357180325610804D+08/
      DATA I(236)/ 7/,J(236)/ 0/,K(236)/ 3/
      DATA CF(237)/-.90719673107177789357180325610804D+08/
      DATA I(237)/ 3/,J(237)/ 7/,K(237)/ 0/
      DATA CF(238)/-.90719673107177789357180325610804D+08/
      DATA I(238)/ 3/,J(238)/ 0/,K(238)/ 7/
      DATA CF(239)/-.90719673107177789357180325610804D+08/
      DATA I(239)/ 0/,J(239)/ 7/,K(239)/ 3/
      DATA CF(240)/-.90719673107177789357180325610804D+08/
      DATA I(240)/ 0/,J(240)/ 3/,K(240)/ 7/
      DATA CF(241)/0.70458587249490119777536781705511D+08/
      DATA I(241)/ 8/,J(241)/ 1/,K(241)/ 1/
      DATA CF(242)/0.70458587249490119777536781705511D+08/
      DATA I(242)/ 1/,J(242)/ 8/,K(242)/ 1/
      DATA CF(243)/0.70458587249490119777536781705511D+08/
      DATA I(243)/ 1/,J(243)/ 1/,K(243)/ 8/
      DATA CF(244)/0.22707879673964003022704697631800D+08/
      DATA I(244)/ 8/,J(244)/ 2/,K(244)/ 0/
      DATA CF(245)/0.22707879673964003022704697631800D+08/
      DATA I(245)/ 8/,J(245)/ 0/,K(245)/ 2/
      DATA CF(246)/0.22707879673964003022704697631800D+08/
      DATA I(246)/ 2/,J(246)/ 8/,K(246)/ 0/
      DATA CF(247)/0.22707879673964003022704697631800D+08/
      DATA I(247)/ 2/,J(247)/ 0/,K(247)/ 8/
      DATA CF(248)/0.22707879673964003022704697631800D+08/
      DATA I(248)/ 0/,J(248)/ 8/,K(248)/ 2/
      DATA CF(249)/0.22707879673964003022704697631800D+08/
      DATA I(249)/ 0/,J(249)/ 2/,K(249)/ 8/
      DATA CF(250)/-.15245756843678323587434583896179D+08/
      DATA I(250)/ 9/,J(250)/ 1/,K(250)/ 0/
      DATA CF(251)/-.15245756843678323587434583896179D+08/
      DATA I(251)/ 9/,J(251)/ 0/,K(251)/ 1/
      DATA CF(252)/-.15245756843678323587434583896179D+08/
      DATA I(252)/ 1/,J(252)/ 9/,K(252)/ 0/
      DATA CF(253)/-.15245756843678323587434583896179D+08/
      DATA I(253)/ 1/,J(253)/ 0/,K(253)/ 9/
      DATA CF(254)/-.15245756843678323587434583896179D+08/
      DATA I(254)/ 0/,J(254)/ 9/,K(254)/ 1/
      DATA CF(255)/-.15245756843678323587434583896179D+08/
      DATA I(255)/ 0/,J(255)/ 1/,K(255)/ 9/
      DATA XXX(0)/ 1.D0/,YYY(0)/ 1.D0/,ZZZ(0)/ 1.D0/
      DATA VEX/0.14339096D+01/
      X1 = DEXP(-VEX*X)
      Y1 = DEXP(-VEX*Y)
      Z1 = DEXP(-VEX*Z)
      XX = X*X1
      YY = Y*Y1
      ZZ = Z*Z1
      DO 1 L=1,9
         XXX(L) = XX*XXX(L-1)
         YYY(L) = YY*YYY(L-1)
         ZZZ(L) = ZZ*ZZZ(L-1)
    1 CONTINUE
      ENER = 0.D0
      DO 2 L=1,255
         ENER=ENER+CF(L)*XXX(I(L))*YYY(J(L))*ZZZ(K(L))
    2 CONTINUE
      RETURN
      END
      FUNCTION FUN1(JJ)
      IMPLICIT  REAL * 8 (A-H,O-Z)
      PARAMETER (NEXP=865,IGRAD=12)
      COMMON /IPAINF/ IPA(NEXP,7)
      COMMON /XYZ/ X13(0:IGRAD-2), X23(0:IGRAD-2), X33(0:IGRAD-2),
     ,             X43(0:IGRAD-2), X53(0:IGRAD-2), X63(0:IGRAD-2)
      I = IPA(JJ,1)
      FUN1 = X13(I)*X23(I)*X33(I)*X43(I)*X53(I)*X63(I)
      RETURN
      ENTRY FUN2(JJ)
      J = IPA(JJ,1)
      I = IPA(JJ,2)
      IF(J.EQ.0) THEN
      FUN2 = X23(I)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(I)
      ELSE
      FUN2 = X13(J)*X23(I)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(I)*X63(J)
      ENDIF
      RETURN
      ENTRY FUN3(JJ)
      J = IPA(JJ,1)
      I = IPA(JJ,3)
      IF(J.EQ.0) THEN
      FUN3 = X33(I)*X43(I)*X53(I)*X63(I) + X23(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X43(I)*X53(I)*X63(I) + X23(I)*X33(I)*X53(I)*X63(I) +
     +       X13(I)*X33(I)*X53(I)*X63(I) + X23(I)*X33(I)*X43(I)*X63(I) +
     +       X13(I)*X23(I)*X43(I)*X63(I) + X13(I)*X23(I)*X33(I)*X63(I) +
     +       X13(I)*X33(I)*X43(I)*X53(I) + X13(I)*X23(I)*X43(I)*X53(I) +
     +       X13(I)*X23(I)*X33(I)*X53(I) + X13(I)*X23(I)*X33(I)*X43(I)
      ELSE
      FUN3 = X13(J)*X23(J)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(J)*X63(J)
      ENDIF
      RETURN
      ENTRY FUN4(JJ)
      I = IPA(JJ,1)
      J = IPA(JJ,3)
      IF(J.EQ.0) THEN
      FUN4 = X13(I)*X23(I)*X53(I)*X63(I) + X13(I)*X33(I)*X43(I)*X63(I) +
     +       X23(I)*X33(I)*X43(I)*X53(I)
      ELSE
      FUN4 = X13(I)*X23(I)*X33(J)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(I)*X53(I)*X63(J)
      ENDIF
      RETURN
      ENTRY FUN5(JJ)
      J = IPA(JJ,1)
      I = IPA(JJ,4)
      FUN5 = X13(J)*X23(J)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(J)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(J)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(J)*X63(J)
      RETURN
      ENTRY FUN6(JJ)
      J = IPA(JJ,1)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN6 = X13(J)*X33(J)*X43(J) + X23(J)*X33(J)*X43(J) +
     +       X13(J)*X23(J)*X53(J) + X23(J)*X33(J)*X53(J) +
     +       X23(J)*X43(J)*X53(J) + X33(J)*X43(J)*X53(J) +
     +       X13(J)*X23(J)*X63(J) + X13(J)*X33(J)*X63(J) +
     +       X13(J)*X43(J)*X63(J) + X33(J)*X43(J)*X63(J) +
     +       X13(J)*X53(J)*X63(J) + X23(J)*X53(J)*X63(J)
      ELSE
      FUN6 = X13(J)*X23(I)*X33(J)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(J)*X43(J)*X53(I)*X63(I) +
     +       X13(J)*X23(J)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(J)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(J)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(J)*X43(J)*X53(J)*X63(I) +
     +       X13(J)*X23(J)*X33(I)*X43(I)*X53(I)*X63(J) +
     +       X13(J)*X23(I)*X33(J)*X43(I)*X53(I)*X63(J) +
     +       X13(J)*X23(I)*X33(I)*X43(J)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(J)*X43(J)*X53(I)*X63(J) +
     +       X13(J)*X23(I)*X33(I)*X43(I)*X53(J)*X63(J) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(J)*X63(J)
      ENDIF
      RETURN
      ENTRY FUN7(JJ)
      J = IPA(JJ,1)
      I = IPA(JJ,3)
      IF(I.EQ.0) THEN
      FUN7 = X13(J)*X23(J)*X43(J) + X13(J)*X33(J)*X53(J) +
     +       X23(J)*X33(J)*X63(J) + X43(J)*X53(J)*X63(J)
      ELSE
      FUN7 = X13(J)*X23(J)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(J)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(J)*X43(I)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(J)*X63(J)
      ENDIF
      RETURN
      ENTRY FUN8(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,3)
      IF(J.EQ.0) THEN
      FUN8 = X13(K)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X23(K)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X43(I)*X53(I)*X63(I) +
     +       X23(I)*X33(K)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X33(K)*X43(I)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X53(I)*X63(I) +
     +       X23(I)*X33(I)*X43(K)*X53(I)*X63(I) +
     +       X13(I)*X33(I)*X43(K)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X43(I)*X63(I) +
     +       X13(I)*X23(I)*X33(K)*X43(I)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(K)*X63(I) +
     +       X23(I)*X33(I)*X43(I)*X53(K)*X63(I) +
     +       X13(I)*X23(I)*X43(I)*X53(K)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X53(K)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X43(I)*X53(I) +
     +       X13(I)*X23(I)*X33(K)*X43(I)*X53(I) +
     +       X13(I)*X23(I)*X33(I)*X43(K)*X53(I) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(K) +
     +       X13(I)*X33(I)*X43(I)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X43(I)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X33(I)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X63(K)
      ELSE
      FUN8 = X13(K)*X23(J)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(J)*X23(K)*X33(I)*X43(I)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X33(J)*X43(I)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(K)*X43(I)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(K)*X43(I)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X43(J)*X53(I)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(K)*X53(I)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(K)*X53(I)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(K)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(K)*X53(J)*X63(I) +
     +       X13(J)*X23(I)*X33(I)*X43(I)*X53(K)*X63(I) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(K)*X63(I) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(K)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X43(I)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(K)*X43(I)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(I)*X43(K)*X53(I)*X63(J) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(K)*X63(J) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X33(J)*X43(I)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X33(I)*X43(J)*X53(I)*X63(K) +
     +       X13(I)*X23(I)*X33(I)*X43(I)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN9(JJ)
      I = IPA(JJ,1)
      K = IPA(JJ,3)
      J = IPA(JJ,4)
      IF(J.EQ.0) THEN
      FUN9 = X13(I)*X23(I)*X33(K)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X43(K)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X43(I)*X63(I) +
     +       X13(I)*X33(I)*X43(I)*X53(K)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X43(I)*X53(I) +
     +       X23(I)*X33(I)*X43(I)*X53(I)*X63(K)
      ELSE
      FUN9 = X13(I)*X23(I)*X33(K)*X43(J)*X53(I)*X63(I) +
     +       X13(I)*X23(I)*X33(J)*X43(K)*X53(I)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X43(I)*X53(J)*X63(I) +
     +       X13(I)*X23(J)*X33(I)*X43(I)*X53(K)*X63(I) +
     +       X13(K)*X23(I)*X33(I)*X43(I)*X53(I)*X63(J) +
     +       X13(J)*X23(I)*X33(I)*X43(I)*X53(I)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN10(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,4)
      IF(J.EQ.0) THEN
      FUN10= X13(K)*X43(I)*X53(I)*X63(I) + X23(K)*X43(I)*X53(I)*X63(I) +
     +       X33(K)*X43(I)*X53(I)*X63(I) + X13(K)*X23(I)*X33(I)*X63(I) +
     +       X23(I)*X33(I)*X43(K)*X63(I) + X23(I)*X33(I)*X53(K)*X63(I) +
     +       X13(I)*X23(K)*X33(I)*X53(I) + X13(I)*X33(I)*X43(K)*X53(I) +
     +       X13(I)*X23(I)*X33(K)*X43(I) + X13(I)*X23(I)*X43(I)*X53(K) +
     +       X13(I)*X33(I)*X53(I)*X63(K) + X13(I)*X23(I)*X43(I)*X63(K)
      ELSE
      FUN10 = X13(K)*X23(J)*X33(J)*X43(I)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(J)*X43(I)*X53(I)*X63(I) +
     +        X13(J)*X23(J)*X33(K)*X43(I)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(I)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN11(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,3)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN11 = X13(K)*X33(J)*X43(J) + X23(K)*X33(J)*X43(J) +
     +        X13(K)*X23(J)*X53(J) + X23(J)*X33(K)*X53(J) +
     +        X23(J)*X43(K)*X53(J) + X33(J)*X43(J)*X53(K) +
     +        X13(J)*X23(K)*X63(J) + X13(J)*X33(K)*X63(J) +
     +        X13(J)*X43(K)*X63(J) + X13(J)*X53(K)*X63(J) +
     +        X33(J)*X43(J)*X63(K) + X23(J)*X53(J)*X63(K)
      ELSE
      FUN11 = X13(K)*X23(I)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(I)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN12(JJ)
      K = IPA(JJ,3)
      J = IPA(JJ,1)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN12 = X13(J)*X33(K)*X43(J) + X23(J)*X33(K)*X43(J) +
     +        X13(J)*X33(J)*X43(K) + X23(J)*X33(J)*X43(K) +
     +        X13(J)*X23(K)*X53(J) + X23(K)*X33(J)*X53(J) +
     +        X23(K)*X43(J)*X53(J) + X33(K)*X43(J)*X53(J) +
     +        X33(J)*X43(K)*X53(J) + X13(J)*X23(J)*X53(K) +
     +        X23(J)*X33(J)*X53(K) + X23(J)*X43(J)*X53(K) +
     +        X13(K)*X23(J)*X63(J) + X13(K)*X33(J)*X63(J) +
     +        X13(K)*X43(J)*X63(J) + X33(K)*X43(J)*X63(J) +
     +        X33(J)*X43(K)*X63(J) + X13(K)*X53(J)*X63(J) +
     +        X23(K)*X53(J)*X63(J) + X23(J)*X53(K)*X63(J) +
     +        X13(J)*X23(J)*X63(K) + X13(J)*X33(J)*X63(K) +
     +        X13(J)*X43(J)*X63(K) + X13(J)*X53(J)*X63(K)
      ELSE
      FUN12 = X13(J)*X23(I)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(J)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(I)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN13(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,3)
      IF(I.EQ.0) THEN
      FUN13 = X13(K)*X23(J)*X43(J) + X13(J)*X23(K)*X43(J) +
     +        X13(J)*X23(J)*X43(K) + X13(K)*X33(J)*X53(J) +
     +        X13(J)*X33(K)*X53(J) + X13(J)*X33(J)*X53(K) +
     +        X23(K)*X33(J)*X63(J) + X23(J)*X33(K)*X63(J) +
     +        X43(K)*X53(J)*X63(J) + X43(J)*X53(K)*X63(J) +
     +        X23(J)*X33(J)*X63(K) + X43(J)*X53(J)*X63(K)
      ELSE
      FUN13 = X13(K)*X23(J)*X33(I)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(K)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(I)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(I)*X33(I)*X43(J)*X53(K)*X63(J) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(I)*X43(J)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN14(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,3)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN14= X13(K)*X23(K)*X33(J)*X43(J) + X13(K)*X23(J)*X33(K)*X53(J) +
     +       X13(K)*X23(J)*X43(K)*X53(J) + X13(K)*X33(J)*X43(J)*X53(K) +
     +       X13(J)*X23(K)*X33(K)*X63(J) + X13(J)*X23(K)*X43(K)*X63(J) +
     +       X13(J)*X33(K)*X53(K)*X63(J) + X13(J)*X43(K)*X53(K)*X63(J) +
     +       X23(K)*X33(J)*X43(J)*X63(K) + X23(J)*X33(K)*X53(J)*X63(K) +
     +       X23(J)*X43(K)*X53(J)*X63(K) + X33(J)*X43(J)*X53(K)*X63(K)
      ELSE
      FUN14 = X13(K)*X23(K)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(J)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(K)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(K)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(J)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(K)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN15(JJ)
      K = IPA(JJ,3)
      J = IPA(JJ,1)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN15= X13(J)*X23(J)*X33(K)*X43(K) + X13(J)*X33(K)*X43(K)*X53(J) +
     +       X13(J)*X23(K)*X33(J)*X53(K) + X13(J)*X23(K)*X43(J)*X53(K) +
     +       X23(J)*X33(K)*X43(K)*X63(J) + X33(K)*X43(K)*X53(J)*X63(J) +
     +       X23(K)*X33(J)*X53(K)*X63(J) + X23(K)*X43(J)*X53(K)*X63(J) +
     +       X13(K)*X23(J)*X33(J)*X63(K) + X13(K)*X23(J)*X43(J)*X63(K) +
     +       X13(K)*X33(J)*X53(J)*X63(K) + X13(K)*X43(J)*X53(J)*X63(K)
      ELSE
      FUN15 = X13(J)*X23(J)*X33(K)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(K)*X53(J)*X63(I) +
     +        X13(J)*X23(K)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(K)*X63(J) +
     +        X13(K)*X23(J)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(K)*X23(J)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(J)*X63(K) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN16(JJ)
      K = IPA(JJ,2)
      J = IPA(JJ,4)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN16= X23(K)*X33(K)*X43(J)*X53(J) + X23(K)*X33(J)*X43(K)*X53(J) +
     +       X23(J)*X33(K)*X43(J)*X53(K) + X23(J)*X33(J)*X43(K)*X53(K) +
     +       X13(K)*X33(K)*X43(J)*X63(J) + X13(K)*X33(J)*X43(K)*X63(J) +
     +       X13(K)*X23(K)*X53(J)*X63(J) + X13(K)*X23(J)*X53(K)*X63(J) +
     +       X13(J)*X33(K)*X43(J)*X63(K) + X13(J)*X33(J)*X43(K)*X63(K) +
     +       X13(J)*X23(K)*X53(J)*X63(K) + X13(J)*X23(J)*X53(K)*X63(K)
      ELSE
      FUN16 = X13(I)*X23(K)*X33(K)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(K)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(K)*X43(J)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(K)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(J)*X23(I)*X33(K)*X43(J)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(J)*X43(K)*X53(I)*X63(K) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(K)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN17(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN17= X13(K)*X23(J)*X33(K)*X43(J) + X13(J)*X23(K)*X33(K)*X43(J) +
     +       X13(K)*X23(K)*X33(J)*X53(J) + X13(J)*X23(K)*X33(K)*X53(J) +
     +       X13(K)*X33(J)*X43(K)*X53(J) + X13(K)*X23(J)*X43(J)*X53(K) +
     +       X13(J)*X23(J)*X43(K)*X53(K) + X13(J)*X33(J)*X43(K)*X53(K) +
     +       X13(K)*X23(K)*X33(J)*X63(J) + X13(K)*X23(J)*X33(K)*X63(J) +
     +       X23(K)*X33(J)*X43(K)*X63(J) + X13(K)*X43(K)*X53(J)*X63(J) +
     +       X23(K)*X43(K)*X53(J)*X63(J) + X23(J)*X33(K)*X53(K)*X63(J) +
     +       X13(K)*X43(J)*X53(K)*X63(J) + X33(K)*X43(J)*X53(K)*X63(J) +
     +       X13(J)*X23(K)*X43(J)*X63(K) + X13(J)*X23(J)*X43(K)*X63(K) +
     +       X23(J)*X33(J)*X43(K)*X63(K) + X13(J)*X33(K)*X53(J)*X63(K) +
     +       X23(K)*X43(J)*X53(J)*X63(K) + X33(K)*X43(J)*X53(J)*X63(K) +
     +       X13(J)*X33(J)*X53(K)*X63(K) + X23(J)*X33(J)*X53(K)*X63(K)
      ELSE
      FUN17 = X13(K)*X23(J)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(K)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(K)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(K)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(K)*X53(K)*X63(I) +
     +        X13(K)*X23(K)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(J)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(J)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(K)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(K)*X63(J) +
     +        X13(J)*X23(K)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(J)*X23(J)*X33(I)*X43(K)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(J)*X43(K)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(J)*X63(K) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(K)*X63(K) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(K)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN18(JJ)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN18= X13(K)*X23(J)*X33(J)*X43(K) + X13(J)*X23(K)*X33(J)*X43(K) +
     +       X13(K)*X23(K)*X43(J)*X53(J) + X13(K)*X33(K)*X43(J)*X53(J) +
     +       X13(J)*X23(K)*X43(K)*X53(J) + X13(K)*X23(J)*X33(J)*X53(K) +
     +       X13(J)*X23(J)*X33(K)*X53(K) + X13(J)*X33(K)*X43(J)*X53(K) +
     +       X13(K)*X23(K)*X43(J)*X63(J) + X23(K)*X33(K)*X43(J)*X63(J) +
     +       X13(K)*X23(J)*X43(K)*X63(J) + X13(K)*X33(K)*X53(J)*X63(J) +
     +       X23(K)*X33(K)*X53(J)*X63(J) + X13(K)*X33(J)*X53(K)*X63(J) +
     +       X23(J)*X43(K)*X53(K)*X63(J) + X33(J)*X43(K)*X53(K)*X63(J) +
     +       X13(J)*X23(K)*X33(J)*X63(K) + X13(J)*X23(J)*X33(K)*X63(K) +
     +       X23(J)*X33(K)*X43(J)*X63(K) + X23(K)*X33(J)*X53(J)*X63(K) +
     +       X13(J)*X43(K)*X53(J)*X63(K) + X33(J)*X43(K)*X53(J)*X63(K) +
     +       X13(J)*X43(J)*X53(K)*X63(K) + X23(J)*X43(J)*X53(K)*X63(K)
      ELSE
      FUN18 = X13(K)*X23(J)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(K)*X23(K)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(K)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(J)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(J)*X33(K)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(J)*X53(K)*X63(I) +
     +        X13(K)*X23(K)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(K)*X43(J)*X53(I)*X63(J) +
     +        X13(K)*X23(J)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(K)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(K)*X43(I)*X53(J)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(K)*X63(J) +
     +        X13(J)*X23(K)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(J)*X33(K)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(K)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(J)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(J)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(K)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(K)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN19(JJ)
      K = IPA(JJ,3)
      J = IPA(JJ,2)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN19= X23(J)*X33(K)*X43(K)*X53(J) + X23(K)*X33(J)*X43(J)*X53(K) +
     +       X13(J)*X33(K)*X43(K)*X63(J) + X13(J)*X23(K)*X53(K)*X63(J) +
     +       X13(K)*X33(J)*X43(J)*X63(K) + X13(K)*X23(J)*X53(J)*X63(K)
      ELSE
      FUN19 = X13(I)*X23(J)*X33(K)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(K)*X53(I)*X63(J) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(J)*X53(I)*X63(K) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(J)*X63(K)
      ENDIF
      RETURN
      ENTRY FUN20(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,2)
      J = IPA(JJ,3)
      I = IPA(JJ,4)
      IF(J.EQ.0) THEN
      FUN20 = X13(L)*X23(K)*X43(I)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X43(I)*X53(I)*X63(I) +
     +        X13(L)*X33(K)*X43(I)*X53(I)*X63(I) +
     +        X23(L)*X33(K)*X43(I)*X53(I)*X63(I) +
     +        X13(K)*X33(L)*X43(I)*X53(I)*X63(I) +
     +        X23(K)*X33(L)*X43(I)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X63(I) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X63(I) +
     +        X13(L)*X23(I)*X33(I)*X53(K)*X63(I) +
     +        X23(I)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(I)*X53(L)*X63(I) +
     +        X23(I)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(I) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(I) +
     +        X13(I)*X23(I)*X33(L)*X43(I)*X53(K) +
     +        X13(I)*X23(I)*X33(K)*X43(I)*X53(L) +
     +        X13(I)*X23(L)*X33(I)*X53(I)*X63(K) +
     +        X13(I)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(I)*X63(K) +
     +        X13(I)*X23(I)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(K)*X33(I)*X53(I)*X63(L) +
     +        X13(I)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(I)*X63(L) +
     +        X13(I)*X23(I)*X43(I)*X53(K)*X63(L)
      ELSE
      FUN20 = X13(L)*X23(K)*X33(J)*X43(I)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(I)*X53(I)*X63(I) +
     +        X13(L)*X23(J)*X33(K)*X43(I)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(I)*X53(I)*X63(I) +
     +        X13(K)*X23(J)*X33(L)*X43(I)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(L)*X43(I)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN21(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,2)
      J = IPA(JJ,4)
      I = IPA(JJ,3)
      IF(I.EQ.0) THEN
      FUN21 = X13(L)*X23(K)*X43(J) + X13(K)*X23(L)*X43(J) +
     +        X13(L)*X23(J)*X43(K) + X13(J)*X23(L)*X43(K) +
     +        X13(K)*X23(J)*X43(L) + X13(J)*X23(K)*X43(L) +
     +        X13(L)*X33(K)*X53(J) + X13(K)*X33(L)*X53(J) +
     +        X13(L)*X33(J)*X53(K) + X13(J)*X33(L)*X53(K) +
     +        X13(K)*X33(J)*X53(L) + X13(J)*X33(K)*X53(L) +
     +        X23(L)*X33(K)*X63(J) + X23(K)*X33(L)*X63(J) +
     +        X43(L)*X53(K)*X63(J) + X43(K)*X53(L)*X63(J) +
     +        X23(L)*X33(J)*X63(K) + X23(J)*X33(L)*X63(K) +
     +        X43(L)*X53(J)*X63(K) + X43(J)*X53(L)*X63(K) +
     +        X23(K)*X33(J)*X63(L) + X23(J)*X33(K)*X63(L) +
     +        X43(K)*X53(J)*X63(L) + X43(J)*X53(K)*X63(L)
      ELSE IF(J.EQ.0) THEN
      FUN21 = X13(L)*X23(K)*X33(I)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X53(I)*X63(I) +
     +        X13(L)*X33(I)*X43(K)*X53(I)*X63(I) +
     +        X23(L)*X33(I)*X43(K)*X53(I)*X63(I) +
     +        X13(K)*X33(I)*X43(L)*X53(I)*X63(I) +
     +        X23(K)*X33(I)*X43(L)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X63(I) +
     +        X13(L)*X23(I)*X43(I)*X53(K)*X63(I) +
     +        X23(I)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X43(I)*X53(L)*X63(I) +
     +        X23(I)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(I) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(I) +
     +        X13(I)*X23(I)*X33(I)*X43(L)*X53(K) +
     +        X13(I)*X23(I)*X33(I)*X43(K)*X53(L) +
     +        X13(I)*X23(L)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(I)*X43(L)*X63(K) +
     +        X13(I)*X23(I)*X33(I)*X53(L)*X63(K) +
     +        X13(I)*X23(K)*X43(I)*X53(I)*X63(L) +
     +        X13(I)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(I)*X43(K)*X63(L) +
     +        X13(I)*X23(I)*X33(I)*X53(K)*X63(L)
      ELSE
      FUN21 = X13(L)*X23(K)*X33(I)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(K)*X53(I)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(L)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(I)*X43(L)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(I)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(I)*X43(L)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(I)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(I)*X43(K)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(I)*X43(J)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN22(JJ)
      L = IPA(JJ,3)
      K = IPA(JJ,1)
      J = IPA(JJ,4)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN22 = X13(K)*X33(L)*X43(J) + X23(K)*X33(L)*X43(J) +
     +        X13(K)*X33(J)*X43(L) + X23(K)*X33(J)*X43(L) +
     +        X13(K)*X23(L)*X53(J) + X23(L)*X33(K)*X53(J) +
     +        X23(L)*X43(K)*X53(J) + X33(L)*X43(J)*X53(K) +
     +        X33(J)*X43(L)*X53(K) + X13(K)*X23(J)*X53(L) +
     +        X23(J)*X33(K)*X53(L) + X23(J)*X43(K)*X53(L) +
     +        X13(L)*X23(K)*X63(J) + X13(L)*X33(K)*X63(J) +
     +        X13(L)*X43(K)*X63(J) + X13(L)*X53(K)*X63(J) +
     +        X33(L)*X43(J)*X63(K) + X33(J)*X43(L)*X63(K) +
     +        X23(L)*X53(J)*X63(K) + X23(J)*X53(L)*X63(K) +
     +        X13(J)*X23(K)*X63(L) + X13(J)*X33(K)*X63(L) +
     +        X13(J)*X43(K)*X63(L) + X13(J)*X53(K)*X63(L)
      ELSE IF(J.EQ.0) THEN
      FUN22 = X13(K)*X23(I)*X33(L)*X53(I)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X23(K)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X53(K)*X63(I) +
     +        X13(I)*X23(I)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X33(I)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(I) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(I) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(I) +
     +        X13(L)*X23(I)*X33(I)*X43(I)*X53(K) +
     +        X13(I)*X23(I)*X33(L)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(I)*X63(K) +
     +        X13(I)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X23(K)*X33(I)*X43(I)*X53(I)*X63(L) +
     +        X23(I)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X23(I)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X23(I)*X33(I)*X43(I)*X53(K)*X63(L)
      ELSE
      FUN22 = X13(K)*X23(I)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN23(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,3)
      J = IPA(JJ,4)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN23 = X13(L)*X33(K)*X43(J) + X23(L)*X33(K)*X43(J) +
     +        X13(L)*X33(J)*X43(K) + X23(L)*X33(J)*X43(K) +
     +        X13(L)*X23(K)*X53(J) + X23(K)*X33(L)*X53(J) +
     +        X23(K)*X43(L)*X53(J) + X13(L)*X23(J)*X53(K) +
     +        X23(J)*X33(L)*X53(K) + X23(J)*X43(L)*X53(K) +
     +        X33(K)*X43(J)*X53(L) + X33(J)*X43(K)*X53(L) +
     +        X13(K)*X23(L)*X63(J) + X13(K)*X33(L)*X63(J) +
     +        X13(K)*X43(L)*X63(J) + X13(K)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X63(K) + X13(J)*X33(L)*X63(K) +
     +        X13(J)*X43(L)*X63(K) + X13(J)*X53(L)*X63(K) +
     +        X33(K)*X43(J)*X63(L) + X33(J)*X43(K)*X63(L) +
     +        X23(K)*X53(J)*X63(L) + X23(J)*X53(K)*X63(L)
      ELSE IF(J.EQ.0) THEN
      FUN23 = X13(L)*X23(I)*X33(K)*X53(I)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X43(K)*X53(I)*X63(I) +
     +        X13(I)*X23(L)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X63(I) +
     +        X13(L)*X33(I)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X23(I)*X33(K)*X53(L)*X63(I) +
     +        X13(I)*X23(I)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(I) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(I) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(I) +
     +        X13(K)*X23(I)*X33(I)*X43(I)*X53(L) +
     +        X23(L)*X33(I)*X43(I)*X53(I)*X63(K) +
     +        X23(I)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X23(I)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X23(I)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X33(K)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(I)*X63(L) +
     +        X13(I)*X33(I)*X43(I)*X53(K)*X63(L)
      ELSE
      FUN23 = X13(L)*X23(I)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN24(JJ)
      L = IPA(JJ,3)
      K = IPA(JJ,4)
      J = IPA(JJ,1)
      I = IPA(JJ,2)
      IF(I.EQ.0) THEN
      FUN24 = X13(J)*X33(L)*X43(K) + X23(J)*X33(L)*X43(K) +
     +        X13(J)*X33(K)*X43(L) + X23(J)*X33(K)*X43(L) +
     +        X33(L)*X43(K)*X53(J) + X33(K)*X43(L)*X53(J) +
     +        X13(J)*X23(L)*X53(K) + X23(L)*X33(J)*X53(K) +
     +        X23(L)*X43(J)*X53(K) + X13(J)*X23(K)*X53(L) +
     +        X23(K)*X33(J)*X53(L) + X23(K)*X43(J)*X53(L) +
     +        X33(L)*X43(K)*X63(J) + X33(K)*X43(L)*X63(J) +
     +        X23(L)*X53(K)*X63(J) + X23(K)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X63(K) + X13(L)*X33(J)*X63(K) +
     +        X13(L)*X43(J)*X63(K) + X13(L)*X53(J)*X63(K) +
     +        X13(K)*X23(J)*X63(L) + X13(K)*X33(J)*X63(L) +
     +        X13(K)*X43(J)*X63(L) + X13(K)*X53(J)*X63(L)
      ELSE IF(J.EQ.0) THEN
      FUN24 = X23(I)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(I)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X23(I)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X63(I) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X63(I) +
     +        X23(L)*X33(I)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X53(K)*X63(I) +
     +        X23(K)*X33(I)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X53(L)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(I) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(I) +
     +        X13(I)*X23(L)*X33(I)*X43(I)*X53(K) +
     +        X13(I)*X23(K)*X33(I)*X43(I)*X53(L) +
     +        X13(L)*X33(I)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(I)*X63(K) +
     +        X13(K)*X33(I)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(I)*X63(L)
      ELSE
      FUN24 = X13(J)*X23(I)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(I)*X53(J)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN25(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,2)
      J = IPA(JJ,3)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN25= X13(L)*X23(K)*X33(J)*X43(J) + X13(K)*X23(L)*X33(J)*X43(J) +
     +       X13(L)*X23(J)*X33(K)*X53(J) + X13(K)*X23(J)*X33(L)*X53(J) +
     +       X13(L)*X23(J)*X43(K)*X53(J) + X13(K)*X23(J)*X43(L)*X53(J) +
     +       X13(L)*X33(J)*X43(J)*X53(K) + X13(K)*X33(J)*X43(J)*X53(L) +
     +       X13(J)*X23(L)*X33(K)*X63(J) + X13(J)*X23(K)*X33(L)*X63(J) +
     +       X13(J)*X23(L)*X43(K)*X63(J) + X13(J)*X23(K)*X43(L)*X63(J) +
     +       X13(J)*X33(L)*X53(K)*X63(J) + X13(J)*X43(L)*X53(K)*X63(J) +
     +       X13(J)*X33(K)*X53(L)*X63(J) + X13(J)*X43(K)*X53(L)*X63(J) +
     +       X23(L)*X33(J)*X43(J)*X63(K) + X23(J)*X33(L)*X53(J)*X63(K) +
     +       X23(J)*X43(L)*X53(J)*X63(K) + X33(J)*X43(J)*X53(L)*X63(K) +
     +       X23(K)*X33(J)*X43(J)*X63(L) + X23(J)*X33(K)*X53(J)*X63(L) +
     +       X23(J)*X43(K)*X53(J)*X63(L) + X33(J)*X43(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN25 = X13(L)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X23(L)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(J)*X43(I)*X53(J)*X63(I) +
     +        X23(J)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X53(J)*X63(I) +
     +        X23(J)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(J)*X63(I) +
     +        X23(I)*X33(J)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(L)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X53(I)*X63(J) +
     +        X13(J)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X63(J) +
     +        X13(J)*X23(I)*X43(I)*X53(L)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(J)*X53(I) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(J) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(J) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(L) +
     +        X13(I)*X33(J)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(J)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X63(L)
      ELSE
      FUN25 = X13(L)*X23(K)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(J)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(J)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(J)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(K)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(J)*X23(K)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(K)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(K)*X63(J) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(L)*X63(J) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(K)*X33(J)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(J)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN26(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,4)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN26= X13(L)*X23(J)*X33(J)*X43(K) + X13(J)*X23(L)*X33(J)*X43(K) +
     +       X13(L)*X23(K)*X43(J)*X53(J) + X13(L)*X33(K)*X43(J)*X53(J) +
     +       X13(J)*X23(K)*X43(L)*X53(J) + X13(L)*X23(J)*X33(J)*X53(K) +
     +       X13(J)*X23(J)*X33(L)*X53(K) + X13(J)*X33(K)*X43(J)*X53(L) +
     +       X13(K)*X23(L)*X43(J)*X63(J) + X23(L)*X33(K)*X43(J)*X63(J) +
     +       X13(K)*X23(J)*X43(L)*X63(J) + X13(K)*X33(L)*X53(J)*X63(J) +
     +       X23(K)*X33(L)*X53(J)*X63(J) + X23(J)*X43(L)*X53(K)*X63(J) +
     +       X13(K)*X33(J)*X53(L)*X63(J) + X33(J)*X43(K)*X53(L)*X63(J) +
     +       X13(J)*X23(L)*X33(J)*X63(K) + X13(J)*X23(J)*X33(L)*X63(K) +
     +       X13(J)*X43(L)*X53(J)*X63(K) + X13(J)*X43(J)*X53(L)*X63(K) +
     +       X23(J)*X33(K)*X43(J)*X63(L) + X23(K)*X33(J)*X53(J)*X63(L) +
     +       X33(J)*X43(K)*X53(J)*X63(L) + X23(J)*X43(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN26 = X13(L)*X23(J)*X33(J)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(J)*X53(I)*X63(I) +
     +        X13(L)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(J)*X43(I)*X63(I) +
     +        X13(J)*X23(J)*X33(L)*X43(I)*X63(I) +
     +        X13(J)*X23(I)*X43(J)*X53(L)*X63(I) +
     +        X23(L)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X43(J)*X53(I)*X63(J) +
     +        X23(J)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X23(I)*X33(L)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X33(L)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X63(J) +
     +        X23(I)*X33(J)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X33(J)*X43(I)*X53(I) +
     +        X13(J)*X23(J)*X33(L)*X43(I)*X53(I) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(J) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(L) +
     +        X13(I)*X23(J)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X33(J)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X63(L)
      ELSE
      FUN26 = X13(L)*X23(J)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(J)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(J)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(K)*X43(J)*X53(I)*X63(J) +
     +        X13(K)*X23(J)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(K)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(J)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(J)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(K)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN27(JJ)
      L = IPA(JJ,2)
      K = IPA(JJ,3)
      J = IPA(JJ,4)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN27= X23(L)*X33(K)*X43(J)*X53(J) + X23(K)*X33(L)*X43(J)*X53(J) +
     +       X23(L)*X33(J)*X43(K)*X53(J) + X23(K)*X33(J)*X43(L)*X53(J) +
     +       X23(J)*X33(L)*X43(J)*X53(K) + X23(J)*X33(J)*X43(L)*X53(K) +
     +       X23(J)*X33(K)*X43(J)*X53(L) + X23(J)*X33(J)*X43(K)*X53(L) +
     +       X13(L)*X33(K)*X43(J)*X63(J) + X13(K)*X33(L)*X43(J)*X63(J) +
     +       X13(L)*X33(J)*X43(K)*X63(J) + X13(K)*X33(J)*X43(L)*X63(J) +
     +       X13(L)*X23(K)*X53(J)*X63(J) + X13(K)*X23(L)*X53(J)*X63(J) +
     +       X13(L)*X23(J)*X53(K)*X63(J) + X13(K)*X23(J)*X53(L)*X63(J) +
     +       X13(J)*X33(L)*X43(J)*X63(K) + X13(J)*X33(J)*X43(L)*X63(K) +
     +       X13(J)*X23(L)*X53(J)*X63(K) + X13(J)*X23(J)*X53(L)*X63(K) +
     +       X13(J)*X33(K)*X43(J)*X63(L) + X13(J)*X33(J)*X43(K)*X63(L) +
     +       X13(J)*X23(K)*X53(J)*X63(L) + X13(J)*X23(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN27 = X13(I)*X23(L)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X33(L)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X53(J)*X63(I) +
     +        X13(I)*X33(J)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(J)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(L)*X63(I) +
     +        X13(I)*X23(J)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X43(J)*X53(I)*X63(J) +
     +        X23(I)*X33(L)*X43(J)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X53(I)*X63(J) +
     +        X23(I)*X33(J)*X43(L)*X53(I)*X63(J) +
     +        X13(L)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X23(L)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X63(J) +
     +        X23(J)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(J)*X23(I)*X33(L)*X43(J)*X53(I) +
     +        X13(J)*X23(I)*X33(J)*X43(L)*X53(I) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(J) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(L) +
     +        X13(J)*X23(I)*X43(J)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(J)*X53(I)*X63(L) +
     +        X13(J)*X33(I)*X43(I)*X53(J)*X63(L) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X63(L)
      ELSE
      FUN27 = X13(I)*X23(L)*X33(K)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(J)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(J)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(J)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(L)*X43(J)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(J)*X43(L)*X53(I)*X63(J) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(J)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(J)*X23(I)*X33(L)*X43(J)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(J)*X43(L)*X53(I)*X63(K) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(I)*X33(K)*X43(J)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(J)*X43(K)*X53(I)*X63(L) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(J)*X63(L) +
     +        X13(J)*X23(J)*X33(I)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN28(JJ)
      L = IPA(JJ,3)
      K = IPA(JJ,4)
      J = IPA(JJ,2)
      I = IPA(JJ,1)
*     print*,' FUN28 con IJKL',i,j,k,l
      IF(I.EQ.0) THEN
      FUN28= X23(J)*X33(L)*X43(K)*X53(J) + X23(J)*X33(K)*X43(L)*X53(J) +
     +       X23(L)*X33(J)*X43(J)*X53(K) + X23(K)*X33(J)*X43(J)*X53(L) +
     +       X13(J)*X33(L)*X43(K)*X63(J) + X13(J)*X33(K)*X43(L)*X63(J) +
     +       X13(J)*X23(L)*X53(K)*X63(J) + X13(J)*X23(K)*X53(L)*X63(J) +
     +       X13(L)*X33(J)*X43(J)*X63(K) + X13(L)*X23(J)*X53(J)*X63(K) +
     +       X13(K)*X33(J)*X43(J)*X63(L) + X13(K)*X23(J)*X53(J)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN28 = X13(I)*X23(J)*X33(L)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(J)*X63(I) +
     +        X13(I)*X33(J)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X43(L)*X53(I)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X63(J) +
     +        X13(J)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X43(J)*X53(I) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(J) +
     +        X23(I)*X33(J)*X43(J)*X53(I)*X63(L) +
     +        X23(J)*X33(I)*X43(I)*X53(J)*X63(L)
      ELSE
      FUN28 = X13(I)*X23(J)*X33(L)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(K)*X53(I)*X63(J) +
     +        X13(J)*X23(I)*X33(K)*X43(L)*X53(I)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X43(J)*X53(I)*X63(K) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(K)*X23(I)*X33(J)*X43(J)*X53(I)*X63(L) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(J)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN29(JJ)
      L = IPA(JJ,4)
      K = IPA(JJ,3)
      J = IPA(JJ,1)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN29= X13(J)*X23(J)*X33(K)*X43(L) + X13(J)*X33(L)*X43(K)*X53(J) +
     +       X13(J)*X23(L)*X43(J)*X53(K) + X13(J)*X23(K)*X33(J)*X53(L) +
     +       X23(J)*X33(L)*X43(K)*X63(J) + X33(K)*X43(L)*X53(J)*X63(J) +
     +       X23(L)*X33(J)*X53(K)*X63(J) + X23(K)*X43(J)*X53(L)*X63(J) +
     +       X13(L)*X23(J)*X43(J)*X63(K) + X13(L)*X33(J)*X53(J)*X63(K) +
     +       X13(K)*X23(J)*X33(J)*X63(L) + X13(K)*X43(J)*X53(J)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN29 = X13(J)*X23(J)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(J)*X63(I) +
     +        X13(J)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X63(J) +
     +        X13(I)*X33(I)*X43(J)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(J)*X53(I) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(J) +
     +        X23(J)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X23(I)*X33(I)*X43(J)*X53(J)*X63(L)
      ELSE
      FUN29 = X13(J)*X23(J)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(K)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(J)*X63(K) +
     +        X13(K)*X23(J)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(J)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN30(JJ)
      L = IPA(JJ,3)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN30= X13(K)*X23(J)*X33(L)*X43(J) + X13(J)*X23(K)*X33(L)*X43(J) +
     +       X13(K)*X23(L)*X33(J)*X53(J) + X13(J)*X23(L)*X33(K)*X53(J) +
     +       X13(K)*X33(J)*X43(L)*X53(J) + X13(J)*X33(J)*X43(L)*X53(K) +
     +       X13(K)*X23(J)*X43(J)*X53(L) + X13(J)*X23(J)*X43(K)*X53(L) +
     +       X13(L)*X23(K)*X33(J)*X63(J) + X13(L)*X23(J)*X33(K)*X63(J) +
     +       X23(K)*X33(J)*X43(L)*X63(J) + X13(L)*X43(K)*X53(J)*X63(J) +
     +       X23(L)*X43(K)*X53(J)*X63(J) + X13(L)*X43(J)*X53(K)*X63(J) +
     +       X33(L)*X43(J)*X53(K)*X63(J) + X23(J)*X33(K)*X53(L)*X63(J) +
     +       X23(J)*X33(J)*X43(L)*X63(K) + X23(L)*X43(J)*X53(J)*X63(K) +
     +       X33(L)*X43(J)*X53(J)*X63(K) + X23(J)*X33(J)*X53(L)*X63(K) +
     +       X13(J)*X23(K)*X43(J)*X63(L) + X13(J)*X23(J)*X43(K)*X63(L) +
     +       X13(J)*X33(K)*X53(J)*X63(L) + X13(J)*X33(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN30 = X23(J)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X23(L)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X43(I)*X53(J)*X63(I) +
     +        X23(I)*X33(J)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(L)*X63(I) +
     +        X23(J)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X53(L)*X63(I) +
     +        X13(L)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(J)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X33(J)*X43(L)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X53(J)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X63(J) +
     +        X13(I)*X23(J)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(J)*X33(J)*X43(L)*X53(I) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(J) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(J) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(L) +
     +        X13(J)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(J)*X23(J)*X33(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X43(I)*X53(J)*X63(L) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X63(L)
      ELSE
      FUN30 = X13(K)*X23(J)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(J)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(J)*X43(L)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(J)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(K)*X63(J) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(J)*X33(J)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(K)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(J)*X23(J)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(J)*X63(L) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN31(JJ)
      L = IPA(JJ,1)
      K = IPA(JJ,3)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN31= X13(L)*X23(J)*X33(K)*X43(J) + X13(J)*X23(L)*X33(K)*X43(J) +
     +       X13(L)*X23(K)*X33(J)*X53(J) + X13(J)*X23(K)*X33(L)*X53(J) +
     +       X13(L)*X33(J)*X43(K)*X53(J) + X13(L)*X23(J)*X43(J)*X53(K) +
     +       X13(J)*X23(J)*X43(L)*X53(K) + X13(J)*X33(J)*X43(K)*X53(L) +
     +       X13(K)*X23(L)*X33(J)*X63(J) + X13(K)*X23(J)*X33(L)*X63(J) +
     +       X23(L)*X33(J)*X43(K)*X63(J) + X13(K)*X43(L)*X53(J)*X63(J) +
     +       X23(K)*X43(L)*X53(J)*X63(J) + X23(J)*X33(L)*X53(K)*X63(J) +
     +       X13(K)*X43(J)*X53(L)*X63(J) + X33(K)*X43(J)*X53(L)*X63(J) +
     +       X13(J)*X23(L)*X43(J)*X63(K) + X13(J)*X23(J)*X43(L)*X63(K) +
     +       X13(J)*X33(L)*X53(J)*X63(K) + X13(J)*X33(J)*X53(L)*X63(K) +
     +       X23(J)*X33(J)*X43(K)*X63(L) + X23(K)*X43(J)*X53(J)*X63(L) +
     +       X33(K)*X43(J)*X53(J)*X63(L) + X23(J)*X33(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN31 = X13(L)*X23(J)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(J)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(L)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X53(L)*X63(I) +
     +        X23(L)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X23(J)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X53(I)*X63(J) +
     +        X23(I)*X33(I)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X33(I)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X63(J) +
     +        X23(I)*X33(I)*X43(J)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X43(J)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(J)*X53(I) +
     +        X13(J)*X23(J)*X33(I)*X43(L)*X53(I) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(J) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(L) +
     +        X13(I)*X23(J)*X33(J)*X53(I)*X63(L) +
     +        X13(I)*X33(I)*X43(J)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X43(J)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X63(L)
      ELSE
      FUN31 = X13(L)*X23(J)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(K)*X33(J)*X43(I)*X53(J)*X63(I) +
     +        X13(J)*X23(K)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(K)*X53(J)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(J)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(J)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(J)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(K)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(J)*X63(J) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(K)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(L)*X63(J) +
     +        X13(J)*X23(L)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(J)*X23(J)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(J)*X63(K) +
     +        X13(J)*X23(I)*X33(J)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(J)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(J)*X43(I)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN32(JJ)
      L = IPA(JJ,4)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN32= X13(K)*X23(J)*X33(J)*X43(L) + X13(J)*X23(K)*X33(J)*X43(L) +
     +       X13(K)*X23(L)*X43(J)*X53(J) + X13(K)*X33(L)*X43(J)*X53(J) +
     +       X13(J)*X23(L)*X43(K)*X53(J) + X13(J)*X33(L)*X43(J)*X53(K) +
     +       X13(K)*X23(J)*X33(J)*X53(L) + X13(J)*X23(J)*X33(K)*X53(L) +
     +       X13(L)*X23(K)*X43(J)*X63(J) + X23(K)*X33(L)*X43(J)*X63(J) +
     +       X13(L)*X23(J)*X43(K)*X63(J) + X13(L)*X33(K)*X53(J)*X63(J) +
     +       X23(L)*X33(K)*X53(J)*X63(J) + X13(L)*X33(J)*X53(K)*X63(J) +
     +       X33(J)*X43(L)*X53(K)*X63(J) + X23(J)*X43(K)*X53(L)*X63(J) +
     +       X23(J)*X33(L)*X43(J)*X63(K) + X23(L)*X33(J)*X53(J)*X63(K) +
     +       X33(J)*X43(L)*X53(J)*X63(K) + X23(J)*X43(J)*X53(L)*X63(K) +
     +       X13(J)*X23(K)*X33(J)*X63(L) + X13(J)*X23(J)*X33(K)*X63(L) +
     +       X13(J)*X43(K)*X53(J)*X63(L) + X13(J)*X43(J)*X53(K)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN32 = X23(J)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X23(L)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X23(I)*X33(L)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(J)*X63(I) +
     +        X23(J)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(J)*X43(I)*X53(L)*X63(I) +
     +        X13(L)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X33(L)*X43(J)*X53(I)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X43(I)*X53(J)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X53(L)*X63(J) +
     +        X13(I)*X23(J)*X33(L)*X43(J)*X53(I) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(J) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(J) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(L) +
     +        X13(J)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(J)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X53(J)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X63(L)
      ELSE
      FUN32 = X13(K)*X23(J)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(J)*X53(J)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(J)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(J)*X53(K)*X63(I) +
     +        X13(K)*X23(J)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(J)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(J)*X53(I)*X63(J) +
     +        X13(I)*X23(K)*X33(L)*X43(J)*X53(I)*X63(J) +
     +        X13(L)*X23(J)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(J)*X63(J) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(K)*X63(J) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(J)*X33(L)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(J)*X53(L)*X63(K) +
     +        X13(J)*X23(K)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(J)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(J)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(J)*X53(K)*X63(L)
      ENDIF
      RETURN
      ENTRY FUN33(JJ)
      L = IPA(JJ,3)
      K = IPA(JJ,4)
      J = IPA(JJ,1)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN33= X13(J)*X23(J)*X33(L)*X43(K) + X13(J)*X33(K)*X43(L)*X53(J) +
     +       X13(J)*X23(L)*X33(J)*X53(K) + X13(J)*X23(K)*X43(J)*X53(L) +
     +       X23(J)*X33(K)*X43(L)*X63(J) + X33(L)*X43(K)*X53(J)*X63(J) +
     +       X23(L)*X43(J)*X53(K)*X63(J) + X23(K)*X33(J)*X53(L)*X63(J) +
     +       X13(L)*X23(J)*X33(J)*X63(K) + X13(L)*X43(J)*X53(J)*X63(K) +
     +       X13(K)*X23(J)*X43(J)*X63(L) + X13(K)*X33(J)*X53(J)*X63(L)
      ELSE IF(K.EQ.0) THEN
      FUN33 = X13(J)*X23(J)*X33(L)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(J)*X43(I)*X63(I) +
     +        X13(J)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X63(J) +
     +        X13(I)*X33(J)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X33(J)*X43(I)*X53(I) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(J) +
     +        X23(J)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X23(I)*X33(J)*X43(I)*X53(J)*X63(L)
      ELSE
      FUN33 = X13(J)*X23(J)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(L)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(J)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(J)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(J)*X63(K) +
     +        X13(K)*X23(J)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(J)*X63(L)
      ENDIF
      RETURN
************************************************************************
      ENTRY FUN34(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,2)
      K = IPA(JJ,3)
      J = IPA(JJ,4)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN34= X13(M)*X23(L)*X33(K)*X43(J) + X13(L)*X23(M)*X33(K)*X43(J) +
     +       X13(M)*X23(K)*X33(L)*X53(J) + X13(L)*X23(K)*X33(M)*X53(J) +
     +       X13(M)*X23(J)*X43(L)*X53(K) + X13(L)*X23(J)*X43(M)*X53(K) +
     +       X13(M)*X33(J)*X43(K)*X53(L) + X13(L)*X33(J)*X43(K)*X53(M) +
     +       X13(K)*X23(M)*X33(L)*X63(J) + X13(K)*X23(L)*X33(M)*X63(J) +
     +       X13(K)*X43(M)*X53(L)*X63(J) + X13(K)*X43(L)*X53(M)*X63(J) +
     +       X13(J)*X23(M)*X43(L)*X63(K) + X13(J)*X23(L)*X43(M)*X63(K) +
     +       X13(J)*X33(M)*X53(L)*X63(K) + X13(J)*X33(L)*X53(M)*X63(K) +
     +       X23(M)*X33(J)*X43(K)*X63(L) + X23(K)*X43(M)*X53(J)*X63(L) +
     +       X23(J)*X33(M)*X53(K)*X63(L) + X33(K)*X43(J)*X53(M)*X63(L) +
     +       X23(L)*X33(J)*X43(K)*X63(M) + X23(K)*X43(L)*X53(J)*X63(M) +
     +       X23(J)*X33(L)*X53(K)*X63(M) + X33(K)*X43(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN34 = X13(M)*X23(L)*X33(K)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X53(I)*X63(I) +
     +        X13(M)*X23(K)*X33(L)*X43(I)*X63(I) +
     +        X13(L)*X23(K)*X33(M)*X43(I)*X63(I) +
     +        X13(M)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(L)*X33(I)*X43(M)*X53(K)*X63(I) +
     +        X13(M)*X23(I)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X43(I)*X53(I) +
     +        X13(K)*X23(L)*X33(M)*X43(I)*X53(I) +
     +        X13(K)*X23(I)*X33(I)*X43(M)*X53(L) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(M) +
     +        X23(M)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X23(L)*X33(I)*X43(M)*X53(I)*X63(K) +
     +        X23(I)*X33(M)*X43(I)*X53(L)*X63(K) +
     +        X23(I)*X33(L)*X43(I)*X53(M)*X63(K) +
     +        X13(I)*X23(M)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(M)*X63(L) +
     +        X13(I)*X33(M)*X43(I)*X53(K)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X53(M)*X63(L) +
     +        X13(I)*X23(L)*X43(K)*X53(I)*X63(M) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X63(M) +
     +        X13(I)*X33(L)*X43(I)*X53(K)*X63(M) +
     +        X13(I)*X23(I)*X33(K)*X53(L)*X63(M)
      ELSE
      FUN34 = X13(M)*X23(L)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X43(J)*X53(I)*X63(I) +
     +        X13(M)*X23(K)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(K)*X33(M)*X43(I)*X53(J)*X63(I) +
     +        X13(M)*X23(J)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(M)*X53(K)*X63(I) +
     +        X13(M)*X23(I)*X33(J)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(L)*X33(M)*X43(I)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(M)*X53(L)*X63(J) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(M)*X63(J) +
     +        X13(J)*X23(M)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(J)*X23(L)*X33(I)*X43(M)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(M)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(M)*X63(K) +
     +        X13(I)*X23(M)*X33(J)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(M)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(M)*X43(I)*X53(K)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(M)*X63(L) +
     +        X13(I)*X23(L)*X33(J)*X43(K)*X53(I)*X63(M) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(J)*X63(M) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(K)*X63(M) +
     +        X13(I)*X23(I)*X33(K)*X43(J)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN35(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,3)
      K = IPA(JJ,2)
      J = IPA(JJ,4)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN35= X13(M)*X23(K)*X33(L)*X43(J) + X13(K)*X23(M)*X33(L)*X43(J) +
     +       X13(M)*X23(L)*X33(K)*X53(J) + X13(K)*X23(L)*X33(M)*X53(J) +
     +       X13(M)*X33(J)*X43(L)*X53(K) + X13(M)*X23(J)*X43(K)*X53(L) +
     +       X13(K)*X23(J)*X43(M)*X53(L) + X13(K)*X33(J)*X43(L)*X53(M) +
     +       X13(L)*X23(M)*X33(K)*X63(J) + X13(L)*X23(K)*X33(M)*X63(J) +
     +       X13(L)*X43(M)*X53(K)*X63(J) + X13(L)*X43(K)*X53(M)*X63(J) +
     +       X23(M)*X33(J)*X43(L)*X63(K) + X23(L)*X43(M)*X53(J)*X63(K) +
     +       X23(J)*X33(M)*X53(L)*X63(K) + X33(L)*X43(J)*X53(M)*X63(K) +
     +       X13(J)*X23(M)*X43(K)*X63(L) + X13(J)*X23(K)*X43(M)*X63(L) +
     +       X13(J)*X33(M)*X53(K)*X63(L) + X13(J)*X33(K)*X53(M)*X63(L) +
     +       X23(K)*X33(J)*X43(L)*X63(M) + X23(L)*X43(K)*X53(J)*X63(M) +
     +       X33(L)*X43(J)*X53(K)*X63(M) + X23(J)*X33(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN35 = X13(M)*X23(K)*X33(L)*X53(I)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X53(I)*X63(I) +
     +        X13(M)*X23(L)*X33(K)*X43(I)*X63(I) +
     +        X13(K)*X23(L)*X33(M)*X43(I)*X63(I) +
     +        X13(M)*X23(I)*X43(L)*X53(K)*X63(I) +
     +        X13(M)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X33(I)*X43(M)*X53(L)*X63(I) +
     +        X13(K)*X23(I)*X43(L)*X53(M)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X43(I)*X53(I) +
     +        X13(L)*X23(K)*X33(M)*X43(I)*X53(I) +
     +        X13(L)*X23(I)*X33(I)*X43(M)*X53(K) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(M) +
     +        X13(I)*X23(M)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(M)*X63(K) +
     +        X13(I)*X33(M)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X53(M)*X63(K) +
     +        X23(M)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X23(K)*X33(I)*X43(M)*X53(I)*X63(L) +
     +        X23(I)*X33(M)*X43(I)*X53(K)*X63(L) +
     +        X23(I)*X33(K)*X43(I)*X53(M)*X63(L) +
     +        X13(I)*X23(K)*X43(L)*X53(I)*X63(M) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X63(M) +
     +        X13(I)*X23(I)*X33(L)*X53(K)*X63(M) +
     +        X13(I)*X33(K)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN35 = X13(M)*X23(K)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X43(J)*X53(I)*X63(I) +
     +        X13(M)*X23(L)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(L)*X33(M)*X43(I)*X53(J)*X63(I) +
     +        X13(M)*X23(I)*X33(J)*X43(L)*X53(K)*X63(I) +
     +        X13(M)*X23(J)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(M)*X53(L)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(L)*X53(M)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(K)*X33(M)*X43(I)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(M)*X53(K)*X63(J) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(M)*X63(J) +
     +        X13(I)*X23(M)*X33(J)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(M)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(M)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(M)*X63(K) +
     +        X13(J)*X23(M)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(J)*X23(K)*X33(I)*X43(M)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(M)*X43(I)*X53(K)*X63(L) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(M)*X63(L) +
     +        X13(I)*X23(K)*X33(J)*X43(L)*X53(I)*X63(M) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(J)*X63(M) +
     +        X13(I)*X23(I)*X33(L)*X43(J)*X53(K)*X63(M) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN36(JJ)
      M = IPA(JJ,2)
      L = IPA(JJ,3)
      K = IPA(JJ,4)
      J = IPA(JJ,5)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN36= X23(M)*X33(L)*X43(K)*X53(J) + X23(M)*X33(K)*X43(L)*X53(J) +
     +       X23(L)*X33(M)*X43(J)*X53(K) + X23(L)*X33(J)*X43(M)*X53(K) +
     +       X23(K)*X33(M)*X43(J)*X53(L) + X23(K)*X33(J)*X43(M)*X53(L) +
     +       X23(J)*X33(L)*X43(K)*X53(M) + X23(J)*X33(K)*X43(L)*X53(M) +
     +       X13(M)*X33(L)*X43(K)*X63(J) + X13(M)*X33(K)*X43(L)*X63(J) +
     +       X13(M)*X23(L)*X53(K)*X63(J) + X13(M)*X23(K)*X53(L)*X63(J) +
     +       X13(L)*X33(M)*X43(J)*X63(K) + X13(L)*X33(J)*X43(M)*X63(K) +
     +       X13(L)*X23(M)*X53(J)*X63(K) + X13(L)*X23(J)*X53(M)*X63(K) +
     +       X13(K)*X33(M)*X43(J)*X63(L) + X13(K)*X33(J)*X43(M)*X63(L) +
     +       X13(K)*X23(M)*X53(J)*X63(L) + X13(K)*X23(J)*X53(M)*X63(L) +
     +       X13(J)*X33(L)*X43(K)*X63(M) + X13(J)*X33(K)*X43(L)*X63(M) +
     +       X13(J)*X23(L)*X53(K)*X63(M) + X13(J)*X23(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN36 = X13(I)*X23(M)*X33(L)*X43(K)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X43(L)*X63(I) +
     +        X13(I)*X23(L)*X33(M)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X43(M)*X53(K)*X63(I) +
     +        X13(I)*X23(K)*X33(M)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X43(M)*X53(L)*X63(I) +
     +        X13(I)*X33(L)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X33(K)*X43(L)*X53(M)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X43(K)*X53(I) +
     +        X13(M)*X23(I)*X33(K)*X43(L)*X53(I) +
     +        X13(M)*X23(L)*X33(I)*X43(I)*X53(K) +
     +        X13(M)*X23(K)*X33(I)*X43(I)*X53(L) +
     +        X13(L)*X23(I)*X33(M)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X43(M)*X53(I)*X63(K) +
     +        X13(L)*X23(M)*X33(I)*X43(I)*X63(K) +
     +        X13(L)*X33(I)*X43(I)*X53(M)*X63(K) +
     +        X13(K)*X23(I)*X33(M)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X43(M)*X53(I)*X63(L) +
     +        X13(K)*X23(M)*X33(I)*X43(I)*X63(L) +
     +        X13(K)*X33(I)*X43(I)*X53(M)*X63(L) +
     +        X23(I)*X33(L)*X43(K)*X53(I)*X63(M) +
     +        X23(I)*X33(K)*X43(L)*X53(I)*X63(M) +
     +        X23(L)*X33(I)*X43(I)*X53(K)*X63(M) +
     +        X23(K)*X33(I)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN36 = X13(I)*X23(M)*X33(L)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(M)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(M)*X53(K)*X63(I) +
     +        X13(I)*X23(K)*X33(M)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(M)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(L)*X53(M)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X43(K)*X53(I)*X63(J) +
     +        X13(M)*X23(I)*X33(K)*X43(L)*X53(I)*X63(J) +
     +        X13(M)*X23(L)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(M)*X23(K)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(L)*X23(I)*X33(M)*X43(J)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(J)*X43(M)*X53(I)*X63(K) +
     +        X13(L)*X23(M)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(M)*X63(K) +
     +        X13(K)*X23(I)*X33(M)*X43(J)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(J)*X43(M)*X53(I)*X63(L) +
     +        X13(K)*X23(M)*X33(I)*X43(I)*X53(J)*X63(L) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(M)*X63(L) +
     +        X13(J)*X23(I)*X33(L)*X43(K)*X53(I)*X63(M) +
     +        X13(J)*X23(I)*X33(K)*X43(L)*X53(I)*X63(M) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(K)*X63(M) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN37(JJ)
      M = IPA(JJ,3)
      L = IPA(JJ,2)
      K = IPA(JJ,4)
      J = IPA(JJ,5)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN37= X23(L)*X33(M)*X43(K)*X53(J) + X23(L)*X33(K)*X43(M)*X53(J) +
     +       X23(M)*X33(L)*X43(J)*X53(K) + X23(M)*X33(J)*X43(L)*X53(K) +
     +       X23(J)*X33(M)*X43(K)*X53(L) + X23(J)*X33(K)*X43(M)*X53(L) +
     +       X23(K)*X33(L)*X43(J)*X53(M) + X23(K)*X33(J)*X43(L)*X53(M) +
     +       X13(L)*X33(M)*X43(K)*X63(J) + X13(L)*X33(K)*X43(M)*X63(J) +
     +       X13(L)*X23(M)*X53(K)*X63(J) + X13(L)*X23(K)*X53(M)*X63(J) +
     +       X13(M)*X33(L)*X43(J)*X63(K) + X13(M)*X33(J)*X43(L)*X63(K) +
     +       X13(M)*X23(L)*X53(J)*X63(K) + X13(M)*X23(J)*X53(L)*X63(K) +
     +       X13(J)*X33(M)*X43(K)*X63(L) + X13(J)*X33(K)*X43(M)*X63(L) +
     +       X13(J)*X23(M)*X53(K)*X63(L) + X13(J)*X23(K)*X53(M)*X63(L) +
     +       X13(K)*X33(L)*X43(J)*X63(M) + X13(K)*X33(J)*X43(L)*X63(M) +
     +       X13(K)*X23(L)*X53(J)*X63(M) + X13(K)*X23(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN37 = X13(I)*X23(L)*X33(M)*X43(K)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(M)*X63(I) +
     +        X13(I)*X23(M)*X33(L)*X53(K)*X63(I) +
     +        X13(I)*X23(M)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X33(M)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X33(K)*X43(M)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X43(L)*X53(M)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X43(K)*X53(I) +
     +        X13(L)*X23(I)*X33(K)*X43(M)*X53(I) +
     +        X13(L)*X23(M)*X33(I)*X43(I)*X53(K) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(M) +
     +        X13(M)*X23(I)*X33(L)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X43(L)*X53(I)*X63(K) +
     +        X13(M)*X23(L)*X33(I)*X43(I)*X63(K) +
     +        X13(M)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X23(I)*X33(M)*X43(K)*X53(I)*X63(L) +
     +        X23(I)*X33(K)*X43(M)*X53(I)*X63(L) +
     +        X23(M)*X33(I)*X43(I)*X53(K)*X63(L) +
     +        X23(K)*X33(I)*X43(I)*X53(M)*X63(L) +
     +        X13(K)*X23(I)*X33(L)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X43(L)*X53(I)*X63(M) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X63(M) +
     +        X13(K)*X33(I)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN37 = X13(I)*X23(L)*X33(M)*X43(K)*X53(J)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(M)*X53(J)*X63(I) +
     +        X13(I)*X23(M)*X33(L)*X43(J)*X53(K)*X63(I) +
     +        X13(I)*X23(M)*X33(J)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(M)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X23(J)*X33(K)*X43(M)*X53(L)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(J)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X33(J)*X43(L)*X53(M)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X43(K)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(K)*X43(M)*X53(I)*X63(J) +
     +        X13(L)*X23(M)*X33(I)*X43(I)*X53(K)*X63(J) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(M)*X63(J) +
     +        X13(M)*X23(I)*X33(L)*X43(J)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X33(J)*X43(L)*X53(I)*X63(K) +
     +        X13(M)*X23(L)*X33(I)*X43(I)*X53(J)*X63(K) +
     +        X13(M)*X23(J)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(I)*X33(M)*X43(K)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(K)*X43(M)*X53(I)*X63(L) +
     +        X13(J)*X23(M)*X33(I)*X43(I)*X53(K)*X63(L) +
     +        X13(J)*X23(K)*X33(I)*X43(I)*X53(M)*X63(L) +
     +        X13(K)*X23(I)*X33(L)*X43(J)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X33(J)*X43(L)*X53(I)*X63(M) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(J)*X63(M) +
     +        X13(K)*X23(J)*X33(I)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN38(JJ)
      M = IPA(JJ,4)
      L = IPA(JJ,3)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN38= X13(K)*X23(J)*X33(L)*X43(M) + X13(J)*X23(K)*X33(L)*X43(M) +
     +       X13(K)*X33(M)*X43(L)*X53(J) + X13(J)*X33(M)*X43(L)*X53(K) +
     +       X13(K)*X23(M)*X43(J)*X53(L) + X13(J)*X23(M)*X43(K)*X53(L) +
     +       X13(K)*X23(L)*X33(J)*X53(M) + X13(J)*X23(L)*X33(K)*X53(M) +
     +       X23(K)*X33(M)*X43(L)*X63(J) + X33(L)*X43(M)*X53(K)*X63(J) +
     +       X23(M)*X33(K)*X53(L)*X63(J) + X23(L)*X43(K)*X53(M)*X63(J) +
     +       X23(J)*X33(M)*X43(L)*X63(K) + X33(L)*X43(M)*X53(J)*X63(K) +
     +       X23(M)*X33(J)*X53(L)*X63(K) + X23(L)*X43(J)*X53(M)*X63(K) +
     +       X13(M)*X23(K)*X43(J)*X63(L) + X13(M)*X23(J)*X43(K)*X63(L) +
     +       X13(M)*X33(K)*X53(J)*X63(L) + X13(M)*X33(J)*X53(K)*X63(L) +
     +       X13(L)*X23(K)*X33(J)*X63(M) + X13(L)*X23(J)*X33(K)*X63(M) +
     +       X13(L)*X43(K)*X53(J)*X63(M) + X13(L)*X43(J)*X53(K)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN38 = X13(K)*X33(L)*X43(M)*X53(I)*X63(I) +
     +        X23(K)*X33(L)*X43(M)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X43(L)*X63(I) +
     +        X23(I)*X33(M)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X53(L)*X63(I) +
     +        X23(M)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X43(I)*X53(M)*X63(I) +
     +        X23(L)*X33(K)*X43(I)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X33(M)*X43(L)*X53(I) +
     +        X13(I)*X23(I)*X33(L)*X43(M)*X53(K) +
     +        X13(I)*X23(M)*X33(K)*X43(I)*X53(L) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(M) +
     +        X13(I)*X33(M)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(M)*X63(K) +
     +        X13(I)*X23(M)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X53(M)*X63(K) +
     +        X13(M)*X23(K)*X33(I)*X53(I)*X63(L) +
     +        X13(M)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X33(K)*X43(I)*X63(L) +
     +        X13(M)*X23(I)*X43(I)*X53(K)*X63(L) +
     +        X13(L)*X23(K)*X43(I)*X53(I)*X63(M) +
     +        X13(L)*X33(K)*X43(I)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X63(M) +
     +        X13(L)*X23(I)*X33(I)*X53(K)*X63(M)
      ELSE
      FUN38 = X13(K)*X23(J)*X33(L)*X43(M)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(L)*X43(M)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X43(L)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(M)*X43(L)*X53(K)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(M)*X33(I)*X43(K)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(I)*X53(M)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(I)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X33(M)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(M)*X53(K)*X63(J) +
     +        X13(I)*X23(M)*X33(K)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(K)*X53(M)*X63(J) +
     +        X13(I)*X23(J)*X33(M)*X43(L)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(L)*X43(M)*X53(J)*X63(K) +
     +        X13(I)*X23(M)*X33(J)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(M)*X63(K) +
     +        X13(M)*X23(K)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(M)*X23(J)*X33(I)*X43(K)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X33(K)*X43(I)*X53(J)*X63(L) +
     +        X13(M)*X23(I)*X33(J)*X43(I)*X53(K)*X63(L) +
     +        X13(L)*X23(K)*X33(J)*X43(I)*X53(I)*X63(M) +
     +        X13(L)*X23(J)*X33(K)*X43(I)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X33(I)*X43(K)*X53(J)*X63(M) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(K)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN39(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,4)
      K = IPA(JJ,2)
      J = IPA(JJ,3)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN39= X13(M)*X23(K)*X33(J)*X43(L) + X13(K)*X23(M)*X33(J)*X43(L) +
     +       X13(M)*X23(L)*X43(K)*X53(J) + X13(K)*X23(L)*X43(M)*X53(J) +
     +       X13(M)*X33(L)*X43(J)*X53(K) + X13(M)*X23(J)*X33(K)*X53(L) +
     +       X13(K)*X23(J)*X33(M)*X53(L) + X13(K)*X33(L)*X43(J)*X53(M) +
     +       X13(L)*X23(M)*X43(K)*X63(J) + X13(L)*X23(K)*X43(M)*X63(J) +
     +       X13(L)*X33(M)*X53(K)*X63(J) + X13(L)*X33(K)*X53(M)*X63(J) +
     +       X23(M)*X33(L)*X43(J)*X63(K) + X23(L)*X33(M)*X53(J)*X63(K) +
     +       X23(J)*X43(M)*X53(L)*X63(K) + X33(J)*X43(L)*X53(M)*X63(K) +
     +       X13(J)*X23(M)*X33(K)*X63(L) + X13(J)*X23(K)*X33(M)*X63(L) +
     +       X13(J)*X43(M)*X53(K)*X63(L) + X13(J)*X43(K)*X53(M)*X63(L) +
     +       X23(K)*X33(L)*X43(J)*X63(M) + X23(L)*X33(K)*X53(J)*X63(M) +
     +       X33(J)*X43(L)*X53(K)*X63(M) + X23(J)*X43(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN39 = X13(M)*X23(K)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(M)*X43(L)*X53(I)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X43(K)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(M)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X53(K)*X63(I) +
     +        X13(M)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X33(M)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X53(M)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X43(K)*X53(I) +
     +        X13(L)*X23(K)*X33(I)*X43(M)*X53(I) +
     +        X13(L)*X23(I)*X33(M)*X43(I)*X53(K) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(M) +
     +        X13(I)*X23(M)*X33(L)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(M)*X43(I)*X63(K) +
     +        X13(I)*X33(I)*X43(M)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X43(L)*X53(M)*X63(K) +
     +        X23(M)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X23(K)*X33(M)*X43(I)*X53(I)*X63(L) +
     +        X23(I)*X33(I)*X43(M)*X53(K)*X63(L) +
     +        X23(I)*X33(I)*X43(K)*X53(M)*X63(L) +
     +        X13(I)*X23(K)*X33(L)*X53(I)*X63(M) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X63(M) +
     +        X13(I)*X23(I)*X43(L)*X53(K)*X63(M) +
     +        X13(I)*X33(I)*X43(K)*X53(L)*X63(M)
      ELSE
      FUN39 = X13(M)*X23(K)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(M)*X33(J)*X43(L)*X53(I)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(M)*X53(J)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X43(J)*X53(K)*X63(I) +
     +        X13(M)*X23(J)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X23(J)*X33(M)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(J)*X53(M)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(L)*X23(K)*X33(I)*X43(M)*X53(I)*X63(J) +
     +        X13(L)*X23(I)*X33(M)*X43(I)*X53(K)*X63(J) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(M)*X63(J) +
     +        X13(I)*X23(M)*X33(L)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(L)*X33(M)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(M)*X53(L)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(M)*X63(K) +
     +        X13(J)*X23(M)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(K)*X33(M)*X43(I)*X53(I)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(M)*X53(K)*X63(L) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(M)*X63(L) +
     +        X13(I)*X23(K)*X33(L)*X43(J)*X53(I)*X63(M) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(J)*X63(M) +
     +        X13(I)*X23(I)*X33(J)*X43(L)*X53(K)*X63(M) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN40(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,2)
      K = IPA(JJ,4)
      J = IPA(JJ,3)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN40= X13(M)*X23(L)*X33(J)*X43(K) + X13(L)*X23(M)*X33(J)*X43(K) +
     +       X13(M)*X23(K)*X43(L)*X53(J) + X13(L)*X23(K)*X43(M)*X53(J) +
     +       X13(M)*X23(J)*X33(L)*X53(K) + X13(L)*X23(J)*X33(M)*X53(K) +
     +       X13(M)*X33(K)*X43(J)*X53(L) + X13(L)*X33(K)*X43(J)*X53(M) +
     +       X13(K)*X23(M)*X43(L)*X63(J) + X13(K)*X23(L)*X43(M)*X63(J) +
     +       X13(K)*X33(M)*X53(L)*X63(J) + X13(K)*X33(L)*X53(M)*X63(J) +
     +       X13(J)*X23(M)*X33(L)*X63(K) + X13(J)*X23(L)*X33(M)*X63(K) +
     +       X13(J)*X43(M)*X53(L)*X63(K) + X13(J)*X43(L)*X53(M)*X63(K) +
     +       X23(M)*X33(K)*X43(J)*X63(L) + X23(K)*X33(M)*X53(J)*X63(L) +
     +       X23(J)*X43(M)*X53(K)*X63(L) + X33(J)*X43(K)*X53(M)*X63(L) +
     +       X23(L)*X33(K)*X43(J)*X63(M) + X23(K)*X33(L)*X53(J)*X63(M) +
     +       X23(J)*X43(L)*X53(K)*X63(M) + X33(J)*X43(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN40 = X13(M)*X23(L)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X43(K)*X53(I)*X63(I) +
     +        X13(M)*X23(K)*X33(I)*X43(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(M)*X63(I) +
     +        X13(M)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(L)*X33(M)*X43(I)*X53(K)*X63(I) +
     +        X13(M)*X23(I)*X33(K)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X53(M)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X43(L)*X53(I) +
     +        X13(K)*X23(L)*X33(I)*X43(M)*X53(I) +
     +        X13(K)*X23(I)*X33(M)*X43(I)*X53(L) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(M) +
     +        X23(M)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X23(L)*X33(M)*X43(I)*X53(I)*X63(K) +
     +        X23(I)*X33(I)*X43(M)*X53(L)*X63(K) +
     +        X23(I)*X33(I)*X43(L)*X53(M)*X63(K) +
     +        X13(I)*X23(M)*X33(K)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(M)*X43(I)*X63(L) +
     +        X13(I)*X33(I)*X43(M)*X53(K)*X63(L) +
     +        X13(I)*X23(I)*X43(K)*X53(M)*X63(L) +
     +        X13(I)*X23(L)*X33(K)*X53(I)*X63(M) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X63(M) +
     +        X13(I)*X33(I)*X43(L)*X53(K)*X63(M) +
     +        X13(I)*X23(I)*X43(K)*X53(L)*X63(M)
      ELSE
      FUN40 = X13(M)*X23(L)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(J)*X43(K)*X53(I)*X63(I) +
     +        X13(M)*X23(K)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(M)*X53(J)*X63(I) +
     +        X13(M)*X23(J)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(L)*X23(J)*X33(M)*X43(I)*X53(K)*X63(I) +
     +        X13(M)*X23(I)*X33(K)*X43(J)*X53(L)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(J)*X53(M)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(K)*X23(L)*X33(I)*X43(M)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(M)*X43(I)*X53(L)*X63(J) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(M)*X63(J) +
     +        X13(J)*X23(M)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(L)*X33(M)*X43(I)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(M)*X53(L)*X63(K) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(M)*X63(K) +
     +        X13(I)*X23(M)*X33(K)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(K)*X33(M)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(M)*X53(K)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(M)*X63(L) +
     +        X13(I)*X23(L)*X33(K)*X43(J)*X53(I)*X63(M) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(J)*X63(M) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(K)*X63(M) +
     +        X13(I)*X23(I)*X33(J)*X43(K)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN41(JJ)
      M = IPA(JJ,4)
      L = IPA(JJ,1)
      K = IPA(JJ,2)
      J = IPA(JJ,3)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN41= X13(L)*X23(K)*X33(J)*X43(M) + X13(K)*X23(L)*X33(J)*X43(M) +
     +       X13(L)*X23(M)*X43(K)*X53(J) + X13(K)*X23(M)*X43(L)*X53(J) +
     +       X13(L)*X33(M)*X43(J)*X53(K) + X13(K)*X33(M)*X43(J)*X53(L) +
     +       X13(L)*X23(J)*X33(K)*X53(M) + X13(K)*X23(J)*X33(L)*X53(M) +
     +       X13(M)*X23(L)*X43(K)*X63(J) + X13(M)*X23(K)*X43(L)*X63(J) +
     +       X13(M)*X33(L)*X53(K)*X63(J) + X13(M)*X33(K)*X53(L)*X63(J) +
     +       X23(L)*X33(M)*X43(J)*X63(K) + X23(M)*X33(L)*X53(J)*X63(K) +
     +       X33(J)*X43(M)*X53(L)*X63(K) + X23(J)*X43(L)*X53(M)*X63(K) +
     +       X23(K)*X33(M)*X43(J)*X63(L) + X23(M)*X33(K)*X53(J)*X63(L) +
     +       X33(J)*X43(M)*X53(K)*X63(L) + X23(J)*X43(K)*X53(M)*X63(L) +
     +       X13(J)*X23(L)*X33(K)*X63(M) + X13(J)*X23(K)*X33(L)*X63(M) +
     +       X13(J)*X43(L)*X53(K)*X63(M) + X13(J)*X43(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN41 = X13(L)*X23(K)*X43(M)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X43(M)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X43(K)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X43(L)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X53(L)*X63(I) +
     +        X13(L)*X33(K)*X43(I)*X53(M)*X63(I) +
     +        X13(K)*X33(L)*X43(I)*X53(M)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X43(K)*X53(I) +
     +        X13(M)*X23(K)*X33(I)*X43(L)*X53(I) +
     +        X13(M)*X23(I)*X33(L)*X43(I)*X53(K) +
     +        X13(M)*X23(I)*X33(K)*X43(I)*X53(L) +
     +        X13(I)*X23(L)*X33(M)*X53(I)*X63(K) +
     +        X13(I)*X23(M)*X33(L)*X43(I)*X63(K) +
     +        X13(I)*X23(I)*X43(M)*X53(L)*X63(K) +
     +        X13(I)*X33(I)*X43(L)*X53(M)*X63(K) +
     +        X13(I)*X23(K)*X33(M)*X53(I)*X63(L) +
     +        X13(I)*X23(M)*X33(K)*X43(I)*X63(L) +
     +        X13(I)*X23(I)*X43(M)*X53(K)*X63(L) +
     +        X13(I)*X33(I)*X43(K)*X53(M)*X63(L) +
     +        X23(L)*X33(K)*X43(I)*X53(I)*X63(M) +
     +        X23(K)*X33(L)*X43(I)*X53(I)*X63(M) +
     +        X23(I)*X33(I)*X43(L)*X53(K)*X63(M) +
     +        X23(I)*X33(I)*X43(K)*X53(L)*X63(M)
      ELSE
      FUN41 = X13(L)*X23(K)*X33(J)*X43(M)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(J)*X43(M)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X43(K)*X53(J)*X63(I) +
     +        X13(K)*X23(M)*X33(I)*X43(L)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X43(J)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X43(J)*X53(L)*X63(I) +
     +        X13(L)*X23(J)*X33(K)*X43(I)*X53(M)*X63(I) +
     +        X13(K)*X23(J)*X33(L)*X43(I)*X53(M)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X43(K)*X53(I)*X63(J) +
     +        X13(M)*X23(K)*X33(I)*X43(L)*X53(I)*X63(J) +
     +        X13(M)*X23(I)*X33(L)*X43(I)*X53(K)*X63(J) +
     +        X13(M)*X23(I)*X33(K)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(M)*X43(J)*X53(I)*X63(K) +
     +        X13(I)*X23(M)*X33(L)*X43(I)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(J)*X43(M)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(I)*X43(L)*X53(M)*X63(K) +
     +        X13(I)*X23(K)*X33(M)*X43(J)*X53(I)*X63(L) +
     +        X13(I)*X23(M)*X33(K)*X43(I)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(J)*X43(M)*X53(K)*X63(L) +
     +        X13(I)*X23(J)*X33(I)*X43(K)*X53(M)*X63(L) +
     +        X13(J)*X23(L)*X33(K)*X43(I)*X53(I)*X63(M) +
     +        X13(J)*X23(K)*X33(L)*X43(I)*X53(I)*X63(M) +
     +        X13(J)*X23(I)*X33(I)*X43(L)*X53(K)*X63(M) +
     +        X13(J)*X23(I)*X33(I)*X43(K)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN42(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,4)
      K = IPA(JJ,3)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN42= X13(M)*X23(J)*X33(K)*X43(L) + X13(J)*X23(M)*X33(K)*X43(L) +
     +       X13(M)*X33(L)*X43(K)*X53(J) + X13(M)*X23(L)*X43(J)*X53(K) +
     +       X13(J)*X23(L)*X43(M)*X53(K) + X13(M)*X23(K)*X33(J)*X53(L) +
     +       X13(J)*X23(K)*X33(M)*X53(L) + X13(J)*X33(L)*X43(K)*X53(M) +
     +       X23(M)*X33(L)*X43(K)*X63(J) + X23(L)*X33(M)*X53(K)*X63(J) +
     +       X23(K)*X43(M)*X53(L)*X63(J) + X33(K)*X43(L)*X53(M)*X63(J) +
     +       X13(L)*X23(M)*X43(J)*X63(K) + X13(L)*X23(J)*X43(M)*X63(K) +
     +       X13(L)*X33(M)*X53(J)*X63(K) + X13(L)*X33(J)*X53(M)*X63(K) +
     +       X13(K)*X23(M)*X33(J)*X63(L) + X13(K)*X23(J)*X33(M)*X63(L) +
     +       X13(K)*X43(M)*X53(J)*X63(L) + X13(K)*X43(J)*X53(M)*X63(L) +
     +       X23(J)*X33(L)*X43(K)*X63(M) + X33(K)*X43(L)*X53(J)*X63(M) +
     +       X23(L)*X33(J)*X53(K)*X63(M) + X23(K)*X43(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN42 = X13(M)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X23(M)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X43(K)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X53(K)*X63(I) +
     +        X23(L)*X33(I)*X43(M)*X53(K)*X63(I) +
     +        X13(M)*X23(K)*X43(I)*X53(L)*X63(I) +
     +        X23(K)*X33(M)*X43(I)*X53(L)*X63(I) +
     +        X23(I)*X33(L)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X23(M)*X33(L)*X43(K)*X53(I) +
     +        X13(I)*X23(L)*X33(M)*X43(I)*X53(K) +
     +        X13(I)*X23(K)*X33(I)*X43(M)*X53(L) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(M) +
     +        X13(L)*X23(M)*X33(I)*X53(I)*X63(K) +
     +        X13(L)*X33(I)*X43(M)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(M)*X43(I)*X63(K) +
     +        X13(L)*X23(I)*X43(I)*X53(M)*X63(K) +
     +        X13(K)*X23(M)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X33(M)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(M)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X53(M)*X63(L) +
     +        X13(I)*X33(L)*X43(K)*X53(I)*X63(M) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X63(M) +
     +        X13(I)*X23(L)*X43(I)*X53(K)*X63(M) +
     +        X13(I)*X23(K)*X33(I)*X53(L)*X63(M)
      ELSE
      FUN42 = X13(M)*X23(J)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(M)*X33(K)*X43(L)*X53(I)*X63(I) +
     +        X13(M)*X23(I)*X33(L)*X43(K)*X53(J)*X63(I) +
     +        X13(M)*X23(L)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(M)*X53(K)*X63(I) +
     +        X13(M)*X23(K)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(K)*X33(M)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X23(M)*X33(L)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(M)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(M)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(M)*X63(J) +
     +        X13(L)*X23(M)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(L)*X23(J)*X33(I)*X43(M)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(M)*X43(I)*X53(J)*X63(K) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(M)*X63(K) +
     +        X13(K)*X23(M)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(J)*X33(M)*X43(I)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(M)*X53(J)*X63(L) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(M)*X63(L) +
     +        X13(I)*X23(J)*X33(L)*X43(K)*X53(I)*X63(M) +
     +        X13(I)*X23(I)*X33(K)*X43(L)*X53(J)*X63(M) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(K)*X63(M) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN43(JJ)
      M = IPA(JJ,4)
      L = IPA(JJ,1)
      K = IPA(JJ,3)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN43= X13(L)*X23(J)*X33(K)*X43(M) + X13(J)*X23(L)*X33(K)*X43(M) +
     +       X13(L)*X33(M)*X43(K)*X53(J) + X13(L)*X23(M)*X43(J)*X53(K) +
     +       X13(J)*X23(M)*X43(L)*X53(K) + X13(J)*X33(M)*X43(K)*X53(L) +
     +       X13(L)*X23(K)*X33(J)*X53(M) + X13(J)*X23(K)*X33(L)*X53(M) +
     +       X23(L)*X33(M)*X43(K)*X63(J) + X23(M)*X33(L)*X53(K)*X63(J) +
     +       X33(K)*X43(M)*X53(L)*X63(J) + X23(K)*X43(L)*X53(M)*X63(J) +
     +       X13(M)*X23(L)*X43(J)*X63(K) + X13(M)*X23(J)*X43(L)*X63(K) +
     +       X13(M)*X33(L)*X53(J)*X63(K) + X13(M)*X33(J)*X53(L)*X63(K) +
     +       X23(J)*X33(M)*X43(K)*X63(L) + X33(K)*X43(M)*X53(J)*X63(L) +
     +       X23(M)*X33(J)*X53(K)*X63(L) + X23(K)*X43(J)*X53(M)*X63(L) +
     +       X13(K)*X23(L)*X33(J)*X63(M) + X13(K)*X23(J)*X33(L)*X63(M) +
     +       X13(K)*X43(L)*X53(J)*X63(M) + X13(K)*X43(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN43 = X13(L)*X33(K)*X43(M)*X53(I)*X63(I) +
     +        X23(L)*X33(K)*X43(M)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X43(K)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X53(K)*X63(I) +
     +        X23(M)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X23(I)*X33(M)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X43(I)*X53(M)*X63(I) +
     +        X23(K)*X33(L)*X43(I)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X33(M)*X43(K)*X53(I) +
     +        X13(I)*X23(M)*X33(L)*X43(I)*X53(K) +
     +        X13(I)*X23(I)*X33(K)*X43(M)*X53(L) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(M) +
     +        X13(M)*X23(L)*X33(I)*X53(I)*X63(K) +
     +        X13(M)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X33(L)*X43(I)*X63(K) +
     +        X13(M)*X23(I)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X33(M)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(M)*X63(L) +
     +        X13(I)*X23(M)*X43(I)*X53(K)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X53(M)*X63(L) +
     +        X13(K)*X23(L)*X43(I)*X53(I)*X63(M) +
     +        X13(K)*X33(L)*X43(I)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X63(M) +
     +        X13(K)*X23(I)*X33(I)*X53(L)*X63(M)
      ELSE
      FUN43 = X13(L)*X23(J)*X33(K)*X43(M)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(K)*X43(M)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(M)*X43(K)*X53(J)*X63(I) +
     +        X13(L)*X23(M)*X33(I)*X43(J)*X53(K)*X63(I) +
     +        X13(J)*X23(M)*X33(I)*X43(L)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(M)*X43(K)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(J)*X43(I)*X53(M)*X63(I) +
     +        X13(J)*X23(K)*X33(L)*X43(I)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X33(M)*X43(K)*X53(I)*X63(J) +
     +        X13(I)*X23(M)*X33(L)*X43(I)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(K)*X43(M)*X53(L)*X63(J) +
     +        X13(I)*X23(K)*X33(I)*X43(L)*X53(M)*X63(J) +
     +        X13(M)*X23(L)*X33(I)*X43(J)*X53(I)*X63(K) +
     +        X13(M)*X23(J)*X33(I)*X43(L)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X33(L)*X43(I)*X53(J)*X63(K) +
     +        X13(M)*X23(I)*X33(J)*X43(I)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(M)*X43(K)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(K)*X43(M)*X53(J)*X63(L) +
     +        X13(I)*X23(M)*X33(J)*X43(I)*X53(K)*X63(L) +
     +        X13(I)*X23(K)*X33(I)*X43(J)*X53(M)*X63(L) +
     +        X13(K)*X23(L)*X33(J)*X43(I)*X53(I)*X63(M) +
     +        X13(K)*X23(J)*X33(L)*X43(I)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X33(I)*X43(L)*X53(J)*X63(M) +
     +        X13(K)*X23(I)*X33(I)*X43(J)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN44(JJ)
      M = IPA(JJ,1)
      L = IPA(JJ,3)
      K = IPA(JJ,4)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN44= X13(M)*X23(J)*X33(L)*X43(K) + X13(J)*X23(M)*X33(L)*X43(K) +
     +       X13(M)*X33(K)*X43(L)*X53(J) + X13(M)*X23(L)*X33(J)*X53(K) +
     +       X13(J)*X23(L)*X33(M)*X53(K) + X13(M)*X23(K)*X43(J)*X53(L) +
     +       X13(J)*X23(K)*X43(M)*X53(L) + X13(J)*X33(K)*X43(L)*X53(M) +
     +       X23(M)*X33(K)*X43(L)*X63(J) + X23(L)*X43(M)*X53(K)*X63(J) +
     +       X23(K)*X33(M)*X53(L)*X63(J) + X33(L)*X43(K)*X53(M)*X63(J) +
     +       X13(L)*X23(M)*X33(J)*X63(K) + X13(L)*X23(J)*X33(M)*X63(K) +
     +       X13(L)*X43(M)*X53(J)*X63(K) + X13(L)*X43(J)*X53(M)*X63(K) +
     +       X13(K)*X23(M)*X43(J)*X63(L) + X13(K)*X23(J)*X43(M)*X63(L) +
     +       X13(K)*X33(M)*X53(J)*X63(L) + X13(K)*X33(J)*X53(M)*X63(L) +
     +       X23(J)*X33(K)*X43(L)*X63(M) + X33(L)*X43(K)*X53(J)*X63(M) +
     +       X23(L)*X43(J)*X53(K)*X63(M) + X23(K)*X33(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN44 = X13(M)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X23(M)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(M)*X23(I)*X33(K)*X43(L)*X63(I) +
     +        X13(M)*X23(L)*X43(I)*X53(K)*X63(I) +
     +        X23(L)*X33(M)*X43(I)*X53(K)*X63(I) +
     +        X13(M)*X23(K)*X33(I)*X53(L)*X63(I) +
     +        X23(K)*X33(I)*X43(M)*X53(L)*X63(I) +
     +        X23(I)*X33(K)*X43(L)*X53(M)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X43(L)*X53(I) +
     +        X13(I)*X23(L)*X33(I)*X43(M)*X53(K) +
     +        X13(I)*X23(K)*X33(M)*X43(I)*X53(L) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(M) +
     +        X13(L)*X23(M)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X33(M)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(M)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X53(M)*X63(K) +
     +        X13(K)*X23(M)*X33(I)*X53(I)*X63(L) +
     +        X13(K)*X33(I)*X43(M)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(M)*X43(I)*X63(L) +
     +        X13(K)*X23(I)*X43(I)*X53(M)*X63(L) +
     +        X13(I)*X33(K)*X43(L)*X53(I)*X63(M) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X63(M) +
     +        X13(I)*X23(L)*X33(I)*X53(K)*X63(M) +
     +        X13(I)*X23(K)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN44 = X13(M)*X23(J)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(M)*X33(L)*X43(K)*X53(I)*X63(I) +
     +        X13(M)*X23(I)*X33(K)*X43(L)*X53(J)*X63(I) +
     +        X13(M)*X23(L)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(L)*X33(M)*X43(I)*X53(K)*X63(I) +
     +        X13(M)*X23(K)*X33(I)*X43(J)*X53(L)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(M)*X53(L)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(L)*X53(M)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X43(L)*X53(I)*X63(J) +
     +        X13(I)*X23(L)*X33(I)*X43(M)*X53(K)*X63(J) +
     +        X13(I)*X23(K)*X33(M)*X43(I)*X53(L)*X63(J) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(M)*X63(J) +
     +        X13(L)*X23(M)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(J)*X33(M)*X43(I)*X53(I)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(M)*X53(J)*X63(K) +
     +        X13(L)*X23(I)*X33(I)*X43(J)*X53(M)*X63(K) +
     +        X13(K)*X23(M)*X33(I)*X43(J)*X53(I)*X63(L) +
     +        X13(K)*X23(J)*X33(I)*X43(M)*X53(I)*X63(L) +
     +        X13(K)*X23(I)*X33(M)*X43(I)*X53(J)*X63(L) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(M)*X63(L) +
     +        X13(I)*X23(J)*X33(K)*X43(L)*X53(I)*X63(M) +
     +        X13(I)*X23(I)*X33(L)*X43(K)*X53(J)*X63(M) +
     +        X13(I)*X23(L)*X33(I)*X43(J)*X53(K)*X63(M) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN45(JJ)
      M = IPA(JJ,3)
      L = IPA(JJ,1)
      K = IPA(JJ,2)
      J = IPA(JJ,4)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN45= X13(L)*X23(K)*X33(M)*X43(J) + X13(K)*X23(L)*X33(M)*X43(J) +
     +       X13(L)*X23(M)*X33(K)*X53(J) + X13(K)*X23(M)*X33(L)*X53(J) +
     +       X13(L)*X33(J)*X43(M)*X53(K) + X13(K)*X33(J)*X43(M)*X53(L) +
     +       X13(L)*X23(J)*X43(K)*X53(M) + X13(K)*X23(J)*X43(L)*X53(M) +
     +       X13(M)*X23(L)*X33(K)*X63(J) + X13(M)*X23(K)*X33(L)*X63(J) +
     +       X13(M)*X43(L)*X53(K)*X63(J) + X13(M)*X43(K)*X53(L)*X63(J) +
     +       X23(L)*X33(J)*X43(M)*X63(K) + X23(M)*X43(L)*X53(J)*X63(K) +
     +       X33(M)*X43(J)*X53(L)*X63(K) + X23(J)*X33(L)*X53(M)*X63(K) +
     +       X23(K)*X33(J)*X43(M)*X63(L) + X23(M)*X43(K)*X53(J)*X63(L) +
     +       X33(M)*X43(J)*X53(K)*X63(L) + X23(J)*X33(K)*X53(M)*X63(L) +
     +       X13(J)*X23(L)*X43(K)*X63(M) + X13(J)*X23(K)*X43(L)*X63(M) +
     +       X13(J)*X33(L)*X53(K)*X63(M) + X13(J)*X33(K)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN45 = X13(L)*X23(K)*X33(M)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(M)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X43(I)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X43(I)*X63(I) +
     +        X13(L)*X23(I)*X43(M)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X43(M)*X53(L)*X63(I) +
     +        X13(L)*X33(I)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X33(I)*X43(L)*X53(M)*X63(I) +
     +        X13(M)*X23(L)*X33(K)*X43(I)*X53(I) +
     +        X13(M)*X23(K)*X33(L)*X43(I)*X53(I) +
     +        X13(M)*X23(I)*X33(I)*X43(L)*X53(K) +
     +        X13(M)*X23(I)*X33(I)*X43(K)*X53(L) +
     +        X13(I)*X23(L)*X43(M)*X53(I)*X63(K) +
     +        X13(I)*X23(M)*X33(I)*X43(L)*X63(K) +
     +        X13(I)*X23(I)*X33(M)*X53(L)*X63(K) +
     +        X13(I)*X33(L)*X43(I)*X53(M)*X63(K) +
     +        X13(I)*X23(K)*X43(M)*X53(I)*X63(L) +
     +        X13(I)*X23(M)*X33(I)*X43(K)*X63(L) +
     +        X13(I)*X23(I)*X33(M)*X53(K)*X63(L) +
     +        X13(I)*X33(K)*X43(I)*X53(M)*X63(L) +
     +        X23(L)*X33(I)*X43(K)*X53(I)*X63(M) +
     +        X23(K)*X33(I)*X43(L)*X53(I)*X63(M) +
     +        X23(I)*X33(L)*X43(I)*X53(K)*X63(M) +
     +        X23(I)*X33(K)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN45 = X13(L)*X23(K)*X33(M)*X43(J)*X53(I)*X63(I) +
     +        X13(K)*X23(L)*X33(M)*X43(J)*X53(I)*X63(I) +
     +        X13(L)*X23(M)*X33(K)*X43(I)*X53(J)*X63(I) +
     +        X13(K)*X23(M)*X33(L)*X43(I)*X53(J)*X63(I) +
     +        X13(L)*X23(I)*X33(J)*X43(M)*X53(K)*X63(I) +
     +        X13(K)*X23(I)*X33(J)*X43(M)*X53(L)*X63(I) +
     +        X13(L)*X23(J)*X33(I)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X23(J)*X33(I)*X43(L)*X53(M)*X63(I) +
     +        X13(M)*X23(L)*X33(K)*X43(I)*X53(I)*X63(J) +
     +        X13(M)*X23(K)*X33(L)*X43(I)*X53(I)*X63(J) +
     +        X13(M)*X23(I)*X33(I)*X43(L)*X53(K)*X63(J) +
     +        X13(M)*X23(I)*X33(I)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(J)*X43(M)*X53(I)*X63(K) +
     +        X13(I)*X23(M)*X33(I)*X43(L)*X53(J)*X63(K) +
     +        X13(I)*X23(I)*X33(M)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(L)*X43(I)*X53(M)*X63(K) +
     +        X13(I)*X23(K)*X33(J)*X43(M)*X53(I)*X63(L) +
     +        X13(I)*X23(M)*X33(I)*X43(K)*X53(J)*X63(L) +
     +        X13(I)*X23(I)*X33(M)*X43(J)*X53(K)*X63(L) +
     +        X13(I)*X23(J)*X33(K)*X43(I)*X53(M)*X63(L) +
     +        X13(J)*X23(L)*X33(I)*X43(K)*X53(I)*X63(M) +
     +        X13(J)*X23(K)*X33(I)*X43(L)*X53(I)*X63(M) +
     +        X13(J)*X23(I)*X33(L)*X43(I)*X53(K)*X63(M) +
     +        X13(J)*X23(I)*X33(K)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN46(JJ)
      M = IPA(JJ,3)
      L = IPA(JJ,1)
      K = IPA(JJ,4)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN46= X13(L)*X23(J)*X33(M)*X43(K) + X13(J)*X23(L)*X33(M)*X43(K) +
     +       X13(L)*X33(K)*X43(M)*X53(J) + X13(L)*X23(M)*X33(J)*X53(K) +
     +       X13(J)*X23(M)*X33(L)*X53(K) + X13(J)*X33(K)*X43(M)*X53(L) +
     +       X13(L)*X23(K)*X43(J)*X53(M) + X13(J)*X23(K)*X43(L)*X53(M) +
     +       X23(L)*X33(K)*X43(M)*X63(J) + X23(M)*X43(L)*X53(K)*X63(J) +
     +       X33(M)*X43(K)*X53(L)*X63(J) + X23(K)*X33(L)*X53(M)*X63(J) +
     +       X13(M)*X23(L)*X33(J)*X63(K) + X13(M)*X23(J)*X33(L)*X63(K) +
     +       X13(M)*X43(L)*X53(J)*X63(K) + X13(M)*X43(J)*X53(L)*X63(K) +
     +       X23(J)*X33(K)*X43(M)*X63(L) + X33(M)*X43(K)*X53(J)*X63(L) +
     +       X23(M)*X43(J)*X53(K)*X63(L) + X23(K)*X33(J)*X53(M)*X63(L) +
     +       X13(K)*X23(L)*X43(J)*X63(M) + X13(K)*X23(J)*X43(L)*X63(M) +
     +       X13(K)*X33(L)*X53(J)*X63(M) + X13(K)*X33(J)*X53(L)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN46 = X13(L)*X33(M)*X43(K)*X53(I)*X63(I) +
     +        X23(L)*X33(M)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(M)*X63(I) +
     +        X13(L)*X23(M)*X43(I)*X53(K)*X63(I) +
     +        X23(M)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X23(I)*X33(K)*X43(M)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X53(M)*X63(I) +
     +        X23(K)*X33(I)*X43(L)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(M)*X53(I) +
     +        X13(I)*X23(M)*X33(I)*X43(L)*X53(K) +
     +        X13(I)*X23(I)*X33(M)*X43(K)*X53(L) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(M) +
     +        X13(M)*X23(L)*X43(I)*X53(I)*X63(K) +
     +        X13(M)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X33(I)*X43(L)*X63(K) +
     +        X13(M)*X23(I)*X33(I)*X53(L)*X63(K) +
     +        X13(I)*X33(K)*X43(M)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(M)*X43(K)*X63(L) +
     +        X13(I)*X23(M)*X33(I)*X53(K)*X63(L) +
     +        X13(I)*X23(K)*X43(I)*X53(M)*X63(L) +
     +        X13(K)*X23(L)*X33(I)*X53(I)*X63(M) +
     +        X13(K)*X33(I)*X43(L)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X63(M) +
     +        X13(K)*X23(I)*X43(I)*X53(L)*X63(M)
      ELSE
      FUN46 = X13(L)*X23(J)*X33(M)*X43(K)*X53(I)*X63(I) +
     +        X13(J)*X23(L)*X33(M)*X43(K)*X53(I)*X63(I) +
     +        X13(L)*X23(I)*X33(K)*X43(M)*X53(J)*X63(I) +
     +        X13(L)*X23(M)*X33(J)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(M)*X33(L)*X43(I)*X53(K)*X63(I) +
     +        X13(J)*X23(I)*X33(K)*X43(M)*X53(L)*X63(I) +
     +        X13(L)*X23(K)*X33(I)*X43(J)*X53(M)*X63(I) +
     +        X13(J)*X23(K)*X33(I)*X43(L)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(M)*X53(I)*X63(J) +
     +        X13(I)*X23(M)*X33(I)*X43(L)*X53(K)*X63(J) +
     +        X13(I)*X23(I)*X33(M)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(K)*X33(L)*X43(I)*X53(M)*X63(J) +
     +        X13(M)*X23(L)*X33(J)*X43(I)*X53(I)*X63(K) +
     +        X13(M)*X23(J)*X33(L)*X43(I)*X53(I)*X63(K) +
     +        X13(M)*X23(I)*X33(I)*X43(L)*X53(J)*X63(K) +
     +        X13(M)*X23(I)*X33(I)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(J)*X33(K)*X43(M)*X53(I)*X63(L) +
     +        X13(I)*X23(I)*X33(M)*X43(K)*X53(J)*X63(L) +
     +        X13(I)*X23(M)*X33(I)*X43(J)*X53(K)*X63(L) +
     +        X13(I)*X23(K)*X33(J)*X43(I)*X53(M)*X63(L) +
     +        X13(K)*X23(L)*X33(I)*X43(J)*X53(I)*X63(M) +
     +        X13(K)*X23(J)*X33(I)*X43(L)*X53(I)*X63(M) +
     +        X13(K)*X23(I)*X33(L)*X43(I)*X53(J)*X63(M) +
     +        X13(K)*X23(I)*X33(J)*X43(I)*X53(L)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN47(JJ)
      M = IPA(JJ,3)
      L = IPA(JJ,4)
      K = IPA(JJ,1)
      J = IPA(JJ,2)
      I = IPA(JJ,5)
      IF(I.EQ.0) THEN
      FUN47= X13(K)*X23(J)*X33(M)*X43(L) + X13(J)*X23(K)*X33(M)*X43(L) +
     +       X13(K)*X33(L)*X43(M)*X53(J) + X13(J)*X33(L)*X43(M)*X53(K) +
     +       X13(K)*X23(M)*X33(J)*X53(L) + X13(J)*X23(M)*X33(K)*X53(L) +
     +       X13(K)*X23(L)*X43(J)*X53(M) + X13(J)*X23(L)*X43(K)*X53(M) +
     +       X23(K)*X33(L)*X43(M)*X63(J) + X33(M)*X43(L)*X53(K)*X63(J) +
     +       X23(M)*X43(K)*X53(L)*X63(J) + X23(L)*X33(K)*X53(M)*X63(J) +
     +       X23(J)*X33(L)*X43(M)*X63(K) + X33(M)*X43(L)*X53(J)*X63(K) +
     +       X23(M)*X43(J)*X53(L)*X63(K) + X23(L)*X33(J)*X53(M)*X63(K) +
     +       X13(M)*X23(K)*X33(J)*X63(L) + X13(M)*X23(J)*X33(K)*X63(L) +
     +       X13(M)*X43(K)*X53(J)*X63(L) + X13(M)*X43(J)*X53(K)*X63(L) +
     +       X13(L)*X23(K)*X43(J)*X63(M) + X13(L)*X23(J)*X43(K)*X63(M) +
     +       X13(L)*X33(K)*X53(J)*X63(M) + X13(L)*X33(J)*X53(K)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN47 = X13(K)*X33(M)*X43(L)*X53(I)*X63(I) +
     +        X23(K)*X33(M)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(M)*X63(I) +
     +        X23(I)*X33(L)*X43(M)*X53(K)*X63(I) +
     +        X13(K)*X23(M)*X43(I)*X53(L)*X63(I) +
     +        X23(M)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X53(M)*X63(I) +
     +        X23(L)*X33(I)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(M)*X53(I) +
     +        X13(I)*X23(I)*X33(M)*X43(L)*X53(K) +
     +        X13(I)*X23(M)*X33(I)*X43(K)*X53(L) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(M) +
     +        X13(I)*X33(L)*X43(M)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(M)*X43(L)*X63(K) +
     +        X13(I)*X23(M)*X33(I)*X53(L)*X63(K) +
     +        X13(I)*X23(L)*X43(I)*X53(M)*X63(K) +
     +        X13(M)*X23(K)*X43(I)*X53(I)*X63(L) +
     +        X13(M)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X33(I)*X43(K)*X63(L) +
     +        X13(M)*X23(I)*X33(I)*X53(K)*X63(L) +
     +        X13(L)*X23(K)*X33(I)*X53(I)*X63(M) +
     +        X13(L)*X33(I)*X43(K)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X63(M) +
     +        X13(L)*X23(I)*X43(I)*X53(K)*X63(M)
      ELSE
      FUN47 = X13(K)*X23(J)*X33(M)*X43(L)*X53(I)*X63(I) +
     +        X13(J)*X23(K)*X33(M)*X43(L)*X53(I)*X63(I) +
     +        X13(K)*X23(I)*X33(L)*X43(M)*X53(J)*X63(I) +
     +        X13(J)*X23(I)*X33(L)*X43(M)*X53(K)*X63(I) +
     +        X13(K)*X23(M)*X33(J)*X43(I)*X53(L)*X63(I) +
     +        X13(J)*X23(M)*X33(K)*X43(I)*X53(L)*X63(I) +
     +        X13(K)*X23(L)*X33(I)*X43(J)*X53(M)*X63(I) +
     +        X13(J)*X23(L)*X33(I)*X43(K)*X53(M)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(M)*X53(I)*X63(J) +
     +        X13(I)*X23(I)*X33(M)*X43(L)*X53(K)*X63(J) +
     +        X13(I)*X23(M)*X33(I)*X43(K)*X53(L)*X63(J) +
     +        X13(I)*X23(L)*X33(K)*X43(I)*X53(M)*X63(J) +
     +        X13(I)*X23(J)*X33(L)*X43(M)*X53(I)*X63(K) +
     +        X13(I)*X23(I)*X33(M)*X43(L)*X53(J)*X63(K) +
     +        X13(I)*X23(M)*X33(I)*X43(J)*X53(L)*X63(K) +
     +        X13(I)*X23(L)*X33(J)*X43(I)*X53(M)*X63(K) +
     +        X13(M)*X23(K)*X33(J)*X43(I)*X53(I)*X63(L) +
     +        X13(M)*X23(J)*X33(K)*X43(I)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X33(I)*X43(K)*X53(J)*X63(L) +
     +        X13(M)*X23(I)*X33(I)*X43(J)*X53(K)*X63(L) +
     +        X13(L)*X23(K)*X33(I)*X43(J)*X53(I)*X63(M) +
     +        X13(L)*X23(J)*X33(I)*X43(K)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X33(K)*X43(I)*X53(J)*X63(M) +
     +        X13(L)*X23(I)*X33(J)*X43(I)*X53(K)*X63(M)
      ENDIF
      RETURN
      ENTRY FUN48(JJ)
      M = IPA(JJ,3)
      L = IPA(JJ,4)
      K = IPA(JJ,2)
      J = IPA(JJ,5)
      I = IPA(JJ,1)
      IF(I.EQ.0) THEN
      FUN48= X23(K)*X33(M)*X43(L)*X53(J) + X23(K)*X33(L)*X43(M)*X53(J) +
     +       X23(J)*X33(M)*X43(L)*X53(K) + X23(J)*X33(L)*X43(M)*X53(K) +
     +       X23(M)*X33(K)*X43(J)*X53(L) + X23(M)*X33(J)*X43(K)*X53(L) +
     +       X23(L)*X33(K)*X43(J)*X53(M) + X23(L)*X33(J)*X43(K)*X53(M) +
     +       X13(K)*X33(M)*X43(L)*X63(J) + X13(K)*X33(L)*X43(M)*X63(J) +
     +       X13(K)*X23(M)*X53(L)*X63(J) + X13(K)*X23(L)*X53(M)*X63(J) +
     +       X13(J)*X33(M)*X43(L)*X63(K) + X13(J)*X33(L)*X43(M)*X63(K) +
     +       X13(J)*X23(M)*X53(L)*X63(K) + X13(J)*X23(L)*X53(M)*X63(K) +
     +       X13(M)*X33(K)*X43(J)*X63(L) + X13(M)*X33(J)*X43(K)*X63(L) +
     +       X13(M)*X23(K)*X53(J)*X63(L) + X13(M)*X23(J)*X53(K)*X63(L) +
     +       X13(L)*X33(K)*X43(J)*X63(M) + X13(L)*X33(J)*X43(K)*X63(M) +
     +       X13(L)*X23(K)*X53(J)*X63(M) + X13(L)*X23(J)*X53(K)*X63(M)
      ELSE IF(J.EQ.0) THEN
      FUN48 = X13(I)*X23(K)*X33(M)*X43(L)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(M)*X63(I) +
     +        X13(I)*X33(M)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X33(L)*X43(M)*X53(K)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X53(L)*X63(I) +
     +        X13(I)*X23(M)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X43(L)*X53(I) +
     +        X13(K)*X23(I)*X33(L)*X43(M)*X53(I) +
     +        X13(K)*X23(M)*X33(I)*X43(I)*X53(L) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(M) +
     +        X23(I)*X33(M)*X43(L)*X53(I)*X63(K) +
     +        X23(I)*X33(L)*X43(M)*X53(I)*X63(K) +
     +        X23(M)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X23(L)*X33(I)*X43(I)*X53(M)*X63(K) +
     +        X13(M)*X23(I)*X33(K)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X43(K)*X53(I)*X63(L) +
     +        X13(M)*X23(K)*X33(I)*X43(I)*X63(L) +
     +        X13(M)*X33(I)*X43(I)*X53(K)*X63(L) +
     +        X13(L)*X23(I)*X33(K)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X43(K)*X53(I)*X63(M) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X63(M) +
     +        X13(L)*X33(I)*X43(I)*X53(K)*X63(M)
      ELSE
      FUN48 = X13(I)*X23(K)*X33(M)*X43(L)*X53(J)*X63(I) +
     +        X13(I)*X23(K)*X33(L)*X43(M)*X53(J)*X63(I) +
     +        X13(I)*X23(J)*X33(M)*X43(L)*X53(K)*X63(I) +
     +        X13(I)*X23(J)*X33(L)*X43(M)*X53(K)*X63(I) +
     +        X13(I)*X23(M)*X33(K)*X43(J)*X53(L)*X63(I) +
     +        X13(I)*X23(M)*X33(J)*X43(K)*X53(L)*X63(I) +
     +        X13(I)*X23(L)*X33(K)*X43(J)*X53(M)*X63(I) +
     +        X13(I)*X23(L)*X33(J)*X43(K)*X53(M)*X63(I) +
     +        X13(K)*X23(I)*X33(M)*X43(L)*X53(I)*X63(J) +
     +        X13(K)*X23(I)*X33(L)*X43(M)*X53(I)*X63(J) +
     +        X13(K)*X23(M)*X33(I)*X43(I)*X53(L)*X63(J) +
     +        X13(K)*X23(L)*X33(I)*X43(I)*X53(M)*X63(J) +
     +        X13(J)*X23(I)*X33(M)*X43(L)*X53(I)*X63(K) +
     +        X13(J)*X23(I)*X33(L)*X43(M)*X53(I)*X63(K) +
     +        X13(J)*X23(M)*X33(I)*X43(I)*X53(L)*X63(K) +
     +        X13(J)*X23(L)*X33(I)*X43(I)*X53(M)*X63(K) +
     +        X13(M)*X23(I)*X33(K)*X43(J)*X53(I)*X63(L) +
     +        X13(M)*X23(I)*X33(J)*X43(K)*X53(I)*X63(L) +
     +        X13(M)*X23(K)*X33(I)*X43(I)*X53(J)*X63(L) +
     +        X13(M)*X23(J)*X33(I)*X43(I)*X53(K)*X63(L) +
     +        X13(L)*X23(I)*X33(K)*X43(J)*X53(I)*X63(M) +
     +        X13(L)*X23(I)*X33(J)*X43(K)*X53(I)*X63(M) +
     +        X13(L)*X23(K)*X33(I)*X43(I)*X53(J)*X63(M) +
     +        X13(L)*X23(J)*X33(I)*X43(I)*X53(K)*X63(M)
      RETURN
      ENDIF
      END

